VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cmdMahalanobis"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private m_App As IApplication
Private m_MxDoc As IMxDocument
Private m_bitmap As IPictureDisp
Private m_pThisExt As TopoCorridor.clsExtension

Implements ICommand
Const c_sModuleFileName As String = "D:\arcGIS_stuff\general_tools\Mahalanobis\Code\clsTopoCorridor.cls"

 
Private Sub Class_Initialize()
  On Error GoTo ErrorHandler

15:   Set m_bitmap = LoadResPicture(110, vbResBitmap)

  Exit Sub
ErrorHandler:
  HandleError True, "Class_Initialize " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Class_Terminate()
  On Error GoTo ErrorHandler

25:   Set m_bitmap = Nothing
26:   Set m_MxDoc = Nothing
27:   Set m_App = Nothing
28:   Set m_pThisExt = Nothing

  Exit Sub
ErrorHandler:
  HandleError True, "Class_Terminate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Property Get ICommand_Enabled() As Boolean
  On Error GoTo ErrorHandler
  
38:   ICommand_Enabled = True

  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Enabled " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Checked() As Boolean
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
50:    ICommand_Checked = False


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Checked " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Name() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
63:   ICommand_Name = "Mahalanobis_CalcDistance"


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Name " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Caption() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
76:   ICommand_Caption = "Mahalanobis &Distances - Create Raster Surface"


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Caption " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Tooltip() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
89:   ICommand_Tooltip = "Mahalanobis - Raster"


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Tooltip " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Message() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
102:   ICommand_Message = "Generate Raster of Mahalanobis Distances..."


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Message " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_HelpFile() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
115:   ICommand_HelpFile = ""


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_HelpFile " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_HelpContextID() As Long
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
128:   ICommand_HelpContextID = 0


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_HelpContextID " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Bitmap() As esriSystem.OLE_HANDLE
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
141:   ICommand_Bitmap = m_bitmap.Handle


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Bitmap " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Category() As String
  On Error GoTo ErrorHandler

  ' TODO: Add your implementation here
153:   ICommand_Category = "Land Facet Corridor Tools"

  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Category " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub ICommand_OnCreate(ByVal hook As Object)
  On Error GoTo ErrorHandler

163:   Set m_App = hook
164:   Set m_MxDoc = m_App.Document
  

  Dim newUid As New UID
  Dim pExt As IExtension
169:   newUid.Value = "TopoCorridor.clsExtension"
170:   Set pExt = m_App.FindExtensionByCLSID(newUid)
171:   Set m_pThisExt = pExt
  

  Exit Sub
ErrorHandler:
  HandleError True, "ICommand_OnCreate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub ICommand_OnClick()
  On Error GoTo ErrorHandler
  
  ' CLEAR ANY EXISTING USER PARAMETERS
183:   Set m_pThisExt.frmCovReloadParams = Nothing
184:   Set m_pThisExt.frmCovSourceReturn = Nothing
185:   Set m_pThisExt.frmGridLayersReturn = Nothing
186:   Set m_pThisExt.StatsSaveCorrelationOptions = Nothing
187:   Set m_pThisExt.StatsSaveCovOptions = Nothing
188:   Set m_pThisExt.StatsSaveInvCovOptions = Nothing
189:   Set m_pThisExt.StatsSaveMeansOptions = Nothing
190:   Set m_pThisExt.StatsSavePearsonOptions = Nothing
191:   m_pThisExt.StatsSaveCorrelation = False
192:   m_pThisExt.StatsSaveCov = False
193:   m_pThisExt.StatsSaveInvCov = False
194:   m_pThisExt.StatsSaveMeans = False
195:   m_pThisExt.StatsSavePearson = False
  
  ' GET USER PARAMETERS
  Dim lngStep As Long
199:   lngStep = 1
  
  Dim pCovForm As TopoCorridor.frmCovSource
  Dim pGrids As TopoCorridor.frmGridLayers
203:   Set m_pThisExt.frmCovSourceReturn = Nothing
204:   Set m_pThisExt.frmGridLayersReturn = Nothing
205:   Set m_pThisExt.frmCovReloadParams = Nothing
  
  Dim pParams As esriSystem.IVariantArray
208:   Set pParams = New esriSystem.VarArray
209:   pParams.Add m_App
210:   pParams.Add m_MxDoc
211:   pParams.Add m_pThisExt
  
'  MsgBox "About to define Covariance Source form..."
214:   Set pCovForm = New TopoCorridor.frmCovSource
215:   Set pCovForm.ArcApplication = pParams
  
'  MsgBox "About to define Grid Layers form..."
218:   Set pGrids = New TopoCorridor.frmGridLayers
219:   Set pGrids.ArcApplication = pParams
  
'  MsgBox "About to start loop..."
  
223:   Do Until lngStep = 3
    Select Case lngStep
      Case 1
226:         pCovForm.Show vbModal
227:         If m_pThisExt.ShouldContinue = False Then
228:           m_pThisExt.InputStep = 3
229:         End If
      
      Case 2
232:         pGrids.Show vbModal
'        MsgBox "Should Continue = " & CStr(m_pThisExt.ShouldContinue)
234:         If m_pThisExt.ShouldContinue = False Then
235:           m_pThisExt.InputStep = 3
236:         End If
237:     End Select
238:     lngStep = m_pThisExt.InputStep
239:   Loop
  
241:   Set pCovForm = Nothing
242:   Set pGrids = Nothing
'  MsgBox "Forms Deleted"
'  Exit Sub
  
246:   If m_pThisExt.ShouldContinue = False Then
 '   MsgBox "Operation Canceled..."
    Exit Sub
249:   Else
    Dim strOutputReport As String
    
    Dim pProgressMeter As TopoCorridor.frmJenProgressMeter
253:     Set pProgressMeter = New TopoCorridor.frmJenProgressMeter
254:     Set m_pThisExt.ProgressMeterForm = pProgressMeter
    
256:     strOutputReport = TopoCorridor.Mahal_Functions.MahalanobisRaster(m_pThisExt, m_App, m_MxDoc)
    
258:     Set m_pThisExt.ProgressMeterForm = Nothing
    
    Dim frmReportForm As TopoCorridor.frmReportDialog
261:     Set frmReportForm = New TopoCorridor.frmReportDialog
    
    ' SHOW NORMAL TEXT REPORT
264:     frmReportForm.txtReport.TextRTF = strOutputReport
265:     frmReportForm.txtReport.Locked = False
266:     frmReportForm.Caption = "Analysis Report:"
267:     frmReportForm.Show vbModal
268:     Set frmReportForm = Nothing
  
270:   End If
    
'  ' FOR DEBUGGING - MEAN AND COVARIANCE SOURCES
'  Dim strInputParamsReport As String
'  If m_pThisExt.ShouldContinue = False Then
'    MsgBox "Operation Canceled..."
'  Else
'    Dim pSourceArray As esriSystem.IVariantArray
'    Set pSourceArray = m_pThisExt.frmCovSourceReturn
'    Dim lngType As Long
'    Dim pParamsArray As esriSystem.IVariantArray
'
'    lngType = pSourceArray.Element(0)
'    Set pParamsArray = pSourceArray.Element(1)
'    Dim strSrcReport As String
'
'    Select Case lngType
'      Case 1                   ' POINT THEME
'        Dim pPointLayer As IFeatureLayer
'        Dim booUseAll As Boolean
'        Set pPointLayer = pParamsArray.Element(0)
'        booUseAll = pParamsArray.Element(1)
'        If booUseAll Then
'          strSrcReport = "--> Source = Point Layer [" & pPointLayer.Name & "]" & vbCrLf & _
'                         "    Option to use All Points (n = " & CStr(Format(pParamsArray.Element(2), "#,##0")) & ")"
'        Else
'          strSrcReport = "--> Source = Point Layer [" & pPointLayer.Name & "]" & vbCrLf & _
'                         "    Option to use Selected Points (n = " & CStr(Format(pParamsArray.Element(3), "#,##0")) & _
'                         " of " & CStr(Format(pParamsArray.Element(2), "#,##0")) & ")"
'        End If
'
'      Case 2
'        Dim pRasterBand As IRasterBand
'        Dim strRasterName As String
'        Dim lngFieldIndex As Long
'        Dim pTable As ITable
'        Dim varValue As Variant
'        Dim booIsString As Boolean
'        Dim strFieldName As String
'        Dim pField As IField
'
'        Set pRasterBand = pParamsArray.Element(0)
'        strRasterName = pParamsArray.Element(1)
'        Set pTable = pRasterBand.AttributeTable
'        lngFieldIndex = pParamsArray.Element(2)
'        Set pField = pTable.Fields.Field(lngFieldIndex)
'        strFieldName = pField.Name
'
'        booIsString = pParamsArray.Element(3)
'        varValue = pParamsArray.Element(4)
'
'        strSrcReport = "--> Source = Raster Layer [" & strRasterName & "]" & vbCrLf & _
'                       "  Field Name = " & strFieldName & " at Index #" & CStr(lngFieldIndex) & vbCrLf & _
'                       "  Search Value = " & CStr(varValue) & "  [Is String = " & CStr(booIsString) & "]"
'
'      Case 3
'        Dim pMeanVector As IStandaloneTable
'        Dim pCovMatrix As IStandaloneTable
'        Set pMeanVector = pParamsArray.Element(0)
'        Set pCovMatrix = pParamsArray.Element(1)
'        strSrcReport = "--> Existing Tables:" & vbCrLf & _
'            "  Mean Vector = " & pMeanVector.Name & vbCrLf & _
'            "  Covariance Matrix = " & pCovMatrix.Name
'    End Select
'
'  End If
'
'  strInputParamsReport = strInputParamsReport & "Mean and Covariance Source Options:" & vbCrLf & _
'      strSrcReport & vbCrLf & "-----------------------------------------" & vbCrLf
'
'  ' FOR DEBUGGING - SAVE ANCILLARY STATS TABLES OPTIONS
'  Dim strReport As String
'  Dim pMeansParams As esriSystem.IVariantArray
'  Set pMeansParams = m_pThisExt.StatsSaveMeansOptions
'  Dim pCovParams As esriSystem.IVariantArray
'  Set pCovParams = m_pThisExt.StatsSaveCovOptions
'  Dim pInvCovParams As esriSystem.IVariantArray
'  Set pInvCovParams = m_pThisExt.StatsSaveInvCovOptions
'  Dim pCorrParams As esriSystem.IVariantArray
'  Set pCorrParams = m_pThisExt.StatsSaveCorrelationOptions
'  Dim strMeansReport As String
'  If pMeansParams Is Nothing Then
'    strMeansReport = "  No Means Parameters specified..."
'  Else
'    strMeansReport = "  Table Name = " & pMeansParams.Element(0) & vbCrLf & _
'    "  WS Path = " & pMeansParams.Element(1) & vbCrLf & _
'    "  Full Path = " & pMeansParams.Element(2) & vbCrLf & _
'    "  Workspace Type = " & CStr(pMeansParams.Element(3))
'  End If
'  Dim strCovReport As String
'  If pCovParams Is Nothing Then
'    strCovReport = "  No Covariance Parameters specified..."
'  Else
'    strCovReport = "  Table Name = " & pCovParams.Element(0) & vbCrLf & _
'    "  WS Path = " & pCovParams.Element(1) & vbCrLf & _
'    "  Full Path = " & pCovParams.Element(2) & vbCrLf & _
'    "  Workspace Type = " & CStr(pCovParams.Element(3))
'  End If
'  Dim strInvCovReport As String
'  If pInvCovParams Is Nothing Then
'    strInvCovReport = "  No Inverse Covariance Parameters specified..."
'  Else
'    strInvCovReport = "  Table Name = " & pInvCovParams.Element(0) & vbCrLf & _
'    "  WS Path = " & pInvCovParams.Element(1) & vbCrLf & _
'    "  Full Path = " & pInvCovParams.Element(2) & vbCrLf & _
'    "  Workspace Type = " & CStr(pInvCovParams.Element(3))
'  End If
'  Dim strCorrReport As String
'  If pCorrParams Is Nothing Then
'    strCorrReport = "  No Correlation Parameters specified..."
'  Else
'    strCorrReport = "  Table Name = " & pCorrParams.Element(0) & vbCrLf & _
'    "  WS Path = " & pCorrParams.Element(1) & vbCrLf & _
'    "  Full Path = " & pCorrParams.Element(2) & vbCrLf & _
'    "  Workspace Type = " & CStr(pCorrParams.Element(3))
'  End If
'  strReport = _
'    "Save Means = " & CStr(m_pThisExt.StatsSaveMeans) & vbCrLf & strMeansReport & vbCrLf & _
'    "Save Covariances = " & CStr(m_pThisExt.StatsSaveCov) & vbCrLf & strCovReport & vbCrLf & _
'    "Save Inverse Covariances = " & CStr(m_pThisExt.StatsSaveInvCov) & vbCrLf & strInvCovReport & vbCrLf & _
'    "Save Correlation = " & CStr(m_pThisExt.StatsSaveCorrelation) & vbCrLf & strCorrReport
'
'  strInputParamsReport = strInputParamsReport & "Save Ancillary Tables Options:" & vbCrLf & _
'      strReport & vbCrLf & "-----------------------------------------" & vbCrLf
'
'  ' FOR DEBUGGING - MAHALANOBIS INPUT VARIABLES
'  Dim lngCheckIndex As Long
'  Dim pSelectedArray As esriSystem.IVariantArray
'  Dim pSubArray As esriSystem.IVariantArray
'  Dim pUnknown As IUnknown
'  Dim pOptions As esriSystem.IVariantArray
'  Dim strMahal As String
'  Dim strWS As String
'  Dim lngWSType As JenDatasetTypes
'  Dim booExact As Boolean
'
'  Set pOptions = m_pThisExt.frmGridLayersReturn
'  Set pSelectedArray = pOptions.Element(0)
'  booExact = pOptions.Element(1)
'  strWS = pOptions.Element(2)
'  lngWSType = pOptions.Element(3)
'  strMahal = pOptions.Element(4)
'
'  strReport = "Selected Mahalanobis Data Layer Options:" & vbCrLf & _
'              "  --> Workspace = " & strWS & vbCrLf & _
'              "  --> Workspace Type = " & lngWSType & vbCrLf & _
'              "  --> Name = " & strMahal & vbCrLf & _
'              "  --> " & CStr(pSelectedArray.Count) & " selected data layers:" & vbCrLf
'
'  For lngCheckIndex = 0 To pSelectedArray.Count - 1
'    Set pSubArray = pSelectedArray.Element(lngCheckIndex)
'    Set pUnknown = pSubArray.Element(2)
'    If pSubArray.Element(1) = "Raster" Then
'      strReport = strReport & "   " & CStr(lngCheckIndex + 1) & "] RASTER: " & pSubArray.Element(3) & vbCrLf & _
'                              "       Dataset is IRaster = " & CStr(TypeOf pUnknown Is IRaster) & vbCrLf
'    Else
'      Set pField = pSubArray.Element(5)
'      strReport = strReport & "   " & CStr(lngCheckIndex + 1) & "] POLYGON FEATURE LAYER: " & pSubArray.Element(3) & vbCrLf & _
'                              "       Attribute Field:  Name = " & pField.Name & ",   Index = " & pSubArray.Element(4) & vbCrLf & _
'                              "       Dataset is IFeatureLayer = " & CStr(TypeOf pUnknown Is IFeatureLayer) & vbCrLf
'    End If
'  Next lngCheckIndex
'
'  strInputParamsReport = strInputParamsReport & "Mahalanobis Input Variable Options:" & vbCrLf & _
'      strReport & vbCrLf & "-----------------------------------------" & vbCrLf
'
'
'  Dim frmReportForm As TopoCorridor.frmReportDialog
'  Set frmReportForm = New TopoCorridor.frmReportDialog
'
'  ' SHOW NORMAL TEXT REPORT
'  frmReportForm.txtReport.Text = strInputParamsReport
'  frmReportForm.txtReport.Locked = False
'  frmReportForm.Caption = "Analysis Options:"
'  frmReportForm.Show vbModal
'  Set frmReportForm = Nothing
  
  ' CLEAR MEMORY
448:   Set m_pThisExt.frmCovReloadParams = Nothing
449:   Set m_pThisExt.frmCovBasicReloadParams = Nothing
450:   Set m_pThisExt.frmCovSourceReturn = Nothing
451:   Set m_pThisExt.frmGridLayersReturn = Nothing
452:   Set m_pThisExt.frmLayerIDReturn = Nothing

  Dim pDirty As IDocumentDirty
455:   Set pDirty = m_MxDoc
456:   pDirty.SetDirty
457:   m_App.Visible = True
  
  Exit Sub
ErrorHandler:
  HandleError True, "ICommand_OnClick " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub













