Attribute VB_Name = "Module1"
'Option Explicit
'
'Public Function CreateDensityRaster(pDocParams As esriSystem.IVariantArray, _
'    pParams As esriSystem.IVariantArray) As String
'  On Error GoTo ErrorHandler
'
'
'  Dim pApp As IApplication
'  Dim pMxDoc As IMxDocument
'  Dim pThisExt As TopoCorridor.clsExtension
'
'  Set pApp = pDocParams.Element(0)
'  Set pMxDoc = pDocParams.Element(1)
'  Set pThisExt = pDocParams.Element(2)
'
'  Dim lngIndex As Long
'  Dim lngIndex2 As Long
'  Dim lngIndex3 As Long
'
'
'  Dim datBegan As Date
'  datBegan = Now
'
'  Dim strReport As String
'  strReport = "Function failed..."
'
'  CreateDensityRaster = strReport
'
'  Dim pInputBand As IRasterBand
'  Dim pRastLayer As IRasterLayer
'  Dim pGeoDataset As IGeoDataset
'  Dim pInputDataset As IRasterDataset
'  Dim pInputRaster As IRaster2
'  Dim pEnv As IEnvelope
'  Dim strSaveFormat As String
'  Dim lngNbrHoodRadius As Long
'  Dim strNewRasterName As String
'  Dim booIsFGB As Boolean
'  Dim pRastWS As IRasterWorkspace2
'  Dim pRastWsEx As IRasterWorkspaceEx
'  Dim strSaveFormatString As String
'  Dim pWS As IWorkspace
'  Dim strExtension As String
'  Dim strInputName As String
'  Dim booExcludeIfAnyNull As Boolean
'  booExcludeIfAnyNull = False
'
'  Dim strFieldName As String
'  Dim strSelAttribute As String
'  Dim pSearchValues As esriSystem.IDoubleArray
'
'  ' RETURN ARRAY IS IVariantArray, CONTAINING:
'  ' 0) IRasterBand: SELECTED RASTER BAND
'  ' 1) STRING: Name of original raster band
'  ' 2) STRING: Name of selected attribute field
'  ' 3) STRING: Selected Attribute Value
'  ' 4) IDoubleArray: Array of cell values that correspond with this selected attribute value
'  ' 5) STRING: Save Format
'  ' 6) STRING: TEXT VERSION OF SAVE FORMAT
'  ' 7) STRING: New Raster Name
'  ' 8) BOOLEAN: Whether new workspace is File Geodatabase
'  ' 9) IWORKSPACE: Either an IRasterWorkspace2 or an IRasterWorkspaceEx
'  '10) STRING: Extension for output
'  '11) LONG: Neighborhood Radius, in Cells
'  '12) BOOLEAN: Whether to set to NoData if any NoData cells present
'
''  MsgBox "pParams.Count = " & CStr(pParams.Count)
''  MsgBox "VarType(pParams.Element(0)) = " & CStr(VarType(pParams.Element(0)))
''  MsgBox "TypeOf pParams.Element(0) Is ILayer = " & CStr(TypeOf pParams.Element(0) Is ILayer)
''  MsgBox "TypeOf pParams.Element(0) Is IRasterLayer = " & CStr(TypeOf pParams.Element(0) Is IRasterLayer)
'
'  Set pInputBand = pParams.Element(0)
'  Set pGeoDataset = pInputBand
'  Set pEnv = pGeoDataset.Extent
'  strInputName = pParams.Element(1)
'  strFieldName = pParams.Element(2)
'  strSelAttribute = pParams.Element(3)
'  Set pSearchValues = pParams.Element(4)
'  strSaveFormat = pParams.Element(5)
'  strSaveFormatString = pParams.Element(6)
'  strNewRasterName = pParams.Element(7)
'  booIsFGB = pParams.Element(8)
'  Set pWS = pParams.Element(9)
'  If booIsFGB Then
'    Set pRastWsEx = pWS
'  Else
'    Set pRastWS = pWS
'  End If
'  strExtension = pParams.Element(10)
'  lngNbrHoodRadius = pParams.Element(11)
'  booExcludeIfAnyNull = pParams.Element(12)
'
'  Dim dblSearchVals() As Double
'  ReDim dblSearchVals(pSearchValues.Count - 1)
'  For lngIndex = 0 To pSearchValues.Count - 1
'    dblSearchVals(lngIndex) = pSearchValues.Element(lngIndex)
'  Next lngIndex
'
'  Dim pRastDataset As IRasterDataset3
'
'  Dim pSaveAs As ISaveAs2
'  Dim pRasterProp As IRasterProps
'  Dim pRasLy As IRasterLayer
''  Dim pRaster As IRaster2
'  Dim pRastStDef As IRasterStorageDef2
'  Dim pRastProps As IRasterProps
'
'  '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'  '/////////// |                  | \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
'  '----------  |   CALCULATIONS   |  ---------------------------------------------------------------------------
'  '\\\\\\\\\\\ |                  | ///////////////////////////////////////////////////////////////////////////
'  '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'
'  Dim pPro As IStepProgressor
'  Dim psbar As IStatusBar
'
'  Dim pTempBandColl As IRasterBandCollection
'  Set pTempBandColl = New Raster
'  pTempBandColl.AppendBand pInputBand
'  Set pInputRaster = pTempBandColl
'  Set pRastProps = pInputRaster
''  pRastProps.SpatialReference = pGeoDataset.SpatialReference
'
'  Set psbar = pApp.StatusBar
'  Set pPro = psbar.ProgressBar
'
'  Dim lngHeight As Long
'  Dim lngWidth As Long
''  Dim dblCellSize As Double
'  Dim dblNoData As Double
'  Dim varNoData As Variant
'
''  dblCellSize = (pRastProps.MeanCellSize.X + pRastProps.MeanCellSize.Y) / 2
'  lngWidth = pRastProps.Width
'  lngHeight = pRastProps.Height
'  varNoData = pRastProps.NoDataValue
' ' dblNoData = CDbl(varNoData)
'
''  If lngWidth < 3 Or lngHeight < 3 Then
''    MsgBox "Invalid Raster:  Size must be greater than 3 x 3 cells..." & vbCrLf & "Exiting Function..."
''    CalcSurfaceArea = "Invalid Raster:  Size must be greater than 3 x 3 cells..." & vbCrLf & "Function cancelled..."
''    Exit Function
''  End If
'
'  ' PROGRESS STUFF
'  pPro.position = 0
'  psbar.ShowProgressBar "Calculating Density of '" & strSelAttribute & "' in Cell Neighborhoods...", 1, lngHeight, 1, True
'  pPro.Message = "Calculating Density of '" & strSelAttribute & "' in Cell Neighborhoods..."
'
'  Dim pPnt As IPnt
'  Set pPnt = New Pnt
'  pPnt.SetCoords lngWidth, 1
'
'  Dim pPixBlock As IPixelBlock3
'
'  Dim pTopLeft As IPnt
'
'  Dim varNoDataArray As Variant
'  Dim booHasData() As Boolean
'  Dim varData As Variant
'  Dim varEmptyData() As Variant
'  ReDim varEmptyData(lngWidth - 1)
'
''
''  ' MAKE MASK ARRAY
''  Dim booMaskArray() As Boolean
''  ReDim booMaskArray((lngNbrHoodRadius * 2), (lngNbrHoodRadius * 2))
''  For lngIndex = 0 To (lngNbrHoodRadius * 2)
''    For lngIndex2 = 0 To (lngNbrHoodRadius * 2)
''      booMaskArray(lngIndex, lngIndex2) = _
''          Sqr(((lngNbrHoodRadius - lngIndex) ^ 2) + ((lngNbrHoodRadius - lngIndex2) ^ 2)) <= lngNbrHoodRadius
''    Next lngIndex2
''  Next lngIndex
'
'  ' MAKE MASK ARRAY
'  Dim booMaskArray() As Boolean
'  Dim booCheck As Boolean
'  Dim lngTotalCount As Long
'  ReDim booMaskArray((lngNbrHoodRadius * 2), (lngNbrHoodRadius * 2))
'  For lngIndex = 0 To (lngNbrHoodRadius * 2)
'    For lngIndex2 = 0 To (lngNbrHoodRadius * 2)
'       booCheck = Sqr(((lngNbrHoodRadius - lngIndex) ^ 2) + ((lngNbrHoodRadius - lngIndex2) ^ 2)) <= lngNbrHoodRadius
'       booMaskArray(lngIndex, lngIndex2) = booCheck
'       If booCheck Then lngTotalCount = lngTotalCount + 1
'    Next lngIndex2
'  Next lngIndex
'
'  ' FOR DEBUGGING
''  Dim strDebugReport As String
''  strDebugReport = ""
''  For lngIndex = 0 To (lngNbrHoodRadius * 2)
''    For lngIndex2 = 0 To (lngNbrHoodRadius * 2)
''      strDebugReport = strDebugReport & Left(UCase(CStr(booMaskArray(lngIndex, lngIndex2))), 1) & "  "
''    Next lngIndex2
''    strDebugReport = strDebugReport & vbCrLf
''  Next lngIndex
'
'  Dim varCalcDataArray() As Variant
'  ReDim varCalcDataArray((lngNbrHoodRadius * 2), (lngNbrHoodRadius * 2))
'  Dim booCalcHasDataArray() As Boolean
'  ReDim booCalcHasDataArray((lngNbrHoodRadius * 2), (lngNbrHoodRadius * 2))
'  Dim lngDataIndexX As Long
'  Dim lngDataIndexY As Long
'
'  Dim dblDensity As Double
'  Dim booDensityIsNull As Boolean
'
'
'
'
'    ' OPTION 5, BACK TO RASTER CURSOR, 3 MINUTES 45 SECONDS FOR TEST
'
'  ' CREATE RASTERS TO WRITE TO -----------------------------------------------------------------------------------
'  ' Create the dataset
'  Dim pOutDS As IRasterDataset2
'  Dim pOutRasterEdit As IRasterEdit
'
'  Dim pRasterStorDef As IRasterStorageDef2
'  Dim pRasterDef As IRasterDef
'  Dim pGeomDef As IGeometryDef
'
'  Dim pOriginPoint As IPoint
'  Set pOriginPoint = New Point
'  pOriginPoint.PutCoords pRastProps.Extent.XMin, pRastProps.Extent.YMin
'
'  Dim pOutPnt As IPnt
'  Set pOutPnt = New Pnt
'  Dim lngFocalRow As Long
'
'  Dim pSpRef As ISpatialReference
'  Set pSpRef = pRastProps.SpatialReference
'
'  ' IRasterStorageDef
'  Set pRasterStorDef = New RasterStorageDef
'  Set pRasterStorDef.CellSize = pRastProps.MeanCellSize
'  pRasterStorDef.CompressionType = esriRasterSdeCompressionTypeRunLength
'  pRasterStorDef.PyramidLevel = 2
'  pRasterStorDef.PyramidResampleType = RSP_BilinearInterpolation
'  pRasterStorDef.TileHeight = 128
'  pRasterStorDef.TileWidth = 128
'
'  ' IRasterDef
'  Set pRasterDef = New RasterDef
'  Set pRasterDef.SpatialReference = pSpRef
'  pRasterDef.Description = "rasterdataset"
'
'  ' IGeometryDef
'  Set pGeomDef = Nothing
'
'  Dim pOutProps As IRasterProps
'  Dim pOutBandColl As IRasterBandCollection
'  Dim pTempOutBandColl As IRasterBandCollection
'  Dim pOutBand As IRasterBand
'  Dim pRastDatasetEdit As IRasterDatasetEdit2
'  Dim pTempOutRaster As IRaster
'
'  Set pRasterStorDef.CellSize = pRastProps.MeanCellSize
'  If booIsFGB Then
'    Set pOutDS = pRastWsEx.CreateRasterDataset(strNewRasterName, 1, PT_FLOAT, pRasterStorDef, _
'        "DEFAULTS", pRasterDef, pGeomDef)
'    Set pTempOutBandColl = pOutDS
'    Set pTempOutRaster = New Raster
'    Set pOutBandColl = pTempOutRaster
'    pOutBandColl.AppendBands pTempOutBandColl
'    pTempOutRaster.ResampleMethod = RSP_BilinearInterpolation
'
'    Set pOutProps = pTempOutRaster
'    pOutProps.Extent = pRastProps.Extent
'    pOutProps.Height = pRastProps.Height
'    pOutProps.Width = pRastProps.Width
'    pOutProps.SpatialReference = pSpRef
'    pOutProps.PixelType = PT_FLOAT
'  Else
'    Set pOutDS = pRastWS.CreateRasterDataset(strNewRasterName & strExtension, strSaveFormat, pOriginPoint, lngWidth, lngHeight, _
'        pRastProps.MeanCellSize.X, pRastProps.MeanCellSize.Y, 1, PT_FLOAT, pSpRef, True)
'  End If
'
'  Dim pOutputPixBlock As IPixelBlock3
'
'  ' OUTPUT VARIABLES
'  Dim pOutputRaster As IRaster2
'  Dim pOutputRaster2 As IRaster
'  Dim pPixelData As Variant
'  Dim pRawPixel As IRawPixels
'  Dim pOutPixelBlock As IPixelBlock3
'  Dim pBands As IRasterBandCollection
'  Dim pOutputRastProps As IRasterProps
'  Dim pCache As Variant
'
'  ' QI for IRawPixels and IRasterProps
'  Set pOutputRaster = pOutDS.CreateFullRaster
'  Set pOutputRaster2 = pOutputRaster
'  Set pOutRasterEdit = pOutputRaster
'  Set pBands = pOutDS
'  Set pRawPixel = pBands.Item(0)
'  Set pOutputRastProps = pRawPixel
'  If Not booIsFGB Then
'    pOutputRastProps.NoDataValue = CInt(-9999)
'  End If
''  Set pOutPixelBlock = pRawPixel.CreatePixelBlock(pPnt)
'  Set pOutputPixBlock = pOutputRaster2.CreatePixelBlock(pPnt)
'  pOutputPixBlock.PixelType(0) = PT_FLOAT
'  Dim varOutData As Variant
'
'
'
'
'
'
'
'
'  ' ----------------------------
'  Dim varNbrHeightArray() As Variant
'  ReDim varNbrHeightArray(lngWidth - 1, (lngNbrHoodRadius * 2))
'  Dim booNbrHeightHasDataArray() As Boolean
'  ReDim booNbrHeightHasDataArray(lngWidth - 1, (lngNbrHoodRadius * 2))
'
'  Dim lngPixBlockWidth As Long
'  Dim lngPixBlockHeight As Long
'  Dim lngLastColumn As Long
'  lngPixBlockWidth = lngWidth - 1 - lngNbrHoodRadius
'  lngPixBlockHeight = (lngNbrHoodRadius * 2)
'  lngLastColumn = (lngNbrHoodRadius * 2)
'
'  ' ADD FIRST LINE OF DATA
'  Dim pRastCursor As IRasterCursor
'  Set pRastCursor = pInputRaster.CreateCursorEx(pPnt)
'
'  Set pPixBlock = pRastCursor.PixelBlock
'  pPixBlock.PixelType(0) = PT_FLOAT
'  pRastCursor.Reset
'  Set pPixBlock = pRastCursor.PixelBlock
'  varData = pPixBlock.PixelData(0)
'  booHasData = ConvertNoDataMaskToSomethingUseful(pPixBlock.NoDataMask(0))
''
''  ' BELOW IS WORKAROUND FOR PROBLEM IN WHICH PIXEL BLOCK APPEARS TO NOT BE ABLE TO CORRECTLY READ FIRST ROW.
''  ' I THINK THIS HAS SOMETHING TO DO WITH SETTING THE PIXEL TYPE TO PT_FLOAT.  IT READS IT CORRECTLY AFTER
''  ' THAT POINT, BUT I CANNOT SET IT BEFORE READING THE FIRST ROW FROM RASTER CURSOR, EVEN AFTER USING 'RESET'.
''  ' CODE BELOW SIMPLY EXTRACTS varData1 and booHasData1 FROM A DIFFERENT PIXEL BLOCK THAT IS READ CORRECTLY.
'  Dim pTempPixBlock As IPixelBlock3
'  Dim pTempRaster As IRaster
'  Set pTempRaster = pInputRaster
'  Dim pTempPoint As IPnt
'  Set pTempPoint = New Pnt
'  pTempPoint.SetCoords CInt(lngWidth), 1
'  Set pTempPixBlock = pTempRaster.CreatePixelBlock(pTempPoint)
'  pTempPixBlock.PixelType(0) = PT_FLOAT
'  Dim pTempOrigin As IPnt
'  Set pTempOrigin = New Pnt
'
'  Dim lngRowCounter As Long
'  lngRowCounter = -1
'  Dim varVal As Variant
''  Dim dblVal As Double
'
'  pTempOrigin.SetCoords 0, 0
'  pTempRaster.Read pTempOrigin, pTempPixBlock
'  varData = pTempPixBlock.PixelDataByRef(0)
'  booHasData = ConvertNoDataMaskToSomethingUseful(pTempPixBlock.NoDataMaskByRef(0))
'
'  ' FROM HERE ON OUT, RASTER CURSOR SEEMS TO WORK
' ' MsgBox "UBound(varNbrHeightArray, 1) = " & CStr(UBound(varNbrHeightArray, 1)) & vbCrLf & _
'         "UBound(varNbrHeightArray, 2) = " & CStr(UBound(varNbrHeightArray, 2)) & vbCrLf & _
'         "UBound(booNbrHeightHasDataArray, 1) = " & CStr(UBound(booNbrHeightHasDataArray, 1)) & vbCrLf & _
'         "UBound(booNbrHeightHasDataArray, 2) = " & CStr(UBound(booNbrHeightHasDataArray, 2)) & vbCrLf & _
'         "UBound(varData, 1) = " & CStr(UBound(varData, 1)) & vbCrLf & _
'         "UBound(varData, 2) = " & CStr(UBound(varData, 2)) & vbCrLf & _
'         "lngWidth = " & CStr(lngWidth) & vbCrLf & _
'         "lngNbrHoodRadius = " & CStr(lngNbrHoodRadius)
''
''  MsgBox "IsNull(varData(0)) = " & CStr(IsNull(varData(0)))
''  MsgBox "IsNull(varNbrHeightArray(0,6)) = " & CStr((varNbrHeightArray(0, 6)))
'
'  ' ADD LINE OF DATA TO [CENTRAL ROW + 1] OF varNbrHeightArray AND booNbrHeightHasDataArray
'  For lngIndex = 0 To UBound(varNbrHeightArray, 1)
'    varNbrHeightArray(lngIndex, lngNbrHoodRadius + 1) = varData(lngIndex, 0)
'    booNbrHeightHasDataArray(lngIndex, lngNbrHoodRadius + 1) = booHasData(lngIndex)
'  Next lngIndex
'
'  ' ADD REST OF ROWS TO FILL OUT NEIGHBORHOOD HEIGHT
'  If lngNbrHoodRadius > 1 Then
'    For lngIndex = 2 To lngNbrHoodRadius
'      pRastCursor.Next
'      pPro.Step
'      DoEvents
'      Set pPixBlock = pRastCursor.PixelBlock
'      pPixBlock.PixelType(0) = PT_FLOAT
'      varData = pPixBlock.PixelDataByRef(0)
'      booHasData = ConvertNoDataMaskToSomethingUseful(pPixBlock.NoDataMaskByRef(0))
'      For lngIndex2 = 0 To UBound(varNbrHeightArray, 1)
'        varNbrHeightArray(lngIndex2, lngNbrHoodRadius + lngIndex) = varData(lngIndex, 0)
'        booNbrHeightHasDataArray(lngIndex2, lngNbrHoodRadius + lngIndex) = booHasData(lngIndex)
'      Next lngIndex2
'    Next lngIndex
'  End If
'
'  ' READY TO START DOING AN ANALYSIS
'  ' REMEMBER THAT ALWAYS WORKING lngNbrHoodRadius ROWS BEHIND THE CURRENT RASTER CURSOR POSITION
'
'    ' WORK THROUGH REST OF RASTER
'  Dim lngSliceRowIndex As Long
'  Dim lngSliceColIndex As Long
'  Dim lngColIndex As Long
'  Dim lngColumnToTest As Long
'  Dim lngLastRowIndex As Long
'  lngLastRowIndex = lngNbrHoodRadius * 2
'  Dim lngLastColIndex As Long
'  lngLastColIndex = lngNbrHoodRadius * 2
'
''  MsgBox "pDataLinesArray has " & CStr(pDataLinesArray.Count) & " elements..." & vbCrLf & _
''        "pBooHasDataArray has " & CStr(pBooHasDataArray.Count) & " elements..."
'
'  Dim lngRowOfDataCounter As Long
'  lngRowOfDataCounter = lngNbrHoodRadius
'
'  ' IF lngRowOfDataCounter ACTUALLY IS lngHeight, THEN IT IS ONE ROW TOO FAR.
'
'  lngFocalRow = -1
'  Do Until lngRowOfDataCounter = lngHeight - 1
'
'    lngFocalRow = lngFocalRow + 1
'
'    ' ADD NEW ROWS TO BOTTOM OF SLICE, AND DELETE TOP ROWS
'    lngRowOfDataCounter = lngRowOfDataCounter + 1
'    pRastCursor.Next
'    pPro.Step
'    DoEvents
'    Set pPixBlock = pRastCursor.PixelBlock
'    pPixBlock.PixelType(0) = PT_FLOAT
'
'    ' SHIFT ALL ROWS UP BY ONE
'    For lngDataIndexX = 0 To UBound(varNbrHeightArray, 1)
'      For lngDataIndexY = 1 To lngLastRowIndex
'        varNbrHeightArray(lngDataIndexX, lngDataIndexY - 1) = varNbrHeightArray(lngDataIndexX, lngDataIndexY)
'        booNbrHeightHasDataArray(lngDataIndexX, lngDataIndexY - 1) = booNbrHeightHasDataArray(lngDataIndexX, lngDataIndexY)
'      Next lngDataIndexY
'    Next lngDataIndexX
'
'    ' RESET LOWEST ROW TO NEW VALUES
'    varData = pPixBlock.PixelDataByRef(0)
'    booHasData = ConvertNoDataMaskToSomethingUseful(pPixBlock.NoDataMaskByRef(0))
'    For lngIndex2 = 0 To UBound(varNbrHeightArray, 1)
'      varNbrHeightArray(lngIndex2, lngLastRowIndex) = varData(lngIndex2, 0)
'      booNbrHeightHasDataArray(lngIndex2, lngLastRowIndex) = booHasData(lngIndex2)
'    Next lngIndex2
'
'    ' ANALYZE THIS SLICE OF RASTER
'    ' START WITH ARRAY FULL OF NULL VALUES
'    For lngDataIndexX = 0 To UBound(varCalcDataArray, 1)
'      For lngDataIndexY = 0 To UBound(varCalcDataArray, 2)
'        varCalcDataArray(lngDataIndexX, lngDataIndexY) = Null
'        booCalcHasDataArray(lngDataIndexX, lngDataIndexY) = False
'      Next lngDataIndexY
'    Next lngDataIndexX
'
'
'
'    ' WRITE ROW
'    pOutPnt.SetCoords 0, lngFocalRow
'    'pRawPixel.Read pOutPnt, pOutPixelBlock
'    pOutputRaster2.Read pOutPnt, pOutputPixBlock
'    varOutData = pOutputPixBlock.PixelData(0)
''    pOutPixelBlock.PixelType(0) = PT_FLOAT
''    pPixelData = pOutPixelBlock.PixelDataByRef(0)
'
'    ' START AT NEG RADIUS SO CAN FILL UP HALF OF ARRAY BEFORE CALCULATING
'    For lngIndex2 = -lngNbrHoodRadius To (lngWidth - 1)
'
'      ' SHIFT VALUES IN DATA ARRAY ONE STEP TO LEFT
'      For lngDataIndexX = 1 To (lngNbrHoodRadius * 2)
'        For lngDataIndexY = 0 To (lngNbrHoodRadius * 2)
'          varCalcDataArray(lngDataIndexX - 1, lngDataIndexY) = varCalcDataArray(lngDataIndexX, lngDataIndexY)
'          booCalcHasDataArray(lngDataIndexX - 1, lngDataIndexY) = booCalcHasDataArray(lngDataIndexX, lngDataIndexY)
'        Next lngDataIndexY
'      Next lngDataIndexX
'
'      For lngIndex3 = 0 To lngLastRowIndex
'        If lngIndex2 <= lngPixBlockWidth Then     ' MEANING IF WE ARE ACTUALLY IN RASTER; NOT FILLING LATER CELLS WITH NULLS
''            varVal = varData(lngIndex2 + lngNbrHoodRadius, lngIndex3)
'          varCalcDataArray(lngLastColIndex, lngIndex3) = varNbrHeightArray(lngIndex2 + lngNbrHoodRadius, lngIndex3)
'          booCalcHasDataArray(lngLastColIndex, lngIndex3) = booNbrHeightHasDataArray(lngIndex2 + lngNbrHoodRadius, lngIndex3)
'        Else
'          varCalcDataArray(lngLastColIndex, lngIndex3) = Null
'          booCalcHasDataArray(lngLastColIndex, lngIndex3) = False
'        End If
'      Next lngIndex3
'
'      If lngIndex2 >= 0 Then                        ' MEANING IF WE ARE ACTUALLY IN RASTER; NOT FILLING EARLIER CELLS WITH NULLS
'        ' CALCULATE DENSITY VALUE
'        dblDensity = CalcDensityFromArray(varCalcDataArray, booMaskArray, booCalcHasDataArray, _
'                  booDensityIsNull, booExcludeIfAnyNull, dblSearchVals, lngTotalCount)
'        If booExcludeIfAnyNull Then
'          If booDensityIsNull Then
'            If Not booIsFGB Then
'  '            pPixelData(lngIndex2, 0) = CInt(-9999)
'              varOutData(lngIndex2, 0) = CInt(-9999)
'            End If
'          Else
'  '          pPixelData(lngIndex2, 0) = dblDensity
'            varOutData(lngIndex2, 0) = dblDensity
'          End If
'        Else
'          varOutData(lngIndex2, 0) = dblDensity
'        End If
'      End If
'    Next lngIndex2
'
'    ' SAVE DATA TO HARD DRIVE
'    pOutputPixBlock.PixelData(0) = varOutData
'    pOutRasterEdit.Write pOutPnt, pOutputPixBlock
'    If lngRowOfDataCounter Mod 10 = 0 Then
'      pOutRasterEdit.Refresh
'    End If
''    pOutPixelBlock.PixelData(0) = pPixelData
''    Set pCache = pRawPixel.AcquireCache
''    pRawPixel.Write pOutPnt, pOutPixelBlock
''    pRawPixel.ReturnCache pCache
'
'  Loop
'  pOutRasterEdit.Refresh
'
'  ' CONTINUE UNTIL FINISHED WITH NEIGHBORHOOD RADIUS
'  For lngIndex = 0 To lngNbrHoodRadius
'    lngFocalRow = lngFocalRow + 1
'
'    ' SHIFT ALL ROWS UP BY ONE
'    For lngDataIndexX = 0 To UBound(varNbrHeightArray, 1)
'      For lngDataIndexY = 1 To lngLastRowIndex
'        varNbrHeightArray(lngDataIndexX, lngDataIndexY - 1) = varNbrHeightArray(lngDataIndexX, lngDataIndexY)
'        booNbrHeightHasDataArray(lngDataIndexX, lngDataIndexY - 1) = booNbrHeightHasDataArray(lngDataIndexX, lngDataIndexY)
'      Next lngDataIndexY
'      ' SET LOWEST ROW TO NO DATA
'      booNbrHeightHasDataArray(lngDataIndexX, lngLastRowIndex) = False
'    Next lngDataIndexX
'
'    ' ANALYZE THIS SLICE OF RASTER
'    ' START WITH ARRAY FULL OF NULL VALUES
'    For lngDataIndexX = 0 To UBound(varCalcDataArray, 1)
'      For lngDataIndexY = 0 To UBound(varCalcDataArray, 2)
'        varCalcDataArray(lngDataIndexX, lngDataIndexY) = Null
'        booCalcHasDataArray(lngDataIndexX, lngDataIndexY) = False
'      Next lngDataIndexY
'    Next lngDataIndexX
'
''    ' WRITE ROW
''    pOutPnt.SetCoords 0, lngFocalRow
''    pRawPixel.Read pOutPnt, pOutPixelBlock
''
''    pOutPixelBlock.PixelType(0) = PT_FLOAT
''    pPixelData = pOutPixelBlock.PixelDataByRef(0)
'
'    ' WRITE ROW
'    pOutPnt.SetCoords 0, lngFocalRow
'    pOutputRaster2.Read pOutPnt, pOutputPixBlock
'    varOutData = pOutputPixBlock.PixelData(0)
'
'    ' START AT NEG RADIUS SO CAN FILL UP HALF OF ARRAY BEFORE CALCULATING
'    For lngIndex2 = -lngNbrHoodRadius To (lngWidth - 1)
'
'      ' SHIFT VALUES IN DATA ARRAY ONE STEP TO LEFT
'      For lngDataIndexX = 1 To (lngNbrHoodRadius * 2)
'        For lngDataIndexY = 0 To (lngNbrHoodRadius * 2)
'          varCalcDataArray(lngDataIndexX - 1, lngDataIndexY) = varCalcDataArray(lngDataIndexX, lngDataIndexY)
'          booCalcHasDataArray(lngDataIndexX - 1, lngDataIndexY) = booCalcHasDataArray(lngDataIndexX, lngDataIndexY)
'        Next lngDataIndexY
'      Next lngDataIndexX
'
'      If lngIndex2 >= 0 Then                        ' MEANING IF WE ARE ACTUALLY IN RASTER; NOT FILLING EARLIER CELLS WITH NULLS
'        For lngIndex3 = 0 To lngLastRowIndex
'          If lngIndex2 <= lngPixBlockWidth Then     ' MEANING IF WE ARE ACTUALLY IN RASTER; NOT FILLING LATER CELLS WITH NULLS
''            varVal = varData(lngIndex2 + lngNbrHoodRadius, lngIndex3)
'            varCalcDataArray(lngLastColIndex, lngIndex3) = varNbrHeightArray(lngIndex2 + lngNbrHoodRadius, lngIndex3)
'            booCalcHasDataArray(lngLastColIndex, lngIndex3) = booNbrHeightHasDataArray(lngIndex2 + lngNbrHoodRadius, lngIndex3)
'          Else
'            varCalcDataArray(lngLastColIndex, lngIndex3) = Null
'            booCalcHasDataArray(lngLastColIndex, lngIndex3) = False
'          End If
'        Next lngIndex3
'
'        ' CALCULATE DENSITY INDEX VALUE
'        dblDensity = CalcDensityFromArray(varCalcDataArray, booMaskArray, booCalcHasDataArray, _
'                  booDensityIsNull, booExcludeIfAnyNull, dblSearchVals, lngTotalCount)
'        If booExcludeIfAnyNull Then
'          If booDensityIsNull Then
'            If Not booIsFGB Then
'  '            pPixelData(lngIndex2, 0) = CInt(-9999)
'              varOutData(lngIndex2, 0) = CInt(-9999)
'            End If
'          Else
'  '          pPixelData(lngIndex2, 0) = dblDensity
'            varOutData(lngIndex2, 0) = dblDensity
'          End If
'        Else
'          varOutData(lngIndex2, 0) = dblDensity
'        End If
'      End If
'    Next lngIndex2
'
'    ' SAVE DATA TO HARD DRIVE
'    pOutputPixBlock.PixelData(0) = varOutData
'    pOutRasterEdit.Write pOutPnt, pOutputPixBlock
'    pOutRasterEdit.Refresh
''    pOutPixelBlock.PixelData(0) = pPixelData
''    Set pCache = pRawPixel.AcquireCache
''    pRawPixel.Write pOutPnt, pOutPixelBlock
''    pRawPixel.ReturnCache pCache
'
'  Next lngIndex
'
'
''  ----------------------------
'  Dim pNewLayer As IRasterLayer
'
'  Dim pStatsBandColl As IRasterBandCollection
'  Dim pStatsBand As IRasterBand
'  Set pStatsBandColl = pOutDS
'  Set pStatsBand = pStatsBandColl.Item(0)
'  pStatsBand.ComputeStatsAndHist
'
'  ' ADD RASTER TO MAP DOCUMENT
'  Set pNewLayer = New RasterLayer
''  pNewLayer.CreateFromRaster pMultiplyStep2
'  pNewLayer.CreateFromDataset pOutDS
'  pNewLayer.Name = strNewRasterName
'
'  ' SYMBOLIZE RASTER LAYER
'
'  ' Create renderer and QI RasterRenderer
'  Dim pStretchRen As IRasterStretchColorRampRenderer
'  Set pStretchRen = New RasterStretchColorRampRenderer
'  Dim pRasRen As IRasterRenderer
'  Set pRasRen = pStretchRen
'
'  ' Set raster for the renderer and update
'  Set pRasRen.Raster = pOutputRaster
'  pRasRen.Update
'
'  ' COLORS - MAKE RANDOM COLOR SHADING TO WHITE
'  Dim pStartColor As IColor
'  Dim pWhiteColor As IColor
'
'  Set pStartColor = New RgbColor
'  Set pWhiteColor = New RgbColor
'
'  Randomize
'  pStartColor.RGB = RGB(CLng(Rnd * 100) + 50, CLng(Rnd * 100) + 50, CLng(Rnd * 100) + 50)
'  pWhiteColor.RGB = RGB(255, 255, 255)
'
'  ' CREATE COLOR RAMPS
'  Dim pRamp1 As IAlgorithmicColorRamp
'  Set pRamp1 = New AlgorithmicColorRamp
'  pRamp1.Algorithm = esriLabLChAlgorithm
'  pRamp1.Size = 130
'  pRamp1.FromColor = pWhiteColor
'  pRamp1.ToColor = pStartColor
'  pRamp1.CreateRamp True
'
'  ' Plug this colorramp into renderer and select a band
'  pStretchRen.BandIndex = 0
'  pStretchRen.ColorRamp = pRamp1
'
'  ' Update the renderer with new settings and plug into layer
'  pRasRen.Update
'  Set pNewLayer.Renderer = pStretchRen
'
'  pMxDoc.AddLayer pNewLayer
''-----------------------------------
'
'
'  pPro.position = 0
'  psbar.HideProgressBar
'
'
'
'  strReport = "Raster Density Function Complete:" & vbCrLf & _
'              "----------------------------------------------------------" & vbCrLf & _
'              "Analysis Parameters:" & vbCrLf & _
'              " --> Input Raster Layer: " & strInputName & vbCrLf & _
'              "     --> Attribute Field = [" & strFieldName & "]" & vbCrLf & _
'              "     --> Selected Attribute Value = " & strSelAttribute & vbCrLf & _
'              " --> Circular Neighborhood Radius: " & CStr(lngNbrHoodRadius) & " cells..." & vbCrLf & _
'              " --> Output Format: " & strSaveFormatString & vbCrLf & _
'              " --> Filename: " & strNewRasterName & strExtension & vbCrLf & _
'              " --> Workspace = " & pWS.PathName & vbCrLf & _
'              "----------------------------------------------------------" & vbCrLf & _
'              TopoCorridor.MyGeneralOperations.ReturnTimeElapsed(datBegan, Now)
'
'  pMxDoc.UpdateContents
'  pMxDoc.ActiveView.PartialRefresh esriViewGeography, Nothing, pEnv
'
'  CreateDensityRaster = strReport
'
'
'  Exit Function
'ErrorHandler:
'  HandleError True, "CreateDensityRaster " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
'
'End Function
'
