VERSION 5.00
Begin VB.Form frmChiSquareRaster 
   Caption         =   " Chi-Square Transformation Parameters:"
   ClientHeight    =   3600
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6375
   Icon            =   "frmChiSquareRaster.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   3600
   ScaleWidth      =   6375
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtDF 
      Alignment       =   2  'Center
      Height          =   315
      Left            =   1050
      TabIndex        =   3
      Text            =   "txtDF"
      Top             =   1935
      Width           =   885
   End
   Begin VB.ComboBox cbxLayers 
      Height          =   315
      Left            =   352
      TabIndex        =   1
      Text            =   "Combo1"
      Top             =   1395
      Width           =   2895
   End
   Begin VB.CommandButton cmdGetWorkspace 
      Height          =   360
      Left            =   5820
      Picture         =   "frmChiSquareRaster.frx":058A
      Style           =   1  'Graphical
      TabIndex        =   5
      ToolTipText     =   "Browse for Output Feature Class..."
      Top             =   2715
      Width           =   465
   End
   Begin VB.TextBox txtOutput 
      Height          =   330
      Left            =   165
      TabIndex        =   4
      Text            =   "txtOutput"
      Top             =   2730
      Width           =   5595
   End
   Begin VB.ComboBox cbxFormat 
      Height          =   315
      Left            =   3562
      Style           =   2  'Dropdown List
      TabIndex        =   2
      Top             =   1395
      Width           =   2460
   End
   Begin VB.CommandButton cmdManual 
      Caption         =   "Manual"
      Height          =   345
      Left            =   2662
      TabIndex        =   7
      Top             =   3240
      Width           =   1065
   End
   Begin VB.TextBox txtMessage 
      Height          =   960
      Left            =   90
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      TabStop         =   0   'False
      Text            =   "frmChiSquareRaster.frx":0600
      Top             =   75
      Width           =   6195
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   345
      Left            =   3727
      TabIndex        =   8
      Top             =   3240
      Width           =   1065
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   345
      Left            =   1582
      TabIndex        =   6
      Top             =   3240
      Width           =   1065
   End
   Begin VB.Label lblAdd 
      AutoSize        =   -1  'True
      Caption         =   "Chi Square Degrees of Freedom (# Variables - 1)"
      Height          =   195
      Left            =   2010
      TabIndex        =   12
      Top             =   1995
      Width           =   3420
   End
   Begin VB.Label lblOutputName 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Output Raster Dataset Name:"
      Height          =   195
      Left            =   150
      TabIndex        =   11
      Top             =   2520
      Width           =   2100
   End
   Begin VB.Label lblFormat 
      Alignment       =   1  'Right Justify
      AutoSize        =   -1  'True
      Caption         =   "Output Raster Format:"
      Height          =   195
      Left            =   4005
      TabIndex        =   10
      Top             =   1155
      Width           =   1560
   End
   Begin VB.Image imgParamsBack 
      BorderStyle     =   1  'Fixed Single
      Height          =   795
      Left            =   15
      Top             =   2385
      Width           =   6345
   End
   Begin VB.Image imgCornerBars 
      Height          =   225
      Left            =   6135
      Picture         =   "frmChiSquareRaster.frx":060F
      Top             =   3360
      Width           =   225
   End
   Begin VB.Label lblLayer 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      Caption         =   "-- Select Raster Layer --"
      Height          =   195
      Left            =   930
      TabIndex        =   9
      Top             =   1155
      Width           =   1710
   End
   Begin VB.Image imgBackTop 
      BorderStyle     =   1  'Fixed Single
      Height          =   2355
      Left            =   15
      Top             =   15
      Width           =   6345
   End
End
Attribute VB_Name = "frmChiSquareRaster"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
 
Private m_pMxDoc As esriArcMapUI.IMxDocument
Private m_pApp As IApplication
Private Anchors As AnchorObjectList  ' Main anchor control object
Private m_pLayerArray As esriSystem.IVariantArray
Private m_pLayerFields As esriSystem.IVariantArray
Private m_strSelLayerName As String
Private m_booSelToggle As Boolean
Private m_pThisExt As TopoCorridor.clsExtension
Private m_ShapeTypeOption As JenLayerTypes
Private m_pReturnArray As esriSystem.IVariantArray
Private m_FieldTypeOption As JenFieldTypes
Private m_booIncludeNoIDField As Boolean
Private m_strOutputWorkspace As String
Private m_strOutputBasename As String
Private m_lngOutputWSType As JenDatasetTypes
Private m_booOutputFeatDataset As Boolean
Private m_strOutputFeatDatasetName As String
Private m_booOutputIsFClass As Boolean         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS

Private m_strRasterWS As String
Private m_pSaveFormats As esriSystem.IVariantArray
Private m_pFileExtensions As esriSystem.IVariantArray
Private m_strRasterName As String
Private m_pLayerNames As esriSystem.IStringArray
 
Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\brost_climate_change\code\frmChiSquareRaster.frm"
 
Public Property Set ArcApplication(ByVal pParams As esriSystem.IVariantArray)
  On Error GoTo ErrorHandler
 
33:   Set m_pApp = pParams.Element(0)
34:   Set m_pMxDoc = pParams.Element(1)
35:   Set m_pThisExt = pParams.Element(2)
 
  Dim pSelItem As IUnknown
38:   Set pSelItem = m_pMxDoc.SelectedItem
  Dim pLayer As IRasterLayer
  Dim lngIndex As Long
  Dim pUnknown As IUnknown

43:   m_strSelLayerName = ""
 
45:   If Not pSelItem Is Nothing Then
46:     If TypeOf pSelItem Is IRasterLayer Then
47:       Set pLayer = pSelItem
48:       m_strSelLayerName = pLayer.Name
49:     End If
50:   End If

  ' FILL LAYER ARRAY AND LISTBOX
53:   cbxLayers.Clear
  Dim lngStartSel As Long
55:   lngStartSel = 0
  Dim pTempLayerArray As esriSystem.IVariantArray
57:   Set pTempLayerArray = TopoCorridor.MyGeneralOperations.ReturnLayersByType(m_pMxDoc.FocusMap, ENUM_jenRasterLayers)
58:   Set m_pLayerArray = New esriSystem.VarArray
59:   Set m_pLayerNames = New esriSystem.strArray
  
  Dim pRastBandColl As IRasterBandCollection
  Dim pRastBand As IRasterBand
  Dim pRaster As IRaster
  Dim lngIndex2 As Long
  Dim lngSelCounter As Long
66:   lngSelCounter = -1
  Dim strBandName As String
  
69:   If pTempLayerArray.Count > 0 Then
70:     For lngIndex = 0 To pTempLayerArray.Count - 1
71:       Set pUnknown = pTempLayerArray.Element(lngIndex)
72:       If TypeOf pUnknown Is IRasterLayer Then
73:         Set pLayer = pUnknown
74:         If pLayer.Valid Then
75:           Set pRaster = pLayer.Raster
76:           Set pRastBandColl = pRaster
77:           If pRastBandColl.Count = 1 Then
78:             strBandName = pLayer.Name
79:             cbxLayers.AddItem strBandName
80:             m_pLayerNames.Add strBandName
81:             m_pLayerArray.Add pRastBandColl.Item(0)
82:             lngSelCounter = lngSelCounter + 1
83:             If pLayer.Name = m_strSelLayerName Then lngStartSel = lngSelCounter
84:           Else
85:             For lngIndex2 = 0 To pRastBandColl.Count - 1
86:               Set pRastBand = pRastBandColl.Item(lngIndex2)
87:               strBandName = pLayer.Name & " [Band " & CStr(lngIndex2 + 1) & "]"
88:               m_pLayerNames.Add strBandName
89:               cbxLayers.AddItem strBandName
90:               m_pLayerArray.Add pRastBandColl.Item(lngIndex2)
91:               lngSelCounter = lngSelCounter + 1
92:               If pLayer.Name = m_strSelLayerName Then lngStartSel = lngSelCounter
93:             Next lngIndex2
94:           End If
95:         End If
96:       End If
97:     Next lngIndex
98:     cbxLayers.ListIndex = lngStartSel
99:   End If
  
  Dim strBaseString As String
102:   strBaseString = strBaseString & "This tool will transform a raster of Chi-Square values (i.e. Mahalanobis distance values) to P-values based on the Chi-Square distribution with N-1 degrees of freedom.  If and only if the N input variables are normally distributed, then the Mahalanobis values will follow a Chi-Square distribution with N-1 degrees of freedom." & vbNewLine
103:   strBaseString = strBaseString & " " & vbNewLine
104:   strBaseString = strBaseString & "Select the raster layer of Chi-Square values (i.e. the Mahalanobis raster) layer from the list below, and enter the number of degrees of freedom to use in the Chi-Square transformation.  The degrees of freedom should be equal to [Number of Variables - 1] used in the original Mahalanobis analysis.  For example, if 6 rasters were used to create the Mahalanobis raster, then the Degrees of Freedom would be [6 - 1] = 5.  Finally, specify the name of your new raster and where to save it." & vbNewLine

106:   txtMessage.Text = strBaseString

108:   Set m_pSaveFormats = New esriSystem.VarArray
109:   Set m_pFileExtensions = New esriSystem.VarArray
  
111:   cbxFormat.Clear
  Dim strFileExtension As String
  Dim lngVersion As Long
  Dim strTypeName As String
  Dim strType As String
  
  ' GIVING UP ON SAVING TO FILE GEODATABASE RASTER....
  'lngVersion = TopoCorridor.aml_func_mod.ReturnArcGISVersionAlt(m_pMxDoc)
119:   lngVersion = 0
120:   If lngVersion >= 2 Then
121:     strTypeName = "File Geodatabase Raster"
122:     strType = "GDB"
123:     m_pSaveFormats.Add strType
124:     cbxFormat.AddItem strTypeName
125:     strFileExtension = ""
126:     m_pFileExtensions.Add strFileExtension
127:   End If
  
129:   strTypeName = "ESRI GRID"
130:   strType = "GRID"
131:   m_pSaveFormats.Add strType
132:   cbxFormat.AddItem strTypeName
133:   strFileExtension = ""
134:   m_pFileExtensions.Add strFileExtension
  
136:   strTypeName = "Imagine Image"
137:   strType = "IMAGINE Image"
138:   m_pSaveFormats.Add strType
139:   cbxFormat.AddItem strTypeName
140:   strFileExtension = ".img"
141:   m_pFileExtensions.Add strFileExtension
  
143:   strTypeName = "TIFF File"
144:   strType = "TIFF"
145:   m_pSaveFormats.Add strType
146:   cbxFormat.AddItem strTypeName
147:   strFileExtension = ".tif"
148:   m_pFileExtensions.Add strFileExtension
  
150:   strTypeName = "JPEG File"
151:   strType = "JPG"
152:   m_pSaveFormats.Add strType
153:   cbxFormat.AddItem strTypeName
154:   strFileExtension = ".jpg"
155:   m_pFileExtensions.Add strFileExtension
  
157:   strTypeName = "JPEG 2000 File"
158:   strType = "JP2"
159:   m_pSaveFormats.Add strType
160:   cbxFormat.AddItem strTypeName
161:   strFileExtension = ".jp2"
162:   m_pFileExtensions.Add strFileExtension
  
  Dim strFolder As String
165:   strFolder = m_pThisExt.DirectoryPath
166:   If strFolder = "" Or Not (TopoCorridor.aml_func_mod.ExistFileDir(strFolder)) Then
167:     strFolder = TopoCorridor.aml_func_mod.ReturnDir(TopoCorridor.aml_func_mod.GetMxDocPath(m_pApp))
168:   End If
169:   If Right(strFolder, 1) = "\" Then
170:     strFolder = Left(strFolder, Len(strFolder) - 1)
171:   End If
  
173:   If StrComp(Right(strFolder, 4), ".gdb") = 0 Then
174:     cbxFormat.ListIndex = 0
175:   Else
'    If m_pThisExt.OutputFormat = 0 Then
'      cbxFormat.ListIndex = 1
'    Else
179:       cbxFormat.ListIndex = m_pThisExt.OutputFormat
'    End If
181:   End If
    
  Dim pWS As IWorkspace
  Dim pWsFact As IWorkspaceFactory2
185:   If StrComp(Right(strFolder, 4), ".gdb", vbTextCompare) = 0 Then
186:     Set pWsFact = New FileGDBWorkspaceFactory
187:   Else
188:     Set pWsFact = New RasterWorkspaceFactory
189:   End If
190:   Set pWS = pWsFact.OpenFromFile(strFolder, Me.hWnd)
    
  Dim strSuggest As String
193:   If cbxFormat.Text = "ESRI GRID" Or cbxFormat.Text = "File Geodatabase Raster" Then
194:     strSuggest = TopoCorridor.MyGeneralOperations.MakeUniqueRasterName2 _
        (pWS, "P_vals" & m_pFileExtensions.Element(cbxFormat.ListIndex), CBool(cbxFormat.Text = "ESRI GRID"))
196:     txtOutput.Text = strFolder & "\" & strSuggest
197:   Else
198:     strSuggest = TopoCorridor.MyGeneralOperations.MakeUniqueShapeFilename(strFolder & "\" & _
        "P_vals" & m_pFileExtensions.Element(cbxFormat.ListIndex))
200:     txtOutput.Text = strSuggest
201:   End If
202:   txtOutput.SelStart = Len(txtOutput.Text)
203:   m_strRasterWS = pWS.PathName
204:   m_strRasterName = TopoCorridor.aml_func_mod.ReturnFilename(strSuggest)
  
206:   CheckEnable
207:   txtDF.Text = ""
  ' CLEAR INITIAL SELECTION
209:   Set m_pThisExt.frmChiSquareRasterReturn = Nothing
210:   m_pThisExt.ShouldContinue = False

212:   Set pSelItem = Nothing
213:   Set pLayer = Nothing
214:   Set pUnknown = Nothing
215:   Set pTempLayerArray = Nothing
216:   Set pRastBandColl = Nothing
217:   Set pRastBand = Nothing
218:   Set pRaster = Nothing
219:   Set pWS = Nothing
220:   Set pWsFact = Nothing
  
 Exit Property
ErrorHandler:
  HandleError True, "ArcApplication " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Public Property Get ReturnArray() As esriSystem.IVariantArray
  On Error GoTo ErrorHandler
 
230:   Set ReturnArray = m_pReturnArray
 
  Exit Property
ErrorHandler:
  HandleError True, "ReturnArray " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub CheckEnable()
  On Error GoTo ErrorHandler
  
  Dim booDFOK As Boolean
  Dim lngDF As Long
242:   If IsNumeric(txtDF.Text) Then
243:     lngDF = CLng(txtDF.Text)
244:     booDFOK = lngDF > 0
245:   Else
246:     booDFOK = False
247:   End If
  
249:   cmdOK.Enabled = cbxLayers.Text <> "" And txtOutput.Text <> "" And booDFOK
 
  Exit Sub
ErrorHandler:
  HandleError False, "CheckEnable " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cbxFormat_Change()
  On Error GoTo ErrorHandler

259:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "cbxFormat_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cbxFormat_Click()
267:   CheckEnable
End Sub

Private Sub cmdGetWorkspace_Click()


  On Error GoTo ErrorHandler
   ' Save to TIFF, IMAGINE Image, GRID and geodatabase
  Dim pGxBrowser As IGxDialog
  Dim pGxFilterCol As IGxObjectFilterCollection
  Dim pGxFilter As IGxObjectFilter
  Dim pGxObj As IGxObject
  Dim pName As IName
  Dim sName As String
  
  Dim booIs10 As Boolean
283:   booIs10 = TopoCorridor.aml_func_mod.IsVersion10
  
  ' Select input raster dataset
286:   Set pGxBrowser = New GxDialog
287:   pGxBrowser.AllowMultiSelect = False
288:   pGxBrowser.Title = "Specify Output Chi-Square Raster Dataset"
289:   If TopoCorridor.aml_func_mod.FileExists(m_strRasterWS) Then
290:     pGxBrowser.StartingLocation = m_strRasterWS
291:   End If
  
293:   If Not booIs10 Then
294:     Set pGxFilter = New GxFilterRasterDatasets
    
296:     Set pGxFilterCol = pGxBrowser
297:     pGxFilterCol.AddFilter pGxFilter, True
298:   End If
  
  Dim iPos As Integer
301:   If pGxBrowser.DoModalSave(Me.hWnd) Then
302:     sName = pGxBrowser.Name
303:     iPos = InStrRev(sName, ".")
304:     If iPos > 0 Then
305:       sName = Left(sName, iPos - 1)
306:     End If
    
308:     m_strRasterWS = pGxBrowser.FinalLocation.FullName
309:     m_strRasterName = sName
310:     txtOutput.Text = m_strRasterWS & "\" & m_strRasterName
311:     txtOutput.SelStart = Len(txtOutput.Text)
    'Get the workspace
313:     Set pGxObj = pGxBrowser.FinalLocation
314:     Set pName = pGxObj.InternalObjectName
'    Set m_OutWs = pName.Open
    
    'geodatabase workspace
'    If Not m_OutWs Is Nothing Then m_Format = "SDR"
    
320:     If StrComp(Right(m_strRasterWS, 4), ".gdb", vbTextCompare) = 0 Then
321:       cbxFormat.ListIndex = 0
322:     End If
    
324:   End If
325:   CheckEnable
  
327:   GoTo CleanUp

  Exit Sub
ErrorHandler:
  HandleError True, "cmdGetWorkspace_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4

CleanUp:

335:   Set pGxBrowser = Nothing
336:   Set pGxFilterCol = Nothing
337:   Set pGxFilter = Nothing
338:   Set pGxObj = Nothing
339:   Set pName = Nothing

  
End Sub

Private Sub cmdManual_Click()
  On Error GoTo ErrorHandler
  ' CHANGE AS APPROPRIATE
  Dim strDir As String
348:   strDir = App.Path
349:   If Right(strDir, 1) <> "\" Then strDir = strDir & "\"
350:   strDir = strDir & "docs"
  
352:   Call TopoCorridor.MyGeneralOperations.OpenDoc("Land_Facet_Tools.pdf", strDir)
 
  Exit Sub
ErrorHandler:
  HandleError True, "cmdManual_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdCancel_Click()
  On Error GoTo ErrorHandler

362:   m_pThisExt.ShouldContinue = False
363:   Set m_pThisExt.frmChiSquareRasterReturn = Nothing
364:   Set m_pReturnArray = Nothing
365:   Unload Me
 
  Exit Sub
ErrorHandler:
  HandleError True, "cmdCancel_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdOK_Click()
  On Error GoTo ErrorHandler

  ' RETURN ARRAY IS IVariantArray, CONTAINING:
  ' 0) IRasterBand: SELECTED RASTER BAND
  ' 1) STRING: Save Format
  ' 2) STRING: TEXT VERSION OF SAVE FORMAT
  ' 3) STRING: New Raster Name
  ' 4) BOOLEAN: Whether new workspace is File Geodatabase
  ' 5) IWORKSPACE: Either an IRasterWorkspace2 or an IRasterWorkspaceEx
  ' 6) STRING: Extension for output
  ' 7) STRING: Name of Selected Raster Band
  ' 8) DOUBLE: OPTIONAL ADD VALUE
    
  Dim lngIndex As Long
387:   Set m_pReturnArray = New esriSystem.VarArray
    
  ' SELECTED RASTER LAYER
  Dim pRasterBand As IRasterBand
391:   Set pRasterBand = m_pLayerArray.Element(cbxLayers.ListIndex)
392:   m_pReturnArray.Add pRasterBand
  
  Dim strWS As String
  Dim strFilename As String
  Dim pWS As IWorkspace
  Dim pWS2 As IWorkspace2
  Dim pRastWS As IRasterWorkspace2
  Dim pRastWsEx As IRasterWorkspaceEx
  Dim strFullPath As String
  Dim pWsFact As IWorkspaceFactory2
  Dim pDataset As IDataset
  Dim booIsFGB As Boolean
  Dim iPos As Integer
  Dim booExcludeIfAnyNull As Boolean
      
407:   strFullPath = txtOutput.Text
408:   strFilename = TopoCorridor.aml_func_mod.ReturnFilename(strFullPath)
409:   strWS = TopoCorridor.aml_func_mod.ReturnDir(strFullPath)
410:   If Right(strWS, 1) = "\" Then
411:     strWS = Left(strWS, Len(strWS) - 1)
412:   End If
  
  ' CLIP OFF ANY EXTENSIONS TO NAME
415:   iPos = InStrRev(strFilename, ".")
416:   If iPos > 0 Then
417:     strFilename = Left(strFilename, iPos - 1)
418:   End If
  
  ' MAKE SURE WORKSPACE EXISTS
421:   If Not TopoCorridor.aml_func_mod.ExistFileDir(strWS) Then
422:     MsgBox "Unable to create Raster:" & vbCrLf & _
           strWS & " is not a valid workspace...", , "Failed to Create Raster:"
424:     txtOutput.SetFocus
    Exit Sub
426:   End If
  
428:   booIsFGB = StrComp(Right(strWS, 4), ".gdb", vbTextCompare) = 0
  
  Dim lngVersion As Long
431:   lngVersion = TopoCorridor.aml_func_mod.ReturnArcGISVersionAlt(m_pMxDoc)
    
433:   If lngVersion < 2 And booIsFGB Then
434:     MsgBox "Problem:" & vbCrLf & _
           "You have selected a File Geodatabase workspace, but your version of ArcGIS does not " & vbCrLf & _
           "support file geodatabases.", , "Invalid Workspace Specified:"
437:     txtOutput.SetFocus
    Exit Sub
439:   End If
    
441:   If booIsFGB Then
442:     Set pWsFact = New FileGDBWorkspaceFactory
443:   Else
444:     Set pWsFact = New RasterWorkspaceFactory
445:   End If
446:   Set pWS = pWsFact.OpenFromFile(strWS, Me.hWnd)
    
  ' MAKE SURE FILE GEODATABASE IS SELECTED IF USER SPECIFIES SAVING TO FILE GEODATABASE
  Dim strFormat As String
450:   strFormat = m_pSaveFormats.Element(cbxFormat.ListIndex)
   
  '  MsgBox "strFormat = " & strFormat & vbCrLf & _
          "booIsFGB = " & CStr(booIsFGB) & vbCrLf & _
          "strWS = " & strWS
          
456:   If strFormat = "GDB" And (Not booIsFGB) Then
457:     MsgBox "Problem:" & vbCrLf & vbCrLf & _
           "You have selected to save your inverted raster as a File Geodatabase Raster, " & vbCrLf & _
           "but you have not specified an existing File Geodatabase to save the raster." & vbCrLf & vbCrLf & _
           "Please specify an existing file geodatabase.  If necessary, you may use ArcCatalog " & vbCrLf & _
           "to create a new empty file geodatabase.", , "Incorrect Workspace Specified:"
462:     txtOutput.SetFocus
    Exit Sub
464:   ElseIf strFormat <> "GDB" And booIsFGB Then
465:     MsgBox "Problem:" & vbCrLf & vbCrLf & _
           "You have selected to save your inverted raster as a " & cbxFormat.Text & ", " & vbCrLf & _
           "but you have specified a File Geodatabase workspace to save the raster." & vbCrLf & vbCrLf & _
           "File geodatabases can only store File Geodatabase rasters.  Either change " & vbCrLf & _
           "your format to 'File Geodatabase Raster', or select a different workspace.", , _
           "Incorrect Workspace Specified:"
471:     txtOutput.SetFocus
    Exit Sub
  
474:   End If
   
476:   m_pReturnArray.Add strFormat
477:   m_pReturnArray.Add cbxFormat.Text
478:   m_pReturnArray.Add strFilename
479:   m_pReturnArray.Add booIsFGB
480:   m_pReturnArray.Add pWS
481:   m_pReturnArray.Add m_pFileExtensions.Element(cbxFormat.ListIndex)
482:   m_pReturnArray.Add cbxLayers.List(cbxLayers.ListIndex)
  
  Dim lngDF As Long
  
486:   If txtDF.Text = "" Then
487:     MsgBox "Problem:" & vbCrLf & vbCrLf & _
           "Please enter a valid value for Degrees of Freedom." & vbCrLf & _
           "This value should be equal to the 1 less than number of input variables...", , _
           "Invalid Value:"
491:     txtDF.SetFocus
    Exit Sub
493:   Else
494:     lngDF = CLng(txtDF)
495:     If lngDF <= 0 Then
496:       MsgBox "Problem:" & vbCrLf & vbCrLf & _
             "Please enter a valid value for Degrees of Freedom." & vbCrLf & _
             "This value should be equal to the 1 less than number of input variables...", , _
             "Invalid Value:"
500:       txtDF.SetFocus
      Exit Sub
502:     End If
503:   End If
  
505:   m_pReturnArray.Add lngDF
  
  ' MAKE SURE RASTER DOES NOT EXIST
  Dim lngVBResult As VbMsgBoxResult
509:   If booIsFGB Then
510:     Set pWS2 = pWS
511:     If pWS2.NameExists(esriDTRasterDataset, strFilename) Then
512:       lngVBResult = MsgBox("File '" & strFilename & "' Already exists!" & vbCrLf & _
             "Would you like this tool to attempt to delete the existing file?", vbYesNo, _
             "File Exists:")
515:       If lngVBResult = vbYes Then
516:         Set pRastWsEx = pWS
517:         Set pDataset = pRastWsEx.OpenRasterDataset(strFilename)
518:         If pDataset.CanDelete Then
519:           pDataset.DELETE
520:           If Not pWS2.NameExists(esriDTRasterDataset, strFilename) Then
521:             MsgBox "File Deleted..."
522:           End If
523:         Else
524:           MsgBox "Unable to delete '" & strFilename & "'..." & vbCrLf & _
            "Please delete this file manually before attempting to create a new raster with this name."
526:           txtOutput.SetFocus
          Exit Sub
528:         End If
529:       Else
530:         txtOutput.SetFocus
        Exit Sub
532:       End If
533:       txtOutput.SetFocus
      Exit Sub
535:     End If
536:   Else
537:     If TopoCorridor.aml_func_mod.ExistFileDir(strFullPath) Then
538:       lngVBResult = MsgBox("File '" & strFilename & "' Already exists!" & vbCrLf & _
             "Would you like this tool to attempt to delete the existing file?", vbYesNo, _
             "File Exists:")
541:       If lngVBResult = vbYes Then
542:         Set pRastWS = pWS
543:         Set pDataset = pRastWS.OpenRasterDataset(strFilename)
544:         If pDataset.CanDelete Then
545:           pDataset.DELETE
546:           If Not TopoCorridor.aml_func_mod.ExistFileDir(strFullPath) Then
547:             MsgBox "File Deleted..."
548:           End If
549:         Else
550:           MsgBox "Unable to delete '" & strFilename & "'..." & vbCrLf & _
            "Please delete this file manually before attempting to create a new raster with this name."
552:           txtOutput.SetFocus
          Exit Sub
554:         End If
555:       Else
556:         txtOutput.SetFocus
        Exit Sub
558:       End If
559:       txtOutput.SetFocus
      Exit Sub
561:     End If
562:   End If
    
564:   m_pThisExt.OutputFormat = cbxFormat.ListIndex
565:   m_pThisExt.DirectoryPath = strWS
566:   m_pThisExt.ShouldContinue = True

  Dim pSaveArray As esriSystem.IVariantArray
569:   Set pSaveArray = New esriSystem.VarArray
570:   For lngIndex = 0 To m_pReturnArray.Count - 1
571:     pSaveArray.Add m_pReturnArray.Element(lngIndex)
572:   Next lngIndex
573:   Set m_pThisExt.frmChiSquareRasterReturn = pSaveArray
  
575:   Unload Me
      
'  Me.Visible = False

579:   Set pRasterBand = Nothing
580:   Set pWS = Nothing
581:   Set pWS2 = Nothing
582:   Set pRastWS = Nothing
583:   Set pRastWsEx = Nothing
584:   Set pWsFact = Nothing
585:   Set pDataset = Nothing
586:   Set pSaveArray = Nothing
 
  Exit Sub
ErrorHandler:
  HandleError True, "cmdOK_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub Form_Load()
  On Error GoTo ErrorHandler
 
596:   SetWindowPos Me.hWnd, -1, 0, 0, 0, 0, &H1 Or &H2
597:   Me.Left = (Screen.Width / 2) - (Me.Width / 2)
598:   Me.Top = (Screen.Height / 3) - (Me.Height / 3)
  Dim lngTopBar As Long
600:   lngTopBar = Me.Height - Me.ScaleHeight
601:   Me.Height = cmdOK.Top + cmdOK.Height + lngTopBar
 
603:    Set Anchors = New AnchorObjectList  ' Create new instance
604:    With Anchors
605:       With .Item(cbxFormat)
606:          .SetAnchors enumSizeEnd, enumSizeEnd
607:       End With
608:       With .Item(cbxLayers)
609:          .SetAnchors enumStartEnd, enumSizeEnd
610:       End With
611:       With .Item(cmdCancel)
612:          .SetAnchors enumSizeEnd, enumSizeEnd
613:       End With
614:       With .Item(cmdGetWorkspace)
615:          .SetAnchors enumSizeEnd, enumSizeEnd
616:       End With
617:       With .Item(cmdManual)
618:          .SetAnchors enumSizeEnd, enumSizeEnd
619:       End With
620:       With .Item(cmdOK)
621:          .SetAnchors enumSizeEnd, enumSizeEnd
622:       End With
623:       With .Item(imgBackTop)
624:          .SetAnchors enumStartEnd, enumStartEnd
625:       End With
626:       With .Item(imgCornerBars)
627:          .SetAnchors enumSizeEnd, enumSizeEnd
628:       End With
629:       With .Item(imgParamsBack)
630:          .SetAnchors enumStartEnd, enumSizeEnd
631:       End With
632:       With .Item(lblFormat)
633:          .SetAnchors enumSizeEnd, enumSizeEnd
634:       End With
635:       With .Item(lblLayer)
636:          .SetAnchors enumStartSize, enumSizeEnd
637:       End With
638:       With .Item(txtDF)
639:          .SetAnchors enumStartEnd, enumSizeEnd
640:       End With
641:       With .Item(lblAdd)
642:          .SetAnchors enumSizeEnd, enumSizeEnd
643:       End With
644:       With .Item(lblOutputName)
645:          .SetAnchors enumStartSize, enumSizeEnd
646:       End With
647:       With .Item(txtMessage)
648:          .SetAnchors enumStartEnd, enumStartEnd
649:       End With
650:       With .Item(txtOutput)
651:          .SetAnchors enumStartEnd, enumSizeEnd
652:       End With
653:       .Form = Me  ' Set form reference (suggested to be last step)
654:    End With

656:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub Form_Unload(Cancel As Integer)
  On Error GoTo ErrorHandler
 
666:   Set m_pMxDoc = Nothing
667:   Set m_pApp = Nothing
668:   Set Anchors = Nothing
669:   Set m_pLayerArray = Nothing
670:   Set m_pLayerFields = Nothing
671:   Set m_pThisExt = Nothing
672:   Set m_pReturnArray = Nothing
673:   Set m_pSaveFormats = Nothing
674:   Set m_pFileExtensions = Nothing
675:   Set m_pLayerNames = Nothing
  
  Exit Sub
ErrorHandler:
  HandleError True, "Form_Unload " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cbxLayers_Click()
  On Error GoTo ErrorHandler

685:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "cbxLayers_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub ExtraCodeRequired()
 
  '' PUT IN EXTENSION CLASS
  '
  'Private m_booShouldContinue As Boolean
  'Private m_strDirPath As String
  'Private m_pfrmInvertRasterReturn As esriSystem.IVariantArray
  'Private m_strDirType As String
  'Private m_booIsFeatDataset As Boolean
  'Private m_strFeatDatasetName As String
  '
  '' PUT IN EXTENSION SHUTDOWN EVENT
  ' Set m_pfrmInvertRasterReturn = Nothing
  '
  '' SET FOLLOWING PROPERTIES
  'Public Property Let FeatDatasetName(strFeatDatasetName As String)
  '  m_strFeatDatasetName = strFeatDatasetName
  'End Property
  'Public Property Get FeatDatasetName() As String
  '  FeatDatasetName = m_strFeatDatasetName
  'End Property
  'Public Property Let IsFeatureDataset(booIsFeatDataset As Boolean)
  '  m_booIsFeatDataset = booIsFeatDataset
  'End Property
  'Public Property Get IsFeatureDataset() As Boolean
  '  IsFeatureDataset = m_booIsFeatDataset
  'End Property
  'Public Property Let DirectoryType(strDirType As String)
  '  m_strDirType = strDirType
  'End Property
  'Public Property Get DirectoryType() As String
  '  DirectoryType = m_strDirType
  'End Property
  '
  'Public Property Set frmInvertRasterReturn(pfrmInvertRasterReturn As esriSystem.IVariantArray)
  '  Set m_pfrmInvertRasterReturn = pfrmInvertRasterReturn
  'End Property
  '
  'Public Property Get frmInvertRasterReturn() As esriSystem.IVariantArray
  '  Set frmInvertRasterReturn = m_pfrmInvertRasterReturn
  'End Property
  '
  'Public Property Let DirectoryPath(strPath As String)
  '  On Error GoTo ErrorHandler
  '  m_strDirPath = strPath
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "DirectoryPath " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  'Public Property Get DirectoryPath() As String
  '  On Error GoTo ErrorHandler
  '  DirectoryPath = m_strDirPath
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "DirectoryPath " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  'Public Property Let ShouldContinue(booShouldContinue As Boolean)
  '  On Error GoTo ErrorHandler
  '  m_booShouldContinue = booShouldContinue
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "ShouldContinue " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  'Public Property Get ShouldContinue() As Boolean
  '  On Error GoTo ErrorHandler
  '  ShouldContinue = m_booShouldContinue
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "ShouldContinue " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  '' PUT IN EXTENSION STARTUP EVENT
  '  If m_strDirPath = "" Or m_strDirType = "" Then
  '    m_strDirType = "Shapefile"
  '    m_strDirPath = ""
  '    m_booIsFeatDataset = False
  '    m_strFeatDatasetName = ""
  '  End If
  '
  '===============================================================================================================
  '
' ' SAMPLE CODE
'    Dim pVarArray As esriSystem.IVariantArray
'    Set pVarArray = New VarArray
'
'    ' ADD APPLICATION
'    pVarArray.Add m_pApp
'
'    ' ADD DESIRED LAYER TYPES
'    Dim pLayerTypes As JenLayerTypes
'    pLayerTypes = ENUM_jenRasterLayers
'    pVarArray.Add pLayerTypes
'
'    'EXTENSION SHOULD HAVE PROPERTIES FOR "ShouldContinue", "DirectoryPath", "frmInvertRasterReturn",
'    '     "DirectoryType", "IsFeatureDataset", "FeatDatasetName"
'    pVarArray.Add m_pThisExt
'
'    ' ADD DESIRED FIELD TYPES
'    pVarArray.Add 0
'
'    ' ADD WHETHER TO INCLUDE ID FIELD
'    pVarArray.Add (False)
'
'    ' ADD WHETHER ANY OUTPUT WILL BE A FEATURE CLASS (TRUE) OR TABLE (FALSE)         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    Dim booOutputIsFClass As Boolean                                                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    booOutputIsFClass = True                                                         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    pVarArray.Add (booOutputIsFClass)                                                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'
'    Dim pForm As TopoCorridor.frmInvertRaster
'    Set pForm = New TopoCorridor.frmInvertRaster
'    Set pForm.ArcApplication = pVarArray
'    pForm.Show vbModal
'    Set pForm = Nothing
'
'    If m_pThisExt.ShouldContinue = False Then
'      MsgBox "Function Canceled:" & vbCrLf & "Bailing out..."
'      Exit Sub
'    End If
'
'    Dim pReturnArray As esrisystem.IVariantArray
'    Set pReturnArray = m_pThisExt.frmInvertRasterReturn
 
'    ' OUTPUT
'    ' SELECTED TABLE OR LAYER
'    Dim pUnknown As IUnknown
'    Set pUnknown = pReturnArray.Element(0)
'
'    ' FOR DEBUGGING
'    Dim strReport As String
'    strReport = "Selected Items:" & vbNewLine
'
'    If TypeOf pUnknown Is ILayer Then
'      Dim pLayer As ILayer
'      Set pLayer = pUnknown
'      strReport = strReport & "Name:  " & pLayer.Name & vbNewLine
'    ElseIf TypeOf pUnknown Is IStandaloneTable Then
'      Dim pStTab As IStandaloneTable
'      Set pStTab = pUnknown
'      strReport = strReport & "Name:  " & pStTab.Name & vbNewLine
'    End If
'


'  ' CODE SNIPPET TO USE pFieldNamePairs TO TRANSFER ATTRIBUTE DATA FROM OLD SOURCE TO NEW SOURCE
'  ' MAKE IVariantArray OF FIELD NAME INDICES
'  ' STRUCTURE:  ARRAY OF 4-ITEM VARIANT ARRAYS
'  '             ITEMS = 0) ORIGINAL FCLASS FIELD NAME
'  '                     1) ORIGINAL FCLASS FIELD INDEX
'  '                     2) NEW FCLASS FIELD NAME
'  '                     3) NEW FCLASS FIELD INDEX
'  Dim pFieldNamePairs As esriSystem.IVariantArray
'  Set pFieldNamePairs = pOutputArray.Element(9)
'  Dim pFieldNameData As esriSystem.IVariantArray
'  Set pFieldNameData = TopoCorridor.MyGeneralOperations.MakeFieldNameVarArray(pFeatureClass, pNewFClass, pFieldNamePairs, True)
'  Dim lngFieldIndex As Long
'  Dim pFieldSubArray As esriSystem.IVariantArray
'  ' ROTATE THROUGH ALL FEATURES / ROWS
'    ' TRANSFER ATTRIBUTE DATA; ASSUMES pBuffer ALREADY EXISTS
'    For lngFieldIndex = 0 To pFieldNameData.Count - 1
'      Set pFieldSubArray = pFieldNameData.Element(lngFieldIndex)
'      pBuffer.Value(pFieldSubArray.Element(3)) = pFeature.Value(pFieldSubArray.Element(1))
'    Next lngFieldIndex
'  ' LOOP

''  ' SAMPLE SNIPPET FOR FEATURE LAYERS:  ROTATE THROUGH ALL OR SELECTED RECORDS
''  Dim pFeatureLayer As IFeatureLayer
''  Dim pFClass As IFeatureClass
''  Dim pFeatSel As IFeatureSelection
''  Dim pSelSet As ISelectionSet
''  Dim pCursor As IFeatureCursor
''  Dim lngCount As Long
''
''  Set pFClass = pFeatureLayer.FeatureClass
''  Set pFeatSel = pFeatureLayer
''  Set pSelSet = pFeatSel.SelectionSet
''
''  If pSelSet.Count = 0 Then
''    Set pCursor = pFClass.Search(Nothing, False)
''    lngCount = pFClass.FeatureCount(Nothing)
''  Else
''    If booDoAll = True Then
''      Set pCursor = pFClass.Search(Nothing, False)
''      lngCount = pFClass.FeatureCount(Nothing)
''    Else
''      pSelSet.Search Nothing, True, pCursor
''      lngCount = pSelSet.Count
''    End If
''  End If
''
''  Dim pFeature As IFeature
''  Set pFeature = pCursor.NextFeature
''  Do Until pFeature Is Nothing
''    ' DO ACTIONS
''    Set pFeature = pCursor.NextFeature
''  Loop
''
''  ' SAMPLE CODE SNIPPET:  ADD RECORDS TO FEATURE CLASS USING BUFFER
''  Dim pBuffer As IFeatureBuffer
''  Set pBuffer = pFClass.CreateFeatureBuffer
''  Dim pNewFeatureCursor As IFeatureCursor
''  Set pNewFeatureCursor = pFClass.Insert(True)
''  ' LOOP THROUGH WHATEVER STEPS ARE REQUIRED TO GATHER DATA FOR A SINGLE ROW
''    Set pBuffer.Shape = aGeometry
''    pBuffer.Value(lngFieldIndex) = aValue
''    pNewFeatureCursor.InsertFeature pBuffer
''  ' LOOP
''  pNewFeatureCursor.Flush

''  ' SAMPLE SNIPPET FOR TABLES:  ROTATE THROUGH ALL OR SELECTED RECORDS
''  Dim pStandaloneTable As IStandaloneTable
''  Dim pInputTable As ITable
''  Dim pTableSel As ITableSelection
''  Dim pSelSet As ISelectionSet
''  Dim pRowCursor As ICursor
''  Dim lngCount As Long
''
''  Set pInputTable = pStandaloneTable.Table
''  Set pTableSel = pStandaloneTable
''  Set pSelSet = pTableSel.SelectionSet
''
''  If pSelSet.Count = 0 Then
''    Set pRowCursor = pInputTable.Search(Nothing, False)
''    lngCount = pInputTable.FeatureCount(Nothing)
''  Else
''    If booDoAll = True Then
''      Set pRowCursor = pInputTable.Search(Nothing, False)
''      lngCount = pInputTable.FeatureCount(Nothing)
''    Else
''      pSelSet.Search Nothing, True, pRowCursor
''      lngCount = pSelSet.Count
''    End If
''  End If
''
''  Dim pRow As IRow
''  Set pRow = pRowCursor.NextRow
''  Do Until pRow Is Nothing
'''     DO ACTIONS
''    Set pRow = pRowCursor.NextFeature
''  Loop
 
''  ' SAMPLE CODE SNIPPET:  ADD RECORDS TO TABLE USING BUFFER
''  Dim pBuffer As IRowBuffer
''  Set pBuffer = pTable.CreateRowBuffer
''  Dim pTableCursor As ICursor
''  Set pTableCursor = pTable.Insert(True)
''  ' LOOP THROUGH WHATEVER STEPS ARE REQUIRED TO GATHER DATA FOR A SINGLE ROW
''    pBuffer.Value(lngFieldIndex) = aValue
''    pTableCursor.InsertRow pBuffer
''  ' LOOP
''  pTableCursor.Flush
'    MsgBox strReport, vbOKOnly, "Test of LayerID Form:"
'
'  Dim pDocDirty As IDocumentDirty
'  Set pDocDirty = m_pMxDoc
'  pDocDirty.SetDirty
'

End Sub
 
Private Sub txtDF_Change()
  On Error GoTo ErrorHandler

957:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "txtDF_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub txtDF_KeyPress(KeyAscii As Integer)
  On Error GoTo ErrorHandler

967:   TopoCorridor.MyGeneralOperations.CheckNumericIntegerPositive KeyAscii, txtDF

  Exit Sub
ErrorHandler:
  HandleError True, "txtDF_KeyPress " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub txtOutput_Change()
  On Error GoTo ErrorHandler

977:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "txtOutput_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
