VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "richtx32.Ocx"
Begin VB.Form frmCovSource 
   Caption         =   " Source for Means and Covariances [Step 1 of 2]:"
   ClientHeight    =   8760
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6015
   Icon            =   "frmCovSource.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   8760
   ScaleWidth      =   6015
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox frmSelAll 
      Height          =   2010
      Left            =   3525
      ScaleHeight     =   1950
      ScaleWidth      =   2385
      TabIndex        =   25
      Top             =   3300
      Width           =   2445
      Begin VB.OptionButton optUseAll 
         Caption         =   "Analyze All Points"
         Height          =   285
         Left            =   75
         TabIndex        =   21
         Top             =   285
         Width           =   2265
      End
      Begin VB.OptionButton optUseSelected 
         Caption         =   "Use Only Selected Points"
         Height          =   285
         Left            =   75
         TabIndex        =   22
         Top             =   1065
         Width           =   2265
      End
      Begin VB.Label lblSelected 
         AutoSize        =   -1  'True
         Caption         =   "n = -9,999 of 20,000 points"
         Height          =   195
         Left            =   225
         TabIndex        =   27
         Top             =   1350
         Width           =   1905
      End
      Begin VB.Label lblAll 
         AutoSize        =   -1  'True
         Caption         =   "n = [No Layer Selected]"
         Height          =   195
         Left            =   225
         TabIndex        =   26
         Top             =   600
         Width           =   1680
      End
   End
   Begin VB.ComboBox cbxValue 
      Height          =   315
      Left            =   1710
      Style           =   2  'Dropdown List
      TabIndex        =   20
      Top             =   4995
      Width           =   3855
   End
   Begin VB.CommandButton cmdOptions1 
      Caption         =   "Options to Save Additional Data"
      Height          =   300
      Left            =   3225
      TabIndex        =   1
      Top             =   1935
      Width           =   2625
   End
   Begin VB.CommandButton cmdOptions2 
      Caption         =   "Options to Save Additional Data"
      Height          =   300
      Left            =   3225
      TabIndex        =   3
      Top             =   2295
      Width           =   2625
   End
   Begin VB.ListBox lbxLayers 
      Height          =   1620
      Left            =   90
      TabIndex        =   8
      Top             =   6780
      Width           =   3300
   End
   Begin VB.ListBox lbxFields 
      Height          =   1620
      Left            =   3405
      TabIndex        =   9
      Top             =   6780
      Width           =   2535
   End
   Begin VB.OptionButton optRaster 
      Caption         =   "Generate from categorical raster "
      Height          =   255
      Left            =   165
      TabIndex        =   2
      Top             =   2325
      Width           =   2625
   End
   Begin VB.OptionButton optExisting 
      Caption         =   "Use existing mean vector and covariance matrix tables"
      Height          =   255
      Left            =   165
      TabIndex        =   4
      Top             =   2670
      Width           =   4530
   End
   Begin VB.OptionButton optPointTheme 
      Caption         =   "Generate from point layer"
      Height          =   255
      Left            =   165
      TabIndex        =   0
      Top             =   1965
      Width           =   2265
   End
   Begin VB.CommandButton cmdManual 
      Caption         =   "Manual"
      Height          =   345
      Left            =   2480
      TabIndex        =   11
      Top             =   5415
      Width           =   1065
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "Next --->"
      Default         =   -1  'True
      Height          =   345
      Left            =   3553
      TabIndex        =   12
      Top             =   5415
      Width           =   1065
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   345
      Left            =   1397
      TabIndex        =   10
      Top             =   5415
      Width           =   1065
   End
   Begin VB.ListBox lbxCov 
      Height          =   2010
      Left            =   2970
      TabIndex        =   7
      Top             =   6060
      Width           =   2955
   End
   Begin VB.ListBox lbxMean 
      Height          =   2010
      Left            =   90
      TabIndex        =   6
      Top             =   6060
      Width           =   2850
   End
   Begin RichTextLib.RichTextBox txtMessage 
      Height          =   1500
      Left            =   0
      TabIndex        =   15
      Top             =   -15
      Width           =   6015
      _ExtentX        =   10610
      _ExtentY        =   2646
      _Version        =   393217
      Enabled         =   -1  'True
      ReadOnly        =   -1  'True
      ScrollBars      =   2
      TextRTF         =   $"frmCovSource.frx":058A
   End
   Begin VB.ListBox lbxPointLayers 
      Height          =   2010
      Left            =   90
      TabIndex        =   5
      Top             =   3300
      Width           =   3390
   End
   Begin VB.Line Line2 
      X1              =   2760
      X2              =   3270
      Y1              =   2438
      Y2              =   2438
   End
   Begin VB.Line Line1 
      X1              =   2400
      X2              =   3510
      Y1              =   2085
      Y2              =   2085
   End
   Begin VB.Label lblSource 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      Caption         =   "Identify Source for Mean Vector and Covariance Matrix"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   195
      Left            =   645
      TabIndex        =   24
      Top             =   1590
      Width           =   4710
   End
   Begin VB.Label lblValue 
      Alignment       =   1  'Right Justify
      AutoSize        =   -1  'True
      Caption         =   "Category Value ="
      Height          =   195
      Left            =   435
      TabIndex        =   23
      Top             =   8475
      Width           =   1215
   End
   Begin VB.Label lblLine 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      Caption         =   "--  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  "
      Height          =   195
      Left            =   750
      TabIndex        =   19
      Top             =   2895
      Width           =   4500
   End
   Begin VB.Label lblRasters 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      Caption         =   "-- Select Categorical Raster --"
      Height          =   195
      Left            =   705
      TabIndex        =   18
      Top             =   3090
      Width           =   2070
   End
   Begin VB.Label lblRasterFields 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      Caption         =   "-- Select Raster Attribute Field --"
      Height          =   195
      Left            =   3540
      TabIndex        =   17
      Top             =   3090
      Width           =   2265
   End
   Begin VB.Label lblSelPointTheme 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      Caption         =   "-- Select Point Layer --"
      Height          =   195
      Left            =   1005
      TabIndex        =   16
      Top             =   3090
      Width           =   1560
   End
   Begin VB.Image imgCornerBars 
      Height          =   225
      Left            =   5790
      Picture         =   "frmCovSource.frx":0615
      Top             =   5535
      Width           =   225
   End
   Begin VB.Label lblFields 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      Caption         =   "-- Select Covariance Matrix --"
      Height          =   195
      Left            =   3420
      TabIndex        =   14
      Top             =   3090
      Width           =   2055
   End
   Begin VB.Label lblLayer 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      Caption         =   "-- Select Mean Vector --"
      Height          =   195
      Left            =   675
      TabIndex        =   13
      Top             =   3090
      Width           =   1680
   End
   Begin VB.Image imgBackTop 
      BorderStyle     =   1  'Fixed Single
      Height          =   3870
      Left            =   15
      Top             =   1500
      Width           =   5985
   End
End
Attribute VB_Name = "frmCovSource"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
 
Private m_pMxDoc As esriArcMapUI.IMxDocument
Private m_pApp As IApplication
Private Anchors As AnchorObjectList  ' Main anchor control object
Private m_pPointLayerArray As esriSystem.IVariantArray
Private m_pRasterLayerArray As esriSystem.IVariantArray
Private m_pTrueRasterLayerArray As esriSystem.IVariantArray
Private m_pTrueRasterLayerNames As esriSystem.IStringArray
Private m_pRasterLayerFields As esriSystem.IVariantArray
Private m_pMeanTableLayerArray As esriSystem.IVariantArray
Private m_pCovTableLayerArray As esriSystem.IVariantArray
Private m_strSelLayerName As String
Private m_booSelToggle As Boolean
Private m_pThisExt As TopoCorridor.clsExtension
Private m_ShapeTypeOption As JenLayerTypes
Private m_pReturnArray As esriSystem.IVariantArray
Private m_FieldTypeOption As JenFieldTypes
Private m_booIncludeNoIDField As Boolean
Private m_strOutputWorkspace As String
Private m_strOutputBasename As String
Private m_lngOutputWSType As JenDatasetTypes
Private m_booOutputFeatDataset As Boolean
Private m_strOutputFeatDatasetName As String
Private m_booOutputIsFClass As Boolean         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
Private m_dblValues() As Double
Private m_lngPointCount As Long
Private m_lngSelPointCount As Long
 
Const c_sModuleFileName As String = "D:\arcGIS_stuff\general_tools\Mahalanobis\Code\frmCovSource.frm"
 
Public Property Set ArcApplication(ByVal pParams As esriSystem.IVariantArray)
  On Error GoTo ErrorHandler
 
35:   Set m_pApp = pParams.Element(0)
36:   Set m_pMxDoc = pParams.Element(1)
37:   Set m_pThisExt = pParams.Element(2)
  
  ' SET INITIAL SOURCE OPTION BASED ON LAST SETTING; MIGHT GET AUTOMATICALLY CHANGED IF NO DATA AVAILABLE
  Dim lngSourceOption As Long
41:   lngSourceOption = m_pThisExt.InitialSourceOption
42:   optPointTheme.Value = False
43:   optRaster.Value = False
44:   optExisting.Value = False
  
  Select Case lngSourceOption
    Case 2
48:       optRaster.Value = True
    Case 3
50:       optExisting.Value = True
    Case Else                         ' DEFAULT IF NOT BEEN DONE BEFORE
52:       optPointTheme.Value = True
53:   End Select
  
55:   Set m_pMxDoc = m_pApp.Document
 
  Dim pSelItem As IUnknown
58:   Set pSelItem = m_pMxDoc.SelectedItem
  Dim pLayer As ILayer
  Dim pStandaloneTable As IStandaloneTable
  Dim lngIndex As Long
  Dim pUnknown As IUnknown

'  m_strSelLayerName = ""
'
'  If Not pSelItem Is Nothing Then
'    If TypeOf pSelItem Is ILayer Then
'      Set pLayer = pSelItem
'      m_strSelLayerName = pLayer.Name
'    ElseIf TypeOf pSelItem Is IStandaloneTable Then
'      Set pStandaloneTable = pSelItem
'      m_strSelLayerName = pStandaloneTable.Name
'    End If
'  End If

76:   m_pThisExt.ShouldContinue = False
77:   m_booSelToggle = False

  ' FILL LAYER ARRAY AND LISTBOX
80:   lbxLayers.Clear
  Dim lngStartSel As Long
82:   lngStartSel = 0
  
  Dim pPointLayer As IFeatureLayer
  Dim pRasterLayer As IRasterLayer
  Dim pRastBandColl As IRasterBandCollection
  Dim pRaster As IRaster
  
  ' CLEAR AND FILL LISTBOXES
  ' POINT LAYERS
91:   Set m_pPointLayerArray = TopoCorridor.MyGeneralOperations.ReturnLayersByType(m_pMxDoc.FocusMap, ENUM_jenPointLayers)
92:   lbxPointLayers.Clear
93:   If m_pPointLayerArray.Count > 0 Then
94:     For lngIndex = 0 To m_pPointLayerArray.Count - 1
95:       Set pPointLayer = m_pPointLayerArray.Element(lngIndex)
96:       lbxPointLayers.AddItem CStr(lngIndex + 1) & "]  " & pPointLayer.Name
97:     Next lngIndex
98:     lbxPointLayers.ListIndex = -1
    
100:     lblAll.Enabled = False
101:     lblSelected.Enabled = False
102:     optUseAll.Enabled = False
103:     optUseSelected.Enabled = False
    
105:     optUseAll.Value = True
106:     lblAll.Caption = "n = [No Layer Selected]"
107:     lblSelected.Caption = "n = [No Layer Selected]"
    
109:   End If
  
  ' RASTER LAYERS
112:   Set m_pRasterLayerArray = TopoCorridor.MyGeneralOperations.ReturnLayersByType(m_pMxDoc.FocusMap, ENUM_jenRasterLayers)
113:   Set m_pRasterLayerFields = Nothing
114:   lbxLayers.Clear
115:   lbxFields.Clear
116:   cbxValue.Clear
  Dim lngRastCounter As Long
  Dim pEnumRasterBand As IEnumRasterBand
  Dim pRastBand As IRasterBand
120:   lngRastCounter = 0
  Dim lngIndex2 As Long
  
  Dim pTable As ITable
124:   Set m_pTrueRasterLayerArray = New esriSystem.VarArray
125:   Set m_pTrueRasterLayerNames = New esriSystem.strArray
  Dim strName As String
  
128:   If m_pRasterLayerArray.Count > 0 Then
129:     For lngIndex = 0 To m_pRasterLayerArray.Count - 1
130:       Set pRasterLayer = m_pRasterLayerArray.Element(lngIndex)
131:       Set pRastBandColl = pRasterLayer.Raster
132:       If pRastBandColl.Count > 1 Then
133:         For lngIndex2 = 0 To pRastBandColl.Count - 1
134:           Set pRastBand = pRastBandColl.Item(lngIndex2)
'           Set pTable = pRastBand.AttributeTable              ' <----------------------
136:           Set pTable = TopoCorridor.TopoCor_Functions.ReturnRasterTable(pRastBand)
137:           If Not pTable Is Nothing Then
138:             lngRastCounter = lngRastCounter + 1
139:             strName = pRasterLayer.Name & "   [Band #" & CStr(lngIndex2 + 1) & "]"
140:             lbxLayers.AddItem CStr(lngRastCounter) & "]  " & strName
141:             m_pTrueRasterLayerArray.Add pRastBand
142:             m_pTrueRasterLayerNames.Add strName
143:           End If
144:         Next lngIndex2
145:       Else
146:         Set pRastBand = pRastBandColl.Item(0)
'        Set pTable = pRastBand.AttributeTable
148:         Set pTable = TopoCorridor.TopoCor_Functions.ReturnRasterTable(pRastBand)
149:         If Not pTable Is Nothing Then
150:           lngRastCounter = lngRastCounter + 1
151:           strName = pRasterLayer.Name
152:           lbxLayers.AddItem CStr(lngRastCounter) & "]  " & strName
153:           m_pTrueRasterLayerArray.Add pRastBand
154:           m_pTrueRasterLayerNames.Add strName
155:         End If
156:       End If
157:     Next lngIndex
158:     lbxLayers.ListIndex = -1
159:   End If
  
  ' STANDALONE TABLES
  Dim pTableLayerArray As esriSystem.IVariantArray
163:   Set pTableLayerArray = TopoCorridor.MyGeneralOperations.ReturnLayersByType(m_pMxDoc.FocusMap, ENUM_jenStandaloneTables)
164:   Set m_pMeanTableLayerArray = New esriSystem.VarArray
165:   Set m_pCovTableLayerArray = New esriSystem.VarArray
  
167:   lbxMean.Clear
168:   lbxCov.Clear
  Dim pStTable As IStandaloneTable
  Dim pCheckTable As ITable
  Dim lngFieldCount As Long
  Dim lngRecordCount As Long
  Dim lngFieldIndex As Long
  Dim pCheckField As IField
  
  Dim lngMeanCount As Long
  Dim lngCovCount As Long
  Dim booConsiderTable As Boolean
  
  ' ONLY ADD TABLES TO LIST IF THEY CAN POSSIBLY BE MEAN OR COVARIANCE TABLES
181:   If pTableLayerArray.Count > 0 Then
182:     For lngIndex = 0 To pTableLayerArray.Count - 1
183:       Set pStTable = pTableLayerArray.Element(lngIndex)
184:       Set pCheckTable = pStTable.Table
185:       If Not pCheckTable Is Nothing Then
186:         lngRecordCount = pCheckTable.RowCount(Nothing)             ' <------------------------
187:         lngFieldCount = 0
188:         booConsiderTable = True        ' DISQUALIFY ANY TABLES WITH NON-NUMERIC FIELDS
        
190:         For lngFieldIndex = 0 To pCheckTable.Fields.FieldCount - 1
191:           Set pCheckField = pCheckTable.Fields.Field(lngFieldIndex)
192:           If Not TopoCorridor.aml_func_mod.FieldIsNumeric(pCheckField) And pCheckField.Type <> esriFieldTypeOID Then
193:             booConsiderTable = False
194:           End If
195:           If pCheckField.Type <> esriFieldTypeOID And booConsiderTable Then
196:             lngFieldCount = lngFieldCount + 1
197:           End If
198:         Next lngFieldIndex
        
200:         If booConsiderTable Then
201:           If lngFieldCount = 1 Then
202:             m_pMeanTableLayerArray.Add pStTable
203:             lngMeanCount = lngMeanCount + 1
204:             lbxMean.AddItem CStr(lngMeanCount) & "]  " & pStTable.Name
205:           End If
206:           If lngFieldCount = lngRecordCount Then
207:             m_pCovTableLayerArray.Add pStTable
208:             lngCovCount = lngCovCount + 1
209:             lbxCov.AddItem CStr(lngCovCount) & "]  " & pStTable.Name
210:           End If
211:         End If
212:       End If
213:     Next lngIndex
214:     lbxMean.ListIndex = -1
215:     lbxCov.ListIndex = -1
216:   End If
  
  
  ' DISABLE OPTIONS IF NO DATA AVAILABLE
220:   If m_pPointLayerArray.Count = 0 Then
221:     If optPointTheme.Value = True Then
222:       optRaster.Value = True
223:       optPointTheme.Value = False
224:     End If
225:     optPointTheme.Value = False
226:     optPointTheme.Enabled = False
227:     cmdOptions1.Enabled = False
228:   End If
  
230:   If m_pTrueRasterLayerArray.Count = 0 Then
231:     If optRaster.Value = True Then
232:       If optPointTheme.Enabled Then
233:         optPointTheme.Value = True
234:       Else
235:         optExisting.Value = True
236:       End If
237:     End If
238:     optRaster.Value = False
239:     optRaster.Enabled = False
240:     cmdOptions2.Enabled = False
241:   End If
  
243:   If m_pCovTableLayerArray.Count = 0 Or m_pMeanTableLayerArray.Count = 0 Then
244:     If optExisting.Value = True Then
245:       If optPointTheme.Enabled = True Then
246:         optPointTheme.Value = True
247:       Else
248:         optRaster.Value = True
249:       End If
250:     End If
251:     optExisting.Value = False
252:     optExisting.Enabled = False
253:   End If
  
  ' FILL INSTRUCTION BOX
  Dim strBaseString As String
257:   strBaseString = strBaseString & "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fswiss\fcharset0 Arial;}{\f1\fnil\fcharset0 MS Sans Serif;}}" & vbNewLine
258:   strBaseString = strBaseString & "\viewkind4\uc1\pard\f0\fs16 Mahalanobis distances are calculated based on the means and covariances of a set of variables, and therefore the mean vector and covariance matrix must be specified." & vbNewLine
259:   strBaseString = strBaseString & "\par " & vbNewLine
260:   strBaseString = strBaseString & "\par The mean vector and covariance matrix may be calculated on-the-fly from your data, either based on point locations or from areas with a particular category value in a raster.  In these cases, this tool will calculate the means and covariances of the underlying variable datasets based on the locations of the points or the areas with a particular category value." & vbNewLine
261:   strBaseString = strBaseString & "\par " & vbNewLine
262:   strBaseString = strBaseString & "\par \pard The mean vector and covariance matrix may also be selected from tables currently available in your map document.   \b Note:  \b0 If you select existing tables, then you must take care to ensure that the order of variables in the tables is the same as the order of variables you use to calculate your Mahalanobis surface.  Please refer to the manual for additional information if this does not make sense. \f1\fs17 " & vbNewLine
263:   strBaseString = strBaseString & "\par }" & vbNewLine
264:   strBaseString = strBaseString & " " & vbNewLine

266:   txtMessage.TextRTF = strBaseString
  
  ' CLEAR INITIAL SELECTION
269:   Set m_pThisExt.frmCovSourceReturn = Nothing
270:   m_pThisExt.ShouldContinue = False
  
'  ' RELOAD IF NECESSARY
'  Dim pReloadParams As esriSystem.IVariantArray
'  Set pReloadParams = m_pThisExt.frmCovReloadParams
'  If Not pReloadParams Is Nothing Then
'    optPointTheme.Value = pReloadParams.Element(0)
'    optRaster.Value = pReloadParams.Element(1)
'    optExisting.Value = pReloadParams.Element(2)
'    lbxLayers.ListIndex = pReloadParams.Element(3)
'    If lbxLayers.ListIndex > -1 Then
'      Call lbxLayers_Click
'      lbxFields.ListIndex = pReloadParams.Element(4)
'      If lbxFields.ListIndex > -1 Then
'        Call lbxFields_Click
'        cbxValue.ListIndex = pReloadParams.Element(8)
'      End If
'    End If
'    lbxMean.ListIndex = pReloadParams.Element(5)
'    lbxCov.ListIndex = pReloadParams.Element(6)
'    lbxPointLayers.ListIndex = pReloadParams.Element(7)
'    If lbxPointLayers.ListIndex > -1 Then
'      Call lbxPointLayers_Click
'      optUseAll.Value = pReloadParams.Element(9)
'      optUseSelected.Value = Not pReloadParams.Element(9)
'    End If
'  End If
  
298:   CheckEnable
 
 Exit Property
ErrorHandler:
  HandleError True, "ArcApplication " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property


Public Property Get ReturnArray() As esriSystem.IVariantArray
  On Error GoTo ErrorHandler
 
309:   Set ReturnArray = m_pReturnArray
 
  Exit Property
ErrorHandler:
  HandleError True, "ReturnArray " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
  
Private Sub CheckEnable()
  On Error GoTo ErrorHandler
 
  Dim pGray As IColor
320:   Set pGray = New RgbColor
  
  Dim lngGray As Long
323:   lngGray = RGB(230, 230, 230)
  
325:   cmdOK.Enabled = lbxLayers.SelCount > 0 And lbxFields.SelCount > 0
326:   If optPointTheme.Value = True Then
327:     lblSelPointTheme.Visible = True
328:     lbxPointLayers.Visible = True
329:     lblAll.Visible = True
330:     lblSelected.Visible = True
331:     optUseAll.Visible = True
332:     optUseSelected.Visible = True
333:     frmSelAll.Visible = True
    
335:     lblLayer.Visible = False
336:     lblFields.Visible = False
337:     lbxMean.Visible = False
338:     lbxCov.Visible = False
    
340:     lblRasters.Visible = False
341:     lblRasterFields.Visible = False
342:     lbxLayers.Visible = False
343:     lbxFields.Visible = False
344:     lblValue.Visible = False
345:     cbxValue.Visible = False
    
347:     cmdOptions1.Enabled = True
348:     cmdOptions2.Enabled = False
    
350:     Line1.BorderColor = vbBlack
351:     Line2.BorderColor = lngGray
    
    ' CHECK IF OK SHOULD BE ENABLED
354:     cmdOK.Enabled = lbxPointLayers.SelCount > 0
    
356:   ElseIf optRaster.Value = True Then
357:     lblSelPointTheme.Visible = False
358:     lbxPointLayers.Visible = False
359:     lblAll.Visible = False
360:     lblSelected.Visible = False
361:     optUseAll.Visible = False
362:     optUseSelected.Visible = False
363:     frmSelAll.Visible = False
    
365:     lblLayer.Visible = False
366:     lblFields.Visible = False
367:     lbxMean.Visible = False
368:     lbxCov.Visible = False
    
370:     lblRasters.Visible = True
371:     lblRasterFields.Visible = True
372:     lbxLayers.Visible = True
373:     lbxFields.Visible = True
374:     lblValue.Visible = True
375:     cbxValue.Visible = True
    
377:     Line1.BorderColor = lngGray
378:     Line2.BorderColor = vbBlack
    
380:     cmdOptions1.Enabled = False
381:     cmdOptions2.Enabled = True
    
    ' CHECK IF OK SHOULD BE ENABLED
384:     cmdOK.Enabled = lbxLayers.SelCount > 0 And _
                    lbxFields.SelCount > 0 And _
                    cbxValue.ListIndex > 0 And _
                    cbxValue.Text <> ""
  
389:   ElseIf optExisting.Value = True Then
390:     lblSelPointTheme.Visible = False
391:     lbxPointLayers.Visible = False
392:     lblAll.Visible = False
393:     lblSelected.Visible = False
394:     optUseAll.Visible = False
395:     optUseSelected.Visible = False
396:     frmSelAll.Visible = False
    
398:     lblLayer.Visible = True
399:     lblFields.Visible = True
400:     lbxMean.Visible = True
401:     lbxCov.Visible = True
    
403:     lblRasters.Visible = False
404:     lblRasterFields.Visible = False
405:     lbxLayers.Visible = False
406:     lbxFields.Visible = False
407:     lblValue.Visible = False
408:     cbxValue.Visible = False
    
410:     cmdOptions1.Enabled = False
411:     cmdOptions2.Enabled = False
    
413:     Line1.BorderColor = lngGray
414:     Line2.BorderColor = lngGray
    
    ' CHECK IF OK SHOULD BE ENABLED
417:     cmdOK.Enabled = lbxMean.SelCount > 0 And _
                    lbxCov.SelCount > 0
  
420:   End If
 
  Exit Sub
ErrorHandler:
  HandleError False, "CheckEnable " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cbxValue_Click()
  On Error GoTo ErrorHandler

430:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "cbxValue_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdManual_Click()
  On Error GoTo ErrorHandler
  ' CHANGE AS APPROPRIATE
  Dim strDir As String
441:   strDir = App.Path
442:   If Right(strDir, 1) <> "\" Then strDir = strDir & "\"
443:   strDir = strDir & "docs"
  
445:   Call TopoCorridor.MyGeneralOperations.OpenDoc("Land_Facet_Tools.pdf", strDir)
 
  Exit Sub
ErrorHandler:
  HandleError True, "cmdManual_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdSelFields_Click()
  On Error GoTo ErrorHandler
 
  Dim lngIndex As Long
456:   For lngIndex = 0 To lbxFields.ListCount - 1
457:     lbxFields.Selected(lngIndex) = Not m_booSelToggle
458:   Next lngIndex
 
460:   lbxFields.ListIndex = 0
461:   lbxFields.Refresh
 
463:   m_booSelToggle = Not m_booSelToggle
464:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError False, "cmdSelFields_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdCancel_Click()
  On Error GoTo ErrorHandler
  
474:   m_pThisExt.ShouldContinue = False
475:   Set m_pThisExt.frmCovSourceReturn = Nothing
476:   Set m_pReturnArray = Nothing
477:   Unload Me
 
  Exit Sub
ErrorHandler:
  HandleError True, "cmdCancel_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdOK_Click()
  On Error GoTo ErrorHandler
  
487:   Set m_pReturnArray = New esriSystem.VarArray
  
  ' SOURCE OPTION
  Dim lngOption As Long
491:   If optPointTheme.Value = True Then
492:     lngOption = 1
493:   ElseIf optRaster.Value = True Then
494:     lngOption = 2
495:   ElseIf optExisting.Value = True Then
496:     lngOption = 3
497:   End If
498:   m_pThisExt.InitialSourceOption = lngOption
  
  ' SOURCE PARAMETERS
  Dim pSourceParams As esriSystem.IVariantArray
502:   Set pSourceParams = New esriSystem.VarArray
  
  Select Case lngOption
    Case 1                       ' POINT THEME
      Dim pPointLayer As IFeatureLayer
507:       Set pPointLayer = m_pPointLayerArray.Element(lbxPointLayers.ListIndex)
508:       pSourceParams.Add pPointLayer
509:       pSourceParams.Add optUseAll.Value              ' TRUE IF USING ALL POINTS, FALSE IF ONLY USING SELECTED POINTS
510:       pSourceParams.Add m_lngPointCount              ' TOTAL POINT COUNT FOR THIS LAYER
511:       pSourceParams.Add m_lngSelPointCount           ' SELECTED POINT COUNT FOR THIS LAYER
      
513:       m_pReturnArray.Add lngOption
514:       m_pReturnArray.Add pSourceParams
    
    Case 2                       ' CATEGORICAL RASTER
      Dim pRasterBand As IRasterBand
      Dim strRasterName As String
      Dim pField As IField
      Dim lngFieldIndex As Long
      Dim pTable As ITable
      Dim varValue As Variant
      Dim booIsString As Boolean
      
525:       Set pRasterBand = m_pTrueRasterLayerArray.Element(lbxLayers.ListIndex)
526:       strRasterName = m_pTrueRasterLayerNames.Element(lbxLayers.ListIndex)
'      Set pTable = pRasterBand.AttributeTable
528:       Set pTable = TopoCorridor.TopoCor_Functions.ReturnRasterTable(pRasterBand)
529:       Set pField = m_pRasterLayerFields.Element(lbxFields.ListIndex)
530:       lngFieldIndex = pTable.FindField(pField.Name)
531:       booIsString = pField.Type = esriFieldTypeString
532:       If booIsString Then
533:         varValue = cbxValue.Text
534:       Else
535:         varValue = m_dblValues(cbxValue.ListIndex - 1)
536:       End If
      
538:       pSourceParams.Add pRasterBand
539:       pSourceParams.Add strRasterName
540:       pSourceParams.Add lngFieldIndex
541:       pSourceParams.Add booIsString
542:       pSourceParams.Add varValue
      
544:       m_pReturnArray.Add lngOption
545:       m_pReturnArray.Add pSourceParams
    
    Case 3
      Dim pMeanST As IStandaloneTable
      Dim pCovST As IStandaloneTable
      Dim pMeanVector As ITable
      Dim pCovMatrix As ITable
      
553:       Set pMeanST = m_pMeanTableLayerArray.Element(lbxMean.ListIndex)
554:       Set pMeanVector = pMeanST.Table
      
556:       Set pCovST = m_pCovTableLayerArray.Element(lbxCov.ListIndex)
557:       Set pCovMatrix = pCovST.Table
      
      Dim booIncompatible As Boolean
560:       booIncompatible = False
      Dim strErrorMessage As String
562:       strErrorMessage = "Problem - Incompatible Mean Vector and Covariance Matrices:" & vbCrLf
      
      Dim strMeanNonNumericFields As String
      Dim strCovNonNumericFields As String
566:       strMeanNonNumericFields = "     --> "
567:       strCovNonNumericFields = "     --> "
      Dim booMeanNonNumeric As Boolean
      Dim booCovNonNumeric As Boolean
      
      Dim lngMeanRows As Long
      Dim lngMeanCols As Long
      Dim lngCovRows As Long
      Dim lngCovColumns As Long
      
576:       lngMeanRows = pMeanVector.RowCount(Nothing)
577:       lngCovRows = pCovMatrix.RowCount(Nothing)
      
      Dim pFields As IFields
      Dim lngFieldCounter As Long
      Dim pStatField As IField
      
      ' MEAN VECTOR COLUMNS
584:       lngMeanCols = 0
585:       Set pFields = pMeanVector.Fields
586:       For lngFieldCounter = 0 To pFields.FieldCount - 1
587:         Set pStatField = pFields.Field(lngFieldCounter)
588:         If pStatField.Type <> esriFieldTypeOID Then
589:           If Not TopoCorridor.aml_func_mod.FieldIsNumeric(pStatField) Then
590:             booMeanNonNumeric = True
591:             strMeanNonNumericFields = strMeanNonNumericFields & pStatField.Name & ", "
592:           Else
593:             lngMeanCols = lngMeanCols + 1
594:           End If
595:         End If
596:       Next lngFieldCounter
      ' REMOVE LAST COMMA AND SPACE
598:       strMeanNonNumericFields = Left(strMeanNonNumericFields, Len(strMeanNonNumericFields) - 2)
      ' ADD TO ERROR MESSAGE IF FOUND NON-NUMERIC FIELDS
600:       If booMeanNonNumeric Then
601:         booIncompatible = True
602:         strErrorMessage = strErrorMessage & "  --> The following field(s) in your Mean Vector are non-numeric:" & vbCrLf & strMeanNonNumericFields & vbCrLf
603:       End If
      
      ' COVARIANCE MATRIX COLUMNS
606:       lngCovColumns = 0
607:       Set pFields = pCovMatrix.Fields
608:       For lngFieldCounter = 0 To pFields.FieldCount - 1
609:         Set pStatField = pFields.Field(lngFieldCounter)
610:         If pStatField.Type <> esriFieldTypeOID Then
611:           If Not TopoCorridor.aml_func_mod.FieldIsNumeric(pStatField) Then
612:             booCovNonNumeric = True
613:             strCovNonNumericFields = strCovNonNumericFields & pStatField.Name & ", "
614:           Else
615:             lngCovColumns = lngCovColumns + 1
616:           End If
617:         End If
618:       Next lngFieldCounter
      ' REMOVE LAST COMMA AND SPACE
620:       strCovNonNumericFields = Left(strCovNonNumericFields, Len(strCovNonNumericFields) - 2)
      ' ADD TO ERROR MESSAGE IF FOUND NON-NUMERIC FIELDS
622:       If booCovNonNumeric Then
623:         booIncompatible = True
624:         strErrorMessage = strErrorMessage & "  --> The following field(s) in your Covariance Matrix are non-numeric:" & vbCrLf & _
            strMeanNonNumericFields & vbCrLf
626:       End If
        
      ' MAKE SURE ROWS OF MEAN VECTOR EQUAL COLUMNS OF COVARIANCE MATRIX
629:       If lngMeanRows <> lngCovColumns Then
630:         strErrorMessage = strErrorMessage & "  --> The number of rows in your Mean Vector (" & CStr(Format(lngMeanRows, "#,##0")) & _
          ") is not equal to the number of columns in your Covariance Matrix (" & CStr(Format(lngCovColumns, "#,##0")) & ")" & vbCrLf
632:         booIncompatible = True
633:       End If
      
      ' MAKE SURE EQUAL NUMBER OF ROWS AND COLUMNS IN COVARIANCE MATRIX
636:       If lngCovRows <> lngCovColumns Then
637:         strErrorMessage = strErrorMessage & "  --> The number of rows in your Covariance Matrix (" & CStr(Format(lngMeanRows, "#,##0")) & _
          ") is not equal to the number of columns in your Covariance Matrix (" & CStr(Format(lngCovColumns, "#,##0")) & ")" & vbCrLf
639:         booIncompatible = True
640:       End If
      
      ' MAKE SURE MEAN VECTOR HAS ONLY 1 NON-OID FIELD
643:       If lngMeanCols <> 1 Then
644:         strErrorMessage = strErrorMessage & "  --> Your Mean Vector has " & CStr(Format(lngMeanCols, "#,##0")) & _
          " non-OID columns.  There should only be 1 non-OID column." & vbCrLf
646:         booIncompatible = True
647:       End If
      
649:       If booIncompatible Then
      
        Dim frmReportForm As TopoCorridor.frmReportDialog
652:         Set frmReportForm = New TopoCorridor.frmReportDialog
653:         frmReportForm.txtReport.Text = strErrorMessage
654:         frmReportForm.txtReport.Locked = False
655:         frmReportForm.Caption = " Problems with Specified Statistical Matrices:"
656:         frmReportForm.Show vbModal
      
        Exit Sub
659:       Else
        
661:         pSourceParams.Add pMeanST
662:         pSourceParams.Add pCovST
663:         m_pReturnArray.Add lngOption
664:         m_pReturnArray.Add pSourceParams
        
666:       End If
667:   End Select
  
  ' CHECK FOR MISSING PROJECTION
  Dim pGeoDataset As IGeoDataset
  Dim pSpRef As ISpatialReference
  Dim booHasMissingSpRef As Boolean
  Dim booHasUnknownSpRef As Boolean
  
675:   booHasMissingSpRef = False
676:   booHasUnknownSpRef = False
  Dim strSourceName As String
  Select Case lngOption
    Case 1     ' POINT LAYER
680:       Set pGeoDataset = pPointLayer.FeatureClass
681:       Set pSpRef = pGeoDataset.SpatialReference
682:       If pSpRef Is Nothing Then
683:         booHasMissingSpRef = True
684:       Else
685:         booHasUnknownSpRef = TypeOf pSpRef Is IUnknownCoordinateSystem
686:       End If
687:       strSourceName = pPointLayer.Name
      
    Case 2     ' RASTER
690:       Set pGeoDataset = pRasterBand
691:       Set pSpRef = pGeoDataset.SpatialReference
692:       If pSpRef Is Nothing Then
693:         booHasMissingSpRef = True
694:       Else
695:         booHasUnknownSpRef = TypeOf pSpRef Is IUnknownCoordinateSystem
696:       End If
697:       strSourceName = strRasterName
      
699:   End Select
  
  Dim booBailOut As Boolean
702:   booBailOut = booHasMissingSpRef Or booHasUnknownSpRef
  
  Dim strMessage As String
705:   If booHasMissingSpRef Then
706:     strMessage = _
      "WARNING:" & vbCrLf & "---------------------------------------------" & vbCrLf & _
      "Your source dataset for the mean and covariance sample locations (" & strSourceName & ") " & _
      "is missing a spatial reference.  This function must know the spatial reference in order " & _
      "to ensure that the sample locations align correctly with the Mahalanobis input variables. " & _
      "Please define the spatial reference of your sample source dataset before running this function."
712:   ElseIf booHasUnknownSpRef Then
713:     strMessage = _
      "WARNING:" & vbCrLf & "---------------------------------------------" & vbCrLf & _
      "Your source dataset for the mean and covariance sample locations (" & strSourceName & ") " & _
      "has an unknown spatial reference.  This function must know the spatial reference in order " & _
      "to ensure that the sample locations align correctly with the Mahalanobis input variables. " & _
      "Please define the spatial reference of your sample source dataset before running this function."
719:   End If
  
721:   If booBailOut Then
    Dim pParams As esriSystem.IVariantArray
723:     Set pParams = New esriSystem.VarArray
    
    Dim strHeader As String
    ' 1 = Yes / No
    ' 2 = OK / Cancel
    ' 3 = Yes / No / Cancel
    ' 4 = OK Only
730:     strHeader = "ERROR: Unknown or Missing Spatial Reference:"
  
732:     pParams.Add m_pApp
733:     pParams.Add 4
734:     pParams.Add strHeader                                                 ' DIALOG CAPTION
735:     pParams.Add strMessage                                                ' MESSAGE
  
    Dim pForm As TopoCorridor.frmMsgBox
738:     Set pForm = New TopoCorridor.frmMsgBox
739:     Set pForm.theParameters = pParams
740:     pForm.Show vbModal
  
    ' 0 = Cancel
    ' 1 = Yes / OK
    ' 2 = No
  
    ' MsgBox "Message Box Response = " & CStr(lngResponse)
    
748:     m_pThisExt.ShouldContinue = False
749:     m_pThisExt.InputStep = 3
750:     Set m_pThisExt.frmCovReloadParams = Nothing
751:     Set m_pThisExt.frmCovSourceReturn = Nothing
    Exit Sub
753:   End If
  
  Dim pSaveArray As esriSystem.IVariantArray
756:   Set pSaveArray = New esriSystem.VarArray
  Dim lngIndex As Long
758:   For lngIndex = 0 To m_pReturnArray.Count - 1
759:     pSaveArray.Add m_pReturnArray.Element(lngIndex)
760:   Next lngIndex
761:   Set m_pThisExt.frmCovSourceReturn = pSaveArray
  
763:   m_pThisExt.ShouldContinue = True
764:   Set m_pThisExt.frmCovSourceReturn = m_pReturnArray
  
766:   m_pThisExt.InputStep = 2
  
768:   Me.Visible = False
  
'  ' SAVE CURRENT STATE IN CASE USER CLICKS 'BACK' FROM NEXT DIALOG
'  Dim pReloadParams As esriSystem.IVariantArray
'  Set pReloadParams = New esriSystem.VarArray
'  pReloadParams.Add optPointTheme.Value
'  pReloadParams.Add optRaster.Value
'  pReloadParams.Add optExisting.Value
'  pReloadParams.Add lbxLayers.ListIndex
'  pReloadParams.Add lbxFields.ListIndex
'  pReloadParams.Add lbxMean.ListIndex
'  pReloadParams.Add lbxCov.ListIndex
'  pReloadParams.Add lbxPointLayers.ListIndex
'  pReloadParams.Add cbxValue.ListIndex
'  pReloadParams.Add optUseAll.Value
'  Set m_pThisExt.frmCovReloadParams = pReloadParams
'
'  Unload Me
  
  Exit Sub
ErrorHandler:
  HandleError True, "cmdOK_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub SetAdditionalDataOptions()
  On Error GoTo ErrorHandler


  Dim pOptionsForm As TopoCorridor.frmSaveTables
797:   Set pOptionsForm = New TopoCorridor.frmSaveTables
  
  Dim pParams As esriSystem.IVariantArray
800:   Set pParams = New esriSystem.VarArray
801:   pParams.Add m_pApp
802:   pParams.Add m_pMxDoc
803:   pParams.Add m_pThisExt
804:   Set pOptionsForm.ArcApplication = pParams
  
'   Me.Visible = False
807:   pOptionsForm.Show vbModal
808:   Set pOptionsForm = Nothing
'   Me.Visible = True
  
  ' FOR DEBUGGING
'  Dim strReport As String
'  Dim pMeansParams As esriSystem.IVariantArray
'  Set pMeansParams = m_pThisExt.StatsSaveMeansOptions
'  Dim pCovParams As esriSystem.IVariantArray
'  Set pCovParams = m_pThisExt.StatsSaveCovOptions
'  Dim pInvCovParams As esriSystem.IVariantArray
'  Set pInvCovParams = m_pThisExt.StatsSaveInvCovOptions
'  Dim pCorrParams As esriSystem.IVariantArray
'  Set pCorrParams = m_pThisExt.StatsSaveCorrelationOptions
'  Dim strMeansReport As String
'  If pMeansParams Is Nothing Then
'    strMeansReport = "  No Means Parameters specified..."
'  Else
'    strMeansReport = "  Table Name = " & pMeansParams.Element(0) & vbCrLf & _
'    "  WS Path = " & pMeansParams.Element(1) & vbCrLf & _
'    "  Full Path = " & pMeansParams.Element(2) & vbCrLf & _
'    "  Workspace Type = " & CStr(pMeansParams.Element(3))
'  End If
'  Dim strCovReport As String
'  If pCovParams Is Nothing Then
'    strCovReport = "  No Covariance Parameters specified..."
'  Else
'    strCovReport = "  Table Name = " & pCovParams.Element(0) & vbCrLf & _
'    "  WS Path = " & pCovParams.Element(1) & vbCrLf & _
'    "  Full Path = " & pCovParams.Element(2) & vbCrLf & _
'    "  Workspace Type = " & CStr(pCovParams.Element(3))
'  End If
'  Dim strInvCovReport As String
'  If pInvCovParams Is Nothing Then
'    strInvCovReport = "  No Inverse Covariance Parameters specified..."
'  Else
'    strInvCovReport = "  Table Name = " & pInvCovParams.Element(0) & vbCrLf & _
'    "  WS Path = " & pInvCovParams.Element(1) & vbCrLf & _
'    "  Full Path = " & pInvCovParams.Element(2) & vbCrLf & _
'    "  Workspace Type = " & CStr(pInvCovParams.Element(3))
'  End If
'  Dim strCorrReport As String
'  If pCorrParams Is Nothing Then
'    strCorrReport = "  No Correlation Parameters specified..."
'  Else
'    strCorrReport = "  Table Name = " & pCorrParams.Element(0) & vbCrLf & _
'    "  WS Path = " & pCorrParams.Element(1) & vbCrLf & _
'    "  Full Path = " & pCorrParams.Element(2) & vbCrLf & _
'    "  Workspace Type = " & CStr(pCorrParams.Element(3))
'  End If
'  strReport = _
'    "Save Means = " & CStr(m_pThisExt.StatsSaveMeans) & vbCrLf & strMeansReport & vbCrLf & _
'    "Save Covariances = " & CStr(m_pThisExt.StatsSaveCov) & vbCrLf & strCovReport & vbCrLf & _
'    "Save Inverse Covariances = " & CStr(m_pThisExt.StatsSaveInvCov) & vbCrLf & strInvCovReport & vbCrLf & _
'    "Save Correlation = " & CStr(m_pThisExt.StatsSaveCorrelation) & vbCrLf & strCorrReport
'  MsgBox strReport


  Exit Sub
ErrorHandler:
  HandleError False, "SetAdditionalDataOptions " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdOptions1_Click()
  On Error GoTo ErrorHandler

873:   SetAdditionalDataOptions

  Exit Sub
ErrorHandler:
  HandleError True, "cmdOptions1_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdOptions2_Click()
  On Error GoTo ErrorHandler

883:   SetAdditionalDataOptions

  Exit Sub
ErrorHandler:
  HandleError True, "cmdOptions2_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Form_Activate()
  On Error GoTo ErrorHandler

893:   m_pThisExt.ShouldContinue = False

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Activate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Form_Load()
  On Error GoTo ErrorHandler
 
903:   SetWindowPos Me.hWnd, -1, 0, 0, 0, 0, &H1 Or &H2
904:   Me.Left = (Screen.Width / 2) - (Me.Width / 2)
905:   Me.Top = (Screen.Height / 3) - (Me.Height / 3)
  
  Dim lngTopBar As Long
908:   lngTopBar = Me.Height - Me.ScaleHeight
909:   Me.Height = cmdOK.Top + cmdOK.Height + lngTopBar
910:   lbxFields.Top = 3300
911:   lbxLayers.Top = 3300
912:   lbxMean.Top = 3300
913:   lbxCov.Top = 3300
914:   cbxValue.Top = 4980
915:   lblValue.Top = 5025
 
917:    Set Anchors = New AnchorObjectList  ' Create new instance
918:    With Anchors
919:       With .Item(cbxValue)
920:          .SetAnchors enumStartEnd, enumSizeEnd
921:       End With
922:       With .Item(cmdCancel)
923:          .SetAnchors enumSizeEnd, enumSizeEnd
924:       End With
925:       With .Item(cmdManual)
926:          .SetAnchors enumSizeEnd, enumSizeEnd
927:       End With
928:       With .Item(cmdOK)
929:          .SetAnchors enumSizeEnd, enumSizeEnd
930:       End With
931:       With .Item(cmdOptions1)
932:          .SetAnchors enumSizeEnd, enumSizeEnd
933:       End With
934:       With .Item(cmdOptions2)
935:          .SetAnchors enumSizeEnd, enumSizeEnd
936:       End With
937:       With .Item(imgBackTop)
938:          .SetAnchors enumStartEnd, enumSizeEnd
939:       End With
940:       With .Item(imgCornerBars)
941:          .SetAnchors enumSizeEnd, enumSizeEnd
942:       End With
943:       With .Item(lblFields)
944:          .SetAnchors enumSize, enumSizeEnd
945:       End With
946:       With .Item(lblLayer)
947:          .SetAnchors enumSize, enumSizeEnd
948:       End With
949:       With .Item(lblLine)
950:          .SetAnchors enumSize, enumSizeEnd
951:       End With
952:       With .Item(lblRasterFields)
953:          .SetAnchors enumSizeEnd, enumSizeEnd
954:       End With
955:       With .Item(lblRasters)
956:          .SetAnchors enumSize, enumSizeEnd
957:       End With
958:       With .Item(lblSelPointTheme)
959:          .SetAnchors enumSize, enumSizeEnd
960:       End With
961:       With .Item(lblSource)
962:          .SetAnchors enumSize, enumSizeEnd
963:       End With
964:       With .Item(lblValue)
965:          .SetAnchors enumStartSize, enumSizeEnd
966:       End With
967:       With .Item(lbxCov)
968:          .SetAnchors enumEnd, enumSizeEnd
969:       End With
      
      
972:       With .Item(lblAll)
973:          .SetAnchors enumSizeEnd, enumSizeEnd
974:       End With
975:       With .Item(lblSelected)
976:          .SetAnchors enumSizeEnd, enumSizeEnd
977:       End With
978:       With .Item(optUseAll)
979:          .SetAnchors enumSizeEnd, enumSizeEnd
980:       End With
981:       With .Item(optUseSelected)
982:          .SetAnchors enumSizeEnd, enumSizeEnd
983:       End With
984:       With .Item(frmSelAll)
985:          .SetAnchors enumSizeEnd, enumSizeEnd
986:       End With
      
988:       With .Item(lbxFields)
989:          .SetAnchors enumSizeEnd, enumSizeEnd
990:       End With
991:       With .Item(lbxLayers)
992:          .SetAnchors enumStartEnd, enumSizeEnd
993:       End With
994:       With .Item(lbxMean)
995:          .SetAnchors enumStart, enumSizeEnd
996:       End With
997:       With .Item(lbxPointLayers)
998:          .SetAnchors enumStartEnd, enumSizeEnd
999:       End With
1000:       With .Item(optExisting)
1001:          .SetAnchors enumStartSize, enumSizeEnd
1002:       End With
1003:       With .Item(optPointTheme)
1004:          .SetAnchors enumStartSize, enumSizeEnd
1005:       End With
1006:       With .Item(optRaster)
1007:          .SetAnchors enumStartSize, enumSizeEnd
1008:       End With
1009:       With .Item(txtMessage)
1010:          .SetAnchors enumStartEnd, enumStartEnd
1011:       End With
1012:       .Form = Me  ' Set form reference (suggested to be last step)
1013:    End With


1016:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub Form_Resize()
  On Error GoTo ErrorHandler

  Dim lngRight As Long
  Dim lngTopY As Long
  Dim lngBottomY As Long
  
1030:   lngTopY = cmdOptions1.Top + (cmdOptions1.Height / 2)
1031:   lngBottomY = cmdOptions2.Top + (cmdOptions2.Height / 2)
  
1033:   lngRight = Me.Width - 2000
  
1035:   Line1.X2 = lngRight
1036:   Line1.Y1 = lngTopY
1037:   Line1.Y2 = lngTopY
1038:   Line2.X2 = lngRight
1039:   Line2.Y1 = lngBottomY
1040:   Line2.Y2 = lngBottomY

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Resize " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Form_Terminate()
  On Error GoTo ErrorHandler

1050:   Set m_pMxDoc = Nothing
1051:   Set m_pApp = Nothing
1052:   Set m_pThisExt = Nothing
1053:   Set Anchors = Nothing
1054:   Set m_pThisExt = Nothing
1055:   Set m_pReturnArray = Nothing
1056:   Set m_pPointLayerArray = Nothing
1057:   Set m_pRasterLayerArray = Nothing
1058:   Set m_pTrueRasterLayerArray = Nothing
1059:   Set m_pTrueRasterLayerNames = Nothing
1060:   Set m_pRasterLayerFields = Nothing
1061:   Set m_pMeanTableLayerArray = Nothing
1062:   Set m_pCovTableLayerArray = Nothing

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Terminate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Form_Unload(Cancel As Integer)
  On Error GoTo ErrorHandler
'
'  Set m_pMxDoc = Nothing
'  Set m_pApp = Nothing
'  Set m_pThisExt = Nothing
'  Set Anchors = Nothing
'  Set m_pThisExt = Nothing
'  Set m_pReturnArray = Nothing
'  Set m_pPointLayerArray = Nothing
'  Set m_pRasterLayerArray = Nothing
'  Set m_pTrueRasterLayerArray = Nothing
'  Set m_pTrueRasterLayerNames = Nothing
'  Set m_pRasterLayerFields = Nothing
'  Set m_pTableLayerArray = Nothing

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Unload " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub lbxCov_Click()
  On Error GoTo ErrorHandler

1093:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "lbxCov_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub lbxPointLayers_Click()
  On Error GoTo ErrorHandler
  
  Dim pFeatureLayer As IFeatureLayer
1104:   Set pFeatureLayer = m_pPointLayerArray.Element(lbxPointLayers.ListIndex)
  Dim pFeatureClass As IFeatureClass
1106:   Set pFeatureClass = pFeatureLayer.FeatureClass

  ' UPDATE CONVERSION OPTIONS
  Dim lngNumRecs As Long
  Dim lngSelRecs As Long
 
  Dim pSelSet As ISelectionSet

1114:   lngNumRecs = pFeatureClass.FeatureCount(Nothing)
  Dim pFeatSel As IFeatureSelection
1116:   Set pFeatSel = pFeatureLayer
1117:   Set pSelSet = pFeatSel.SelectionSet

1119:   lngSelRecs = pSelSet.Count
  
'  MsgBox "optUseAll Should Be True = " & CStr(lngSelRecs = 0)
1122:   optUseAll.Value = lngSelRecs = 0
1123:   optUseAll.Enabled = True
1124:   lblAll.Enabled = True
'  MsgBox "optUseAll Is True = " & CStr(optUseAll.Value)
  
1127:   optUseSelected.Enabled = Not lngSelRecs = 0
1128:   optUseSelected.Value = Not lngSelRecs = 0
1129:   lblSelected.Enabled = Not lngSelRecs = 0
  
'  MsgBox "optUseAll Is True (after OptUseSelected Value Set) = " & CStr(optUseAll.Value)
  
1133:   lblAll.Caption = "n = " & CStr(Format(lngNumRecs, "#,##0")) & " points"
1134:   lblSelected.Caption = "n = " & CStr(Format(lngSelRecs, "#,##0")) & _
      " of " & CStr(Format(lngNumRecs, "#,##0")) & " points"
 
1137:   m_lngPointCount = lngNumRecs
1138:   m_lngSelPointCount = lngSelRecs
  
1140:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "lbxPointLayers_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub lbxMean_Click()
  On Error GoTo ErrorHandler

1150:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "lbxMean_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub lbxFields_Click()
  On Error GoTo ErrorHandler
  
  Dim pRasterBand As IRasterBand
1161:   Set pRasterBand = m_pTrueRasterLayerArray.Element(lbxLayers.ListIndex)
  Dim pTable As ITable
1163:   Set pTable = TopoCorridor.TopoCor_Functions.ReturnRasterTable(pRasterBand)
'  Set pTable = pRasterBand.AttributeTable
  
  Dim pFields As IFields
  Dim pField As IField
  Dim pFieldInfo As IFieldInfo
  
1170:   Set pField = m_pRasterLayerFields.Element(lbxFields.ListIndex)
  
1172:   cbxValue.Clear
1173:   cbxValue.AddItem "Select Category Value from List Below:"
  
  Dim booIsString As Boolean
1176:   booIsString = pField.Type = esriFieldTypeString
  
  Dim pCollection As New Collection
  Dim pRow As IRow
  Dim pCursor As ICursor
1181:   Set pCursor = pTable.Search(Nothing, True)
1182:   Set pRow = pCursor.NextRow
  
  Dim lngFieldIndex As Long
1185:   lngFieldIndex = pTable.FindField(pField.Name)
  
  Dim lngCounter As Long
1188:   lngCounter = -1
  Dim strTestValue As String
  Dim lngIndex As Long
  Dim dblValue As Double
  
1193:   If booIsString Then
    Dim strValues() As String
    ReDim strValues(pTable.RowCount(Nothing))
    
1197:     Do Until pRow Is Nothing
      
1199:       strTestValue = pRow.Value(lngFieldIndex)
      
      ' CHECK IF VALUE ALREADY EXISTS
1202:       If Not TopoCorridor.MyGeneralOperations.CheckCollectionForKey(pCollection, strTestValue) Then
1203:         lngCounter = lngCounter + 1
1204:         strValues(lngCounter) = strTestValue
1205:         pCollection.Add 1, strTestValue
'      Else
1207:       End If
      
1209:       Set pRow = pCursor.NextRow
1210:     Loop
    
    ReDim Preserve strValues(lngCounter)
1213:     TopoCorridor.QuickSort.StringsAscending strValues, 0, lngCounter
    
1215:     For lngIndex = 0 To lngCounter
1216:       cbxValue.AddItem strValues(lngIndex)
1217:     Next lngIndex
1218:     cbxValue.ListIndex = 0
1219:   Else
    Dim dblValues() As Double
    ReDim dblValues(pTable.RowCount(Nothing))
    
1223:     Do Until pRow Is Nothing
      
1225:       dblValue = pRow.Value(lngFieldIndex)
1226:       strTestValue = CStr(Format(dblValue, "#.####################"))
1227:       strTestValue = TopoCorridor.aml_func_mod.BasicTrimAvenue(strTestValue, "", ".")
      
      ' CHECK IF VALUE ALREADY EXISTS
1230:       If Not TopoCorridor.MyGeneralOperations.CheckCollectionForKey(pCollection, strTestValue) Then
1231:         lngCounter = lngCounter + 1
1232:         dblValues(lngCounter) = dblValue
1233:         pCollection.Add 1, strTestValue
 '     Else
1235:       End If
      
1237:       Set pRow = pCursor.NextRow
1238:     Loop
    
    ReDim Preserve dblValues(lngCounter)
1241:     TopoCorridor.QuickSort.DoubleAscending dblValues, 0, lngCounter
    
1243:     For lngIndex = 0 To lngCounter
1244:       cbxValue.AddItem dblValues(lngIndex)
1245:     Next lngIndex
1246:     cbxValue.ListIndex = 0
1247:     m_dblValues = dblValues
1248:   End If
    
    
  
  
1253:   CheckEnable
 
  Exit Sub
ErrorHandler:
  HandleError True, "lbxFields_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub lbxLayers_Click()
  On Error GoTo ErrorHandler
  
  Dim pRasterBand As IRasterBand
1264:   Set pRasterBand = m_pTrueRasterLayerArray.Element(lbxLayers.ListIndex)
  Dim pTable As ITable
1266:   Set pTable = TopoCorridor.TopoCor_Functions.ReturnRasterTable(pRasterBand)
'  Set pTable = pRasterBand.AttributeTable
  
  Dim pFields As IFields
  Dim pField As IField
  Dim pFieldInfo As IFieldInfo

1273:   Set pFields = pTable.Fields
1274:   lbxFields.Clear
  
1276:   Set m_pRasterLayerFields = TopoCorridor.MyGeneralOperations.ReturnFieldsByType(pFields, ENUM_FieldNumber + ENUM_FieldString)

  Dim lngIndex As Long
1279:   For lngIndex = 0 To m_pRasterLayerFields.Count - 1
1280:     Set pField = m_pRasterLayerFields.Element(lngIndex)
1281:     lbxFields.AddItem pField.AliasName
1282:   Next lngIndex
1283:   lbxFields.ListIndex = -1

1285:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "lbxLayers_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub ExtraCodeRequired()
 
  '' PUT IN EXTENSION CLASS
  '
  'Private m_booShouldContinue As Boolean
  'Private m_strDirPath As String
  'Private m_pfrmCovSourceReturn As esriSystem.IVariantArray
  'Private m_strDirType As String
  'Private m_booIsFeatDataset As Boolean
  'Private m_strFeatDatasetName As String
  '
  '' PUT IN EXTENSION SHUTDOWN EVENT
  ' Set m_pfrmCovSourceReturn = Nothing
  '
  '' SET FOLLOWING PROPERTIES
  'Public Property Let FeatDatasetName(strFeatDatasetName As String)
  '  m_strFeatDatasetName = strFeatDatasetName
  'End Property
  'Public Property Get FeatDatasetName() As String
  '  FeatDatasetName = m_strFeatDatasetName
  'End Property
  'Public Property Let IsFeatureDataset(booIsFeatDataset As Boolean)
  '  m_booIsFeatDataset = booIsFeatDataset
  'End Property
  'Public Property Get IsFeatureDataset() As Boolean
  '  IsFeatureDataset = m_booIsFeatDataset
  'End Property
  'Public Property Let DirectoryType(strDirType As String)
  '  m_strDirType = strDirType
  'End Property
  'Public Property Get DirectoryType() As String
  '  DirectoryType = m_strDirType
  'End Property
  '
  'Public Property Set frmCovSourceReturn(pfrmCovSourceReturn As esriSystem.IVariantArray)
  '  Set m_pfrmCovSourceReturn = pfrmCovSourceReturn
  'End Property
  '
  'Public Property Get frmCovSourceReturn() As esriSystem.IVariantArray
  '  Set frmCovSourceReturn = m_pfrmCovSourceReturn
  'End Property
  '
  'Public Property Let DirectoryPath(strPath As String)
  '  On Error GoTo ErrorHandler
  '  m_strDirPath = strPath
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "DirectoryPath " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  'Public Property Get DirectoryPath() As String
  '  On Error GoTo ErrorHandler
  '  DirectoryPath = m_strDirPath
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "DirectoryPath " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  'Public Property Let ShouldContinue(booShouldContinue As Boolean)
  '  On Error GoTo ErrorHandler
  '  m_booShouldContinue = booShouldContinue
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "ShouldContinue " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  'Public Property Get ShouldContinue() As Boolean
  '  On Error GoTo ErrorHandler
  '  ShouldContinue = m_booShouldContinue
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "ShouldContinue " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  '' PUT IN EXTENSION STARTUP EVENT
  '  If m_strDirPath = "" Or m_strDirType = "" Then
  '    m_strDirType = "Shapefile"
  '    m_strDirPath = ""
  '    m_booIsFeatDataset = False
  '    m_strFeatDatasetName = ""
  '  End If
  '
  '===============================================================================================================
  '
' ' SAMPLE CODE
'    Dim pVarArray As esriSystem.IVariantArray
'    Set pVarArray = New VarArray
'
'    ' ADD APPLICATION
'    pVarArray.Add m_pApp
'
'    ' ADD DESIRED LAYER TYPES
'    Dim pLayerTypes As JenLayerTypes
'    pLayerTypes = ENUM_jenPointLayers + ENUM_jenRasterLayers
'    pVarArray.Add pLayerTypes
'
'    'EXTENSION SHOULD HAVE PROPERTIES FOR "ShouldContinue", "DirectoryPath", "frmCovSourceReturn",
'    '     "DirectoryType", "IsFeatureDataset", "FeatDatasetName"
'    pVarArray.Add m_pThisExt
'
'    ' ADD DESIRED FIELD TYPES
'    Dim pFieldTypes As JenFieldTypes
'    pFieldTypes =  ENUM_FieldNumber
'    pVarArray.Add pFieldTypes
'
'    ' ADD WHETHER TO INCLUDE ID FIELD
'    pVarArray.Add (False)
'
'    ' ADD WHETHER ANY OUTPUT WILL BE A FEATURE CLASS (TRUE) OR TABLE (FALSE)         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    Dim booOutputIsFClass As Boolean                                                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    booOutputIsFClass = True                                                         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    pVarArray.Add (booOutputIsFClass)                                                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'
'    Dim pForm As TopoCorridor.frmCovSource
'    Set pForm = New TopoCorridor.frmCovSource
'    Set pForm.ArcApplication = pVarArray
'    pForm.Show vbModal
'    Set pForm = Nothing
'
'    If m_pThisExt.ShouldContinue = False Then
'      MsgBox "Function Canceled:" & vbCrLf & "Bailing out..."
'      Exit Sub
'    End If
'
'    Dim pReturnArray As esrisystem.IVariantArray
'    Set pReturnArray = m_pThisExt.frmCovSourceReturn
 
'    ' OUTPUT
'    ' SELECTED TABLE OR LAYER
'    Dim pUnknown As IUnknown
'    Set pUnknown = pReturnArray.Element(0)
'
'    ' FOR DEBUGGING
'    Dim strReport As String
'    strReport = "Selected Items:" & vbNewLine
'
'    If TypeOf pUnknown Is ILayer Then
'      Dim pLayer As ILayer
'      Set pLayer = pUnknown
'      strReport = strReport & "Name:  " & pLayer.Name & vbNewLine
'    ElseIf TypeOf pUnknown Is IStandaloneTable Then
'      Dim pStTab As IStandaloneTable
'      Set pStTab = pUnknown
'      strReport = strReport & "Name:  " & pStTab.Name & vbNewLine
'    End If
'
'    ' SELECTED FIELD OR FIELDS
'    Dim pSelFields As esriSystem.IVariantArray
'    Set pSelFields = pReturnArray.Element(1)
'    strReport = strReport & CStr(pSelFields.Count) & " fields selected..." & vbNewLine
'
'    Dim pField As IField
'    Set pField = pSelFields.Element(0)
'    strReport = strReport & "First Selected Field is named '" & pField.Name & "'" & vbNewLine
'

''  ' SAMPLE SNIPPET FOR FEATURE LAYERS:  ROTATE THROUGH ALL OR SELECTED RECORDS
''  Dim pFeatureLayer As IFeatureLayer
''  Dim pFClass As IFeatureClass
''  Dim pFeatSel As IFeatureSelection
''  Dim pSelSet As ISelectionSet
''  Dim pCursor As IFeatureCursor
''  Dim lngCount As Long
''
''  Set pFClass = pFeatureLayer.FeatureClass
''  Set pFeatSel = pFeatureLayer
''  Set pSelSet = pFeatSel.SelectionSet
''
''  If pSelSet.Count = 0 Then
''    Set pCursor = pFClass.Search(Nothing, False)
''    lngCount = pFClass.FeatureCount(Nothing)
''  Else
''    If booDoAll = True Then
''      Set pCursor = pFClass.Search(Nothing, False)
''      lngCount = pFClass.FeatureCount(Nothing)
''    Else
''      pSelSet.Search Nothing, True, pCursor
''      lngCount = pSelSet.Count
''    End If
''  End If
''
''  Dim pFeature As IFeature
''  Set pFeature = pCursor.NextFeature
''  Do Until pFeature Is Nothing
''    ' DO ACTIONS
''    Set pFeature = pCursor.NextFeature
''  Loop
''
''  ' SAMPLE CODE SNIPPET:  ADD RECORDS TO FEATURE CLASS USING BUFFER
''  Dim pBuffer As IFeatureBuffer
''  Set pBuffer = pFClass.CreateFeatureBuffer
''  Dim pNewFeatureCursor As IFeatureCursor
''  Set pNewFeatureCursor = pFClass.Insert(True)
''  ' LOOP THROUGH WHATEVER STEPS ARE REQUIRED TO GATHER DATA FOR A SINGLE ROW
''    Set pBuffer.Shape = aGeometry
''    pBuffer.Value(lngFieldIndex) = aValue
''    pNewFeatureCursor.InsertFeature pBuffer
''  ' LOOP
''  pNewFeatureCursor.Flush

''  ' SAMPLE SNIPPET FOR TABLES:  ROTATE THROUGH ALL OR SELECTED RECORDS
''  Dim pStandaloneTable As IStandaloneTable
''  Dim pInputTable As ITable
''  Dim pTableSel As ITableSelection
''  Dim pSelSet As ISelectionSet
''  Dim pRowCursor As ICursor
''  Dim lngCount As Long
''
''  Set pInputTable = pStandaloneTable.Table
''  Set pTableSel = pStandaloneTable
''  Set pSelSet = pTableSel.SelectionSet
''
''  If pSelSet.Count = 0 Then
''    Set pRowCursor = pInputTable.Search(Nothing, False)
''    lngCount = pInputTable.FeatureCount(Nothing)
''  Else
''    If booDoAll = True Then
''      Set pRowCursor = pInputTable.Search(Nothing, False)
''      lngCount = pInputTable.FeatureCount(Nothing)
''    Else
''      pSelSet.Search Nothing, True, pRowCursor
''      lngCount = pSelSet.Count
''    End If
''  End If
''
''  Dim pRow As IRow
''  Set pRow = pRowCursor.NextRow
''  Do Until pRow Is Nothing
'''     DO ACTIONS
''    Set pRow = pRowCursor.NextFeature
''  Loop
 
''  ' SAMPLE CODE SNIPPET:  ADD RECORDS TO TABLE USING BUFFER
''  Dim pBuffer As IRowBuffer
''  Set pBuffer = pTable.CreateRowBuffer
''  Dim pTableCursor As ICursor
''  Set pTableCursor = pTable.Insert(True)
''  ' LOOP THROUGH WHATEVER STEPS ARE REQUIRED TO GATHER DATA FOR A SINGLE ROW
''    pBuffer.Value(lngFieldIndex) = aValue
''    pTableCursor.InsertRow pBuffer
''  ' LOOP
''  pTableCursor.Flush
'    MsgBox strReport, vbOKOnly, "Test of LayerID Form:"
'
'  Dim pDocDirty As IDocumentDirty
'  Set pDocDirty = m_pMxDoc
'  pDocDirty.SetDirty
'

End Sub
 

Private Sub optExisting_Click()
  On Error GoTo ErrorHandler

1547:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "optExisting_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub optPointTheme_Click()
  On Error GoTo ErrorHandler

1557:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "optPointTheme_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub optRaster_Click()
  On Error GoTo ErrorHandler

1567:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "optRaster_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
