VERSION 5.00
Begin VB.Form frmDensityRaster 
   Caption         =   " Density Raster Parameters:"
   ClientHeight    =   6435
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6375
   Icon            =   "frmDensityRaster.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   6435
   ScaleWidth      =   6375
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtCells 
      Alignment       =   2  'Center
      Height          =   315
      Left            =   3480
      TabIndex        =   16
      Text            =   "txtCells"
      Top             =   3840
      Width           =   1245
   End
   Begin VB.CheckBox chkNull 
      Caption         =   "Set to NoData if any NoData cells in neighborhood"
      Height          =   405
      Left            =   1260
      TabIndex        =   15
      Top             =   4155
      Width           =   4860
   End
   Begin VB.ListBox lbxFields 
      Height          =   1620
      Left            =   3630
      TabIndex        =   2
      Top             =   1425
      Width           =   2535
   End
   Begin VB.ListBox lbxLayers 
      Height          =   1620
      Left            =   195
      TabIndex        =   1
      Top             =   1425
      Width           =   3420
   End
   Begin VB.ComboBox cbxValue 
      Height          =   315
      Left            =   1965
      Style           =   2  'Dropdown List
      TabIndex        =   3
      Top             =   3120
      Width           =   3855
   End
   Begin VB.CommandButton cmdGetWorkspace 
      Height          =   360
      Left            =   5820
      Picture         =   "frmDensityRaster.frx":058A
      Style           =   1  'Graphical
      TabIndex        =   6
      ToolTipText     =   "Browse for Output Feature Class..."
      Top             =   5565
      Width           =   465
   End
   Begin VB.TextBox txtOutput 
      Height          =   330
      Left            =   165
      TabIndex        =   5
      Text            =   "txtOutput"
      Top             =   5580
      Width           =   5595
   End
   Begin VB.ComboBox cbxFormat 
      Height          =   315
      Left            =   3795
      Style           =   2  'Dropdown List
      TabIndex        =   4
      Top             =   5055
      Width           =   2460
   End
   Begin VB.CommandButton cmdManual 
      Caption         =   "Manual"
      Height          =   345
      Left            =   2655
      TabIndex        =   8
      Top             =   6090
      Width           =   1065
   End
   Begin VB.TextBox txtMessage 
      Height          =   960
      Left            =   90
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      TabStop         =   0   'False
      Text            =   "frmDensityRaster.frx":0600
      Top             =   75
      Width           =   6195
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   345
      Left            =   3720
      TabIndex        =   9
      Top             =   6090
      Width           =   1065
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   345
      Left            =   1575
      TabIndex        =   7
      Top             =   6090
      Width           =   1065
   End
   Begin VB.Image imgNbrHoodBack 
      BorderStyle     =   1  'Fixed Single
      Height          =   990
      Left            =   15
      Top             =   3645
      Width           =   6345
   End
   Begin VB.Label lblNbrHoodSize 
      AutoSize        =   -1  'True
      Caption         =   "Circular Neighborhood Radius:"
      Height          =   195
      Left            =   1245
      TabIndex        =   18
      Top             =   3885
      Width           =   2160
   End
   Begin VB.Label lblCells 
      AutoSize        =   -1  'True
      Caption         =   "Cells"
      Height          =   195
      Left            =   4800
      TabIndex        =   17
      Top             =   3900
      Width           =   330
   End
   Begin VB.Label lblRasterFields 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      Caption         =   "-- Select Raster Attribute Field --"
      Height          =   195
      Left            =   3765
      TabIndex        =   14
      Top             =   1185
      Width           =   2265
   End
   Begin VB.Label lblRasters 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      Caption         =   "-- Select Categorical Raster --"
      Height          =   195
      Left            =   870
      TabIndex        =   13
      Top             =   1200
      Width           =   2070
   End
   Begin VB.Label lblValue 
      Alignment       =   1  'Right Justify
      AutoSize        =   -1  'True
      Caption         =   "Category Value ="
      Height          =   195
      Left            =   675
      TabIndex        =   12
      Top             =   3180
      Width           =   1215
   End
   Begin VB.Label lblOutputName 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Output Raster Dataset Name:"
      Height          =   195
      Left            =   165
      TabIndex        =   11
      Top             =   5325
      Width           =   2100
   End
   Begin VB.Label lblFormat 
      Alignment       =   1  'Right Justify
      AutoSize        =   -1  'True
      Caption         =   "Output Raster Format:"
      Height          =   195
      Left            =   4245
      TabIndex        =   10
      Top             =   4815
      Width           =   1560
   End
   Begin VB.Image imgParamsBack 
      BorderStyle     =   1  'Fixed Single
      Height          =   1380
      Left            =   15
      Top             =   4650
      Width           =   6345
   End
   Begin VB.Image imgCornerBars 
      Height          =   225
      Left            =   6135
      Picture         =   "frmDensityRaster.frx":060F
      Top             =   6210
      Width           =   225
   End
   Begin VB.Image imgBackTop 
      BorderStyle     =   1  'Fixed Single
      Height          =   3600
      Left            =   15
      Top             =   15
      Width           =   6345
   End
End
Attribute VB_Name = "frmDensityRaster"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
 
Private m_pMxDoc As esriArcMapUI.IMxDocument
Private m_pApp As IApplication
Private Anchors As AnchorObjectList  ' Main anchor control object
Private m_pRasterLayerArray As esriSystem.IVariantArray
Private m_pTrueRasterLayerArray As esriSystem.IVariantArray
Private m_pTrueRasterLayerNames As esriSystem.IStringArray
Private m_pRasterLayerFields As esriSystem.IVariantArray
Private m_strSelLayerName As String
Private m_booSelToggle As Boolean
Private m_pThisExt As TopoCorridor.clsExtension
Private m_ShapeTypeOption As JenLayerTypes
Private m_pReturnArray As esriSystem.IVariantArray
Private m_FieldTypeOption As JenFieldTypes
Private m_booIncludeNoIDField As Boolean
Private m_strOutputWorkspace As String
Private m_strOutputBasename As String
Private m_lngOutputWSType As JenDatasetTypes
Private m_booOutputFeatDataset As Boolean
Private m_strOutputFeatDatasetName As String
Private m_booOutputIsFClass As Boolean         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
Private m_dblValues() As Double

Private m_strRasterWS As String
Private m_pSaveFormats As esriSystem.IVariantArray
Private m_pFileExtensions As esriSystem.IVariantArray
Private m_strRasterName As String
Private m_pLayerNames As esriSystem.IStringArray
 
Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\brost_climate_change\code\frmDensityRaster.frm"
 
Public Property Set ArcApplication(ByVal pParams As esriSystem.IVariantArray)
  On Error GoTo ErrorHandler
 
36:   Set m_pApp = pParams.Element(0)
37:   Set m_pMxDoc = pParams.Element(1)
38:   Set m_pThisExt = pParams.Element(2)
 
  Dim pSelItem As IUnknown
41:   Set pSelItem = m_pMxDoc.SelectedItem
  Dim pLayer As IRasterLayer
  Dim lngIndex As Long
  Dim pUnknown As IUnknown

46:   m_strSelLayerName = ""
 
48:   If Not pSelItem Is Nothing Then
49:     If TypeOf pSelItem Is IRasterLayer Then
50:       Set pLayer = pSelItem
51:       m_strSelLayerName = pLayer.Name
52:     End If
53:   End If

  ' FILL LAYER ARRAY AND LISTBOX
  Dim lngStartSel As Long
57:   lngStartSel = 0
58:   Set m_pTrueRasterLayerArray = New esriSystem.VarArray
59:   Set m_pTrueRasterLayerNames = New esriSystem.strArray
  
  ' RASTER LAYERS
62:   Set m_pRasterLayerArray = TopoCorridor.MyGeneralOperations.ReturnLayersByType(m_pMxDoc.FocusMap, ENUM_jenRasterLayers)
63:   Set m_pRasterLayerFields = Nothing
64:   lbxLayers.Clear
65:   lbxFields.Clear
66:   cbxValue.Clear
  Dim lngRastCounter As Long
  Dim pEnumRasterBand As IEnumRasterBand
  Dim pRastBand As IRasterBand
70:   lngRastCounter = 0
  Dim lngIndex2 As Long
  Dim pRasterLayer As IRasterLayer
  Dim pRastBandColl As IRasterBandCollection
  Dim pTable As ITable
  Dim strName As String
    
77:   If m_pRasterLayerArray.Count > 0 Then
78:     For lngIndex = 0 To m_pRasterLayerArray.Count - 1
79:       Set pRasterLayer = m_pRasterLayerArray.Element(lngIndex)
80:       Set pRastBandColl = pRasterLayer.Raster
81:       If pRastBandColl.Count > 1 Then
82:         For lngIndex2 = 0 To pRastBandColl.Count - 1
83:           Set pRastBand = pRastBandColl.Item(lngIndex2)
84:           Set pTable = TopoCorridor.TopoCor_Functions.ReturnRasterTable(pRastBand)
'          Set pTable = pRastBand.AttributeTable
86:           If Not pTable Is Nothing Then
87:             lngRastCounter = lngRastCounter + 1
88:             strName = pRasterLayer.Name & "   [Band #" & CStr(lngIndex2 + 1) & "]"
89:             lbxLayers.AddItem CStr(lngRastCounter) & "]  " & strName
90:             m_pTrueRasterLayerArray.Add pRastBand
91:             m_pTrueRasterLayerNames.Add strName
92:           End If
93:         Next lngIndex2
94:       Else
95:         Set pRastBand = pRastBandColl.Item(0)
'        Set pTable = pRastBand.AttributeTable
97:         Set pTable = TopoCorridor.TopoCor_Functions.ReturnRasterTable(pRastBand)
98:         If Not pTable Is Nothing Then
99:           lngRastCounter = lngRastCounter + 1
100:           strName = pRasterLayer.Name
101:           lbxLayers.AddItem CStr(lngRastCounter) & "]  " & strName
102:           m_pTrueRasterLayerArray.Add pRastBand
103:           m_pTrueRasterLayerNames.Add strName
104:         End If
105:       End If
106:     Next lngIndex
107:     lbxLayers.ListIndex = -1
108:   End If
  
  Dim strBaseString As String
111:   strBaseString = strBaseString & "This function will calculate the density of a particular cell value within a specified radius of each cell.  The output raster will have values ranging from 0 to 1, where 0 means there are no cells of that value in the neighborhood and 1 means that all neighborhood cells have that value. Optionally you may choose to automatically exclude cells from the analysis if any NoData cells exist within their neighborhood." & vbNewLine

113:   txtMessage.Text = strBaseString
  
115:   Set m_pSaveFormats = New esriSystem.VarArray
116:   Set m_pFileExtensions = New esriSystem.VarArray
  
118:   cbxFormat.Clear
  Dim strFileExtension As String
  Dim lngVersion As Long
  Dim strTypeName As String
  Dim strType As String
  
124:   If m_pThisExt.DensNbrhoodSize = 0 Then
125:     txtCells.Text = "5"
126:   Else
127:     txtCells.Text = CStr(m_pThisExt.DensNbrhoodSize)
128:   End If
  
  ' GIVING UP ON SAVING TO FILE GEODATABASE RASTER....
  'lngVersion = TopoCorridor.aml_func_mod.ReturnArcGISVersionAlt(m_pMxDoc)
132:   lngVersion = 0
133:   If lngVersion >= 2 Then
134:     strTypeName = "File Geodatabase Raster"
135:     strType = "GDB"
136:     m_pSaveFormats.Add strType
137:     cbxFormat.AddItem strTypeName
138:     strFileExtension = ""
139:     m_pFileExtensions.Add strFileExtension
140:   End If
  
142:   strTypeName = "ESRI GRID"
143:   strType = "GRID"
144:   m_pSaveFormats.Add strType
145:   cbxFormat.AddItem strTypeName
146:   strFileExtension = ""
147:   m_pFileExtensions.Add strFileExtension
  
149:   strTypeName = "Imagine Image"
150:   strType = "IMAGINE Image"
151:   m_pSaveFormats.Add strType
152:   cbxFormat.AddItem strTypeName
153:   strFileExtension = ".img"
154:   m_pFileExtensions.Add strFileExtension
  
156:   strTypeName = "TIFF File"
157:   strType = "TIFF"
158:   m_pSaveFormats.Add strType
159:   cbxFormat.AddItem strTypeName
160:   strFileExtension = ".tif"
161:   m_pFileExtensions.Add strFileExtension
  
163:   strTypeName = "JPEG File"
164:   strType = "JPG"
165:   m_pSaveFormats.Add strType
166:   cbxFormat.AddItem strTypeName
167:   strFileExtension = ".jpg"
168:   m_pFileExtensions.Add strFileExtension
  
170:   strTypeName = "JPEG 2000 File"
171:   strType = "JP2"
172:   m_pSaveFormats.Add strType
173:   cbxFormat.AddItem strTypeName
174:   strFileExtension = ".jp2"
175:   m_pFileExtensions.Add strFileExtension
  
  Dim strFolder As String
178:   strFolder = m_pThisExt.DirectoryPath
179:   If strFolder = "" Or Not (TopoCorridor.aml_func_mod.ExistFileDir(strFolder)) Then
180:     strFolder = TopoCorridor.aml_func_mod.ReturnDir(TopoCorridor.aml_func_mod.GetMxDocPath(m_pApp))
181:   End If
182:   If Right(strFolder, 1) = "\" Then
183:     strFolder = Left(strFolder, Len(strFolder) - 1)
184:   End If
  
186:   If StrComp(Right(strFolder, 4), ".gdb") = 0 Then
187:     cbxFormat.ListIndex = 0
188:   Else
'    If m_pThisExt.OutputFormat = 0 Then
'      cbxFormat.ListIndex = 1
'    Else
192:       cbxFormat.ListIndex = m_pThisExt.OutputFormat
'    End If
194:   End If
    
  Dim pWS As IWorkspace
  Dim pWsFact As IWorkspaceFactory2
198:   If StrComp(Right(strFolder, 4), ".gdb", vbTextCompare) = 0 Then
199:     Set pWsFact = New FileGDBWorkspaceFactory
200:   Else
201:     Set pWsFact = New RasterWorkspaceFactory
202:   End If
203:   Set pWS = pWsFact.OpenFromFile(strFolder, Me.hWnd)
    
  Dim strSuggest As String
206:   If cbxFormat.Text = "ESRI GRID" Or cbxFormat.Text = "File Geodatabase Raster" Then
207:     strSuggest = TopoCorridor.MyGeneralOperations.MakeUniqueRasterName2 _
        (pWS, "Density" & m_pFileExtensions.Element(cbxFormat.ListIndex), CBool(cbxFormat.Text = "ESRI GRID"))
209:     txtOutput.Text = strFolder & "\" & strSuggest
210:   Else
211:     strSuggest = TopoCorridor.MyGeneralOperations.MakeUniqueShapeFilename(strFolder & "\" & _
        "Density" & m_pFileExtensions.Element(cbxFormat.ListIndex))
213:     txtOutput.Text = strSuggest
214:   End If
215:   txtOutput.SelStart = Len(txtOutput.Text)
  
217:   m_strRasterWS = pWS.PathName
218:   m_strRasterName = TopoCorridor.aml_func_mod.ReturnFilename(strSuggest)
  
220:   CheckEnable
  ' CLEAR INITIAL SELECTION
222:   Set m_pThisExt.frmDensityReturn = Nothing
223:   m_pThisExt.ShouldContinue = False

225:   Set pSelItem = Nothing
226:   Set pLayer = Nothing
227:   Set pUnknown = Nothing
228:   Set pEnumRasterBand = Nothing
229:   Set pRastBand = Nothing
230:   Set pWS = Nothing
231:   Set pWsFact = Nothing

 Exit Property
ErrorHandler:
  HandleError True, "ArcApplication " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Public Property Get ReturnArray() As esriSystem.IVariantArray
  On Error GoTo ErrorHandler
 
241:   Set ReturnArray = m_pReturnArray
 
  Exit Property
ErrorHandler:
  HandleError True, "ReturnArray " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub CheckEnable()
  On Error GoTo ErrorHandler
  
  
252:   cmdOK.Enabled = lbxLayers.SelCount > 0 And lbxFields.SelCount > 0 And cbxValue.ListIndex > 0 And _
        cbxValue.Text <> "" And txtOutput.Text <> ""
 
  Exit Sub
ErrorHandler:
  HandleError False, "CheckEnable " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cbxFormat_Change()
  On Error GoTo ErrorHandler

263:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "cbxFormat_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cbxValue_Change()
  On Error GoTo ErrorHandler

273:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "cbxValue_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cbxValue_Click()
281:   CheckEnable
End Sub

Private Sub chkNull_Click()
  On Error GoTo ErrorHandler

287:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "chkNull_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdGetWorkspace_Click()


  On Error GoTo ErrorHandler
   ' Save to TIFF, IMAGINE Image, GRID and geodatabase
  Dim pGxBrowser As IGxDialog
  Dim pGxFilterCol As IGxObjectFilterCollection
  Dim pGxFilter As IGxObjectFilter
  Dim pGxObj As IGxObject
  Dim pName As IName
  Dim sName As String
  
  Dim booIs10 As Boolean
307:   booIs10 = TopoCorridor.aml_func_mod.IsVersion10
  
  ' Select input raster dataset
310:   Set pGxBrowser = New GxDialog
311:   pGxBrowser.AllowMultiSelect = False
312:   pGxBrowser.Title = "Specify Output Density Raster Dataset"
313:   If TopoCorridor.aml_func_mod.FileExists(m_strRasterWS) Then
314:     pGxBrowser.StartingLocation = m_strRasterWS
315:   End If
316:   If Not booIs10 Then
317:     Set pGxFilter = New GxFilterRasterDatasets
    
319:     Set pGxFilterCol = pGxBrowser
320:     pGxFilterCol.AddFilter pGxFilter, True
321:   End If
  
  Dim iPos As Integer
324:   If pGxBrowser.DoModalSave(Me.hWnd) Then
325:     sName = pGxBrowser.Name
326:     iPos = InStrRev(sName, ".")
327:     If iPos > 0 Then
328:       sName = Left(sName, iPos - 1)
329:     End If
    
331:     m_strRasterWS = pGxBrowser.FinalLocation.FullName
332:     m_strRasterName = sName
333:     txtOutput.Text = m_strRasterWS & "\" & m_strRasterName
334:     txtOutput.SelStart = Len(txtOutput.Text)
    
    'Get the workspace
337:     Set pGxObj = pGxBrowser.FinalLocation
338:     Set pName = pGxObj.InternalObjectName
'    Set m_OutWs = pName.Open
    
    'geodatabase workspace
'    If Not m_OutWs Is Nothing Then m_Format = "SDR"
    
344:     If StrComp(Right(m_strRasterWS, 4), ".gdb", vbTextCompare) = 0 Then
345:       cbxFormat.ListIndex = 0
346:     End If
    
348:   End If
349:   CheckEnable
  
351:   GoTo CleanUp

  Exit Sub
ErrorHandler:
  HandleError True, "cmdGetWorkspace_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4

CleanUp:

359:   Set pGxBrowser = Nothing
360:   Set pGxFilterCol = Nothing
361:   Set pGxFilter = Nothing
362:   Set pGxObj = Nothing
363:   Set pName = Nothing

  
End Sub

Private Sub cmdManual_Click()
  On Error GoTo ErrorHandler
  ' CHANGE AS APPROPRIATE
  Dim strDir As String
372:   strDir = App.Path
373:   If Right(strDir, 1) <> "\" Then strDir = strDir & "\"
374:   strDir = strDir & "docs"
  
376:   Call TopoCorridor.MyGeneralOperations.OpenDoc("Land_Facet_Tools.pdf", strDir)
 
  Exit Sub
ErrorHandler:
  HandleError True, "cmdManual_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdCancel_Click()
  On Error GoTo ErrorHandler

386:   m_pThisExt.ShouldContinue = False
387:   Set m_pThisExt.frmDensityReturn = Nothing
388:   Set m_pReturnArray = Nothing
389:   Unload Me
 
  Exit Sub
ErrorHandler:
  HandleError True, "cmdCancel_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdOK_Click()
  On Error GoTo ErrorHandler

  ' RETURN ARRAY IS IVariantArray, CONTAINING:
  ' 0) IRasterBand: SELECTED RASTER BAND
  ' 1) STRING: Name of original raster band
  ' 2) STRING: Name of selected attribute field
  ' 3) STRING: Selected Attribute Value
  ' 4) IDoubleArray: Array of cell values that correspond with this selected attribute value
  ' 5) STRING: Save Format
  ' 6) STRING: TEXT VERSION OF SAVE FORMAT
  ' 7) STRING: New Raster Name
  ' 8) BOOLEAN: Whether new workspace is File Geodatabase
  ' 9) IWORKSPACE: Either an IRasterWorkspace2 or an IRasterWorkspaceEx
  '10) STRING: Extension for output
  '11) LONG: Neighborhood Radius, in Cells
  '12) BOOLEAN: Whether to set to NoData if any NoData cells present
    
  Dim lngIndex As Long
415:   Set m_pReturnArray = New esriSystem.VarArray
    
  ' SELECTED RASTER LAYER
  Dim pRasterBand As IRasterBand
419:   Set pRasterBand = m_pTrueRasterLayerArray.Element(lbxLayers.ListIndex)
420:   m_pReturnArray.Add pRasterBand
  
  ' SELECTED RASTER VALUE
  Dim strRasterName As String
424:   strRasterName = m_pTrueRasterLayerNames.Element(lbxLayers.ListIndex)
  
  Dim pField As IField
  Dim lngFieldIndex As Long
  Dim pTable As ITable
  Dim varValue As Variant
  Dim booIsString As Boolean
  
'  Set pTable = pRasterBand.AttributeTable
433:   Set pTable = TopoCorridor.TopoCor_Functions.ReturnRasterTable(pRasterBand)
434:   If pTable Is Nothing Then
435:     MsgBox "Unable to open attribute table for '" & m_pTrueRasterLayerNames.Element(lbxLayers.ListIndex) & _
        "!" & vbCrLf & "Please select a raster with an attribute table...", , "Missing Raster Attribute Table:"
    Exit Sub
438:   End If
  
440:   Set pField = m_pRasterLayerFields.Element(lbxFields.ListIndex)
441:   lngFieldIndex = pTable.FindField(pField.Name)
442:   booIsString = pField.Type = esriFieldTypeString
443:   If booIsString Then
444:     varValue = cbxValue.Text
445:   Else
446:     varValue = m_dblValues(cbxValue.ListIndex - 1)
447:   End If
  Dim lngValIndex As Long
  Dim dblValue As Double
  Dim pCursor As ICursor
  Dim pRow As IRow
452:   lngValIndex = pTable.FindField("Value")
  Dim varTestValue As Variant
  Dim pValues As esriSystem.IDoubleArray
455:   Set pValues = New esriSystem.DoubleArray
456:   If lngValIndex = lngFieldIndex Then
457:     dblValue = CDbl(varValue)
458:     pValues.Add dblValue
459:   Else
460:     Set pCursor = pTable.Search(Nothing, True)
461:     Set pRow = pCursor.NextRow
462:     Do Until pRow Is Nothing
463:       If booIsString Then
464:         varTestValue = pRow.Value(lngFieldIndex)
465:       Else
466:         varTestValue = CDbl(pRow.Value(lngFieldIndex))
467:       End If
      
469:       If varTestValue = varValue Then
470:         dblValue = pRow.Value(lngValIndex)
471:         pValues.Add dblValue
472:       End If
473:       Set pRow = pCursor.NextRow
474:     Loop
475:   End If
  
  Dim strFieldName As String
  Dim strValueString As String
479:   strFieldName = pField.Name
480:   strValueString = cbxValue.Text
  
482:   m_pReturnArray.Add strRasterName
483:   m_pReturnArray.Add strFieldName
484:   m_pReturnArray.Add strValueString
485:   m_pReturnArray.Add pValues
  
  ' OUTPUT SECTION
  Dim strWS As String
  Dim strFilename As String
  Dim pWS As IWorkspace
  Dim pWS2 As IWorkspace2
  Dim pRastWS As IRasterWorkspace2
  Dim pRastWsEx As IRasterWorkspaceEx
  Dim strFullPath As String
  Dim pWsFact As IWorkspaceFactory2
  Dim pDataset As IDataset
  Dim booIsFGB As Boolean
  Dim iPos As Integer
  Dim booExcludeIfAnyNull As Boolean
      
501:   strFullPath = txtOutput.Text
502:   strFilename = TopoCorridor.aml_func_mod.ReturnFilename(strFullPath)
503:   strWS = TopoCorridor.aml_func_mod.ReturnDir(strFullPath)
504:   If Right(strWS, 1) = "\" Then
505:     strWS = Left(strWS, Len(strWS) - 1)
506:   End If
  
  ' CLIP OFF ANY EXTENSIONS TO NAME
509:   iPos = InStrRev(strFilename, ".")
510:   If iPos > 0 Then
511:     strFilename = Left(strFilename, iPos - 1)
512:   End If
  
  ' MAKE SURE WORKSPACE EXISTS
515:   If Not TopoCorridor.aml_func_mod.ExistFileDir(strWS) Then
516:     MsgBox "Unable to create Raster:" & vbCrLf & _
           strWS & " is not a valid workspace...", , "Failed to Create Raster:"
518:     txtOutput.SetFocus
    Exit Sub
520:   End If
  
522:   booIsFGB = StrComp(Right(strWS, 4), ".gdb", vbTextCompare) = 0
  
  Dim lngVersion As Long
525:   lngVersion = TopoCorridor.aml_func_mod.ReturnArcGISVersionAlt(m_pMxDoc)
    
527:   If lngVersion < 2 And booIsFGB Then
528:     MsgBox "Problem:" & vbCrLf & _
           "You have selected a File Geodatabase workspace, but your version of ArcGIS does not " & vbCrLf & _
           "support file geodatabases.", , "Invalid Workspace Specified:"
531:     txtOutput.SetFocus
    Exit Sub
533:   End If
    
535:   If booIsFGB Then
536:     Set pWsFact = New FileGDBWorkspaceFactory
537:   Else
538:     Set pWsFact = New RasterWorkspaceFactory
539:   End If
540:   Set pWS = pWsFact.OpenFromFile(strWS, Me.hWnd)
    
  ' MAKE SURE FILE GEODATABASE IS SELECTED IF USER SPECIFIES SAVING TO FILE GEODATABASE
  Dim strFormat As String
544:   strFormat = m_pSaveFormats.Element(cbxFormat.ListIndex)
   
  '  MsgBox "strFormat = " & strFormat & vbCrLf & _
          "booIsFGB = " & CStr(booIsFGB) & vbCrLf & _
          "strWS = " & strWS
          
550:   If strFormat = "GDB" And (Not booIsFGB) Then
551:     MsgBox "Problem:" & vbCrLf & vbCrLf & _
           "You have selected to save your Density raster as a File Geodatabase Raster, " & vbCrLf & _
           "but you have not specified an existing File Geodatabase to save the raster." & vbCrLf & vbCrLf & _
           "Please specify an existing file geodatabase.  If necessary, you may use ArcCatalog " & vbCrLf & _
           "to create a new empty file geodatabase.", , "Incorrect Workspace Specified:"
556:     txtOutput.SetFocus
    Exit Sub
558:   ElseIf strFormat <> "GDB" And booIsFGB Then
559:     MsgBox "Problem:" & vbCrLf & vbCrLf & _
           "You have selected to save your Density raster as a " & cbxFormat.Text & ", " & vbCrLf & _
           "but you have specified a File Geodatabase workspace to save the raster." & vbCrLf & vbCrLf & _
           "File geodatabases can only store File Geodatabase rasters.  Either change " & vbCrLf & _
           "your format to 'File Geodatabase Raster', or select a different workspace.", , _
           "Incorrect Workspace Specified:"
565:     txtOutput.SetFocus
    Exit Sub
  
568:   End If
   
570:   m_pReturnArray.Add strFormat
571:   m_pReturnArray.Add cbxFormat.Text
572:   m_pReturnArray.Add strFilename
573:   m_pReturnArray.Add booIsFGB
574:   m_pReturnArray.Add pWS
575:   m_pReturnArray.Add m_pFileExtensions.Element(cbxFormat.ListIndex)
  
  ' MAKE SURE RASTER DOES NOT EXIST
  Dim lngVBResult As VbMsgBoxResult
579:   If booIsFGB Then
580:     Set pWS2 = pWS
581:     If pWS2.NameExists(esriDTRasterDataset, strFilename) Then
582:       lngVBResult = MsgBox("File '" & strFilename & "' Already exists!" & vbCrLf & _
             "Would you like this tool to attempt to delete the existing file?", vbYesNo, _
             "File Exists:")
585:       If lngVBResult = vbYes Then
586:         Set pRastWsEx = pWS
587:         Set pDataset = pRastWsEx.OpenRasterDataset(strFilename)
588:         If pDataset.CanDelete Then
589:           pDataset.DELETE
590:           If Not pWS2.NameExists(esriDTRasterDataset, strFilename) Then
591:             MsgBox "File Deleted..."
592:           End If
593:         Else
594:           MsgBox "Unable to delete '" & strFilename & "'..." & vbCrLf & _
            "Please delete this file manually before attempting to create a new raster with this name."
596:           txtOutput.SetFocus
          Exit Sub
598:         End If
599:       Else
600:         txtOutput.SetFocus
        Exit Sub
602:       End If
603:       txtOutput.SetFocus
      Exit Sub
605:     End If
606:   Else
607:     If TopoCorridor.aml_func_mod.ExistFileDir(strFullPath) Then
608:       lngVBResult = MsgBox("File '" & strFilename & "' Already exists!" & vbCrLf & _
             "Would you like this tool to attempt to delete the existing file?", vbYesNo, _
             "File Exists:")
611:       If lngVBResult = vbYes Then
612:         Set pRastWS = pWS
613:         Set pDataset = pRastWS.OpenRasterDataset(strFilename)
614:         If pDataset.CanDelete Then
615:           pDataset.DELETE
616:           If Not TopoCorridor.aml_func_mod.ExistFileDir(strFullPath) Then
617:             MsgBox "File Deleted..."
618:           End If
619:         Else
620:           MsgBox "Unable to delete '" & strFilename & "'..." & vbCrLf & _
            "Please delete this file manually before attempting to create a new raster with this name."
622:           txtOutput.SetFocus
          Exit Sub
624:         End If
625:       Else
626:         txtOutput.SetFocus
        Exit Sub
628:       End If
629:       txtOutput.SetFocus
      Exit Sub
631:     End If
632:   End If
  
  
  Dim lngNbrHoodRadius As Long     ' AUTOMATICALLY CIRCULAR, RADIUS IN CELLS
636:   If txtCells.Text = "" Then
637:     MsgBox "Invalid Neighborhood Radius Value:" & vbCrLf & _
          "Neighborhood radius must be >= 1 raster cell...", , "Invalid Neighborhood Size:"
639:     txtCells.SetFocus
640:   Else
641:     lngNbrHoodRadius = CLng(txtCells.Text)
642:     If lngNbrHoodRadius <= 0 Then
643:       MsgBox "Invalid Neighborhood Radius Value:" & vbCrLf & _
            "Neighborhood radius must be >= 1 raster cell...", , "Invalid Neighborhood Size:"
645:       txtCells.SetFocus
646:     End If
647:   End If
648:   m_pReturnArray.Add lngNbrHoodRadius
  
650:   booExcludeIfAnyNull = chkNull.Value = 1
651:   m_pReturnArray.Add booExcludeIfAnyNull
  
653:   m_pThisExt.DensNbrhoodSize = lngNbrHoodRadius
654:   m_pThisExt.ExcludeIfAnyNull = booExcludeIfAnyNull
655:   m_pThisExt.OutputFormat = cbxFormat.ListIndex
656:   m_pThisExt.DirectoryPath = strWS
657:   m_pThisExt.ShouldContinue = True
  
  Dim pSaveArray As esriSystem.IVariantArray
660:   Set pSaveArray = New esriSystem.VarArray
661:   For lngIndex = 0 To m_pReturnArray.Count - 1
662:     pSaveArray.Add m_pReturnArray.Element(lngIndex)
663:   Next lngIndex
664:   Set m_pThisExt.frmDensityReturn = pSaveArray
  
  ' FOR DEBUGGING
'  Dim strReport As String
'  strReport = "Selected Values..." & vbCrLf
'  For lngIndex = 0 To pValues.Count - 1
'    strReport = strReport & "  --> " & CStr(pValues.Element(lngIndex)) & vbCrLf
'  Next lngIndex
'  MsgBox strReport
  
674:   Unload Me
      
'  Me.Visible = False

678:   Set pRasterBand = Nothing
679:   Set pField = Nothing
680:   Set pTable = Nothing
681:   Set pCursor = Nothing
682:   Set pRow = Nothing
683:   Set pValues = Nothing
684:   Set pWS = Nothing
685:   Set pWS2 = Nothing
686:   Set pRastWS = Nothing
687:   Set pRastWsEx = Nothing
688:   Set pWsFact = Nothing
689:   Set pDataset = Nothing
690:   Set pSaveArray = Nothing

  Exit Sub
ErrorHandler:
  HandleError True, "cmdOK_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub Form_Load()
  On Error GoTo ErrorHandler
 
700:   SetWindowPos Me.hWnd, -1, 0, 0, 0, 0, &H1 Or &H2
701:   Me.Left = (Screen.Width / 2) - (Me.Width / 2)
702:   Me.Top = (Screen.Height / 3) - (Me.Height / 3)
  Dim lngTopBar As Long
704:   lngTopBar = Me.Height - Me.ScaleHeight
705:   Me.Height = cmdOK.Top + cmdOK.Height + lngTopBar
706:     Set Anchors = New AnchorObjectList  ' Create new instance
707:    With Anchors
708:       With .Item(cbxFormat)
709:          .SetAnchors enumStartEnd, enumSizeEnd
710:       End With
711:       With .Item(cbxValue)
712:          .SetAnchors enumStartEnd, enumSizeEnd
713:       End With
714:       With .Item(chkNull)
715:          .SetAnchors enumSize, enumSizeEnd
716:       End With
717:       With .Item(cmdCancel)
718:          .SetAnchors enumSizeEnd, enumSizeEnd
719:       End With
720:       With .Item(cmdGetWorkspace)
721:          .SetAnchors enumSizeEnd, enumSizeEnd
722:       End With
723:       With .Item(cmdManual)
724:          .SetAnchors enumSizeEnd, enumSizeEnd
725:       End With
726:       With .Item(cmdOK)
727:          .SetAnchors enumSizeEnd, enumSizeEnd
728:       End With
729:       With .Item(imgBackTop)
730:          .SetAnchors enumStartEnd, enumStartEnd
731:       End With
732:       With .Item(imgCornerBars)
733:          .SetAnchors enumSizeEnd, enumSizeEnd
734:       End With
735:       With .Item(imgNbrHoodBack)
736:          .SetAnchors enumStartEnd, enumSizeEnd
737:       End With
738:       With .Item(imgParamsBack)
739:          .SetAnchors enumStartEnd, enumSizeEnd
740:       End With
741:       With .Item(lblCells)
742:          .SetAnchors enumSizeEnd, enumSizeEnd
743:       End With
744:       With .Item(lblFormat)
745:          .SetAnchors enumStartSize, enumSizeEnd
746:       End With
747:       With .Item(lblNbrHoodSize)
748:          .SetAnchors enumStartSize, enumSizeEnd
749:       End With
750:       With .Item(lblOutputName)
751:          .SetAnchors enumStartSize, enumSizeEnd
752:       End With
753:       With .Item(lblRasterFields)
754:          .SetAnchors enumSizeEnd, enumStartSize
755:       End With
756:       With .Item(lblRasters)
757:          .SetAnchors enumSize, enumStartSize
758:       End With
759:       With .Item(lblValue)
760:          .SetAnchors enumStartSize, enumSizeEnd
761:       End With
762:       With .Item(lbxFields)
763:          .SetAnchors enumSizeEnd, enumStartEnd
764:       End With
765:       With .Item(lbxLayers)
766:          .SetAnchors enumStartEnd, enumStartEnd
767:       End With
768:       With .Item(txtCells)
769:          .SetAnchors enumStartEnd, enumSizeEnd
770:       End With
771:       With .Item(txtMessage)
772:          .SetAnchors enumStartEnd, enumStartSize
773:       End With
774:       With .Item(txtOutput)
775:          .SetAnchors enumStartEnd, enumSizeEnd
776:       End With
777:       .Form = Me  ' Set form reference (suggested to be last step)
778:    End With


781:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub Form_Unload(Cancel As Integer)
  On Error GoTo ErrorHandler
 
791:   Set m_pMxDoc = Nothing
792:   Set m_pApp = Nothing
793:   Set Anchors = Nothing
794:   Set m_pRasterLayerArray = Nothing
795:   Set m_pTrueRasterLayerArray = Nothing
796:   Set m_pTrueRasterLayerNames = Nothing
797:   Set m_pRasterLayerFields = Nothing
798:   Set m_pThisExt = Nothing
799:   Set m_pReturnArray = Nothing
800:   Set m_pSaveFormats = Nothing
801:   Set m_pFileExtensions = Nothing
802:   Set m_pLayerNames = Nothing

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Unload " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 

Private Sub lbxFields_Click()
  On Error GoTo ErrorHandler


  
  Dim pRasterBand As IRasterBand
816:   Set pRasterBand = m_pTrueRasterLayerArray.Element(lbxLayers.ListIndex)
  Dim pTable As ITable
'  Set pTable = pRasterBand.AttributeTable
819:   Set pTable = TopoCorridor.TopoCor_Functions.ReturnRasterTable(pRasterBand)
  
  Dim pFields As IFields
  Dim pField As IField
  Dim pFieldInfo As IFieldInfo
  
825:   Set pField = m_pRasterLayerFields.Element(lbxFields.ListIndex)
  
827:   cbxValue.Clear
828:   cbxValue.AddItem "Select Category Value from List Below:"
  
  Dim booIsString As Boolean
831:   booIsString = pField.Type = esriFieldTypeString
  
  Dim pCollection As New Collection
  Dim pRow As IRow
  Dim pCursor As ICursor
836:   Set pCursor = pTable.Search(Nothing, True)
837:   Set pRow = pCursor.NextRow
  
  Dim lngFieldIndex As Long
840:   lngFieldIndex = pTable.FindField(pField.Name)
  
  Dim lngCounter As Long
843:   lngCounter = -1
  Dim strTestValue As String
  Dim lngIndex As Long
  Dim dblValue As Double
  
848:   If booIsString Then
    Dim strValues() As String
    ReDim strValues(pTable.RowCount(Nothing))
    
852:     Do Until pRow Is Nothing
      
854:       strTestValue = pRow.Value(lngFieldIndex)
      
      ' CHECK IF VALUE ALREADY EXISTS
857:       If Not TopoCorridor.MyGeneralOperations.CheckCollectionForKey(pCollection, strTestValue) Then
858:         lngCounter = lngCounter + 1
859:         strValues(lngCounter) = strTestValue
860:         pCollection.Add 1, strTestValue
'      Else
862:       End If
      
864:       Set pRow = pCursor.NextRow
865:     Loop
    
    ReDim Preserve strValues(lngCounter)
868:     TopoCorridor.QuickSort.StringsAscending strValues, 0, lngCounter
    
870:     For lngIndex = 0 To lngCounter
871:       cbxValue.AddItem strValues(lngIndex)
872:     Next lngIndex
873:     cbxValue.ListIndex = 0
874:   Else
    Dim dblValues() As Double
    ReDim dblValues(pTable.RowCount(Nothing))
    
878:     Do Until pRow Is Nothing
      
880:       dblValue = pRow.Value(lngFieldIndex)
881:       strTestValue = CStr(Format(dblValue, "#.####################"))
882:       strTestValue = TopoCorridor.aml_func_mod.BasicTrimAvenue(strTestValue, "", ".")
      
      ' CHECK IF VALUE ALREADY EXISTS
885:       If Not TopoCorridor.MyGeneralOperations.CheckCollectionForKey(pCollection, strTestValue) Then
886:         lngCounter = lngCounter + 1
887:         dblValues(lngCounter) = dblValue
888:         pCollection.Add 1, strTestValue
 '     Else
890:       End If
      
892:       Set pRow = pCursor.NextRow
893:     Loop
    
    ReDim Preserve dblValues(lngCounter)
896:     TopoCorridor.QuickSort.DoubleAscending dblValues, 0, lngCounter
    
898:     For lngIndex = 0 To lngCounter
899:       cbxValue.AddItem CStr(dblValues(lngIndex))
900:     Next lngIndex
901:     cbxValue.ListIndex = 0
902:     m_dblValues = dblValues
903:   End If
  
905:   CheckEnable
 
907:   Set pRasterBand = Nothing
908:   Set pTable = Nothing
909:   Set pFields = Nothing
910:   Set pField = Nothing
911:   Set pFieldInfo = Nothing
912:   Set pCollection = Nothing
913:   Set pRow = Nothing
914:   Set pCursor = Nothing
  

  Exit Sub
ErrorHandler:
  HandleError True, "lbxFields_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub lbxLayers_Click()
  On Error GoTo ErrorHandler


  
  Dim pRasterBand As IRasterBand
928:   Set pRasterBand = m_pTrueRasterLayerArray.Element(lbxLayers.ListIndex)
  Dim pTable As ITable
930:   Set pTable = TopoCorridor.TopoCor_Functions.ReturnRasterTable(pRasterBand)
'  Set pTable = pRasterBand.AttributeTable
  
  Dim pFields As IFields
  Dim pField As IField
  Dim pFieldInfo As IFieldInfo

937:   Set pFields = pTable.Fields
938:   lbxFields.Clear
  
940:   Set m_pRasterLayerFields = TopoCorridor.MyGeneralOperations.ReturnFieldsByType(pFields, ENUM_FieldNumber + ENUM_FieldString)

  Dim lngIndex As Long
943:   For lngIndex = 0 To m_pRasterLayerFields.Count - 1
944:     Set pField = m_pRasterLayerFields.Element(lngIndex)
945:     lbxFields.AddItem pField.AliasName
946:   Next lngIndex
947:   lbxFields.ListIndex = -1

949:   CheckEnable
  
951:   Set pRasterBand = Nothing
952:   Set pTable = Nothing
953:   Set pFields = Nothing
954:   Set pField = Nothing
955:   Set pFieldInfo = Nothing


  Exit Sub
ErrorHandler:
  HandleError True, "lbxLayers_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub txtCells_Change()
  On Error GoTo ErrorHandler

966:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "txtCells_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub txtCells_KeyPress(KeyAscii As Integer)
  On Error GoTo ErrorHandler

976:    TopoCorridor.MyGeneralOperations.CheckNumericIntegerPositive KeyAscii, txtCells

  Exit Sub
ErrorHandler:
  HandleError True, "txtCells_KeyPress " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub txtOutput_Change()
  On Error GoTo ErrorHandler

986:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "txtOutput_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
