VERSION 5.00
Begin VB.Form frmDocsListBox 
   Caption         =   " Message"
   ClientHeight    =   3150
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5700
   Icon            =   "frmDocsListBox.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   3150
   ScaleWidth      =   5700
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox lbxList 
      Height          =   2085
      Left            =   -15
      Style           =   1  'Checkbox
      TabIndex        =   1
      Top             =   690
      Width           =   5715
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   330
      Left            =   1973
      TabIndex        =   4
      Top             =   2820
      Width           =   915
   End
   Begin VB.TextBox txtMessage 
      Height          =   660
      Left            =   -15
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Text            =   "frmDocsListBox.frx":058A
      Top             =   0
      Width           =   5715
   End
   Begin VB.CommandButton cmdNo 
      Caption         =   "No"
      Height          =   330
      Left            =   255
      TabIndex        =   3
      Top             =   2820
      Width           =   825
   End
   Begin VB.CommandButton cmdYes 
      Caption         =   "OK"
      Height          =   330
      Left            =   2903
      TabIndex        =   2
      Top             =   2820
      Width           =   825
   End
   Begin VB.Image imgCornerBars 
      Height          =   225
      Left            =   5475
      Picture         =   "frmDocsListBox.frx":0594
      Top             =   2925
      Width           =   225
   End
End
Attribute VB_Name = "frmDocsListBox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
 
Private m_MxDoc As esriArcMapUI.IMxDocument
Private m_pApp As IApplication
Private m_pExt As IExtension
Private m_ThisExt As TopoCorridor.clsExtension
Private Anchors As AnchorObjectList  ' Main anchor control object
Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\brost_climate_change\code\frmDocsListBox.frm"
 
Public Property Set theParameters(pParams As esriSystem.IVariantArray)
  On Error GoTo ErrorHandler

  Dim lngOption As Long
14:   Set m_pApp = pParams.Element(0)
15:   Set m_MxDoc = m_pApp.Document

17:   If m_ThisExt Is Nothing Then
    Dim newUid As New UID
19:     newUid.Value = "TopoCorridor.clsExtension"
20:     Set m_pExt = m_pApp.FindExtensionByCLSID(newUid)
21:     Set m_ThisExt = m_pExt
    
23:   End If

  ' PRESET RESPONSE TO "CANCEL"
  Dim pResponse As esriSystem.IVariantArray
27:   Set pResponse = New esriSystem.VarArray
28:   pResponse.Add 0
29:   pResponse.Add Nothing
30:   Set m_ThisExt.frmDocsListBoxResponse = pResponse
    
32:   lngOption = pParams.Element(1)
    
  Select Case lngOption
    Case 1 ' YES / NO
36:       cmdYes.Left = 1297
37:       cmdYes.Caption = "Yes"
38:       cmdNo.Left = 2152
39:       cmdNo.Visible = False
40:       cmdCancel.Left = 0
41:       cmdCancel.Visible = False
    Case 2 ' OK / CANCEL
'      cmdYes.Left = 1252
44:       cmdYes.Caption = "OK"
45:       cmdNo.Left = 0
46:       cmdNo.Visible = False
'      cmdCancel.Left = 2107
48:       cmdCancel.Visible = True
    Case 3 ' YES / NO / CANCEL
50:       cmdYes.Left = 825
51:       cmdYes.Caption = "Yes"
52:       cmdNo.Left = 1680
53:       cmdNo.Visible = True
54:       cmdCancel.Left = 2535
55:       cmdCancel.Visible = True
    Case 4 ' OK ONLY
57:       cmdYes.Left = 1725
58:       cmdYes.Caption = "OK"
59:       cmdNo.Left = 0
60:       cmdNo.Visible = False
61:       cmdCancel.Left = 0
62:       cmdCancel.Visible = False
63:   End Select

65:   Me.Caption = pParams.Element(2)
66:   txtMessage.Text = pParams.Element(3)

  Dim pList As esriSystem.IVariantArray
69:   Set pList = pParams.Element(4)

  Dim lngIndex As Long
72:   For lngIndex = 0 To pList.Count - 1
73:     lbxList.AddItem pList.Element(lngIndex)
74:   Next lngIndex
75:   lbxList.ListIndex = -1

77:   CheckEnable

  Exit Property
ErrorHandler:
  HandleError True, "theParameters " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub CheckEnable()
  On Error GoTo ErrorHandler
 

88:   cmdYes.Enabled = lbxList.SelCount > 0
 
  Exit Sub
ErrorHandler:
  HandleError False, "CheckEnable " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdCancel_Click()
  On Error GoTo ErrorHandler
 
  Dim pResponse As esriSystem.IVariantArray
99:   Set pResponse = New esriSystem.VarArray
100:   pResponse.Add 0
101:   pResponse.Add Nothing
102:   Set m_ThisExt.frmDocsListBoxResponse = pResponse
103:   Unload Me
 
  Exit Sub
ErrorHandler:
  HandleError True, "cmdCancel_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdNo_Click()
  On Error GoTo ErrorHandler
 
  Dim pResponse As esriSystem.IVariantArray
114:   Set pResponse = New esriSystem.VarArray
115:   pResponse.Add 2
116:   pResponse.Add Nothing
117:   Set m_ThisExt.frmDocsListBoxResponse = pResponse
118:   Unload Me
 
  Exit Sub
ErrorHandler:
  HandleError True, "cmdNo_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdYes_Click()
  On Error GoTo ErrorHandler

  Dim pResponse As esriSystem.IVariantArray
129:   Set pResponse = New esriSystem.VarArray
130:   pResponse.Add 1

  Dim pSubArray As esriSystem.IVariantArray
133:   Set pSubArray = New esriSystem.VarArray

  Dim lngIndex As Long
136:   For lngIndex = 0 To lbxList.ListCount - 1
137:     If lbxList.Selected(lngIndex) Then
138:       pSubArray.Add lbxList.List(lngIndex)
139:     End If
140:   Next lngIndex
141:   pResponse.Add pSubArray

143:   Set m_ThisExt.frmDocsListBoxResponse = pResponse
144:   Unload Me

  Exit Sub
ErrorHandler:
  HandleError True, "cmdYes_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub Form_Load()
  On Error GoTo ErrorHandler

154:   SetWindowPos Me.hWnd, -1, 0, 0, 0, 0, &H1 Or &H2
155:   Me.Left = (Screen.Width / 2) - (Me.Width / 2)
156:   Me.Top = (2 * Screen.Height / 3) - (Me.Height / 2)
  Dim lngTopBar As Long
158:   lngTopBar = Me.Height - Me.ScaleHeight
159:   Me.Height = cmdYes.Top + cmdYes.Height + lngTopBar
 
161:   Set Anchors = New AnchorObjectList  ' Create new instance
162:   With Anchors
163:      With .Item(cmdNo)
164:         .SetAnchors enumStartSize, enumSizeEnd
165:      End With
166:      With .Item(cmdYes)
167:         .SetAnchors enumStartSize, enumSizeEnd
168:      End With
169:      With .Item(cmdCancel)
170:         .SetAnchors enumStartSize, enumSizeEnd
171:      End With
172:      With .Item(imgCornerBars)
173:         .SetAnchors enumSizeEnd, enumSizeEnd
174:      End With
175:      With .Item(txtMessage)
176:         .SetAnchors enumStartEnd, enumStartSize
177:      End With
178:      With .Item(lbxList)
179:         .SetAnchors enumStartEnd, enumStartEnd
180:      End With
181:      .Form = Me  ' Set form reference (suggested to be last step)
182:   End With

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub Form_Unload(Cancel As Integer)
  On Error GoTo ErrorHandler
 
192:   Set m_MxDoc = Nothing
193:   Set m_pApp = Nothing
194:   Set m_pExt = Nothing
195:   Set m_ThisExt = Nothing
 
  Exit Sub
ErrorHandler:
  HandleError True, "Form_Unload " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub SampleCode()
  On Error GoTo ErrorHandler
 
' FOLLOWING NEEDS TO GO IN EXTENSION
'
'Private m_pfrmDocsListBoxResponse As esrisystem.IVariantArray
'Public Property set frmDocsListBoxResponse(pSelection As esrisystem.IVariantArray)
'  Set m_pfrmDocsListBoxResponse = pSelection
'End Property
'Public Property Get frmDocsListBoxResponse() As Long
'  set frmDocsListBoxResponse = m_pfrmDocsListBoxResponse
'End Property
'
' FOLLOWING NEEDS TO GO IN EXTENSION SHUTDOWN
' Set m_pfrmDocsListBoxResponse = Nothing
'
' FOLLOWING WILL RUN THE DIALOG AND CHECK THE RESPONSE
 
  ' NEEDS TO HAVE A REFERENCE TO THE APPLICATION
  Dim pParams As esriSystem.IVariantArray
222:   Set pParams = New esriSystem.VarArray

  Dim lngOption As Long
  ' 1 = Yes / No
  ' 2 = OK / Cancel
  ' 3 = Yes / No / Cancel
  ' 4 = OK Only
229:   lngOption = 2

  Dim pList As esriSystem.IVariantArray
232:   Set pList = New esriSystem.VarArray
233:   pList.Add "Blue"
234:   pList.Add "Flagstaff"
235:   pList.Add "Spotted Owl"
236:   pList.Add "12"
237:   pList.Add "December 7, 1941"

239:   pParams.Add m_pApp
240:   pParams.Add lngOption
241:   pParams.Add " Sample Caption:"                                                 ' DIALOG CAPTION
242:   pParams.Add "This is a sample message that might appear in the message box."   ' MESSAGE
243:   pParams.Add pList

  Dim pForm As TopoCorridor.frmDocsListBox
246:   Set pForm = New TopoCorridor.frmDocsListBox
247:   Set pForm.theParameters = pParams
248:   pForm.Show vbModal

  Dim pExt As IExtension
  Dim pThisExt As TopoCorridor.clsExtension
  Dim newUid As New UID
253:   newUid.Value = "TopoCorridor.clsExtension"
254:   Set pExt = m_pApp.FindExtensionByCLSID(newUid)
255:   Set pThisExt = pExt

  Dim pResponse As esriSystem.IVariantArray
258:   Set pResponse = pThisExt.frmDocsListBoxResponse

  Dim lngResponse As Long
261:   lngResponse = pResponse.Element(0)
  ' 0 = Cancel
  ' 1 = Yes / OK
  ' 2 = No

  Dim strResponseReport As String

268:   strResponseReport = "List Box Response = " & CStr(lngResponse) & vbCrLf
269:   If lngResponse = 1 Then
    Dim pSubArray As esriSystem.IVariantArray
271:     Set pSubArray = pResponse.Element(1)
272:     strResponseReport = strResponseReport & pSubArray.Count & " list elements selected..." & vbCrLf
    Dim lngIndex As Long
274:     For lngIndex = 0 To pSubArray.Count - 1
275:       strResponseReport = strResponseReport & "  " & CStr(lngIndex + 1) & "]  " & CStr(pSubArray.Element(lngIndex)) & vbCrLf
276:     Next lngIndex
277:   End If

279:   MsgBox strResponseReport
 
  Exit Sub
ErrorHandler:
  HandleError False, "SampleCode " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub lbxList_Click()
  On Error GoTo ErrorHandler
 
289:   CheckEnable
 
  Exit Sub
ErrorHandler:
  HandleError True, "lbxList_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 

