VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "richtx32.Ocx"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "ComDlg32.OCX"
Begin VB.Form frmIdentifyTermini 
   Caption         =   " Identify Termini Polygons:"
   ClientHeight    =   4545
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6375
   Icon            =   "frmIdentifyTermini.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   4545
   ScaleWidth      =   6375
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtDataThreshold 
      Alignment       =   2  'Center
      Height          =   315
      Left            =   5040
      TabIndex        =   1
      Text            =   "txtDataThreshold"
      Top             =   1920
      Width           =   990
   End
   Begin VB.TextBox txtThreshold 
      Alignment       =   2  'Center
      Height          =   315
      Left            =   5107
      TabIndex        =   3
      Text            =   "txtThreshold"
      Top             =   2865
      Width           =   885
   End
   Begin RichTextLib.RichTextBox txtMessage 
      Height          =   1215
      Left            =   45
      TabIndex        =   12
      Top             =   30
      Width           =   6300
      _ExtentX        =   11113
      _ExtentY        =   2143
      _Version        =   393217
      Enabled         =   -1  'True
      ScrollBars      =   2
      TextRTF         =   $"frmIdentifyTermini.frx":058A
   End
   Begin VB.ComboBox cbxPolygons 
      Height          =   315
      Left            =   3105
      Style           =   2  'Dropdown List
      TabIndex        =   2
      Top             =   2385
      Width           =   3150
   End
   Begin VB.ComboBox cbxLayers 
      Height          =   315
      Left            =   3105
      Style           =   2  'Dropdown List
      TabIndex        =   0
      Top             =   1410
      Width           =   3150
   End
   Begin VB.CommandButton cmdGetWorkspace 
      Height          =   360
      Left            =   5820
      Picture         =   "frmIdentifyTermini.frx":0615
      Style           =   1  'Graphical
      TabIndex        =   5
      ToolTipText     =   "Browse for Output Feature Class..."
      Top             =   3675
      Width           =   465
   End
   Begin VB.TextBox txtOutput 
      Height          =   330
      Left            =   165
      TabIndex        =   4
      Text            =   "txtOutput"
      Top             =   3690
      Width           =   5595
   End
   Begin VB.CommandButton cmdManual 
      Caption         =   "Manual"
      Height          =   345
      Left            =   2662
      TabIndex        =   7
      Top             =   4200
      Width           =   1065
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   345
      Left            =   3727
      TabIndex        =   8
      Top             =   4200
      Width           =   1065
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   345
      Left            =   1582
      TabIndex        =   6
      Top             =   4200
      Width           =   1065
   End
   Begin MSComDlg.CommonDialog cdlg 
      Left            =   0
      Top             =   0
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Label lblDataThreshold 
      Alignment       =   1  'Right Justify
      AutoSize        =   -1  'True
      Caption         =   "Analysis Layer Threshold, All regions with cell values greater than"
      Height          =   195
      Left            =   345
      TabIndex        =   14
      Top             =   1965
      Width           =   4590
   End
   Begin VB.Label lblThreshold 
      Alignment       =   1  'Right Justify
      AutoSize        =   -1  'True
      Caption         =   "Relative Size Threshold for Termini Polygons (Integer, 0 - 100%) ="
      Height          =   195
      Left            =   375
      TabIndex        =   13
      Top             =   2910
      Width           =   4620
   End
   Begin VB.Label lblPolygons 
      Alignment       =   1  'Right Justify
      AutoSize        =   -1  'True
      Caption         =   "Wildland Block Polygon Layer ="
      Height          =   195
      Left            =   795
      TabIndex        =   11
      Top             =   2445
      Width           =   2250
   End
   Begin VB.Label lblOutputName 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Output Termini Polygon shapefile:"
      Height          =   195
      Left            =   150
      TabIndex        =   10
      Top             =   3480
      Width           =   2370
   End
   Begin VB.Image imgParamsBack 
      BorderStyle     =   1  'Fixed Single
      Height          =   795
      Left            =   15
      Top             =   3345
      Width           =   6345
   End
   Begin VB.Image imgCornerBars 
      Height          =   225
      Left            =   6135
      Picture         =   "frmIdentifyTermini.frx":068B
      Top             =   4320
      Width           =   225
   End
   Begin VB.Label lblLayer 
      AutoSize        =   -1  'True
      Caption         =   "Analysis Layer (i.e. Density or Diversity) ="
      Height          =   195
      Left            =   165
      TabIndex        =   9
      Top             =   1470
      Width           =   2880
   End
   Begin VB.Image imgBackTop 
      BorderStyle     =   1  'Fixed Single
      Height          =   3330
      Left            =   15
      Top             =   0
      Width           =   6345
   End
End
Attribute VB_Name = "frmIdentifyTermini"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
 
Private m_pMxDoc As esriArcMapUI.IMxDocument
Private m_pApp As IApplication
Private Anchors As AnchorObjectList  ' Main anchor control object
Private m_pRasterLayerArray As esriSystem.IVariantArray
Private m_pPolygonLayerArray As esriSystem.IVariantArray
Private m_strSelLayerName As String
Private m_pThisExt As TopoCorridor.clsExtension
Private m_strOutputWorkspace As String
Private m_strOutputBasename As String
Private m_pRasterLayerNames As esriSystem.IStringArray
Private m_pPolygonLayerNames As esriSystem.IStringArray
 
Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\brost_climate_change\code\frmIdentifyTermini.frm"
 
Public Property Set ArcApplication(ByVal pParams As esriSystem.IVariantArray)
  On Error GoTo ErrorHandler
 
20:   Set m_pApp = pParams.Element(0)
21:   Set m_pMxDoc = pParams.Element(1)
22:   Set m_pThisExt = pParams.Element(2)
  
Dim strBaseString As String
25:   strBaseString = strBaseString & "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fswiss\fcharset0 Arial;}{\f1\fswiss\fprq2\fcharset0 Arial;}{\f2\fnil\fcharset0 MS Sans Serif;}}" & vbNewLine
26:   strBaseString = strBaseString & "\viewkind4\uc1\pard\f0\fs16 This tool will identify termini polygons located within each Wildland Block, based on an analysis raster (usually a Density or Diversity raster), a raster cell value threshold and a termini polygon size threshold value." & vbNewLine
27:   strBaseString = strBaseString & "\par " & vbNewLine
28:   strBaseString = strBaseString & "\par \b Analysis Raster Layer:\b0   All areas with a cell value > the specified threshold will be converted to polygons, clipped to the Wildland Block polygons, and saved  or discarded based on their size relative to the largest polygon in the Wildland Block." & vbNewLine
29:   strBaseString = strBaseString & "\par " & vbNewLine
30:   strBaseString = strBaseString & "\par \b Analysis Layer Threshold:\b0   " & vbNewLine
31:   strBaseString = strBaseString & "\par   -- For Land Facet Density rasters, this value is typically set to 0. " & vbNewLine
32:   strBaseString = strBaseString & "\par   -- For Land Facet Diversity rasters, this value is typically set to some H' value that approximates the median Shannon's Index value." & vbNewLine
33:   strBaseString = strBaseString & "\par " & vbNewLine
34:   strBaseString = strBaseString & "\par \b Wildland Block Polygon Layer:\b0   Both Wildland Blocks should be available within a single polygon feature class.  The tool will only show you polygon layers with 2 polygons in them.  A single Wildland Block may be composed of multiple sub-polygons, but each Wildland Block should only occupy a single row in the attribute table." & vbNewLine
35:   strBaseString = strBaseString & "\par " & vbNewLine
36:   strBaseString = strBaseString & "\par \b Relative Size Threshold for Termini Polygons:\b0   \f1 This threshold should be read as ""Retain all polygons with an area \u8805? X% of the largest polygon in each Wildland Block"".  After all polygons are clipped to Wildland Blocks, this tool will calculate the area of all polygons within each block and retain those that are larger than the specified threshold for that block.  Each Wildland Block will therefore have at least one termini polygon, provided that there were actually cell values greater than the specified threshold within that block.\f0 " & vbNewLine
37:   strBaseString = strBaseString & "\par " & vbNewLine
38:   strBaseString = strBaseString & "\par \fs20 " & vbNewLine
39:   strBaseString = strBaseString & "\par \pard\f2\fs17 " & vbNewLine
40:   strBaseString = strBaseString & "\par }" & vbNewLine
41:   strBaseString = strBaseString & " " & vbNewLine


44:   txtMessage.TextRTF = strBaseString
  
  Dim pLayer As ILayer
  Dim pSelItem As IUnknown
48:   Set pSelItem = m_pMxDoc.SelectedItem
  Dim pRasterLayer As IRasterLayer
  Dim pPolyLayer As IFeatureLayer
  Dim lngIndex As Long
  Dim pUnknown As IUnknown

54:   m_strSelLayerName = ""
 
56:   If Not pSelItem Is Nothing Then
57:     If TypeOf pSelItem Is ILayer Then
58:       Set pLayer = pSelItem
59:       m_strSelLayerName = pLayer.Name
60:     End If
61:   End If

  ' FILL LAYER ARRAY AND LISTBOX
64:   cbxLayers.Clear
65:   cbxPolygons.Clear
  
  Dim lngRasterStartSel As Long
68:   lngRasterStartSel = 0
  Dim lngPolyStartSel As Long
70:   lngPolyStartSel = 0
  
  Dim pTempLayerArray As esriSystem.IVariantArray
73:   Set pTempLayerArray = TopoCorridor.MyGeneralOperations.ReturnLayersByType(m_pMxDoc.FocusMap, ENUM_jenRasterLayers + ENUM_jenPolygonLayers)
74:   Set m_pRasterLayerArray = New esriSystem.VarArray
75:   Set m_pRasterLayerNames = New esriSystem.strArray
76:   Set m_pPolygonLayerArray = New esriSystem.VarArray
77:   Set m_pPolygonLayerNames = New esriSystem.strArray
  
  Dim pRastBandColl As IRasterBandCollection
  Dim pRastBand As IRasterBand
  Dim pRaster As IRaster
  Dim lngIndex2 As Long
  Dim lngRasterSelCounter As Long
84:   lngRasterSelCounter = -1
  Dim strBandName As String
  
  Dim strPolyName As String
  Dim pFClass As IFeatureClass
  Dim lngPolyCount As Long
  Dim lngPolySelCounter As Long
91:   lngPolySelCounter = -1
  
93:   If pTempLayerArray.Count > 0 Then
94:     For lngIndex = 0 To pTempLayerArray.Count - 1
95:       Set pUnknown = pTempLayerArray.Element(lngIndex)
96:       If TypeOf pUnknown Is IRasterLayer Then
97:         Set pRasterLayer = pUnknown
98:         If pRasterLayer.Valid Then
99:           Set pRaster = pRasterLayer.Raster
100:           Set pRastBandColl = pRaster
101:           If pRastBandColl.Count = 1 Then
102:             strBandName = pRasterLayer.Name
103:             cbxLayers.AddItem strBandName
104:             m_pRasterLayerNames.Add strBandName
105:             m_pRasterLayerArray.Add pRastBandColl.Item(0)
106:             lngRasterSelCounter = lngRasterSelCounter + 1
107:             If pRasterLayer.Name = m_strSelLayerName Then lngRasterStartSel = lngRasterSelCounter
108:           Else
109:             For lngIndex2 = 0 To pRastBandColl.Count - 1
110:               Set pRastBand = pRastBandColl.Item(lngIndex2)
111:               strBandName = pLayer.Name & " [Band " & CStr(lngIndex2 + 1) & "]"
112:               m_pRasterLayerNames.Add strBandName
113:               cbxLayers.AddItem strBandName
114:               m_pRasterLayerArray.Add pRastBandColl.Item(lngIndex2)
115:               lngRasterSelCounter = lngRasterSelCounter + 1
116:               If pRasterLayer.Name = m_strSelLayerName Then lngRasterStartSel = lngRasterSelCounter
117:             Next lngIndex2
118:           End If
119:         End If
120:       ElseIf TypeOf pUnknown Is IFeatureLayer Then
121:         Set pPolyLayer = pUnknown
122:         If pPolyLayer.Valid Then
123:           Set pFClass = pPolyLayer.FeatureClass
124:           If pFClass.ShapeType = esriGeometryPolygon Then
125:             lngPolyCount = pFClass.FeatureCount(Nothing)
126:             If lngPolyCount = 2 Then
127:               strPolyName = pPolyLayer.Name
128:               m_pPolygonLayerNames.Add strPolyName
129:               m_pPolygonLayerArray.Add pPolyLayer
130:               cbxPolygons.AddItem strPolyName
131:               lngPolySelCounter = lngPolySelCounter + 1
132:               If strPolyName = m_strSelLayerName Then lngPolyStartSel = lngPolySelCounter
133:             End If
134:           End If
135:         End If
136:       End If
137:     Next lngIndex
138:     cbxLayers.ListIndex = lngRasterStartSel
139:     If m_pPolygonLayerNames.Count = 0 Then
140:       cbxPolygons.AddItem "<-- No 2-Polygon Feature Layers Found -->"
141:       lngPolyStartSel = 0
142:     End If
143:     cbxPolygons.ListIndex = lngPolyStartSel
144:   End If

  Dim lngThreshold As Long
147:   lngThreshold = m_pThisExt.frmTerminiThreshold
148:   If lngThreshold <= 0 Then lngThreshold = 50
149:   txtThreshold.Text = CStr(lngThreshold)
  
  Dim dblDataThreshold As Double
152:   dblDataThreshold = m_pThisExt.frmTerminiDataThresholdDouble
153:   txtDataThreshold.Text = CStr(dblDataThreshold)
  
  ' OUTPUT DEFAULT FILENAME
  Dim boolWorkspaceExists As Boolean
  Dim strDirShapefilePath As String
  Dim strTempShapefileName As String
  
160:   strDirShapefilePath = m_pThisExt.frmTerminiFolderPath
161:   boolWorkspaceExists = TopoCorridor.aml_func_mod.ExistFileDir(strDirShapefilePath)
  
163:   If Not boolWorkspaceExists Then
164:     strDirShapefilePath = App.Path
165:   End If
166:   If Right(strDirShapefilePath, 1) <> "\" Then strDirShapefilePath = strDirShapefilePath & "\"
167:   boolWorkspaceExists = TopoCorridor.aml_func_mod.ExistFileDir(strDirShapefilePath)
  
169:   If Not boolWorkspaceExists Then
170:     strDirShapefilePath = TopoCorridor.aml_func_mod.GetFullFileString(TopoCorridor.aml_func_mod.TempPathLocation)
171:   End If
172:   If Right(strDirShapefilePath, 1) <> "\" Then strDirShapefilePath = strDirShapefilePath & "\"
  
174:   strTempShapefileName = TopoCorridor.MyGeneralOperations.MakeUniqueShapeFilename(strDirShapefilePath & "Termini.shp")
175:   txtOutput.Text = strTempShapefileName
176:   txtOutput.SelStart = Len(txtOutput.Text)
  
178:   CheckEnable
  
  ' CLEAR INITIAL SELECTION
181:   Set m_pThisExt.frmTerminiResponse = Nothing
182:   m_pThisExt.ShouldContinue = False
  
184:   Set pLayer = Nothing
185:   Set pSelItem = Nothing
186:   Set pRasterLayer = Nothing
187:   Set pPolyLayer = Nothing
188:   Set pUnknown = Nothing
189:   Set pTempLayerArray = Nothing
190:   Set pRastBandColl = Nothing
191:   Set pRastBand = Nothing
192:   Set pRaster = Nothing
193:   Set pFClass = Nothing
  
 Exit Property
ErrorHandler:
  HandleError True, "ArcApplication " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub CheckEnable()
  On Error GoTo ErrorHandler
  
203:   cmdOK.Enabled = cbxLayers.Text <> "" And txtOutput.Text <> "" _
      And cbxPolygons.Text <> "" And txtThreshold.Text <> "" And m_pPolygonLayerArray.Count > 0 And _
      m_pRasterLayerArray.Count > 0
 
  Exit Sub
ErrorHandler:
  HandleError False, "CheckEnable " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cbxPolygons_Click()
  On Error GoTo ErrorHandler

215:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "cbxPolygons_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdGetWorkspace_Click()
  On Error GoTo ErrorHandler

  
  ' SET DEFAULT NAME
  Dim strDefault As String
228:   strDefault = txtOutput.Text
  
230:   cdlg.Filter = "Shapefiles (*.shp)|*.shp"
231:   cdlg.InitDir = TopoCorridor.aml_func_mod.ReturnDir(strDefault)
232:   cdlg.FileName = TopoCorridor.aml_func_mod.ReturnFilename(strDefault)
233:   cdlg.DialogTitle = "Save Termini Polygon Shapefile:"
234:   cdlg.ShowSave
  
  Dim strFilename As String
237:   strFilename = cdlg.FileName
  
239:   If strFilename <> "" Then
    Dim strBaseName As String
241:     strBaseName = TopoCorridor.aml_func_mod.ReturnFilename(strFilename)
242:     txtOutput.Text = strFilename
243:     txtOutput.SelStart = Len(txtOutput.Text)

245:   End If
'  MsgBox "strFileName = " & strFileName
  
248:   CheckEnable

  

  Exit Sub
ErrorHandler:
  HandleError True, "cmdGetWorkspace_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdManual_Click()
  On Error GoTo ErrorHandler

  
  ' CHANGE AS APPROPRIATE
  Dim strDir As String
263:   strDir = App.Path
264:   If Right(strDir, 1) <> "\" Then strDir = strDir & "\"
265:   strDir = strDir & "docs"
  
267:   Call TopoCorridor.MyGeneralOperations.OpenDoc("Land_Facet_Tools.pdf", strDir)
  
  Exit Sub
ErrorHandler:
  HandleError True, "cmdManual_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdCancel_Click()
  On Error GoTo ErrorHandler

277:   m_pThisExt.ShouldContinue = False
278:   Set m_pThisExt.frmTerminiResponse = Nothing
279:   Unload Me
 
  Exit Sub
ErrorHandler:
  HandleError True, "cmdCancel_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdOK_Click()
  On Error GoTo ErrorHandler

  ' RETURN ARRAY IS IVariantArray, CONTAINING:
  ' 0) IRasterBand: SELECTED DENSITY RASTER BAND
  ' 1) STRING: NAME OF SELECTED RASTER
  ' 2) IFeatureLayer: SELECTED HABITAT BLOCK POLYGON LAYER
  ' 3) STRING: NAME OF SELECTED FEATURE LAYER
  ' 4) LONG: SIZE THRESHOLD
  ' 5) STRING: FULL OUTPUT STRING FROM txtOutput
  ' 6) IWORKSPACE: OUTPUT WORKSPACE
  ' 7) PATH TO WORKSPACE
  ' 8) JUST FILENAME
  ' 9) DOUBLE: DATA THRESHOLD
  
  Dim lngIndex As Long
  
  Dim pReturnArray As esriSystem.IVariantArray
304:   Set pReturnArray = New esriSystem.VarArray
  
  ' SELECTED RASTER LAYER
  Dim pRasterBand As IRasterBand
308:   Set pRasterBand = m_pRasterLayerArray.Element(cbxLayers.ListIndex)
309:   pReturnArray.Add pRasterBand
310:   pReturnArray.Add m_pRasterLayerNames.Element(cbxLayers.ListIndex)
311:   pReturnArray.Add m_pPolygonLayerArray.Element(cbxPolygons.ListIndex)
312:   pReturnArray.Add m_pPolygonLayerNames.Element(cbxPolygons.ListIndex)
  
  Dim lngThreshold As Long
315:   If Not IsNumeric(txtThreshold.Text) Then
316:     MsgBox "The Relative Size Threshold Value must be a number!" & vbCrLf & vbCrLf & _
           "Please enter a numeric value...", , "Invalid Size Threshold Value:"
318:     txtThreshold.SetFocus
    Exit Sub
320:   Else
321:     lngThreshold = CLng(txtThreshold.Text)
322:     If lngThreshold < 0 Or lngThreshold >= 100 Then
323:       MsgBox "The Relative Size Threshold Value must be >= 0 and < 100!" & vbCrLf & vbCrLf & _
             "Please enter a value between 0 and 99...", , "Invalid Size Threshold Value:"
325:       txtThreshold.SetFocus
      Exit Sub
327:     End If
328:   End If
329:   pReturnArray.Add lngThreshold
    
  Dim strWS As String
  Dim strFilename As String
  Dim pWS As IWorkspace
  Dim pWS2 As IWorkspace2
  Dim pFeatWS As IFeatureWorkspace
  Dim strFullPath As String
  Dim pWsFact As IWorkspaceFactory2
  Dim pDataset As IDataset
      
340:   strFullPath = txtOutput.Text
341:   strFilename = TopoCorridor.aml_func_mod.ReturnFilename(strFullPath)
342:   strWS = TopoCorridor.aml_func_mod.ReturnDir(strFullPath)
343:   If Right(strWS, 1) = "\" Then
344:     strWS = Left(strWS, Len(strWS) - 1)
345:   End If
  
  ' CLIP OFF ANY EXTENSIONS TO NAME
  Dim iPos As Long
349:   iPos = InStrRev(strFilename, ".")
350:   If iPos > 0 Then
351:     strFilename = Left(strFilename, iPos - 1)
352:   End If
  
  ' MAKE SURE WORKSPACE EXISTS
355:   If Not TopoCorridor.aml_func_mod.ExistFileDir(strWS) Then
356:     MsgBox "Unable to create Termini shapefile:" & vbCrLf & _
           strWS & " is not a valid workspace...", , "Failed to Create Shapefile:"
358:     txtOutput.SetFocus
    Exit Sub
360:   End If
  
362:   Set pWsFact = New ShapefileWorkspaceFactory
363:   Set pWS = pWsFact.OpenFromFile(strWS, Me.hWnd)
 ' Set pWS2 = pWS
  
366:   pReturnArray.Add txtOutput.Text
367:   pReturnArray.Add pWS
368:   pReturnArray.Add strWS
369:   pReturnArray.Add strFilename
  
  Dim dblDataThreshold As Double
372:   If Not IsNumeric(txtDataThreshold.Text) Then
373:     MsgBox "The Analysis Layer Threshold Value must be a number!" & vbCrLf & vbCrLf & _
           "Please enter a numeric value...", , "Invalid Analysis Layer Threshold Value:"
375:     txtDataThreshold.SetFocus
    Exit Sub
377:   End If
378:   dblDataThreshold = CDbl(txtDataThreshold.Text)
379:   pReturnArray.Add dblDataThreshold
380:   m_pThisExt.frmTerminiDataThresholdDouble = dblDataThreshold
  
  ' MAKE SURE RASTER DOES NOT EXIST
  Dim lngVBResult As VbMsgBoxResult
384:   If TopoCorridor.aml_func_mod.ExistFileDir(strFullPath) Then
385:     lngVBResult = MsgBox("'" & strFilename & "' Already exists!" & vbCrLf & _
           "Would you like this tool to attempt to delete the existing file?", vbYesNo, _
           "File Exists:")
388:     If lngVBResult = vbYes Then
389:       Set pFeatWS = pWS
390:       Set pDataset = pFeatWS.OpenFeatureClass(strFilename)
391:       If pDataset.CanDelete Then
392:         pDataset.DELETE
393:         If Not TopoCorridor.aml_func_mod.ExistFileDir(strFullPath) Then
394:           MsgBox "File Deleted..."
395:         End If
396:       Else
397:         MsgBox "Unable to delete '" & strFilename & "'..." & vbCrLf & _
          "Please delete this file manually before attempting to create a new shapefile with this name."
399:         txtOutput.SetFocus
        Exit Sub
401:       End If
402:     Else
403:       txtOutput.SetFocus
      Exit Sub
405:     End If
406:     txtOutput.SetFocus
    Exit Sub
408:   End If
    
410:   m_pThisExt.ShouldContinue = True
411:   m_pThisExt.frmTerminiFolderPath = strWS
412:   m_pThisExt.frmTerminiThreshold = lngThreshold
413:   Set m_pThisExt.frmTerminiResponse = pReturnArray
  
415:   Unload Me
      
'  Me.Visible = False
418:   Set pReturnArray = Nothing
419:   Set pRasterBand = Nothing
420:   Set pWS = Nothing
421:   Set pWS2 = Nothing
422:   Set pFeatWS = Nothing
423:   Set pWsFact = Nothing
424:   Set pDataset = Nothing
  
  Exit Sub
ErrorHandler:
  HandleError True, "cmdOK_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub Form_Load()
  On Error GoTo ErrorHandler
 
434:   SetWindowPos Me.hWnd, -1, 0, 0, 0, 0, &H1 Or &H2
435:   Me.Left = (Screen.Width / 2) - (Me.Width / 2)
436:   Me.Top = (Screen.Height / 3) - (Me.Height / 3)
  Dim lngTopBar As Long
438:   lngTopBar = Me.Height - Me.ScaleHeight
439:   Me.Height = cmdOK.Top + cmdOK.Height + lngTopBar
440:    Set Anchors = New AnchorObjectList  ' Create new instance
441:    With Anchors
442:       With .Item(cbxLayers)
443:          .SetAnchors enumStartEnd, enumSizeEnd
444:       End With
445:       With .Item(cbxPolygons)
446:          .SetAnchors enumStartEnd, enumSizeEnd
447:       End With
448:       With .Item(cmdCancel)
449:          .SetAnchors enumSizeEnd, enumSizeEnd
450:       End With
451:       With .Item(cmdGetWorkspace)
452:          .SetAnchors enumSizeEnd, enumSizeEnd
453:       End With
454:       With .Item(cmdManual)
455:          .SetAnchors enumSizeEnd, enumSizeEnd
456:       End With
457:       With .Item(cmdOK)
458:          .SetAnchors enumSizeEnd, enumSizeEnd
459:       End With
460:       With .Item(imgBackTop)
461:          .SetAnchors enumStartEnd, enumStartEnd
462:       End With
463:       With .Item(imgCornerBars)
464:          .SetAnchors enumSizeEnd, enumSizeEnd
465:       End With
466:       With .Item(imgParamsBack)
467:          .SetAnchors enumStartEnd, enumSizeEnd
468:       End With
469:       With .Item(lblPolygons)
470:          .SetAnchors enumStartSize, enumSizeEnd
471:       End With
472:       With .Item(lblLayer)
473:          .SetAnchors enumStartSize, enumSizeEnd
474:       End With
475:       With .Item(lblThreshold)
476:          .SetAnchors enumStartSize, enumSizeEnd
477:       End With
478:       With .Item(lblDataThreshold)
479:          .SetAnchors enumStartSize, enumSizeEnd
480:       End With
481:       With .Item(lblOutputName)
482:          .SetAnchors enumStartSize, enumSizeEnd
483:       End With
484:       With .Item(txtMessage)
485:          .SetAnchors enumStartEnd, enumStartEnd
486:       End With
487:       With .Item(txtThreshold)
488:          .SetAnchors enumStartEnd, enumSizeEnd
489:       End With
490:       With .Item(txtDataThreshold)
491:          .SetAnchors enumStartEnd, enumSizeEnd
492:       End With
493:       With .Item(txtOutput)
494:          .SetAnchors enumStartEnd, enumSizeEnd
495:       End With
496:       .Form = Me  ' Set form reference (suggested to be last step)
497:    End With
  
499:   Set m_pRasterLayerArray = New esriSystem.VarArray
500:   Set m_pRasterLayerNames = New esriSystem.strArray
501:   Set m_pPolygonLayerArray = New esriSystem.VarArray
502:   Set m_pPolygonLayerNames = New esriSystem.strArray
  
504:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub Form_Unload(Cancel As Integer)
  On Error GoTo ErrorHandler
 

515:   Set m_pMxDoc = Nothing
516:   Set m_pApp = Nothing
517:   Set Anchors = Nothing
518:   Set m_pRasterLayerArray = Nothing
519:   Set m_pPolygonLayerArray = Nothing
520:   Set m_pThisExt = Nothing
521:   Set m_pRasterLayerNames = Nothing
522:   Set m_pPolygonLayerNames = Nothing

  
  Exit Sub
ErrorHandler:
  HandleError True, "Form_Unload " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cbxLayers_Click()
  On Error GoTo ErrorHandler

533:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "cbxLayers_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub ExtraCodeRequired()
 
  '' PUT IN EXTENSION CLASS
  '
  'Private m_booShouldContinue As Boolean
  'Private m_strDirPath As String
  'Private m_pfrmInvertRasterReturn As esriSystem.IVariantArray
  'Private m_strDirType As String
  'Private m_booIsFeatDataset As Boolean
  'Private m_strFeatDatasetName As String
  '
  '' PUT IN EXTENSION SHUTDOWN EVENT
  ' Set m_pfrmInvertRasterReturn = Nothing
  '
  '' SET FOLLOWING PROPERTIES
  'Public Property Let FeatDatasetName(strFeatDatasetName As String)
  '  m_strFeatDatasetName = strFeatDatasetName
  'End Property
  'Public Property Get FeatDatasetName() As String
  '  FeatDatasetName = m_strFeatDatasetName
  'End Property
  'Public Property Let IsFeatureDataset(booIsFeatDataset As Boolean)
  '  m_booIsFeatDataset = booIsFeatDataset
  'End Property
  'Public Property Get IsFeatureDataset() As Boolean
  '  IsFeatureDataset = m_booIsFeatDataset
  'End Property
  'Public Property Let DirectoryType(strDirType As String)
  '  m_strDirType = strDirType
  'End Property
  'Public Property Get DirectoryType() As String
  '  DirectoryType = m_strDirType
  'End Property
  '
  'Public Property Set frmInvertRasterReturn(pfrmInvertRasterReturn As esriSystem.IVariantArray)
  '  Set m_pfrmInvertRasterReturn = pfrmInvertRasterReturn
  'End Property
  '
  'Public Property Get frmInvertRasterReturn() As esriSystem.IVariantArray
  '  Set frmInvertRasterReturn = m_pfrmInvertRasterReturn
  'End Property
  '
  'Public Property Let DirectoryPath(strPath As String)
  '  On Error GoTo ErrorHandler
  '  m_strDirPath = strPath
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "DirectoryPath " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  'Public Property Get DirectoryPath() As String
  '  On Error GoTo ErrorHandler
  '  DirectoryPath = m_strDirPath
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "DirectoryPath " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  'Public Property Let ShouldContinue(booShouldContinue As Boolean)
  '  On Error GoTo ErrorHandler
  '  m_booShouldContinue = booShouldContinue
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "ShouldContinue " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  'Public Property Get ShouldContinue() As Boolean
  '  On Error GoTo ErrorHandler
  '  ShouldContinue = m_booShouldContinue
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "ShouldContinue " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  '' PUT IN EXTENSION STARTUP EVENT
  '  If m_strDirPath = "" Or m_strDirType = "" Then
  '    m_strDirType = "Shapefile"
  '    m_strDirPath = ""
  '    m_booIsFeatDataset = False
  '    m_strFeatDatasetName = ""
  '  End If
  '
  '===============================================================================================================
  '
' ' SAMPLE CODE
'    Dim pVarArray As esriSystem.IVariantArray
'    Set pVarArray = New VarArray
'
'    ' ADD APPLICATION
'    pVarArray.Add m_pApp
'
'    ' ADD DESIRED LAYER TYPES
'    Dim pLayerTypes As JenLayerTypes
'    pLayerTypes = ENUM_jenRasterLayers
'    pVarArray.Add pLayerTypes
'
'    'EXTENSION SHOULD HAVE PROPERTIES FOR "ShouldContinue", "DirectoryPath", "frmInvertRasterReturn",
'    '     "DirectoryType", "IsFeatureDataset", "FeatDatasetName"
'    pVarArray.Add m_pThisExt
'
'    ' ADD DESIRED FIELD TYPES
'    pVarArray.Add 0
'
'    ' ADD WHETHER TO INCLUDE ID FIELD
'    pVarArray.Add (False)
'
'    ' ADD WHETHER ANY OUTPUT WILL BE A FEATURE CLASS (TRUE) OR TABLE (FALSE)         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    Dim booOutputIsFClass As Boolean                                                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    booOutputIsFClass = True                                                         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    pVarArray.Add (booOutputIsFClass)                                                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'
'    Dim pForm As TopoCorridor.frmInvertRaster
'    Set pForm = New TopoCorridor.frmInvertRaster
'    Set pForm.ArcApplication = pVarArray
'    pForm.Show vbModal
'    Set pForm = Nothing
'
'    If m_pThisExt.ShouldContinue = False Then
'      MsgBox "Function Canceled:" & vbCrLf & "Bailing out..."
'      Exit Sub
'    End If
'
'    Dim pReturnArray As esrisystem.IVariantArray
'    Set pReturnArray = m_pThisExt.frmInvertRasterReturn
 
'    ' OUTPUT
'    ' SELECTED TABLE OR LAYER
'    Dim pUnknown As IUnknown
'    Set pUnknown = pReturnArray.Element(0)
'
'    ' FOR DEBUGGING
'    Dim strReport As String
'    strReport = "Selected Items:" & vbNewLine
'
'    If TypeOf pUnknown Is ILayer Then
'      Dim pLayer As ILayer
'      Set pLayer = pUnknown
'      strReport = strReport & "Name:  " & pLayer.Name & vbNewLine
'    ElseIf TypeOf pUnknown Is IStandaloneTable Then
'      Dim pStTab As IStandaloneTable
'      Set pStTab = pUnknown
'      strReport = strReport & "Name:  " & pStTab.Name & vbNewLine
'    End If
'


'  ' CODE SNIPPET TO USE pFieldNamePairs TO TRANSFER ATTRIBUTE DATA FROM OLD SOURCE TO NEW SOURCE
'  ' MAKE IVariantArray OF FIELD NAME INDICES
'  ' STRUCTURE:  ARRAY OF 4-ITEM VARIANT ARRAYS
'  '             ITEMS = 0) ORIGINAL FCLASS FIELD NAME
'  '                     1) ORIGINAL FCLASS FIELD INDEX
'  '                     2) NEW FCLASS FIELD NAME
'  '                     3) NEW FCLASS FIELD INDEX
'  Dim pFieldNamePairs As esriSystem.IVariantArray
'  Set pFieldNamePairs = pOutputArray.Element(9)
'  Dim pFieldNameData As esriSystem.IVariantArray
'  Set pFieldNameData = TopoCorridor.MyGeneralOperations.MakeFieldNameVarArray(pFeatureClass, pNewFClass, pFieldNamePairs, True)
'  Dim lngFieldIndex As Long
'  Dim pFieldSubArray As esriSystem.IVariantArray
'  ' ROTATE THROUGH ALL FEATURES / ROWS
'    ' TRANSFER ATTRIBUTE DATA; ASSUMES pBuffer ALREADY EXISTS
'    For lngFieldIndex = 0 To pFieldNameData.Count - 1
'      Set pFieldSubArray = pFieldNameData.Element(lngFieldIndex)
'      pBuffer.Value(pFieldSubArray.Element(3)) = pFeature.Value(pFieldSubArray.Element(1))
'    Next lngFieldIndex
'  ' LOOP

''  ' SAMPLE SNIPPET FOR FEATURE LAYERS:  ROTATE THROUGH ALL OR SELECTED RECORDS
''  Dim pFeatureLayer As IFeatureLayer
''  Dim pFClass As IFeatureClass
''  Dim pFeatSel As IFeatureSelection
''  Dim pSelSet As ISelectionSet
''  Dim pCursor As IFeatureCursor
''  Dim lngCount As Long
''
''  Set pFClass = pFeatureLayer.FeatureClass
''  Set pFeatSel = pFeatureLayer
''  Set pSelSet = pFeatSel.SelectionSet
''
''  If pSelSet.Count = 0 Then
''    Set pCursor = pFClass.Search(Nothing, False)
''    lngCount = pFClass.FeatureCount(Nothing)
''  Else
''    If booDoAll = True Then
''      Set pCursor = pFClass.Search(Nothing, False)
''      lngCount = pFClass.FeatureCount(Nothing)
''    Else
''      pSelSet.Search Nothing, True, pCursor
''      lngCount = pSelSet.Count
''    End If
''  End If
''
''  Dim pFeature As IFeature
''  Set pFeature = pCursor.NextFeature
''  Do Until pFeature Is Nothing
''    ' DO ACTIONS
''    Set pFeature = pCursor.NextFeature
''  Loop
''
''  ' SAMPLE CODE SNIPPET:  ADD RECORDS TO FEATURE CLASS USING BUFFER
''  Dim pBuffer As IFeatureBuffer
''  Set pBuffer = pFClass.CreateFeatureBuffer
''  Dim pNewFeatureCursor As IFeatureCursor
''  Set pNewFeatureCursor = pFClass.Insert(True)
''  ' LOOP THROUGH WHATEVER STEPS ARE REQUIRED TO GATHER DATA FOR A SINGLE ROW
''    Set pBuffer.Shape = aGeometry
''    pBuffer.Value(lngFieldIndex) = aValue
''    pNewFeatureCursor.InsertFeature pBuffer
''  ' LOOP
''  pNewFeatureCursor.Flush

''  ' SAMPLE SNIPPET FOR TABLES:  ROTATE THROUGH ALL OR SELECTED RECORDS
''  Dim pStandaloneTable As IStandaloneTable
''  Dim pInputTable As ITable
''  Dim pTableSel As ITableSelection
''  Dim pSelSet As ISelectionSet
''  Dim pRowCursor As ICursor
''  Dim lngCount As Long
''
''  Set pInputTable = pStandaloneTable.Table
''  Set pTableSel = pStandaloneTable
''  Set pSelSet = pTableSel.SelectionSet
''
''  If pSelSet.Count = 0 Then
''    Set pRowCursor = pInputTable.Search(Nothing, False)
''    lngCount = pInputTable.FeatureCount(Nothing)
''  Else
''    If booDoAll = True Then
''      Set pRowCursor = pInputTable.Search(Nothing, False)
''      lngCount = pInputTable.FeatureCount(Nothing)
''    Else
''      pSelSet.Search Nothing, True, pRowCursor
''      lngCount = pSelSet.Count
''    End If
''  End If
''
''  Dim pRow As IRow
''  Set pRow = pRowCursor.NextRow
''  Do Until pRow Is Nothing
'''     DO ACTIONS
''    Set pRow = pRowCursor.NextFeature
''  Loop
 
''  ' SAMPLE CODE SNIPPET:  ADD RECORDS TO TABLE USING BUFFER
''  Dim pBuffer As IRowBuffer
''  Set pBuffer = pTable.CreateRowBuffer
''  Dim pTableCursor As ICursor
''  Set pTableCursor = pTable.Insert(True)
''  ' LOOP THROUGH WHATEVER STEPS ARE REQUIRED TO GATHER DATA FOR A SINGLE ROW
''    pBuffer.Value(lngFieldIndex) = aValue
''    pTableCursor.InsertRow pBuffer
''  ' LOOP
''  pTableCursor.Flush
'    MsgBox strReport, vbOKOnly, "Test of LayerID Form:"
'
'  Dim pDocDirty As IDocumentDirty
'  Set pDocDirty = m_pMxDoc
'  pDocDirty.SetDirty
'

End Sub

Private Sub txtDataThreshold_Change()
803:   CheckEnable
End Sub

Private Sub txtDataThreshold_KeyPress(KeyAscii As Integer)
  
808:    TopoCorridor.MyGeneralOperations.CheckNumericReal KeyAscii, txtDataThreshold

End Sub

Private Sub txtOutput_Change()
  On Error GoTo ErrorHandler

815:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "txtOutput_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub txtThreshold_Change()
  On Error GoTo ErrorHandler

825:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "txtThreshold_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub txtThreshold_KeyPress(KeyAscii As Integer)
  On Error GoTo ErrorHandler

835:    TopoCorridor.MyGeneralOperations.CheckNumericIntegerPositive KeyAscii, txtThreshold

  Exit Sub
ErrorHandler:
  HandleError True, "txtThreshold_KeyPress " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
