VERSION 5.00
Begin VB.Form frmInvertRaster 
   Caption         =   " Invert Raster Parameters:"
   ClientHeight    =   3600
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6375
   Icon            =   "frmInvertRaster.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   3600
   ScaleWidth      =   6375
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtAdd 
      Alignment       =   2  'Center
      Height          =   315
      Left            =   1050
      TabIndex        =   4
      Text            =   "txtAdd"
      Top             =   1935
      Width           =   885
   End
   Begin VB.CheckBox chkAdd 
      Caption         =   "Add"
      Height          =   315
      Left            =   345
      TabIndex        =   3
      Top             =   1935
      Width           =   675
   End
   Begin VB.ComboBox cbxLayers 
      Height          =   315
      Left            =   352
      Style           =   2  'Dropdown List
      TabIndex        =   1
      Top             =   1395
      Width           =   2895
   End
   Begin VB.CommandButton cmdGetWorkspace 
      Height          =   360
      Left            =   5820
      Picture         =   "frmInvertRaster.frx":058A
      Style           =   1  'Graphical
      TabIndex        =   6
      ToolTipText     =   "Browse for Output Feature Class..."
      Top             =   2715
      Width           =   465
   End
   Begin VB.TextBox txtOutput 
      Height          =   330
      Left            =   165
      TabIndex        =   5
      Text            =   "txtOutput"
      Top             =   2730
      Width           =   5595
   End
   Begin VB.ComboBox cbxFormat 
      Height          =   315
      Left            =   3562
      Style           =   2  'Dropdown List
      TabIndex        =   2
      Top             =   1395
      Width           =   2460
   End
   Begin VB.CommandButton cmdManual 
      Caption         =   "Manual"
      Height          =   345
      Left            =   2662
      TabIndex        =   8
      Top             =   3240
      Width           =   1065
   End
   Begin VB.TextBox txtMessage 
      Height          =   960
      Left            =   90
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      TabStop         =   0   'False
      Text            =   "frmInvertRaster.frx":0600
      Top             =   75
      Width           =   6195
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   345
      Left            =   3727
      TabIndex        =   9
      Top             =   3240
      Width           =   1065
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   345
      Left            =   1582
      TabIndex        =   7
      Top             =   3240
      Width           =   1065
   End
   Begin VB.Label lblAdd 
      AutoSize        =   -1  'True
      Caption         =   "to all cells to avoid 'NoData' when input cell values = 0"
      Height          =   195
      Left            =   2010
      TabIndex        =   13
      Top             =   1995
      Width           =   3855
   End
   Begin VB.Label lblOutputName 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Output Raster Dataset Name:"
      Height          =   195
      Left            =   150
      TabIndex        =   12
      Top             =   2520
      Width           =   2100
   End
   Begin VB.Label lblFormat 
      Alignment       =   1  'Right Justify
      AutoSize        =   -1  'True
      Caption         =   "Output Raster Format:"
      Height          =   195
      Left            =   4005
      TabIndex        =   11
      Top             =   1155
      Width           =   1560
   End
   Begin VB.Image imgParamsBack 
      BorderStyle     =   1  'Fixed Single
      Height          =   795
      Left            =   15
      Top             =   2385
      Width           =   6345
   End
   Begin VB.Image imgCornerBars 
      Height          =   225
      Left            =   6135
      Picture         =   "frmInvertRaster.frx":060F
      Top             =   3360
      Width           =   225
   End
   Begin VB.Label lblLayer 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      Caption         =   "-- Select Raster Layer --"
      Height          =   195
      Left            =   930
      TabIndex        =   10
      Top             =   1155
      Width           =   1710
   End
   Begin VB.Image imgBackTop 
      BorderStyle     =   1  'Fixed Single
      Height          =   2355
      Left            =   15
      Top             =   15
      Width           =   6345
   End
End
Attribute VB_Name = "frmInvertRaster"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
 
Private m_pMxDoc As esriArcMapUI.IMxDocument
Private m_pApp As IApplication
Private Anchors As AnchorObjectList  ' Main anchor control object
Private m_pLayerArray As esriSystem.IVariantArray
Private m_pLayerFields As esriSystem.IVariantArray
Private m_strSelLayerName As String
Private m_booSelToggle As Boolean
Private m_pThisExt As TopoCorridor.clsExtension
Private m_ShapeTypeOption As JenLayerTypes
Private m_pReturnArray As esriSystem.IVariantArray
Private m_FieldTypeOption As JenFieldTypes
Private m_booIncludeNoIDField As Boolean
Private m_strOutputWorkspace As String
Private m_strOutputBasename As String
Private m_lngOutputWSType As JenDatasetTypes
Private m_booOutputFeatDataset As Boolean
Private m_strOutputFeatDatasetName As String
Private m_booOutputIsFClass As Boolean         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS

Private m_strRasterWS As String
Private m_pSaveFormats As esriSystem.IVariantArray
Private m_pFileExtensions As esriSystem.IVariantArray
Private m_strRasterName As String
Private m_pLayerNames As esriSystem.IStringArray
 
Const c_sModuleFileName As String = "...Form = frmInvertRaster.frm"
 
Public Property Set ArcApplication(ByVal pParams As esriSystem.IVariantArray)
  On Error GoTo ErrorHandler
 
33:   Set m_pApp = pParams.Element(0)
34:   Set m_pMxDoc = pParams.Element(1)
35:   Set m_pThisExt = pParams.Element(2)
 
  Dim pSelItem As IUnknown
38:   Set pSelItem = m_pMxDoc.SelectedItem
  Dim pLayer As IRasterLayer
  Dim lngIndex As Long
  Dim pUnknown As IUnknown

43:   m_strSelLayerName = ""
 
45:   If Not pSelItem Is Nothing Then
46:     If TypeOf pSelItem Is IRasterLayer Then
47:       Set pLayer = pSelItem
48:       m_strSelLayerName = pLayer.Name
49:     End If
50:   End If

  ' FILL LAYER ARRAY AND LISTBOX
53:   cbxLayers.Clear
  Dim lngStartSel As Long
55:   lngStartSel = 0
  Dim pTempLayerArray As esriSystem.IVariantArray
57:   Set pTempLayerArray = TopoCorridor.MyGeneralOperations.ReturnLayersByType(m_pMxDoc.FocusMap, ENUM_jenRasterLayers)
58:   Set m_pLayerArray = New esriSystem.VarArray
59:   Set m_pLayerNames = New esriSystem.strArray
  
  Dim pRastBandColl As IRasterBandCollection
  Dim pRastBand As IRasterBand
  Dim pRaster As IRaster
  Dim lngIndex2 As Long
  Dim lngSelCounter As Long
66:   lngSelCounter = -1
  Dim strBandName As String
  
69:   If pTempLayerArray.Count > 0 Then
70:     For lngIndex = 0 To pTempLayerArray.Count - 1
71:       Set pUnknown = pTempLayerArray.Element(lngIndex)
72:       If TypeOf pUnknown Is IRasterLayer Then
73:         Set pLayer = pUnknown
74:         If pLayer.Valid Then
75:           Set pRaster = pLayer.Raster
76:           Set pRastBandColl = pRaster
77:           If pRastBandColl.Count = 1 Then
78:             strBandName = pLayer.Name
79:             cbxLayers.AddItem strBandName
80:             m_pLayerNames.Add strBandName
81:             m_pLayerArray.Add pRastBandColl.Item(0)
82:             lngSelCounter = lngSelCounter + 1
83:             If pLayer.Name = m_strSelLayerName Then lngStartSel = lngSelCounter
84:           Else
85:             For lngIndex2 = 0 To pRastBandColl.Count - 1
86:               Set pRastBand = pRastBandColl.Item(lngIndex2)
87:               strBandName = pLayer.Name & " [Band " & CStr(lngIndex2 + 1) & "]"
88:               m_pLayerNames.Add strBandName
89:               cbxLayers.AddItem strBandName
90:               m_pLayerArray.Add pRastBandColl.Item(lngIndex2)
91:               lngSelCounter = lngSelCounter + 1
92:               If pLayer.Name = m_strSelLayerName Then lngStartSel = lngSelCounter
93:             Next lngIndex2
94:           End If
95:         End If
96:       End If
97:     Next lngIndex
98:     cbxLayers.ListIndex = lngStartSel
99:   End If

  Dim strBaseString As String
102:   strBaseString = strBaseString & "This tool will mathematically invert the raster by inverting each cell value (i.e. Inverse X = 1/X).  Any cells with 0-value will automatically be converted to 'NoData' because you cannot divide a value by 0.  Optionally you may add some constant value to all cells before inverting it to prevent this from happening." & vbNewLine

104:   txtMessage.Text = strBaseString

106:   Set m_pSaveFormats = New esriSystem.VarArray
107:   Set m_pFileExtensions = New esriSystem.VarArray
  
109:   cbxFormat.Clear
  Dim strFileExtension As String
  Dim lngVersion As Long
  Dim strTypeName As String
  Dim strType As String
  
  ' GIVING UP ON SAVING TO FILE GEODATABASE RASTER....
  'lngVersion = TopoCorridor.aml_func_mod.ReturnArcGISVersionAlt(m_pMxDoc)
117:   lngVersion = 0
118:   If lngVersion >= 2 Then
119:     strTypeName = "File Geodatabase Raster"
120:     strType = "GDB"
121:     m_pSaveFormats.Add strType
122:     cbxFormat.AddItem strTypeName
123:     strFileExtension = ""
124:     m_pFileExtensions.Add strFileExtension
125:   End If
  
127:   strTypeName = "ESRI GRID"
128:   strType = "GRID"
129:   m_pSaveFormats.Add strType
130:   cbxFormat.AddItem strTypeName
131:   strFileExtension = ""
132:   m_pFileExtensions.Add strFileExtension
  
134:   strTypeName = "Imagine Image"
135:   strType = "IMAGINE Image"
136:   m_pSaveFormats.Add strType
137:   cbxFormat.AddItem strTypeName
138:   strFileExtension = ".img"
139:   m_pFileExtensions.Add strFileExtension
  
141:   strTypeName = "TIFF File"
142:   strType = "TIFF"
143:   m_pSaveFormats.Add strType
144:   cbxFormat.AddItem strTypeName
145:   strFileExtension = ".tif"
146:   m_pFileExtensions.Add strFileExtension
  
148:   strTypeName = "JPEG File"
149:   strType = "JPG"
150:   m_pSaveFormats.Add strType
151:   cbxFormat.AddItem strTypeName
152:   strFileExtension = ".jpg"
153:   m_pFileExtensions.Add strFileExtension
  
155:   strTypeName = "JPEG 2000 File"
156:   strType = "JP2"
157:   m_pSaveFormats.Add strType
158:   cbxFormat.AddItem strTypeName
159:   strFileExtension = ".jp2"
160:   m_pFileExtensions.Add strFileExtension
  
  Dim strFolder As String
163:   strFolder = m_pThisExt.DirectoryPath
164:   If strFolder = "" Or Not (TopoCorridor.aml_func_mod.ExistFileDir(strFolder)) Then
165:     strFolder = TopoCorridor.aml_func_mod.ReturnDir(TopoCorridor.aml_func_mod.GetMxDocPath(m_pApp))
166:   End If
167:   If Right(strFolder, 1) = "\" Then
168:     strFolder = Left(strFolder, Len(strFolder) - 1)
169:   End If
  
171:   If StrComp(Right(strFolder, 4), ".gdb") = 0 Then
172:     cbxFormat.ListIndex = 0
173:   Else
'    If m_pThisExt.OutputFormat = 0 Then
'      cbxFormat.ListIndex = 1
'    Else
177:       cbxFormat.ListIndex = m_pThisExt.OutputFormat
'    End If
179:   End If
    
  Dim pWS As IWorkspace
  Dim pWsFact As IWorkspaceFactory2
183:   If StrComp(Right(strFolder, 4), ".gdb", vbTextCompare) = 0 Then
184:     Set pWsFact = New FileGDBWorkspaceFactory
185:   Else
186:     Set pWsFact = New RasterWorkspaceFactory
187:   End If
188:   Set pWS = pWsFact.OpenFromFile(strFolder, Me.hWnd)
    
  Dim strSuggest As String
191:   If cbxFormat.Text = "ESRI GRID" Or cbxFormat.Text = "File Geodatabase Raster" Then
192:     strSuggest = TopoCorridor.MyGeneralOperations.MakeUniqueRasterName2 _
        (pWS, "Invert" & m_pFileExtensions.Element(cbxFormat.ListIndex), CBool(cbxFormat.Text = "ESRI GRID"))
194:     txtOutput.Text = strFolder & "\" & strSuggest
195:   Else
196:     strSuggest = TopoCorridor.MyGeneralOperations.MakeUniqueShapeFilename(strFolder & "\" & _
        "Invert" & m_pFileExtensions.Element(cbxFormat.ListIndex))
198:     txtOutput.Text = strSuggest
199:   End If
200:   txtOutput.SelStart = Len(txtOutput.Text)
  
202:   m_strRasterWS = pWS.PathName
203:   m_strRasterName = TopoCorridor.aml_func_mod.ReturnFilename(strSuggest)
  
  Dim dblAdd As Double
  Dim booShouldAdd As Boolean
207:   booShouldAdd = m_pThisExt.frmInvertShouldAdd
208:   dblAdd = m_pThisExt.frmInvertAdd
  
  ' MODIFIED APRIL 25 2010 to turn this option on by default.
211:   booShouldAdd = True
  
213:   If dblAdd = 0 Then
214:     dblAdd = 0.1
215:   End If
216:   If booShouldAdd Then
217:     chkAdd.Value = 1
218:   Else
219:     chkAdd.Value = 0
220:   End If
  
222:   txtAdd.Text = CStr(dblAdd)
  
224:   CheckEnable
  
  ' CLEAR INITIAL SELECTION
227:   Set m_pThisExt.frmInvertReturn = Nothing
228:   m_pThisExt.ShouldContinue = False

230:   Set pSelItem = Nothing
231:   Set pLayer = Nothing
232:   Set pUnknown = Nothing
233:   Set pTempLayerArray = Nothing
234:   Set pRastBandColl = Nothing
235:   Set pRastBand = Nothing
236:   Set pRaster = Nothing
237:   Set pWS = Nothing
238:   Set pWsFact = Nothing
  
 Exit Property
ErrorHandler:
  HandleError True, "ArcApplication " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Public Property Get ReturnArray() As esriSystem.IVariantArray
  On Error GoTo ErrorHandler
 
248:   Set ReturnArray = m_pReturnArray
 
  Exit Property
ErrorHandler:
  HandleError True, "ReturnArray " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub CheckEnable()
  On Error GoTo ErrorHandler
  
  Dim booAddOK As Boolean
259:   If chkAdd.Value = 1 Then
260:     booAddOK = txtAdd.Text <> ""
261:     txtAdd.Enabled = True
262:     txtAdd.BackColor = &H80000005
263:   Else
264:     txtAdd.Enabled = False
265:     txtAdd.BackColor = &H8000000F
266:     booAddOK = True
267:   End If
  
269:   cmdOK.Enabled = cbxLayers.Text <> "" And txtOutput.Text <> "" And booAddOK
 
  Exit Sub
ErrorHandler:
  HandleError False, "CheckEnable " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cbxFormat_Change()
277:   CheckEnable
End Sub

Private Sub chkAdd_Click()
281:   CheckEnable
End Sub

Private Sub cmdGetWorkspace_Click()


  On Error GoTo ErrorHandler
   ' Save to TIFF, IMAGINE Image, GRID and geodatabase
  Dim pGxBrowser As IGxDialog
  Dim pGxFilterCol As IGxObjectFilterCollection
  Dim pGxFilter As IGxObjectFilter
  Dim pGxObj As IGxObject
  Dim pName As IName
  Dim sName As String
  
  Dim booIs10 As Boolean
297:   booIs10 = TopoCorridor.aml_func_mod.IsVersion10
  
  ' Select input raster dataset
300:   Set pGxBrowser = New GxDialog
301:   pGxBrowser.AllowMultiSelect = False
302:   pGxBrowser.Title = "Specify Output Inverted Raster Dataset"
303:   If TopoCorridor.aml_func_mod.FileExists(m_strRasterWS) Then
304:     pGxBrowser.StartingLocation = m_strRasterWS
305:   End If
  
307:   If Not booIs10 Then
308:     Set pGxFilter = New GxFilterRasterDatasets
    
310:     Set pGxFilterCol = pGxBrowser
311:     pGxFilterCol.AddFilter pGxFilter, True
312:   End If
  
  Dim iPos As Integer
315:   If pGxBrowser.DoModalSave(Me.hWnd) Then
316:     sName = pGxBrowser.Name
317:     iPos = InStrRev(sName, ".")
318:     If iPos > 0 Then
319:       sName = Left(sName, iPos - 1)
320:     End If
    
322:     m_strRasterWS = pGxBrowser.FinalLocation.FullName
323:     m_strRasterName = sName
324:     txtOutput.Text = m_strRasterWS & "\" & m_strRasterName
325:   txtOutput.SelStart = Len(txtOutput.Text)
    
    'Get the workspace
328:     Set pGxObj = pGxBrowser.FinalLocation
329:     Set pName = pGxObj.InternalObjectName
'    Set m_OutWs = pName.Open
    
    'geodatabase workspace
'    If Not m_OutWs Is Nothing Then m_Format = "SDR"
    
335:     If StrComp(Right(m_strRasterWS, 4), ".gdb", vbTextCompare) = 0 Then
336:       cbxFormat.ListIndex = 0
337:     End If
    
339:   End If
340:   CheckEnable
  
342:   GoTo CleanUp

  Exit Sub
ErrorHandler:
  HandleError True, "cmdGetWorkspace_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4

CleanUp:

350:   Set pGxBrowser = Nothing
351:   Set pGxFilterCol = Nothing
352:   Set pGxFilter = Nothing
353:   Set pGxObj = Nothing
354:   Set pName = Nothing

  
End Sub

Private Sub cmdManual_Click()
  On Error GoTo ErrorHandler

  
  ' CHANGE AS APPROPRIATE
  Dim strDir As String
365:   strDir = App.Path
366:   If Right(strDir, 1) <> "\" Then strDir = strDir & "\"
367:   strDir = strDir & "docs"
  
369:   Call TopoCorridor.MyGeneralOperations.OpenDoc("Land_Facet_Tools.pdf", strDir)
  
  Exit Sub
ErrorHandler:
  HandleError True, "cmdManual_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdCancel_Click()
  On Error GoTo ErrorHandler

379:   m_pThisExt.ShouldContinue = False
380:   Set m_pThisExt.frmInvertReturn = Nothing
381:   Set m_pReturnArray = Nothing
382:   Unload Me
 
  Exit Sub
ErrorHandler:
  HandleError True, "cmdCancel_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdOK_Click()
  On Error GoTo ErrorHandler

  ' RETURN ARRAY IS IVariantArray, CONTAINING:
  ' 0) IRasterBand: SELECTED RASTER BAND
  ' 1) STRING: Save Format
  ' 2) STRING: TEXT VERSION OF SAVE FORMAT
  ' 3) STRING: New Raster Name
  ' 4) BOOLEAN: Whether new workspace is File Geodatabase
  ' 5) IWORKSPACE: Either an IRasterWorkspace2 or an IRasterWorkspaceEx
  ' 6) STRING: Extension for output
  ' 7) STRING: Name of Selected Raster Band
  ' 8) DOUBLE: OPTIONAL ADD VALUE
    
  Dim lngIndex As Long
404:   Set m_pReturnArray = New esriSystem.VarArray
    
  ' SELECTED RASTER LAYER
  Dim pRasterBand As IRasterBand
408:   Set pRasterBand = m_pLayerArray.Element(cbxLayers.ListIndex)
409:   m_pReturnArray.Add pRasterBand
  
  Dim strWS As String
  Dim strFilename As String
  Dim pWS As IWorkspace
  Dim pWS2 As IWorkspace2
  Dim pRastWS As IRasterWorkspace2
  Dim pRastWsEx As IRasterWorkspaceEx
  Dim strFullPath As String
  Dim pWsFact As IWorkspaceFactory2
  Dim pDataset As IDataset
  Dim booIsFGB As Boolean
  Dim iPos As Integer
  Dim booExcludeIfAnyNull As Boolean
      
424:   strFullPath = txtOutput.Text
425:   strFilename = TopoCorridor.aml_func_mod.ReturnFilename(strFullPath)
426:   strWS = TopoCorridor.aml_func_mod.ReturnDir(strFullPath)
427:   If Right(strWS, 1) = "\" Then
428:     strWS = Left(strWS, Len(strWS) - 1)
429:   End If
  
  ' CLIP OFF ANY EXTENSIONS TO NAME
432:   iPos = InStrRev(strFilename, ".")
433:   If iPos > 0 Then
434:     strFilename = Left(strFilename, iPos - 1)
435:   End If
  
  ' MAKE SURE WORKSPACE EXISTS
438:   If Not TopoCorridor.aml_func_mod.ExistFileDir(strWS) Then
439:     MsgBox "Unable to create Raster:" & vbCrLf & _
           strWS & " is not a valid workspace...", , "Failed to Create Raster:"
441:     txtOutput.SetFocus
    Exit Sub
443:   End If
  
445:   booIsFGB = StrComp(Right(strWS, 4), ".gdb", vbTextCompare) = 0
  
  Dim lngVersion As Long
448:   lngVersion = TopoCorridor.aml_func_mod.ReturnArcGISVersionAlt(m_pMxDoc)
    
450:   If lngVersion < 2 And booIsFGB Then
451:     MsgBox "Problem:" & vbCrLf & _
           "You have selected a File Geodatabase workspace, but your version of ArcGIS does not " & vbCrLf & _
           "support file geodatabases.", , "Invalid Workspace Specified:"
454:     txtOutput.SetFocus
    Exit Sub
456:   End If
    
458:   If booIsFGB Then
459:     Set pWsFact = New FileGDBWorkspaceFactory
460:   Else
461:     Set pWsFact = New RasterWorkspaceFactory
462:   End If
463:   Set pWS = pWsFact.OpenFromFile(strWS, Me.hWnd)
    
  ' MAKE SURE FILE GEODATABASE IS SELECTED IF USER SPECIFIES SAVING TO FILE GEODATABASE
  Dim strFormat As String
467:   strFormat = m_pSaveFormats.Element(cbxFormat.ListIndex)
   
  '  MsgBox "strFormat = " & strFormat & vbCrLf & _
          "booIsFGB = " & CStr(booIsFGB) & vbCrLf & _
          "strWS = " & strWS
          
473:   If strFormat = "GDB" And (Not booIsFGB) Then
474:     MsgBox "Problem:" & vbCrLf & vbCrLf & _
           "You have selected to save your inverted raster as a File Geodatabase Raster, " & vbCrLf & _
           "but you have not specified an existing File Geodatabase to save the raster." & vbCrLf & vbCrLf & _
           "Please specify an existing file geodatabase.  If necessary, you may use ArcCatalog " & vbCrLf & _
           "to create a new empty file geodatabase.", , "Incorrect Workspace Specified:"
479:     txtOutput.SetFocus
    Exit Sub
481:   ElseIf strFormat <> "GDB" And booIsFGB Then
482:     MsgBox "Problem:" & vbCrLf & vbCrLf & _
           "You have selected to save your inverted raster as a " & cbxFormat.Text & ", " & vbCrLf & _
           "but you have specified a File Geodatabase workspace to save the raster." & vbCrLf & vbCrLf & _
           "File geodatabases can only store File Geodatabase rasters.  Either change " & vbCrLf & _
           "your format to 'File Geodatabase Raster', or select a different workspace.", , _
           "Incorrect Workspace Specified:"
488:     txtOutput.SetFocus
    Exit Sub
  
491:   End If
   
493:   m_pReturnArray.Add strFormat
494:   m_pReturnArray.Add cbxFormat.Text
495:   m_pReturnArray.Add strFilename
496:   m_pReturnArray.Add booIsFGB
497:   m_pReturnArray.Add pWS
498:   m_pReturnArray.Add m_pFileExtensions.Element(cbxFormat.ListIndex)
499:   m_pReturnArray.Add cbxLayers.List(cbxLayers.ListIndex)
  
  Dim dblAdd As Double
502:   dblAdd = 0
  Dim booShouldAdd As Boolean
504:   booShouldAdd = chkAdd.Value = 1
505:   If booShouldAdd Then
506:     If txtAdd.Text = "" Then
507:       MsgBox "Problem:" & vbCrLf & vbCrLf & _
             "Please enter a valid value to add to input raster, to avoid" & vbCrLf & _
             "'NoData' values when input cells are equal to Zero...", , _
             "Invalid Value:"
511:       txtAdd.SetFocus
      Exit Sub
513:     Else
514:       dblAdd = CDbl(txtAdd.Text)
515:       m_pThisExt.frmInvertAdd = dblAdd
516:     End If
517:   End If
518:   m_pReturnArray.Add dblAdd
519:   m_pThisExt.frmInvertShouldAdd = booShouldAdd
  
  ' MAKE SURE RASTER DOES NOT EXIST
  Dim lngVBResult As VbMsgBoxResult
523:   If booIsFGB Then
524:     Set pWS2 = pWS
525:     If pWS2.NameExists(esriDTRasterDataset, strFilename) Then
526:       lngVBResult = MsgBox("File '" & strFilename & "' Already exists!" & vbCrLf & _
             "Would you like this tool to attempt to delete the existing file?", vbYesNo, _
             "File Exists:")
529:       If lngVBResult = vbYes Then
530:         Set pRastWsEx = pWS
531:         Set pDataset = pRastWsEx.OpenRasterDataset(strFilename)
532:         If pDataset.CanDelete Then
533:           pDataset.DELETE
534:           If Not pWS2.NameExists(esriDTRasterDataset, strFilename) Then
535:             MsgBox "File Deleted..."
536:           End If
537:         Else
538:           MsgBox "Unable to delete '" & strFilename & "'..." & vbCrLf & _
            "Please delete this file manually before attempting to create a new raster with this name."
540:           txtOutput.SetFocus
          Exit Sub
542:         End If
543:       Else
544:         txtOutput.SetFocus
        Exit Sub
546:       End If
547:       txtOutput.SetFocus
      Exit Sub
549:     End If
550:   Else
551:     If TopoCorridor.aml_func_mod.ExistFileDir(strFullPath) Then
552:       lngVBResult = MsgBox("File '" & strFilename & "' Already exists!" & vbCrLf & _
             "Would you like this tool to attempt to delete the existing file?", vbYesNo, _
             "File Exists:")
555:       If lngVBResult = vbYes Then
556:         Set pRastWS = pWS
557:         Set pDataset = pRastWS.OpenRasterDataset(strFilename)
558:         If pDataset.CanDelete Then
559:           pDataset.DELETE
560:           If Not TopoCorridor.aml_func_mod.ExistFileDir(strFullPath) Then
561:             MsgBox "File Deleted..."
562:           End If
563:         Else
564:           MsgBox "Unable to delete '" & strFilename & "'..." & vbCrLf & _
            "Please delete this file manually before attempting to create a new raster with this name."
566:           txtOutput.SetFocus
          Exit Sub
568:         End If
569:       Else
570:         txtOutput.SetFocus
        Exit Sub
572:       End If
573:       txtOutput.SetFocus
      Exit Sub
575:     End If
576:   End If
    
578:   m_pThisExt.OutputFormat = cbxFormat.ListIndex
579:   m_pThisExt.DirectoryPath = strWS
580:   m_pThisExt.ShouldContinue = True

  Dim pSaveArray As esriSystem.IVariantArray
583:   Set pSaveArray = New esriSystem.VarArray
584:   For lngIndex = 0 To m_pReturnArray.Count - 1
585:     pSaveArray.Add m_pReturnArray.Element(lngIndex)
586:   Next lngIndex
587:   Set m_pThisExt.frmInvertReturn = pSaveArray
  
589:   Unload Me
      
'  Me.Visible = False

593:   Set pRasterBand = Nothing
594:   Set pWS = Nothing
595:   Set pWS2 = Nothing
596:   Set pRastWS = Nothing
597:   Set pRastWsEx = Nothing
598:   Set pWsFact = Nothing
599:   Set pDataset = Nothing
600:   Set pSaveArray = Nothing
 
  Exit Sub
ErrorHandler:
  HandleError True, "cmdOK_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub Form_Load()
  On Error GoTo ErrorHandler
 
610:   SetWindowPos Me.hWnd, -1, 0, 0, 0, 0, &H1 Or &H2
611:   Me.Left = (Screen.Width / 2) - (Me.Width / 2)
612:   Me.Top = (Screen.Height / 3) - (Me.Height / 3)
  Dim lngTopBar As Long
614:   lngTopBar = Me.Height - Me.ScaleHeight
615:   Me.Height = cmdOK.Top + cmdOK.Height + lngTopBar
 
617:    Set Anchors = New AnchorObjectList  ' Create new instance
618:    With Anchors
619:       With .Item(cbxFormat)
620:          .SetAnchors enumSizeEnd, enumSizeEnd
621:       End With
622:       With .Item(cbxLayers)
623:          .SetAnchors enumStartEnd, enumSizeEnd
624:       End With
625:       With .Item(cmdCancel)
626:          .SetAnchors enumSizeEnd, enumSizeEnd
627:       End With
628:       With .Item(cmdGetWorkspace)
629:          .SetAnchors enumSizeEnd, enumSizeEnd
630:       End With
631:       With .Item(cmdManual)
632:          .SetAnchors enumSizeEnd, enumSizeEnd
633:       End With
634:       With .Item(cmdOK)
635:          .SetAnchors enumSizeEnd, enumSizeEnd
636:       End With
637:       With .Item(imgBackTop)
638:          .SetAnchors enumStartEnd, enumStartEnd
639:       End With
640:       With .Item(imgCornerBars)
641:          .SetAnchors enumSizeEnd, enumSizeEnd
642:       End With
643:       With .Item(imgParamsBack)
644:          .SetAnchors enumStartEnd, enumSizeEnd
645:       End With
646:       With .Item(lblFormat)
647:          .SetAnchors enumSizeEnd, enumSizeEnd
648:       End With
649:       With .Item(lblLayer)
650:          .SetAnchors enumStartSize, enumSizeEnd
651:       End With
652:       With .Item(chkAdd)
653:          .SetAnchors enumStartSize, enumSizeEnd
654:       End With
655:       With .Item(txtAdd)
656:          .SetAnchors enumStartEnd, enumSizeEnd
657:       End With
658:       With .Item(lblAdd)
659:          .SetAnchors enumSizeEnd, enumSizeEnd
660:       End With
661:       With .Item(lblOutputName)
662:          .SetAnchors enumStartSize, enumSizeEnd
663:       End With
664:       With .Item(txtMessage)
665:          .SetAnchors enumStartEnd, enumStartEnd
666:       End With
667:       With .Item(txtOutput)
668:          .SetAnchors enumStartEnd, enumSizeEnd
669:       End With
670:       .Form = Me  ' Set form reference (suggested to be last step)
671:    End With

673:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub Form_Unload(Cancel As Integer)
  On Error GoTo ErrorHandler
 
683:   Set m_pMxDoc = Nothing
684:   Set m_pApp = Nothing
685:   Set Anchors = Nothing
686:   Set m_pLayerArray = Nothing
687:   Set m_pLayerFields = Nothing
688:   Set m_pThisExt = Nothing
689:   Set m_pReturnArray = Nothing
690:   Set m_pSaveFormats = Nothing
691:   Set m_pFileExtensions = Nothing
692:   Set m_pLayerNames = Nothing
  
  Exit Sub
ErrorHandler:
  HandleError True, "Form_Unload " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cbxLayers_Click()
  On Error GoTo ErrorHandler

702:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "cbxLayers_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub ExtraCodeRequired()
 
  '' PUT IN EXTENSION CLASS
  '
  'Private m_booShouldContinue As Boolean
  'Private m_strDirPath As String
  'Private m_pfrmInvertRasterReturn As esriSystem.IVariantArray
  'Private m_strDirType As String
  'Private m_booIsFeatDataset As Boolean
  'Private m_strFeatDatasetName As String
  '
  '' PUT IN EXTENSION SHUTDOWN EVENT
  ' Set m_pfrmInvertRasterReturn = Nothing
  '
  '' SET FOLLOWING PROPERTIES
  'Public Property Let FeatDatasetName(strFeatDatasetName As String)
  '  m_strFeatDatasetName = strFeatDatasetName
  'End Property
  'Public Property Get FeatDatasetName() As String
  '  FeatDatasetName = m_strFeatDatasetName
  'End Property
  'Public Property Let IsFeatureDataset(booIsFeatDataset As Boolean)
  '  m_booIsFeatDataset = booIsFeatDataset
  'End Property
  'Public Property Get IsFeatureDataset() As Boolean
  '  IsFeatureDataset = m_booIsFeatDataset
  'End Property
  'Public Property Let DirectoryType(strDirType As String)
  '  m_strDirType = strDirType
  'End Property
  'Public Property Get DirectoryType() As String
  '  DirectoryType = m_strDirType
  'End Property
  '
  'Public Property Set frmInvertRasterReturn(pfrmInvertRasterReturn As esriSystem.IVariantArray)
  '  Set m_pfrmInvertRasterReturn = pfrmInvertRasterReturn
  'End Property
  '
  'Public Property Get frmInvertRasterReturn() As esriSystem.IVariantArray
  '  Set frmInvertRasterReturn = m_pfrmInvertRasterReturn
  'End Property
  '
  'Public Property Let DirectoryPath(strPath As String)
  '  On Error GoTo ErrorHandler
  '  m_strDirPath = strPath
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "DirectoryPath " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  'Public Property Get DirectoryPath() As String
  '  On Error GoTo ErrorHandler
  '  DirectoryPath = m_strDirPath
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "DirectoryPath " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  'Public Property Let ShouldContinue(booShouldContinue As Boolean)
  '  On Error GoTo ErrorHandler
  '  m_booShouldContinue = booShouldContinue
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "ShouldContinue " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  'Public Property Get ShouldContinue() As Boolean
  '  On Error GoTo ErrorHandler
  '  ShouldContinue = m_booShouldContinue
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "ShouldContinue " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  '' PUT IN EXTENSION STARTUP EVENT
  '  If m_strDirPath = "" Or m_strDirType = "" Then
  '    m_strDirType = "Shapefile"
  '    m_strDirPath = ""
  '    m_booIsFeatDataset = False
  '    m_strFeatDatasetName = ""
  '  End If
  '
  '===============================================================================================================
  '
' ' SAMPLE CODE
'    Dim pVarArray As esriSystem.IVariantArray
'    Set pVarArray = New VarArray
'
'    ' ADD APPLICATION
'    pVarArray.Add m_pApp
'
'    ' ADD DESIRED LAYER TYPES
'    Dim pLayerTypes As JenLayerTypes
'    pLayerTypes = ENUM_jenRasterLayers
'    pVarArray.Add pLayerTypes
'
'    'EXTENSION SHOULD HAVE PROPERTIES FOR "ShouldContinue", "DirectoryPath", "frmInvertRasterReturn",
'    '     "DirectoryType", "IsFeatureDataset", "FeatDatasetName"
'    pVarArray.Add m_pThisExt
'
'    ' ADD DESIRED FIELD TYPES
'    pVarArray.Add 0
'
'    ' ADD WHETHER TO INCLUDE ID FIELD
'    pVarArray.Add (False)
'
'    ' ADD WHETHER ANY OUTPUT WILL BE A FEATURE CLASS (TRUE) OR TABLE (FALSE)         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    Dim booOutputIsFClass As Boolean                                                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    booOutputIsFClass = True                                                         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    pVarArray.Add (booOutputIsFClass)                                                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'
'    Dim pForm As TopoCorridor.frmInvertRaster
'    Set pForm = New TopoCorridor.frmInvertRaster
'    Set pForm.ArcApplication = pVarArray
'    pForm.Show vbModal
'    Set pForm = Nothing
'
'    If m_pThisExt.ShouldContinue = False Then
'      MsgBox "Function Canceled:" & vbCrLf & "Bailing out..."
'      Exit Sub
'    End If
'
'    Dim pReturnArray As esrisystem.IVariantArray
'    Set pReturnArray = m_pThisExt.frmInvertRasterReturn
 
'    ' OUTPUT
'    ' SELECTED TABLE OR LAYER
'    Dim pUnknown As IUnknown
'    Set pUnknown = pReturnArray.Element(0)
'
'    ' FOR DEBUGGING
'    Dim strReport As String
'    strReport = "Selected Items:" & vbNewLine
'
'    If TypeOf pUnknown Is ILayer Then
'      Dim pLayer As ILayer
'      Set pLayer = pUnknown
'      strReport = strReport & "Name:  " & pLayer.Name & vbNewLine
'    ElseIf TypeOf pUnknown Is IStandaloneTable Then
'      Dim pStTab As IStandaloneTable
'      Set pStTab = pUnknown
'      strReport = strReport & "Name:  " & pStTab.Name & vbNewLine
'    End If
'


'  ' CODE SNIPPET TO USE pFieldNamePairs TO TRANSFER ATTRIBUTE DATA FROM OLD SOURCE TO NEW SOURCE
'  ' MAKE IVariantArray OF FIELD NAME INDICES
'  ' STRUCTURE:  ARRAY OF 4-ITEM VARIANT ARRAYS
'  '             ITEMS = 0) ORIGINAL FCLASS FIELD NAME
'  '                     1) ORIGINAL FCLASS FIELD INDEX
'  '                     2) NEW FCLASS FIELD NAME
'  '                     3) NEW FCLASS FIELD INDEX
'  Dim pFieldNamePairs As esriSystem.IVariantArray
'  Set pFieldNamePairs = pOutputArray.Element(9)
'  Dim pFieldNameData As esriSystem.IVariantArray
'  Set pFieldNameData = TopoCorridor.MyGeneralOperations.MakeFieldNameVarArray(pFeatureClass, pNewFClass, pFieldNamePairs, True)
'  Dim lngFieldIndex As Long
'  Dim pFieldSubArray As esriSystem.IVariantArray
'  ' ROTATE THROUGH ALL FEATURES / ROWS
'    ' TRANSFER ATTRIBUTE DATA; ASSUMES pBuffer ALREADY EXISTS
'    For lngFieldIndex = 0 To pFieldNameData.Count - 1
'      Set pFieldSubArray = pFieldNameData.Element(lngFieldIndex)
'      pBuffer.Value(pFieldSubArray.Element(3)) = pFeature.Value(pFieldSubArray.Element(1))
'    Next lngFieldIndex
'  ' LOOP

''  ' SAMPLE SNIPPET FOR FEATURE LAYERS:  ROTATE THROUGH ALL OR SELECTED RECORDS
''  Dim pFeatureLayer As IFeatureLayer
''  Dim pFClass As IFeatureClass
''  Dim pFeatSel As IFeatureSelection
''  Dim pSelSet As ISelectionSet
''  Dim pCursor As IFeatureCursor
''  Dim lngCount As Long
''
''  Set pFClass = pFeatureLayer.FeatureClass
''  Set pFeatSel = pFeatureLayer
''  Set pSelSet = pFeatSel.SelectionSet
''
''  If pSelSet.Count = 0 Then
''    Set pCursor = pFClass.Search(Nothing, False)
''    lngCount = pFClass.FeatureCount(Nothing)
''  Else
''    If booDoAll = True Then
''      Set pCursor = pFClass.Search(Nothing, False)
''      lngCount = pFClass.FeatureCount(Nothing)
''    Else
''      pSelSet.Search Nothing, True, pCursor
''      lngCount = pSelSet.Count
''    End If
''  End If
''
''  Dim pFeature As IFeature
''  Set pFeature = pCursor.NextFeature
''  Do Until pFeature Is Nothing
''    ' DO ACTIONS
''    Set pFeature = pCursor.NextFeature
''  Loop
''
''  ' SAMPLE CODE SNIPPET:  ADD RECORDS TO FEATURE CLASS USING BUFFER
''  Dim pBuffer As IFeatureBuffer
''  Set pBuffer = pFClass.CreateFeatureBuffer
''  Dim pNewFeatureCursor As IFeatureCursor
''  Set pNewFeatureCursor = pFClass.Insert(True)
''  ' LOOP THROUGH WHATEVER STEPS ARE REQUIRED TO GATHER DATA FOR A SINGLE ROW
''    Set pBuffer.Shape = aGeometry
''    pBuffer.Value(lngFieldIndex) = aValue
''    pNewFeatureCursor.InsertFeature pBuffer
''  ' LOOP
''  pNewFeatureCursor.Flush

''  ' SAMPLE SNIPPET FOR TABLES:  ROTATE THROUGH ALL OR SELECTED RECORDS
''  Dim pStandaloneTable As IStandaloneTable
''  Dim pInputTable As ITable
''  Dim pTableSel As ITableSelection
''  Dim pSelSet As ISelectionSet
''  Dim pRowCursor As ICursor
''  Dim lngCount As Long
''
''  Set pInputTable = pStandaloneTable.Table
''  Set pTableSel = pStandaloneTable
''  Set pSelSet = pTableSel.SelectionSet
''
''  If pSelSet.Count = 0 Then
''    Set pRowCursor = pInputTable.Search(Nothing, False)
''    lngCount = pInputTable.FeatureCount(Nothing)
''  Else
''    If booDoAll = True Then
''      Set pRowCursor = pInputTable.Search(Nothing, False)
''      lngCount = pInputTable.FeatureCount(Nothing)
''    Else
''      pSelSet.Search Nothing, True, pRowCursor
''      lngCount = pSelSet.Count
''    End If
''  End If
''
''  Dim pRow As IRow
''  Set pRow = pRowCursor.NextRow
''  Do Until pRow Is Nothing
'''     DO ACTIONS
''    Set pRow = pRowCursor.NextFeature
''  Loop
 
''  ' SAMPLE CODE SNIPPET:  ADD RECORDS TO TABLE USING BUFFER
''  Dim pBuffer As IRowBuffer
''  Set pBuffer = pTable.CreateRowBuffer
''  Dim pTableCursor As ICursor
''  Set pTableCursor = pTable.Insert(True)
''  ' LOOP THROUGH WHATEVER STEPS ARE REQUIRED TO GATHER DATA FOR A SINGLE ROW
''    pBuffer.Value(lngFieldIndex) = aValue
''    pTableCursor.InsertRow pBuffer
''  ' LOOP
''  pTableCursor.Flush
'    MsgBox strReport, vbOKOnly, "Test of LayerID Form:"
'
'  Dim pDocDirty As IDocumentDirty
'  Set pDocDirty = m_pMxDoc
'  pDocDirty.SetDirty
'

End Sub
 

Private Sub txtAdd_Change()
973:   CheckEnable
End Sub

Private Sub txtAdd_KeyPress(KeyAscii As Integer)

978:   TopoCorridor.MyGeneralOperations.CheckNumericRealPositive KeyAscii, txtAdd
End Sub

Private Sub txtOutput_Change()
982:   CheckEnable
End Sub
