VERSION 5.00
Begin VB.Form frmPointOutputOptions 
   Caption         =   " Output Options [Step 3 of 3]:"
   ClientHeight    =   4125
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6915
   Icon            =   "frmPointOutputOptions.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   4125
   ScaleWidth      =   6915
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdNote 
      Caption         =   "Note on Field Name Restrictions"
      Height          =   315
      Left            =   4170
      TabIndex        =   16
      Top             =   3255
      Width           =   2625
   End
   Begin VB.TextBox txtFieldName 
      Height          =   315
      Left            =   2370
      TabIndex        =   15
      Text            =   "txtFieldName"
      Top             =   3255
      Width           =   1695
   End
   Begin VB.OptionButton optNewField 
      Caption         =   "Create New Field in Point Layer"
      Height          =   270
      Left            =   240
      TabIndex        =   13
      Top             =   2925
      Width           =   2715
   End
   Begin VB.ComboBox cbxExistingFields 
      Height          =   315
      Left            =   2745
      Style           =   2  'Dropdown List
      TabIndex        =   11
      Top             =   2355
      Width           =   2400
   End
   Begin VB.OptionButton optAddToExisting 
      Caption         =   "Add Data to Existing Field"
      Height          =   270
      Left            =   240
      TabIndex        =   10
      Top             =   2085
      Width           =   2370
   End
   Begin VB.ComboBox cbxIDFields 
      Height          =   315
      Left            =   2760
      Style           =   2  'Dropdown List
      TabIndex        =   8
      Top             =   840
      Width           =   2400
   End
   Begin VB.OptionButton optNewTable 
      Caption         =   "Create New Table"
      Height          =   270
      Left            =   240
      TabIndex        =   6
      Top             =   540
      Width           =   2370
   End
   Begin VB.CommandButton cmdBack 
      Caption         =   "<-- Back"
      Height          =   345
      Left            =   1290
      TabIndex        =   5
      Top             =   3780
      Width           =   1065
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   345
      Left            =   2385
      TabIndex        =   2
      Top             =   3780
      Width           =   1065
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   345
      Left            =   4560
      TabIndex        =   4
      Top             =   3780
      Width           =   1065
   End
   Begin VB.CommandButton cmdManual 
      Caption         =   "Manual"
      Height          =   345
      Left            =   3480
      TabIndex        =   3
      Top             =   3780
      Width           =   1065
   End
   Begin VB.TextBox txtNewTable 
      Height          =   330
      Left            =   600
      TabIndex        =   0
      Text            =   "txtNewTable"
      Top             =   1470
      Width           =   5685
   End
   Begin VB.CommandButton cmdNewTable 
      Height          =   360
      Left            =   6360
      Picture         =   "frmPointOutputOptions.frx":058A
      Style           =   1  'Graphical
      TabIndex        =   1
      ToolTipText     =   "Browse for Output Table..."
      Top             =   1455
      Width           =   465
   End
   Begin VB.Label lblPointName 
      AutoSize        =   -1  'True
      Caption         =   "Point Layer = "
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   9
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00004000&
      Height          =   225
      Left            =   75
      TabIndex        =   17
      Top             =   60
      Width           =   1155
   End
   Begin VB.Label lblNewFieldName 
      AutoSize        =   -1  'True
      Caption         =   "Enter New Field Name:"
      Height          =   195
      Left            =   615
      TabIndex        =   14
      Top             =   3300
      Width           =   1635
   End
   Begin VB.Label lblExistingFields 
      AutoSize        =   -1  'True
      Caption         =   "Mahalanobis Distance Field ="
      Height          =   195
      Left            =   615
      TabIndex        =   12
      Top             =   2430
      Width           =   2085
   End
   Begin VB.Label lblIDField 
      AutoSize        =   -1  'True
      Caption         =   "Point Layer Unique ID Field ="
      Height          =   195
      Left            =   615
      TabIndex        =   9
      Top             =   915
      Width           =   2070
   End
   Begin VB.Label lblTableLocation 
      AutoSize        =   -1  'True
      Caption         =   "New Mahalanobis Distances Table Location:"
      Height          =   195
      Left            =   615
      TabIndex        =   7
      Top             =   1245
      Width           =   3180
   End
   Begin VB.Image imgCornerBars 
      Height          =   225
      Left            =   6690
      Picture         =   "frmPointOutputOptions.frx":0600
      Top             =   3900
      Width           =   225
   End
   Begin VB.Image imgBack 
      BorderStyle     =   1  'Fixed Single
      Height          =   3375
      Left            =   0
      Top             =   345
      Width           =   6915
   End
End
Attribute VB_Name = "frmPointOutputOptions"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Anchors As AnchorObjectList  ' Main anchor control objec
Private m_pMxDoc As esriArcMapUI.IMxDocument
Private m_pApp As IApplication
Private m_pThisExt As TopoCorridor.clsExtension
Private m_strTableBasename As String
Private m_strTableDirName As String
Private m_strTableFullText As String
Private m_pTableWStype As JenDatasetTypes
Private m_pFeatureLayer As IFeatureLayer
Private m_booRefillListboxes As Boolean
Private m_pNumericFields As esriSystem.IVariantArray
Private m_pIDFields As esriSystem.IVariantArray

Const m_booOutputIsFClass As Boolean = False     ' HARD-CODED TO FALSE BECAUSE THIS DIALOG ONLY EXPORTS TO TABLES

Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\brost_climate_change\code\frmPointOutputOptions.frm"

Public Property Set PointFeatureLayer(pFeatureLayer As IFeatureLayer)
  On Error GoTo ErrorHandler

  Dim pFields As IFields
  Dim pFClass As IFeatureClass
  
25:   txtFieldName.Text = ""
  
27:   If pFeatureLayer Is Nothing Then
28:     Set m_pFeatureLayer = Nothing
29:     m_booRefillListboxes = False
30:   Else
31:     If m_pFeatureLayer Is Nothing Then
32:       Set m_pFeatureLayer = pFeatureLayer
      
34:       Set pFClass = m_pFeatureLayer.FeatureClass
35:       Set pFields = pFClass.Fields
36:       txtFieldName.Text = TopoCorridor.MyGeneralOperations.ReturnDBASEFieldName("Mahal", pFields)
37:       m_booRefillListboxes = True
38:       Call Form_Activate
39:     Else
40:       If Not m_pFeatureLayer Is pFeatureLayer Then
41:         Set m_pFeatureLayer = pFeatureLayer
42:         m_booRefillListboxes = True
43:         Call Form_Activate
44:       End If
45:     End If
46:   End If
  
48:   Set pFields = Nothing
49:   Set pFClass = Nothing

  Exit Property
ErrorHandler:
  HandleError True, "PointFeatureLayer " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Set ArcApplication(ByVal pParams As esriSystem.IVariantArray)
  On Error GoTo ErrorHandler
  
59:   Set m_pApp = pParams.Element(0)
60:   Set m_pMxDoc = pParams.Element(1)
61:   Set m_pThisExt = pParams.Element(2)
  
  ' DECIDE WHICH OPTION TO PRE-SELECT
  Select Case m_pThisExt.frmMahalOutputChoice
    Case 0
66:       optNewTable.Value = True
67:       optAddToExisting.Value = False
68:       optNewField.Value = False
    Case 1
70:       optNewTable.Value = False
71:       optAddToExisting.Value = True
72:       optNewField.Value = False
    Case 2
74:       optNewTable.Value = False
75:       optAddToExisting.Value = False
76:       optNewField.Value = True
77:   End Select
  
  
  ' FILL OUTPUT FEATURE CLASS SECTION
  Dim strTableName As String
 
  ' WORKSPACE
  ' FIRST SEE IF IT HAS BEEN SAVED TO EXTENSION PROPERTIES.  THIS PROPERTY WILL BE EMPTY THE FIRST TIME THE DIALOG
  '      IS OPENED, BUT EACH TIME THEREAFTER IT WILL HAVE A VALUE.  THIS VALUE ALSO GETS SAVED WITH THE DOCUMENT.
  ' IF NOT IN EXTENSION PROPERTY, THEN CHECK ArcGIS LAST SAVE TO LOCATION
  ' IF THIS DOESN'T WORK, USE MxDoc PATH NAME.
  Dim strDirPath As String
  Dim strUserName As String
  Dim lngDatasetType As JenDatasetTypes
  Dim strDatasetType As String
  Dim booIsFeatDataset As Boolean
  Dim strFeatDatasetName As String
 
95:   strDirPath = m_pThisExt.DirectoryPath
96:   strDatasetType = m_pThisExt.DirectoryType
97:   booIsFeatDataset = m_pThisExt.IsFeatureDataset
98:   strFeatDatasetName = m_pThisExt.FeatDatasetName
  Select Case strDatasetType
    Case "Shapefile", ""
101:       lngDatasetType = ENUM_Shapefile
102:       If m_booOutputIsFClass Then                   ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
103:         strTableName = "M_Distance_Values.shp"                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
104:       Else                                          ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
105:         strTableName = "M_Distance_Values.dbf"                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
106:       End If                                        ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
    Case "File Geodatabase"
108:       lngDatasetType = ENUM_FileGDB
109:       strTableName = "Mahalanobis"
    Case "Personal Geodatabase"
111:       lngDatasetType = ENUM_PersonalGDB
112:       strTableName = "Mahalanobis"
    Case Else
114:       lngDatasetType = 0
115:   End Select

  ' IF TABLE, SET FEATURE DATASET TO FALSE          ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
118:   If Not m_booOutputIsFClass Then                   ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
119:     booIsFeatDataset = False                        ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
120:     strFeatDatasetName = ""                         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
121:   End If                                            ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
 
123:   If (Not TopoCorridor.aml_func_mod.ExistFileDir(strDirPath)) Or (lngDatasetType = 0) Then
124:     strDirPath = TopoCorridor.aml_func_mod.GetFullFileString(TopoCorridor.aml_func_mod.GetMxDocPath(m_pApp))
125:     strDirPath = TopoCorridor.aml_func_mod.ReturnDir(strDirPath)
126:     lngDatasetType = ENUM_Shapefile
127:     booIsFeatDataset = False
128:     strFeatDatasetName = ""
129:   End If

  Dim pWsFact As IWorkspaceFactory2
  Dim pFeatWS As IWorkspace2
  Dim strForTextbox As String
  Dim strWsPathname As String
  Dim strBaseName As String

'  MsgBox "Setting Properties:  #1" & vbCrLf & _
         "(Not TopoCorridor.aml_func_mod.ExistFileDir(strDirPath)) = " & CStr((Not TopoCorridor.aml_func_mod.ExistFileDir(strDirPath))) & vbCrLf & _
         "lngDatasetType = " & CStr(lngDatasetType) & vbCrLf & _
         "strDirPath = " & strDirPath & vbCrLf & _
         "strDatasetType = " & strDatasetType & vbCrLf & _
         "booIsFeatDataset = " & CStr(booIsFeatDataset) & vbCrLf & _
         "strFeatDatasetName = " & strFeatDatasetName & vbCrLf & _
         "strShapeName = " & strShapeName
  
  Dim strDirPathTable As String
  Dim strWsTable As String
  Dim strBaseNameTable As String
  
  Select Case lngDatasetType
    Case ENUM_Shapefile
152:       If Right(strDirPath, 1) <> "\" And Right(strDirPath, 1) <> "/" Then
153:         strDirPath = strDirPath & "\"
154:       End If
155:       If m_booOutputIsFClass Then                                          ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
156:         strDirPathTable = TopoCorridor.MyGeneralOperations.MakeUniqueShapeFilename(strDirPath & strTableName)
157:       Else
158:         strDirPathTable = TopoCorridor.MyGeneralOperations.MakeUniquedBASEName(strDirPath & strTableName)
159:       End If                                                               ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
      
      ' BREAK UP FULL PATH NAMES INTO FILE AND WORKSPACE NAMES
162:       strWsTable = TopoCorridor.aml_func_mod.ReturnDir(strDirPathTable)

164:       If Right(strWsTable, 1) = "\" Then strWsTable = Left(strWsTable, Len(strWsTable) - 1)
      
166:       strBaseNameTable = TopoCorridor.aml_func_mod.ReturnFilename(strDirPathTable)
      
    Case ENUM_FileGDB
169:       If Right(strDirPath, 1) = "\" Or Right(strDirPath, 1) = "/" Then
170:         strDirPath = Left(strDirPath, Len(strDirPath) - 1)
171:       End If
172:       Set pWsFact = New FileGDBWorkspaceFactory
173:       Set pFeatWS = pWsFact.OpenFromFile(strDirPath, Me.hWnd)
174:       If m_booOutputIsFClass Then                                          ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
175:         strTableName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBFeatureClassName(pFeatWS, strTableName)
176:       Else
177:         strTableName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBTableName(pFeatWS, strTableName)
178:       End If                                                               ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
179:       If booIsFeatDataset Then
180:         strDirPathTable = strDirPath & "\" & strFeatDatasetName & "\" & strTableName
181:       Else
182:         strDirPathTable = strDirPath & "\" & strTableName
183:       End If
      
185:       strWsPathname = strDirPath
186:       If Right(strWsPathname, 1) = "\" Then strWsPathname = Left(strWsPathname, Len(strWsPathname) - 1)
      
188:       strWsTable = strWsPathname
189:       strBaseNameTable = strTableName
      
    Case ENUM_PersonalGDB
192:       Set pWsFact = New AccessWorkspaceFactory
193:       Set pFeatWS = pWsFact.OpenFromFile(strDirPath, Me.hWnd)
'      MsgBox "In Select Case:  Before " & vbCrLf & "strShapeName = " & strShapeName & vbCrLf & _
              "Workspace is Nothing = " & CStr(pFeatWS Is Nothing)
196:       If m_booOutputIsFClass Then                                          ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
197:         strTableName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBFeatureClassName(pFeatWS, strTableName)
198:       Else
199:         strTableName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBTableName(pFeatWS, strTableName)
200:       End If                                                                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'      MsgBox "In Select Case:  After " & vbCrLf & "strShapeName = " & strShapeName
202:       If booIsFeatDataset Then
203:         strDirPathTable = strDirPath & "\" & strFeatDatasetName & "\" & strTableName
204:       Else
205:         strDirPathTable = strDirPath & "\" & strTableName
206:       End If
      
208:       strWsPathname = strDirPath
209:       If Right(strWsPathname, 1) = "\" Then strWsPathname = Left(strWsPathname, Len(strWsPathname) - 1)
      
211:       strWsTable = strWsPathname
212:       strBaseNameTable = strTableName
213:   End Select
  
215:   txtNewTable.Text = strDirPathTable
216:   txtNewTable.SelStart = Len(txtNewTable.Text)
  
218:   CheckEnabled
  
  ' SET MODULE VARIABLES
221:   m_strTableBasename = strBaseNameTable
222:   m_strTableDirName = strWsTable
223:   m_strTableFullText = strDirPathTable
224:   m_pTableWStype = lngDatasetType
  
226:   Set pWsFact = Nothing
227:   Set pFeatWS = Nothing
  
 
 Exit Property
ErrorHandler:
  HandleError True, "ArcApplication " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub CheckEnabled()
  On Error GoTo ErrorHandler
  
  Dim booEnableOK As Boolean
239:   booEnableOK = True

241:   If optNewTable.Value = True Then
    
243:     lblNewFieldName.Enabled = False
244:     txtFieldName.Enabled = False
245:     cmdNote.Enabled = False
246:     txtFieldName.BackColor = &H8000000F
    
248:     lblExistingFields.Enabled = False
249:     cbxExistingFields.Enabled = False
250:     cbxExistingFields.BackColor = &H8000000F
    
252:     lblIDField.Enabled = True
253:     cbxIDFields.Enabled = True
254:     lblTableLocation.Enabled = True
255:     txtNewTable.Enabled = True
256:     cmdNewTable.Enabled = True
257:     cbxIDFields.BackColor = &H80000005
258:     txtNewTable.BackColor = &H80000005
    
260:   ElseIf optAddToExisting.Value = True Then
    
262:     lblNewFieldName.Enabled = False
263:     txtFieldName.Enabled = False
264:     cmdNote.Enabled = False
265:     txtFieldName.BackColor = &H8000000F
    
267:     lblExistingFields.Enabled = True
268:     cbxExistingFields.Enabled = True
269:     cbxExistingFields.BackColor = &H80000005
    
271:     lblIDField.Enabled = False
272:     cbxIDFields.Enabled = False
273:     lblTableLocation.Enabled = False
274:     txtNewTable.Enabled = False
275:     cmdNewTable.Enabled = False
276:     cbxIDFields.BackColor = &H8000000F
277:     txtNewTable.BackColor = &H8000000F
    
279:   ElseIf optNewField.Value = True Then
    
281:     lblNewFieldName.Enabled = True
282:     txtFieldName.Enabled = True
283:     cmdNote.Enabled = True
284:     txtFieldName.BackColor = &H80000005
    
286:     lblExistingFields.Enabled = False
287:     cbxExistingFields.Enabled = False
288:     cbxExistingFields.BackColor = &H8000000F
    
290:     lblIDField.Enabled = False
291:     cbxIDFields.Enabled = False
292:     lblTableLocation.Enabled = False
293:     txtNewTable.Enabled = False
294:     cmdNewTable.Enabled = False
295:     cbxIDFields.BackColor = &H8000000F
296:     txtNewTable.BackColor = &H8000000F
    
298:     booEnableOK = txtFieldName <> ""
    
300:   End If
    
  
  
  
305:   cmdOK.Enabled = booEnableOK

  Exit Sub
ErrorHandler:
  HandleError False, "CheckEnabled " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 

Private Sub cbxExistingFields_Change()
  On Error GoTo ErrorHandler

316:   CheckEnabled

  Exit Sub
ErrorHandler:
  HandleError True, "cbxExistingFields_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cbxExistingFields_Click()
  On Error GoTo ErrorHandler

326:   CheckEnabled

  Exit Sub
ErrorHandler:
  HandleError True, "cbxExistingFields_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cbxIDFields_Change()
  On Error GoTo ErrorHandler

336:   CheckEnabled

  Exit Sub
ErrorHandler:
  HandleError True, "cbxIDFields_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cbxIDFields_Click()
  On Error GoTo ErrorHandler

346: CheckEnabled

  Exit Sub
ErrorHandler:
  HandleError True, "cbxIDFields_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdBack_Click()
  On Error GoTo ErrorHandler


357:   m_pThisExt.ShouldContinue = True
358:   m_pThisExt.InputStep = 2
359:   Me.Visible = False
'  Unload Me
  

  Exit Sub
ErrorHandler:
  HandleError True, "cmdBack_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdCancel_Click()
  On Error GoTo ErrorHandler
  
371:   m_pThisExt.ShouldContinue = False
372:   Unload Me
  

  Exit Sub
ErrorHandler:
  HandleError True, "cmdCancel_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub



Private Sub cmdManual_Click()
  On Error GoTo ErrorHandler
  
  ' CHANGE AS APPROPRIATE
  Dim strDir As String
387:   strDir = App.Path
388:   If Right(strDir, 1) <> "\" Then strDir = strDir & "\"
389:   strDir = strDir & "docs"
  
391:   Call TopoCorridor.MyGeneralOperations.OpenDoc("Land_Facet_Tools.pdf", strDir)
  

  Exit Sub
ErrorHandler:
  HandleError True, "cmdManual_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Private Sub cmdNewTable_Click()
  On Error GoTo ErrorHandler


  Dim pGxDialog As IGxDialog
 
  ' SET DEFAULT NAME
  Dim strDefault As String
408:   If m_pTableWStype = ENUM_Shapefile Then
409:     strDefault = TopoCorridor.MyGeneralOperations.MakeUniqueShapeFilename(txtNewTable.Text)
410:   Else
411:     strDefault = txtNewTable.Text
412:   End If

  ' SAMPLE CODE BELOW
  Dim pGxDataset As IGxDataset
  Dim pDataset As IDataset
  Dim pWorkspace As IWorkspace
  Dim pFeatureDataset As IFeatureDataset
  Dim booHasFeatureDataset As Boolean
  Dim strFeatDatasetName As String
  Dim strCategory As String
  Dim strBaseName As String
  Dim strWsPathname As String
  Dim pGxObj As IGxObject
  Dim pGxFCFilter As IGxObjectFilter
  Dim pFilterCol As IGxObjectFilterCollection
  Dim pCategory As JenDatasetTypes
  Dim lngReturn As VbMsgBoxResult
  Dim booValidDataset As Boolean

'  MsgBox "m_strOutputBasename = " & m_strOutputBasename & vbCrLf & _
         "m_strOutputWorkspace = " & m_strOutputWorkspace & vbCrLf & _
         "m_booOutputFeatDataset = " & CStr(m_booOutputFeatDataset) & vbCrLf & _
         "m_strOutputFeatDatasetName = " & m_strOutputFeatDatasetName
         
436:   booValidDataset = False
437:   Do Until booValidDataset = True

    ' FOR SAMPLE; QUERY USER FOR NEW FEATURE CLASS LOCATION
    ' CAN BE A SHAPEFILE, OR IN A FILE / PERSONAL GEODATABASE
441:     Set pGxDialog = New GxDialog
442:     If m_booOutputIsFClass Then                                                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
443:       Set pGxFCFilter = New GxFilterFeatureClasses                             ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
444:     Else                                                                       ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
445:       Set pGxFCFilter = New GxFilterTables                                     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
446:     End If                                                                     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
    
448:     Set pFilterCol = pGxDialog
449:     pFilterCol.AddFilter pGxFCFilter, True
    
451:     With pGxDialog
452:       .AllowMultiSelect = False
453:       .StartingLocation = Replace(strDefault, ":", "\")
454:       If m_booOutputIsFClass Then                                              ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
455:         .Title = "Enter the name of your new Feature Class or Shapefile:"      ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
456:       Else                                                                     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
457:         .Title = "Enter the name of your new Mahalanobis Distances Table:"                           ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
458:       End If                                                                   ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
459:       .Name = m_strTableBasename
460:     End With

462:     If Not pGxDialog.DoModalSave(Me.hWnd) Then
      Exit Sub 'Exit if user press Cancel
464:     End If
    
466:     Set pGxObj = pGxDialog.FinalLocation
467:     strWsPathname = pGxObj.FullName
468:     strBaseName = pGxDialog.Name
469:     booHasFeatureDataset = False
470:     strFeatDatasetName = ""
    
    ' CHECK TO SEE IF WE ARE WRITING TO A FEATURE DATASET
473:     If TypeOf pGxObj Is IGxDataset Then
474:       Set pGxDataset = pGxObj
        
476:       Set pDataset = pGxDataset.Dataset
477:       Set pWorkspace = pDataset.Workspace
478:       strWsPathname = pWorkspace.PathName
      
480:       booHasFeatureDataset = TypeOf pDataset Is IFeatureDataset
481:       If booHasFeatureDataset Then
482:         Set pFeatureDataset = pDataset
483:         strFeatDatasetName = pFeatureDataset.Name
484:       End If
485:     End If
    
    ' BACK OUT OF FEATURE DATASET IF CREATING A TABLE                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
488:     If Not m_booOutputIsFClass Then                                  ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
489:       booHasFeatureDataset = False                                   ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
490:       strFeatDatasetName = ""                                        ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
491:     End If                                                           ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
    
    ' FOR SAMPLE; GET CATEGORY
494:     strCategory = pGxObj.Category
    Select Case strCategory
      Case "Shapefile", "Folder", "dBASE Table"                                                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
497:         pCategory = ENUM_Shapefile
498:         booValidDataset = True
      Case "File Geodatabase Feature Class", "File Geodatabase Raster Catalog", _
           "File Geodatabase", "File Geodatabase Feature Dataset", "File Geodatabase Table"     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
501:         pCategory = ENUM_FileGDB
502:         booValidDataset = True
        ' REMOVE ".SHP" IF PRESENT
504:         If Right(strBaseName, 4) = ".shp" Then strBaseName = Left(strBaseName, Len(strBaseName) - 4)
        ' REPLACE ODD CHARACTERS
506:         strBaseName = TopoCorridor.MyGeneralOperations.ReplaceBadChars(strBaseName, True, True, True, True)
      Case "Personal Geodatabase Feature Class", "Personal Geodatabase Raster Catalog", _
           "Personal Geodatabase", "Personal Geodatabase Feature Dataset", _
           "Personal Geodatabase Table"                                                         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
510:         pCategory = ENUM_PersonalGDB
511:         booValidDataset = True
        ' REMOVE ".SHP" IF PRESENT
513:         If Right(strBaseName, 4) = ".shp" Then strBaseName = Left(strBaseName, Len(strBaseName) - 4)
        ' REPLACE ODD CHARACTERS
515:         strBaseName = TopoCorridor.MyGeneralOperations.ReplaceBadChars(strBaseName, True, True, True, True)
      Case Else
517:         lngReturn = MsgBox("Unexpected Feature Class Type (" & strCategory & ")!" & vbCrLf & _
            "This function will only create shapefiles or feature classes in " & vbCrLf & _
            "File or Personal GeoDatabases.  Please click 'OK' to select a " & vbCrLf & _
            "new Feature Class Name, or 'Cancel' to bail out.", vbOKCancel, "Invalid Feature Class Type:")
521:         If lngReturn = vbOK Then
522:           booValidDataset = False
523:         Else
          Exit Sub
525:         End If
526:     End Select
527:   Loop

529:   m_strTableDirName = strWsPathname
530:   m_strTableBasename = strBaseName
531:   m_pTableWStype = pCategory
532:   m_strTableFullText = strWsPathname & "\" & strBaseName
533:   txtNewTable.Text = m_strTableFullText
534:   txtNewTable.SelStart = Len(txtNewTable.Text)

536:   CheckEnabled
537:   Set pGxDialog = Nothing
538:   Set pGxDataset = Nothing
539:   Set pDataset = Nothing
540:   Set pWorkspace = Nothing
541:   Set pFeatureDataset = Nothing
542:   Set pGxObj = Nothing
543:   Set pGxFCFilter = Nothing
544:   Set pFilterCol = Nothing



  Exit Sub
ErrorHandler:
  HandleError True, "cmdNewTable_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdNote_Click()
  On Error GoTo ErrorHandler

  Dim strMessage As String
557:   strMessage = "Note on Field Names:" & vbCrLf & "--------------------------------------" & vbCrLf & _
      "In order to prevent crashes, this function will only accept field names " & _
      "that conform to dBASE specifications.  Therefore the field name must be <= 10 characters, must " & _
      "begin with a letter, and must not have characters other than letters, numbers or the underscore " & _
      "character." & vbCrLf & vbCrLf & _
      "If you enter a field name that does not conform to these specifications, then the " & _
      "field name will be changed to force it to conform."
  
    ' NEEDS TO HAVE A REFERENCE TO THE APPLICATION
  Dim pParams As esriSystem.IVariantArray
567:   Set pParams = New esriSystem.VarArray

  Dim lngOption As Long
  ' 1 = Yes / No
  ' 2 = OK / Cancel
  ' 3 = Yes / No / Cancel
  ' 4 = OK Only
574:   lngOption = 4

576:   pParams.Add m_pApp
577:   pParams.Add lngOption
578:   pParams.Add " dBASE Field Name Rules:"                                                 ' DIALOG CAPTION
579:   pParams.Add strMessage   ' MESSAGE

  Dim pForm As TopoCorridor.frmMsgBox
582:   Set pForm = New TopoCorridor.frmMsgBox
583:   Set pForm.theParameters = pParams
584:   pForm.Show vbModal

  Dim pExt As IExtension
  Dim pThisExt As TopoCorridor.clsExtension
  Dim newUid As New UID
589:   newUid.Value = "TopoCorridor.clsExtension"
590:   Set pExt = m_pApp.FindExtensionByCLSID(newUid)
591:   Set pThisExt = pExt

  Dim lngResponse As Long
594:   lngResponse = pThisExt.MessageBoxResponse
  ' 0 = Cancel
  ' 1 = Yes / OK
  ' 2 = No

599:   Set pParams = Nothing
600:   Set pForm = Nothing
601:   Set pExt = Nothing
602:   Set pThisExt = Nothing
603:   Set newUid = Nothing

  Exit Sub
ErrorHandler:
  HandleError True, "cmdNote_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdOK_Click()
  On Error GoTo ErrorHandler

  Dim lngOption As Long
614:   If optNewTable.Value = True Then
615:     lngOption = 0
616:   ElseIf optAddToExisting.Value = True Then
617:     lngOption = 1
618:   ElseIf optNewField.Value = True Then
619:     lngOption = 2
620:   End If
  
622:   m_pThisExt.frmMahalOutputChoice = lngOption
  
  Dim pOptions As esriSystem.IVariantArray
625:   Set pOptions = New esriSystem.VarArray
  
627:   pOptions.Add lngOption        ' 0 FOR NEW TABLE, 1 FOR EXISTING FIELD, 2 FOR NEW FIELD
  
  Dim pFields As IFields
  Dim pFClass As IFeatureClass
631:   Set pFClass = m_pFeatureLayer.FeatureClass
632:   Set pFields = pFClass.Fields
  
  Select Case lngOption
    Case 0       ' MAKE NEW TABLE
636:       pOptions.Add m_pIDFields.Element(cbxIDFields.ListIndex)  ' 1] INDEX VALUE FOR ID FIELD TO TRANSFER
637:       pOptions.Add m_strTableDirName                           ' 2] WORKSPACE PATH STRING
638:       pOptions.Add m_strTableBasename                          ' 3] NEW FILE NAME
639:       pOptions.Add m_strTableFullText                          ' 4] FULL PATH, FOR OUTPUT REPORT
640:       pOptions.Add m_pTableWStype                              ' 5] FILE VS. GEODATABASE TABLE
      
    Case 1
643:       pOptions.Add m_pNumericFields.Element(cbxExistingFields.ListIndex)
    
    Case 2
646:       pOptions.Add TopoCorridor.MyGeneralOperations.ReturnDBASEFieldName(txtFieldName.Text, pFields)
    
648:   End Select
  
'  ' SAVE OPTIONS TO EXTENSION PROPERTIES
'  If chkMeans.Value = 1 Then
'    Dim pMeanOptions As esriSystem.IVariantArray
'    Set pMeanOptions = New esriSystem.VarArray
'    pMeanOptions.Add m_strMeansBasename
'    pMeanOptions.Add m_strMeansDirName
'    pMeanOptions.Add m_strMeansFullText
'    pMeanOptions.Add m_pMeansWSType
'
'    m_pThisExt.StatsSaveMeans = True
'    Set m_pThisExt.StatsSaveMeansOptions = pMeanOptions
'  Else
'    m_pThisExt.StatsSaveMeans = False
'    Set m_pThisExt.StatsSaveMeansOptions = Nothing
'  End If
  
666:   Set m_pThisExt.frmMahalOutputOptions = pOptions
  
668:   m_pThisExt.InputStep = 4
669:   m_pThisExt.ShouldContinue = True
  
671:   Set pOptions = Nothing
672:   Set pFields = Nothing
673:   Set pFClass = Nothing

675:   Unload Me

  Exit Sub
ErrorHandler:
  HandleError True, "cmdOK_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Form_Activate()
  On Error GoTo ErrorHandler
  
685:   m_pThisExt.ShouldContinue = False
  
687:   If m_booRefillListboxes Then
    
689:     lblPointName.Caption = "Point Layer = " & m_pFeatureLayer.Name
    
    Dim pFClass As IFeatureClass
692:     Set pFClass = m_pFeatureLayer.FeatureClass
    
694:     Set m_pNumericFields = New esriSystem.VarArray
695:     Set m_pIDFields = New esriSystem.VarArray
    
    Dim pField As IField
    Dim lngIndex As Long
    Dim pTempFields As esriSystem.IVariantArray
700:     Set pTempFields = TopoCorridor.MyGeneralOperations.ReturnFieldsByType(pFClass.Fields, ENUM_FieldNumber)
    
702:     For lngIndex = 0 To pTempFields.Count - 1
703:       Set pField = pTempFields.Element(lngIndex)
704:       If Not pField.Type = esriFieldTypeOID Then
705:         m_pNumericFields.Add pField
706:       End If
707:     Next lngIndex
    
709:     Set pTempFields = TopoCorridor.MyGeneralOperations.ReturnFieldsByType(pFClass.Fields, ENUM_FieldNumber + ENUM_FieldString)
    
711:     For lngIndex = 0 To pTempFields.Count - 1
712:       Set pField = pTempFields.Element(lngIndex)
713:       If Not pField.Type = esriFieldTypeOID Then
714:         m_pIDFields.Add pField
715:       End If
716:     Next lngIndex
    
    
719:     cbxIDFields.Clear
720:     cbxExistingFields.Clear
    
722:     For lngIndex = 0 To m_pNumericFields.Count - 1
723:       Set pField = m_pNumericFields.Element(lngIndex)
724:       cbxExistingFields.AddItem CStr(lngIndex + 1) & ":  [" & pField.Name & "]"
725:     Next lngIndex
    
727:     For lngIndex = 0 To m_pIDFields.Count - 1
728:       Set pField = m_pIDFields.Element(lngIndex)
729:       cbxIDFields.AddItem CStr(lngIndex + 1) & ":  [" & pField.Name & "]"
730:     Next lngIndex
    
732:     cbxIDFields.ListIndex = 0
733:     cbxExistingFields.ListIndex = 0
734:   End If
  
736:   m_booRefillListboxes = False
737:   CheckEnabled
  
739:   Set pFClass = Nothing
740:   Set pField = Nothing
  

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Activate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Form_Load()
  On Error GoTo ErrorHandler

751:   SetWindowPos Me.hWnd, -1, 0, 0, 0, 0, &H1 Or &H2
752:   Me.Left = (Screen.Width / 2) - (Me.Width / 2)
753:   Me.Top = (Screen.Height / 3) - (Me.Height / 3)
  
  Dim lngTopBar As Long
756:   lngTopBar = Me.Height - Me.ScaleHeight
757:   Me.Height = cmdOK.Top + cmdOK.Height + lngTopBar
   
759:    Set Anchors = New AnchorObjectList  ' Create new instance
760:    With Anchors

762:       With .Item(cmdCancel)
763:          .SetAnchors enumSizeEnd, enumSizeEnd
764:       End With
765:       With .Item(cmdNewTable)
766:          .SetAnchors enumSizeEnd, enumStartSize
767:       End With
768:       With .Item(cmdManual)
769:          .SetAnchors enumSizeEnd, enumSizeEnd
770:       End With
771:       With .Item(cmdBack)
772:          .SetAnchors enumSizeEnd, enumSizeEnd
773:       End With
774:       With .Item(cmdOK)
775:          .SetAnchors enumSizeEnd, enumSizeEnd
776:       End With
777:       With .Item(imgBack)
778:          .SetAnchors enumStartEnd, enumStartSize
779:       End With
780:       With .Item(imgCornerBars)
781:          .SetAnchors enumSizeEnd, enumSizeEnd
782:       End With
783:       With .Item(txtNewTable)
784:          .SetAnchors enumStartEnd, enumStartSize
785:       End With
786:       .Form = Me  ' Set form reference (suggested to be last step)
787:    End With


  Exit Sub
ErrorHandler:
  HandleError True, "Form_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Form_Terminate()
  On Error GoTo ErrorHandler

798:   Set Anchors = Nothing
799:   Set m_pMxDoc = Nothing
800:   Set m_pApp = Nothing
801:   Set m_pThisExt = Nothing
802:   Set m_pFeatureLayer = Nothing
803:   Set m_pNumericFields = Nothing
804:   Set m_pIDFields = Nothing

  Exit Sub
  HandleError True, "Form_Terminate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
ErrorHandler:
End Sub

Private Sub Form_Unload(Cancel As Integer)

813:   Set Anchors = Nothing
814:   Set m_pMxDoc = Nothing
815:   Set m_pApp = Nothing
816:   Set m_pThisExt = Nothing
817:   Set m_pFeatureLayer = Nothing
818:   Set m_pNumericFields = Nothing
819:   Set m_pIDFields = Nothing
End Sub

Private Sub optAddToExisting_Click()
  On Error GoTo ErrorHandler

825:   CheckEnabled

  Exit Sub
ErrorHandler:
  HandleError True, "optAddToExisting_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub optNewField_Click()
  On Error GoTo ErrorHandler

835:   CheckEnabled

  Exit Sub
ErrorHandler:
  HandleError True, "optNewField_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub optNewTable_Click()
  On Error GoTo ErrorHandler

845:   CheckEnabled

  Exit Sub
ErrorHandler:
  HandleError True, "optNewTable_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub txtFieldName_Change()
  On Error GoTo ErrorHandler

855:   CheckEnabled

  Exit Sub
ErrorHandler:
  HandleError True, "txtFieldName_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub txtNewTable_Change()
  On Error GoTo ErrorHandler


  Dim strFullPath As String
867:   strFullPath = txtNewTable.Text
  Dim strFile As String
  Dim strDir As String
870:   strFile = TopoCorridor.aml_func_mod.ReturnFilename(strFullPath)
871:   strDir = TopoCorridor.aml_func_mod.ReturnDir(strFullPath)
  
873:   If Right(strDir, 1) = "\" Or Right(strDir, 1) = "/" Then
874:     strDir = Left(strDir, Len(strDir) - 1)
875:   End If
  
877:   m_strTableDirName = strDir
878:   m_strTableBasename = strFile
879:   m_strTableFullText = strFullPath
  
881:   If Right(strDir, 4) = ".gdb" Then       ' IS A FILE GEODATABASE
882:     m_pTableWStype = ENUM_FileGDB
883:   ElseIf Right(strDir, 4) = ".mdb" Then   ' IS A PERSONAL GEODATABASE
884:     m_pTableWStype = ENUM_PersonalGDB
885:   Else                                    ' TREAT AS SHAPEFILE
886:     m_pTableWStype = ENUM_Shapefile
887:     m_strTableBasename = TopoCorridor.aml_func_mod.SetExtension(m_strTableBasename, "dbf")
888:   End If
  

  Exit Sub
ErrorHandler:
  HandleError True, "txtNewTable_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

