VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "richtx32.Ocx"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "ComDlg32.OCX"
Begin VB.Form frmRImport_4 
   Caption         =   " Classify Land Facets, Step 4 of 4:"
   ClientHeight    =   6855
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6135
   Icon            =   "frmRImport_4.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   6855
   ScaleWidth      =   6135
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdLoad 
      Caption         =   "Load"
      Height          =   300
      Left            =   4515
      TabIndex        =   1
      Top             =   5685
      Width           =   615
   End
   Begin RichTextLib.RichTextBox rtbInstructions 
      Height          =   1890
      Left            =   0
      TabIndex        =   9
      Top             =   -15
      Width           =   6120
      _ExtentX        =   10795
      _ExtentY        =   3334
      _Version        =   393217
      ScrollBars      =   2
      TextRTF         =   $"frmRImport_4.frx":058A
   End
   Begin VB.CommandButton cmdManual 
      Caption         =   "Manual"
      Height          =   345
      Left            =   3075
      TabIndex        =   5
      Top             =   6510
      Width           =   1065
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Height          =   345
      Left            =   4155
      TabIndex        =   6
      Top             =   6510
      Width           =   1065
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   345
      Left            =   1995
      TabIndex        =   4
      Top             =   6510
      Width           =   1065
   End
   Begin VB.CommandButton cmdBack 
      Caption         =   "<-- Back"
      Height          =   345
      Left            =   915
      TabIndex        =   3
      Top             =   6510
      Width           =   1065
   End
   Begin VB.TextBox txt2 
      Height          =   300
      Left            =   3375
      TabIndex        =   2
      Text            =   "txt2"
      Top             =   6060
      Width           =   1020
   End
   Begin VB.TextBox txt1 
      Height          =   300
      Left            =   3375
      TabIndex        =   0
      Text            =   "txt1"
      Top             =   5685
      Width           =   1020
   End
   Begin MSComDlg.CommonDialog cdlg 
      Left            =   0
      Top             =   6345
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Image imgParams 
      BorderStyle     =   1  'Fixed Single
      Height          =   870
      Left            =   0
      Top             =   5580
      Width           =   6120
   End
   Begin VB.Image Image2 
      Height          =   2580
      Left            =   105
      Picture         =   "frmRImport_4.frx":0615
      Top             =   1935
      Width           =   5925
   End
   Begin VB.Image Image1 
      Height          =   870
      Left            =   525
      Picture         =   "frmRImport_4.frx":32489
      Top             =   4605
      Width           =   5070
   End
   Begin VB.Image imgCornerBars 
      Height          =   225
      Left            =   5910
      Picture         =   "frmRImport_4.frx":40AFD
      Top             =   6615
      Width           =   225
   End
   Begin VB.Image imgBack 
      BorderStyle     =   1  'Fixed Single
      Height          =   3675
      Left            =   0
      Picture         =   "frmRImport_4.frx":40B56
      Stretch         =   -1  'True
      Top             =   1875
      Width           =   6120
   End
   Begin VB.Label lbl2 
      Alignment       =   1  'Right Justify
      AutoSize        =   -1  'True
      Caption         =   "Confusion Index Threshold ="
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   195
      Left            =   885
      TabIndex        =   8
      Top             =   6120
      Width           =   2445
   End
   Begin VB.Label lblClass1 
      Alignment       =   1  'Right Justify
      AutoSize        =   -1  'True
      Caption         =   "Fuzziness Parameter ="
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   195
      Left            =   1410
      TabIndex        =   7
      Top             =   5745
      Width           =   1920
   End
End
Attribute VB_Name = "frmRImport_4"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
 
Private m_MxDoc As esriArcMapUI.IMxDocument
Private m_pApp As IApplication
Private m_pThisExt As TopoCorridor.clsExtension
Private m_lngResponse As Long
Private Anchors As AnchorObjectList  ' Main anchor control object
Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\brost_climate_change\code\frmRImport_4.frm"
 
Public Property Set ArcApplication(pParams As esriSystem.IVariantArray)
  On Error GoTo ErrorHandler

13:   Set m_pApp = pParams.Element(0)
14:   Set m_MxDoc = pParams.Element(1)
15:   Set m_pThisExt = pParams.Element(2)
  
17:   m_pThisExt.ShouldContinue = False
18:   m_pThisExt.InputStep = 5
  
  Dim dblPhi As Double
  Dim dblThreshold As Double
  
23:   dblPhi = m_pThisExt.frmImportStep4FuzzinessParam
24:   dblThreshold = m_pThisExt.frmImportStep4FuzzinessThreshold
  
26:   If dblPhi <= 0 Then
27:     dblPhi = 1.5
28:     m_pThisExt.frmImportStep4FuzzinessParam = dblPhi
29:   End If
  
31:   If dblThreshold <= 0 Then
32:     dblThreshold = 0.6
33:     m_pThisExt.frmImportStep4FuzzinessThreshold = dblThreshold
34:   End If
  
36:   txt1.Text = CStr(dblPhi)
37:   txt2.Text = CStr(dblThreshold)

  Dim strBaseString As String
40:   strBaseString = strBaseString & "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fswiss\fcharset0 Arial;}{\f1\fnil\fcharset0 Microsoft Sans Serif;}{\f2\fnil\fcharset0 MS Sans Serif;}}" & vbNewLine
41:   strBaseString = strBaseString & "\viewkind4\uc1\pard\b\f0\fs16 Fuzzy C-Means Clustering\b0  (FCM) is a method for separating data into some pre-determined number of relatively homogeneous clusters.  FCM does not simply assign each cell to a cluster, but rather calculates the strength of membership of that cell to all clusters.  Cells are generally assigned to the cluster with the highest cluster membership value." & vbNewLine
42:   strBaseString = strBaseString & "\par " & vbNewLine
43:   strBaseString = strBaseString & "\par \b Fuzziness Parameter:\b0   The fuzziness parameter \f1\fs23\u966?\f0\fs20  \fs16 affects how the algorithm classifies data.  When performing the FCM analysis in R, you must specify a fuzziness parameter.  You \b must\b0  enter that \b same value\b0  here.  If you have saved that parameter value to a text file, you may use the 'Load' button to load the value from the file." & vbNewLine
44:   strBaseString = strBaseString & "\par " & vbNewLine
45:   strBaseString = strBaseString & "\par \b Confusion Index:  \b0 Cells that have relatively equal cluster membership values to more than one cluster are considered to have a weak cluster identification with any particular cluster.  We want to exclude these cells from the analysis because they are poor representatives of the clusters.  Therefore, we use the Confusion Index of the cell to determine whether the cluster membership is strong enough to include the cell in the analysis.  Cells with a confusion index higher than our threshold are excluded from the analysis, and cells with low confusion indices are retained." & vbNewLine
46:   strBaseString = strBaseString & "\par " & vbNewLine
47:   strBaseString = strBaseString & "\par \pard This tool assumes you have already generated your cluster centroids using R or a similar statistical software package.  This tool will use the cluster centroids and statistical output from R to classify the landscape into the cluster categories, and to screen out outliers and cells with high confusion indices.\f2\fs17 " & vbNewLine
48:   strBaseString = strBaseString & "\par }" & vbNewLine
  
50:   rtbInstructions.TextRTF = strBaseString
  
  Exit Property
ErrorHandler:
  HandleError True, "ArcApplication " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Sub CheckEnable()
  On Error GoTo ErrorHandler

60:   cmdOK.Enabled = txt1.Text <> "" And txt2.Text <> ""
  

  Exit Sub
ErrorHandler:
  HandleError True, "CheckEnable " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdBack_Click()
  On Error GoTo ErrorHandler


72:   m_pThisExt.InputStep = 3
73:   m_pThisExt.ShouldContinue = True
74:   Me.Visible = False
  

  Exit Sub
ErrorHandler:
  HandleError True, "cmdBack_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdCancel_Click()
  On Error GoTo ErrorHandler
 

86:   m_pThisExt.InputStep = 5
87:   m_pThisExt.ShouldContinue = False
88:   Set m_pThisExt.frmImportStep3Return = Nothing
  
90:   Unload Me
  Exit Sub
ErrorHandler:
  HandleError True, "cmdCancel_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdLoad_Click()
  On Error GoTo ErrorHandler

  ' SET DEFAULT NAME
  Dim strDefault As String
101:   strDefault = m_pThisExt.frmImportStep2StatsFolder
    
103:   If strDefault = "" Then
104:     strDefault = App.Path
105:   End If
  
107:   cdlg.Filter = "Text File (*.txt)|*.txt"
108:   cdlg.FileName = vbNullString
109:   cdlg.InitDir = strDefault
110:   cdlg.DialogTitle = "Select Fuzziness Parameter file:"
111:   cdlg.ShowOpen
  
  Dim strFilename As String
114:   strFilename = cdlg.FileName
  
  Dim strBaseName As String
  Dim strDir As String
  Dim lngFileNumber As Long
  Dim booFileOK As Boolean
  Dim strLine As String
  Dim lngIndex As Long
  Dim dblVal As Double
  Dim strActualFile As String
  Dim lngLineCounter As Long
  
126:   If strFilename <> "" Then
'    strBaseName = TopoCorridor.aml_func_mod.ReturnFilename(strFileName)
'
'    strDir = TopoCorridor.aml_func_mod.ReturnDir(strFileName)
'    MsgBox "strFilename = " & strFileName & vbCrLf & _
           "strBaseName = " & strBaseName & vbCrLf & _
           "strDir = " & strDir
  '  m_pThisExt.frmImportStep2StatsFolder = strDir
   
135:     lngFileNumber = FreeFile(0)
136:     booFileOK = True
   
138:     Open strFilename For Input As #lngFileNumber
     
140:     Line Input #lngFileNumber, strLine
     
142:     Close #lngFileNumber
    
144:     strLine = Trim(strLine)
145:     If Not IsNumeric(strLine) Then
146:       MsgBox "Invalid Fuzziness Parameter File:" & vbCrLf & vbCrLf & _
             "The Fuzziness Parameter file should have a single line " & vbCrLf & _
             "of data, consisting of a single numeric value." & vbCrLf & vbCrLf & _
             "Please select a different file or enter the value manually.", , "Invalid File:"
150:       txt1.SetFocus
      Exit Sub
152:     End If
    
154:     txt1.Text = strLine
    
156:   End If
  
158:   CheckEnable
  
  Exit Sub
ErrorHandler:
  HandleError True, "cmdLoad_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdManual_Click()
  On Error GoTo ErrorHandler


  
  ' CHANGE AS APPROPRIATE
  Dim strDir As String
172:   strDir = App.Path
173:   If Right(strDir, 1) <> "\" Then strDir = strDir & "\"
174:   strDir = strDir & "docs"
  
176:   Call TopoCorridor.MyGeneralOperations.OpenDoc("Land_Facet_Tools.pdf", strDir)
  
  Exit Sub
ErrorHandler:
  HandleError True, "cmdManual_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdOK_Click()
  On Error GoTo ErrorHandler


  Dim dblPhi As Double
  Dim dblThreshold As Double
  
190:   dblPhi = CDbl(txt1.Text)
191:   dblThreshold = CDbl(txt2.Text)
  
193:   If dblPhi <= 0 Then
194:     MsgBox "Invalid Fuzziness Parameter:" & vbCrLf & vbCrLf & _
          "Value must be > 0...", , "Invalid Parameter:"
    Exit Sub
197:   End If
  
199:   If dblThreshold <= 0 Or dblThreshold > 1 Then
200:     MsgBox "Invalid Confusion Index Threshold:" & vbCrLf & vbCrLf & _
          "Value must be between 0 and 1...", , "Invalid Parameter:"
    Exit Sub
203:   End If
  
205:   m_pThisExt.frmImportStep4FuzzinessParam = dblPhi
206:   m_pThisExt.frmImportStep4FuzzinessThreshold = dblThreshold
207:   m_pThisExt.ShouldContinue = True
208:   m_pThisExt.InputStep = 5
  
210:   Unload Me
  

  Exit Sub
ErrorHandler:
  HandleError True, "cmdOK_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Form_Load()
  On Error GoTo ErrorHandler

221:   SetWindowPos Me.hWnd, -1, 0, 0, 0, 0, &H1 Or &H2
222:   Me.Left = (Screen.Width / 2) - (Me.Width / 2)
223:   Me.Top = (Screen.Height / 2) - (Me.Height / 2)
  Dim lngTopBar As Long
225:   lngTopBar = Me.Height - Me.ScaleHeight
226:   Me.Height = cmdOK.Top + cmdOK.Height + lngTopBar
  
228:    Set Anchors = New AnchorObjectList  ' Create new instance
229:    With Anchors
230:       With .Item(cmdBack)
231:          .SetAnchors enumSizeEnd, enumSizeEnd
232:       End With
233:       With .Item(cmdCancel)
234:          .SetAnchors enumSizeEnd, enumSizeEnd
235:       End With
236:       With .Item(cmdManual)
237:          .SetAnchors enumSizeEnd, enumSizeEnd
238:       End With
239:       With .Item(cmdOK)
240:          .SetAnchors enumSizeEnd, enumSizeEnd
241:       End With
242:       With .Item(cmdLoad)
243:          .SetAnchors enumSizeEnd, enumSizeEnd
244:       End With
245:       With .Item(Image1)
246:          .SetAnchors enumSize, enumSizeEnd
247:       End With
248:       With .Item(Image2)
249:          .SetAnchors enumSize, enumSizeEnd
250:       End With
251:       With .Item(imgBack)
252:          .SetAnchors enumStartEnd, enumSizeEnd
253:       End With
254:       With .Item(imgCornerBars)
255:          .SetAnchors enumSizeEnd, enumSizeEnd
256:       End With
257:       With .Item(imgParams)
258:          .SetAnchors enumStartEnd, enumSizeEnd
259:       End With
260:       With .Item(lbl2)
261:          .SetAnchors enumStartSize, enumSizeEnd
262:       End With
263:       With .Item(lblClass1)
264:          .SetAnchors enumStartSize, enumSizeEnd
265:       End With
266:       With .Item(rtbInstructions)
267:          .SetAnchors enumStartEnd, enumStartEnd
268:       End With
269:       With .Item(txt1)
270:          .SetAnchors enumStartEnd, enumSizeEnd
271:       End With
272:       With .Item(txt2)
273:          .SetAnchors enumStartEnd, enumSizeEnd
274:       End With
275:       .Form = Me  ' Set form reference (suggested to be last step)
276:    End With
 
 
  Exit Sub
ErrorHandler:
  HandleError True, "Form_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub Form_Unload(Cancel As Integer)
  On Error GoTo ErrorHandler
 
287:   Set m_MxDoc = Nothing
288:   Set m_pApp = Nothing
289:   Set m_pThisExt = Nothing
290:   Set Anchors = Nothing
  Exit Sub
ErrorHandler:
  HandleError True, "Form_Unload " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 


Private Sub txt1_Change()
  On Error GoTo ErrorHandler
  
301:   If IsNumeric(txt1.Text) Then
302:     m_pThisExt.frmImportStep4FuzzinessParam = CDbl(txt1.Text)
303:   End If
304:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "txt1_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub txt1_KeyPress(KeyAscii As Integer)
  On Error GoTo ErrorHandler

314:   TopoCorridor.MyGeneralOperations.CheckNumericRealPositive KeyAscii, txt1

  Exit Sub
ErrorHandler:
  HandleError True, "txt1_KeyPress " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub txt2_Change()
  On Error GoTo ErrorHandler

324:   If IsNumeric(txt2.Text) Then
325:     m_pThisExt.frmImportStep4FuzzinessThreshold = CDbl(txt2.Text)
326:   End If
327:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "txt2_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Private Sub txt2_KeyPress(KeyAscii As Integer)
  On Error GoTo ErrorHandler


339:   TopoCorridor.MyGeneralOperations.CheckNumericRealPositive KeyAscii, txt2

  Exit Sub
ErrorHandler:
  HandleError True, "txt2_KeyPress " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
