VERSION 5.00
Begin VB.Form frmSaveTables 
   Caption         =   " Save Statistical Data Options:"
   ClientHeight    =   3615
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6915
   Icon            =   "frmSaveTables.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   3615
   ScaleWidth      =   6915
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   345
      Left            =   1845
      TabIndex        =   12
      Top             =   3270
      Width           =   1065
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   345
      Left            =   4005
      TabIndex        =   14
      Top             =   3270
      Width           =   1065
   End
   Begin VB.CommandButton cmdManual 
      Caption         =   "Manual"
      Height          =   345
      Left            =   2925
      TabIndex        =   13
      Top             =   3270
      Width           =   1065
   End
   Begin VB.CheckBox chkCorrelation 
      Caption         =   "Save Correlation Matrix?"
      Height          =   240
      Left            =   165
      TabIndex        =   9
      Top             =   2475
      Width           =   3150
   End
   Begin VB.TextBox txtCorrelation 
      Height          =   330
      Left            =   495
      TabIndex        =   10
      Text            =   "txtCorrelation"
      Top             =   2730
      Width           =   5640
   End
   Begin VB.CommandButton cmdCorrelation 
      Height          =   360
      Left            =   6210
      Picture         =   "frmSaveTables.frx":058A
      Style           =   1  'Graphical
      TabIndex        =   11
      ToolTipText     =   "Browse for Output Table..."
      Top             =   2715
      Width           =   555
   End
   Begin VB.CheckBox chkInvCov 
      Caption         =   "Save Inverse Covariance Matrix?"
      Height          =   240
      Left            =   165
      TabIndex        =   6
      Top             =   1695
      Width           =   3150
   End
   Begin VB.TextBox txtInvCov 
      Height          =   330
      Left            =   495
      TabIndex        =   7
      Text            =   "txtInvCov"
      Top             =   1950
      Width           =   5640
   End
   Begin VB.CommandButton cmdInvCov 
      Height          =   360
      Left            =   6210
      Picture         =   "frmSaveTables.frx":0600
      Style           =   1  'Graphical
      TabIndex        =   8
      ToolTipText     =   "Browse for Output Table..."
      Top             =   1935
      Width           =   555
   End
   Begin VB.CheckBox chkCov 
      Caption         =   "Save Covariance Matrix?"
      Height          =   240
      Left            =   165
      TabIndex        =   3
      Top             =   915
      Width           =   3150
   End
   Begin VB.TextBox txtCov 
      Height          =   330
      Left            =   495
      TabIndex        =   4
      Text            =   "txtCov"
      Top             =   1170
      Width           =   5640
   End
   Begin VB.CommandButton cmdCov 
      Height          =   360
      Left            =   6210
      Picture         =   "frmSaveTables.frx":0676
      Style           =   1  'Graphical
      TabIndex        =   5
      ToolTipText     =   "Browse for Output Table..."
      Top             =   1155
      Width           =   555
   End
   Begin VB.CheckBox chkMeans 
      Caption         =   "Save Vector of Mean Values?"
      Height          =   240
      Left            =   165
      TabIndex        =   0
      Top             =   135
      Width           =   3150
   End
   Begin VB.TextBox txtMeans 
      Height          =   330
      Left            =   495
      TabIndex        =   1
      Text            =   "txtMeans"
      Top             =   390
      Width           =   5640
   End
   Begin VB.CommandButton cmdMeans 
      Height          =   360
      Left            =   6210
      Picture         =   "frmSaveTables.frx":06EC
      Style           =   1  'Graphical
      TabIndex        =   2
      ToolTipText     =   "Browse for Output Table..."
      Top             =   375
      Width           =   555
   End
   Begin VB.Image imgCornerBars 
      Height          =   225
      Left            =   6690
      Picture         =   "frmSaveTables.frx":0762
      Top             =   3390
      Width           =   225
   End
   Begin VB.Image imgBack 
      BorderStyle     =   1  'Fixed Single
      Height          =   3210
      Left            =   0
      Top             =   0
      Width           =   6915
   End
End
Attribute VB_Name = "frmSaveTables"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Anchors As AnchorObjectList  ' Main anchor control objec
Private m_pMxDoc As esriArcMapUI.IMxDocument
Private m_pApp As IApplication
Private m_pThisExt As TopoCorridor.clsExtension
Private m_strMeansBasename As String
Private m_strMeansDirName As String
Private m_strMeansFullText As String
Private m_pMeansWSType As JenDatasetTypes
Private m_strCovBasename As String
Private m_strCovDirName As String
Private m_strCovFullText As String
Private m_pCovWStype As JenDatasetTypes
Private m_strInvCovBasename As String
Private m_strInvCovDirName As String
Private m_strInvCovFullText As String
Private m_pInvCovWStype As JenDatasetTypes
Private m_strCorrBasename As String
Private m_strCorrDirName As String
Private m_strCorrFullText As String
Private m_pCorrWStype As JenDatasetTypes

Const m_booOutputIsFClass As Boolean = False     ' HARD-CODED TO FALSE BECAUSE THIS DIALOG ONLY EXPORTS TO TABLES

Const c_sModuleFileName As String = "D:\arcGIS_stuff\general_tools\Mahalanobis\Code\frmSaveTables.frm"

Public Property Set ArcApplication(ByVal pParams As esriSystem.IVariantArray)
  On Error GoTo ErrorHandler
  
30:   Set m_pApp = pParams.Element(0)
31:   Set m_pMxDoc = pParams.Element(1)
32:   Set m_pThisExt = pParams.Element(2)

  ' FILL OUTPUT FEATURE CLASS SECTION
  Dim strMeansName As String
  Dim strCovName As String
  Dim strInvCovName As String
  Dim strCorrName As String
 
  ' WORKSPACE
  ' FIRST SEE IF IT HAS BEEN SAVED TO EXTENSION PROPERTIES.  THIS PROPERTY WILL BE EMPTY THE FIRST TIME THE DIALOG
  '      IS OPENED, BUT EACH TIME THEREAFTER IT WILL HAVE A VALUE.  THIS VALUE ALSO GETS SAVED WITH THE DOCUMENT.
  ' IF NOT IN EXTENSION PROPERTY, THEN CHECK ArcGIS LAST SAVE TO LOCATION
  ' IF THIS DOESN'T WORK, USE MxDoc PATH NAME.
  Dim strDirPath As String
  Dim strUserName As String
  Dim lngDatasetType As JenDatasetTypes
  Dim strDatasetType As String
  Dim booIsFeatDataset As Boolean
  Dim strFeatDatasetName As String
 
52:   strDirPath = m_pThisExt.DirectoryPath
53:   strDatasetType = m_pThisExt.DirectoryType
54:   booIsFeatDataset = m_pThisExt.IsFeatureDataset
55:   strFeatDatasetName = m_pThisExt.FeatDatasetName
  Select Case strDatasetType
    Case "Shapefile", ""
58:       lngDatasetType = ENUM_Shapefile
59:       If m_booOutputIsFClass Then                   ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
60:         strMeansName = "Means.shp"                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
61:         strCovName = "Covariance.shp"                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
62:         strInvCovName = "Inv_Covariance.shp"                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
63:         strCorrName = "Correlation.shp"                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
64:       Else                                          ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
65:         strMeansName = "Means.dbf"                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
66:         strCovName = "Covariance.dbf"                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
67:         strInvCovName = "Inv_Covariance.dbf"                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
68:         strCorrName = "Correlation.dbf"                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
69:       End If                                        ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
    Case "File Geodatabase"
71:       lngDatasetType = ENUM_FileGDB
72:       strMeansName = "Means"
73:       strCovName = "Covariance"
74:       strInvCovName = "InvCov"
75:       strCorrName = "Correlation"
    Case "Personal Geodatabase"
77:       lngDatasetType = ENUM_PersonalGDB
78:       strMeansName = "Means"
79:       strCovName = "Covariance"
80:       strInvCovName = "InvCov"
81:       strCorrName = "Correlation"
    Case Else
83:       lngDatasetType = 0
84:   End Select

  ' IF TABLE, SET FEATURE DATASET TO FALSE          ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
87:   If Not m_booOutputIsFClass Then                   ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
88:     booIsFeatDataset = False                        ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
89:     strFeatDatasetName = ""                         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
90:   End If                                            ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
 
92:   If (Not TopoCorridor.aml_func_mod.ExistFileDir(strDirPath)) Or (lngDatasetType = 0) Then
93:     strDirPath = TopoCorridor.aml_func_mod.GetFullFileString(TopoCorridor.aml_func_mod.GetMxDocPath(m_pApp))
94:     strDirPath = TopoCorridor.aml_func_mod.ReturnDir(strDirPath)
95:     lngDatasetType = ENUM_Shapefile
96:     booIsFeatDataset = False
97:     strFeatDatasetName = ""
98:   End If

  Dim pWsFact As IWorkspaceFactory2
  Dim pFeatWS As IWorkspace2
  Dim strForTextbox As String
  Dim strWsPathname As String
  Dim strBaseName As String

'  MsgBox "Setting Properties:  #1" & vbCrLf & _
         "(Not TopoCorridor.aml_func_mod.ExistFileDir(strDirPath)) = " & CStr((Not TopoCorridor.aml_func_mod.ExistFileDir(strDirPath))) & vbCrLf & _
         "lngDatasetType = " & CStr(lngDatasetType) & vbCrLf & _
         "strDirPath = " & strDirPath & vbCrLf & _
         "strDatasetType = " & strDatasetType & vbCrLf & _
         "booIsFeatDataset = " & CStr(booIsFeatDataset) & vbCrLf & _
         "strFeatDatasetName = " & strFeatDatasetName & vbCrLf & _
         "strShapeName = " & strShapeName
  
  Dim strDirPathMeans As String
  Dim strDirPathCov As String
  Dim strDirPathInvCov As String
  Dim strDirPathCorr As String
  Dim strWsMeans As String
  Dim strWsCov As String
  Dim strWsInvCov As String
  Dim strWsCorr As String
  Dim strBaseNameMeans As String
  Dim strBaseNameCov As String
  Dim strBaseNameInvCov As String
  Dim strBaseNameCorr As String
  
  Select Case lngDatasetType
    Case ENUM_Shapefile
130:       If Right(strDirPath, 1) <> "\" And Right(strDirPath, 1) <> "/" Then
131:         strDirPath = strDirPath & "\"
132:       End If
133:       If m_booOutputIsFClass Then                                          ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
134:         strDirPathMeans = TopoCorridor.MyGeneralOperations.MakeUniqueShapeFilename(strDirPath & strMeansName)
135:         strDirPathCov = TopoCorridor.MyGeneralOperations.MakeUniqueShapeFilename(strDirPath & strCovName)
136:         strDirPathInvCov = TopoCorridor.MyGeneralOperations.MakeUniqueShapeFilename(strDirPath & strInvCovName)
137:         strDirPathCorr = TopoCorridor.MyGeneralOperations.MakeUniqueShapeFilename(strDirPath & strCorrName)
138:       Else
139:         strDirPathMeans = TopoCorridor.MyGeneralOperations.MakeUniquedBASEName(strDirPath & strMeansName)
140:         strDirPathCov = TopoCorridor.MyGeneralOperations.MakeUniquedBASEName(strDirPath & strCovName)
141:         strDirPathInvCov = TopoCorridor.MyGeneralOperations.MakeUniquedBASEName(strDirPath & strInvCovName)
142:         strDirPathCorr = TopoCorridor.MyGeneralOperations.MakeUniquedBASEName(strDirPath & strCorrName)
143:       End If                                                               ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
      
      ' BREAK UP FULL PATH NAMES INTO FILE AND WORKSPACE NAMES
146:       strWsMeans = TopoCorridor.aml_func_mod.ReturnDir(strDirPathMeans)
147:       strWsCov = TopoCorridor.aml_func_mod.ReturnDir(strDirPathCov)
148:       strWsInvCov = TopoCorridor.aml_func_mod.ReturnDir(strDirPathInvCov)
149:       strWsCorr = TopoCorridor.aml_func_mod.ReturnDir(strDirPathCorr)

151:       If Right(strWsMeans, 1) = "\" Then strWsMeans = Left(strWsMeans, Len(strWsMeans) - 1)
152:       If Right(strWsCov, 1) = "\" Then strWsCov = Left(strWsCov, Len(strWsCov) - 1)
153:       If Right(strWsInvCov, 1) = "\" Then strWsInvCov = Left(strWsInvCov, Len(strWsInvCov) - 1)
154:       If Right(strWsCorr, 1) = "\" Then strWsCorr = Left(strWsCorr, Len(strWsCorr) - 1)
      
156:       strBaseNameMeans = TopoCorridor.aml_func_mod.ReturnFilename(strDirPathMeans)
157:       strBaseNameCov = TopoCorridor.aml_func_mod.ReturnFilename(strDirPathCov)
158:       strBaseNameInvCov = TopoCorridor.aml_func_mod.ReturnFilename(strDirPathInvCov)
159:       strBaseNameCorr = TopoCorridor.aml_func_mod.ReturnFilename(strDirPathCorr)
      
    Case ENUM_FileGDB
162:       If Right(strDirPath, 1) = "\" Or Right(strDirPath, 1) = "/" Then
163:         strDirPath = Left(strDirPath, Len(strDirPath) - 1)
164:       End If
165:       Set pWsFact = New FileGDBWorkspaceFactory
166:       Set pFeatWS = pWsFact.OpenFromFile(strDirPath, Me.hWnd)
167:       If m_booOutputIsFClass Then                                          ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
168:         strMeansName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBFeatureClassName(pFeatWS, strMeansName)
169:         strCovName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBFeatureClassName(pFeatWS, strCovName)
170:         strInvCovName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBFeatureClassName(pFeatWS, strInvCovName)
171:         strCorrName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBFeatureClassName(pFeatWS, strCorrName)
172:       Else
173:         strMeansName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBTableName(pFeatWS, strMeansName)
174:         strCovName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBTableName(pFeatWS, strCovName)
175:         strInvCovName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBTableName(pFeatWS, strInvCovName)
176:         strCorrName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBTableName(pFeatWS, strCorrName)
177:       End If                                                               ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
178:       If booIsFeatDataset Then
179:         strDirPathMeans = strDirPath & "\" & strFeatDatasetName & "\" & strMeansName
180:         strDirPathCov = strDirPath & "\" & strFeatDatasetName & "\" & strCovName
181:         strDirPathInvCov = strDirPath & "\" & strFeatDatasetName & "\" & strInvCovName
182:         strDirPathCorr = strDirPath & "\" & strFeatDatasetName & "\" & strCorrName
183:       Else
184:         strDirPathMeans = strDirPath & "\" & strMeansName
185:         strDirPathCov = strDirPath & "\" & strCovName
186:         strDirPathInvCov = strDirPath & "\" & strInvCovName
187:         strDirPathCorr = strDirPath & "\" & strCorrName
188:       End If
      
190:       strWsPathname = strDirPath
191:       If Right(strWsPathname, 1) = "\" Then strWsPathname = Left(strWsPathname, Len(strWsPathname) - 1)
      
193:       strWsMeans = strWsPathname
194:       strWsCov = strWsPathname
195:       strWsInvCov = strWsPathname
196:       strWsCorr = strWsPathname
      
198:       strBaseNameMeans = strMeansName
199:       strBaseNameCov = strCovName
200:       strBaseNameInvCov = strInvCovName
201:       strBaseNameCorr = strCorrName
      
    Case ENUM_PersonalGDB
204:       Set pWsFact = New AccessWorkspaceFactory
205:       Set pFeatWS = pWsFact.OpenFromFile(strDirPath, Me.hWnd)
'      MsgBox "In Select Case:  Before " & vbCrLf & "strShapeName = " & strShapeName & vbCrLf & _
              "Workspace is Nothing = " & CStr(pFeatWS Is Nothing)
208:       If m_booOutputIsFClass Then                                          ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
209:         strMeansName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBFeatureClassName(pFeatWS, strMeansName)
210:         strCovName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBFeatureClassName(pFeatWS, strCovName)
211:         strInvCovName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBFeatureClassName(pFeatWS, strInvCovName)
212:         strCorrName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBFeatureClassName(pFeatWS, strCorrName)
213:       Else
214:         strMeansName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBTableName(pFeatWS, strMeansName)
215:         strCovName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBTableName(pFeatWS, strCovName)
216:         strInvCovName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBTableName(pFeatWS, strInvCovName)
217:         strCorrName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBTableName(pFeatWS, strCorrName)
218:       End If                                                                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'      MsgBox "In Select Case:  After " & vbCrLf & "strShapeName = " & strShapeName
220:       If booIsFeatDataset Then
221:         strDirPathMeans = strDirPath & "\" & strFeatDatasetName & "\" & strMeansName
222:         strDirPathCov = strDirPath & "\" & strFeatDatasetName & "\" & strCovName
223:         strDirPathInvCov = strDirPath & "\" & strFeatDatasetName & "\" & strInvCovName
224:         strDirPathCorr = strDirPath & "\" & strFeatDatasetName & "\" & strCorrName
225:       Else
226:         strDirPathMeans = strDirPath & "\" & strMeansName
227:         strDirPathCov = strDirPath & "\" & strCovName
228:         strDirPathInvCov = strDirPath & "\" & strInvCovName
229:         strDirPathCorr = strDirPath & "\" & strCorrName
230:       End If
      
232:       strWsPathname = strDirPath
233:       If Right(strWsPathname, 1) = "\" Then strWsPathname = Left(strWsPathname, Len(strWsPathname) - 1)
      
235:       strWsMeans = strWsPathname
236:       strWsCov = strWsPathname
237:       strWsInvCov = strWsPathname
238:       strWsCorr = strWsPathname
      
240:       strBaseNameMeans = strMeansName
241:       strBaseNameCov = strCovName
242:       strBaseNameInvCov = strInvCovName
243:       strBaseNameCorr = strCorrName
244:   End Select
  
246:   txtMeans.Text = strDirPathMeans
247:   txtCov.Text = strDirPathCov
248:   txtInvCov.Text = strDirPathInvCov
249:   txtCorrelation.Text = strDirPathCorr
250:   txtMeans.SelStart = Len(txtMeans.Text)
251:   txtCov.SelStart = Len(txtCov.Text)
252:   txtInvCov.SelStart = Len(txtInvCov.Text)
253:   txtCorrelation.SelStart = Len(txtCorrelation.Text)
  
  ' SET DIALOG CONTROLS
256:   If m_pThisExt.StatsSaveMeans Then
257:     chkMeans.Value = 1
258:   Else
259:     chkMeans.Value = 0
260:   End If
  
262:   If m_pThisExt.StatsSaveCov Then
263:     chkCov.Value = 1
264:   Else
265:     chkCov.Value = 0
266:   End If
  
268:   If m_pThisExt.StatsSaveInvCov Then
269:     chkInvCov.Value = 1
270:   Else
271:     chkInvCov.Value = 0
272:   End If
  
274:   If m_pThisExt.StatsSaveCorrelation Then
275:     chkCorrelation.Value = 1
276:   Else
277:     chkCorrelation.Value = 0
278:   End If
  
280:   CheckEnabled
  
  ' SET MODULE VARIABLES
283:   m_strMeansBasename = strBaseNameMeans
284:   m_strMeansDirName = strWsMeans
285:   m_strMeansFullText = strDirPathMeans
286:   m_pMeansWSType = lngDatasetType
287:   m_strCovBasename = strBaseNameCov
288:   m_strCovDirName = strWsCov
289:   m_strCovFullText = strDirPathCov
290:   m_pCovWStype = lngDatasetType
291:   m_strInvCovBasename = strBaseNameInvCov
292:   m_strInvCovDirName = strWsInvCov
293:   m_strInvCovFullText = strDirPathInvCov
294:   m_pInvCovWStype = lngDatasetType
295:   m_strCorrBasename = strBaseNameCorr
296:   m_strCorrDirName = strWsCorr
297:   m_strCorrFullText = strDirPathCorr
298:   m_pCorrWStype = lngDatasetType
 
 Exit Property
ErrorHandler:
  HandleError True, "ArcApplication " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub CheckEnabled()
  On Error GoTo ErrorHandler

308:   If chkMeans.Value = 1 Then
309:     txtMeans.Enabled = True
310:     cmdMeans.Enabled = True
311:     txtMeans.BackColor = &H80000005
312:   Else
313:     txtMeans.Enabled = False
314:     cmdMeans.Enabled = False
315:     txtMeans.BackColor = &H8000000F
316:   End If
317:   If chkCov.Value = 1 Then
318:     txtCov.Enabled = True
319:     cmdCov.Enabled = True
320:     txtCov.BackColor = &H80000005
321:   Else
322:     txtCov.Enabled = False
323:     cmdCov.Enabled = False
324:     txtCov.BackColor = &H8000000F
325:   End If
326:   If chkInvCov.Value = 1 Then
327:     txtInvCov.Enabled = True
328:     cmdInvCov.Enabled = True
329:     txtInvCov.BackColor = &H80000005
330:   Else
331:     txtInvCov.Enabled = False
332:     cmdInvCov.Enabled = False
333:     txtInvCov.BackColor = &H8000000F
334:   End If
335:   If chkCorrelation.Value = 1 Then
336:     txtCorrelation.Enabled = True
337:     cmdCorrelation.Enabled = True
338:     txtCorrelation.BackColor = &H80000005
339:   Else
340:     txtCorrelation.Enabled = False
341:     cmdCorrelation.Enabled = False
342:     txtCorrelation.BackColor = &H8000000F
343:   End If


  Exit Sub
ErrorHandler:
  HandleError False, "CheckEnabled " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub chkCorrelation_Click()
  On Error GoTo ErrorHandler

354:   CheckEnabled

  Exit Sub
ErrorHandler:
  HandleError True, "chkCorrelation_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub chkCov_Click()
  On Error GoTo ErrorHandler

364:   CheckEnabled

  Exit Sub
ErrorHandler:
  HandleError True, "chkCov_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub chkInvCov_Click()
  On Error GoTo ErrorHandler

374:   CheckEnabled

  Exit Sub
ErrorHandler:
  HandleError True, "chkInvCov_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub chkMeans_Click()
  On Error GoTo ErrorHandler

384:   CheckEnabled

  Exit Sub
ErrorHandler:
  HandleError True, "chkMeans_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdCancel_Click()
  On Error GoTo ErrorHandler

394:   Unload Me
  

  Exit Sub
ErrorHandler:
  HandleError True, "cmdCancel_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdCorrelation_Click()
  On Error GoTo ErrorHandler

  Dim pGxDialog As IGxDialog
 
  ' SET DEFAULT NAME
  Dim strDefault As String
409:   If m_pCorrWStype = ENUM_Shapefile Then
410:     strDefault = TopoCorridor.MyGeneralOperations.MakeUniqueShapeFilename(txtCorrelation.Text)
411:   Else
412:     strDefault = txtCorrelation.Text
413:   End If

  ' SAMPLE CODE BELOW
  Dim pGxDataset As IGxDataset
  Dim pDataset As IDataset
  Dim pWorkspace As IWorkspace
  Dim pFeatureDataset As IFeatureDataset
  Dim booHasFeatureDataset As Boolean
  Dim strFeatDatasetName As String
  Dim strCategory As String
  Dim strBaseName As String
  Dim strWsPathname As String
  Dim pGxObj As IGxObject
  Dim pGxFCFilter As IGxObjectFilter
  Dim pFilterCol As IGxObjectFilterCollection
  Dim pCategory As JenDatasetTypes
  Dim lngReturn As VbMsgBoxResult
  Dim booValidDataset As Boolean

'  MsgBox "m_strOutputBasename = " & m_strOutputBasename & vbCrLf & _
         "m_strOutputWorkspace = " & m_strOutputWorkspace & vbCrLf & _
         "m_booOutputFeatDataset = " & CStr(m_booOutputFeatDataset) & vbCrLf & _
         "m_strOutputFeatDatasetName = " & m_strOutputFeatDatasetName
         
437:   booValidDataset = False
438:   Do Until booValidDataset = True

    ' FOR SAMPLE; QUERY USER FOR NEW FEATURE CLASS LOCATION
    ' CAN BE A SHAPEFILE, OR IN A FILE / PERSONAL GEODATABASE
442:     Set pGxDialog = New GxDialog
443:     If m_booOutputIsFClass Then                                                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
444:       Set pGxFCFilter = New GxFilterFeatureClasses                             ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
445:     Else                                                                       ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
446:       Set pGxFCFilter = New GxFilterTables                                     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
447:     End If                                                                     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
    
449:     Set pFilterCol = pGxDialog
450:     pFilterCol.AddFilter pGxFCFilter, True
    
452:     With pGxDialog
453:       .AllowMultiSelect = False
454:       .StartingLocation = Replace(strDefault, ":", "\")
455:       If m_booOutputIsFClass Then                                              ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
456:         .Title = "Enter the name of your new Feature Class or Shapefile:"      ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
457:       Else                                                                     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
458:         .Title = "Enter the name of your new Correlation Table:"                           ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
459:       End If                                                                   ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
460:       .Name = m_strCorrBasename
461:     End With

463:     If Not pGxDialog.DoModalSave(Me.hWnd) Then
      Exit Sub 'Exit if user press Cancel
465:     End If
    
467:     Set pGxObj = pGxDialog.FinalLocation
468:     strWsPathname = pGxObj.FullName
469:     strBaseName = pGxDialog.Name
470:     booHasFeatureDataset = False
471:     strFeatDatasetName = ""
    
    ' CHECK TO SEE IF WE ARE WRITING TO A FEATURE DATASET
474:     If TypeOf pGxObj Is IGxDataset Then
475:       Set pGxDataset = pGxObj
        
477:       Set pDataset = pGxDataset.Dataset
478:       Set pWorkspace = pDataset.Workspace
479:       strWsPathname = pWorkspace.PathName
      
481:       booHasFeatureDataset = TypeOf pDataset Is IFeatureDataset
482:       If booHasFeatureDataset Then
483:         Set pFeatureDataset = pDataset
484:         strFeatDatasetName = pFeatureDataset.Name
485:       End If
486:     End If
    
    ' BACK OUT OF FEATURE DATASET IF CREATING A TABLE                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
489:     If Not m_booOutputIsFClass Then                                  ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
490:       booHasFeatureDataset = False                                   ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
491:       strFeatDatasetName = ""                                        ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
492:     End If                                                           ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
    
    ' FOR SAMPLE; GET CATEGORY
495:     strCategory = pGxObj.Category
    Select Case strCategory
      Case "Shapefile", "Folder", "dBASE Table"                                                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
498:         pCategory = ENUM_Shapefile
499:         booValidDataset = True
      Case "File Geodatabase Feature Class", "File Geodatabase Raster Catalog", _
           "File Geodatabase", "File Geodatabase Feature Dataset", "File Geodatabase Table"     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
502:         pCategory = ENUM_FileGDB
503:         booValidDataset = True
        ' REMOVE ".SHP" IF PRESENT
505:         If Right(strBaseName, 4) = ".shp" Then strBaseName = Left(strBaseName, Len(strBaseName) - 4)
        ' REPLACE ODD CHARACTERS
507:         strBaseName = TopoCorridor.MyGeneralOperations.ReplaceBadChars(strBaseName, True, True, True, True)
      Case "Personal Geodatabase Feature Class", "Personal Geodatabase Raster Catalog", _
           "Personal Geodatabase", "Personal Geodatabase Feature Dataset", _
           "Personal Geodatabase Table"                                                         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
511:         pCategory = ENUM_PersonalGDB
512:         booValidDataset = True
        ' REMOVE ".SHP" IF PRESENT
514:         If Right(strBaseName, 4) = ".shp" Then strBaseName = Left(strBaseName, Len(strBaseName) - 4)
        ' REPLACE ODD CHARACTERS
516:         strBaseName = TopoCorridor.MyGeneralOperations.ReplaceBadChars(strBaseName, True, True, True, True)
      Case Else
518:         lngReturn = MsgBox("Unexpected Feature Class Type (" & strCategory & ")!" & vbCrLf & _
            "This function will only create shapefiles or feature classes in " & vbCrLf & _
            "File or Personal GeoDatabases.  Please click 'OK' to select a " & vbCrLf & _
            "new Feature Class Name, or 'Cancel' to bail out.", vbOKCancel, "Invalid Feature Class Type:")
522:         If lngReturn = vbOK Then
523:           booValidDataset = False
524:         Else
          Exit Sub
526:         End If
527:     End Select
528:   Loop

530:   m_strCorrDirName = strWsPathname
531:   m_strCorrBasename = strBaseName
532:   m_pCorrWStype = pCategory
533:   m_strCorrFullText = strWsPathname & "\" & strBaseName
534:   txtCorrelation.Text = m_strCorrFullText
535:   txtCorrelation.SelStart = Len(txtCorrelation.Text)

537:   CheckEnabled

  Exit Sub
ErrorHandler:
  HandleError True, "cmdCorrelation_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdCov_Click()
  On Error GoTo ErrorHandler

  Dim pGxDialog As IGxDialog
 
  ' SET DEFAULT NAME
  Dim strDefault As String
551:   If m_pCovWStype = ENUM_Shapefile Then
552:     strDefault = TopoCorridor.MyGeneralOperations.MakeUniqueShapeFilename(txtCov.Text)
553:   Else
554:     strDefault = txtCov.Text
555:   End If

  ' SAMPLE CODE BELOW
  Dim pGxDataset As IGxDataset
  Dim pDataset As IDataset
  Dim pWorkspace As IWorkspace
  Dim pFeatureDataset As IFeatureDataset
  Dim booHasFeatureDataset As Boolean
  Dim strFeatDatasetName As String
  Dim strCategory As String
  Dim strBaseName As String
  Dim strWsPathname As String
  Dim pGxObj As IGxObject
  Dim pGxFCFilter As IGxObjectFilter
  Dim pFilterCol As IGxObjectFilterCollection
  Dim pCategory As JenDatasetTypes
  Dim lngReturn As VbMsgBoxResult
  Dim booValidDataset As Boolean

'  MsgBox "m_strOutputBasename = " & m_strOutputBasename & vbCrLf & _
         "m_strOutputWorkspace = " & m_strOutputWorkspace & vbCrLf & _
         "m_booOutputFeatDataset = " & CStr(m_booOutputFeatDataset) & vbCrLf & _
         "m_strOutputFeatDatasetName = " & m_strOutputFeatDatasetName
         
579:   booValidDataset = False
580:   Do Until booValidDataset = True

    ' FOR SAMPLE; QUERY USER FOR NEW FEATURE CLASS LOCATION
    ' CAN BE A SHAPEFILE, OR IN A FILE / PERSONAL GEODATABASE
584:     Set pGxDialog = New GxDialog
585:     If m_booOutputIsFClass Then                                                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
586:       Set pGxFCFilter = New GxFilterFeatureClasses                             ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
587:     Else                                                                       ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
588:       Set pGxFCFilter = New GxFilterTables                                     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
589:     End If                                                                     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
    
591:     Set pFilterCol = pGxDialog
592:     pFilterCol.AddFilter pGxFCFilter, True
    
594:     With pGxDialog
595:       .AllowMultiSelect = False
596:       .StartingLocation = Replace(strDefault, ":", "\")
597:       If m_booOutputIsFClass Then                                              ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
598:         .Title = "Enter the name of your new Feature Class or Shapefile:"      ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
599:       Else                                                                     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
600:         .Title = "Enter the name of your new Covariance Table:"                           ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
601:       End If                                                                   ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
602:       .Name = m_strCovBasename
603:     End With

605:     If Not pGxDialog.DoModalSave(Me.hWnd) Then
      Exit Sub 'Exit if user press Cancel
607:     End If
    
609:     Set pGxObj = pGxDialog.FinalLocation
610:     strWsPathname = pGxObj.FullName
611:     strBaseName = pGxDialog.Name
612:     booHasFeatureDataset = False
613:     strFeatDatasetName = ""
    
    ' CHECK TO SEE IF WE ARE WRITING TO A FEATURE DATASET
616:     If TypeOf pGxObj Is IGxDataset Then
617:       Set pGxDataset = pGxObj
        
619:       Set pDataset = pGxDataset.Dataset
620:       Set pWorkspace = pDataset.Workspace
621:       strWsPathname = pWorkspace.PathName
      
623:       booHasFeatureDataset = TypeOf pDataset Is IFeatureDataset
624:       If booHasFeatureDataset Then
625:         Set pFeatureDataset = pDataset
626:         strFeatDatasetName = pFeatureDataset.Name
627:       End If
628:     End If
    
    ' BACK OUT OF FEATURE DATASET IF CREATING A TABLE                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
631:     If Not m_booOutputIsFClass Then                                  ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
632:       booHasFeatureDataset = False                                   ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
633:       strFeatDatasetName = ""                                        ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
634:     End If                                                           ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
    
    ' FOR SAMPLE; GET CATEGORY
637:     strCategory = pGxObj.Category
    Select Case strCategory
      Case "Shapefile", "Folder", "dBASE Table"                                                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
640:         pCategory = ENUM_Shapefile
641:         booValidDataset = True
      Case "File Geodatabase Feature Class", "File Geodatabase Raster Catalog", _
           "File Geodatabase", "File Geodatabase Feature Dataset", "File Geodatabase Table"     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
644:         pCategory = ENUM_FileGDB
645:         booValidDataset = True
        ' REMOVE ".SHP" IF PRESENT
647:         If Right(strBaseName, 4) = ".shp" Then strBaseName = Left(strBaseName, Len(strBaseName) - 4)
        ' REPLACE ODD CHARACTERS
649:         strBaseName = TopoCorridor.MyGeneralOperations.ReplaceBadChars(strBaseName, True, True, True, True)
      Case "Personal Geodatabase Feature Class", "Personal Geodatabase Raster Catalog", _
           "Personal Geodatabase", "Personal Geodatabase Feature Dataset", _
           "Personal Geodatabase Table"                                                         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
653:         pCategory = ENUM_PersonalGDB
654:         booValidDataset = True
        ' REMOVE ".SHP" IF PRESENT
656:         If Right(strBaseName, 4) = ".shp" Then strBaseName = Left(strBaseName, Len(strBaseName) - 4)
        ' REPLACE ODD CHARACTERS
658:         strBaseName = TopoCorridor.MyGeneralOperations.ReplaceBadChars(strBaseName, True, True, True, True)
      Case Else
660:         lngReturn = MsgBox("Unexpected Feature Class Type (" & strCategory & ")!" & vbCrLf & _
            "This function will only create shapefiles or feature classes in " & vbCrLf & _
            "File or Personal GeoDatabases.  Please click 'OK' to select a " & vbCrLf & _
            "new Feature Class Name, or 'Cancel' to bail out.", vbOKCancel, "Invalid Feature Class Type:")
664:         If lngReturn = vbOK Then
665:           booValidDataset = False
666:         Else
          Exit Sub
668:         End If
669:     End Select
670:   Loop

672:   m_strCovDirName = strWsPathname
673:   m_strCovBasename = strBaseName
674:   m_pCovWStype = pCategory
675:   m_strCovFullText = strWsPathname & "\" & strBaseName
676:   txtCov.Text = m_strCovFullText
677:   txtCov.SelStart = Len(txtCov.Text)

679:   CheckEnabled

  Exit Sub
ErrorHandler:
  HandleError True, "cmdCov_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdInvCov_Click()
  On Error GoTo ErrorHandler

  Dim pGxDialog As IGxDialog
 
  ' SET DEFAULT NAME
  Dim strDefault As String
693:   If m_pInvCovWStype = ENUM_Shapefile Then
694:     strDefault = TopoCorridor.MyGeneralOperations.MakeUniqueShapeFilename(txtInvCov.Text)
695:   Else
696:     strDefault = txtInvCov.Text
697:   End If

  ' SAMPLE CODE BELOW
  Dim pGxDataset As IGxDataset
  Dim pDataset As IDataset
  Dim pWorkspace As IWorkspace
  Dim pFeatureDataset As IFeatureDataset
  Dim booHasFeatureDataset As Boolean
  Dim strFeatDatasetName As String
  Dim strCategory As String
  Dim strBaseName As String
  Dim strWsPathname As String
  Dim pGxObj As IGxObject
  Dim pGxFCFilter As IGxObjectFilter
  Dim pFilterCol As IGxObjectFilterCollection
  Dim pCategory As JenDatasetTypes
  Dim lngReturn As VbMsgBoxResult
  Dim booValidDataset As Boolean

'  MsgBox "m_strOutputBasename = " & m_strOutputBasename & vbCrLf & _
         "m_strOutputWorkspace = " & m_strOutputWorkspace & vbCrLf & _
         "m_booOutputFeatDataset = " & CStr(m_booOutputFeatDataset) & vbCrLf & _
         "m_strOutputFeatDatasetName = " & m_strOutputFeatDatasetName
         
721:   booValidDataset = False
722:   Do Until booValidDataset = True

    ' FOR SAMPLE; QUERY USER FOR NEW FEATURE CLASS LOCATION
    ' CAN BE A SHAPEFILE, OR IN A FILE / PERSONAL GEODATABASE
726:     Set pGxDialog = New GxDialog
727:     If m_booOutputIsFClass Then                                                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
728:       Set pGxFCFilter = New GxFilterFeatureClasses                             ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
729:     Else                                                                       ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
730:       Set pGxFCFilter = New GxFilterTables                                     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
731:     End If                                                                     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
    
733:     Set pFilterCol = pGxDialog
734:     pFilterCol.AddFilter pGxFCFilter, True
    
736:     With pGxDialog
737:       .AllowMultiSelect = False
738:       .StartingLocation = Replace(strDefault, ":", "\")
739:       If m_booOutputIsFClass Then                                              ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
740:         .Title = "Enter the name of your new Feature Class or Shapefile:"      ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
741:       Else                                                                     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
742:         .Title = "Enter the name of your new Inverse Covariance Table:"                           ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
743:       End If                                                                   ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
744:       .Name = m_strInvCovBasename
745:     End With

747:     If Not pGxDialog.DoModalSave(Me.hWnd) Then
      Exit Sub 'Exit if user press Cancel
749:     End If
    
751:     Set pGxObj = pGxDialog.FinalLocation
752:     strWsPathname = pGxObj.FullName
753:     strBaseName = pGxDialog.Name
754:     booHasFeatureDataset = False
755:     strFeatDatasetName = ""
    
    ' CHECK TO SEE IF WE ARE WRITING TO A FEATURE DATASET
758:     If TypeOf pGxObj Is IGxDataset Then
759:       Set pGxDataset = pGxObj
        
761:       Set pDataset = pGxDataset.Dataset
762:       Set pWorkspace = pDataset.Workspace
763:       strWsPathname = pWorkspace.PathName
      
765:       booHasFeatureDataset = TypeOf pDataset Is IFeatureDataset
766:       If booHasFeatureDataset Then
767:         Set pFeatureDataset = pDataset
768:         strFeatDatasetName = pFeatureDataset.Name
769:       End If
770:     End If
    
    ' BACK OUT OF FEATURE DATASET IF CREATING A TABLE                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
773:     If Not m_booOutputIsFClass Then                                  ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
774:       booHasFeatureDataset = False                                   ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
775:       strFeatDatasetName = ""                                        ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
776:     End If                                                           ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
    
    ' FOR SAMPLE; GET CATEGORY
779:     strCategory = pGxObj.Category
    Select Case strCategory
      Case "Shapefile", "Folder", "dBASE Table"                                                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
782:         pCategory = ENUM_Shapefile
783:         booValidDataset = True
      Case "File Geodatabase Feature Class", "File Geodatabase Raster Catalog", _
           "File Geodatabase", "File Geodatabase Feature Dataset", "File Geodatabase Table"     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
786:         pCategory = ENUM_FileGDB
787:         booValidDataset = True
        ' REMOVE ".SHP" IF PRESENT
789:         If Right(strBaseName, 4) = ".shp" Then strBaseName = Left(strBaseName, Len(strBaseName) - 4)
        ' REPLACE ODD CHARACTERS
791:         strBaseName = TopoCorridor.MyGeneralOperations.ReplaceBadChars(strBaseName, True, True, True, True)
      Case "Personal Geodatabase Feature Class", "Personal Geodatabase Raster Catalog", _
           "Personal Geodatabase", "Personal Geodatabase Feature Dataset", _
           "Personal Geodatabase Table"                                                         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
795:         pCategory = ENUM_PersonalGDB
796:         booValidDataset = True
        ' REMOVE ".SHP" IF PRESENT
798:         If Right(strBaseName, 4) = ".shp" Then strBaseName = Left(strBaseName, Len(strBaseName) - 4)
        ' REPLACE ODD CHARACTERS
800:         strBaseName = TopoCorridor.MyGeneralOperations.ReplaceBadChars(strBaseName, True, True, True, True)
      Case Else
802:         lngReturn = MsgBox("Unexpected Feature Class Type (" & strCategory & ")!" & vbCrLf & _
            "This function will only create shapefiles or feature classes in " & vbCrLf & _
            "File or Personal GeoDatabases.  Please click 'OK' to select a " & vbCrLf & _
            "new Feature Class Name, or 'Cancel' to bail out.", vbOKCancel, "Invalid Feature Class Type:")
806:         If lngReturn = vbOK Then
807:           booValidDataset = False
808:         Else
          Exit Sub
810:         End If
811:     End Select
812:   Loop

814:   m_strInvCovDirName = strWsPathname
815:   m_strInvCovBasename = strBaseName
816:   m_pInvCovWStype = pCategory
817:   m_strInvCovFullText = strWsPathname & "\" & strBaseName
818:   txtInvCov.Text = m_strInvCovFullText
819:   txtInvCov.SelStart = Len(txtInvCov.Text)

821:   CheckEnabled

  Exit Sub
ErrorHandler:
  HandleError True, "cmdInvCov_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdManual_Click()
  On Error GoTo ErrorHandler

  
  ' CHANGE AS APPROPRIATE
  Dim strDir As String
834:   strDir = App.Path
835:   If Right(strDir, 1) <> "\" Then strDir = strDir & "\"
836:   strDir = strDir & "docs"
  
838:   Call TopoCorridor.MyGeneralOperations.OpenDoc("Land_Facet_Tools.pdf", strDir)
  

  Exit Sub
ErrorHandler:
  HandleError True, "cmdManual_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdMeans_Click()
  On Error GoTo ErrorHandler

 
  Dim pGxDialog As IGxDialog
 
  ' SET DEFAULT NAME
  Dim strDefault As String
854:   If m_pMeansWSType = ENUM_Shapefile Then
855:     strDefault = TopoCorridor.MyGeneralOperations.MakeUniqueShapeFilename(txtMeans.Text)
856:   Else
857:     strDefault = txtMeans.Text
858:   End If

  ' SAMPLE CODE BELOW
  Dim pGxDataset As IGxDataset
  Dim pDataset As IDataset
  Dim pWorkspace As IWorkspace
  Dim pFeatureDataset As IFeatureDataset
  Dim booHasFeatureDataset As Boolean
  Dim strFeatDatasetName As String
  Dim strCategory As String
  Dim strBaseName As String
  Dim strWsPathname As String
  Dim pGxObj As IGxObject
  Dim pGxFCFilter As IGxObjectFilter
  Dim pFilterCol As IGxObjectFilterCollection
  Dim pCategory As JenDatasetTypes
  Dim lngReturn As VbMsgBoxResult
  Dim booValidDataset As Boolean

'  MsgBox "m_strOutputBasename = " & m_strOutputBasename & vbCrLf & _
         "m_strOutputWorkspace = " & m_strOutputWorkspace & vbCrLf & _
         "m_booOutputFeatDataset = " & CStr(m_booOutputFeatDataset) & vbCrLf & _
         "m_strOutputFeatDatasetName = " & m_strOutputFeatDatasetName
         
882:   booValidDataset = False
883:   Do Until booValidDataset = True

    ' FOR SAMPLE; QUERY USER FOR NEW FEATURE CLASS LOCATION
    ' CAN BE A SHAPEFILE, OR IN A FILE / PERSONAL GEODATABASE
887:     Set pGxDialog = New GxDialog
888:     If m_booOutputIsFClass Then                                                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
889:       Set pGxFCFilter = New GxFilterFeatureClasses                             ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
890:     Else                                                                       ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
891:       Set pGxFCFilter = New GxFilterTables                                     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
892:     End If                                                                     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
    
894:     Set pFilterCol = pGxDialog
895:     pFilterCol.AddFilter pGxFCFilter, True
    
897:     With pGxDialog
898:       .AllowMultiSelect = False
899:       .StartingLocation = Replace(strDefault, ":", "\")
900:       If m_booOutputIsFClass Then                                              ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
901:         .Title = "Enter the name of your new Feature Class or Shapefile:"      ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
902:       Else                                                                     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
903:         .Title = "Enter the name of your new Means Table:"                           ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
904:       End If                                                                   ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
905:       .Name = m_strMeansBasename
906:     End With

908:     If Not pGxDialog.DoModalSave(Me.hWnd) Then
      Exit Sub 'Exit if user press Cancel
910:     End If
    
912:     Set pGxObj = pGxDialog.FinalLocation
913:     strWsPathname = pGxObj.FullName
914:     strBaseName = pGxDialog.Name
915:     booHasFeatureDataset = False
916:     strFeatDatasetName = ""
    
    ' CHECK TO SEE IF WE ARE WRITING TO A FEATURE DATASET
919:     If TypeOf pGxObj Is IGxDataset Then
920:       Set pGxDataset = pGxObj
        
922:       Set pDataset = pGxDataset.Dataset
923:       Set pWorkspace = pDataset.Workspace
924:       strWsPathname = pWorkspace.PathName
      
926:       booHasFeatureDataset = TypeOf pDataset Is IFeatureDataset
927:       If booHasFeatureDataset Then
928:         Set pFeatureDataset = pDataset
929:         strFeatDatasetName = pFeatureDataset.Name
930:       End If
931:     End If
    
    ' BACK OUT OF FEATURE DATASET IF CREATING A TABLE                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
934:     If Not m_booOutputIsFClass Then                                  ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
935:       booHasFeatureDataset = False                                   ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
936:       strFeatDatasetName = ""                                        ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
937:     End If                                                           ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
    
    ' FOR SAMPLE; GET CATEGORY
940:     strCategory = pGxObj.Category
    Select Case strCategory
      Case "Shapefile", "Folder", "dBASE Table"                                                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
943:         pCategory = ENUM_Shapefile
944:         booValidDataset = True
      Case "File Geodatabase Feature Class", "File Geodatabase Raster Catalog", _
           "File Geodatabase", "File Geodatabase Feature Dataset", "File Geodatabase Table"     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
947:         pCategory = ENUM_FileGDB
948:         booValidDataset = True
        ' REMOVE ".SHP" IF PRESENT
950:         If Right(strBaseName, 4) = ".shp" Then strBaseName = Left(strBaseName, Len(strBaseName) - 4)
        ' REPLACE ODD CHARACTERS
952:         strBaseName = TopoCorridor.MyGeneralOperations.ReplaceBadChars(strBaseName, True, True, True, True)
      Case "Personal Geodatabase Feature Class", "Personal Geodatabase Raster Catalog", _
           "Personal Geodatabase", "Personal Geodatabase Feature Dataset", _
           "Personal Geodatabase Table"                                                         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
956:         pCategory = ENUM_PersonalGDB
957:         booValidDataset = True
        ' REMOVE ".SHP" IF PRESENT
959:         If Right(strBaseName, 4) = ".shp" Then strBaseName = Left(strBaseName, Len(strBaseName) - 4)
        ' REPLACE ODD CHARACTERS
961:         strBaseName = TopoCorridor.MyGeneralOperations.ReplaceBadChars(strBaseName, True, True, True, True)
      Case Else
963:         lngReturn = MsgBox("Unexpected Feature Class Type (" & strCategory & ")!" & vbCrLf & _
            "This function will only create shapefiles or feature classes in " & vbCrLf & _
            "File or Personal GeoDatabases.  Please click 'OK' to select a " & vbCrLf & _
            "new Feature Class Name, or 'Cancel' to bail out.", vbOKCancel, "Invalid Feature Class Type:")
967:         If lngReturn = vbOK Then
968:           booValidDataset = False
969:         Else
          Exit Sub
971:         End If
972:     End Select
973:   Loop

975:   m_strMeansDirName = strWsPathname
976:   m_strMeansBasename = strBaseName
977:   m_pMeansWSType = pCategory
978:   m_strMeansFullText = strWsPathname & "\" & strBaseName
979:   txtMeans.Text = m_strMeansFullText
980:   txtMeans.SelStart = Len(txtMeans.Text)

982:   CheckEnabled

  Exit Sub
ErrorHandler:
  HandleError True, "cmdMeans_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdOK_Click()
  On Error GoTo ErrorHandler


  ' SAVE OPTIONS TO EXTENSION PROPERTIES
994:   If chkMeans.Value = 1 Then
    Dim pMeanOptions As esriSystem.IVariantArray
996:     Set pMeanOptions = New esriSystem.VarArray
997:     pMeanOptions.Add m_strMeansBasename
998:     pMeanOptions.Add m_strMeansDirName
999:     pMeanOptions.Add m_strMeansFullText
1000:     pMeanOptions.Add m_pMeansWSType
    
1002:     m_pThisExt.StatsSaveMeans = True
1003:     Set m_pThisExt.StatsSaveMeansOptions = pMeanOptions
1004:   Else
1005:     m_pThisExt.StatsSaveMeans = False
1006:     Set m_pThisExt.StatsSaveMeansOptions = Nothing
1007:   End If
  
1009:   If chkCov.Value = 1 Then
    Dim pCovOptions As esriSystem.IVariantArray
1011:     Set pCovOptions = New esriSystem.VarArray
1012:     pCovOptions.Add m_strCovBasename
1013:     pCovOptions.Add m_strCovDirName
1014:     pCovOptions.Add m_strCovFullText
1015:     pCovOptions.Add m_pCovWStype
    
1017:     m_pThisExt.StatsSaveCov = True
1018:     Set m_pThisExt.StatsSaveCovOptions = pCovOptions
1019:   Else
1020:     m_pThisExt.StatsSaveCov = False
1021:     Set m_pThisExt.StatsSaveCovOptions = Nothing
1022:   End If
    
1024:   If chkInvCov.Value = 1 Then
    Dim pInvCovOptions As esriSystem.IVariantArray
1026:     Set pInvCovOptions = New esriSystem.VarArray
1027:     pInvCovOptions.Add m_strInvCovBasename
1028:     pInvCovOptions.Add m_strInvCovDirName
1029:     pInvCovOptions.Add m_strInvCovFullText
1030:     pInvCovOptions.Add m_pInvCovWStype
    
1032:     m_pThisExt.StatsSaveInvCov = True
1033:     Set m_pThisExt.StatsSaveInvCovOptions = pInvCovOptions
1034:   Else
1035:     m_pThisExt.StatsSaveInvCov = False
1036:     Set m_pThisExt.StatsSaveInvCovOptions = Nothing
1037:   End If
    
1039:   If chkCorrelation.Value = 1 Then
    Dim pCorrOptions As esriSystem.IVariantArray
1041:     Set pCorrOptions = New esriSystem.VarArray
1042:     pCorrOptions.Add m_strCorrBasename
1043:     pCorrOptions.Add m_strCorrDirName
1044:     pCorrOptions.Add m_strCorrFullText
1045:     pCorrOptions.Add m_pCorrWStype
    
1047:     m_pThisExt.StatsSaveCorrelation = True
1048:     Set m_pThisExt.StatsSaveCorrelationOptions = pCorrOptions
1049:   Else
1050:     m_pThisExt.StatsSaveCorrelation = False
1051:     Set m_pThisExt.StatsSaveCorrelationOptions = Nothing
1052:   End If

1054:   Unload Me

  Exit Sub
ErrorHandler:
  HandleError True, "cmdOK_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Form_Load()
  On Error GoTo ErrorHandler


1065:   SetWindowPos Me.hWnd, -1, 0, 0, 0, 0, &H1 Or &H2
1066:   Me.Left = (Screen.Width / 2) - (Me.Width / 2)
1067:   Me.Top = (Screen.Height / 3) - (Me.Height / 3)
   
1069:    Set Anchors = New AnchorObjectList  ' Create new instance
1070:    With Anchors
1071:       With .Item(chkCorrelation)
1072:          .SetAnchors enumStartSize, enumStartSize
1073:       End With
1074:       With .Item(chkCov)
1075:          .SetAnchors enumStartSize, enumStartSize
1076:       End With
1077:       With .Item(chkInvCov)
1078:          .SetAnchors enumStartSize, enumStartSize
1079:       End With
1080:       With .Item(chkMeans)
1081:          .SetAnchors enumStartSize, enumStartSize
1082:       End With
1083:       With .Item(cmdCancel)
1084:          .SetAnchors enumSizeEnd, enumSizeEnd
1085:       End With
1086:       With .Item(cmdCorrelation)
1087:          .SetAnchors enumSizeEnd, enumStartSize
1088:       End With
1089:       With .Item(cmdCov)
1090:          .SetAnchors enumSizeEnd, enumStartSize
1091:       End With
1092:       With .Item(cmdInvCov)
1093:          .SetAnchors enumSizeEnd, enumStartSize
1094:       End With
1095:       With .Item(cmdManual)
1096:          .SetAnchors enumSizeEnd, enumSizeEnd
1097:       End With
1098:       With .Item(cmdMeans)
1099:          .SetAnchors enumSizeEnd, enumStartSize
1100:       End With
1101:       With .Item(cmdOK)
1102:          .SetAnchors enumSizeEnd, enumSizeEnd
1103:       End With
1104:       With .Item(imgBack)
1105:          .SetAnchors enumStartEnd, enumStartSize
1106:       End With
1107:       With .Item(imgCornerBars)
1108:          .SetAnchors enumSizeEnd, enumSizeEnd
1109:       End With
1110:       With .Item(txtCorrelation)
1111:          .SetAnchors enumStartEnd, enumStartSize
1112:       End With
1113:       With .Item(txtCov)
1114:          .SetAnchors enumStartEnd, enumStartSize
1115:       End With
1116:       With .Item(txtInvCov)
1117:          .SetAnchors enumStartEnd, enumStartSize
1118:       End With
1119:       With .Item(txtMeans)
1120:          .SetAnchors enumStartEnd, enumStartSize
1121:       End With
1122:       .Form = Me  ' Set form reference (suggested to be last step)
1123:    End With


  Exit Sub
ErrorHandler:
  HandleError True, "Form_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Form_Terminate()
  On Error GoTo ErrorHandler

1134:   Set m_pMxDoc = Nothing
1135:   Set m_pApp = Nothing
1136:   Set m_pThisExt = Nothing

  Exit Sub
  HandleError True, "Form_Terminate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
ErrorHandler:
End Sub

Private Sub txtCorrelation_Change()
  On Error GoTo ErrorHandler


  Dim strFullPath As String
1148:   strFullPath = txtCorrelation.Text
  Dim strFile As String
  Dim strDir As String
1151:   strFile = TopoCorridor.aml_func_mod.ReturnFilename(strFullPath)
1152:   strDir = TopoCorridor.aml_func_mod.ReturnDir(strFullPath)
  
1154:   If Right(strDir, 1) = "\" Or Right(strDir, 1) = "/" Then
1155:     strDir = Left(strDir, Len(strDir) - 1)
1156:   End If
  
1158:   m_strCorrDirName = strDir
1159:   m_strCorrBasename = strFile
1160:   m_strCorrFullText = strFullPath
  
1162:   If Right(strDir, 4) = ".gdb" Then       ' IS A FILE GEODATABASE
1163:     m_pCorrWStype = ENUM_FileGDB
1164:   ElseIf Right(strDir, 4) = ".mdb" Then   ' IS A PERSONAL GEODATABASE
1165:     m_pCorrWStype = ENUM_PersonalGDB
1166:   Else                                    ' TREAT AS SHAPEFILE
1167:     m_pCorrWStype = ENUM_Shapefile
1168:     m_strCorrBasename = TopoCorridor.aml_func_mod.SetExtension(m_strCorrBasename, "dbf")
1169:   End If
  
'  Private m_strCorrBasename As String
'  Private m_strCorrDirName As String
'  Private m_strCorrFullText As String
'  Private m_pCorrWStype As JenDatasetTypes
  

  Exit Sub
ErrorHandler:
  HandleError True, "txtCorrelation_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub txtCov_Change()
  On Error GoTo ErrorHandler


  Dim strFullPath As String
1187:   strFullPath = txtCov.Text
  Dim strFile As String
  Dim strDir As String
1190:   strFile = TopoCorridor.aml_func_mod.ReturnFilename(strFullPath)
1191:   strDir = TopoCorridor.aml_func_mod.ReturnDir(strFullPath)
  
1193:   If Right(strDir, 1) = "\" Or Right(strDir, 1) = "/" Then
1194:     strDir = Left(strDir, Len(strDir) - 1)
1195:   End If
  
1197:   m_strCovDirName = strDir
1198:   m_strCovBasename = strFile
1199:   m_strCovFullText = strFullPath
  
1201:   If Right(strDir, 4) = ".gdb" Then       ' IS A FILE GEODATABASE
1202:     m_pCovWStype = ENUM_FileGDB
1203:   ElseIf Right(strDir, 4) = ".mdb" Then   ' IS A PERSONAL GEODATABASE
1204:     m_pCovWStype = ENUM_PersonalGDB
1205:   Else                                    ' TREAT AS SHAPEFILE
1206:     m_pCovWStype = ENUM_Shapefile
1207:     m_strCovBasename = TopoCorridor.aml_func_mod.SetExtension(m_strCovBasename, "dbf")
1208:   End If
  
'  Private m_strCovBasename As String
'  Private m_strCovDirName As String
'  Private m_strCovFullText As String
'  Private m_pCovWStype As JenDatasetTypes


  Exit Sub
ErrorHandler:
  HandleError True, "txtCov_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub txtInvCov_Change()
  On Error GoTo ErrorHandler


  Dim strFullPath As String
1226:   strFullPath = txtInvCov.Text
  Dim strFile As String
  Dim strDir As String
1229:   strFile = TopoCorridor.aml_func_mod.ReturnFilename(strFullPath)
1230:   strDir = TopoCorridor.aml_func_mod.ReturnDir(strFullPath)
  
1232:   If Right(strDir, 1) = "\" Or Right(strDir, 1) = "/" Then
1233:     strDir = Left(strDir, Len(strDir) - 1)
1234:   End If
  
1236:   m_strInvCovDirName = strDir
1237:   m_strInvCovBasename = strFile
1238:   m_strInvCovFullText = strFullPath
  
1240:   If Right(strDir, 4) = ".gdb" Then       ' IS A FILE GEODATABASE
1241:     m_pInvCovWStype = ENUM_FileGDB
1242:   ElseIf Right(strDir, 4) = ".mdb" Then   ' IS A PERSONAL GEODATABASE
1243:     m_pInvCovWStype = ENUM_PersonalGDB
1244:   Else                                    ' TREAT AS SHAPEFILE
1245:     m_pInvCovWStype = ENUM_Shapefile
1246:     m_strInvCovBasename = TopoCorridor.aml_func_mod.SetExtension(m_strInvCovBasename, "dbf")
1247:   End If
  
'  Private m_strInvCovBasename As String
'  Private m_strInvCovDirName As String
'  Private m_strInvCovFullText As String
'  Private m_pInvCovWStype As JenDatasetTypes


  Exit Sub
ErrorHandler:
  HandleError True, "txtInvCov_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub txtMeans_Change()
  On Error GoTo ErrorHandler


  Dim strFullPath As String
1265:   strFullPath = txtMeans.Text
  Dim strFile As String
  Dim strDir As String
  
1269:   strFile = TopoCorridor.aml_func_mod.ReturnFilename(strFullPath)
1270:   strDir = TopoCorridor.aml_func_mod.ReturnDir(strFullPath)
  
1272:   If Right(strDir, 1) = "\" Or Right(strDir, 1) = "/" Then
1273:     strDir = Left(strDir, Len(strDir) - 1)
1274:   End If
  
1276:   m_strMeansDirName = strDir
1277:   m_strMeansBasename = strFile
1278:   m_strMeansFullText = strFullPath
  
1280:   If Right(strDir, 4) = ".gdb" Then       ' IS A FILE GEODATABASE
1281:     m_pMeansWSType = ENUM_FileGDB
1282:   ElseIf Right(strDir, 4) = ".mdb" Then   ' IS A PERSONAL GEODATABASE
1283:     m_pMeansWSType = ENUM_PersonalGDB
1284:   Else                                    ' TREAT AS SHAPEFILE
1285:     m_pMeansWSType = ENUM_Shapefile
1286:     m_strMeansBasename = TopoCorridor.aml_func_mod.SetExtension(m_strMeansBasename, "dbf")
1287:   End If
  
'  Private m_strMeansBasename As String
'  Private m_strMeansDirName As String
'  Private m_strMeansFullText As String
'  Private m_pMeansWSType As JenDatasetTypes


  Exit Sub
ErrorHandler:
  HandleError True, "txtMeans_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
