VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsExtension"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private m_booShouldContinue As Boolean
Private m_strDirPath As String
Private m_strDirType As String
Private m_booIsFeatDataset As Boolean
Private m_strFeatDatasetName As String
Private m_lngVersion As Long
Private m_strRasterWS As String
Private m_lngOutputFormat As Long

' FOR PROGRESS METER
Private m_ProgressDialogCloseOnComplete As Boolean
Private m_ProgressDialogExpanded As Boolean

' SHANNON
Private m_pfrmLayerIDReturn As esriSystem.IVariantArray
Private m_lngNbrHoodSize As Long
Private m_booSetNoData As Boolean

' INVERT RASTER
Private m_pfrmInvertRasterReturn As esriSystem.IVariantArray
Private m_dblAddValue As Double
Private m_booAddValue As Boolean

' DENSITY
Private m_lngDensNbrhoodSize As Long
Private m_pfrmDensityReturn As esriSystem.IVariantArray
Private m_booDensityExcludeIfAnyNull As Boolean

' TPI
Private m_pfrmTPIReturn As esriSystem.IVariantArray
Private m_lngTPIType As Long
Private m_lngTPIShape As Long
Private m_lngTPISizeUnits As Long
Private m_dblTPINbrhoodParam1 As Double
Private m_dblTPINbrhoodParam2 As Double
Private m_dblTPINbrhoodParam3 As Double

' Slope3
Private m_pfrmSlope3Return As esriSystem.IVariantArray
Private m_lngSlope3TPIType As Long
Private m_lngSlope3TPIShape As Long
Private m_lngSlope3TPISizeUnits As Long
Private m_dblSlope3TPINbrhoodParam1 As Double
Private m_dblSlope3TPINbrhoodParam2 As Double
Private m_dblSlope3TPINbrhoodParam3 As Double
Private m_dblSlope3SplitA As Double
Private m_dblSlope3SplitB As Double
Private m_booSlope3AddIntermediate As Boolean
Private m_strSlope3Name1 As String
Private m_strSlope3Name2 As String
Private m_strSlope3Name3 As String

' Slope4
Private m_pfrmSlope4Return As esriSystem.IVariantArray
Private m_lngSlope4TPIType As Long
Private m_lngSlope4TPIShape As Long
Private m_lngSlope4TPISizeUnits As Long
Private m_dblSlope4TPINbrhoodParam1 As Double
Private m_dblSlope4TPINbrhoodParam2 As Double
Private m_dblSlope4TPINbrhoodParam3 As Double
Private m_dblSlope4SplitA As Double
Private m_dblSlope4SplitB As Double
Private m_dblSlope4SplitS As Double
Private m_booSlope4AddIntermediate As Boolean
Private m_strSlope4Name1 As String
Private m_strSlope4Name2 As String
Private m_strSlope4Name3 As String
Private m_strSlope4Name4 As String

' Slope6
Private m_pfrmSlope6Return As esriSystem.IVariantArray
Private m_lngSlope6TPIType As Long
Private m_lngSlope6TPIShape As Long
Private m_lngSlope6TPISizeUnits As Long
Private m_dblSlope6TPINbrhoodParam1 As Double
Private m_dblSlope6TPINbrhoodParam2 As Double
Private m_dblSlope6TPINbrhoodParam3 As Double
Private m_dblSlope6SplitA As Double
Private m_dblSlope6SplitB As Double
Private m_dblSlope6SplitC As Double
Private m_dblSlope6SplitD As Double
Private m_dblSlope6SplitS As Double
Private m_booSlope6AddIntermediate As Boolean
Private m_strSlope6Name1 As String
Private m_strSlope6Name2 As String
Private m_strSlope6Name3 As String
Private m_strSlope6Name4 As String
Private m_strSlope6Name5 As String
Private m_strSlope6Name6 As String

' Landform10
Private m_pfrmLandform10Return As esriSystem.IVariantArray
Private m_lngLandform10TPIType As Long
Private m_lngLandform10TPIShape As Long
Private m_lngLandform10TPISizeUnits As Long
Private m_dblLandform10TPINbrhoodParam1 As Double
Private m_dblLandform10TPINbrhoodParam2 As Double
Private m_dblLandform10TPINbrhoodParam3 As Double
Private m_dblLandform10SplitA As Double
Private m_dblLandform10SplitB As Double
Private m_dblLandform10SplitC As Double
Private m_dblLandform10SplitD As Double
Private m_dblLandform10SplitS As Double
Private m_booLandform10AddIntermediate As Boolean
Private m_strLandform10Name1 As String
Private m_strLandform10Name2 As String
Private m_strLandform10Name3 As String
Private m_strLandform10Name4 As String
Private m_strLandform10Name5 As String
Private m_strLandform10Name6 As String
Private m_strLandform10Name7 As String
Private m_strLandform10Name8 As String
Private m_strLandform10Name9 As String
Private m_strLandform10Name10 As String

' MAHALANOBIS
Private m_pfrmCovSourceReturn As esriSystem.IVariantArray
Private m_pfrmGridLayersReturn As esriSystem.IVariantArray
Private m_booSaveMeans As Boolean
Private m_booSaveCov As Boolean
Private m_booSaveInvCov As Boolean
Private m_booSaveCorrelation As Boolean
Private m_booSavePearson As Boolean
Private m_booSaveSpearman As Boolean
Private m_pSaveMeansOptions As esriSystem.IVariantArray
Private m_pSaveCovOptions As esriSystem.IVariantArray
Private m_pSaveInvCovOptions As esriSystem.IVariantArray
Private m_pSaveCorrOptions As esriSystem.IVariantArray
Private m_pSavePearson As esriSystem.IVariantArray
Private m_pSaveSpearman As esriSystem.IVariantArray
Private m_lngInitialSourceOption As Long     ' 1 FOR POINT THEME, 2 FOR RASTER, 3 FOR EXISTING
Private m_lngRasterTabIndex As Long
Private m_booRasterExactCellValue As Boolean
Private m_lngStep As Long
Private m_lngMsgBox As Long
Private m_pCovReloadParams As esriSystem.IVariantArray
Private m_booRasterInterpCellValue As Boolean    ' TO SUBSTITUTE FOR EXACT CELL VALUE PROPERTY,
Private m_pProgressMeter As Object
Private m_pCovBasicReloadParams As esriSystem.IVariantArray
Private m_pGridLayersReloadParams As esriSystem.IVariantArray
Private m_pMahalVectorParams As esriSystem.IVariantArray
Private m_pMahalVectorVariables As esriSystem.IVariantArray
Private m_pMahalOutputVariables As esriSystem.IVariantArray
Private m_lngOutputChoice As Long  ' 0 FOR NEW TABLE, 1 FOR EXISTING FIELD, 2 FOR NEW FIELD

' CHI-SQUARE
Dim m_pChiSquareRasterReturn As esriSystem.IVariantArray

' EXPORT TO R
Private m_pfrmRasterExportLayerIDReturn As esriSystem.IVariantArray
Private m_pfrmCircuitscapeLayerIDReturn As esriSystem.IVariantArray
Private m_strFolderPath As String
Private m_booClipLayers As Boolean
Private m_lngExportFormat As Long
Private m_booAddCombined As Boolean

' IMPORT FROM R
Private m_pFrmImportStep1 As esriSystem.IVariantArray
Private m_pFrmImportStep2 As esriSystem.IVariantArray
Private m_pFrmImportStep3 As esriSystem.IVariantArray
Private m_strStatsFolder As String
Private m_dblFuzzinessParam As Double
Private m_dblFuzzinessThreshold As Double
Private m_strTableFolderPath As String
Private m_lngTableExportFormat As Long
Private m_booShouldExportTable As Boolean

' ADDITIONAL DOCS LIST BOX
Private m_pfrmDocsListBoxResponse As esriSystem.IVariantArray

' TERMINI POLYGONS
Private m_lngSizeThreshold As Long
Private m_dblDataThreshold As Double
Private m_strTerminiFolderPath As String
Private m_pFrmIdentifyTerminiParams As esriSystem.IVariantArray

Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\brost_climate_change\code\clsExtension.cls"
Implements IExtension
Implements IPersistVariant

' SET FOLLOWING PROPERTIES
Public Property Set frmTerminiResponse(pTerminiFormReturn As esriSystem.IVariantArray)
185:   Set m_pFrmIdentifyTerminiParams = pTerminiFormReturn
End Property
Public Property Get frmTerminiResponse() As esriSystem.IVariantArray
188:   Set frmTerminiResponse = m_pFrmIdentifyTerminiParams
End Property
Public Property Let frmTerminiFolderPath(strTerminiFolderPath As String)
191:   m_strTerminiFolderPath = strTerminiFolderPath
End Property
Public Property Get frmTerminiFolderPath() As String
194:   frmTerminiFolderPath = m_strTerminiFolderPath
End Property
Public Property Let frmTerminiThreshold(lngTerminiThreshold As Long)
197:   m_lngSizeThreshold = lngTerminiThreshold
End Property
Public Property Get frmTerminiThreshold() As Long
200:   frmTerminiThreshold = m_lngSizeThreshold
End Property
Public Property Let frmTerminiDataThreshold(lngTerminiDataThreshold As Long)
203:   m_dblDataThreshold = lngTerminiDataThreshold
End Property
Public Property Get frmTerminiDataThreshold() As Long
206:   frmTerminiDataThreshold = m_dblDataThreshold
End Property
Public Property Let frmTerminiDataThresholdDouble(dblTerminiDataThreshold As Double)
209:   m_dblDataThreshold = dblTerminiDataThreshold
End Property
Public Property Get frmTerminiDataThresholdDouble() As Double
212:   frmTerminiDataThresholdDouble = m_dblDataThreshold
End Property

Public Property Set frmDocsListBoxResponse(pSelection As esriSystem.IVariantArray)
216:   Set m_pfrmDocsListBoxResponse = pSelection
End Property
Public Property Get frmDocsListBoxResponse() As esriSystem.IVariantArray
219:   Set frmDocsListBoxResponse = m_pfrmDocsListBoxResponse
End Property

Public Property Let frmImportStep1TableFolderPath(strTableFolderPath As String)
223:   m_strTableFolderPath = strTableFolderPath
End Property
Public Property Get frmImportStep1TableFolderPath() As String
226:   frmImportStep1TableFolderPath = m_strTableFolderPath
End Property
Public Property Let frmImportStep1TableExportFormat(lngTableExportFormat As Long)
229:   m_lngTableExportFormat = lngTableExportFormat
End Property
Public Property Get frmImportStep1TableExportFormat() As Long
232:   frmImportStep1TableExportFormat = m_lngTableExportFormat
End Property
Public Property Let frmImportStep1ShouldExportTable(booShouldExportTable As Boolean)
235:   m_booShouldExportTable = booShouldExportTable
End Property
Public Property Get frmImportStep1ShouldExportTable() As Boolean
238:   frmImportStep1ShouldExportTable = m_booShouldExportTable
End Property
Public Property Let frmImportStep4FuzzinessParam(dblFuzzinessParam As Double)
241:   m_dblFuzzinessParam = dblFuzzinessParam
End Property
Public Property Get frmImportStep4FuzzinessParam() As Double
244:   frmImportStep4FuzzinessParam = m_dblFuzzinessParam
End Property
Public Property Let frmImportStep4FuzzinessThreshold(dblFuzzinessThreshold As Double)
247:   m_dblFuzzinessThreshold = dblFuzzinessThreshold
End Property
Public Property Get frmImportStep4FuzzinessThreshold() As Double
250:   frmImportStep4FuzzinessThreshold = m_dblFuzzinessThreshold
End Property

Public Property Let frmImportStep2StatsFolder(strStep2StatsFolder As String)
254:   m_strStatsFolder = strStep2StatsFolder
End Property
Public Property Get frmImportStep2StatsFolder() As String
257:   frmImportStep2StatsFolder = m_strStatsFolder
End Property
Public Property Set frmImportStep1Return(frmImportStep1 As esriSystem.IVariantArray)
260:   Set m_pFrmImportStep1 = frmImportStep1
End Property
Public Property Get frmImportStep1Return() As esriSystem.IVariantArray
263:   Set frmImportStep1Return = m_pFrmImportStep1
End Property
Public Property Set frmImportStep2Return(frmImportStep2 As esriSystem.IVariantArray)
266:   Set m_pFrmImportStep2 = frmImportStep2
End Property
Public Property Get frmImportStep2Return() As esriSystem.IVariantArray
269:   Set frmImportStep2Return = m_pFrmImportStep2
End Property
Public Property Set frmImportStep3Return(frmImportStep3 As esriSystem.IVariantArray)
272:   Set m_pFrmImportStep3 = frmImportStep3
End Property
Public Property Get frmImportStep3Return() As esriSystem.IVariantArray
275:   Set frmImportStep3Return = m_pFrmImportStep3
End Property

Public Property Let RasterExportAddCombined(booAddCombinedRaster As Boolean)
279:   m_booAddCombined = booAddCombinedRaster
End Property
Public Property Get RasterExportAddCombined() As Boolean
282:   RasterExportAddCombined = m_booAddCombined
End Property
Public Property Let RasterExportFormat(strExportFormat As Long)
285:   m_lngExportFormat = strExportFormat
End Property
Public Property Get RasterExportFormat() As Long
288:   RasterExportFormat = m_lngExportFormat
End Property
Public Property Let RasterExportClip(booShouldClipToPolygon As Boolean)
291:   m_booClipLayers = booShouldClipToPolygon
End Property
Public Property Get RasterExportClip() As Boolean
294:   RasterExportClip = m_booClipLayers
End Property
Public Property Set frmRasterExportLayerIDReturn(pfrmRasterExportLayerIDReturn As esriSystem.IVariantArray)
297:   Set m_pfrmRasterExportLayerIDReturn = pfrmRasterExportLayerIDReturn
End Property
Public Property Get frmRasterExportLayerIDReturn() As esriSystem.IVariantArray
300:   Set frmRasterExportLayerIDReturn = m_pfrmRasterExportLayerIDReturn
End Property
Public Property Set frmCircuitscapeLayerIDReturn(pfrmCircuitscapeLayerIDReturn As esriSystem.IVariantArray)
303:   Set m_pfrmCircuitscapeLayerIDReturn = pfrmCircuitscapeLayerIDReturn
End Property
Public Property Get frmCircuitscapeLayerIDReturn() As esriSystem.IVariantArray
306:   Set frmCircuitscapeLayerIDReturn = m_pfrmCircuitscapeLayerIDReturn
End Property

Public Property Let Folder_Export_Location(strFolderPath As String)
  On Error GoTo ErrorHandler
311:   m_strFolderPath = strFolderPath
  Exit Property
ErrorHandler:
  HandleError True, "Folder_Export_Location " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Get Folder_Export_Location() As String
  On Error GoTo ErrorHandler
319:   Folder_Export_Location = m_strFolderPath
  Exit Property
ErrorHandler:
  HandleError True, "Folder_Export_Location " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property


Public Property Set frmChiSquareRasterReturn(pfrmChiSquareRasterReturn As esriSystem.IVariantArray)
327:   Set m_pChiSquareRasterReturn = pfrmChiSquareRasterReturn
End Property
Public Property Get frmChiSquareRasterReturn() As esriSystem.IVariantArray
330:   Set frmChiSquareRasterReturn = m_pChiSquareRasterReturn
End Property

Public Property Set frmDensityReturn(pfrmDensityReturn As esriSystem.IVariantArray)
334:   Set m_pfrmDensityReturn = pfrmDensityReturn
End Property
Public Property Get frmDensityReturn() As esriSystem.IVariantArray
337:   Set frmDensityReturn = m_pfrmDensityReturn
End Property

Public Property Set frmTPIReturn(pfrmTPIReturn As esriSystem.IVariantArray)
341:   Set m_pfrmTPIReturn = pfrmTPIReturn
End Property
Public Property Get frmTPIReturn() As esriSystem.IVariantArray
344:   Set frmTPIReturn = m_pfrmTPIReturn
End Property

Public Property Set frmSlope3Return(pfrmSlope3Return As esriSystem.IVariantArray)
348:   Set m_pfrmSlope3Return = pfrmSlope3Return
End Property
Public Property Get frmSlope3Return() As esriSystem.IVariantArray
351:   Set frmSlope3Return = m_pfrmSlope3Return
End Property

Public Property Set frmSlope4Return(pfrmSlope4Return As esriSystem.IVariantArray)
355:   Set m_pfrmSlope4Return = pfrmSlope4Return
End Property
Public Property Get frmSlope4Return() As esriSystem.IVariantArray
358:   Set frmSlope4Return = m_pfrmSlope4Return
End Property

Public Property Set frmSlope6Return(pfrmSlope6Return As esriSystem.IVariantArray)
362:   Set m_pfrmSlope6Return = pfrmSlope6Return
End Property
Public Property Get frmSlope6Return() As esriSystem.IVariantArray
365:   Set frmSlope6Return = m_pfrmSlope6Return
End Property

Public Property Set frmLandform10Return(pfrmLandform10Return As esriSystem.IVariantArray)
369:   Set m_pfrmLandform10Return = pfrmLandform10Return
End Property
Public Property Get frmLandform10Return() As esriSystem.IVariantArray
372:   Set frmLandform10Return = m_pfrmLandform10Return
End Property
Public Property Let DensNbrhoodSize(lngDensNbrhoodSize As Long)
375:   m_lngDensNbrhoodSize = lngDensNbrhoodSize
End Property
Public Property Get DensNbrhoodSize() As Long
378:   DensNbrhoodSize = m_lngDensNbrhoodSize
End Property

Public Property Let TPIType(lngTPIType As Long)
382:   m_lngTPIType = lngTPIType
End Property
Public Property Get TPIType() As Long
385:   TPIType = m_lngTPIType
End Property

Public Property Let TPIShape(lngTPIShape As Long)
389:   m_lngTPIShape = lngTPIShape
End Property
Public Property Get TPIShape() As Long
392:   TPIShape = m_lngTPIShape
End Property

Public Property Let TPISizeUnits(lngTPISizeUnits As Long)
396:   m_lngTPISizeUnits = lngTPISizeUnits
End Property
Public Property Get TPISizeUnits() As Long
399:   TPISizeUnits = m_lngTPISizeUnits
End Property

Public Property Let TPINbrhoodParam1(dblTPINbrhoodParam1 As Double)
403:   m_dblTPINbrhoodParam1 = dblTPINbrhoodParam1
End Property
Public Property Get TPINbrhoodParam1() As Double
406:   TPINbrhoodParam1 = m_dblTPINbrhoodParam1
End Property

Public Property Let TPINbrhoodParam2(dblTPINbrhoodParam2 As Double)
410:   m_dblTPINbrhoodParam2 = dblTPINbrhoodParam2
End Property
Public Property Get TPINbrhoodParam2() As Double
413:   TPINbrhoodParam2 = m_dblTPINbrhoodParam2
End Property

Public Property Let TPINbrhoodParam3(dblTPINbrhoodParam3 As Double)
417:   m_dblTPINbrhoodParam3 = dblTPINbrhoodParam3
End Property
Public Property Get TPINbrhoodParam3() As Double
420:   TPINbrhoodParam3 = m_dblTPINbrhoodParam3
End Property

Public Property Let Slope3TPIType(lngSlope3TPIType As Long)
424:   m_lngSlope3TPIType = lngSlope3TPIType
End Property
Public Property Get Slope3TPIType() As Long
427:   Slope3TPIType = m_lngSlope3TPIType
End Property

Public Property Let Slope3TPIShape(lngSlope3TPIShape As Long)
431:   m_lngSlope3TPIShape = lngSlope3TPIShape
End Property
Public Property Get Slope3TPIShape() As Long
434:   Slope3TPIShape = m_lngSlope3TPIShape
End Property

Public Property Let Slope3TPISizeUnits(lngSlope3TPISizeUnits As Long)
438:   m_lngSlope3TPISizeUnits = lngSlope3TPISizeUnits
End Property
Public Property Get Slope3TPISizeUnits() As Long
441:   Slope3TPISizeUnits = m_lngSlope3TPISizeUnits
End Property

Public Property Let Slope3TPINbrhoodParam1(dblSlope3TPINbrhoodParam1 As Double)
445:   m_dblSlope3TPINbrhoodParam1 = dblSlope3TPINbrhoodParam1
End Property
Public Property Get Slope3TPINbrhoodParam1() As Double
448:   Slope3TPINbrhoodParam1 = m_dblSlope3TPINbrhoodParam1
End Property

Public Property Let Slope3TPINbrhoodParam2(dblSlope3TPINbrhoodParam2 As Double)
452:   m_dblSlope3TPINbrhoodParam2 = dblSlope3TPINbrhoodParam2
End Property
Public Property Get Slope3TPINbrhoodParam2() As Double
455:   Slope3TPINbrhoodParam2 = m_dblSlope3TPINbrhoodParam2
End Property

Public Property Let Slope3TPINbrhoodParam3(dblSlope3TPINbrhoodParam3 As Double)
459:   m_dblSlope3TPINbrhoodParam3 = dblSlope3TPINbrhoodParam3
End Property
Public Property Get Slope3TPINbrhoodParam3() As Double
462:   Slope3TPINbrhoodParam3 = m_dblSlope3TPINbrhoodParam3
End Property

Public Property Let Slope3SplitA(dblSlope3SplitA As Double)
466:   m_dblSlope3SplitA = dblSlope3SplitA
End Property
Public Property Get Slope3SplitA() As Double
469:   Slope3SplitA = m_dblSlope3SplitA
End Property

Public Property Let Slope3SplitB(dblSlope3SplitB As Double)
473:   m_dblSlope3SplitB = dblSlope3SplitB
End Property
Public Property Get Slope3SplitB() As Double
476:   Slope3SplitB = m_dblSlope3SplitB
End Property

Public Property Let Slope3AddIntermediate(booSlope3AddIntermediate As Boolean)
480:   m_booSlope3AddIntermediate = booSlope3AddIntermediate
End Property
Public Property Get Slope3AddIntermediate() As Boolean
483:   Slope3AddIntermediate = m_booSlope3AddIntermediate
End Property

Public Property Let Slope3Name1(strSlope3Name1 As String)
487:   m_strSlope3Name1 = strSlope3Name1
End Property
Public Property Get Slope3Name1() As String
490:   Slope3Name1 = m_strSlope3Name1
End Property

Public Property Let Slope3Name2(strSlope3Name2 As String)
494:   m_strSlope3Name2 = strSlope3Name2
End Property
Public Property Get Slope3Name2() As String
497:   Slope3Name2 = m_strSlope3Name2
End Property

Public Property Let Slope3Name3(strSlope3Name3 As String)
501:   m_strSlope3Name3 = strSlope3Name3
End Property
Public Property Get Slope3Name3() As String
504:   Slope3Name3 = m_strSlope3Name3
End Property

Public Property Let Slope4TPIType(lngSlope4TPIType As Long)
508:   m_lngSlope4TPIType = lngSlope4TPIType
End Property
Public Property Get Slope4TPIType() As Long
511:   Slope4TPIType = m_lngSlope4TPIType
End Property

Public Property Let Slope4TPIShape(lngSlope4TPIShape As Long)
515:   m_lngSlope4TPIShape = lngSlope4TPIShape
End Property
Public Property Get Slope4TPIShape() As Long
518:   Slope4TPIShape = m_lngSlope4TPIShape
End Property

Public Property Let Slope4TPISizeUnits(lngSlope4TPISizeUnits As Long)
522:   m_lngSlope4TPISizeUnits = lngSlope4TPISizeUnits
End Property
Public Property Get Slope4TPISizeUnits() As Long
525:   Slope4TPISizeUnits = m_lngSlope4TPISizeUnits
End Property

Public Property Let Slope4TPINbrhoodParam1(dblSlope4TPINbrhoodParam1 As Double)
529:   m_dblSlope4TPINbrhoodParam1 = dblSlope4TPINbrhoodParam1
End Property
Public Property Get Slope4TPINbrhoodParam1() As Double
532:   Slope4TPINbrhoodParam1 = m_dblSlope4TPINbrhoodParam1
End Property

Public Property Let Slope4TPINbrhoodParam2(dblSlope4TPINbrhoodParam2 As Double)
536:   m_dblSlope4TPINbrhoodParam2 = dblSlope4TPINbrhoodParam2
End Property
Public Property Get Slope4TPINbrhoodParam2() As Double
539:   Slope4TPINbrhoodParam2 = m_dblSlope4TPINbrhoodParam2
End Property

Public Property Let Slope4TPINbrhoodParam3(dblSlope4TPINbrhoodParam3 As Double)
543:   m_dblSlope4TPINbrhoodParam3 = dblSlope4TPINbrhoodParam3
End Property
Public Property Get Slope4TPINbrhoodParam3() As Double
546:   Slope4TPINbrhoodParam3 = m_dblSlope4TPINbrhoodParam3
End Property

Public Property Let Slope4SplitA(dblSlope4SplitA As Double)
550:   m_dblSlope4SplitA = dblSlope4SplitA
End Property
Public Property Get Slope4SplitA() As Double
553:   Slope4SplitA = m_dblSlope4SplitA
End Property

Public Property Let Slope4SplitB(dblSlope4SplitB As Double)
557:   m_dblSlope4SplitB = dblSlope4SplitB
End Property
Public Property Get Slope4SplitB() As Double
560:   Slope4SplitB = m_dblSlope4SplitB
End Property

Public Property Let Slope4SplitS(dblSlope4SplitS As Double)
564:   m_dblSlope4SplitS = dblSlope4SplitS
End Property
Public Property Get Slope4SplitS() As Double
567:   Slope4SplitS = m_dblSlope4SplitS
End Property

Public Property Let Slope4AddIntermediate(booSlope4AddIntermediate As Boolean)
571:   m_booSlope4AddIntermediate = booSlope4AddIntermediate
End Property
Public Property Get Slope4AddIntermediate() As Boolean
574:   Slope4AddIntermediate = m_booSlope4AddIntermediate
End Property

Public Property Let Slope4Name1(strSlope4Name1 As String)
578:   m_strSlope4Name1 = strSlope4Name1
End Property
Public Property Get Slope4Name1() As String
581:   Slope4Name1 = m_strSlope4Name1
End Property

Public Property Let Slope4Name2(strSlope4Name2 As String)
585:   m_strSlope4Name2 = strSlope4Name2
End Property
Public Property Get Slope4Name2() As String
588:   Slope4Name2 = m_strSlope4Name2
End Property

Public Property Let Slope4Name3(strSlope4Name3 As String)
592:   m_strSlope4Name3 = strSlope4Name3
End Property
Public Property Get Slope4Name3() As String
595:   Slope4Name3 = m_strSlope4Name3
End Property

Public Property Let Slope4Name4(strSlope4Name4 As String)
599:   m_strSlope4Name4 = strSlope4Name4
End Property
Public Property Get Slope4Name4() As String
602:   Slope4Name4 = m_strSlope4Name4
End Property

Public Property Let Slope6TPIType(lngSlope6TPIType As Long)
606:   m_lngSlope6TPIType = lngSlope6TPIType
End Property
Public Property Get Slope6TPIType() As Long
609:   Slope6TPIType = m_lngSlope6TPIType
End Property

Public Property Let Slope6TPIShape(lngSlope6TPIShape As Long)
613:   m_lngSlope6TPIShape = lngSlope6TPIShape
End Property
Public Property Get Slope6TPIShape() As Long
616:   Slope6TPIShape = m_lngSlope6TPIShape
End Property

Public Property Let Slope6TPISizeUnits(lngSlope6TPISizeUnits As Long)
620:   m_lngSlope6TPISizeUnits = lngSlope6TPISizeUnits
End Property
Public Property Get Slope6TPISizeUnits() As Long
623:   Slope6TPISizeUnits = m_lngSlope6TPISizeUnits
End Property

Public Property Let Slope6TPINbrhoodParam1(dblSlope6TPINbrhoodParam1 As Double)
627:   m_dblSlope6TPINbrhoodParam1 = dblSlope6TPINbrhoodParam1
End Property
Public Property Get Slope6TPINbrhoodParam1() As Double
630:   Slope6TPINbrhoodParam1 = m_dblSlope6TPINbrhoodParam1
End Property

Public Property Let Slope6TPINbrhoodParam2(dblSlope6TPINbrhoodParam2 As Double)
634:   m_dblSlope6TPINbrhoodParam2 = dblSlope6TPINbrhoodParam2
End Property
Public Property Get Slope6TPINbrhoodParam2() As Double
637:   Slope6TPINbrhoodParam2 = m_dblSlope6TPINbrhoodParam2
End Property

Public Property Let Slope6TPINbrhoodParam3(dblSlope6TPINbrhoodParam3 As Double)
641:   m_dblSlope6TPINbrhoodParam3 = dblSlope6TPINbrhoodParam3
End Property
Public Property Get Slope6TPINbrhoodParam3() As Double
644:   Slope6TPINbrhoodParam3 = m_dblSlope6TPINbrhoodParam3
End Property

Public Property Let Slope6SplitA(dblSlope6SplitA As Double)
648:   m_dblSlope6SplitA = dblSlope6SplitA
End Property
Public Property Get Slope6SplitA() As Double
651:   Slope6SplitA = m_dblSlope6SplitA
End Property

Public Property Let Slope6SplitB(dblSlope6SplitB As Double)
655:   m_dblSlope6SplitB = dblSlope6SplitB
End Property
Public Property Get Slope6SplitB() As Double
658:   Slope6SplitB = m_dblSlope6SplitB
End Property

Public Property Let Slope6SplitC(dblSlope6SplitC As Double)
662:   m_dblSlope6SplitC = dblSlope6SplitC
End Property
Public Property Get Slope6SplitC() As Double
665:   Slope6SplitC = m_dblSlope6SplitC
End Property

Public Property Let Slope6SplitD(dblSlope6SplitD As Double)
669:   m_dblSlope6SplitD = dblSlope6SplitD
End Property
Public Property Get Slope6SplitD() As Double
672:   Slope6SplitD = m_dblSlope6SplitD
End Property

Public Property Let Slope6SplitS(dblSlope6SplitS As Double)
676:   m_dblSlope6SplitS = dblSlope6SplitS
End Property
Public Property Get Slope6SplitS() As Double
679:   Slope6SplitS = m_dblSlope6SplitS
End Property

Public Property Let Slope6AddIntermediate(booSlope6AddIntermediate As Boolean)
683:   m_booSlope6AddIntermediate = booSlope6AddIntermediate
End Property
Public Property Get Slope6AddIntermediate() As Boolean
686:   Slope6AddIntermediate = m_booSlope6AddIntermediate
End Property

Public Property Let Slope6Name1(strSlope6Name1 As String)
690:   m_strSlope6Name1 = strSlope6Name1
End Property
Public Property Get Slope6Name1() As String
693:   Slope6Name1 = m_strSlope6Name1
End Property

Public Property Let Slope6Name2(strSlope6Name2 As String)
697:   m_strSlope6Name2 = strSlope6Name2
End Property
Public Property Get Slope6Name2() As String
700:   Slope6Name2 = m_strSlope6Name2
End Property

Public Property Let Slope6Name3(strSlope6Name3 As String)
704:   m_strSlope6Name3 = strSlope6Name3
End Property
Public Property Get Slope6Name3() As String
707:   Slope6Name3 = m_strSlope6Name3
End Property

Public Property Let Slope6Name4(strSlope6Name4 As String)
711:   m_strSlope6Name4 = strSlope6Name4
End Property
Public Property Get Slope6Name4() As String
714:   Slope6Name4 = m_strSlope6Name4
End Property

Public Property Let Slope6Name5(strSlope6Name5 As String)
718:   m_strSlope6Name5 = strSlope6Name5
End Property
Public Property Get Slope6Name5() As String
721:   Slope6Name5 = m_strSlope6Name5
End Property

Public Property Let Slope6Name6(strSlope6Name6 As String)
725:   m_strSlope6Name6 = strSlope6Name6
End Property
Public Property Get Slope6Name6() As String
728:   Slope6Name6 = m_strSlope6Name6
End Property

Public Property Let Landform10TPIType(lngLandform10TPIType As Long)
732:   m_lngLandform10TPIType = lngLandform10TPIType
End Property
Public Property Get Landform10TPIType() As Long
735:   Landform10TPIType = m_lngLandform10TPIType
End Property

Public Property Let Landform10TPIShape(lngLandform10TPIShape As Long)
739:   m_lngLandform10TPIShape = lngLandform10TPIShape
End Property
Public Property Get Landform10TPIShape() As Long
742:   Landform10TPIShape = m_lngLandform10TPIShape
End Property

Public Property Let Landform10TPISizeUnits(lngLandform10TPISizeUnits As Long)
746:   m_lngLandform10TPISizeUnits = lngLandform10TPISizeUnits
End Property
Public Property Get Landform10TPISizeUnits() As Long
749:   Landform10TPISizeUnits = m_lngLandform10TPISizeUnits
End Property

Public Property Let Landform10TPINbrhoodParam1(dblLandform10TPINbrhoodParam1 As Double)
753:   m_dblLandform10TPINbrhoodParam1 = dblLandform10TPINbrhoodParam1
End Property
Public Property Get Landform10TPINbrhoodParam1() As Double
756:   Landform10TPINbrhoodParam1 = m_dblLandform10TPINbrhoodParam1
End Property

Public Property Let Landform10TPINbrhoodParam2(dblLandform10TPINbrhoodParam2 As Double)
760:   m_dblLandform10TPINbrhoodParam2 = dblLandform10TPINbrhoodParam2
End Property
Public Property Get Landform10TPINbrhoodParam2() As Double
763:   Landform10TPINbrhoodParam2 = m_dblLandform10TPINbrhoodParam2
End Property

Public Property Let Landform10TPINbrhoodParam3(dblLandform10TPINbrhoodParam3 As Double)
767:   m_dblLandform10TPINbrhoodParam3 = dblLandform10TPINbrhoodParam3
End Property
Public Property Get Landform10TPINbrhoodParam3() As Double
770:   Landform10TPINbrhoodParam3 = m_dblLandform10TPINbrhoodParam3
End Property

Public Property Let Landform10SplitA(dblLandform10SplitA As Double)
774:   m_dblLandform10SplitA = dblLandform10SplitA
End Property
Public Property Get Landform10SplitA() As Double
777:   Landform10SplitA = m_dblLandform10SplitA
End Property

Public Property Let Landform10SplitB(dblLandform10SplitB As Double)
781:   m_dblLandform10SplitB = dblLandform10SplitB
End Property
Public Property Get Landform10SplitB() As Double
784:   Landform10SplitB = m_dblLandform10SplitB
End Property

Public Property Let Landform10SplitC(dblLandform10SplitC As Double)
788:   m_dblLandform10SplitC = dblLandform10SplitC
End Property
Public Property Get Landform10SplitC() As Double
791:   Landform10SplitC = m_dblLandform10SplitC
End Property

Public Property Let Landform10SplitD(dblLandform10SplitD As Double)
795:   m_dblLandform10SplitD = dblLandform10SplitD
End Property
Public Property Get Landform10SplitD() As Double
798:   Landform10SplitD = m_dblLandform10SplitD
End Property

Public Property Let Landform10SplitS(dblLandform10SplitS As Double)
802:   m_dblLandform10SplitS = dblLandform10SplitS
End Property
Public Property Get Landform10SplitS() As Double
805:   Landform10SplitS = m_dblLandform10SplitS
End Property

Public Property Let Landform10AddIntermediate(booLandform10AddIntermediate As Boolean)
809:   m_booLandform10AddIntermediate = booLandform10AddIntermediate
End Property
Public Property Get Landform10AddIntermediate() As Boolean
812:   Landform10AddIntermediate = m_booLandform10AddIntermediate
End Property

Public Property Let Landform10Name1(strLandform10Name1 As String)
816:   m_strLandform10Name1 = strLandform10Name1
End Property
Public Property Get Landform10Name1() As String
819:   Landform10Name1 = m_strLandform10Name1
End Property

Public Property Let Landform10Name2(strLandform10Name2 As String)
823:   m_strLandform10Name2 = strLandform10Name2
End Property
Public Property Get Landform10Name2() As String
826:   Landform10Name2 = m_strLandform10Name2
End Property

Public Property Let Landform10Name3(strLandform10Name3 As String)
830:   m_strLandform10Name3 = strLandform10Name3
End Property
Public Property Get Landform10Name3() As String
833:   Landform10Name3 = m_strLandform10Name3
End Property

Public Property Let Landform10Name4(strLandform10Name4 As String)
837:   m_strLandform10Name4 = strLandform10Name4
End Property
Public Property Get Landform10Name4() As String
840:   Landform10Name4 = m_strLandform10Name4
End Property

Public Property Let Landform10Name5(strLandform10Name5 As String)
844:   m_strLandform10Name5 = strLandform10Name5
End Property
Public Property Get Landform10Name5() As String
847:   Landform10Name5 = m_strLandform10Name5
End Property

Public Property Let Landform10Name6(strLandform10Name6 As String)
851:   m_strLandform10Name6 = strLandform10Name6
End Property
Public Property Get Landform10Name6() As String
854:   Landform10Name6 = m_strLandform10Name6
End Property

Public Property Let Landform10Name7(strLandform10Name7 As String)
858:   m_strLandform10Name7 = strLandform10Name7
End Property
Public Property Get Landform10Name7() As String
861:   Landform10Name7 = m_strLandform10Name7
End Property

Public Property Let Landform10Name8(strLandform10Name8 As String)
865:   m_strLandform10Name8 = strLandform10Name8
End Property
Public Property Get Landform10Name8() As String
868:   Landform10Name8 = m_strLandform10Name8
End Property

Public Property Let Landform10Name9(strLandform10Name9 As String)
872:   m_strLandform10Name9 = strLandform10Name9
End Property
Public Property Get Landform10Name9() As String
875:   Landform10Name9 = m_strLandform10Name9
End Property

Public Property Let Landform10Name10(strLandform10Name10 As String)
879:   m_strLandform10Name10 = strLandform10Name10
End Property
Public Property Get Landform10Name10() As String
882:   Landform10Name10 = m_strLandform10Name10
End Property


Public Property Set frmInvertReturn(pfrmInvertReturn As esriSystem.IVariantArray)
887:   Set m_pfrmInvertRasterReturn = pfrmInvertReturn
End Property
Public Property Get frmInvertReturn() As esriSystem.IVariantArray
890:   Set frmInvertReturn = m_pfrmInvertRasterReturn
End Property
Public Property Let frmInvertAdd(dblInvertAdd As Double)
893:   m_dblAddValue = dblInvertAdd
End Property
Public Property Get frmInvertAdd() As Double
896:   frmInvertAdd = m_dblAddValue
End Property
Public Property Let frmInvertShouldAdd(booShouldAdd As Boolean)
899:   m_booAddValue = booShouldAdd
End Property
Public Property Get frmInvertShouldAdd() As Boolean
902:   frmInvertShouldAdd = m_booAddValue
End Property

Public Property Let ExcludeIfAnyNull(booSetNoData As Boolean)
906:   m_booSetNoData = booSetNoData
End Property
Public Property Get ExcludeIfAnyNull() As Boolean
909:   ExcludeIfAnyNull = m_booSetNoData
End Property
Public Property Let NeighborhoodSize(lngNeighborhoodSize As Long)
912:   m_lngNbrHoodSize = lngNeighborhoodSize
End Property
Public Property Get NeighborhoodSize() As Long
915:   NeighborhoodSize = m_lngNbrHoodSize
End Property
Public Property Let OutputFormat(lngOutputFormat As Long)
918:   m_lngOutputFormat = lngOutputFormat
End Property
Public Property Get OutputFormat() As Long
921:   OutputFormat = m_lngOutputFormat
End Property
Public Property Let RasterWorkspacePath(strRastWS As String)
924:   m_strRasterWS = strRastWS
End Property
Public Property Get RasterWorkspacePath() As String
927:   RasterWorkspacePath = m_strRasterWS
End Property
Public Property Let FeatDatasetName(strFeatDatasetName As String)
930:   m_strFeatDatasetName = strFeatDatasetName
End Property
Public Property Get FeatDatasetName() As String
933:   FeatDatasetName = m_strFeatDatasetName
End Property
Public Property Let IsFeatureDataset(booIsFeatDataset As Boolean)
936:   m_booIsFeatDataset = booIsFeatDataset
End Property
Public Property Get IsFeatureDataset() As Boolean
939:   IsFeatureDataset = m_booIsFeatDataset
End Property
Public Property Let DirectoryType(strDirType As String)
942:   m_strDirType = strDirType
End Property
Public Property Get DirectoryType() As String
945:   DirectoryType = m_strDirType
End Property


Public Property Let frmMahalOutputChoice(lngOption As Long)
950:   m_lngOutputChoice = lngOption
End Property
Public Property Get frmMahalOutputChoice() As Long
953:   frmMahalOutputChoice = m_lngOutputChoice
End Property
Public Property Set frmMahalOutputOptions(pOutputOptions As esriSystem.IVariantArray)
956:   Set m_pMahalOutputVariables = pOutputOptions
End Property
Public Property Get frmMahalOutputOptions() As esriSystem.IVariantArray
959:   Set frmMahalOutputOptions = m_pMahalOutputVariables
End Property
Public Property Set frmMahalVectorVariables(pVectorVariables As esriSystem.IVariantArray)
962:   Set m_pMahalVectorVariables = pVectorVariables
End Property
Public Property Get frmMahalVectorVariables() As esriSystem.IVariantArray
965:   Set frmMahalVectorVariables = m_pMahalVectorVariables
End Property
Public Property Set frmMahalVectorSource(pVectorSource As esriSystem.IVariantArray)
968:   Set m_pMahalVectorParams = pVectorSource
End Property
Public Property Get frmMahalVectorSource() As esriSystem.IVariantArray
971:   Set frmMahalVectorSource = m_pMahalVectorParams
End Property
Public Property Set frmGridLayerReloadParams(pReloadParams As esriSystem.IVariantArray)
974:   Set m_pGridLayersReloadParams = pReloadParams
End Property
Public Property Get frmGridLayerReloadParams() As esriSystem.IVariantArray
977:   Set frmGridLayerReloadParams = m_pGridLayersReloadParams
End Property
Public Property Set frmCovBasicReloadParams(pReloadParams As esriSystem.IVariantArray)
980:   Set m_pCovBasicReloadParams = pReloadParams
End Property
Public Property Get frmCovBasicReloadParams() As esriSystem.IVariantArray
983:   Set frmCovBasicReloadParams = m_pCovBasicReloadParams
End Property
Public Property Set ProgressMeterForm(pForm As Object)
986:   Set m_pProgressMeter = pForm
End Property
Public Property Get ProgressMeterForm() As Object
989:   Set ProgressMeterForm = m_pProgressMeter
End Property
Public Property Let UseInterpCellValue(booUseInterpolatedValue As Boolean)
992:   m_booRasterInterpCellValue = booUseInterpolatedValue
End Property
Public Property Get UseInterpCellValue() As Boolean
995:   UseInterpCellValue = m_booRasterInterpCellValue
End Property
Public Property Set frmCovReloadParams(pReloadParams As esriSystem.IVariantArray)
998:   Set m_pCovReloadParams = pReloadParams
End Property
Public Property Get frmCovReloadParams() As esriSystem.IVariantArray
1001:   Set frmCovReloadParams = m_pCovReloadParams
End Property
Public Property Let MessageBoxResponse(lngMsgBox As Long)
1004:   m_lngMsgBox = lngMsgBox
End Property
Public Property Get MessageBoxResponse() As Long
1007:   MessageBoxResponse = m_lngMsgBox
End Property
Public Property Let InputStep(lngStep As Long)
1010:   m_lngStep = lngStep
End Property
Public Property Get InputStep() As Long
1013:   InputStep = m_lngStep
End Property
Public Property Set frmGridLayersReturn(GridLayersReturn As esriSystem.IVariantArray)
1016:   Set m_pfrmGridLayersReturn = GridLayersReturn
End Property
Public Property Get frmGridLayersReturn() As esriSystem.IVariantArray
1019:   Set frmGridLayersReturn = m_pfrmGridLayersReturn
End Property
Public Property Let UseExactCellValue(booUseExact As Boolean)
1022:   Let m_booRasterExactCellValue = booUseExact
End Property
Public Property Get UseExactCellValue() As Boolean
1025:   UseExactCellValue = m_booRasterExactCellValue
End Property
Public Property Let RasterTabIndex(lngTabIndex As Long)
1028:   Let m_lngRasterTabIndex = lngTabIndex
End Property
Public Property Get RasterTabIndex() As Long
1031:   If m_lngRasterTabIndex = 0 Then m_lngRasterTabIndex = 1
1032:   RasterTabIndex = m_lngRasterTabIndex
End Property
Public Property Let InitialSourceOption(lngSourceOption As Long)
1035:   m_lngInitialSourceOption = lngSourceOption
End Property
Public Property Get InitialSourceOption() As Long
1038:   InitialSourceOption = m_lngInitialSourceOption
End Property
Public Property Set StatsSaveMeansOptions(pSaveMeansOptions As esriSystem.IVariantArray)
1041:   Set m_pSaveMeansOptions = pSaveMeansOptions
End Property
Public Property Get StatsSaveMeansOptions() As esriSystem.IVariantArray
1044:   Set StatsSaveMeansOptions = m_pSaveMeansOptions
End Property
Public Property Set StatsSaveCovOptions(pSaveCovOptions As esriSystem.IVariantArray)
1047:   Set m_pSaveCovOptions = pSaveCovOptions
End Property
Public Property Get StatsSaveCovOptions() As esriSystem.IVariantArray
1050:   Set StatsSaveCovOptions = m_pSaveCovOptions
End Property
Public Property Set StatsSaveInvCovOptions(pSaveInvCovOptions As esriSystem.IVariantArray)
1053:   Set m_pSaveInvCovOptions = pSaveInvCovOptions
End Property
Public Property Get StatsSaveInvCovOptions() As esriSystem.IVariantArray
1056:   Set StatsSaveInvCovOptions = m_pSaveInvCovOptions
End Property
Public Property Set StatsSaveCorrelationOptions(pSaveCorrelationOptions As esriSystem.IVariantArray)
1059:   Set m_pSaveCorrOptions = pSaveCorrelationOptions
End Property
Public Property Get StatsSaveCorrelationOptions() As esriSystem.IVariantArray
1062:  Set StatsSaveCorrelationOptions = m_pSaveCorrOptions
End Property
Public Property Set StatsSavePearsonOptions(pSavePearsonOptions As esriSystem.IVariantArray)
1065:   Set m_pSavePearson = pSavePearsonOptions
End Property
Public Property Get StatsSavePearsonOptions() As esriSystem.IVariantArray
1068:  Set StatsSavePearsonOptions = m_pSavePearson
End Property
Public Property Set StatsSaveSpearmanOptions(pSaveSpearmanOptions As esriSystem.IVariantArray)
1071:   Set m_pSaveSpearman = pSaveSpearmanOptions
End Property
Public Property Get StatsSaveSpearmanOptions() As esriSystem.IVariantArray
1074:  Set StatsSaveSpearmanOptions = m_pSaveSpearman
End Property
Public Property Let StatsSaveMeans(booSaveMeans As Boolean)
1077:   m_booSaveMeans = booSaveMeans
End Property
Public Property Get StatsSaveMeans() As Boolean
1080:   StatsSaveMeans = m_booSaveMeans
End Property
Public Property Let StatsSaveCov(booSaveCov As Boolean)
1083:   m_booSaveCov = booSaveCov
End Property
Public Property Get StatsSaveCov() As Boolean
1086:   StatsSaveCov = m_booSaveCov
End Property
Public Property Let StatsSaveInvCov(booSaveInvCov As Boolean)
1089:   m_booSaveInvCov = booSaveInvCov
End Property
Public Property Get StatsSaveInvCov() As Boolean
1092:   StatsSaveInvCov = m_booSaveInvCov
End Property
Public Property Let StatsSaveCorrelation(booSaveCorrelation As Boolean)
1095:   m_booSaveCorrelation = booSaveCorrelation
End Property
Public Property Get StatsSaveCorrelation() As Boolean
1098:   StatsSaveCorrelation = m_booSaveCorrelation
End Property
Public Property Let StatsSavePearson(booSavePearson As Boolean)
1101:   m_booSavePearson = booSavePearson
End Property
Public Property Get StatsSavePearson() As Boolean
1104:   StatsSavePearson = m_booSavePearson
End Property
Public Property Let StatsSaveSpearman(booSaveSpearman As Boolean)
1107:   m_booSaveSpearman = booSaveSpearman
End Property
Public Property Get StatsSaveSpearman() As Boolean
1110:   StatsSaveSpearman = m_booSaveSpearman
End Property
Public Property Set frmCovSourceReturn(pfrmCovSourceReturn As esriSystem.IVariantArray)
1113:   Set m_pfrmCovSourceReturn = pfrmCovSourceReturn
End Property
Public Property Get frmCovSourceReturn() As esriSystem.IVariantArray
1116:   Set frmCovSourceReturn = m_pfrmCovSourceReturn
End Property


Public Property Let ProgressDialogAutoClose(SetAutoClose As Boolean)    ' FOR frmJenProgressPercent
1121:   Let m_ProgressDialogCloseOnComplete = SetAutoClose
End Property
Public Property Get ProgressDialogAutoClose() As Boolean           ' FOR frmJenProgressPercent
1124:   ProgressDialogAutoClose = m_ProgressDialogCloseOnComplete
End Property
Public Property Let ProgressDialogSetExpanded(SetExpanded As Boolean)    ' FOR frmJenProgressPercent
1127:   Let m_ProgressDialogExpanded = SetExpanded
End Property
Public Property Get ProgressDialogSetExpanded() As Boolean           ' FOR frmJenProgressPercent
1130:   ProgressDialogSetExpanded = m_ProgressDialogExpanded
End Property


Public Property Set frmLayerIDReturn(pfrmLayerIDReturn As esriSystem.IVariantArray)
1135:   Set m_pfrmLayerIDReturn = pfrmLayerIDReturn
End Property

Public Property Get frmLayerIDReturn() As esriSystem.IVariantArray
1139:   Set frmLayerIDReturn = m_pfrmLayerIDReturn
End Property

Public Property Let DirectoryPath(strPath As String)
  On Error GoTo ErrorHandler
1144:   m_strDirPath = strPath
  Exit Property
ErrorHandler:
  HandleError True, "DirectoryPath " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Get DirectoryPath() As String
  On Error GoTo ErrorHandler
1152:   DirectoryPath = m_strDirPath
  Exit Property
ErrorHandler:
  HandleError True, "DirectoryPath " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Let ShouldContinue(booShouldContinue As Boolean)
  On Error GoTo ErrorHandler
1160:   m_booShouldContinue = booShouldContinue
  Exit Property
ErrorHandler:
  HandleError True, "ShouldContinue " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Get ShouldContinue() As Boolean
  On Error GoTo ErrorHandler
1168:   ShouldContinue = m_booShouldContinue
  Exit Property
ErrorHandler:
  HandleError True, "ShouldContinue " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Get ExtensionVersion() As Long
1175:   ExtensionVersion = m_lngVersion
End Property

Private Property Get IExtension_Name() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
1182:   IExtension_Name = "TopoCorridor"
  
  Exit Property
ErrorHandler:
  HandleError True, "IExtension_Name " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub IExtension_Startup(ByRef initializationData As Variant)
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
1193:   If m_strDirPath = "" Or m_strDirType = "" Then
1194:     m_strDirType = "Shapefile"
1195:     m_strDirPath = ""
1196:     m_booIsFeatDataset = False
1197:     m_strFeatDatasetName = ""
    
1199:   End If
   
  Exit Sub
ErrorHandler:
  HandleError True, "IExtension_Startup " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub IExtension_Shutdown()
  On Error GoTo ErrorHandler
  
 ' MsgBox "Starting Extension Shutdown..."
  
  ' TODO: Add your implementation here
1212:   Set m_pfrmLayerIDReturn = Nothing
1213:   Set m_pfrmInvertRasterReturn = Nothing
1214:   Set m_pfrmDensityReturn = Nothing
1215:   Set m_pfrmTPIReturn = Nothing
1216:   Set m_pfrmSlope3Return = Nothing
1217:   Set m_pfrmSlope4Return = Nothing
1218:   Set m_pfrmSlope6Return = Nothing
1219:   Set m_pfrmLandform10Return = Nothing
1220:   Set m_pfrmCovSourceReturn = Nothing
1221:   Set m_pfrmGridLayersReturn = Nothing
1222:   Set m_pSaveMeansOptions = Nothing
1223:   Set m_pSaveCovOptions = Nothing
1224:   Set m_pSaveInvCovOptions = Nothing
1225:   Set m_pSaveCorrOptions = Nothing
1226:   Set m_pSavePearson = Nothing
1227:   Set m_pSaveSpearman = Nothing
1228:   Set m_pCovReloadParams = Nothing
1229:   Set m_pProgressMeter = Nothing
1230:   Set m_pCovBasicReloadParams = Nothing
1231:   Set m_pGridLayersReloadParams = Nothing
1232:   Set m_pMahalVectorParams = Nothing
1233:   Set m_pMahalVectorVariables = Nothing
1234:   Set m_pMahalOutputVariables = Nothing
1235:   Set m_pChiSquareRasterReturn = Nothing
1236:   Set m_pfrmRasterExportLayerIDReturn = Nothing
1237:   Set m_pfrmCircuitscapeLayerIDReturn = Nothing
1238:   Set m_pFrmImportStep1 = Nothing
1239:   Set m_pFrmImportStep2 = Nothing
1240:   Set m_pFrmImportStep3 = Nothing
1241:   Set m_pfrmDocsListBoxResponse = Nothing
1242:   Set m_pFrmIdentifyTerminiParams = Nothing
  
  ' msgbox "Finishing Extension Shutdown.."
  Exit Sub
ErrorHandler:
  HandleError True, "IExtension_Shutdown " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Property Get IPersistVariant_ID() As esriSystem.IUID
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
  ' IPersistVariant_ID =
  
  Exit Property
ErrorHandler:
  HandleError True, "IPersistVariant_ID " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub IPersistVariant_Load(ByVal Stream As esriSystem.IVariantStream)
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here

1266:   m_lngVersion = Stream.Read
1267:   m_strDirType = Stream.Read
1268:   m_strDirPath = Stream.Read
1269:   m_strRasterWS = Stream.Read
1270:   m_lngOutputFormat = Stream.Read
1271:   m_lngNbrHoodSize = Stream.Read
1272:   m_booSetNoData = Stream.Read
1273:   m_dblAddValue = Stream.Read
1274:   m_booAddValue = Stream.Read
1275:   m_lngDensNbrhoodSize = Stream.Read
1276:   m_lngTPIType = Stream.Read
1277:   m_lngTPIShape = Stream.Read
1278:   m_lngTPISizeUnits = Stream.Read
1279:   m_dblTPINbrhoodParam1 = Stream.Read
1280:   m_dblTPINbrhoodParam2 = Stream.Read
1281:   m_dblTPINbrhoodParam3 = Stream.Read
1282:   m_lngSlope3TPIType = Stream.Read
1283:   m_lngSlope3TPIShape = Stream.Read
1284:   m_lngSlope3TPISizeUnits = Stream.Read
1285:   m_dblSlope3TPINbrhoodParam1 = Stream.Read
1286:   m_dblSlope3TPINbrhoodParam2 = Stream.Read
1287:   m_dblSlope3TPINbrhoodParam3 = Stream.Read
1288:   m_dblSlope3SplitA = Stream.Read
1289:   m_dblSlope3SplitB = Stream.Read
1290:   m_booSlope3AddIntermediate = Stream.Read
1291:   m_strSlope3Name1 = Stream.Read
1292:   m_strSlope3Name2 = Stream.Read
1293:   m_strSlope3Name3 = Stream.Read
1294:   m_lngSlope4TPIType = Stream.Read
1295:   m_lngSlope4TPIShape = Stream.Read
1296:   m_lngSlope4TPISizeUnits = Stream.Read
1297:   m_dblSlope4TPINbrhoodParam1 = Stream.Read
1298:   m_dblSlope4TPINbrhoodParam2 = Stream.Read
1299:   m_dblSlope4TPINbrhoodParam3 = Stream.Read
1300:   m_dblSlope4SplitA = Stream.Read
1301:   m_dblSlope4SplitB = Stream.Read
1302:   m_dblSlope4SplitS = Stream.Read
1303:   m_booSlope4AddIntermediate = Stream.Read
1304:   m_strSlope4Name1 = Stream.Read
1305:   m_strSlope4Name2 = Stream.Read
1306:   m_strSlope4Name3 = Stream.Read
1307:   m_strSlope4Name4 = Stream.Read
1308:   m_lngSlope6TPIType = Stream.Read
1309:   m_lngSlope6TPIShape = Stream.Read
1310:   m_lngSlope6TPISizeUnits = Stream.Read
1311:   m_dblSlope6TPINbrhoodParam1 = Stream.Read
1312:   m_dblSlope6TPINbrhoodParam2 = Stream.Read
1313:   m_dblSlope6TPINbrhoodParam3 = Stream.Read
1314:   m_dblSlope6SplitA = Stream.Read
1315:   m_dblSlope6SplitB = Stream.Read
1316:   m_dblSlope6SplitC = Stream.Read
1317:   m_dblSlope6SplitD = Stream.Read
1318:   m_dblSlope6SplitS = Stream.Read
1319:   m_booSlope6AddIntermediate = Stream.Read
1320:   m_strSlope6Name1 = Stream.Read
1321:   m_strSlope6Name2 = Stream.Read
1322:   m_strSlope6Name3 = Stream.Read
1323:   m_strSlope6Name4 = Stream.Read
1324:   m_strSlope6Name5 = Stream.Read
1325:   m_strSlope6Name6 = Stream.Read
1326:   m_lngLandform10TPIType = Stream.Read
1327:   m_lngLandform10TPIShape = Stream.Read
1328:   m_lngLandform10TPISizeUnits = Stream.Read
1329:   m_dblLandform10TPINbrhoodParam1 = Stream.Read
1330:   m_dblLandform10TPINbrhoodParam2 = Stream.Read
1331:   m_dblLandform10TPINbrhoodParam3 = Stream.Read
1332:   m_dblLandform10SplitA = Stream.Read
1333:   m_dblLandform10SplitB = Stream.Read
1334:   m_dblLandform10SplitC = Stream.Read
1335:   m_dblLandform10SplitD = Stream.Read
1336:   m_dblLandform10SplitS = Stream.Read
1337:   m_booLandform10AddIntermediate = Stream.Read
1338:   m_strLandform10Name1 = Stream.Read
1339:   m_strLandform10Name2 = Stream.Read
1340:   m_strLandform10Name3 = Stream.Read
1341:   m_strLandform10Name4 = Stream.Read
1342:   m_strLandform10Name5 = Stream.Read
1343:   m_strLandform10Name6 = Stream.Read
1344:   m_strLandform10Name7 = Stream.Read
1345:   m_strLandform10Name8 = Stream.Read
1346:   m_strLandform10Name9 = Stream.Read
1347:   m_strLandform10Name10 = Stream.Read
1348:   m_ProgressDialogExpanded = Stream.Read
1349:   m_ProgressDialogCloseOnComplete = Stream.Read
1350:   m_booRasterExactCellValue = Stream.Read
1351:   m_booRasterInterpCellValue = Stream.Read
1352:   m_lngOutputChoice = Stream.Read
1353:   m_strFolderPath = Stream.Read
1354:   m_booClipLayers = Stream.Read
1355:   m_lngExportFormat = Stream.Read
1356:   m_booAddCombined = Stream.Read
1357:   m_strStatsFolder = Stream.Read
1358:   m_dblFuzzinessThreshold = Stream.Read
1359:   m_dblFuzzinessParam = Stream.Read
1360:   m_strTableFolderPath = Stream.Read
1361:   m_lngTableExportFormat = Stream.Read
1362:   m_booShouldExportTable = Stream.Read
1363:   m_lngSizeThreshold = Stream.Read
1364:   m_strTerminiFolderPath = Stream.Read
1365:   m_dblDataThreshold = Stream.Read
  
  Exit Sub
ErrorHandler:
  HandleError True, "IPersistVariant_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub IPersistVariant_Save(ByVal Stream As esriSystem.IVariantStream)
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
1376:   m_lngVersion = 1
  
1378:   Stream.Write m_lngVersion
1379:   Stream.Write m_strDirType
1380:   Stream.Write m_strDirPath
1381:   Stream.Write m_strRasterWS
1382:   Stream.Write m_lngOutputFormat
1383:   Stream.Write m_lngNbrHoodSize
1384:   Stream.Write m_booSetNoData
1385:   Stream.Write m_dblAddValue
1386:   Stream.Write m_booAddValue
1387:   Stream.Write m_lngDensNbrhoodSize
1388:   Stream.Write m_lngTPIType
1389:   Stream.Write m_lngTPIShape
1390:   Stream.Write m_lngTPISizeUnits
1391:   Stream.Write m_dblTPINbrhoodParam1
1392:   Stream.Write m_dblTPINbrhoodParam2
1393:   Stream.Write m_dblTPINbrhoodParam3
1394:   Stream.Write m_lngSlope3TPIType
1395:   Stream.Write m_lngSlope3TPIShape
1396:   Stream.Write m_lngSlope3TPISizeUnits
1397:   Stream.Write m_dblSlope3TPINbrhoodParam1
1398:   Stream.Write m_dblSlope3TPINbrhoodParam2
1399:   Stream.Write m_dblSlope3TPINbrhoodParam3
1400:   Stream.Write m_dblSlope3SplitA
1401:   Stream.Write m_dblSlope3SplitB
1402:   Stream.Write m_booSlope3AddIntermediate
1403:   Stream.Write m_strSlope3Name1
1404:   Stream.Write m_strSlope3Name2
1405:   Stream.Write m_strSlope3Name3
1406:   Stream.Write m_lngSlope4TPIType
1407:   Stream.Write m_lngSlope4TPIShape
1408:   Stream.Write m_lngSlope4TPISizeUnits
1409:   Stream.Write m_dblSlope4TPINbrhoodParam1
1410:   Stream.Write m_dblSlope4TPINbrhoodParam2
1411:   Stream.Write m_dblSlope4TPINbrhoodParam3
1412:   Stream.Write m_dblSlope4SplitA
1413:   Stream.Write m_dblSlope4SplitB
1414:   Stream.Write m_dblSlope4SplitS
1415:   Stream.Write m_booSlope4AddIntermediate
1416:   Stream.Write m_strSlope4Name1
1417:   Stream.Write m_strSlope4Name2
1418:   Stream.Write m_strSlope4Name3
1419:   Stream.Write m_strSlope4Name4
1420:   Stream.Write m_lngSlope6TPIType
1421:   Stream.Write m_lngSlope6TPIShape
1422:   Stream.Write m_lngSlope6TPISizeUnits
1423:   Stream.Write m_dblSlope6TPINbrhoodParam1
1424:   Stream.Write m_dblSlope6TPINbrhoodParam2
1425:   Stream.Write m_dblSlope6TPINbrhoodParam3
1426:   Stream.Write m_dblSlope6SplitA
1427:   Stream.Write m_dblSlope6SplitB
1428:   Stream.Write m_dblSlope6SplitC
1429:   Stream.Write m_dblSlope6SplitD
1430:   Stream.Write m_dblSlope6SplitS
1431:   Stream.Write m_booSlope6AddIntermediate
1432:   Stream.Write m_strSlope6Name1
1433:   Stream.Write m_strSlope6Name2
1434:   Stream.Write m_strSlope6Name3
1435:   Stream.Write m_strSlope6Name4
1436:   Stream.Write m_strSlope6Name5
1437:   Stream.Write m_strSlope6Name6
1438:   Stream.Write m_lngLandform10TPIType
1439:   Stream.Write m_lngLandform10TPIShape
1440:   Stream.Write m_lngLandform10TPISizeUnits
1441:   Stream.Write m_dblLandform10TPINbrhoodParam1
1442:   Stream.Write m_dblLandform10TPINbrhoodParam2
1443:   Stream.Write m_dblLandform10TPINbrhoodParam3
1444:   Stream.Write m_dblLandform10SplitA
1445:   Stream.Write m_dblLandform10SplitB
1446:   Stream.Write m_dblLandform10SplitC
1447:   Stream.Write m_dblLandform10SplitD
1448:   Stream.Write m_dblLandform10SplitS
1449:   Stream.Write m_booLandform10AddIntermediate
1450:   Stream.Write m_strLandform10Name1
1451:   Stream.Write m_strLandform10Name2
1452:   Stream.Write m_strLandform10Name3
1453:   Stream.Write m_strLandform10Name4
1454:   Stream.Write m_strLandform10Name5
1455:   Stream.Write m_strLandform10Name6
1456:   Stream.Write m_strLandform10Name7
1457:   Stream.Write m_strLandform10Name8
1458:   Stream.Write m_strLandform10Name9
1459:   Stream.Write m_strLandform10Name10
1460:   Stream.Write m_ProgressDialogExpanded
1461:   Stream.Write m_ProgressDialogCloseOnComplete
1462:   Stream.Write m_booRasterExactCellValue
1463:   Stream.Write m_booRasterInterpCellValue
1464:   Stream.Write m_lngOutputChoice
1465:   Stream.Write m_strFolderPath
1466:   Stream.Write m_booClipLayers
1467:   Stream.Write m_lngExportFormat
1468:   Stream.Write m_booAddCombined
1469:   Stream.Write m_strStatsFolder
1470:   Stream.Write m_dblFuzzinessThreshold
1471:   Stream.Write m_dblFuzzinessParam
1472:   Stream.Write m_strTableFolderPath
1473:   Stream.Write m_lngTableExportFormat
1474:   Stream.Write m_booShouldExportTable
1475:   Stream.Write m_lngSizeThreshold
1476:   Stream.Write m_strTerminiFolderPath
1477:   Stream.Write m_dblDataThreshold
  
  Exit Sub
ErrorHandler:
  HandleError True, "IPersistVariant_Save " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
