VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cmdImportFromR"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private m_pApp As IApplication
Private m_pMxDoc As IMxDocument
Private m_bitmap As IPictureDisp
Private m_pThisExt As TopoCorridor.clsExtension

Implements ICommand
Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\brost_climate_change\code\cmdImportFromR.cls"

 
Private Sub Class_Initialize()
  On Error GoTo ErrorHandler

15:   Set m_bitmap = LoadResPicture(117, vbResBitmap)

  Exit Sub
ErrorHandler:
  HandleError True, "Class_Initialize " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Class_Terminate()
  On Error GoTo ErrorHandler

'  MsgBox "Staring Command Terminate..."

27:   Set m_bitmap = Nothing
28:   Set m_pMxDoc = Nothing
29:   Set m_pApp = Nothing
30:   Set m_pThisExt = Nothing
  
 ' MsgBox "Ending Command Terminate..."
  
  Exit Sub
ErrorHandler:
  HandleError True, "Class_Terminate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Property Get ICommand_Enabled() As Boolean
  On Error GoTo ErrorHandler
  
42:   ICommand_Enabled = True
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Enabled " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Checked() As Boolean
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
54:    ICommand_Checked = False


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Checked " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Name() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
67:   ICommand_Name = "Import_From_R"


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Name " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Caption() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
80:   ICommand_Caption = "Land Facet &Clusters from 'R'..."


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Caption " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Tooltip() As String
  On Error GoTo ErrorHandler

  
92:   ICommand_Tooltip = ""
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Tooltip " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Message() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
104:   ICommand_Message = "Classify the landscape according to fuzzy cluster rules developed in R..."


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Message " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_HelpFile() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
117:   ICommand_HelpFile = ""


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_HelpFile " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_HelpContextID() As Long
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
130:   ICommand_HelpContextID = 0


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_HelpContextID " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Bitmap() As esriSystem.OLE_HANDLE
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here

144:   ICommand_Bitmap = m_bitmap.Handle


  Exit Property
ErrorHandler:
'  HandleError True, "ICommand_Bitmap " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Category() As String
  On Error GoTo ErrorHandler

  ' TODO: Add your implementation here
156:   ICommand_Category = "Land Facet Corridor Tools"

  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Category " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub ICommand_OnCreate(ByVal hook As Object)
  On Error GoTo ErrorHandler

166:   Set m_pApp = hook
167:   Set m_pMxDoc = m_pApp.Document
  Dim newUid As New UID
  Dim pExt As IExtension
170:   newUid.Value = "TopoCorridor.clsExtension"
171:   Set pExt = m_pApp.FindExtensionByCLSID(newUid)
172:   Set m_pThisExt = pExt
  
  Exit Sub
ErrorHandler:
  HandleError True, "ICommand_OnCreate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub ICommand_OnClick()
  On Error GoTo ErrorHandler
   
'  MsgBox "Placeholder for Import from R Tool..."
 
  ' CLEAR ANY EXISTING USER PARAMETERS

    Dim strOutputReport As String
187:     strOutputReport = "Operation Cancelled..."
    
189:   Set m_pThisExt.frmImportStep1Return = Nothing
190:   Set m_pThisExt.frmImportStep2Return = Nothing
191:   Set m_pThisExt.frmImportStep3Return = Nothing
  
  ' GET USER PARAMETERS
  Dim lngStep As Long
195:   lngStep = 1
  
  
  Dim pParams As esriSystem.IVariantArray
199:   Set pParams = New esriSystem.VarArray
200:   pParams.Add m_pApp
201:   pParams.Add m_pMxDoc
202:   pParams.Add m_pThisExt
  
'  MsgBox "About to define Step 1 Form..."
  Dim pForm1 As TopoCorridor.frmRImport_1
206:   Set pForm1 = New TopoCorridor.frmRImport_1
  
'  MsgBox "About to define Step 2 form..."
  Dim pForm2 As TopoCorridor.frmRImport_2
210:   Set pForm2 = New TopoCorridor.frmRImport_2
  
'  MsgBox "About to define Step 3 form..."
  Dim pForm3 As TopoCorridor.frmRImport_3
214:   Set pForm3 = New TopoCorridor.frmRImport_3
  
'  MsgBox "About to define Step 4 form..."
  Dim pForm4 As TopoCorridor.frmRImport_4
218:   Set pForm4 = New TopoCorridor.frmRImport_4
  
  
'  MsgBox "About to start loop..."
  
223:   m_pThisExt.InputStep = lngStep
  
225:   Do Until lngStep = 5
    Select Case lngStep
      Case 1
228:         Set pForm1.ArcApplication = pParams
229:         pForm1.Show vbModal
230:         If m_pThisExt.ShouldContinue = False Then
231:           m_pThisExt.InputStep = 5
232:         End If
        
      Case 2
235:         Set pForm2.ArcApplication = pParams
236:         pForm2.Show vbModal
'        MsgBox "Should Continue = " & CStr(m_pThisExt.ShouldContinue)
238:         If m_pThisExt.ShouldContinue = False Then
239:           m_pThisExt.InputStep = 5
240:         End If
        
      Case 3
243:         Set pForm3.ArcApplication = pParams
244:         pForm3.Show vbModal
'        MsgBox "Should Continue = " & CStr(m_pThisExt.ShouldContinue)
246:         If m_pThisExt.ShouldContinue = False Then
247:           m_pThisExt.InputStep = 5
248:         End If
      
      Case 4
251:         Set pForm4.ArcApplication = pParams
252:         pForm4.Show vbModal
'        MsgBox "Should Continue = " & CStr(m_pThisExt.ShouldContinue)
254:         If m_pThisExt.ShouldContinue = False Then
255:           m_pThisExt.InputStep = 5
256:         End If
257:     End Select
258:     lngStep = m_pThisExt.InputStep
259:   Loop
260:   If Not pForm1 Is Nothing Then
261:     Unload pForm1
262:   End If
263:   Set pForm1 = Nothing
  
265:   If Not pForm2 Is Nothing Then
266:     Unload pForm2
267:   End If
268:   Set pForm2 = Nothing
  
270:   If Not pForm3 Is Nothing Then
271:     Unload pForm3
272:   End If
273:   Set pForm3 = Nothing
  
275:   If Not pForm4 Is Nothing Then
276:     Unload pForm4
277:   End If
278:   Set pForm4 = Nothing
'  MsgBox "Forms Deleted"
'  Exit Sub
  
282:   If m_pThisExt.ShouldContinue = False Then
 '   MsgBox "Operation Canceled..."
284:     Set m_pThisExt.frmImportStep1Return = Nothing
285:     Set m_pThisExt.frmImportStep2Return = Nothing
286:     Set m_pThisExt.frmImportStep3Return = Nothing
    Exit Sub
288:   End If
   
290:   strOutputReport = TopoCorridor.LandFacetFunctions.CalcLandFacetRaster(pParams)
   
292:   Set pParams = Nothing
  Dim frmReportForm As TopoCorridor.frmReportDialog
294:   Set frmReportForm = New TopoCorridor.frmReportDialog
   
  ' SHOW NORMAL TEXT REPORT
297:   frmReportForm.txtReport.TextRTF = strOutputReport
298:   frmReportForm.txtReport.Locked = False
299:   frmReportForm.Caption = "Analysis Report:"
  
  ' COPY TEXT TO CLIPBOARD
302:   Clipboard.Clear
303:   Clipboard.SetText frmReportForm.txtReport.Text
  
305:   If Left(strOutputReport, 5) = "{\rtf" Then
306:     Clipboard.SetText strOutputReport, vbCFRTF
307:   Else
308:     Clipboard.SetText frmReportForm.txtReport.Text
309:   End If
  
311:   frmReportForm.Show vbModal
312:   Set frmReportForm = Nothing
    
  ' CLEAR MEMORY
315:   Set m_pThisExt.frmImportStep1Return = Nothing
316:   Set m_pThisExt.frmImportStep2Return = Nothing
317:   Set m_pThisExt.frmImportStep3Return = Nothing

  Dim pDirty As IDocumentDirty
320:   Set pDirty = m_pMxDoc
321:   pDirty.SetDirty
322:   m_pApp.Visible = True
  
  Exit Sub
ErrorHandler:
  HandleError True, "ICommand_OnClick " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4

328:   Set pForm1 = Nothing
329:   Set pForm2 = Nothing
330:   Set pForm3 = Nothing
331:   Set pForm4 = Nothing
332:   Set m_pThisExt.frmImportStep1Return = Nothing
333:   Set m_pThisExt.frmImportStep2Return = Nothing
334:   Set m_pThisExt.frmImportStep3Return = Nothing
End Sub
  


































