VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cmdShannon"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private m_pApp As IApplication
Private m_pMxDoc As IMxDocument
Private m_bitmap As IPictureDisp
Private m_pThisExt As TopoCorridor.clsExtension

Implements ICommand
Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\brost_climate_change\code\cmdShannon.cls"

 
Private Sub Class_Initialize()
  On Error GoTo ErrorHandler

15:   Set m_bitmap = LoadResPicture(101, vbResBitmap)

  Exit Sub
ErrorHandler:
  HandleError True, "Class_Initialize " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Class_Terminate()
  On Error GoTo ErrorHandler

25:   Set m_bitmap = Nothing
26:   Set m_pMxDoc = Nothing
27:   Set m_pApp = Nothing
28:   Set m_pThisExt = Nothing
  
  Exit Sub
ErrorHandler:
  HandleError True, "Class_Terminate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Property Get ICommand_Enabled() As Boolean
  On Error GoTo ErrorHandler
  
38:   ICommand_Enabled = True
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Enabled " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Checked() As Boolean
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
50:    ICommand_Checked = False


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Checked " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Name() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
63:   ICommand_Name = "Shannon"


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Name " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Caption() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
76:   ICommand_Caption = "&Shannon's Index..."


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Caption " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Tooltip() As String
  On Error GoTo ErrorHandler

  
88:   ICommand_Tooltip = "Shannon's Index"
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Tooltip " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Message() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
100:   ICommand_Message = "Calculate Shannon's Index for a Raster..."


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Message " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_HelpFile() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
113:   ICommand_HelpFile = ""


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_HelpFile " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_HelpContextID() As Long
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
126:   ICommand_HelpContextID = 0


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_HelpContextID " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Bitmap() As esriSystem.OLE_HANDLE
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here

140:   ICommand_Bitmap = m_bitmap.Handle


  Exit Property
ErrorHandler:
'  HandleError True, "ICommand_Bitmap " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Category() As String
  On Error GoTo ErrorHandler

  ' TODO: Add your implementation here
152:   ICommand_Category = "Land Facet Corridor Tools"

  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Category " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub ICommand_OnCreate(ByVal hook As Object)
  On Error GoTo ErrorHandler

162:   Set m_pApp = hook
163:   Set m_pMxDoc = m_pApp.Document
  Dim newUid As New UID
  Dim pExt As IExtension
166:   newUid.Value = "TopoCorridor.clsExtension"
167:   Set pExt = m_pApp.FindExtensionByCLSID(newUid)
168:   Set m_pThisExt = pExt
  
  Exit Sub
ErrorHandler:
  HandleError True, "ICommand_OnCreate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub ICommand_OnClick()
  On Error GoTo ErrorHandler
  
'  MsgBox "Placeholder for Jurisdiction ID Tool..."
  
  Dim pForm As TopoCorridor.frmLayerID
181:   Set pForm = New TopoCorridor.frmLayerID

  Dim pParams As esriSystem.IVariantArray
'  MsgBox "m_pThisExt is Nothing = " & CStr(m_pThisExt Is Nothing)
  
186:   Set pParams = New esriSystem.VarArray
187:   pParams.Add m_pApp
188:   pParams.Add m_pMxDoc
189:   pParams.Add m_pThisExt

191:   Set pForm.ArcApplication = pParams
192:   pForm.Show vbModal
193:   Set pForm = Nothing
  
  Dim pActiveView As IActiveView
196:   Set pActiveView = m_pMxDoc.FocusMap
197:   pActiveView.PartialRefresh esriViewGraphicSelection, Nothing, pActiveView.Extent
198:   DoEvents

200:   m_pApp.Visible = True
201:   If m_pThisExt.ShouldContinue = False Then
'    MsgBox "Function Canceled:" & vbCrLf & "Bailing out..."
    Exit Sub
204:   End If

  Dim pReturnArray As esriSystem.IVariantArray
207:   Set pReturnArray = m_pThisExt.frmLayerIDReturn
  
  Dim strReport As String
210:   strReport = TopoCorridor.TopoCor_Functions.CreateDiversityRaster(pParams, pReturnArray)

  Dim frmReportForm As New TopoCorridor.frmReportDialog
213:   frmReportForm.txtReport.TextRTF = strReport
214:   frmReportForm.Show vbModal
215:   Set frmReportForm = Nothing
  
  ' CLEAR MEMORY
218:   Set m_pThisExt.frmLayerIDReturn = Nothing

  Dim pDirty As IDocumentDirty
221:   Set pDirty = m_pMxDoc
222:   pDirty.SetDirty
223:   m_pApp.Visible = True
  
  Exit Sub
ErrorHandler:
  HandleError True, "ICommand_OnClick " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
  






























