VERSION 5.00
Begin VB.Form frmBasicTPI 
   Caption         =   " Topographic Position Index Parameters:"
   ClientHeight    =   5565
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6375
   Icon            =   "frmBasicTPI.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   5565
   ScaleWidth      =   6375
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox chkNull 
      Caption         =   "Set to NoData if any NoData cells in neighborhood"
      Height          =   330
      Left            =   495
      TabIndex        =   8
      Top             =   3615
      Width           =   5520
   End
   Begin VB.ComboBox cbxTPIOption 
      Height          =   315
      Left            =   3262
      TabIndex        =   2
      Text            =   "cbxTPIOption"
      Top             =   1395
      Width           =   2895
   End
   Begin VB.TextBox txtNbr3 
      Alignment       =   2  'Center
      Height          =   315
      Left            =   5145
      TabIndex        =   7
      Text            =   "txtNbr3"
      Top             =   3165
      Width           =   1020
   End
   Begin VB.TextBox txtNbr2 
      Alignment       =   2  'Center
      Height          =   315
      Left            =   5145
      TabIndex        =   6
      Text            =   "txtNbr2"
      Top             =   2730
      Width           =   1020
   End
   Begin VB.TextBox txtNbr1 
      Alignment       =   2  'Center
      Height          =   315
      Left            =   5145
      TabIndex        =   5
      Text            =   "txtNbr1"
      Top             =   2310
      Width           =   1020
   End
   Begin VB.ComboBox cbxSizeUnits 
      Height          =   315
      Left            =   450
      TabIndex        =   4
      Text            =   "cbxSizeUnits"
      Top             =   3090
      Width           =   2535
   End
   Begin VB.ComboBox cbxNbrHoodType 
      Height          =   315
      Left            =   450
      TabIndex        =   3
      Text            =   "cbxNbrHoodType"
      Top             =   2340
      Width           =   2535
   End
   Begin VB.ComboBox cbxLayers 
      Height          =   315
      Left            =   217
      TabIndex        =   1
      Text            =   "cbxLayers"
      Top             =   1395
      Width           =   2895
   End
   Begin VB.CommandButton cmdGetWorkspace 
      Height          =   360
      Left            =   5820
      Picture         =   "frmBasicTPI.frx":058A
      Style           =   1  'Graphical
      TabIndex        =   11
      ToolTipText     =   "Browse for Output Feature Class..."
      Top             =   4695
      Width           =   465
   End
   Begin VB.TextBox txtOutput 
      Height          =   330
      Left            =   165
      TabIndex        =   10
      Text            =   "txtOutput"
      Top             =   4710
      Width           =   5595
   End
   Begin VB.ComboBox cbxFormat 
      Height          =   315
      Left            =   3810
      Style           =   2  'Dropdown List
      TabIndex        =   9
      Top             =   4155
      Width           =   2460
   End
   Begin VB.CommandButton cmdManual 
      Caption         =   "Manual"
      Height          =   345
      Left            =   2662
      TabIndex        =   13
      Top             =   5220
      Width           =   1065
   End
   Begin VB.TextBox txtMessage 
      Height          =   960
      Left            =   90
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      TabStop         =   0   'False
      Text            =   "frmBasicTPI.frx":0600
      Top             =   75
      Width           =   6195
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   345
      Left            =   3727
      TabIndex        =   14
      Top             =   5220
      Width           =   1065
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   345
      Left            =   1582
      TabIndex        =   12
      Top             =   5220
      Width           =   1065
   End
   Begin VB.Label lblSelTPIType 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      Caption         =   "-- Select TPI Type --"
      Height          =   195
      Left            =   3975
      TabIndex        =   24
      Top             =   1155
      Width           =   1440
   End
   Begin VB.Label lblParam3 
      Alignment       =   1  'Right Justify
      Caption         =   "Inner Radius ="
      Height          =   195
      Left            =   3630
      TabIndex        =   23
      Top             =   3225
      Width           =   1455
   End
   Begin VB.Label lblParam2 
      Alignment       =   1  'Right Justify
      Caption         =   "Outer Radius ="
      Height          =   195
      Left            =   3600
      TabIndex        =   22
      Top             =   2790
      Width           =   1485
   End
   Begin VB.Label lblParam1 
      Alignment       =   1  'Right Justify
      Caption         =   "Inner Radius ="
      Height          =   195
      Left            =   3630
      TabIndex        =   21
      Top             =   2370
      Width           =   1455
   End
   Begin VB.Label lblNbrhoodSizeUnits 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      Caption         =   "Neighborhood Size Units"
      Height          =   195
      Left            =   825
      TabIndex        =   20
      Top             =   2820
      Width           =   1770
   End
   Begin VB.Label lblNbrhoodShape 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      Caption         =   "Neighborhood Shape"
      Height          =   195
      Left            =   945
      TabIndex        =   19
      Top             =   2040
      Width           =   1530
   End
   Begin VB.Label lblNbrOptions 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      Caption         =   "Neighborhood Options"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   -1  'True
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   195
      Left            =   4140
      TabIndex        =   18
      Top             =   1950
      Width           =   1920
   End
   Begin VB.Image imgNbrhoodParams 
      BorderStyle     =   1  'Fixed Single
      Height          =   2190
      Left            =   15
      Top             =   1815
      Width           =   6345
   End
   Begin VB.Label lblOutputName 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Output Raster Dataset Name:"
      Height          =   195
      Left            =   150
      TabIndex        =   17
      Top             =   4500
      Width           =   2100
   End
   Begin VB.Label lblFormat 
      Alignment       =   1  'Right Justify
      AutoSize        =   -1  'True
      Caption         =   "Output Raster Format:"
      Height          =   195
      Left            =   2160
      TabIndex        =   16
      Top             =   4215
      Width           =   1560
   End
   Begin VB.Image imgParamsBack 
      BorderStyle     =   1  'Fixed Single
      Height          =   1140
      Left            =   15
      Top             =   4020
      Width           =   6345
   End
   Begin VB.Image imgCornerBars 
      Height          =   225
      Left            =   6135
      Picture         =   "frmBasicTPI.frx":060F
      Top             =   5340
      Width           =   225
   End
   Begin VB.Label lblLayer 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      Caption         =   "-- Select DEM Raster Layer --"
      Height          =   195
      Left            =   622
      TabIndex        =   15
      Top             =   1155
      Width           =   2070
   End
   Begin VB.Image imgBackTop 
      BorderStyle     =   1  'Fixed Single
      Height          =   1785
      Left            =   15
      Top             =   15
      Width           =   6345
   End
End
Attribute VB_Name = "frmBasicTPI"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
 
Private m_pMxDoc As esriArcMapUI.IMxDocument
Private m_pApp As IApplication
Private Anchors As AnchorObjectList  ' Main anchor control object
Private m_pLayerArray As esriSystem.IVariantArray
Private m_pLayerFields As esriSystem.IVariantArray
Private m_strSelLayerName As String
Private m_booSelToggle As Boolean
Private m_pThisExt As TopoCorridor.clsExtension
Private m_ShapeTypeOption As JenLayerTypes
Private m_pReturnArray As esriSystem.IVariantArray
Private m_FieldTypeOption As JenFieldTypes
Private m_booIncludeNoIDField As Boolean
Private m_strOutputWorkspace As String
Private m_strOutputBasename As String
Private m_lngOutputWSType As JenDatasetTypes
Private m_booOutputFeatDataset As Boolean
Private m_strOutputFeatDatasetName As String
Private m_booOutputIsFClass As Boolean         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS

Private m_strRasterWS As String
Private m_pSaveFormats As esriSystem.IVariantArray
Private m_pFileExtensions As esriSystem.IVariantArray
Private m_strRasterName As String
Private m_pLayerNames As esriSystem.IStringArray
 
Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\brost_climate_change\code\frmBasicTPI.frm"
 
Public Property Set ArcApplication(ByVal pParams As esriSystem.IVariantArray)
  On Error GoTo ErrorHandler
 
33:   Set m_pApp = pParams.Element(0)
34:   Set m_pMxDoc = pParams.Element(1)
35:   Set m_pThisExt = pParams.Element(2)
 
  Dim pSelItem As IUnknown
38:   Set pSelItem = m_pMxDoc.SelectedItem
  Dim pLayer As IRasterLayer
  Dim lngIndex As Long
  Dim pUnknown As IUnknown

43:   m_strSelLayerName = ""
 
45:   If Not pSelItem Is Nothing Then
46:     If TypeOf pSelItem Is IRasterLayer Then
47:       Set pLayer = pSelItem
48:       m_strSelLayerName = pLayer.Name
49:     End If
50:   End If

  ' FILL LAYER ARRAY AND LISTBOX
53:   cbxLayers.Clear
  Dim lngStartSel As Long
55:   lngStartSel = 0
  Dim pTempLayerArray As esriSystem.IVariantArray
57:   Set pTempLayerArray = TopoCorridor.MyGeneralOperations.ReturnLayersByType(m_pMxDoc.FocusMap, ENUM_jenRasterLayers)
58:   Set m_pLayerArray = New esriSystem.VarArray
59:   Set m_pLayerNames = New esriSystem.strArray
  
  Dim pRastBandColl As IRasterBandCollection
  Dim pRastBand As IRasterBand
  Dim pRaster As IRaster
  Dim lngIndex2 As Long
  Dim lngSelCounter As Long
66:   lngSelCounter = -1
  Dim strBandName As String
  
69:   If pTempLayerArray.Count > 0 Then
70:     For lngIndex = 0 To pTempLayerArray.Count - 1
71:       Set pUnknown = pTempLayerArray.Element(lngIndex)
72:       If TypeOf pUnknown Is IRasterLayer Then
73:         Set pLayer = pUnknown
74:         If pLayer.Valid Then
75:           Set pRaster = pLayer.Raster
76:           Set pRastBandColl = pRaster
77:           If pRastBandColl.Count = 1 Then
78:             strBandName = pLayer.Name
79:             cbxLayers.AddItem strBandName
80:             m_pLayerNames.Add strBandName
81:             m_pLayerArray.Add pRastBandColl.Item(0)
82:             lngSelCounter = lngSelCounter + 1
83:             If pLayer.Name = m_strSelLayerName Then lngStartSel = lngSelCounter
84:           Else
85:             For lngIndex2 = 0 To pRastBandColl.Count - 1
86:               Set pRastBand = pRastBandColl.Item(lngIndex2)
87:               strBandName = pLayer.Name & " [Band " & CStr(lngIndex2 + 1) & "]"
88:               m_pLayerNames.Add strBandName
89:               cbxLayers.AddItem strBandName
90:               m_pLayerArray.Add pRastBandColl.Item(lngIndex2)
91:               lngSelCounter = lngSelCounter + 1
92:               If pLayer.Name = m_strSelLayerName Then lngStartSel = lngSelCounter
93:             Next lngIndex2
94:           End If
95:         End If
96:       End If
97:     Next lngIndex
98:     cbxLayers.ListIndex = lngStartSel
99:   End If
  
  Dim strBaseString As String
102:   strBaseString = strBaseString & "The topographic position index reflects the difference in elevation between a focal cell and all cells in the neighborhood.  This tool offers three methods for calculating TPI, which differ in units of the final TPI raster." & vbNewLine
103:   strBaseString = strBaseString & "1) Type TPI: Units are in elevation units (usually meters or feet)" & vbNewLine
104:   strBaseString = strBaseString & "2) Type Standardized Elevation:  Units are in Elevation standard deviations, standardized by the neighborhood elevation values." & vbNewLine
105:   strBaseString = strBaseString & "3) Type Standardized TPI:  Units are in TPI standard deviations, standardized by the entire TPI raster." & vbNewLine

107:   txtMessage.Text = strBaseString

109:   Set m_pSaveFormats = New esriSystem.VarArray
110:   Set m_pFileExtensions = New esriSystem.VarArray
  
112:   cbxFormat.Clear
  Dim strFileExtension As String
  Dim lngVersion As Long
  Dim strTypeName As String
  Dim strType As String
  
  ' GIVING UP ON SAVING TO FILE GEODATABASE RASTER....
  'lngVersion = TopoCorridor.aml_func_mod.ReturnArcGISVersionAlt(m_pMxDoc)
120:   lngVersion = 0
121:   If lngVersion >= 2 Then
122:     strTypeName = "File Geodatabase Raster"
123:     strType = "GDB"
124:     m_pSaveFormats.Add strType
125:     cbxFormat.AddItem strTypeName
126:     strFileExtension = ""
127:     m_pFileExtensions.Add strFileExtension
128:   End If
  
130:   strTypeName = "ESRI GRID"
131:   strType = "GRID"
132:   m_pSaveFormats.Add strType
133:   cbxFormat.AddItem strTypeName
134:   strFileExtension = ""
135:   m_pFileExtensions.Add strFileExtension
  
137:   strTypeName = "Imagine Image"
138:   strType = "IMAGINE Image"
139:   m_pSaveFormats.Add strType
140:   cbxFormat.AddItem strTypeName
141:   strFileExtension = ".img"
142:   m_pFileExtensions.Add strFileExtension
  
144:   strTypeName = "TIFF File"
145:   strType = "TIFF"
146:   m_pSaveFormats.Add strType
147:   cbxFormat.AddItem strTypeName
148:   strFileExtension = ".tif"
149:   m_pFileExtensions.Add strFileExtension
  
151:   strTypeName = "JPEG File"
152:   strType = "JPG"
153:   m_pSaveFormats.Add strType
154:   cbxFormat.AddItem strTypeName
155:   strFileExtension = ".jpg"
156:   m_pFileExtensions.Add strFileExtension
  
158:   strTypeName = "JPEG 2000 File"
159:   strType = "JP2"
160:   m_pSaveFormats.Add strType
161:   cbxFormat.AddItem strTypeName
162:   strFileExtension = ".jp2"
163:   m_pFileExtensions.Add strFileExtension
  
  Dim strFolder As String
166:   strFolder = m_pThisExt.DirectoryPath
167:   If strFolder = "" Or Not (TopoCorridor.aml_func_mod.ExistFileDir(strFolder)) Then
168:     strFolder = TopoCorridor.aml_func_mod.ReturnDir(TopoCorridor.aml_func_mod.GetMxDocPath(m_pApp))
169:   End If
170:   If Right(strFolder, 1) = "\" Then
171:     strFolder = Left(strFolder, Len(strFolder) - 1)
172:   End If
  
174:   If StrComp(Right(strFolder, 4), ".gdb") = 0 Then
175:     cbxFormat.ListIndex = 0
176:   Else
'    If m_pThisExt.OutputFormat = 0 Then
'      cbxFormat.ListIndex = 1
'    Else
180:       cbxFormat.ListIndex = m_pThisExt.OutputFormat
'    End If
182:   End If
    
  Dim pWS As IWorkspace
  Dim pWsFact As IWorkspaceFactory2
186:   If StrComp(Right(strFolder, 4), ".gdb", vbTextCompare) = 0 Then
187:     Set pWsFact = New FileGDBWorkspaceFactory
188:   Else
189:     Set pWsFact = New RasterWorkspaceFactory
190:   End If
191:   Set pWS = pWsFact.OpenFromFile(strFolder, Me.hWnd)
    
  Dim strSuggest As String
194:   If cbxFormat.Text = "ESRI GRID" Or cbxFormat.Text = "File Geodatabase Raster" Then
195:     strSuggest = TopoCorridor.MyGeneralOperations.MakeUniqueRasterName2 _
        (pWS, "TPI" & m_pFileExtensions.Element(cbxFormat.ListIndex), CBool(cbxFormat.Text = "ESRI GRID"))
197:     txtOutput.Text = strFolder & "\" & strSuggest
198:   Else
199:     strSuggest = TopoCorridor.MyGeneralOperations.MakeUniqueShapeFilename(strFolder & "\" & _
        "TPI" & m_pFileExtensions.Element(cbxFormat.ListIndex))
201:     txtOutput.Text = strSuggest
202:   End If
203:   txtOutput.SelStart = Len(txtOutput.Text)
  
205:   m_strRasterWS = pWS.PathName
206:   m_strRasterName = TopoCorridor.aml_func_mod.ReturnFilename(strSuggest)
    
  ' FILL TPI AND NEIGHBORHOOD OPTIONS
209:   cbxTPIOption.Clear
210:   cbxTPIOption.AddItem "TPI"
211:   cbxTPIOption.AddItem "Standardized Elevation"
212:   cbxTPIOption.AddItem "Standardized TPI"
213:   cbxTPIOption.ListIndex = m_pThisExt.TPIType
  
215:   cbxNbrHoodType.Clear
216:   cbxNbrHoodType.AddItem "Circle"
217:   cbxNbrHoodType.AddItem "Rectangle"
218:   cbxNbrHoodType.AddItem "Annulus"
219:   cbxNbrHoodType.AddItem "Wedge"
220:   cbxNbrHoodType.ListIndex = m_pThisExt.TPIShape
  
222:   cbxSizeUnits.Clear
223:   cbxSizeUnits.AddItem "Cells"
224:   cbxSizeUnits.AddItem "DEM Horizontal Units"
225:   cbxSizeUnits.ListIndex = m_pThisExt.TPISizeUnits
  
227:   If m_pThisExt.TPINbrhoodParam1 <= 0 Then
228:     txtNbr1.Text = ""
229:   Else
230:     txtNbr1.Text = CStr(m_pThisExt.TPINbrhoodParam1)
231:   End If
232:   If m_pThisExt.TPINbrhoodParam2 <= 0 Then
233:     txtNbr2.Text = ""
234:   Else
235:     txtNbr2.Text = CStr(m_pThisExt.TPINbrhoodParam2)
236:   End If
237:   If m_pThisExt.TPINbrhoodParam3 <= 0 Then
238:     txtNbr3.Text = ""
239:   Else
240:     txtNbr3.Text = CStr(m_pThisExt.TPINbrhoodParam3)
241:   End If
  
243:   If m_pThisExt.ExcludeIfAnyNull Then
244:     chkNull.Value = 1
245:   Else
246:     chkNull.Value = 0
247:   End If
  
249:   CheckEnable
  
  ' CLEAR INITIAL SELECTION
252:   Set m_pThisExt.frmTPIReturn = Nothing
253:   m_pThisExt.ShouldContinue = False

255:   Set pSelItem = Nothing
256:   Set pLayer = Nothing
257:   Set pUnknown = Nothing
258:   Set pTempLayerArray = Nothing
259:   Set pRastBandColl = Nothing
260:   Set pRastBand = Nothing
261:   Set pRaster = Nothing
262:   Set pWS = Nothing
263:   Set pWsFact = Nothing
  
 Exit Property
ErrorHandler:
  HandleError True, "ArcApplication " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Public Property Get ReturnArray() As esriSystem.IVariantArray
  On Error GoTo ErrorHandler
 
273:   Set ReturnArray = m_pReturnArray
 
  Exit Property
ErrorHandler:
  HandleError True, "ReturnArray " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub CheckEnable()
  On Error GoTo ErrorHandler
    
  Dim booNbrHoodParamsOK As Boolean
284:   booNbrHoodParamsOK = False
285:   lblParam1.Visible = True
  Select Case cbxNbrHoodType.Text
    Case "Circle"
288:       lblParam1.Caption = "Radius ="
289:       lblParam2.Visible = False
290:       txtNbr2.Visible = False
291:       lblParam3.Visible = False
292:       txtNbr3.Visible = False
293:       booNbrHoodParamsOK = (txtNbr1.Text <> "")
    Case "Rectangle"
295:       lblParam1.Caption = "Width ="
296:       lblParam2.Caption = "Height ="
297:       lblParam2.Visible = True
298:       txtNbr2.Visible = True
      
300:       lblParam3.Visible = False
301:       txtNbr3.Visible = False
302:       booNbrHoodParamsOK = (txtNbr1.Text <> "") And (txtNbr2.Text <> "")
    Case "Annulus"
304:       lblParam1.Caption = "Inner Radius ="
305:       lblParam2.Caption = "Outer Radius ="
306:       lblParam2.Visible = True
307:       txtNbr2.Visible = True
      
309:       lblParam3.Visible = False
310:       txtNbr3.Visible = False
311:       booNbrHoodParamsOK = (txtNbr1.Text <> "") And (txtNbr2.Text <> "")
      
    Case "Wedge"
314:       lblParam1.Caption = "Start Angle ="
315:       lblParam2.Caption = "End Angle ="
316:       lblParam2.Visible = True
317:       txtNbr2.Visible = True
318:       lblParam3.Caption = "Wedge Radius ="
319:       lblParam3.Visible = True
320:       txtNbr3.Visible = True
321:       booNbrHoodParamsOK = (txtNbr1.Text <> "") And (txtNbr2.Text <> "") And (txtNbr3.Text <> "")
    Case Else
323:   End Select
  
 ' lblParam1.Left = Me.Width - 1455 - lblParam1.Width
 ' lblParam2.Left = Me.Width - 1455 - lblParam2.Width
 ' lblParam3.Left = Me.Width - 1455 - lblParam3.Width
  
329:   Me.Refresh
  
331:   cmdOK.Enabled = cbxLayers.Text <> "" And txtOutput.Text <> "" And booNbrHoodParamsOK And _
      cbxTPIOption.Text <> ""
'  MsgBox lblParam1.Left
  Exit Sub
ErrorHandler:
  HandleError False, "CheckEnable " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cbxFormat_Click()
  On Error GoTo ErrorHandler

342:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "cbxFormat_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cbxNbrHoodType_Click()
  On Error GoTo ErrorHandler

352:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "cbxNbrHoodType_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cbxSizeUnits_Click()
  On Error GoTo ErrorHandler

362:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "cbxSizeUnits_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cbxTPIOption_Click()
  On Error GoTo ErrorHandler

372:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "cbxTPIOption_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub chkNull_Click()
  On Error GoTo ErrorHandler

382:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "chkNull_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdGetWorkspace_Click()


  On Error GoTo ErrorHandler
   ' Save to TIFF, IMAGINE Image, GRID and geodatabase
  Dim pGxBrowser As IGxDialog
  Dim pGxFilterCol As IGxObjectFilterCollection
  Dim pGxFilter As IGxObjectFilter
  Dim pGxObj As IGxObject
  Dim pName As IName
  Dim sName As String
  
  
  Dim booIs10 As Boolean
403:   booIs10 = TopoCorridor.aml_func_mod.IsVersion10
  
  ' Select input raster dataset
406:   Set pGxBrowser = New GxDialog
407:   pGxBrowser.AllowMultiSelect = False
408:   pGxBrowser.Title = "Specify Output TPI Raster Dataset"
409:   If TopoCorridor.aml_func_mod.FileExists(m_strRasterWS) Then
410:     pGxBrowser.StartingLocation = m_strRasterWS
411:   End If
  
413:   If Not booIs10 Then
414:     Set pGxFilter = New GxFilterRasterDatasets
    
416:     Set pGxFilterCol = pGxBrowser
417:     pGxFilterCol.AddFilter pGxFilter, True
418:   End If
  
  Dim iPos As Integer
421:   If pGxBrowser.DoModalSave(Me.hWnd) Then
422:     sName = pGxBrowser.Name
423:     iPos = InStrRev(sName, ".")
424:     If iPos > 0 Then
425:       sName = Left(sName, iPos - 1)
426:     End If
    
428:     m_strRasterWS = pGxBrowser.FinalLocation.FullName
429:     m_strRasterName = sName
430:     txtOutput.Text = m_strRasterWS & "\" & m_strRasterName
431:     txtOutput.SelStart = Len(txtOutput.Text)
    'Get the workspace
433:     Set pGxObj = pGxBrowser.FinalLocation
434:     Set pName = pGxObj.InternalObjectName
'    Set m_OutWs = pName.Open
    
    'geodatabase workspace
'    If Not m_OutWs Is Nothing Then m_Format = "SDR"
    
440:     If StrComp(Right(m_strRasterWS, 4), ".gdb", vbTextCompare) = 0 Then
441:       cbxFormat.ListIndex = 0
442:     End If
    
444:   End If
445:   CheckEnable
  
447:   GoTo CleanUp

  Exit Sub
ErrorHandler:
  HandleError True, "cmdGetWorkspace_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4

CleanUp:

455:   Set pGxBrowser = Nothing
456:   Set pGxFilterCol = Nothing
457:   Set pGxFilter = Nothing
458:   Set pGxObj = Nothing
459:   Set pName = Nothing

  
End Sub

Private Sub cmdManual_Click()
  On Error GoTo ErrorHandler

  ' CHANGE AS APPROPRIATE
  Dim strDir As String
469:   strDir = App.Path
470:   If Right(strDir, 1) <> "\" Then strDir = strDir & "\"
471:   strDir = strDir & "docs"
  
473:   Call TopoCorridor.MyGeneralOperations.OpenDoc("Land_Facet_Tools.pdf", strDir)
  Exit Sub
ErrorHandler:
  HandleError True, "cmdManual_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdCancel_Click()
  On Error GoTo ErrorHandler

482:   m_pThisExt.ShouldContinue = False
483:   Set m_pThisExt.frmTPIReturn = Nothing
484:   Set m_pReturnArray = Nothing
485:   Unload Me
 
  Exit Sub
ErrorHandler:
  HandleError True, "cmdCancel_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdOK_Click()
  On Error GoTo ErrorHandler

  ' RETURN ARRAY IS IVariantArray, CONTAINING:
  ' 0) IRasterBand: SELECTED RASTER BAND
  ' 1) STRING: Save Format
  ' 2) STRING: TEXT VERSION OF SAVE FORMAT
  ' 3) STRING: New Raster Name
  ' 4) BOOLEAN: Whether new workspace is File Geodatabase
  ' 5) IWORKSPACE: Either an IRasterWorkspace2 or an IRasterWorkspaceEx
  ' 6) STRING: Extension for output
  ' 7) STRING: Name of Selected Raster Band
  ' 8) STRING: TPI Option; "TPI", "Standardized Elevation", "Standardized TPI"
  ' 9) INbrHood:  DEFINED NEIGHBORHOOD
  '10) STRING: Description of neighborhood
  '11) BOOLEAN: SET NODATA IF ANY NULL
    
  Dim lngIndex As Long
510:   Set m_pReturnArray = New esriSystem.VarArray
  
  ' SELECTED RASTER LAYER
  Dim pRasterBand As IRasterBand
514:   Set pRasterBand = m_pLayerArray.Element(cbxLayers.ListIndex)
515:   m_pReturnArray.Add pRasterBand
  
  Dim strWS As String
  Dim strFilename As String
  Dim pWS As IWorkspace
  Dim pWS2 As IWorkspace2
  Dim pRastWS As IRasterWorkspace2
  Dim pRastWsEx As IRasterWorkspaceEx
  Dim strFullPath As String
  Dim pWsFact As IWorkspaceFactory2
  Dim pDataset As IDataset
  Dim booIsFGB As Boolean
  Dim iPos As Integer
  Dim booExcludeIfAnyNull As Boolean
      
530:   strFullPath = txtOutput.Text
531:   strFilename = TopoCorridor.aml_func_mod.ReturnFilename(strFullPath)
532:   strWS = TopoCorridor.aml_func_mod.ReturnDir(strFullPath)
533:   If Right(strWS, 1) = "\" Then
534:     strWS = Left(strWS, Len(strWS) - 1)
535:   End If
  
  ' CLIP OFF ANY EXTENSIONS TO NAME
538:   iPos = InStrRev(strFilename, ".")
539:   If iPos > 0 Then
540:     strFilename = Left(strFilename, iPos - 1)
541:   End If
  
  ' MAKE SURE WORKSPACE EXISTS
544:   If Not TopoCorridor.aml_func_mod.ExistFileDir(strWS) Then
545:     MsgBox "Unable to create Raster:" & vbCrLf & _
           strWS & " is not a valid workspace...", , "Failed to Create Raster:"
547:     txtOutput.SetFocus
    Exit Sub
549:   End If
  
551:   booIsFGB = StrComp(Right(strWS, 4), ".gdb", vbTextCompare) = 0
  
  Dim lngVersion As Long
554:   lngVersion = TopoCorridor.aml_func_mod.ReturnArcGISVersionAlt(m_pMxDoc)
    
556:   If lngVersion < 2 And booIsFGB Then
557:     MsgBox "Problem:" & vbCrLf & _
           "You have selected a File Geodatabase workspace, but your version of ArcGIS does not " & vbCrLf & _
           "support file geodatabases.", , "Invalid Workspace Specified:"
560:     txtOutput.SetFocus
    Exit Sub
562:   End If
    
564:   If booIsFGB Then
565:     Set pWsFact = New FileGDBWorkspaceFactory
566:   Else
567:     Set pWsFact = New RasterWorkspaceFactory
568:   End If
569:   Set pWS = pWsFact.OpenFromFile(strWS, Me.hWnd)
    
  ' MAKE SURE FILE GEODATABASE IS SELECTED IF USER SPECIFIES SAVING TO FILE GEODATABASE
  Dim strFormat As String
573:   strFormat = m_pSaveFormats.Element(cbxFormat.ListIndex)
   
  '  MsgBox "strFormat = " & strFormat & vbCrLf & _
          "booIsFGB = " & CStr(booIsFGB) & vbCrLf & _
          "strWS = " & strWS
          
579:   If strFormat = "GDB" And (Not booIsFGB) Then
580:     MsgBox "Problem:" & vbCrLf & vbCrLf & _
           "You have selected to save your inverted raster as a File Geodatabase Raster, " & vbCrLf & _
           "but you have not specified an existing File Geodatabase to save the raster." & vbCrLf & vbCrLf & _
           "Please specify an existing file geodatabase.  If necessary, you may use ArcCatalog " & vbCrLf & _
           "to create a new empty file geodatabase.", , "Incorrect Workspace Specified:"
585:     txtOutput.SetFocus
    Exit Sub
587:   ElseIf strFormat <> "GDB" And booIsFGB Then
588:     MsgBox "Problem:" & vbCrLf & vbCrLf & _
           "You have selected to save your inverted raster as a " & cbxFormat.Text & ", " & vbCrLf & _
           "but you have specified a File Geodatabase workspace to save the raster." & vbCrLf & vbCrLf & _
           "File geodatabases can only store File Geodatabase rasters.  Either change " & vbCrLf & _
           "your format to 'File Geodatabase Raster', or select a different workspace.", , _
           "Incorrect Workspace Specified:"
594:     txtOutput.SetFocus
    Exit Sub
  
597:   End If
   
599:   m_pReturnArray.Add strFormat
600:   m_pReturnArray.Add cbxFormat.Text
601:   m_pReturnArray.Add strFilename
602:   m_pReturnArray.Add booIsFGB
603:   m_pReturnArray.Add pWS
604:   m_pReturnArray.Add m_pFileExtensions.Element(cbxFormat.ListIndex)
605:   m_pReturnArray.Add cbxLayers.List(cbxLayers.ListIndex)
  
  Dim strTPIType As String
608:   strTPIType = cbxTPIOption.Text
609:   m_pReturnArray.Add strTPIType
610:   m_pThisExt.TPIType = cbxTPIOption.ListIndex
  
  Dim strNbrHoodDesc As String
  Dim pNbrHood As IRasterNeighborhood
614:   Set pNbrHood = New RasterNeighborhood
  Dim dblMeanCellSize As Double
  Dim pRastProps As IRasterProps
617:   Set pRastProps = pRasterBand
618:   dblMeanCellSize = (pRastProps.MeanCellSize.X + pRastProps.MeanCellSize.Y) / 2
  
  Dim dblParam1 As Double
  Dim dblParam2 As Double
  Dim dblParam3 As Double
  
  Select Case cbxNbrHoodType.Text
    Case "Circle"
626:       If IsNumeric(txtNbr1.Text) Then
627:         dblParam1 = Abs(CDbl(txtNbr1.Text))
628:       Else
629:         MsgBox "Circle Radius must be a positive number!", , "Invalid Radius:"
630:         txtNbr1.SetFocus
        Exit Sub
632:       End If
      Select Case cbxSizeUnits.ListIndex
        Case 0      ' USING CELL UNITS
635:           strNbrHoodDesc = "Neighborhood = Circle [Radius = " & txtNbr1.Text & " cells]"
636:           pNbrHood.SetCircle dblParam1 * dblMeanCellSize * 1.0001, esriUnitsMap
        Case Else   ' USING MAP UNITS
638:           strNbrHoodDesc = "Neighborhood = Circle [Radius = " & txtNbr1.Text & " DEM Horizontal units]"
639:           pNbrHood.SetCircle dblParam1, esriUnitsMap
640:       End Select
      
642:       m_pThisExt.TPINbrhoodParam1 = CDbl(txtNbr1.Text)
      
    Case "Rectangle"
645:       If IsNumeric(txtNbr1.Text) Then
646:         dblParam1 = Abs(CDbl(txtNbr1.Text))
647:       Else
648:         MsgBox "Rectangle Width must be a positive number!", , "Invalid Width:"
649:         txtNbr1.SetFocus
        Exit Sub
651:       End If
652:       If IsNumeric(txtNbr2.Text) Then
653:         dblParam2 = Abs(CDbl(txtNbr2.Text))
654:       Else
655:         MsgBox "Rectangle Height must be a positive number!", , "Invalid Height:"
656:         txtNbr2.SetFocus
        Exit Sub
658:       End If
      Select Case cbxSizeUnits.ListIndex
        Case 0      ' USING CELL UNITS
661:           strNbrHoodDesc = "Neighborhood = Rectangle [Width = " & txtNbr1.Text & " cells, Height = " & _
              txtNbr2.Text & " cells]"
663:           pNbrHood.SetRectangle dblParam1 * dblMeanCellSize * 1.0001, _
              dblParam2 * dblMeanCellSize * 1.0001, esriUnitsMap
        Case Else   ' USING MAP UNITS
666:           strNbrHoodDesc = "Neighborhood = Rectangle [Width = " & txtNbr1.Text & _
              "DEM Horizontal units, Height = " & txtNbr2.Text & " DEM Horizontal units]"
668:           pNbrHood.SetRectangle dblParam1, dblParam2, esriUnitsMap
669:       End Select
      
671:       m_pThisExt.TPINbrhoodParam1 = CDbl(txtNbr1.Text)
672:       m_pThisExt.TPINbrhoodParam2 = CDbl(txtNbr2.Text)
      
    Case "Annulus"
675:       If IsNumeric(txtNbr1.Text) Then
676:         dblParam1 = Abs(CDbl(txtNbr1.Text))
677:       Else
678:         MsgBox "Inner Radius must be a positive number!", , "Invalid Inner Radius:"
679:         txtNbr1.SetFocus
        Exit Sub
681:       End If
682:       If IsNumeric(txtNbr2.Text) Then
683:         dblParam2 = Abs(CDbl(txtNbr2.Text))
684:       Else
685:         MsgBox "Outer Radius must be a positive number!", , "Invalid Outer Radius:"
686:         txtNbr2.SetFocus
        Exit Sub
688:       End If
689:       If dblParam2 <= dblParam1 Then
690:         MsgBox "Outer Radius must be larger than Inner Radius!", , "Invalid Radius Values:"
691:         txtNbr2.SetFocus
        Exit Sub
693:       End If
      Select Case cbxSizeUnits.ListIndex
        Case 0      ' USING CELL UNITS
696:           strNbrHoodDesc = "Neighborhood = Annulus [Inner Radius = " & txtNbr1.Text & " cells, Outer Radius = " & _
              txtNbr2.Text & " cells]"
698:           pNbrHood.SetAnnulus dblParam1 * dblMeanCellSize * 0.9999, _
                dblParam2 * dblMeanCellSize * 1.0001, esriUnitsMap
        Case Else   ' USING MAP UNITS
701:           strNbrHoodDesc = "Neighborhood = Annulus [Inner Radius = " & txtNbr1.Text & _
              "DEM Horizontal units, Outer Radius = " & txtNbr2.Text & " DEM Horizontal units]"
703:           pNbrHood.SetAnnulus dblParam1, dblParam2, esriUnitsMap
704:       End Select
      
706:       m_pThisExt.TPINbrhoodParam1 = CDbl(txtNbr1.Text)
707:       m_pThisExt.TPINbrhoodParam2 = CDbl(txtNbr2.Text)
    
    Case "Wedge"
710:       If IsNumeric(txtNbr1.Text) Then
711:         dblParam1 = Abs(CDbl(txtNbr1.Text))
712:       Else
713:         MsgBox "Start Angle must be a number!", , "Invalid Start Angle:"
714:         txtNbr1.SetFocus
        Exit Sub
716:       End If
717:       If IsNumeric(txtNbr2.Text) Then
718:         dblParam2 = Abs(CDbl(txtNbr2.Text))
719:       Else
720:         MsgBox "End Angle must be a number!", , "Invalid End Angle:"
721:         txtNbr2.SetFocus
        Exit Sub
723:       End If
724:       If IsNumeric(txtNbr3.Text) Then
725:         dblParam3 = Abs(CDbl(txtNbr3.Text))
726:       Else
727:         MsgBox "Wedge Radius must be a positive number!", , "Invalid Wedge Radius:"
728:         txtNbr3.SetFocus
        Exit Sub
730:       End If
      
      Select Case cbxSizeUnits.ListIndex
        Case 0      ' USING CELL UNITS
734:           strNbrHoodDesc = "Neighborhood = Wedge [Radius = " & txtNbr3.Text & " cells, Start Angle = " & _
              txtNbr1.Text & ", End Angle = " & txtNbr2.Text & "]"
736:           pNbrHood.SetWedge dblParam3 * dblMeanCellSize * 1.0001, _
                dblParam1, dblParam2, esriUnitsMap
        Case Else   ' USING MAP UNITS
739:           strNbrHoodDesc = "Neighborhood = Wedge [Radius = " & txtNbr3.Text & " DEM Horizontal units, Start Angle = " & _
              txtNbr1.Text & ", End Angle = " & txtNbr2.Text & "]"
741:           pNbrHood.SetWedge dblParam3, dblParam1, dblParam2, esriUnitsMap
742:       End Select
      
744:       m_pThisExt.TPINbrhoodParam1 = CDbl(txtNbr1.Text)
745:       m_pThisExt.TPINbrhoodParam2 = CDbl(txtNbr2.Text)
746:       m_pThisExt.TPINbrhoodParam3 = CDbl(txtNbr3.Text)
    Case Else
748:   End Select
  
750:   m_pReturnArray.Add pNbrHood
751:   m_pReturnArray.Add strNbrHoodDesc
752:   m_pThisExt.TPIShape = cbxNbrHoodType.ListIndex
753:   m_pThisExt.TPISizeUnits = cbxSizeUnits.ListIndex
  
  Dim booSetNoData As Boolean
756:   booSetNoData = chkNull.Value = 1
757:   m_pReturnArray.Add booSetNoData
758:   m_pThisExt.ExcludeIfAnyNull = booSetNoData
  
  ' MAKE SURE RASTER DOES NOT EXIST
  Dim lngVBResult As VbMsgBoxResult
762:   If booIsFGB Then
763:     Set pWS2 = pWS
764:     If pWS2.NameExists(esriDTRasterDataset, strFilename) Then
765:       lngVBResult = MsgBox("File '" & strFilename & "' Already exists!" & vbCrLf & _
             "Would you like this tool to attempt to delete the existing file?", vbYesNo, _
             "File Exists:")
768:       If lngVBResult = vbYes Then
769:         Set pRastWsEx = pWS
770:         Set pDataset = pRastWsEx.OpenRasterDataset(strFilename)
771:         If pDataset.CanDelete Then
772:           pDataset.DELETE
773:           If Not pWS2.NameExists(esriDTRasterDataset, strFilename) Then
774:             MsgBox "File Deleted..."
775:           End If
776:         Else
777:           MsgBox "Unable to delete '" & strFilename & "'..." & vbCrLf & _
            "Please delete this file manually before attempting to create a new raster with this name."
779:           txtOutput.SetFocus
          Exit Sub
781:         End If
782:       Else
783:         txtOutput.SetFocus
        Exit Sub
785:       End If
786:       txtOutput.SetFocus
      Exit Sub
788:     End If
789:   Else
790:     If TopoCorridor.aml_func_mod.ExistFileDir(strFullPath) Then
791:       lngVBResult = MsgBox("File '" & strFilename & "' Already exists!" & vbCrLf & _
             "Would you like this tool to attempt to delete the existing file?", vbYesNo, _
             "File Exists:")
794:       If lngVBResult = vbYes Then
795:         Set pRastWS = pWS
796:         Set pDataset = pRastWS.OpenRasterDataset(strFilename)
797:         If pDataset.CanDelete Then
798:           pDataset.DELETE
799:           If Not TopoCorridor.aml_func_mod.ExistFileDir(strFullPath) Then
800:             MsgBox "File Deleted..."
801:           End If
802:         Else
803:           MsgBox "Unable to delete '" & strFilename & "'..." & vbCrLf & _
            "Please delete this file manually before attempting to create a new raster with this name."
805:           txtOutput.SetFocus
          Exit Sub
807:         End If
808:       Else
809:         txtOutput.SetFocus
        Exit Sub
811:       End If
812:       txtOutput.SetFocus
      Exit Sub
814:     End If
815:   End If
816:   m_pThisExt.OutputFormat = cbxFormat.ListIndex
817:   m_pThisExt.DirectoryPath = strWS
818:   m_pThisExt.ShouldContinue = True

  Dim pSaveArray As esriSystem.IVariantArray
821:   Set pSaveArray = New esriSystem.VarArray
822:   For lngIndex = 0 To m_pReturnArray.Count - 1
823:     pSaveArray.Add m_pReturnArray.Element(lngIndex)
824:   Next lngIndex
825:   Set m_pThisExt.frmTPIReturn = pSaveArray
  
827:   Unload Me
      
'  Me.Visible = False

831:   Set pRasterBand = Nothing
832:   Set pWS = Nothing
833:   Set pWS2 = Nothing
834:   Set pRastWS = Nothing
835:   Set pRastWsEx = Nothing
836:   Set pWsFact = Nothing
837:   Set pDataset = Nothing
838:   Set pSaveArray = Nothing
 
  Exit Sub
ErrorHandler:
  HandleError True, "cmdOK_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub Form_Activate()
846:   CheckEnable
End Sub

Private Sub Form_Load()
  On Error GoTo ErrorHandler
 
852:   SetWindowPos Me.hWnd, -1, 0, 0, 0, 0, &H1 Or &H2
853:   Me.Left = (Screen.Width / 2) - (Me.Width / 2)
854:   Me.Top = (Screen.Height / 3) - (Me.Height / 3)
  Dim lngTopBar As Long
856:   lngTopBar = Me.Height - Me.ScaleHeight
857:   Me.Height = cmdOK.Top + cmdOK.Height + lngTopBar
 
859:    Set Anchors = New AnchorObjectList  ' Create new instance
860:    With Anchors
861:       With .Item(cbxFormat)
862:          .SetAnchors enumStartEnd, enumSizeEnd
863:       End With
864:       With .Item(cbxLayers)
865:          .SetAnchors enumStartEnd, enumSizeEnd
866:       End With
867:       With .Item(cbxNbrHoodType)
868:          .SetAnchors enumStartEnd, enumSizeEnd
869:       End With
870:       With .Item(cbxSizeUnits)
871:          .SetAnchors enumStartEnd, enumSizeEnd
872:       End With
873:       With .Item(cbxTPIOption)
874:          .SetAnchors enumSizeEnd, enumSizeEnd
875:       End With
876:       With .Item(chkNull)
877:          .SetAnchors enumStartEnd, enumSizeEnd
878:       End With
879:       With .Item(cmdCancel)
880:          .SetAnchors enumSizeEnd, enumSizeEnd
881:       End With
882:       With .Item(cmdGetWorkspace)
883:          .SetAnchors enumSizeEnd, enumSizeEnd
884:       End With
885:       With .Item(cmdManual)
886:          .SetAnchors enumSizeEnd, enumSizeEnd
887:       End With
888:       With .Item(cmdOK)
889:          .SetAnchors enumSizeEnd, enumSizeEnd
890:       End With
891:       With .Item(imgBackTop)
892:          .SetAnchors enumStartEnd, enumStartEnd
893:       End With
894:       With .Item(imgCornerBars)
895:          .SetAnchors enumSizeEnd, enumSizeEnd
896:       End With
897:       With .Item(imgNbrhoodParams)
898:          .SetAnchors enumStartEnd, enumSizeEnd
899:       End With
900:       With .Item(imgParamsBack)
901:          .SetAnchors enumStartEnd, enumSizeEnd
902:       End With
903:       With .Item(lblFormat)
904:          .SetAnchors enumStartSize, enumSizeEnd
905:       End With
906:       With .Item(lblLayer)
907:          .SetAnchors enumStartSize, enumSizeEnd
908:       End With
909:       With .Item(lblNbrhoodShape)
910:          .SetAnchors enumStartSize, enumSizeEnd
911:       End With
912:       With .Item(lblNbrhoodSizeUnits)
913:          .SetAnchors enumStartSize, enumSizeEnd
914:       End With
915:       With .Item(lblNbrOptions)
916:          .SetAnchors enumSizeEnd, enumSizeEnd
917:       End With
918:       With .Item(lblOutputName)
919:          .SetAnchors enumStartSize, enumSizeEnd
920:       End With
921:       With .Item(lblParam1)
922:          .SetAnchors enumSizeEnd, enumSizeEnd
923:       End With
924:       With .Item(lblParam2)
925:          .SetAnchors enumSizeEnd, enumSizeEnd
926:       End With
927:       With .Item(lblParam3)
928:          .SetAnchors enumSizeEnd, enumSizeEnd
929:       End With
930:       With .Item(lblSelTPIType)
931:          .SetAnchors enumSizeEnd, enumSizeEnd
932:       End With
933:       With .Item(txtMessage)
934:          .SetAnchors enumStartEnd, enumStartEnd
935:       End With
936:       With .Item(txtNbr1)
937:          .SetAnchors enumSizeEnd, enumSizeEnd
938:       End With
939:       With .Item(txtNbr2)
940:          .SetAnchors enumSizeEnd, enumSizeEnd
941:       End With
942:       With .Item(txtNbr3)
943:          .SetAnchors enumSizeEnd, enumSizeEnd
944:       End With
945:       With .Item(txtOutput)
946:          .SetAnchors enumStartEnd, enumSizeEnd
947:       End With
948:       .Form = Me  ' Set form reference (suggested to be last step)
949:    End With

 ' lblParam1.Left = Me.Width - 1455 - lblParam1.Width
 ' lblParam2.Left = Me.Width - 1455 - lblParam2.Width
 ' lblParam3.Left = Me.Width - 1455 - lblParam3.Width
  
955:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub Form_Unload(Cancel As Integer)
  On Error GoTo ErrorHandler
 
965:   Set m_pMxDoc = Nothing
966:   Set m_pApp = Nothing
967:   Set Anchors = Nothing
968:   Set m_pLayerArray = Nothing
969:   Set m_pLayerFields = Nothing
970:   Set m_pThisExt = Nothing
971:   Set m_pReturnArray = Nothing
972:   Set m_pSaveFormats = Nothing
973:   Set m_pFileExtensions = Nothing
974:   Set m_pLayerNames = Nothing
  
  Exit Sub
ErrorHandler:
  HandleError True, "Form_Unload " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cbxLayers_Click()
  On Error GoTo ErrorHandler

984:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "cbxLayers_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub ExtraCodeRequired()
 
  '' PUT IN EXTENSION CLASS
  '
  'Private m_booShouldContinue As Boolean
  'Private m_strDirPath As String
  'Private m_pfrmInvertRasterReturn As esriSystem.IVariantArray
  'Private m_strDirType As String
  'Private m_booIsFeatDataset As Boolean
  'Private m_strFeatDatasetName As String
  '
  '' PUT IN EXTENSION SHUTDOWN EVENT
  ' Set m_pfrmInvertRasterReturn = Nothing
  '
  '' SET FOLLOWING PROPERTIES
  'Public Property Let FeatDatasetName(strFeatDatasetName As String)
  '  m_strFeatDatasetName = strFeatDatasetName
  'End Property
  'Public Property Get FeatDatasetName() As String
  '  FeatDatasetName = m_strFeatDatasetName
  'End Property
  'Public Property Let IsFeatureDataset(booIsFeatDataset As Boolean)
  '  m_booIsFeatDataset = booIsFeatDataset
  'End Property
  'Public Property Get IsFeatureDataset() As Boolean
  '  IsFeatureDataset = m_booIsFeatDataset
  'End Property
  'Public Property Let DirectoryType(strDirType As String)
  '  m_strDirType = strDirType
  'End Property
  'Public Property Get DirectoryType() As String
  '  DirectoryType = m_strDirType
  'End Property
  '
  'Public Property Set frmInvertRasterReturn(pfrmInvertRasterReturn As esriSystem.IVariantArray)
  '  Set m_pfrmInvertRasterReturn = pfrmInvertRasterReturn
  'End Property
  '
  'Public Property Get frmInvertRasterReturn() As esriSystem.IVariantArray
  '  Set frmInvertRasterReturn = m_pfrmInvertRasterReturn
  'End Property
  '
  'Public Property Let DirectoryPath(strPath As String)
  '  On Error GoTo ErrorHandler
  '  m_strDirPath = strPath
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "DirectoryPath " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  'Public Property Get DirectoryPath() As String
  '  On Error GoTo ErrorHandler
  '  DirectoryPath = m_strDirPath
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "DirectoryPath " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  'Public Property Let ShouldContinue(booShouldContinue As Boolean)
  '  On Error GoTo ErrorHandler
  '  m_booShouldContinue = booShouldContinue
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "ShouldContinue " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  'Public Property Get ShouldContinue() As Boolean
  '  On Error GoTo ErrorHandler
  '  ShouldContinue = m_booShouldContinue
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "ShouldContinue " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  '' PUT IN EXTENSION STARTUP EVENT
  '  If m_strDirPath = "" Or m_strDirType = "" Then
  '    m_strDirType = "Shapefile"
  '    m_strDirPath = ""
  '    m_booIsFeatDataset = False
  '    m_strFeatDatasetName = ""
  '  End If
  '
  '===============================================================================================================
  '
' ' SAMPLE CODE
'    Dim pVarArray As esriSystem.IVariantArray
'    Set pVarArray = New VarArray
'
'    ' ADD APPLICATION
'    pVarArray.Add m_pApp
'
'    ' ADD DESIRED LAYER TYPES
'    Dim pLayerTypes As JenLayerTypes
'    pLayerTypes = ENUM_jenRasterLayers
'    pVarArray.Add pLayerTypes
'
'    'EXTENSION SHOULD HAVE PROPERTIES FOR "ShouldContinue", "DirectoryPath", "frmInvertRasterReturn",
'    '     "DirectoryType", "IsFeatureDataset", "FeatDatasetName"
'    pVarArray.Add m_pThisExt
'
'    ' ADD DESIRED FIELD TYPES
'    pVarArray.Add 0
'
'    ' ADD WHETHER TO INCLUDE ID FIELD
'    pVarArray.Add (False)
'
'    ' ADD WHETHER ANY OUTPUT WILL BE A FEATURE CLASS (TRUE) OR TABLE (FALSE)         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    Dim booOutputIsFClass As Boolean                                                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    booOutputIsFClass = True                                                         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    pVarArray.Add (booOutputIsFClass)                                                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'
'    Dim pForm As TopoCorridor.frmInvertRaster
'    Set pForm = New TopoCorridor.frmInvertRaster
'    Set pForm.ArcApplication = pVarArray
'    pForm.Show vbModal
'    Set pForm = Nothing
'
'    If m_pThisExt.ShouldContinue = False Then
'      MsgBox "Function Canceled:" & vbCrLf & "Bailing out..."
'      Exit Sub
'    End If
'
'    Dim pReturnArray As esrisystem.IVariantArray
'    Set pReturnArray = m_pThisExt.frmInvertRasterReturn
 
'    ' OUTPUT
'    ' SELECTED TABLE OR LAYER
'    Dim pUnknown As IUnknown
'    Set pUnknown = pReturnArray.Element(0)
'
'    ' FOR DEBUGGING
'    Dim strReport As String
'    strReport = "Selected Items:" & vbNewLine
'
'    If TypeOf pUnknown Is ILayer Then
'      Dim pLayer As ILayer
'      Set pLayer = pUnknown
'      strReport = strReport & "Name:  " & pLayer.Name & vbNewLine
'    ElseIf TypeOf pUnknown Is IStandaloneTable Then
'      Dim pStTab As IStandaloneTable
'      Set pStTab = pUnknown
'      strReport = strReport & "Name:  " & pStTab.Name & vbNewLine
'    End If
'


'  ' CODE SNIPPET TO USE pFieldNamePairs TO TRANSFER ATTRIBUTE DATA FROM OLD SOURCE TO NEW SOURCE
'  ' MAKE IVariantArray OF FIELD NAME INDICES
'  ' STRUCTURE:  ARRAY OF 4-ITEM VARIANT ARRAYS
'  '             ITEMS = 0) ORIGINAL FCLASS FIELD NAME
'  '                     1) ORIGINAL FCLASS FIELD INDEX
'  '                     2) NEW FCLASS FIELD NAME
'  '                     3) NEW FCLASS FIELD INDEX
'  Dim pFieldNamePairs As esriSystem.IVariantArray
'  Set pFieldNamePairs = pOutputArray.Element(9)
'  Dim pFieldNameData As esriSystem.IVariantArray
'  Set pFieldNameData = TopoCorridor.MyGeneralOperations.MakeFieldNameVarArray(pFeatureClass, pNewFClass, pFieldNamePairs, True)
'  Dim lngFieldIndex As Long
'  Dim pFieldSubArray As esriSystem.IVariantArray
'  ' ROTATE THROUGH ALL FEATURES / ROWS
'    ' TRANSFER ATTRIBUTE DATA; ASSUMES pBuffer ALREADY EXISTS
'    For lngFieldIndex = 0 To pFieldNameData.Count - 1
'      Set pFieldSubArray = pFieldNameData.Element(lngFieldIndex)
'      pBuffer.Value(pFieldSubArray.Element(3)) = pFeature.Value(pFieldSubArray.Element(1))
'    Next lngFieldIndex
'  ' LOOP

''  ' SAMPLE SNIPPET FOR FEATURE LAYERS:  ROTATE THROUGH ALL OR SELECTED RECORDS
''  Dim pFeatureLayer As IFeatureLayer
''  Dim pFClass As IFeatureClass
''  Dim pFeatSel As IFeatureSelection
''  Dim pSelSet As ISelectionSet
''  Dim pCursor As IFeatureCursor
''  Dim lngCount As Long
''
''  Set pFClass = pFeatureLayer.FeatureClass
''  Set pFeatSel = pFeatureLayer
''  Set pSelSet = pFeatSel.SelectionSet
''
''  If pSelSet.Count = 0 Then
''    Set pCursor = pFClass.Search(Nothing, False)
''    lngCount = pFClass.FeatureCount(Nothing)
''  Else
''    If booDoAll = True Then
''      Set pCursor = pFClass.Search(Nothing, False)
''      lngCount = pFClass.FeatureCount(Nothing)
''    Else
''      pSelSet.Search Nothing, True, pCursor
''      lngCount = pSelSet.Count
''    End If
''  End If
''
''  Dim pFeature As IFeature
''  Set pFeature = pCursor.NextFeature
''  Do Until pFeature Is Nothing
''    ' DO ACTIONS
''    Set pFeature = pCursor.NextFeature
''  Loop
''
''  ' SAMPLE CODE SNIPPET:  ADD RECORDS TO FEATURE CLASS USING BUFFER
''  Dim pBuffer As IFeatureBuffer
''  Set pBuffer = pFClass.CreateFeatureBuffer
''  Dim pNewFeatureCursor As IFeatureCursor
''  Set pNewFeatureCursor = pFClass.Insert(True)
''  ' LOOP THROUGH WHATEVER STEPS ARE REQUIRED TO GATHER DATA FOR A SINGLE ROW
''    Set pBuffer.Shape = aGeometry
''    pBuffer.Value(lngFieldIndex) = aValue
''    pNewFeatureCursor.InsertFeature pBuffer
''  ' LOOP
''  pNewFeatureCursor.Flush

''  ' SAMPLE SNIPPET FOR TABLES:  ROTATE THROUGH ALL OR SELECTED RECORDS
''  Dim pStandaloneTable As IStandaloneTable
''  Dim pInputTable As ITable
''  Dim pTableSel As ITableSelection
''  Dim pSelSet As ISelectionSet
''  Dim pRowCursor As ICursor
''  Dim lngCount As Long
''
''  Set pInputTable = pStandaloneTable.Table
''  Set pTableSel = pStandaloneTable
''  Set pSelSet = pTableSel.SelectionSet
''
''  If pSelSet.Count = 0 Then
''    Set pRowCursor = pInputTable.Search(Nothing, False)
''    lngCount = pInputTable.FeatureCount(Nothing)
''  Else
''    If booDoAll = True Then
''      Set pRowCursor = pInputTable.Search(Nothing, False)
''      lngCount = pInputTable.FeatureCount(Nothing)
''    Else
''      pSelSet.Search Nothing, True, pRowCursor
''      lngCount = pSelSet.Count
''    End If
''  End If
''
''  Dim pRow As IRow
''  Set pRow = pRowCursor.NextRow
''  Do Until pRow Is Nothing
'''     DO ACTIONS
''    Set pRow = pRowCursor.NextFeature
''  Loop
 
''  ' SAMPLE CODE SNIPPET:  ADD RECORDS TO TABLE USING BUFFER
''  Dim pBuffer As IRowBuffer
''  Set pBuffer = pTable.CreateRowBuffer
''  Dim pTableCursor As ICursor
''  Set pTableCursor = pTable.Insert(True)
''  ' LOOP THROUGH WHATEVER STEPS ARE REQUIRED TO GATHER DATA FOR A SINGLE ROW
''    pBuffer.Value(lngFieldIndex) = aValue
''    pTableCursor.InsertRow pBuffer
''  ' LOOP
''  pTableCursor.Flush
'    MsgBox strReport, vbOKOnly, "Test of LayerID Form:"
'
'  Dim pDocDirty As IDocumentDirty
'  Set pDocDirty = m_pMxDoc
'  pDocDirty.SetDirty
'

End Sub
 
Private Sub txtNbr1_Change()
  On Error GoTo ErrorHandler

1256:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "txtNbr1_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
Private Sub txtNbr2_Change()
  On Error GoTo ErrorHandler

1265:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "txtNbr2_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
Private Sub txtNbr3_Change()
  On Error GoTo ErrorHandler

1274:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "txtNbr3_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub txtNbr1_KeyPress(KeyAscii As Integer)
  On Error GoTo ErrorHandler

1284:   TopoCorridor.MyGeneralOperations.CheckNumericRealPositive KeyAscii, txtNbr1

  Exit Sub
ErrorHandler:
  HandleError True, "txtNbr1_KeyPress " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub txtNbr2_KeyPress(KeyAscii As Integer)
  On Error GoTo ErrorHandler

1294:   TopoCorridor.MyGeneralOperations.CheckNumericRealPositive KeyAscii, txtNbr2

  Exit Sub
ErrorHandler:
  HandleError True, "txtNbr2_KeyPress " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub txtNbr3_KeyPress(KeyAscii As Integer)
  On Error GoTo ErrorHandler

1304:   TopoCorridor.MyGeneralOperations.CheckNumericRealPositive KeyAscii, txtNbr3

  Exit Sub
ErrorHandler:
  HandleError True, "txtNbr3_KeyPress " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub txtOutput_Change()
  On Error GoTo ErrorHandler

1314:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "txtOutput_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
