VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "richtx32.Ocx"
Begin VB.Form frmClock 
   AutoRedraw      =   -1  'True
   BorderStyle     =   1  'Fixed Single
   Caption         =   " Tool Working:"
   ClientHeight    =   1065
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   3690
   Icon            =   "frmClock.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1065
   ScaleWidth      =   3690
   Begin RichTextLib.RichTextBox rtbReport 
      Height          =   1095
      Left            =   -15
      TabIndex        =   0
      Top             =   -15
      Width           =   2475
      _ExtentX        =   4366
      _ExtentY        =   1931
      _Version        =   393217
      ReadOnly        =   -1  'True
      ScrollBars      =   2
      TextRTF         =   $"frmClock.frx":728A
   End
   Begin VB.Timer Timer1 
      Interval        =   50
      Left            =   3255
      Top             =   630
   End
   Begin VB.Line lineHour 
      BorderColor     =   &H00008000&
      BorderWidth     =   2
      X1              =   3045
      X2              =   3265
      Y1              =   540
      Y2              =   540
   End
   Begin VB.Line lineMinute 
      BorderColor     =   &H00008000&
      BorderWidth     =   2
      X1              =   3045
      X2              =   3045
      Y1              =   540
      Y2              =   210
   End
   Begin VB.Line Line1 
      X1              =   3240
      X2              =   3270
      Y1              =   870
      Y2              =   922
   End
   Begin VB.Line Line2 
      X1              =   3390
      X2              =   3442
      Y1              =   735
      Y2              =   765
   End
   Begin VB.Line Line3 
      BorderWidth     =   2
      X1              =   3420
      X2              =   3510
      Y1              =   540
      Y2              =   540
   End
   Begin VB.Line Line4 
      X1              =   3390
      X2              =   3442
      Y1              =   345
      Y2              =   315
   End
   Begin VB.Line Line5 
      X1              =   3240
      X2              =   3270
      Y1              =   202
      Y2              =   150
   End
   Begin VB.Line Line6 
      BorderWidth     =   2
      X1              =   3045
      X2              =   3045
      Y1              =   165
      Y2              =   75
   End
   Begin VB.Line Line7 
      X1              =   2850
      X2              =   2820
      Y1              =   202
      Y2              =   150
   End
   Begin VB.Line Line8 
      X1              =   2707
      X2              =   2655
      Y1              =   345
      Y2              =   315
   End
   Begin VB.Line Line9 
      BorderWidth     =   2
      X1              =   2670
      X2              =   2580
      Y1              =   540
      Y2              =   540
   End
   Begin VB.Line Line10 
      X1              =   2707
      X2              =   2655
      Y1              =   735
      Y2              =   765
   End
   Begin VB.Line Line11 
      X1              =   2850
      X2              =   2820
      Y1              =   870
      Y2              =   922
   End
   Begin VB.Line Line12 
      BorderWidth     =   2
      X1              =   3045
      X2              =   3045
      Y1              =   915
      Y2              =   1005
   End
End
Attribute VB_Name = "frmClock"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Const m_lngMinuteLength As Long = 330
Const m_lngHourLength As Long = 220
Const m_lngStartX As Long = 3045
Const m_lngStartY As Long = 540
Private m_lngStep As Long
Private m_Frame As IModelessFrame
Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\brost_climate_change\code\frmClock.frm"


Public Function Frame() As IModelessFrame
  On Error GoTo ErrorHandler

15:   If m_Frame Is Nothing Then
16:     Set m_Frame = New ModelessFrame
17:     m_Frame.Create Me
18:     m_Frame.Caption = " Tool Working:"
19:   End If

21:   Set Frame = m_Frame

  Exit Function
ErrorHandler:
  HandleError True, "Frame " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Sub CalcEndCoords(lngStartX As Long, lngStartY As Long, theLength As Double, dblAzimuth As Double, _
  lngEndX As Long, lngEndY As Long)
  On Error GoTo ErrorHandler


' Jenness Enterprises <www.jennessent.com>
' Given an origin point, distance and bearing, this script will return a new point at that distance and bearing, and a line
' connecting that new point to the origin point

'' MAKE SURE AZIMUTH IS BETWEEN 0 AND 360
Dim theAzimuth As Double
39: theAzimuth = dblAzimuth


42: Do While theAzimuth < 0
43:   theAzimuth = theAzimuth + 360
44: Loop
45: theAzimuth = theAzimuth Mod 360
'
'' NEW SEGMENT AND POINT DISTANCE NORTH/SOUTH AND EAST/WEST BASED ON DISTANCE AND BEARING FROM ORIGIN.
'' THERE ARE EIGHT DIFFERENT POSSIBILITIES:  THE BEARING COULD BE ONE OF THE FOUR CARDINAL DIRECTIONS OR IT
'' COULD BE IN ONE OF THE FOUR QUADRANTS.  THE BEARING IS TREATED DIFFERENTLY IN EACH OF THESE CIRCUMSTANCES.
'' THE CALCULATION TO DETERMINE THE NEW POINT LOCATION IS ESSENTIALLY A MATTER OF TAKING THE SINE OR THE
'' COSINE OF THE ANGLE (AFTER CONVERTING IT TO RADIANS), AND MULTIPLYING THAT SINE OR COSINE BY THE MEASURED
'' DISTANCE.  PLEASE CONTACT THE AUTHOR IF THIS DOESN'T MAKE SENSE, OR IF YOU WOULD LIKE FURTHER EXPLANATION.
Dim NorthSouthDistance As Double
Dim EastWestDistance As Double
Dim EastWest As Integer
Dim NorthSouth As Integer

58: If theAzimuth = 0 Or theAzimuth = 360 Then
59:   NorthSouthDistance = theLength
60:   NorthSouth = 1
61:   EastWestDistance = 0
62:   EastWest = 1
63: ElseIf (theAzimuth = 180) Then
64:   NorthSouthDistance = theLength
65:   NorthSouth = -1
66:   EastWestDistance = 0
67:   EastWest = 1
68: ElseIf (theAzimuth = 90) Then
69:   NorthSouthDistance = 0
70:   NorthSouth = 1
71:   EastWestDistance = theLength
72:   EastWest = 1
73: ElseIf (theAzimuth = 270) Then
74:   NorthSouthDistance = 0
75:   NorthSouth = 1
76:   EastWestDistance = theLength
77:   EastWest = -1
78: ElseIf ((theAzimuth > 0) And (theAzimuth < 90)) Then
79:   NorthSouthDistance = Cos(AsRadians(theAzimuth)) * theLength
80:   NorthSouth = 1
81:   EastWestDistance = Sin(AsRadians(theAzimuth)) * theLength
82:   EastWest = 1
83: ElseIf ((theAzimuth > 90) And (theAzimuth < 180)) Then
84:   NorthSouthDistance = (Sin(AsRadians(theAzimuth - 90))) * theLength
85:   NorthSouth = -1
86:   EastWestDistance = (Cos(AsRadians(theAzimuth - 90))) * theLength
87:   EastWest = 1
88: ElseIf ((theAzimuth > 180) And (theAzimuth < 270)) Then
89:   NorthSouthDistance = (Cos(AsRadians(theAzimuth - 180))) * theLength
90:   NorthSouth = -1
91:   EastWestDistance = (Sin(AsRadians(theAzimuth - 180))) * theLength
92:   EastWest = -1
93: ElseIf ((theAzimuth > 270) And (theAzimuth < 360)) Then
94:   NorthSouthDistance = (Sin(AsRadians(theAzimuth - 270))) * theLength
95:   NorthSouth = 1
96:   EastWestDistance = (Cos(AsRadians(theAzimuth - 270))) * theLength
97:   EastWest = -1
98: End If

Dim theMovementNorth As Double
Dim theMovementWest As Double

103: theMovementNorth = -NorthSouthDistance * NorthSouth
104: theMovementWest = EastWestDistance * EastWest

106: lngEndX = lngStartX + theMovementWest
107: lngEndY = lngStartY + theMovementNorth


  Exit Sub
ErrorHandler:
  HandleError True, "CalcEndCoords " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Public Sub UpdateLines()

  On Error Resume Next
118:   m_lngStep = m_lngStep + 1
  
  Dim dblMinuteBearing As Double
  Dim dblHourBearing As Double
122:   dblMinuteBearing = CDbl(m_lngStep)
123:   dblHourBearing = CDbl(m_lngStep / 12)

'  Dim strTestString As String
'  strTestString = "aaa"
  
  Dim lngMinuteEndX As Long
  Dim lngMinuteEndY As Long
  Dim lngHourEndX As Long
  Dim lngHourEndY As Long
  
133:   CalcEndCoords 3045, 540, m_lngMinuteLength, dblMinuteBearing, lngMinuteEndX, lngMinuteEndY
134:   CalcEndCoords 3045, 540, m_lngHourLength, dblHourBearing, lngHourEndX, lngHourEndY
  

137:   lineMinute.X2 = lngMinuteEndX
138:   lineMinute.Y2 = lngMinuteEndY
139:   lineHour.X2 = lngHourEndX
140:   lineHour.Y2 = lngHourEndY
141:   DoEvents
142:   Me.Refresh

End Sub

Private Sub InitializeStuff()
  On Error GoTo ErrorHandler
  
'  Dim pClockObject As Object
'  Set pClockObject = pClock
 

153:   Me.Refresh
'  Me.Show
155:   DoEvents

'  txtProgress.Text = txtProgress.Text & vbCrLf & "Ready to Start..." & vbCrLf
'  txtProgress.SelStart = Len(txtProgress.Text)
159:   Me.SetFocus
160:   DoEvents
  

  Exit Sub
ErrorHandler:
  HandleError False, "InitializeStuff " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub




Private Sub Form_Unload(Cancel As Integer)
  On Error GoTo ErrorHandler

   
175:   Set m_Frame = Nothing

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Unload " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Timer1_Timer()
  On Error GoTo ErrorHandler

185:   UpdateLines

  Exit Sub
ErrorHandler:
  HandleError True, "Timer1_Timer " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Form_Load()
  On Error GoTo ErrorHandler


196:   SetWindowPos Me.hWnd, -1, 0, 0, 0, 0, &H1 Or &H2
197:   Me.Left = (3 * Screen.Width / 4) - (Me.Width / 2)
198:   Me.Top = (Screen.Height / 4) - (Me.Height / 2)
  
  'This sample is designed to perform license initialization on a system
  'that may have access to a floating license. It requires the spatial Analyst extension
  
'  Dim pClock As Argyll_Exe_2.frmClock
'  Set pClock = New Argyll_Exe_2.frmClock
'  pClock.Show vbModeless
'  pClock.txtMessage.Text = "Checking ArcGIS License..."
'  pClock.txtMessage.SelStart = Len(pClock.txtMessage.Text)

' SetWindowPos Me.hWnd, -1, 0, 0, 0, 0, &H1 Or &H2

211:   Call Frame
212:   DoEvents
  
 
'  lngTimer = 0
'  timTimer.Interval = 0
217:   m_lngStep = 0
218:   UpdateLines
    
  Exit Sub
ErrorHandler:
  HandleError True, "Form_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

