VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "richtx32.Ocx"
Begin VB.Form frmCovSourceBasic 
   Caption         =   " Source for Means and Covariances [Step 1 of 3]:"
   ClientHeight    =   7590
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6015
   Icon            =   "frmCovSourceBasic.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   7590
   ScaleWidth      =   6015
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox frmSelAll 
      Height          =   2010
      Left            =   3495
      ScaleHeight     =   1950
      ScaleWidth      =   2385
      TabIndex        =   18
      Top             =   3000
      Width           =   2445
      Begin VB.OptionButton optUseSelected 
         Caption         =   "Use Only Selected Points"
         Height          =   285
         Left            =   75
         TabIndex        =   15
         Top             =   1065
         Width           =   2265
      End
      Begin VB.OptionButton optUseAll 
         Caption         =   "Analyze All Points"
         Height          =   285
         Left            =   75
         TabIndex        =   14
         Top             =   285
         Width           =   2265
      End
      Begin VB.Label lblAll 
         AutoSize        =   -1  'True
         Caption         =   "n = [No Layer Selected]"
         Height          =   195
         Left            =   225
         TabIndex        =   20
         Top             =   600
         Width           =   1680
      End
      Begin VB.Label lblSelected 
         AutoSize        =   -1  'True
         Caption         =   "n = -9,999 of 20,000 points"
         Height          =   195
         Left            =   225
         TabIndex        =   19
         Top             =   1350
         Width           =   1905
      End
   End
   Begin VB.ComboBox cbxValue 
      Height          =   315
      Left            =   1710
      Style           =   2  'Dropdown List
      TabIndex        =   13
      Top             =   4680
      Width           =   3855
   End
   Begin VB.ListBox lbxLayers 
      Height          =   1620
      Left            =   90
      TabIndex        =   3
      Top             =   5625
      Width           =   3300
   End
   Begin VB.ListBox lbxFields 
      Height          =   1620
      Left            =   3405
      TabIndex        =   4
      Top             =   5625
      Width           =   2535
   End
   Begin VB.OptionButton optRaster 
      Caption         =   "Generate from categorical raster "
      Height          =   255
      Left            =   165
      TabIndex        =   1
      Top             =   2295
      Width           =   2625
   End
   Begin VB.OptionButton optPointTheme 
      Caption         =   "Generate from point layer"
      Height          =   255
      Left            =   165
      TabIndex        =   0
      Top             =   1935
      Width           =   2265
   End
   Begin VB.CommandButton cmdManual 
      Caption         =   "Manual"
      Height          =   345
      Left            =   2480
      TabIndex        =   6
      Top             =   5115
      Width           =   1065
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "Next --->"
      Default         =   -1  'True
      Height          =   345
      Left            =   3553
      TabIndex        =   7
      Top             =   5115
      Width           =   1065
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   345
      Left            =   1397
      TabIndex        =   5
      Top             =   5115
      Width           =   1065
   End
   Begin RichTextLib.RichTextBox txtMessage 
      Height          =   1500
      Left            =   0
      TabIndex        =   8
      Top             =   -15
      Width           =   6015
      _ExtentX        =   10610
      _ExtentY        =   2646
      _Version        =   393217
      Enabled         =   -1  'True
      ReadOnly        =   -1  'True
      ScrollBars      =   2
      TextRTF         =   $"frmCovSourceBasic.frx":058A
   End
   Begin VB.ListBox lbxPointLayers 
      Height          =   2010
      Left            =   90
      TabIndex        =   2
      Top             =   3000
      Width           =   3390
   End
   Begin VB.Label lblSource 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      Caption         =   "Identify Sample Source for Statistical Matrices"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   195
      Left            =   1020
      TabIndex        =   17
      Top             =   1590
      Width           =   3960
   End
   Begin VB.Label lblValue 
      Alignment       =   1  'Right Justify
      AutoSize        =   -1  'True
      Caption         =   "Category Value ="
      Height          =   195
      Left            =   435
      TabIndex        =   16
      Top             =   7320
      Width           =   1215
   End
   Begin VB.Label lblLine 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      Caption         =   "--  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  "
      Height          =   195
      Left            =   750
      TabIndex        =   12
      Top             =   2595
      Width           =   4500
   End
   Begin VB.Label lblRasters 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      Caption         =   "-- Select Categorical Raster --"
      Height          =   195
      Left            =   705
      TabIndex        =   11
      Top             =   2790
      Width           =   2070
   End
   Begin VB.Label lblRasterFields 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      Caption         =   "-- Select Raster Attribute Field --"
      Height          =   195
      Left            =   3540
      TabIndex        =   10
      Top             =   2790
      Width           =   2265
   End
   Begin VB.Label lblSelPointTheme 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      Caption         =   "-- Select Point Layer --"
      Height          =   195
      Left            =   1005
      TabIndex        =   9
      Top             =   2790
      Width           =   1560
   End
   Begin VB.Image imgCornerBars 
      Height          =   225
      Left            =   5790
      Picture         =   "frmCovSourceBasic.frx":0615
      Top             =   5235
      Width           =   225
   End
   Begin VB.Image imgBackTop 
      BorderStyle     =   1  'Fixed Single
      Height          =   3570
      Left            =   15
      Top             =   1500
      Width           =   5985
   End
End
Attribute VB_Name = "frmCovSourceBasic"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
 
Private m_pMxDoc As esriArcMapUI.IMxDocument
Private m_pApp As IApplication
Private Anchors As AnchorObjectList  ' Main anchor control object
Private m_pPointLayerArray As esriSystem.IVariantArray
Private m_pRasterLayerArray As esriSystem.IVariantArray
Private m_pTrueRasterLayerArray As esriSystem.IVariantArray
Private m_pTrueRasterLayerNames As esriSystem.IStringArray
Private m_pRasterLayerFields As esriSystem.IVariantArray
Private m_pTableLayerArray As esriSystem.IVariantArray
Private m_strSelLayerName As String
Private m_booSelToggle As Boolean
Private m_pThisExt As TopoCorridor.clsExtension
Private m_ShapeTypeOption As JenLayerTypes
Private m_pReturnArray As esriSystem.IVariantArray
Private m_FieldTypeOption As JenFieldTypes
Private m_booIncludeNoIDField As Boolean
Private m_strOutputWorkspace As String
Private m_strOutputBasename As String
Private m_lngOutputWSType As JenDatasetTypes
Private m_booOutputFeatDataset As Boolean
Private m_strOutputFeatDatasetName As String
Private m_booOutputIsFClass As Boolean         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
Private m_dblValues() As Double
Private m_lngPointCount As Long
Private m_lngSelPointCount As Long
 
Const c_sModuleFileName As String = "D:\arcGIS_stuff\general_tools\Mahalanobis\Code\frmCovSourceBasic.frm"
 
Public Property Set ArcApplication(ByVal pParams As esriSystem.IVariantArray)
  On Error GoTo ErrorHandler
 
34:   Set m_pApp = pParams.Element(0)
35:   Set m_pMxDoc = pParams.Element(1)
36:   Set m_pThisExt = pParams.Element(2)
  
  ' SET INITIAL SOURCE OPTION BASED ON LAST SETTING; MIGHT GET AUTOMATICALLY CHANGED IF NO DATA AVAILABLE
  Dim lngSourceOption As Long
40:   lngSourceOption = m_pThisExt.InitialSourceOption
41:   optPointTheme.Value = False
42:   optRaster.Value = False
  
  Select Case lngSourceOption
    Case 2
46:       optRaster.Value = True
    Case Else                         ' DEFAULT IF NOT BEEN DONE BEFORE
48:       optPointTheme.Value = True
49:   End Select
  
51:   Set m_pMxDoc = m_pApp.Document
 
  Dim pSelItem As IUnknown
54:   Set pSelItem = m_pMxDoc.SelectedItem
  Dim pLayer As ILayer
  Dim lngIndex As Long
  Dim pUnknown As IUnknown

59:   m_pThisExt.ShouldContinue = False
60:   m_booSelToggle = False

  ' FILL LAYER ARRAY AND LISTBOX
63:   lbxLayers.Clear
  Dim lngStartSel As Long
65:   lngStartSel = 0
  
  Dim pPointLayer As IFeatureLayer
  Dim pRasterLayer As IRasterLayer
  Dim pRastBandColl As IRasterBandCollection
  Dim pRaster As IRaster
  
  ' CLEAR AND FILL LISTBOXES
  ' POINT LAYERS
74:   Set m_pPointLayerArray = TopoCorridor.MyGeneralOperations.ReturnLayersByType(m_pMxDoc.FocusMap, ENUM_jenPointLayers)
75:   lbxPointLayers.Clear
76:   If m_pPointLayerArray.Count > 0 Then
77:     For lngIndex = 0 To m_pPointLayerArray.Count - 1
78:       Set pPointLayer = m_pPointLayerArray.Element(lngIndex)
79:       lbxPointLayers.AddItem CStr(lngIndex + 1) & "]  " & pPointLayer.Name
80:     Next lngIndex
81:     lbxPointLayers.ListIndex = -1
    
83:     lblAll.Enabled = False
84:     lblSelected.Enabled = False
85:     optUseAll.Enabled = False
86:     optUseSelected.Enabled = False
    
88:     optUseAll.Value = True
89:     lblAll.Caption = "n = [No Layer Selected]"
90:     lblSelected.Caption = "n = [No Layer Selected]"
    
92:   End If
  
  ' RASTER LAYERS
95:   Set m_pRasterLayerArray = TopoCorridor.MyGeneralOperations.ReturnLayersByType(m_pMxDoc.FocusMap, ENUM_jenRasterLayers)
96:   Set m_pRasterLayerFields = Nothing
97:   lbxLayers.Clear
98:   lbxFields.Clear
99:   cbxValue.Clear
  Dim lngRastCounter As Long
  Dim pEnumRasterBand As IEnumRasterBand
  Dim pRastBand As IRasterBand
103:   lngRastCounter = 0
  Dim lngIndex2 As Long
  
  Dim pTable As ITable
107:   Set m_pTrueRasterLayerArray = New esriSystem.VarArray
108:   Set m_pTrueRasterLayerNames = New esriSystem.strArray
  Dim strName As String
  
111:   If m_pRasterLayerArray.Count > 0 Then
112:     For lngIndex = 0 To m_pRasterLayerArray.Count - 1
113:       Set pRasterLayer = m_pRasterLayerArray.Element(lngIndex)
114:       Set pRastBandColl = pRasterLayer.Raster
115:       If pRastBandColl.Count > 1 Then
116:         For lngIndex2 = 0 To pRastBandColl.Count - 1
117:           Set pRastBand = pRastBandColl.Item(lngIndex2)
'          Set pTable = pRastBand.AttributeTable
119:           Set pTable = TopoCorridor.TopoCor_Functions.ReturnRasterTable(pRastBand)
120:           If Not pTable Is Nothing Then
121:             lngRastCounter = lngRastCounter + 1
122:             strName = pRasterLayer.Name & "   [Band #" & CStr(lngIndex2 + 1) & "]"
123:             lbxLayers.AddItem CStr(lngRastCounter) & "]  " & strName
124:             m_pTrueRasterLayerArray.Add pRastBand
125:             m_pTrueRasterLayerNames.Add strName
126:           End If
127:         Next lngIndex2
128:       Else
129:         Set pRastBand = pRastBandColl.Item(0)
'        Set pTable = pRastBand.AttributeTable
131:         Set pTable = TopoCorridor.TopoCor_Functions.ReturnRasterTable(pRastBand)
132:         If Not pTable Is Nothing Then
133:           lngRastCounter = lngRastCounter + 1
134:           strName = pRasterLayer.Name
135:           lbxLayers.AddItem CStr(lngRastCounter) & "]  " & strName
136:           m_pTrueRasterLayerArray.Add pRastBand
137:           m_pTrueRasterLayerNames.Add strName
138:         End If
139:       End If
140:     Next lngIndex
141:     lbxLayers.ListIndex = -1
142:   End If
  
  ' DISABLE OPTIONS IF NO DATA AVAILABLE
145:   If m_pPointLayerArray.Count = 0 Then
146:     If optPointTheme.Value = True Then
147:       optRaster.Value = True
148:       optPointTheme.Value = False
149:     End If
150:     optPointTheme.Value = False
151:     optPointTheme.Enabled = False
152:   End If
  
154:   If m_pTrueRasterLayerArray.Count = 0 Then
155:     If optRaster.Value = True Then
156:       If optPointTheme.Enabled Then
157:         optPointTheme.Value = True
158:       End If
159:     End If
160:     optRaster.Value = False
161:     optRaster.Enabled = False
162:   End If
  
  ' FILL INSTRUCTION BOX
  
  Dim strBaseString As String
167:   strBaseString = strBaseString & "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fswiss\fcharset0 Arial;}{\f1\fnil\fcharset0 MS Sans Serif;}}" & vbNewLine
168:   strBaseString = strBaseString & "\viewkind4\uc1\pard\f0\fs16 This tool will optionally calculate the Mean Vector, Covariance Matrix, Inverse Covariance Matrix, Correlation Matrix and Spearman's Rank Correlation (Rho) Matrix for raster or vector data occuring within specified regions of the landscape.  The Mean Vector and Covariance Matrix may then be used in Mahalanobis calculations, provided you take care to enter your Mahalanobis variables in the same order that you used to create the original Mean Vector and Covariance Matrix.  Please refer to the manual for additional information if this does not make sense. \f1\fs17 " & vbNewLine
169:   strBaseString = strBaseString & "\par }" & vbNewLine
170:   strBaseString = strBaseString & " " & vbNewLine

172:   txtMessage.TextRTF = strBaseString
  
  ' CLEAR INITIAL SELECTION
175:   Set m_pThisExt.frmCovSourceReturn = Nothing
176:   m_pThisExt.ShouldContinue = False
  
'  ' RELOAD IF NECESSARY
'  Dim pReloadParams As esriSystem.IVariantArray
'  Set pReloadParams = m_pThisExt.frmCovBasicReloadParams
'  If Not pReloadParams Is Nothing Then
'    optPointTheme.Value = pReloadParams.Element(0)
'    optRaster.Value = pReloadParams.Element(1)
'    lbxLayers.ListIndex = pReloadParams.Element(2)
'    If lbxLayers.ListIndex > -1 Then
'      Call lbxLayers_Click
'      lbxFields.ListIndex = pReloadParams.Element(3)
'      If lbxFields.ListIndex > -1 Then
'        Call lbxFields_Click
'        cbxValue.ListIndex = pReloadParams.Element(4)
'      End If
'    End If
'    lbxPointLayers.ListIndex = pReloadParams.Element(5)
'    If lbxPointLayers.ListIndex > -1 Then
'      Call lbxPointLayers_Click
'      optUseAll.Value = pReloadParams.Element(6)
'      optUseSelected.Value = Not pReloadParams.Element(6)
'    End If
'  End If
  
201:   CheckEnable
 
203:   Set pSelItem = Nothing
204:   Set pLayer = Nothing
205:   Set pUnknown = Nothing
206:   Set pPointLayer = Nothing
207:   Set pRasterLayer = Nothing
208:   Set pRastBandColl = Nothing
209:   Set pRaster = Nothing
210:   Set pEnumRasterBand = Nothing
211:   Set pRastBand = Nothing
212:   Set pTable = Nothing

 Exit Property
ErrorHandler:
  HandleError True, "ArcApplication " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Public Property Get ReturnArray() As esriSystem.IVariantArray
  On Error GoTo ErrorHandler
 
222:   Set ReturnArray = m_pReturnArray
 
  Exit Property
ErrorHandler:
  HandleError True, "ReturnArray " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub CheckEnable()
  On Error GoTo ErrorHandler
 
  Dim pGray As IColor
233:   Set pGray = New RgbColor
  
  Dim lngGray As Long
236:   lngGray = RGB(230, 230, 230)
  
238:   cmdOK.Enabled = lbxLayers.SelCount > 0 And lbxFields.SelCount > 0
239:   If optPointTheme.Value = True Then
240:     lblSelPointTheme.Visible = True
241:     lbxPointLayers.Visible = True
242:     lblAll.Visible = True
243:     lblSelected.Visible = True
244:     optUseAll.Visible = True
245:     optUseSelected.Visible = True
246:     frmSelAll.Visible = True
    
248:     lblRasters.Visible = False
249:     lblRasterFields.Visible = False
250:     lbxLayers.Visible = False
251:     lbxFields.Visible = False
252:     lblValue.Visible = False
253:     cbxValue.Visible = False
        
    ' CHECK IF OK SHOULD BE ENABLED
256:     cmdOK.Enabled = lbxPointLayers.SelCount > 0
    
258:   ElseIf optRaster.Value = True Then
259:     lblSelPointTheme.Visible = False
260:     lbxPointLayers.Visible = False
261:     lblAll.Visible = False
262:     lblSelected.Visible = False
263:     optUseAll.Visible = False
264:     optUseSelected.Visible = False
265:     frmSelAll.Visible = False
        
267:     lblRasters.Visible = True
268:     lblRasterFields.Visible = True
269:     lbxLayers.Visible = True
270:     lbxFields.Visible = True
271:     lblValue.Visible = True
272:     cbxValue.Visible = True
    
    ' CHECK IF OK SHOULD BE ENABLED
275:     cmdOK.Enabled = lbxLayers.SelCount > 0 And _
                    lbxFields.SelCount > 0 And _
                    cbxValue.ListIndex > 0 And _
                    cbxValue.Text <> ""
  
280:   End If
 
282:   Set pGray = Nothing
  Exit Sub
ErrorHandler:
  HandleError False, "CheckEnable " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cbxValue_Click()
  On Error GoTo ErrorHandler

291:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "cbxValue_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdManual_Click()
  On Error GoTo ErrorHandler
  ' CHANGE AS APPROPRIATE
  Dim strDir As String
302:   strDir = App.Path
303:   If Right(strDir, 1) <> "\" Then strDir = strDir & "\"
304:   strDir = strDir & "docs"
  
306:   Call TopoCorridor.MyGeneralOperations.OpenDoc("Land_Facet_Tools.pdf", strDir)
 
  Exit Sub
ErrorHandler:
  HandleError True, "cmdManual_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 

Private Sub cmdCancel_Click()
  On Error GoTo ErrorHandler
  
317:   m_pThisExt.ShouldContinue = False
318:   Set m_pThisExt.frmCovSourceReturn = Nothing
319:   Set m_pReturnArray = Nothing
320:   Unload Me
 
  Exit Sub
ErrorHandler:
  HandleError True, "cmdCancel_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdOK_Click()
  On Error GoTo ErrorHandler
  
330:   Set m_pReturnArray = New esriSystem.VarArray
  
  ' SOURCE OPTION
  Dim lngOption As Long
334:   If optPointTheme.Value = True Then
335:     lngOption = 1
336:   ElseIf optRaster.Value = True Then
337:     lngOption = 2
338:   End If
339:   m_pThisExt.InitialSourceOption = lngOption
  
  ' SOURCE PARAMETERS
  Dim pSourceParams As esriSystem.IVariantArray
343:   Set pSourceParams = New esriSystem.VarArray
  
  Select Case lngOption
    Case 1                       ' POINT THEME
      Dim pPointLayer As IFeatureLayer
348:       Set pPointLayer = m_pPointLayerArray.Element(lbxPointLayers.ListIndex)
349:       pSourceParams.Add pPointLayer
350:       pSourceParams.Add optUseAll.Value              ' TRUE IF USING ALL POINTS, FALSE IF ONLY USING SELECTED POINTS
351:       pSourceParams.Add m_lngPointCount              ' TOTAL POINT COUNT FOR THIS LAYER
352:       pSourceParams.Add m_lngSelPointCount           ' SELECTED POINT COUNT FOR THIS LAYER
      
354:       m_pReturnArray.Add lngOption
355:       m_pReturnArray.Add pSourceParams
    
    Case 2                       ' CATEGORICAL RASTER
      Dim pRasterBand As IRasterBand
      Dim strRasterName As String
      Dim pField As IField
      Dim lngFieldIndex As Long
      Dim pTable As ITable
      Dim varValue As Variant
      Dim booIsString As Boolean
      
366:       Set pRasterBand = m_pTrueRasterLayerArray.Element(lbxLayers.ListIndex)
367:       strRasterName = m_pTrueRasterLayerNames.Element(lbxLayers.ListIndex)
'      Set pTable = pRasterBand.AttributeTable
369:       Set pTable = TopoCorridor.TopoCor_Functions.ReturnRasterTable(pRasterBand)
370:       Set pField = m_pRasterLayerFields.Element(lbxFields.ListIndex)
371:       lngFieldIndex = pTable.FindField(pField.Name)
372:       booIsString = pField.Type = esriFieldTypeString
373:       If booIsString Then
374:         varValue = cbxValue.Text
375:       Else
376:         varValue = m_dblValues(cbxValue.ListIndex - 1)
377:       End If
      
379:       pSourceParams.Add pRasterBand
380:       pSourceParams.Add strRasterName
381:       pSourceParams.Add lngFieldIndex
382:       pSourceParams.Add booIsString
383:       pSourceParams.Add varValue
      
385:       m_pReturnArray.Add lngOption
386:       m_pReturnArray.Add pSourceParams
    
388:   End Select
  
  ' CHECK FOR MISSING PROJECTION
  Dim pGeoDataset As IGeoDataset
  Dim pSpRef As ISpatialReference
  Dim booHasMissingSpRef As Boolean
  Dim booHasUnknownSpRef As Boolean
  
396:   booHasMissingSpRef = False
397:   booHasUnknownSpRef = False
  Dim strSourceName As String
  Select Case lngOption
    Case 1     ' POINT LAYER
401:       Set pGeoDataset = pPointLayer.FeatureClass
402:       Set pSpRef = pGeoDataset.SpatialReference
403:       If pSpRef Is Nothing Then
404:         booHasMissingSpRef = True
405:       Else
406:         booHasUnknownSpRef = TypeOf pSpRef Is IUnknownCoordinateSystem
407:       End If
408:       strSourceName = pPointLayer.Name
      
    Case 2     ' RASTER
411:       Set pGeoDataset = pRasterBand
412:       Set pSpRef = pGeoDataset.SpatialReference
413:       If pSpRef Is Nothing Then
414:         booHasMissingSpRef = True
415:       Else
416:         booHasUnknownSpRef = TypeOf pSpRef Is IUnknownCoordinateSystem
417:       End If
418:       strSourceName = strRasterName
      
420:   End Select
  
  Dim booBailOut As Boolean
423:   booBailOut = booHasMissingSpRef Or booHasUnknownSpRef
  
  Dim strMessage As String
426:   If booHasMissingSpRef Then
427:     strMessage = _
      "WARNING:" & vbCrLf & "---------------------------------------------" & vbCrLf & _
      "Your source dataset for the mean and covariance sample locations (" & strSourceName & ") " & _
      "is missing a spatial reference.  This function must know the spatial reference in order " & _
      "to ensure that the sample locations align correctly with the input variable datasets. " & _
      "Please define the spatial reference of your sample source dataset before running this function."
433:   ElseIf booHasUnknownSpRef Then
434:     strMessage = _
      "WARNING:" & vbCrLf & "---------------------------------------------" & vbCrLf & _
      "Your source dataset for the mean and covariance sample locations (" & strSourceName & ") " & _
      "has an unknown spatial reference.  This function must know the spatial reference in order " & _
      "to ensure that the sample locations align correctly with the input variable datasets. " & _
      "Please define the spatial reference of your sample source dataset before running this function."
440:   End If
  
442:   If booBailOut Then
    Dim pParams As esriSystem.IVariantArray
444:     Set pParams = New esriSystem.VarArray
    
    Dim strHeader As String
    ' 1 = Yes / No
    ' 2 = OK / Cancel
    ' 3 = Yes / No / Cancel
    ' 4 = OK Only
451:     strHeader = "ERROR: Unknown or Missing Spatial Reference:"
  
453:     pParams.Add m_pApp
454:     pParams.Add 4
455:     pParams.Add strHeader                                                 ' DIALOG CAPTION
456:     pParams.Add strMessage                                                ' MESSAGE
  
    Dim pForm As TopoCorridor.frmMsgBox
459:     Set pForm = New TopoCorridor.frmMsgBox
460:     Set pForm.theParameters = pParams
461:     pForm.Show vbModal
  
    ' 0 = Cancel
    ' 1 = Yes / OK
    ' 2 = No
  
    ' MsgBox "Message Box Response = " & CStr(lngResponse)
    
469:     m_pThisExt.ShouldContinue = False
470:     m_pThisExt.InputStep = 3
471:     Set m_pThisExt.frmCovBasicReloadParams = Nothing
472:     Set m_pThisExt.frmCovSourceReturn = Nothing
    Exit Sub
474:   End If
  
  Dim pSaveArray As esriSystem.IVariantArray
477:   Set pSaveArray = New esriSystem.VarArray
  Dim lngIndex As Long
479:   For lngIndex = 0 To m_pReturnArray.Count - 1
480:     pSaveArray.Add m_pReturnArray.Element(lngIndex)
481:   Next lngIndex
482:   Set m_pThisExt.frmCovSourceReturn = pSaveArray
  
484:   m_pThisExt.ShouldContinue = True
485:   Set m_pThisExt.frmCovSourceReturn = m_pReturnArray
  
487:   m_pThisExt.InputStep = 2
  
489:   Me.Visible = False
  
491:   Set pSourceParams = Nothing
492:   Set pPointLayer = Nothing
493:   Set pRasterBand = Nothing
494:   Set pField = Nothing
495:   Set pTable = Nothing
496:   Set pGeoDataset = Nothing
497:   Set pSpRef = Nothing
498:   Set pParams = Nothing
499:   Set pForm = Nothing
500:   Set pSaveArray = Nothing
  
'  ' SAVE CURRENT STATE IN CASE USER CLICKS 'BACK' FROM NEXT DIALOG
'  Dim pReloadParams As esriSystem.IVariantArray
'  Set pReloadParams = New esriSystem.VarArray
'  pReloadParams.Add optPointTheme.Value
'  pReloadParams.Add optRaster.Value
'  pReloadParams.Add lbxLayers.ListIndex
'  pReloadParams.Add lbxFields.ListIndex
'  pReloadParams.Add lbxPointLayers.ListIndex
'  pReloadParams.Add cbxValue.ListIndex
'  pReloadParams.Add optUseAll.Value
'  Set m_pThisExt.frmCovBasicReloadParams = pReloadParams
  
'  Unload Me
  
  Exit Sub
ErrorHandler:
  HandleError True, "cmdOK_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Private Sub Form_Activate()
  On Error GoTo ErrorHandler

525:   m_pThisExt.ShouldContinue = False

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Activate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Form_Load()
  On Error GoTo ErrorHandler
 
535:   SetWindowPos Me.hWnd, -1, 0, 0, 0, 0, &H1 Or &H2
536:   Me.Left = (Screen.Width / 2) - (Me.Width / 2)
537:   Me.Top = (Screen.Height / 3) - (Me.Height / 3)
  
  Dim lngTopBar As Long
540:   lngTopBar = Me.Height - Me.ScaleHeight
541:   Me.Height = cmdOK.Top + cmdOK.Height + lngTopBar
542:   lbxFields.Top = 3000
543:   lbxLayers.Top = 3000
544:   cbxValue.Top = 4680
545:   lblValue.Top = 4725
 
547:    Set Anchors = New AnchorObjectList  ' Create new instance
548:    With Anchors
549:       With .Item(cbxValue)
550:          .SetAnchors enumStartEnd, enumSizeEnd
551:       End With
552:       With .Item(cmdCancel)
553:          .SetAnchors enumSizeEnd, enumSizeEnd
554:       End With
555:       With .Item(cmdManual)
556:          .SetAnchors enumSizeEnd, enumSizeEnd
557:       End With
558:       With .Item(cmdOK)
559:          .SetAnchors enumSizeEnd, enumSizeEnd
560:       End With

562:       With .Item(imgBackTop)
563:          .SetAnchors enumStartEnd, enumSizeEnd
564:       End With
565:       With .Item(imgCornerBars)
566:          .SetAnchors enumSizeEnd, enumSizeEnd
567:       End With

569:       With .Item(lblLine)
570:          .SetAnchors enumSize, enumSizeEnd
571:       End With
572:       With .Item(lblRasterFields)
573:          .SetAnchors enumSizeEnd, enumSizeEnd
574:       End With
575:       With .Item(lblRasters)
576:          .SetAnchors enumSize, enumSizeEnd
577:       End With
578:       With .Item(lblSelPointTheme)
579:          .SetAnchors enumSize, enumSizeEnd
580:       End With
581:       With .Item(lblSource)
582:          .SetAnchors enumSize, enumSizeEnd
583:       End With
584:       With .Item(lblValue)
585:          .SetAnchors enumStartSize, enumSizeEnd
586:       End With
      
588:       With .Item(lblAll)
589:          .SetAnchors enumSizeEnd, enumSizeEnd
590:       End With
591:       With .Item(lblSelected)
592:          .SetAnchors enumSizeEnd, enumSizeEnd
593:       End With
594:       With .Item(optUseAll)
595:          .SetAnchors enumSizeEnd, enumSizeEnd
596:       End With
597:       With .Item(optUseSelected)
598:          .SetAnchors enumSizeEnd, enumSizeEnd
599:       End With
600:       With .Item(frmSelAll)
601:          .SetAnchors enumSizeEnd, enumSizeEnd
602:       End With
      
604:       With .Item(lbxFields)
605:          .SetAnchors enumSizeEnd, enumSizeEnd
606:       End With
607:       With .Item(lbxLayers)
608:          .SetAnchors enumStartEnd, enumSizeEnd
609:       End With
      
611:       With .Item(lbxPointLayers)
612:          .SetAnchors enumStartEnd, enumSizeEnd
613:       End With
      
615:       With .Item(optPointTheme)
616:          .SetAnchors enumStartSize, enumSizeEnd
617:       End With
618:       With .Item(optRaster)
619:          .SetAnchors enumStartSize, enumSizeEnd
620:       End With
621:       With .Item(txtMessage)
622:          .SetAnchors enumStartEnd, enumStartEnd
623:       End With
624:       .Form = Me  ' Set form reference (suggested to be last step)
625:    End With


628:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub Form_Resize()
  On Error GoTo ErrorHandler

'  Dim lngRight As Long
'  Dim lngTopY As Long
'  Dim lngBottomY As Long
'
'  lngTopY = cmdOptions1.Top + (cmdOptions1.Height / 2)
'  lngBottomY = cmdOptions2.Top + (cmdOptions2.Height / 2)
'
'  lngRight = Me.Width - 2000
'
'  Line1.X2 = lngRight
'  Line1.Y1 = lngTopY
'  Line1.Y2 = lngTopY
'  Line2.X2 = lngRight
'  Line2.Y1 = lngBottomY
'  Line2.Y2 = lngBottomY

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Resize " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Form_Unload(Cancel As Integer)
  On Error GoTo ErrorHandler
  
662:   Set m_pMxDoc = Nothing
663:   Set m_pApp = Nothing
664:   Set Anchors = Nothing
665:   Set m_pPointLayerArray = Nothing
666:   Set m_pRasterLayerArray = Nothing
667:   Set m_pTrueRasterLayerArray = Nothing
668:   Set m_pTrueRasterLayerNames = Nothing
669:   Set m_pRasterLayerFields = Nothing
670:   Set m_pTableLayerArray = Nothing
671:   Set m_pThisExt = Nothing
672:   Set m_pReturnArray = Nothing

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Unload " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub lbxPointLayers_Click()
  On Error GoTo ErrorHandler
  
  Dim pFeatureLayer As IFeatureLayer
683:   Set pFeatureLayer = m_pPointLayerArray.Element(lbxPointLayers.ListIndex)
  Dim pFeatureClass As IFeatureClass
685:   Set pFeatureClass = pFeatureLayer.FeatureClass

  ' UPDATE CONVERSION OPTIONS
  Dim lngNumRecs As Long
  Dim lngSelRecs As Long
 
  Dim pSelSet As ISelectionSet

693:   lngNumRecs = pFeatureClass.FeatureCount(Nothing)
  Dim pFeatSel As IFeatureSelection
695:   Set pFeatSel = pFeatureLayer
696:   Set pSelSet = pFeatSel.SelectionSet

698:   lngSelRecs = pSelSet.Count
  
'  MsgBox "optUseAll Should Be True = " & CStr(lngSelRecs = 0)
701:   optUseAll.Value = lngSelRecs = 0
702:   optUseAll.Enabled = True
703:   lblAll.Enabled = True
'  MsgBox "optUseAll Is True = " & CStr(optUseAll.Value)
  
706:   optUseSelected.Enabled = Not lngSelRecs = 0
707:   optUseSelected.Value = Not lngSelRecs = 0
708:   lblSelected.Enabled = Not lngSelRecs = 0
  
'  MsgBox "optUseAll Is True (after OptUseSelected Value Set) = " & CStr(optUseAll.Value)
  
712:   lblAll.Caption = "n = " & CStr(Format(lngNumRecs, "#,##0")) & " points"
713:   lblSelected.Caption = "n = " & CStr(Format(lngSelRecs, "#,##0")) & _
      " of " & CStr(Format(lngNumRecs, "#,##0")) & " points"
 
716:   m_lngPointCount = lngNumRecs
717:   m_lngSelPointCount = lngSelRecs
  
719:   CheckEnable

721:   Set pFeatureLayer = Nothing
722:   Set pFeatureClass = Nothing
723:   Set pSelSet = Nothing
724:   Set pFeatSel = Nothing
  
  Exit Sub
ErrorHandler:
  HandleError True, "lbxPointLayers_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub lbxFields_Click()
  On Error GoTo ErrorHandler
  
  Dim pRasterBand As IRasterBand
735:   Set pRasterBand = m_pTrueRasterLayerArray.Element(lbxLayers.ListIndex)
  Dim pTable As ITable
'  Set pTable = pRasterBand.AttributeTable
738:   Set pTable = TopoCorridor.TopoCor_Functions.ReturnRasterTable(pRasterBand)
  
  Dim pFields As IFields
  Dim pField As IField
  Dim pFieldInfo As IFieldInfo
  
744:   Set pField = m_pRasterLayerFields.Element(lbxFields.ListIndex)
  
746:   cbxValue.Clear
747:   cbxValue.AddItem "Select Category Value from List Below:"
  
  Dim booIsString As Boolean
750:   booIsString = pField.Type = esriFieldTypeString
  
  Dim pCollection As New Collection
  Dim pRow As IRow
  Dim pCursor As ICursor
755:   Set pCursor = pTable.Search(Nothing, True)
756:   Set pRow = pCursor.NextRow
  
  Dim lngFieldIndex As Long
759:   lngFieldIndex = pTable.FindField(pField.Name)
  
  Dim lngCounter As Long
762:   lngCounter = -1
  Dim strTestValue As String
  Dim lngIndex As Long
  Dim dblValue As Double
  
767:   If booIsString Then
    Dim strValues() As String
    ReDim strValues(pTable.RowCount(Nothing))
    
771:     Do Until pRow Is Nothing
      
773:       strTestValue = pRow.Value(lngFieldIndex)
      
      ' CHECK IF VALUE ALREADY EXISTS
776:       If Not TopoCorridor.MyGeneralOperations.CheckCollectionForKey(pCollection, strTestValue) Then
777:         lngCounter = lngCounter + 1
778:         strValues(lngCounter) = strTestValue
779:         pCollection.Add 1, strTestValue
'      Else
781:       End If
      
783:       Set pRow = pCursor.NextRow
784:     Loop
    
    ReDim Preserve strValues(lngCounter)
787:     TopoCorridor.QuickSort.StringsAscending strValues, 0, lngCounter
    
789:     For lngIndex = 0 To lngCounter
790:       cbxValue.AddItem strValues(lngIndex)
791:     Next lngIndex
792:     cbxValue.ListIndex = 0
793:   Else
    Dim dblValues() As Double
    ReDim dblValues(pTable.RowCount(Nothing))
    
797:     Do Until pRow Is Nothing
      
799:       dblValue = pRow.Value(lngFieldIndex)
800:       strTestValue = CStr(Format(dblValue, "#.####################"))
801:       strTestValue = TopoCorridor.aml_func_mod.BasicTrimAvenue(strTestValue, "", ".")
      
      ' CHECK IF VALUE ALREADY EXISTS
804:       If Not TopoCorridor.MyGeneralOperations.CheckCollectionForKey(pCollection, strTestValue) Then
805:         lngCounter = lngCounter + 1
806:         dblValues(lngCounter) = dblValue
807:         pCollection.Add 1, strTestValue
 '     Else
809:       End If
      
811:       Set pRow = pCursor.NextRow
812:     Loop
    
    ReDim Preserve dblValues(lngCounter)
815:     TopoCorridor.QuickSort.DoubleAscending dblValues, 0, lngCounter
    
817:     For lngIndex = 0 To lngCounter
818:       cbxValue.AddItem dblValues(lngIndex)
819:     Next lngIndex
820:     cbxValue.ListIndex = 0
821:     m_dblValues = dblValues
822:   End If
    
    
  
  
827:   CheckEnable
 
829:   Set pRasterBand = Nothing
830:   Set pTable = Nothing
831:   Set pFields = Nothing
832:   Set pField = Nothing
833:   Set pFieldInfo = Nothing
834:   Set pCollection = Nothing
835:   Set pRow = Nothing
836:   Set pCursor = Nothing
  
  Exit Sub
ErrorHandler:
  HandleError True, "lbxFields_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub lbxLayers_Click()
  On Error GoTo ErrorHandler
  
  Dim pRasterBand As IRasterBand
847:   Set pRasterBand = m_pTrueRasterLayerArray.Element(lbxLayers.ListIndex)
  Dim pTable As ITable
'  Set pTable = pRasterBand.AttributeTable
850:   Set pTable = TopoCorridor.TopoCor_Functions.ReturnRasterTable(pRasterBand)
  
  Dim pFields As IFields
  Dim pField As IField
  Dim pFieldInfo As IFieldInfo

856:   Set pFields = pTable.Fields
857:   lbxFields.Clear
  
859:   Set m_pRasterLayerFields = TopoCorridor.MyGeneralOperations.ReturnFieldsByType(pFields, ENUM_FieldNumber + ENUM_FieldString)

  Dim lngIndex As Long
862:   For lngIndex = 0 To m_pRasterLayerFields.Count - 1
863:     Set pField = m_pRasterLayerFields.Element(lngIndex)
864:     lbxFields.AddItem pField.AliasName
865:   Next lngIndex
866:   lbxFields.ListIndex = -1

868:   CheckEnable

870:   Set pRasterBand = Nothing
871:   Set pTable = Nothing
872:   Set pFields = Nothing
873:   Set pField = Nothing
874:   Set pFieldInfo = Nothing
  Exit Sub
ErrorHandler:
  HandleError True, "lbxLayers_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub ExtraCodeRequired()
 
  '' PUT IN EXTENSION CLASS
  '
  'Private m_booShouldContinue As Boolean
  'Private m_strDirPath As String
  'Private m_pfrmCovSourceReturn As esriSystem.IVariantArray
  'Private m_strDirType As String
  'Private m_booIsFeatDataset As Boolean
  'Private m_strFeatDatasetName As String
  '
  '' PUT IN EXTENSION SHUTDOWN EVENT
  ' Set m_pfrmCovSourceReturn = Nothing
  '
  '' SET FOLLOWING PROPERTIES
  'Public Property Let FeatDatasetName(strFeatDatasetName As String)
  '  m_strFeatDatasetName = strFeatDatasetName
  'End Property
  'Public Property Get FeatDatasetName() As String
  '  FeatDatasetName = m_strFeatDatasetName
  'End Property
  'Public Property Let IsFeatureDataset(booIsFeatDataset As Boolean)
  '  m_booIsFeatDataset = booIsFeatDataset
  'End Property
  'Public Property Get IsFeatureDataset() As Boolean
  '  IsFeatureDataset = m_booIsFeatDataset
  'End Property
  'Public Property Let DirectoryType(strDirType As String)
  '  m_strDirType = strDirType
  'End Property
  'Public Property Get DirectoryType() As String
  '  DirectoryType = m_strDirType
  'End Property
  '
  'Public Property Set frmCovSourceReturn(pfrmCovSourceReturn As esriSystem.IVariantArray)
  '  Set m_pfrmCovSourceReturn = pfrmCovSourceReturn
  'End Property
  '
  'Public Property Get frmCovSourceReturn() As esriSystem.IVariantArray
  '  Set frmCovSourceReturn = m_pfrmCovSourceReturn
  'End Property
  '
  'Public Property Let DirectoryPath(strPath As String)
  '  On Error GoTo ErrorHandler
  '  m_strDirPath = strPath
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "DirectoryPath " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  'Public Property Get DirectoryPath() As String
  '  On Error GoTo ErrorHandler
  '  DirectoryPath = m_strDirPath
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "DirectoryPath " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  'Public Property Let ShouldContinue(booShouldContinue As Boolean)
  '  On Error GoTo ErrorHandler
  '  m_booShouldContinue = booShouldContinue
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "ShouldContinue " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  'Public Property Get ShouldContinue() As Boolean
  '  On Error GoTo ErrorHandler
  '  ShouldContinue = m_booShouldContinue
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "ShouldContinue " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  '' PUT IN EXTENSION STARTUP EVENT
  '  If m_strDirPath = "" Or m_strDirType = "" Then
  '    m_strDirType = "Shapefile"
  '    m_strDirPath = ""
  '    m_booIsFeatDataset = False
  '    m_strFeatDatasetName = ""
  '  End If
  '
  '===============================================================================================================
  '
' ' SAMPLE CODE
'    Dim pVarArray As esriSystem.IVariantArray
'    Set pVarArray = New VarArray
'
'    ' ADD APPLICATION
'    pVarArray.Add m_pApp
'
'    ' ADD DESIRED LAYER TYPES
'    Dim pLayerTypes As JenLayerTypes
'    pLayerTypes = ENUM_jenPointLayers + ENUM_jenRasterLayers
'    pVarArray.Add pLayerTypes
'
'    'EXTENSION SHOULD HAVE PROPERTIES FOR "ShouldContinue", "DirectoryPath", "frmCovSourceReturn",
'    '     "DirectoryType", "IsFeatureDataset", "FeatDatasetName"
'    pVarArray.Add m_pThisExt
'
'    ' ADD DESIRED FIELD TYPES
'    Dim pFieldTypes As JenFieldTypes
'    pFieldTypes =  ENUM_FieldNumber
'    pVarArray.Add pFieldTypes
'
'    ' ADD WHETHER TO INCLUDE ID FIELD
'    pVarArray.Add (False)
'
'    ' ADD WHETHER ANY OUTPUT WILL BE A FEATURE CLASS (TRUE) OR TABLE (FALSE)         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    Dim booOutputIsFClass As Boolean                                                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    booOutputIsFClass = True                                                         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    pVarArray.Add (booOutputIsFClass)                                                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'
'    Dim pForm As TopoCorridor.frmCovSource
'    Set pForm = New TopoCorridor.frmCovSource
'    Set pForm.ArcApplication = pVarArray
'    pForm.Show vbModal
'    Set pForm = Nothing
'
'    If m_pThisExt.ShouldContinue = False Then
'      MsgBox "Function Canceled:" & vbCrLf & "Bailing out..."
'      Exit Sub
'    End If
'
'    Dim pReturnArray As esrisystem.IVariantArray
'    Set pReturnArray = m_pThisExt.frmCovSourceReturn
 
'    ' OUTPUT
'    ' SELECTED TABLE OR LAYER
'    Dim pUnknown As IUnknown
'    Set pUnknown = pReturnArray.Element(0)
'
'    ' FOR DEBUGGING
'    Dim strReport As String
'    strReport = "Selected Items:" & vbNewLine
'
'    If TypeOf pUnknown Is ILayer Then
'      Dim pLayer As ILayer
'      Set pLayer = pUnknown
'      strReport = strReport & "Name:  " & pLayer.Name & vbNewLine
'    ElseIf TypeOf pUnknown Is IStandaloneTable Then
'      Dim pStTab As IStandaloneTable
'      Set pStTab = pUnknown
'      strReport = strReport & "Name:  " & pStTab.Name & vbNewLine
'    End If
'
'    ' SELECTED FIELD OR FIELDS
'    Dim pSelFields As esriSystem.IVariantArray
'    Set pSelFields = pReturnArray.Element(1)
'    strReport = strReport & CStr(pSelFields.Count) & " fields selected..." & vbNewLine
'
'    Dim pField As IField
'    Set pField = pSelFields.Element(0)
'    strReport = strReport & "First Selected Field is named '" & pField.Name & "'" & vbNewLine
'

''  ' SAMPLE SNIPPET FOR FEATURE LAYERS:  ROTATE THROUGH ALL OR SELECTED RECORDS
''  Dim pFeatureLayer As IFeatureLayer
''  Dim pFClass As IFeatureClass
''  Dim pFeatSel As IFeatureSelection
''  Dim pSelSet As ISelectionSet
''  Dim pCursor As IFeatureCursor
''  Dim lngCount As Long
''
''  Set pFClass = pFeatureLayer.FeatureClass
''  Set pFeatSel = pFeatureLayer
''  Set pSelSet = pFeatSel.SelectionSet
''
''  If pSelSet.Count = 0 Then
''    Set pCursor = pFClass.Search(Nothing, False)
''    lngCount = pFClass.FeatureCount(Nothing)
''  Else
''    If booDoAll = True Then
''      Set pCursor = pFClass.Search(Nothing, False)
''      lngCount = pFClass.FeatureCount(Nothing)
''    Else
''      pSelSet.Search Nothing, True, pCursor
''      lngCount = pSelSet.Count
''    End If
''  End If
''
''  Dim pFeature As IFeature
''  Set pFeature = pCursor.NextFeature
''  Do Until pFeature Is Nothing
''    ' DO ACTIONS
''    Set pFeature = pCursor.NextFeature
''  Loop
''
''  ' SAMPLE CODE SNIPPET:  ADD RECORDS TO FEATURE CLASS USING BUFFER
''  Dim pBuffer As IFeatureBuffer
''  Set pBuffer = pFClass.CreateFeatureBuffer
''  Dim pNewFeatureCursor As IFeatureCursor
''  Set pNewFeatureCursor = pFClass.Insert(True)
''  ' LOOP THROUGH WHATEVER STEPS ARE REQUIRED TO GATHER DATA FOR A SINGLE ROW
''    Set pBuffer.Shape = aGeometry
''    pBuffer.Value(lngFieldIndex) = aValue
''    pNewFeatureCursor.InsertFeature pBuffer
''  ' LOOP
''  pNewFeatureCursor.Flush

''  ' SAMPLE SNIPPET FOR TABLES:  ROTATE THROUGH ALL OR SELECTED RECORDS
''  Dim pStandaloneTable As IStandaloneTable
''  Dim pInputTable As ITable
''  Dim pTableSel As ITableSelection
''  Dim pSelSet As ISelectionSet
''  Dim pRowCursor As ICursor
''  Dim lngCount As Long
''
''  Set pInputTable = pStandaloneTable.Table
''  Set pTableSel = pStandaloneTable
''  Set pSelSet = pTableSel.SelectionSet
''
''  If pSelSet.Count = 0 Then
''    Set pRowCursor = pInputTable.Search(Nothing, False)
''    lngCount = pInputTable.FeatureCount(Nothing)
''  Else
''    If booDoAll = True Then
''      Set pRowCursor = pInputTable.Search(Nothing, False)
''      lngCount = pInputTable.FeatureCount(Nothing)
''    Else
''      pSelSet.Search Nothing, True, pRowCursor
''      lngCount = pSelSet.Count
''    End If
''  End If
''
''  Dim pRow As IRow
''  Set pRow = pRowCursor.NextRow
''  Do Until pRow Is Nothing
'''     DO ACTIONS
''    Set pRow = pRowCursor.NextFeature
''  Loop
 
''  ' SAMPLE CODE SNIPPET:  ADD RECORDS TO TABLE USING BUFFER
''  Dim pBuffer As IRowBuffer
''  Set pBuffer = pTable.CreateRowBuffer
''  Dim pTableCursor As ICursor
''  Set pTableCursor = pTable.Insert(True)
''  ' LOOP THROUGH WHATEVER STEPS ARE REQUIRED TO GATHER DATA FOR A SINGLE ROW
''    pBuffer.Value(lngFieldIndex) = aValue
''    pTableCursor.InsertRow pBuffer
''  ' LOOP
''  pTableCursor.Flush
'    MsgBox strReport, vbOKOnly, "Test of LayerID Form:"
'
'  Dim pDocDirty As IDocumentDirty
'  Set pDocDirty = m_pMxDoc
'  pDocDirty.SetDirty
'

End Sub

Private Sub optPointTheme_Click()
  On Error GoTo ErrorHandler

1134:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "optPointTheme_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub optRaster_Click()
  On Error GoTo ErrorHandler

1144:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "optRaster_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
