VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "richtx32.Ocx"
Begin VB.Form frmCovSourceVector 
   Caption         =   " Point Layer and Statistical Matrices [Step 1 of 3]:"
   ClientHeight    =   6570
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6015
   Icon            =   "frmCovSourceVector.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   6570
   ScaleWidth      =   6015
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox frmSelAll 
      Height          =   1425
      Left            =   3510
      ScaleHeight     =   1365
      ScaleWidth      =   2385
      TabIndex        =   16
      Top             =   2130
      Width           =   2445
      Begin VB.OptionButton optUseAll 
         Caption         =   "Analyze All Points"
         Height          =   285
         Left            =   75
         TabIndex        =   1
         Top             =   90
         Width           =   2265
      End
      Begin VB.OptionButton optUseSelected 
         Caption         =   "Use Only Selected Points"
         Height          =   285
         Left            =   75
         TabIndex        =   2
         Top             =   750
         Width           =   2265
      End
      Begin VB.Label lblSelected 
         AutoSize        =   -1  'True
         Caption         =   "n = -9,999 of 20,000 points"
         Height          =   195
         Left            =   225
         TabIndex        =   18
         Top             =   1035
         Width           =   1905
      End
      Begin VB.Label lblAll 
         AutoSize        =   -1  'True
         Caption         =   "n = [No Layer Selected]"
         Height          =   195
         Left            =   225
         TabIndex        =   17
         Top             =   405
         Width           =   1680
      End
   End
   Begin VB.CommandButton cmdManual 
      Caption         =   "Manual"
      Height          =   345
      Left            =   2480
      TabIndex        =   6
      Top             =   6225
      Width           =   1065
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "Next --->"
      Default         =   -1  'True
      Height          =   345
      Left            =   3553
      TabIndex        =   7
      Top             =   6225
      Width           =   1065
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   345
      Left            =   1397
      TabIndex        =   5
      Top             =   6225
      Width           =   1065
   End
   Begin VB.ListBox lbxCov 
      Height          =   1815
      Left            =   2970
      TabIndex        =   4
      Top             =   4290
      Width           =   2955
   End
   Begin VB.ListBox lbxMean 
      Height          =   1815
      Left            =   90
      TabIndex        =   3
      Top             =   4290
      Width           =   2850
   End
   Begin RichTextLib.RichTextBox txtMessage 
      Height          =   1500
      Left            =   0
      TabIndex        =   10
      Top             =   -15
      Width           =   6015
      _ExtentX        =   10610
      _ExtentY        =   2646
      _Version        =   393217
      ReadOnly        =   -1  'True
      ScrollBars      =   2
      TextRTF         =   $"frmCovSourceVector.frx":058A
   End
   Begin VB.ListBox lbxPointLayers 
      Height          =   1425
      Left            =   90
      TabIndex        =   0
      Top             =   2130
      Width           =   3390
   End
   Begin VB.Image imgBackBottom 
      BorderStyle     =   1  'Fixed Single
      Height          =   2520
      Left            =   0
      Top             =   3645
      Width           =   5985
   End
   Begin VB.Label lblLine2 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "--  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  "
      Height          =   195
      Left            =   750
      TabIndex        =   15
      Top             =   3885
      Width           =   4500
   End
   Begin VB.Label lblPoints 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Identify Point Layer"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   195
      Left            =   2160
      TabIndex        =   14
      Top             =   1590
      Width           =   1680
   End
   Begin VB.Label lblSource 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Identify Source for Mean Vector and Covariance Matrix"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   195
      Left            =   645
      TabIndex        =   13
      Top             =   3735
      Width           =   4710
   End
   Begin VB.Label lblLine 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "--  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  "
      Height          =   195
      Left            =   750
      TabIndex        =   12
      Top             =   1740
      Width           =   4500
   End
   Begin VB.Label lblSelPointTheme 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "-- Select Point Layer --"
      Height          =   195
      Left            =   1005
      TabIndex        =   11
      Top             =   1920
      Width           =   1560
   End
   Begin VB.Image imgCornerBars 
      Height          =   225
      Left            =   5790
      Picture         =   "frmCovSourceVector.frx":0615
      Top             =   6345
      Width           =   225
   End
   Begin VB.Label lblFields 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "-- Select Covariance Matrix --"
      Height          =   195
      Left            =   3420
      TabIndex        =   9
      Top             =   4065
      Width           =   2055
   End
   Begin VB.Label lblLayer 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "-- Select Mean Vector --"
      Height          =   195
      Left            =   675
      TabIndex        =   8
      Top             =   4065
      Width           =   1680
   End
   Begin VB.Image imgBackTop 
      BorderStyle     =   1  'Fixed Single
      Height          =   2115
      Left            =   15
      Top             =   1500
      Width           =   5985
   End
End
Attribute VB_Name = "frmCovSourceVector"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
 
Private m_pMxDoc As esriArcMapUI.IMxDocument
Private m_pApp As IApplication
Private Anchors As AnchorObjectList  ' Main anchor control object
Private m_pPointLayerArray As esriSystem.IVariantArray
Private m_pRasterLayerArray As esriSystem.IVariantArray
Private m_pTrueRasterLayerArray As esriSystem.IVariantArray
Private m_pTrueRasterLayerNames As esriSystem.IStringArray
Private m_pRasterLayerFields As esriSystem.IVariantArray
Private m_pMeanTableLayerArray As esriSystem.IVariantArray
Private m_pCovTableLayerArray As esriSystem.IVariantArray
Private m_strSelLayerName As String
Private m_booSelToggle As Boolean
Private m_pThisExt As TopoCorridor.clsExtension
Private m_ShapeTypeOption As JenLayerTypes
Private m_pReturnArray As esriSystem.IVariantArray
Private m_FieldTypeOption As JenFieldTypes
Private m_booIncludeNoIDField As Boolean
Private m_strOutputWorkspace As String
Private m_strOutputBasename As String
Private m_lngOutputWSType As JenDatasetTypes
Private m_booOutputFeatDataset As Boolean
Private m_strOutputFeatDatasetName As String
Private m_booOutputIsFClass As Boolean         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
Private m_dblValues() As Double
Private m_lngPointCount As Long
Private m_lngSelPointCount As Long
 
Const c_sModuleFileName As String = "D:\arcGIS_stuff\general_tools\Mahalanobis\Code\frmCovSourceVector.frm"
 
Public Property Set ArcApplication(ByVal pParams As esriSystem.IVariantArray)
  On Error GoTo ErrorHandler
 
35:   Set m_pApp = pParams.Element(0)
36:   Set m_pMxDoc = pParams.Element(1)
37:   Set m_pThisExt = pParams.Element(2)
   
39:   Set m_pMxDoc = m_pApp.Document
 
  Dim pSelItem As IUnknown
42:   Set pSelItem = m_pMxDoc.SelectedItem
  Dim pLayer As ILayer
  Dim pStandaloneTable As IStandaloneTable
  Dim lngIndex As Long
  Dim pUnknown As IUnknown

48:   m_pThisExt.ShouldContinue = False
49:   m_booSelToggle = False

  ' FILL LAYER ARRAY AND LISTBOX
  Dim pPointLayer As IFeatureLayer
  
  ' CLEAR AND FILL LISTBOXES
  ' POINT LAYERS
56:   Set m_pPointLayerArray = TopoCorridor.MyGeneralOperations.ReturnLayersByType(m_pMxDoc.FocusMap, ENUM_jenPointLayers)
57:   lbxPointLayers.Clear
58:   If m_pPointLayerArray.Count > 0 Then
59:     For lngIndex = 0 To m_pPointLayerArray.Count - 1
60:       Set pPointLayer = m_pPointLayerArray.Element(lngIndex)
61:       lbxPointLayers.AddItem CStr(lngIndex + 1) & "]  " & pPointLayer.Name
62:     Next lngIndex
63:     lbxPointLayers.ListIndex = -1
    
65:     lblAll.Enabled = False
66:     lblSelected.Enabled = False
67:     optUseAll.Enabled = False
68:     optUseSelected.Enabled = False
    
70:     optUseAll.Value = True
71:     lblAll.Caption = "n = [No Layer Selected]"
72:     lblSelected.Caption = "n = [No Layer Selected]"
    
74:   End If
    
  ' STANDALONE TABLES
  Dim pTableLayerArray As esriSystem.IVariantArray
78:   Set pTableLayerArray = TopoCorridor.MyGeneralOperations.ReturnLayersByType(m_pMxDoc.FocusMap, ENUM_jenStandaloneTables)
79:   Set m_pMeanTableLayerArray = New esriSystem.VarArray
80:   Set m_pCovTableLayerArray = New esriSystem.VarArray
  
82:   lbxMean.Clear
83:   lbxCov.Clear
  Dim pStTable As IStandaloneTable
  Dim pCheckTable As ITable
  Dim lngFieldCount As Long
  Dim lngRecordCount As Long
  Dim lngFieldIndex As Long
  Dim pCheckField As IField
  
  Dim lngMeanCount As Long
  Dim lngCovCount As Long
  Dim booConsiderTable As Boolean
  
  ' ONLY ADD TABLES TO LIST IF THEY CAN POSSIBLY BE MEAN OR COVARIANCE TABLES
96:   If pTableLayerArray.Count > 0 Then
97:     For lngIndex = 0 To pTableLayerArray.Count - 1
98:       Set pStTable = pTableLayerArray.Element(lngIndex)
99:       Set pCheckTable = pStTable.Table
100:       lngRecordCount = pCheckTable.RowCount(Nothing)
101:       lngFieldCount = 0
102:       booConsiderTable = True        ' DISQUALIFY ANY TABLES WITH NON-NUMERIC FIELDS
      
104:       For lngFieldIndex = 0 To pCheckTable.Fields.FieldCount - 1
105:         Set pCheckField = pCheckTable.Fields.Field(lngFieldIndex)
106:         If Not TopoCorridor.aml_func_mod.FieldIsNumeric(pCheckField) And pCheckField.Type <> esriFieldTypeOID Then
107:           booConsiderTable = False
108:         End If
109:         If pCheckField.Type <> esriFieldTypeOID And booConsiderTable Then
110:           lngFieldCount = lngFieldCount + 1
111:         End If
112:       Next lngFieldIndex
      
114:       If booConsiderTable Then
115:         If lngFieldCount = 1 Then
116:           m_pMeanTableLayerArray.Add pStTable
117:           lngMeanCount = lngMeanCount + 1
118:           lbxMean.AddItem CStr(lngMeanCount) & "]  " & pStTable.Name
119:         End If
120:         If lngFieldCount = lngRecordCount Then
121:           m_pCovTableLayerArray.Add pStTable
122:           lngCovCount = lngCovCount + 1
123:           lbxCov.AddItem CStr(lngCovCount) & "]  " & pStTable.Name
124:         End If
125:       End If
126:     Next lngIndex
127:     lbxMean.ListIndex = -1
128:     lbxCov.ListIndex = -1
129:   End If
  
  ' FILL INSTRUCTION BOX
  Dim strBaseString As String
133:   strBaseString = strBaseString & "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fswiss\fcharset0 Arial;}{\f1\fnil\fcharset0 MS Sans Serif;}}" & vbNewLine
134:   strBaseString = strBaseString & "\viewkind4\uc1\pard\f0\fs16 This tool will calculate the Mahalanobis distance values at a set of points, based on an existing mean vector and covariance matrix.  Optionally the tool will add the Mahalanobis values to an existing field in the attribute table, to a new field added to the attribute table, or to a new table entirely." & vbNewLine
135:   strBaseString = strBaseString & "\par " & vbNewLine
136:   strBaseString = strBaseString & "\par \pard The mean vector and covariance matrix must be selected from tables currently available in your map document.   \b Note:  \b0 You must take care to ensure that the order of variables in the tables is the same as the order of variables you use to calculate your Mahalanobis surface.  Please refer to the manual for additional information if this does not make sense. \f1\fs17 " & vbNewLine
137:   strBaseString = strBaseString & "\par }" & vbNewLine
138:   strBaseString = strBaseString & " " & vbNewLine


141:   txtMessage.TextRTF = strBaseString
  
  ' CLEAR INITIAL SELECTION
144:   Set m_pThisExt.frmMahalVectorSource = Nothing
145:   m_pThisExt.ShouldContinue = False
  
147:   CheckEnable

149:   Set pSelItem = Nothing
150:   Set pLayer = Nothing
151:   Set pStandaloneTable = Nothing
152:   Set pUnknown = Nothing
153:   Set pPointLayer = Nothing
154:   Set pTableLayerArray = Nothing
155:   Set pStTable = Nothing
156:   Set pCheckTable = Nothing
157:   Set pCheckField = Nothing
 
 Exit Property
ErrorHandler:
  HandleError True, "ArcApplication " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Public Property Get ReturnArray() As esriSystem.IVariantArray
  On Error GoTo ErrorHandler
 
167:   Set ReturnArray = m_pReturnArray
 
  Exit Property
ErrorHandler:
  HandleError True, "ReturnArray " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
  
Private Sub CheckEnable()
  On Error GoTo ErrorHandler
  
  ' CHECK IF OK SHOULD BE ENABLED
178:   cmdOK.Enabled = lbxPointLayers.SelCount > 0 And lbxMean.SelCount > 0 And _
                    lbxCov.SelCount > 0
 
  Exit Sub
ErrorHandler:
  HandleError False, "CheckEnable " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdManual_Click()
  On Error GoTo ErrorHandler
  ' CHANGE AS APPROPRIATE
  Dim strDir As String
190:   strDir = App.Path
191:   If Right(strDir, 1) <> "\" Then strDir = strDir & "\"
192:   strDir = strDir & "docs"
  
194:   Call TopoCorridor.MyGeneralOperations.OpenDoc("Land_Facet_Tools.pdf", strDir)
 
  Exit Sub
ErrorHandler:
  HandleError True, "cmdManual_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdCancel_Click()
  On Error GoTo ErrorHandler
  
204:   m_pThisExt.ShouldContinue = False
205:   Set m_pThisExt.frmMahalVectorSource = Nothing
206:   Set m_pReturnArray = Nothing
207:   Unload Me
 
  Exit Sub
ErrorHandler:
  HandleError True, "cmdCancel_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdOK_Click()
  On Error GoTo ErrorHandler
  
  ' RETURN ARRAY pSourceParams WILL BE AN IVariantArray CONTAINING THE FOLLOWING ITEMS:
  ' 0) pPointParams; IVariantArray CONTAINING:
  '    0) IFeatureLayer: SELECTED POINT LAYER
  '    1) BOOLEAN: Whether to use all points
  '    2) LONG: Total number of points to be used
  '    3) LONG: Selected Number of Points in this layer
  ' 1) pStatsParams; IVariantArray CONTAINING:
  '    0) IStandaloneTable: MEAN VECTOR
  '    1) IStandaloneTable: COVARIANCE MATRIX
  
  ' POINT PARAMETERS --------------------------------------------------------------------------------------------------------------------
  Dim pSourceParams As esriSystem.IVariantArray
229:   Set pSourceParams = New esriSystem.VarArray
  
  Dim pPointParams As esriSystem.IVariantArray
232:   Set pPointParams = New esriSystem.VarArray
  
  Dim pPointLayer As IFeatureLayer
235:   Set pPointLayer = m_pPointLayerArray.Element(lbxPointLayers.ListIndex)
236:   pPointParams.Add pPointLayer
237:   pPointParams.Add optUseAll.Value              ' TRUE IF USING ALL POINTS, FALSE IF ONLY USING SELECTED POINTS
238:   pPointParams.Add m_lngPointCount              ' TOTAL POINT COUNT FOR THIS LAYER
239:   pPointParams.Add m_lngSelPointCount           ' SELECTED POINT COUNT FOR THIS LAYER
  
241:   pSourceParams.Add pPointParams
  
  ' CHECK FOR MISSING PROJECTION -------------------------------
  Dim pGeoDataset As IGeoDataset
  Dim pSpRef As ISpatialReference
  Dim booHasMissingSpRef As Boolean
  Dim booHasUnknownSpRef As Boolean
  
249:   booHasMissingSpRef = False
250:   booHasUnknownSpRef = False
  Dim strSourceName As String
      
253:   Set pGeoDataset = pPointLayer.FeatureClass
254:   Set pSpRef = pGeoDataset.SpatialReference
255:   If pSpRef Is Nothing Then
256:     booHasMissingSpRef = True
257:   Else
258:     booHasUnknownSpRef = TypeOf pSpRef Is IUnknownCoordinateSystem
259:   End If
260:   strSourceName = pPointLayer.Name
  
  Dim booBailOut As Boolean
263:   booBailOut = booHasMissingSpRef Or booHasUnknownSpRef
  
  Dim strMessage As String
266:   If booHasMissingSpRef Then
267:     strMessage = _
      "WARNING:" & vbCrLf & "---------------------------------------------" & vbCrLf & _
      "Your Point dataset (" & strSourceName & ") " & _
      "is missing a spatial reference.  This function must know the spatial reference in order " & _
      "to ensure that the point locations align correctly with the Mahalanobis input variable datasets. " & _
      "Please define the spatial reference of your Point dataset before running this function."
273:   ElseIf booHasUnknownSpRef Then
274:     strMessage = _
      "WARNING:" & vbCrLf & "---------------------------------------------" & vbCrLf & _
      "Your Point dataset (" & strSourceName & ") " & _
      "has an unknown spatial reference.  This function must know the spatial reference in order " & _
      "to ensure that the point locations align correctly with the Mahalanobis input variable datasets. " & _
      "Please define the spatial reference of your Point dataset before running this function."
280:   End If
  
282:   If booBailOut Then
    Dim pParams As esriSystem.IVariantArray
284:     Set pParams = New esriSystem.VarArray
    
    Dim strHeader As String
    ' 1 = Yes / No
    ' 2 = OK / Cancel
    ' 3 = Yes / No / Cancel
    ' 4 = OK Only
291:     strHeader = "ERROR: Unknown or Missing Spatial Reference:"
  
293:     pParams.Add m_pApp
294:     pParams.Add 4
295:     pParams.Add strHeader                                                 ' DIALOG CAPTION
296:     pParams.Add strMessage                                                ' MESSAGE
  
    Dim pForm As TopoCorridor.frmMsgBox
299:     Set pForm = New TopoCorridor.frmMsgBox
300:     Set pForm.theParameters = pParams
301:     pForm.Show vbModal
  
    ' 0 = Cancel
    ' 1 = Yes / OK
    ' 2 = No
  
    ' MsgBox "Message Box Response = " & CStr(lngResponse)
    
309:     m_pThisExt.ShouldContinue = False
310:     m_pThisExt.InputStep = 3
311:     Set m_pThisExt.frmMahalVectorSource = Nothing
    Exit Sub
313:   End If
  
  ' MEAN VECTOR AND COVARIANCE MATRIX ----------------------------------------------------------------------------------------------------
  Dim pStatsParams As esriSystem.IVariantArray
317:   Set pStatsParams = New esriSystem.VarArray
  
  Dim pMeanST As IStandaloneTable
  Dim pCovST As IStandaloneTable
  Dim pMeanVector As ITable
  Dim pCovMatrix As ITable
  
324:   Set pMeanST = m_pMeanTableLayerArray.Element(lbxMean.ListIndex)
325:   Set pMeanVector = pMeanST.Table
  
327:   Set pCovST = m_pCovTableLayerArray.Element(lbxCov.ListIndex)
328:   Set pCovMatrix = pCovST.Table
  
  ' CHECK FOR ERRORS IN SELECTED TABLES
  Dim booIncompatible As Boolean
332:   booIncompatible = False
  Dim strErrorMessage As String
334:   strErrorMessage = "Problem - Incompatible Mean Vector and Covariance Matrices:" & vbCrLf
  
  Dim strMeanNonNumericFields As String
  Dim strCovNonNumericFields As String
338:   strMeanNonNumericFields = "     --> "
339:   strCovNonNumericFields = "     --> "
  Dim booMeanNonNumeric As Boolean
  Dim booCovNonNumeric As Boolean
  
  Dim lngMeanRows As Long
  Dim lngMeanCols As Long
  Dim lngCovRows As Long
  Dim lngCovColumns As Long
  
348:   lngMeanRows = pMeanVector.RowCount(Nothing)
349:   lngCovRows = pCovMatrix.RowCount(Nothing)
  
  Dim pFields As IFields
  Dim lngFieldCounter As Long
  Dim pStatField As IField
  
  ' MEAN VECTOR COLUMNS
356:   lngMeanCols = 0
357:   Set pFields = pMeanVector.Fields
358:   For lngFieldCounter = 0 To pFields.FieldCount - 1
359:     Set pStatField = pFields.Field(lngFieldCounter)
360:     If pStatField.Type <> esriFieldTypeOID Then
361:       If Not TopoCorridor.aml_func_mod.FieldIsNumeric(pStatField) Then
362:         booMeanNonNumeric = True
363:         strMeanNonNumericFields = strMeanNonNumericFields & pStatField.Name & ", "
364:       Else
365:         lngMeanCols = lngMeanCols + 1
366:       End If
367:     End If
368:   Next lngFieldCounter
  ' REMOVE LAST COMMA AND SPACE
370:   strMeanNonNumericFields = Left(strMeanNonNumericFields, Len(strMeanNonNumericFields) - 2)
  ' ADD TO ERROR MESSAGE IF FOUND NON-NUMERIC FIELDS
372:   If booMeanNonNumeric Then
373:     booIncompatible = True
374:     strErrorMessage = strErrorMessage & "  --> The following field(s) in your Mean Vector are non-numeric:" & vbCrLf & strMeanNonNumericFields & vbCrLf
375:   End If
  
  ' COVARIANCE MATRIX COLUMNS
378:   lngCovColumns = 0
379:   Set pFields = pCovMatrix.Fields
380:   For lngFieldCounter = 0 To pFields.FieldCount - 1
381:     Set pStatField = pFields.Field(lngFieldCounter)
382:     If pStatField.Type <> esriFieldTypeOID Then
383:       If Not TopoCorridor.aml_func_mod.FieldIsNumeric(pStatField) Then
384:         booCovNonNumeric = True
385:         strCovNonNumericFields = strCovNonNumericFields & pStatField.Name & ", "
386:       Else
387:         lngCovColumns = lngCovColumns + 1
388:       End If
389:     End If
390:   Next lngFieldCounter
  ' REMOVE LAST COMMA AND SPACE
392:   strCovNonNumericFields = Left(strCovNonNumericFields, Len(strCovNonNumericFields) - 2)
  ' ADD TO ERROR MESSAGE IF FOUND NON-NUMERIC FIELDS
394:   If booCovNonNumeric Then
395:     booIncompatible = True
396:     strErrorMessage = strErrorMessage & "  --> The following field(s) in your Covariance Matrix are non-numeric:" & vbCrLf & _
        strMeanNonNumericFields & vbCrLf
398:   End If
    
  ' MAKE SURE ROWS OF MEAN VECTOR EQUAL COLUMNS OF COVARIANCE MATRIX
401:   If lngMeanRows <> lngCovColumns Then
402:     strErrorMessage = strErrorMessage & "  --> The number of rows in your Mean Vector (" & CStr(Format(lngMeanRows, "#,##0")) & _
      ") is not equal to the number of columns in your Covariance Matrix (" & CStr(Format(lngCovColumns, "#,##0")) & ")" & vbCrLf
404:     booIncompatible = True
405:   End If
  
  ' MAKE SURE EQUAL NUMBER OF ROWS AND COLUMNS IN COVARIANCE MATRIX
408:   If lngCovRows <> lngCovColumns Then
409:     strErrorMessage = strErrorMessage & "  --> The number of rows in your Covariance Matrix (" & CStr(Format(lngMeanRows, "#,##0")) & _
      ") is not equal to the number of columns in your Covariance Matrix (" & CStr(Format(lngCovColumns, "#,##0")) & ")" & vbCrLf
411:     booIncompatible = True
412:   End If
  
  ' MAKE SURE MEAN VECTOR HAS ONLY 1 NON-OID FIELD
415:   If lngMeanCols <> 1 Then
416:     strErrorMessage = strErrorMessage & "  --> Your Mean Vector has " & CStr(Format(lngMeanCols, "#,##0")) & _
      " non-OID columns.  There should only be 1 non-OID column." & vbCrLf
418:     booIncompatible = True
419:   End If
  
421:   If booIncompatible Then
  
    Dim frmReportForm As TopoCorridor.frmReportDialog
424:     Set frmReportForm = New TopoCorridor.frmReportDialog
425:     frmReportForm.txtReport.Text = strErrorMessage
426:     frmReportForm.txtReport.Locked = False
427:     frmReportForm.Caption = " Problems with Specified Statistical Matrices:"
428:     frmReportForm.Show vbModal
  
    Exit Sub
431:   Else
    
433:     pStatsParams.Add pMeanST
434:     pStatsParams.Add pCovST
435:     pSourceParams.Add pStatsParams
    
437:   End If
  
  
  
441:   Set m_pThisExt.frmMahalVectorSource = pSourceParams
442:   m_pThisExt.ShouldContinue = True
443:   m_pThisExt.InputStep = 2
  
445:   Me.Visible = False
  
447:   Set pSourceParams = Nothing
448:   Set pPointParams = Nothing
449:   Set pPointLayer = Nothing
450:   Set pGeoDataset = Nothing
451:   Set pSpRef = Nothing
452:   Set pParams = Nothing
453:   Set pForm = Nothing
454:   Set pStatsParams = Nothing
455:   Set pMeanST = Nothing
456:   Set pCovST = Nothing
457:   Set pMeanVector = Nothing
458:   Set pCovMatrix = Nothing
459:   Set pFields = Nothing
460:   Set pStatField = Nothing
461:   Set frmReportForm = Nothing
  
  Exit Sub
ErrorHandler:
  HandleError True, "cmdOK_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Form_Activate()
  On Error GoTo ErrorHandler

471:   m_pThisExt.ShouldContinue = False

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Activate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Form_Load()
  On Error GoTo ErrorHandler
 
481:   SetWindowPos Me.hWnd, -1, 0, 0, 0, 0, &H1 Or &H2
482:   Me.Left = (Screen.Width / 2) - (Me.Width / 2)
483:   Me.Top = (Screen.Height / 3) - (Me.Height / 3)
  
  Dim lngTopBar As Long
486:   lngTopBar = Me.Height - Me.ScaleHeight
487:   Me.Height = cmdOK.Top + cmdOK.Height + lngTopBar
 
489:    Set Anchors = New AnchorObjectList  ' Create new instance
490:    With Anchors

492:       With .Item(cmdCancel)
493:          .SetAnchors enumSizeEnd, enumSizeEnd
494:       End With
495:       With .Item(cmdManual)
496:          .SetAnchors enumSizeEnd, enumSizeEnd
497:       End With
498:       With .Item(cmdOK)
499:          .SetAnchors enumSizeEnd, enumSizeEnd
500:       End With

502:       With .Item(imgBackTop)
503:          .SetAnchors enumStartEnd, enumSizeEnd
504:       End With
      
506:       With .Item(imgBackBottom)
507:          .SetAnchors enumStartEnd, enumSizeEnd
508:       End With
509:       With .Item(imgCornerBars)
510:          .SetAnchors enumSizeEnd, enumSizeEnd
511:       End With
512:       With .Item(lblFields)
513:          .SetAnchors enumSize, enumSizeEnd
514:       End With
515:       With .Item(lblLayer)
516:          .SetAnchors enumSize, enumSizeEnd
517:       End With
518:       With .Item(lblLine)
519:          .SetAnchors enumSize, enumSizeEnd
520:       End With
521:       With .Item(lblLine2)
522:          .SetAnchors enumSize, enumSizeEnd
523:       End With

525:       With .Item(lblSelPointTheme)
526:          .SetAnchors enumSize, enumSizeEnd
527:       End With
528:       With .Item(lblSource)
529:          .SetAnchors enumSize, enumSizeEnd
530:       End With
531:       With .Item(lblPoints)
532:          .SetAnchors enumSize, enumSizeEnd
533:       End With

535:       With .Item(lbxCov)
536:          .SetAnchors enumEnd, enumSizeEnd
537:       End With
      
      
540:       With .Item(lblAll)
541:          .SetAnchors enumSizeEnd, enumSizeEnd
542:       End With
543:       With .Item(lblSelected)
544:          .SetAnchors enumSizeEnd, enumSizeEnd
545:       End With
546:       With .Item(optUseAll)
547:          .SetAnchors enumSizeEnd, enumSizeEnd
548:       End With
549:       With .Item(optUseSelected)
550:          .SetAnchors enumSizeEnd, enumSizeEnd
551:       End With
552:       With .Item(frmSelAll)
553:          .SetAnchors enumSizeEnd, enumSizeEnd
554:       End With
      
556:       With .Item(lbxMean)
557:          .SetAnchors enumStart, enumSizeEnd
558:       End With
559:       With .Item(lbxPointLayers)
560:          .SetAnchors enumStartEnd, enumSizeEnd
561:       End With

563:       With .Item(txtMessage)
564:          .SetAnchors enumStartEnd, enumStartEnd
565:       End With
566:       .Form = Me  ' Set form reference (suggested to be last step)
567:    End With


570:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub Form_Resize()
  On Error GoTo ErrorHandler

'  Dim lngRight As Long
'  Dim lngTopY As Long
'  Dim lngBottomY As Long
'
'  lngTopY = cmdOptions1.Top + (cmdOptions1.Height / 2)
'  lngBottomY = cmdOptions2.Top + (cmdOptions2.Height / 2)
'
'  lngRight = Me.Width - 2000
'
'  Line1.X2 = lngRight
'  Line1.Y1 = lngTopY
'  Line1.Y2 = lngTopY
'  Line2.X2 = lngRight
'  Line2.Y1 = lngBottomY
'  Line2.Y2 = lngBottomY

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Resize " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Form_Unload(Cancel As Integer)
  On Error GoTo ErrorHandler
 


606:   Set m_pMxDoc = Nothing
607:   Set m_pApp = Nothing
608:   Set Anchors = Nothing
609:   Set m_pPointLayerArray = Nothing
610:   Set m_pRasterLayerArray = Nothing
611:   Set m_pTrueRasterLayerArray = Nothing
612:   Set m_pTrueRasterLayerNames = Nothing
613:   Set m_pRasterLayerFields = Nothing
614:   Set m_pMeanTableLayerArray = Nothing
615:   Set m_pCovTableLayerArray = Nothing
616:   Set m_pThisExt = Nothing
617:   Set m_pReturnArray = Nothing

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Unload " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub lbxCov_Click()
  On Error GoTo ErrorHandler

627:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "lbxCov_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub lbxPointLayers_Click()
  On Error GoTo ErrorHandler
  
  Dim pFeatureLayer As IFeatureLayer
638:   Set pFeatureLayer = m_pPointLayerArray.Element(lbxPointLayers.ListIndex)
  Dim pFeatureClass As IFeatureClass
640:   Set pFeatureClass = pFeatureLayer.FeatureClass

  ' UPDATE CONVERSION OPTIONS
  Dim lngNumRecs As Long
  Dim lngSelRecs As Long
 
  Dim pSelSet As ISelectionSet

648:   lngNumRecs = pFeatureClass.FeatureCount(Nothing)
  Dim pFeatSel As IFeatureSelection
650:   Set pFeatSel = pFeatureLayer
651:   Set pSelSet = pFeatSel.SelectionSet

653:   lngSelRecs = pSelSet.Count
  
'  MsgBox "optUseAll Should Be True = " & CStr(lngSelRecs = 0)
656:   optUseAll.Value = lngSelRecs = 0
657:   optUseAll.Enabled = True
658:   lblAll.Enabled = True
'  MsgBox "optUseAll Is True = " & CStr(optUseAll.Value)
  
661:   optUseSelected.Enabled = Not lngSelRecs = 0
662:   optUseSelected.Value = Not lngSelRecs = 0
663:   lblSelected.Enabled = Not lngSelRecs = 0
  
'  MsgBox "optUseAll Is True (after OptUseSelected Value Set) = " & CStr(optUseAll.Value)
  
667:   lblAll.Caption = "n = " & CStr(Format(lngNumRecs, "#,##0")) & " points"
668:   lblSelected.Caption = "n = " & CStr(Format(lngSelRecs, "#,##0")) & _
      " of " & CStr(Format(lngNumRecs, "#,##0")) & " points"
 
671:   m_lngPointCount = lngNumRecs
672:   m_lngSelPointCount = lngSelRecs
  
674:   CheckEnable

676:   Set pFeatureLayer = Nothing
677:   Set pFeatureClass = Nothing
678:   Set pSelSet = Nothing
679:   Set pFeatSel = Nothing

  Exit Sub
ErrorHandler:
  HandleError True, "lbxPointLayers_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub lbxMean_Click()
  On Error GoTo ErrorHandler

689:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "lbxMean_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

 
Private Sub ExtraCodeRequired()
 
  '' PUT IN EXTENSION CLASS
  '
  'Private m_booShouldContinue As Boolean
  'Private m_strDirPath As String
  'Private m_pfrmMahalVectorSource As esriSystem.IVariantArray
  'Private m_strDirType As String
  'Private m_booIsFeatDataset As Boolean
  'Private m_strFeatDatasetName As String
  '
  '' PUT IN EXTENSION SHUTDOWN EVENT
  ' Set m_pfrmMahalVectorSource = Nothing
  '
  '' SET FOLLOWING PROPERTIES
  'Public Property Let FeatDatasetName(strFeatDatasetName As String)
  '  m_strFeatDatasetName = strFeatDatasetName
  'End Property
  'Public Property Get FeatDatasetName() As String
  '  FeatDatasetName = m_strFeatDatasetName
  'End Property
  'Public Property Let IsFeatureDataset(booIsFeatDataset As Boolean)
  '  m_booIsFeatDataset = booIsFeatDataset
  'End Property
  'Public Property Get IsFeatureDataset() As Boolean
  '  IsFeatureDataset = m_booIsFeatDataset
  'End Property
  'Public Property Let DirectoryType(strDirType As String)
  '  m_strDirType = strDirType
  'End Property
  'Public Property Get DirectoryType() As String
  '  DirectoryType = m_strDirType
  'End Property
  '
  'Public Property Set frmMahalVectorSource(pfrmMahalVectorSource As esriSystem.IVariantArray)
  '  Set m_pfrmMahalVectorSource = pfrmMahalVectorSource
  'End Property
  '
  'Public Property Get frmMahalVectorSource() As esriSystem.IVariantArray
  '  Set frmMahalVectorSource = m_pfrmMahalVectorSource
  'End Property
  '
  'Public Property Let DirectoryPath(strPath As String)
  '  On Error GoTo ErrorHandler
  '  m_strDirPath = strPath
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "DirectoryPath " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  'Public Property Get DirectoryPath() As String
  '  On Error GoTo ErrorHandler
  '  DirectoryPath = m_strDirPath
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "DirectoryPath " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  'Public Property Let ShouldContinue(booShouldContinue As Boolean)
  '  On Error GoTo ErrorHandler
  '  m_booShouldContinue = booShouldContinue
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "ShouldContinue " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  'Public Property Get ShouldContinue() As Boolean
  '  On Error GoTo ErrorHandler
  '  ShouldContinue = m_booShouldContinue
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "ShouldContinue " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  '' PUT IN EXTENSION STARTUP EVENT
  '  If m_strDirPath = "" Or m_strDirType = "" Then
  '    m_strDirType = "Shapefile"
  '    m_strDirPath = ""
  '    m_booIsFeatDataset = False
  '    m_strFeatDatasetName = ""
  '  End If
  '
  '===============================================================================================================
  '
' ' SAMPLE CODE
'    Dim pVarArray As esriSystem.IVariantArray
'    Set pVarArray = New VarArray
'
'    ' ADD APPLICATION
'    pVarArray.Add m_pApp
'
'    ' ADD DESIRED LAYER TYPES
'    Dim pLayerTypes As JenLayerTypes
'    pLayerTypes = ENUM_jenPointLayers + ENUM_jenRasterLayers
'    pVarArray.Add pLayerTypes
'
'    'EXTENSION SHOULD HAVE PROPERTIES FOR "ShouldContinue", "DirectoryPath", "frmMahalVectorSource",
'    '     "DirectoryType", "IsFeatureDataset", "FeatDatasetName"
'    pVarArray.Add m_pThisExt
'
'    ' ADD DESIRED FIELD TYPES
'    Dim pFieldTypes As JenFieldTypes
'    pFieldTypes =  ENUM_FieldNumber
'    pVarArray.Add pFieldTypes
'
'    ' ADD WHETHER TO INCLUDE ID FIELD
'    pVarArray.Add (False)
'
'    ' ADD WHETHER ANY OUTPUT WILL BE A FEATURE CLASS (TRUE) OR TABLE (FALSE)         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    Dim booOutputIsFClass As Boolean                                                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    booOutputIsFClass = True                                                         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    pVarArray.Add (booOutputIsFClass)                                                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'
'    Dim pForm As TopoCorridor.frmCovSource
'    Set pForm = New TopoCorridor.frmCovSource
'    Set pForm.ArcApplication = pVarArray
'    pForm.Show vbModal
'    Set pForm = Nothing
'
'    If m_pThisExt.ShouldContinue = False Then
'      MsgBox "Function Canceled:" & vbCrLf & "Bailing out..."
'      Exit Sub
'    End If
'
'    Dim pReturnArray As esrisystem.IVariantArray
'    Set pReturnArray = m_pThisExt.frmMahalVectorSource
 
'    ' OUTPUT
'    ' SELECTED TABLE OR LAYER
'    Dim pUnknown As IUnknown
'    Set pUnknown = pReturnArray.Element(0)
'
'    ' FOR DEBUGGING
'    Dim strReport As String
'    strReport = "Selected Items:" & vbNewLine
'
'    If TypeOf pUnknown Is ILayer Then
'      Dim pLayer As ILayer
'      Set pLayer = pUnknown
'      strReport = strReport & "Name:  " & pLayer.Name & vbNewLine
'    ElseIf TypeOf pUnknown Is IStandaloneTable Then
'      Dim pStTab As IStandaloneTable
'      Set pStTab = pUnknown
'      strReport = strReport & "Name:  " & pStTab.Name & vbNewLine
'    End If
'
'    ' SELECTED FIELD OR FIELDS
'    Dim pSelFields As esriSystem.IVariantArray
'    Set pSelFields = pReturnArray.Element(1)
'    strReport = strReport & CStr(pSelFields.Count) & " fields selected..." & vbNewLine
'
'    Dim pField As IField
'    Set pField = pSelFields.Element(0)
'    strReport = strReport & "First Selected Field is named '" & pField.Name & "'" & vbNewLine
'

''  ' SAMPLE SNIPPET FOR FEATURE LAYERS:  ROTATE THROUGH ALL OR SELECTED RECORDS
''  Dim pFeatureLayer As IFeatureLayer
''  Dim pFClass As IFeatureClass
''  Dim pFeatSel As IFeatureSelection
''  Dim pSelSet As ISelectionSet
''  Dim pCursor As IFeatureCursor
''  Dim lngCount As Long
''
''  Set pFClass = pFeatureLayer.FeatureClass
''  Set pFeatSel = pFeatureLayer
''  Set pSelSet = pFeatSel.SelectionSet
''
''  If pSelSet.Count = 0 Then
''    Set pCursor = pFClass.Search(Nothing, False)
''    lngCount = pFClass.FeatureCount(Nothing)
''  Else
''    If booDoAll = True Then
''      Set pCursor = pFClass.Search(Nothing, False)
''      lngCount = pFClass.FeatureCount(Nothing)
''    Else
''      pSelSet.Search Nothing, True, pCursor
''      lngCount = pSelSet.Count
''    End If
''  End If
''
''  Dim pFeature As IFeature
''  Set pFeature = pCursor.NextFeature
''  Do Until pFeature Is Nothing
''    ' DO ACTIONS
''    Set pFeature = pCursor.NextFeature
''  Loop
''
''  ' SAMPLE CODE SNIPPET:  ADD RECORDS TO FEATURE CLASS USING BUFFER
''  Dim pBuffer As IFeatureBuffer
''  Set pBuffer = pFClass.CreateFeatureBuffer
''  Dim pNewFeatureCursor As IFeatureCursor
''  Set pNewFeatureCursor = pFClass.Insert(True)
''  ' LOOP THROUGH WHATEVER STEPS ARE REQUIRED TO GATHER DATA FOR A SINGLE ROW
''    Set pBuffer.Shape = aGeometry
''    pBuffer.Value(lngFieldIndex) = aValue
''    pNewFeatureCursor.InsertFeature pBuffer
''  ' LOOP
''  pNewFeatureCursor.Flush

''  ' SAMPLE SNIPPET FOR TABLES:  ROTATE THROUGH ALL OR SELECTED RECORDS
''  Dim pStandaloneTable As IStandaloneTable
''  Dim pInputTable As ITable
''  Dim pTableSel As ITableSelection
''  Dim pSelSet As ISelectionSet
''  Dim pRowCursor As ICursor
''  Dim lngCount As Long
''
''  Set pInputTable = pStandaloneTable.Table
''  Set pTableSel = pStandaloneTable
''  Set pSelSet = pTableSel.SelectionSet
''
''  If pSelSet.Count = 0 Then
''    Set pRowCursor = pInputTable.Search(Nothing, False)
''    lngCount = pInputTable.FeatureCount(Nothing)
''  Else
''    If booDoAll = True Then
''      Set pRowCursor = pInputTable.Search(Nothing, False)
''      lngCount = pInputTable.FeatureCount(Nothing)
''    Else
''      pSelSet.Search Nothing, True, pRowCursor
''      lngCount = pSelSet.Count
''    End If
''  End If
''
''  Dim pRow As IRow
''  Set pRow = pRowCursor.NextRow
''  Do Until pRow Is Nothing
'''     DO ACTIONS
''    Set pRow = pRowCursor.NextFeature
''  Loop
 
''  ' SAMPLE CODE SNIPPET:  ADD RECORDS TO TABLE USING BUFFER
''  Dim pBuffer As IRowBuffer
''  Set pBuffer = pTable.CreateRowBuffer
''  Dim pTableCursor As ICursor
''  Set pTableCursor = pTable.Insert(True)
''  ' LOOP THROUGH WHATEVER STEPS ARE REQUIRED TO GATHER DATA FOR A SINGLE ROW
''    pBuffer.Value(lngFieldIndex) = aValue
''    pTableCursor.InsertRow pBuffer
''  ' LOOP
''  pTableCursor.Flush
'    MsgBox strReport, vbOKOnly, "Test of LayerID Form:"
'
'  Dim pDocDirty As IDocumentDirty
'  Set pDocDirty = m_pMxDoc
'  pDocDirty.SetDirty
'

End Sub
 
