VERSION 5.00
Begin VB.Form frmLayerID 
   Caption         =   " Shannon's Index Parameters:"
   ClientHeight    =   4425
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6345
   Icon            =   "frmLayerID.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   4425
   ScaleWidth      =   6345
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox chkNull 
      Caption         =   "Set to NoData if any NoData cells in neighborhood"
      Height          =   405
      Left            =   3630
      TabIndex        =   4
      Top             =   2670
      Width           =   2535
   End
   Begin VB.TextBox txtCells 
      Alignment       =   2  'Center
      Height          =   315
      Left            =   4140
      TabIndex        =   3
      Text            =   "txtCells"
      Top             =   2190
      Width           =   1245
   End
   Begin VB.ComboBox cbxFormat 
      Height          =   315
      Left            =   3735
      Style           =   2  'Dropdown List
      TabIndex        =   2
      Top             =   1485
      Width           =   2340
   End
   Begin VB.TextBox txtOutput 
      Height          =   330
      Left            =   150
      TabIndex        =   5
      Text            =   "txtOutput"
      Top             =   3585
      Width           =   5595
   End
   Begin VB.CommandButton cmdGetWorkspace 
      Height          =   360
      Left            =   5805
      Picture         =   "frmLayerID.frx":058A
      Style           =   1  'Graphical
      TabIndex        =   6
      ToolTipText     =   "Browse for Output Feature Class..."
      Top             =   3570
      Width           =   465
   End
   Begin VB.CommandButton cmdManual 
      Caption         =   "Manual"
      Height          =   345
      Left            =   2647
      TabIndex        =   8
      Top             =   4080
      Width           =   1065
   End
   Begin VB.TextBox txtMessage 
      Height          =   960
      Left            =   75
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      TabStop         =   0   'False
      Text            =   "frmLayerID.frx":0600
      Top             =   75
      Width           =   6210
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   345
      Left            =   3712
      TabIndex        =   9
      Top             =   4080
      Width           =   1065
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   345
      Left            =   1567
      TabIndex        =   7
      Top             =   4080
      Width           =   1065
   End
   Begin VB.ListBox lbxLayers 
      Height          =   1815
      Left            =   75
      TabIndex        =   1
      Top             =   1305
      Width           =   3315
   End
   Begin VB.Image imgParamsBack 
      BorderStyle     =   1  'Fixed Single
      Height          =   795
      Left            =   0
      Top             =   3240
      Width           =   6345
   End
   Begin VB.Label lblCells 
      AutoSize        =   -1  'True
      Caption         =   "Cells"
      Height          =   195
      Left            =   5460
      TabIndex        =   14
      Top             =   2250
      Width           =   330
   End
   Begin VB.Label lblNbrHoodSize 
      AutoSize        =   -1  'True
      Caption         =   "Circular Neighborhood Radius:"
      Height          =   195
      Left            =   3735
      TabIndex        =   13
      Top             =   1965
      Width           =   2160
   End
   Begin VB.Label lblFormat 
      Alignment       =   1  'Right Justify
      AutoSize        =   -1  'True
      Caption         =   "Output Raster Format:"
      Height          =   195
      Left            =   3735
      TabIndex        =   12
      Top             =   1260
      Width           =   1560
   End
   Begin VB.Label lblOutputName 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Output Raster Dataset Name:"
      Height          =   195
      Left            =   135
      TabIndex        =   11
      Top             =   3375
      Width           =   2100
   End
   Begin VB.Image imgCornerBars 
      Height          =   225
      Left            =   6135
      Picture         =   "frmLayerID.frx":060F
      Top             =   4200
      Width           =   225
   End
   Begin VB.Label lblLayer 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      Caption         =   "-- Select Raster Layer --"
      Height          =   195
      Left            =   705
      TabIndex        =   10
      Top             =   1095
      Width           =   1710
   End
   Begin VB.Image imgBackTop 
      BorderStyle     =   1  'Fixed Single
      Height          =   3195
      Left            =   15
      Top             =   15
      Width           =   6330
   End
End
Attribute VB_Name = "frmLayerID"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
 
Private m_pMxDoc As esriArcMapUI.IMxDocument
Private m_pApp As IApplication
Private Anchors As AnchorObjectList  ' Main anchor control object
Private m_pLayerArray As esriSystem.IVariantArray
Private m_strSelLayerName As String
Private m_pThisExt As TopoCorridor.clsExtension
Private m_pReturnArray As esriSystem.IVariantArray
Private m_strOutputWorkspace As String
Private m_strOutputBasename As String
Private m_lngOutputWSType As JenDatasetTypes

Private m_strRasterWS As String
Private m_pSaveFormats As esriSystem.IVariantArray
Private m_pFileExtensions As esriSystem.IVariantArray
Private m_strRasterName As String
Private m_pLayerNames As esriSystem.IStringArray
 
Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\brost_climate_change\code\frmLayerID.frm"
 
Public Property Set ArcApplication(ByVal pParams As esriSystem.IVariantArray)
  On Error GoTo ErrorHandler
 
25:   Set m_pApp = pParams.Element(0)
26:   Set m_pMxDoc = pParams.Element(1)
27:   Set m_pThisExt = pParams.Element(2)
  
  ' CLEAR INITIAL SELECTION
30:   Set m_pThisExt.frmLayerIDReturn = Nothing
31:   m_pThisExt.ShouldContinue = False
 
  Dim pSelItem As IUnknown
34:   Set pSelItem = m_pMxDoc.SelectedItem
  Dim pLayer As IRasterLayer
  Dim lngIndex As Long
  Dim pUnknown As IUnknown

39:   m_strSelLayerName = ""
 
41:   If Not pSelItem Is Nothing Then
42:     If TypeOf pSelItem Is IRasterLayer Then
43:       Set pLayer = pSelItem
44:       m_strSelLayerName = pLayer.Name
45:     End If
46:   End If

  ' FILL LAYER ARRAY AND LISTBOX
49:   lbxLayers.Clear
  Dim lngStartSel As Long
51:   lngStartSel = 0
  Dim pTempLayerArray As esriSystem.IVariantArray
53:   Set pTempLayerArray = TopoCorridor.MyGeneralOperations.ReturnLayersByType(m_pMxDoc.FocusMap, ENUM_jenRasterLayers)
54:   Set m_pLayerArray = New esriSystem.VarArray
55:   Set m_pLayerNames = New esriSystem.strArray
  
  Dim pRastBandColl As IRasterBandCollection
  Dim pRastBand As IRasterBand
  Dim pRaster As IRaster
  Dim lngIndex2 As Long
  Dim lngSelCounter As Long
62:   lngSelCounter = -1
  Dim strBandName As String
  
65:   If pTempLayerArray.Count > 0 Then
66:     For lngIndex = 0 To pTempLayerArray.Count - 1
67:       Set pUnknown = pTempLayerArray.Element(lngIndex)
68:       If TypeOf pUnknown Is IRasterLayer Then
69:         Set pLayer = pUnknown
70:         If pLayer.Valid Then
71:           Set pRaster = pLayer.Raster
72:           Set pRastBandColl = pRaster
73:           If pRastBandColl.Count = 1 Then
74:             strBandName = pLayer.Name
75:             lbxLayers.AddItem strBandName
76:             m_pLayerNames.Add strBandName
77:             m_pLayerArray.Add pRastBandColl.Item(0)
78:             lngSelCounter = lngSelCounter + 1
79:             If pLayer.Name = m_strSelLayerName Then lngStartSel = lngSelCounter
80:           Else
81:             For lngIndex2 = 0 To pRastBandColl.Count - 1
82:               Set pRastBand = pRastBandColl.Item(lngIndex2)
83:               strBandName = pLayer.Name & " [Band " & CStr(lngIndex2 + 1) & "]"
84:               m_pLayerNames.Add strBandName
85:               lbxLayers.AddItem strBandName
86:               m_pLayerArray.Add pRastBandColl.Item(lngIndex2)
87:               lngSelCounter = lngSelCounter + 1
88:               If pLayer.Name = m_strSelLayerName Then lngStartSel = lngSelCounter
89:             Next lngIndex2
90:           End If
91:         End If
92:       End If
93:     Next lngIndex
94:     lbxLayers.ListIndex = lngStartSel
95:   End If

97:   txtMessage.Text = "This tool will calculate Shannon's Index for all cells within a specified circular neighborhood.  In general, higher values reflect more diversity and better balance among unique values.  There are multiple definitions of this statistic so please refer to the manual for the exact formula used.  If you plan to use the Shannon's Index Raster as a cost layer for the Land Facet analysis, please remember to invert it so that the 'best' diversity values will have the lowest cost."

99:   Set m_pSaveFormats = New esriSystem.VarArray
100:   Set m_pFileExtensions = New esriSystem.VarArray
  
102:   cbxFormat.Clear
  Dim strFileExtension As String
  Dim lngVersion As Long
  Dim strTypeName As String
  Dim strType As String
  
  ' GIVING UP ON SAVING TO FILE GEODATABASE RASTER....
  'lngVersion = TopoCorridor.aml_func_mod.ReturnArcGISVersionAlt(m_pMxDoc)
110:   lngVersion = 0
111:   If lngVersion >= 2 Then
112:     strTypeName = "File Geodatabase Raster"
113:     strType = "GDB"
114:     m_pSaveFormats.Add strType
115:     cbxFormat.AddItem strTypeName
116:     strFileExtension = ""
117:     m_pFileExtensions.Add strFileExtension
118:   End If
  
120:   strTypeName = "ESRI GRID"
121:   strType = "GRID"
122:   m_pSaveFormats.Add strType
123:   cbxFormat.AddItem strTypeName
124:   strFileExtension = ""
125:   m_pFileExtensions.Add strFileExtension
  
127:   strTypeName = "Imagine Image"
128:   strType = "IMAGINE Image"
129:   m_pSaveFormats.Add strType
130:   cbxFormat.AddItem strTypeName
131:   strFileExtension = ".img"
132:   m_pFileExtensions.Add strFileExtension
  
134:   strTypeName = "TIFF File"
135:   strType = "TIFF"
136:   m_pSaveFormats.Add strType
137:   cbxFormat.AddItem strTypeName
138:   strFileExtension = ".tif"
139:   m_pFileExtensions.Add strFileExtension
  
141:   strTypeName = "JPEG File"
142:   strType = "JPG"
143:   m_pSaveFormats.Add strType
144:   cbxFormat.AddItem strTypeName
145:   strFileExtension = ".jpg"
146:   m_pFileExtensions.Add strFileExtension
  
148:   strTypeName = "JPEG 2000 File"
149:   strType = "JP2"
150:   m_pSaveFormats.Add strType
151:   cbxFormat.AddItem strTypeName
152:   strFileExtension = ".jp2"
153:   m_pFileExtensions.Add strFileExtension
  
  Dim strFolder As String
156:   strFolder = m_pThisExt.DirectoryPath
157:   If strFolder = "" Or Not (TopoCorridor.aml_func_mod.ExistFileDir(strFolder)) Then
158:     strFolder = TopoCorridor.aml_func_mod.ReturnDir(TopoCorridor.aml_func_mod.GetMxDocPath(m_pApp))
159:   End If
160:   If Right(strFolder, 1) = "\" Then
161:     strFolder = Left(strFolder, Len(strFolder) - 1)
162:   End If
  
164:   If StrComp(Right(strFolder, 4), ".gdb") = 0 Then
165:     cbxFormat.ListIndex = 0
166:   Else
'    If m_pThisExt.OutputFormat = 0 Then
'      cbxFormat.ListIndex = 1
'    Else
170:       cbxFormat.ListIndex = m_pThisExt.OutputFormat
'    End If
172:   End If
    
  Dim pWS As IWorkspace
  Dim pWsFact As IWorkspaceFactory2
176:   If StrComp(Right(strFolder, 4), ".gdb", vbTextCompare) = 0 Then
177:     Set pWsFact = New FileGDBWorkspaceFactory
178:   Else
179:     Set pWsFact = New RasterWorkspaceFactory
180:   End If
181:   Set pWS = pWsFact.OpenFromFile(strFolder, Me.hWnd)
    
  Dim strSuggest As String
184:   If cbxFormat.Text = "ESRI GRID" Or cbxFormat.Text = "File Geodatabase Raster" Then
185:     strSuggest = TopoCorridor.MyGeneralOperations.MakeUniqueRasterName2 _
        (pWS, "Shannon" & m_pFileExtensions.Element(cbxFormat.ListIndex), CBool(cbxFormat.Text = "ESRI GRID"))
187:     txtOutput.Text = strFolder & "\" & strSuggest
188:   Else
189:     strSuggest = TopoCorridor.MyGeneralOperations.MakeUniqueShapeFilename(strFolder & "\" & _
        "Shannon" & m_pFileExtensions.Element(cbxFormat.ListIndex))
191:     txtOutput.Text = strSuggest
192:   End If
193:   txtOutput.SelStart = Len(txtOutput.Text)
  
195:   m_strRasterWS = pWS.PathName
196:   m_strRasterName = TopoCorridor.aml_func_mod.ReturnFilename(strSuggest)
  
  Dim lngNbrHoodSize As Long
199:   lngNbrHoodSize = m_pThisExt.NeighborhoodSize
200:   If lngNbrHoodSize <= 0 Then
201:     lngNbrHoodSize = 3
202:   End If
203:   txtCells.Text = CStr(lngNbrHoodSize)
  
205:   If m_pThisExt.ExcludeIfAnyNull Then
206:     chkNull.Value = 1
207:   Else
208:     chkNull.Value = 0
209:   End If
  
211:   CheckEnable

213:   Set pSelItem = Nothing
214:   Set pLayer = Nothing
215:   Set pUnknown = Nothing
216:   Set pTempLayerArray = Nothing
217:   Set pRastBandColl = Nothing
218:   Set pRastBand = Nothing
219:   Set pRaster = Nothing
220:   Set pWS = Nothing
221:   Set pWsFact = Nothing
  
 Exit Property
ErrorHandler:
  HandleError True, "ArcApplication " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Public Property Get ReturnArray() As esriSystem.IVariantArray
  On Error GoTo ErrorHandler
 
231:   Set ReturnArray = m_pReturnArray
 
  Exit Property
ErrorHandler:
  HandleError True, "ReturnArray " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub CheckEnable()
  On Error GoTo ErrorHandler
 
241:   cmdOK.Enabled = lbxLayers.SelCount > 0 And txtCells.Text <> "" And txtOutput.Text <> ""
 
  Exit Sub
ErrorHandler:
  HandleError False, "CheckEnable " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cbxFormat_Change()
  On Error GoTo ErrorHandler

251:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "cbxFormat_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cbxFormat_Click()
  On Error GoTo ErrorHandler

261: CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "cbxFormat_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub chkNull_Click()
  On Error GoTo ErrorHandler

271:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "chkNull_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdGetWorkspace_Click()

  On Error GoTo ErrorHandler
   ' Save to TIFF, IMAGINE Image, GRID and geodatabase
  Dim pGxBrowser As IGxDialog
  Dim pGxFilterCol As IGxObjectFilterCollection
  Dim pGxFilter As IGxObjectFilter
  Dim pGxObj As IGxObject
  Dim pName As IName
  Dim sName As String
  
  Dim booIs10 As Boolean
290:   booIs10 = TopoCorridor.aml_func_mod.IsVersion10
  
  ' Select input raster dataset
293:   Set pGxBrowser = New GxDialog
294:   pGxBrowser.AllowMultiSelect = False
295:   pGxBrowser.Title = "Specify Output Shannon's Index Raster Dataset"
296:   If TopoCorridor.aml_func_mod.FileExists(m_strRasterWS) Then
297:     pGxBrowser.StartingLocation = m_strRasterWS
298:   End If
  
300:   If Not booIs10 Then
301:     Set pGxFilter = New GxFilterRasterDatasets
    
303:     Set pGxFilterCol = pGxBrowser
304:     pGxFilterCol.AddFilter pGxFilter, True
305:   End If
  
  Dim iPos As Integer
308:   If pGxBrowser.DoModalSave(Me.hWnd) Then
309:     sName = pGxBrowser.Name
310:     iPos = InStrRev(sName, ".")
311:     If iPos > 0 Then
312:       sName = Left(sName, iPos - 1)
313:     End If
    
315:     m_strRasterWS = pGxBrowser.FinalLocation.FullName
316:     m_strRasterName = sName
317:     txtOutput.Text = m_strRasterWS & "\" & m_strRasterName
318:   txtOutput.SelStart = Len(txtOutput.Text)
    
    'Get the workspace
321:     Set pGxObj = pGxBrowser.FinalLocation
322:     Set pName = pGxObj.InternalObjectName
'    Set m_OutWs = pName.Open
    
    'geodatabase workspace
'    If Not m_OutWs Is Nothing Then m_Format = "SDR"
    
328:     If StrComp(Right(m_strRasterWS, 4), ".gdb", vbTextCompare) = 0 Then
329:       cbxFormat.ListIndex = 0
330:     End If
    
332:   End If
333:   CheckEnable
  
335:   GoTo CleanUp

  Exit Sub
ErrorHandler:
  HandleError True, "cmdGetWorkspace_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4

CleanUp:

343:   Set pGxBrowser = Nothing
344:   Set pGxFilterCol = Nothing
345:   Set pGxFilter = Nothing
346:   Set pGxObj = Nothing
347:   Set pName = Nothing

  
End Sub

Private Sub cmdManual_Click()
  On Error GoTo ErrorHandler

  
  ' CHANGE AS APPROPRIATE
  Dim strDir As String
358:   strDir = App.Path
359:   If Right(strDir, 1) <> "\" Then strDir = strDir & "\"
360:   strDir = strDir & "docs"
  
362:   Call TopoCorridor.MyGeneralOperations.OpenDoc("Land_Facet_Tools.pdf", strDir)
  
  Exit Sub
ErrorHandler:
  HandleError True, "cmdManual_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdCancel_Click()
  On Error GoTo ErrorHandler

372:   m_pThisExt.ShouldContinue = False
373:   Set m_pThisExt.frmLayerIDReturn = Nothing
374:   Set m_pReturnArray = Nothing
375:   Unload Me
 
  Exit Sub
ErrorHandler:
  HandleError True, "cmdCancel_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdOK_Click()
  On Error GoTo ErrorHandler

  Dim lngVersion As Long
386:   lngVersion = TopoCorridor.aml_func_mod.ReturnArcGISVersionAlt(m_pMxDoc)
  
  ' RETURN ARRAY IS IVariantArray, CONTAINING:
  ' 0) IRasterBand: SELECTED RASTER BAND
  ' 1) LONG: Circular Neighborhood Radius, in units of Cells
  ' 2) STRING: Save Format
  ' 3) STRING: TEXT VERSION OF SAVE FORMAT
  ' 4) STRING: New Raster Name
  ' 5) BOOLEAN: Whether new workspace is File Geodatabase
  ' 6) IWORKSPACE: Either an IRasterWorkspace2 or an IRasterWorkspaceEx
  ' 7) STRING: Extension for output
  ' 8) STRING: Name of Selected Raster Band
  ' 9) BOOLEAN: Whether to exclude if any Null values
    
  Dim lngIndex As Long
401:   Set m_pReturnArray = New esriSystem.VarArray
    
  ' SELECTED RASTER LAYER
  Dim pRasterBand As IRasterBand
405:   Set pRasterBand = m_pLayerArray.Element(lbxLayers.ListIndex)
406:   m_pReturnArray.Add pRasterBand
  
  ' OPTIONS
  Dim lngNbrHoodRadius As Long     ' AUTOMATICALLY CIRCULAR, RADIUS IN CELLS
410:   If txtCells.Text = "" Then
411:     MsgBox "Invalid Neighborhood Radius Value:" & vbCrLf & _
          "Neighborhood radius must be >= 1 raster cell...", , "Invalid Neighborhood Size:"
413:     txtCells.SetFocus
414:   Else
415:     lngNbrHoodRadius = CLng(txtCells.Text)
416:     If lngNbrHoodRadius <= 0 Then
417:       MsgBox "Invalid Neighborhood Radius Value:" & vbCrLf & _
            "Neighborhood radius must be >= 1 raster cell...", , "Invalid Neighborhood Size:"
419:       txtCells.SetFocus
420:     End If
421:   End If
  
423:   m_pReturnArray.Add lngNbrHoodRadius
  
  Dim strWS As String
  Dim strFilename As String
  Dim pWS As IWorkspace
  Dim pWS2 As IWorkspace2
  Dim pRastWS As IRasterWorkspace2
  Dim pRastWsEx As IRasterWorkspaceEx
  Dim strFullPath As String
  Dim pWsFact As IWorkspaceFactory2
  Dim pDataset As IDataset
  Dim booIsFGB As Boolean
  Dim iPos As Integer
  Dim booExcludeIfAnyNull As Boolean
      
438:   strFullPath = txtOutput.Text
439:   strFilename = TopoCorridor.aml_func_mod.ReturnFilename(strFullPath)
440:   strWS = TopoCorridor.aml_func_mod.ReturnDir(strFullPath)
441:   If Right(strWS, 1) = "\" Then
442:     strWS = Left(strWS, Len(strWS) - 1)
443:   End If
  
  ' CLIP OFF ANY EXTENSIONS TO NAME
446:   iPos = InStrRev(strFilename, ".")
447:   If iPos > 0 Then
448:     strFilename = Left(strFilename, iPos - 1)
449:   End If
  
  ' MAKE SURE WORKSPACE EXISTS
452:   If Not TopoCorridor.aml_func_mod.ExistFileDir(strWS) Then
453:     MsgBox "Unable to create Raster:" & vbCrLf & _
           strWS & " is not a valid workspace...", , "Failed to Create Raster:"
455:     txtOutput.SetFocus
    Exit Sub
457:   End If
  
459:   booIsFGB = StrComp(Right(strWS, 4), ".gdb", vbTextCompare) = 0
    
461:   If lngVersion < 2 And booIsFGB Then
462:     MsgBox "Problem:" & vbCrLf & _
           "You have selected a File Geodatabase workspace, but your version of ArcGIS does not " & vbCrLf & _
           "support file geodatabases.", , "Invalid Workspace Specified:"
465:     txtOutput.SetFocus
    Exit Sub
467:   End If
    
469:   If booIsFGB Then
470:     Set pWsFact = New FileGDBWorkspaceFactory
471:   Else
472:     Set pWsFact = New RasterWorkspaceFactory
473:   End If
474:   Set pWS = pWsFact.OpenFromFile(strWS, Me.hWnd)
    
  ' MAKE SURE FILE GEODATABASE IS SELECTED IF USER SPECIFIES SAVING TO FILE GEODATABASE
  Dim strFormat As String
478:   strFormat = m_pSaveFormats.Element(cbxFormat.ListIndex)
   
  '  MsgBox "strFormat = " & strFormat & vbCrLf & _
          "booIsFGB = " & CStr(booIsFGB) & vbCrLf & _
          "strWS = " & strWS
          
484:   If strFormat = "GDB" And (Not booIsFGB) Then
485:     MsgBox "Problem:" & vbCrLf & vbCrLf & _
           "You have selected to save your Shannon's Index raster as a File Geodatabase Raster, " & vbCrLf & _
           "but you have not specified an existing File Geodatabase to save the raster." & vbCrLf & vbCrLf & _
           "Please specify an existing file geodatabase.  If necessary, you may use ArcCatalog " & vbCrLf & _
           "to create a new empty file geodatabase.", , "Incorrect Workspace Specified:"
490:     txtOutput.SetFocus
    Exit Sub
492:   ElseIf strFormat <> "GDB" And booIsFGB Then
493:     MsgBox "Problem:" & vbCrLf & vbCrLf & _
           "You have selected to save your Shannon's Index raster as a " & cbxFormat.Text & ", " & vbCrLf & _
           "but you have specified a File Geodatabase workspace to save the raster." & vbCrLf & vbCrLf & _
           "File geodatabases can only store File Geodatabase rasters.  Either change " & vbCrLf & _
           "your format to 'File Geodatabase Raster', or select a different workspace.", , _
           "Incorrect Workspace Specified:"
499:     txtOutput.SetFocus
    Exit Sub
  
502:   End If
   
504:   m_pReturnArray.Add strFormat
505:   m_pReturnArray.Add cbxFormat.Text
506:   m_pReturnArray.Add strFilename
507:   m_pReturnArray.Add booIsFGB
508:   m_pReturnArray.Add pWS
509:   m_pReturnArray.Add m_pFileExtensions.Element(cbxFormat.ListIndex)
510:   m_pReturnArray.Add lbxLayers.List(lbxLayers.ListIndex)
511:   booExcludeIfAnyNull = chkNull.Value = 1
512:   m_pReturnArray.Add booExcludeIfAnyNull
  
  ' MAKE SURE RASTER DOES NOT EXIST
  Dim lngVBResult As VbMsgBoxResult
516:   If booIsFGB Then
517:     Set pWS2 = pWS
518:     If pWS2.NameExists(esriDTRasterDataset, strFilename) Then
519:       lngVBResult = MsgBox("File '" & strFilename & "' Already exists!" & vbCrLf & _
             "Would you like this tool to attempt to delete the existing file?", vbYesNo, _
             "File Exists:")
522:       If lngVBResult = vbYes Then
523:         Set pRastWsEx = pWS
524:         Set pDataset = pRastWsEx.OpenRasterDataset(strFilename)
525:         If pDataset.CanDelete Then
526:           pDataset.DELETE
527:           If Not pWS2.NameExists(esriDTRasterDataset, strFilename) Then
528:             MsgBox "File Deleted..."
529:           End If
530:         Else
531:           MsgBox "Unable to delete '" & strFilename & "'..." & vbCrLf & _
            "Please delete this file manually before attempting to create a new raster with this name."
533:           txtOutput.SetFocus
          Exit Sub
535:         End If
536:       Else
537:         txtOutput.SetFocus
        Exit Sub
539:       End If
540:       txtOutput.SetFocus
      Exit Sub
542:     End If
543:   Else
544:     If TopoCorridor.aml_func_mod.ExistFileDir(strFullPath) Then
545:       lngVBResult = MsgBox("File '" & strFilename & "' Already exists!" & vbCrLf & _
             "Would you like this tool to attempt to delete the existing file?", vbYesNo, _
             "File Exists:")
548:       If lngVBResult = vbYes Then
549:         Set pRastWS = pWS
550:         Set pDataset = pRastWS.OpenRasterDataset(strFilename)
551:         If pDataset.CanDelete Then
552:           pDataset.DELETE
553:         Else
554:           MsgBox "Unable to delete '" & strFilename & "'..." & vbCrLf & _
            "Please delete this file manually before attempting to create a new raster with this name."
556:           txtOutput.SetFocus
          Exit Sub
558:         End If
559:       Else
560:         txtOutput.SetFocus
        Exit Sub
562:       End If
563:       txtOutput.SetFocus
      Exit Sub
565:     End If
566:   End If
    
568:   m_pThisExt.OutputFormat = cbxFormat.ListIndex
569:   m_pThisExt.DirectoryPath = strWS
570:   m_pThisExt.ShouldContinue = True
571:   m_pThisExt.NeighborhoodSize = lngNbrHoodRadius
572:   m_pThisExt.ExcludeIfAnyNull = booExcludeIfAnyNull

  Dim pSaveArray As esriSystem.IVariantArray
575:   Set pSaveArray = New esriSystem.VarArray
576:   For lngIndex = 0 To m_pReturnArray.Count - 1
577:     pSaveArray.Add m_pReturnArray.Element(lngIndex)
578:   Next lngIndex
579:   Set m_pThisExt.frmLayerIDReturn = pSaveArray
  
581:   Set pRasterBand = Nothing
582:   Set pWS = Nothing
583:   Set pWS2 = Nothing
584:   Set pRastWS = Nothing
585:   Set pRastWsEx = Nothing
586:   Set pWsFact = Nothing
587:   Set pDataset = Nothing
588:   Set pSaveArray = Nothing

  
591:   Unload Me
 
  Exit Sub
ErrorHandler:
  HandleError True, "cmdOK_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Private Sub Form_Load()
  On Error GoTo ErrorHandler
 
602:   SetWindowPos Me.hWnd, -1, 0, 0, 0, 0, &H1 Or &H2
603:   Me.Left = (Screen.Width / 2) - (Me.Width / 2)
604:   Me.Top = (Screen.Height / 3) - (Me.Height / 3)
  Dim lngTopBar As Long
606:   lngTopBar = Me.Height - Me.ScaleHeight
607:   Me.Height = cmdOK.Top + cmdOK.Height + lngTopBar
 
609:    Set Anchors = New AnchorObjectList  ' Create new instance
610:    With Anchors
611:       With .Item(cbxFormat)
612:          .SetAnchors enumSizeEnd, enumStartSize
613:       End With
614:       With .Item(chkNull)
615:          .SetAnchors enumSizeEnd, enumStartSize
616:       End With
617:       With .Item(cmdCancel)
618:          .SetAnchors enumSizeEnd, enumSizeEnd
619:       End With
620:       With .Item(cmdGetWorkspace)
621:          .SetAnchors enumSizeEnd, enumSizeEnd
622:       End With
623:       With .Item(cmdManual)
624:          .SetAnchors enumSizeEnd, enumSizeEnd
625:       End With
626:       With .Item(cmdOK)
627:          .SetAnchors enumSizeEnd, enumSizeEnd
628:       End With
629:       With .Item(imgBackTop)
630:          .SetAnchors enumStartEnd, enumStartEnd
631:       End With
632:       With .Item(imgCornerBars)
633:          .SetAnchors enumSizeEnd, enumSizeEnd
634:       End With
635:       With .Item(imgParamsBack)
636:          .SetAnchors enumStartEnd, enumSizeEnd
637:       End With
638:       With .Item(lblCells)
639:          .SetAnchors enumSizeEnd, enumStartSize
640:       End With
641:       With .Item(lblFormat)
642:          .SetAnchors enumSizeEnd, enumStartSize
643:       End With
644:       With .Item(lblLayer)
645:          .SetAnchors enumSize, enumStartSize
646:       End With
647:       With .Item(lblNbrHoodSize)
648:          .SetAnchors enumSizeEnd, enumStartSize
649:       End With
650:       With .Item(lblOutputName)
651:          .SetAnchors enumStartSize, enumSizeEnd
652:       End With
653:       With .Item(lbxLayers)
654:          .SetAnchors enumStartEnd, enumStartEnd
655:       End With
656:       With .Item(txtCells)
657:          .SetAnchors enumSizeEnd, enumStartSize
658:       End With
659:       With .Item(txtMessage)
660:          .SetAnchors enumStartEnd, enumStartSize
661:       End With
662:       With .Item(txtOutput)
663:          .SetAnchors enumStartEnd, enumSizeEnd
664:       End With
665:       .Form = Me  ' Set form reference (suggested to be last step)
666:    End With


669:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub Form_Unload(Cancel As Integer)
  On Error GoTo ErrorHandler
 
679:   Set m_pMxDoc = Nothing
680:   Set m_pApp = Nothing
681:   Set Anchors = Nothing
682:   Set m_pLayerArray = Nothing
683:   Set m_pThisExt = Nothing
684:   Set m_pReturnArray = Nothing
685:   Set m_pSaveFormats = Nothing
686:   Set m_pFileExtensions = Nothing
687:   Set m_pLayerNames = Nothing
  
  Exit Sub
ErrorHandler:
  HandleError True, "Form_Unload " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub lbxLayers_Click()
  On Error GoTo ErrorHandler

697:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "lbxLayers_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub ExtraCodeRequired()
 
  '' PUT IN EXTENSION CLASS
  '
  'Private m_booShouldContinue As Boolean
  'Private m_strDirPath As String
  'Private m_pfrmLayerIDReturn As esriSystem.IVariantArray
  'Private m_strDirType As String
  'Private m_booIsFeatDataset As Boolean
  'Private m_strFeatDatasetName As String
  '
  '' PUT IN EXTENSION SHUTDOWN EVENT
  ' Set m_pfrmLayerIDReturn = Nothing
  '
  '' SET FOLLOWING PROPERTIES
  'Public Property Let FeatDatasetName(strFeatDatasetName As String)
  '  m_strFeatDatasetName = strFeatDatasetName
  'End Property
  'Public Property Get FeatDatasetName() As String
  '  FeatDatasetName = m_strFeatDatasetName
  'End Property
  'Public Property Let IsFeatureDataset(booIsFeatDataset As Boolean)
  '  m_booIsFeatDataset = booIsFeatDataset
  'End Property
  'Public Property Get IsFeatureDataset() As Boolean
  '  IsFeatureDataset = m_booIsFeatDataset
  'End Property
  'Public Property Let DirectoryType(strDirType As String)
  '  m_strDirType = strDirType
  'End Property
  'Public Property Get DirectoryType() As String
  '  DirectoryType = m_strDirType
  'End Property
  '
  'Public Property Set frmLayerIDReturn(pfrmLayerIDReturn As esriSystem.IVariantArray)
  '  Set m_pfrmLayerIDReturn = pfrmLayerIDReturn
  'End Property
  '
  'Public Property Get frmLayerIDReturn() As esriSystem.IVariantArray
  '  Set frmLayerIDReturn = m_pfrmLayerIDReturn
  'End Property
  '
  'Public Property Let DirectoryPath(strPath As String)
  '  On Error GoTo ErrorHandler
  '  m_strDirPath = strPath
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "DirectoryPath " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  'Public Property Get DirectoryPath() As String
  '  On Error GoTo ErrorHandler
  '  DirectoryPath = m_strDirPath
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "DirectoryPath " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  'Public Property Let ShouldContinue(booShouldContinue As Boolean)
  '  On Error GoTo ErrorHandler
  '  m_booShouldContinue = booShouldContinue
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "ShouldContinue " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  'Public Property Get ShouldContinue() As Boolean
  '  On Error GoTo ErrorHandler
  '  ShouldContinue = m_booShouldContinue
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "ShouldContinue " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  '' PUT IN EXTENSION STARTUP EVENT
  '  If m_strDirPath = "" Or m_strDirType = "" Then
  '    m_strDirType = "Shapefile"
  '    m_strDirPath = ""
  '    m_booIsFeatDataset = False
  '    m_strFeatDatasetName = ""
  '  End If
  '
  '===============================================================================================================
  '
' ' SAMPLE CODE
'    Dim pVarArray As esriSystem.IVariantArray
'    Set pVarArray = New VarArray
'
'    ' ADD APPLICATION
'    pVarArray.Add m_pApp
'
'    ' ADD DESIRED LAYER TYPES
'    Dim pLayerTypes As JenLayerTypes
'    pLayerTypes = ENUM_jenRasterLayers
'    pVarArray.Add pLayerTypes
'
'    'EXTENSION SHOULD HAVE PROPERTIES FOR "ShouldContinue", "DirectoryPath", "frmLayerIDReturn",
'    '     "DirectoryType", "IsFeatureDataset", "FeatDatasetName"
'    pVarArray.Add m_pThisExt
'
'    ' ADD DESIRED FIELD TYPES
'    pVarArray.Add 0
'
'    ' ADD WHETHER TO INCLUDE ID FIELD
'    pVarArray.Add (False)
'
'    ' ADD WHETHER ANY OUTPUT WILL BE A FEATURE CLASS (TRUE) OR TABLE (FALSE)         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    Dim booOutputIsFClass As Boolean                                                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    booOutputIsFClass = True                                                         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    pVarArray.Add (booOutputIsFClass)                                                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'
'    Dim pForm As TopoCorridor.frmLayerID
'    Set pForm = New TopoCorridor.frmLayerID
'    Set pForm.ArcApplication = pVarArray
'    pForm.Show vbModal
'    Set pForm = Nothing
'
'    If m_pThisExt.ShouldContinue = False Then
'      MsgBox "Function Canceled:" & vbCrLf & "Bailing out..."
'      Exit Sub
'    End If
'
'    Dim pReturnArray As esrisystem.IVariantArray
'    Set pReturnArray = m_pThisExt.frmLayerIDReturn
 
'    ' OUTPUT
'    ' SELECTED TABLE OR LAYER
'    Dim pUnknown As IUnknown
'    Set pUnknown = pReturnArray.Element(0)
'
'    ' FOR DEBUGGING
'    Dim strReport As String
'    strReport = "Selected Items:" & vbNewLine
'
'    If TypeOf pUnknown Is ILayer Then
'      Dim pLayer As ILayer
'      Set pLayer = pUnknown
'      strReport = strReport & "Name:  " & pLayer.Name & vbNewLine
'    ElseIf TypeOf pUnknown Is IStandaloneTable Then
'      Dim pStTab As IStandaloneTable
'      Set pStTab = pUnknown
'      strReport = strReport & "Name:  " & pStTab.Name & vbNewLine
'    End If
'


'  ' CODE SNIPPET TO USE pFieldNamePairs TO TRANSFER ATTRIBUTE DATA FROM OLD SOURCE TO NEW SOURCE
'  ' MAKE IVariantArray OF FIELD NAME INDICES
'  ' STRUCTURE:  ARRAY OF 4-ITEM VARIANT ARRAYS
'  '             ITEMS = 0) ORIGINAL FCLASS FIELD NAME
'  '                     1) ORIGINAL FCLASS FIELD INDEX
'  '                     2) NEW FCLASS FIELD NAME
'  '                     3) NEW FCLASS FIELD INDEX
'  Dim pFieldNamePairs As esriSystem.IVariantArray
'  Set pFieldNamePairs = pOutputArray.Element(9)
'  Dim pFieldNameData As esriSystem.IVariantArray
'  Set pFieldNameData = TopoCorridor.MyGeneralOperations.MakeFieldNameVarArray(pFeatureClass, pNewFClass, pFieldNamePairs, True)
'  Dim lngFieldIndex As Long
'  Dim pFieldSubArray As esriSystem.IVariantArray
'  ' ROTATE THROUGH ALL FEATURES / ROWS
'    ' TRANSFER ATTRIBUTE DATA; ASSUMES pBuffer ALREADY EXISTS
'    For lngFieldIndex = 0 To pFieldNameData.Count - 1
'      Set pFieldSubArray = pFieldNameData.Element(lngFieldIndex)
'      pBuffer.Value(pFieldSubArray.Element(3)) = pFeature.Value(pFieldSubArray.Element(1))
'    Next lngFieldIndex
'  ' LOOP

''  ' SAMPLE SNIPPET FOR FEATURE LAYERS:  ROTATE THROUGH ALL OR SELECTED RECORDS
''  Dim pFeatureLayer As IFeatureLayer
''  Dim pFClass As IFeatureClass
''  Dim pFeatSel As IFeatureSelection
''  Dim pSelSet As ISelectionSet
''  Dim pCursor As IFeatureCursor
''  Dim lngCount As Long
''
''  Set pFClass = pFeatureLayer.FeatureClass
''  Set pFeatSel = pFeatureLayer
''  Set pSelSet = pFeatSel.SelectionSet
''
''  If pSelSet.Count = 0 Then
''    Set pCursor = pFClass.Search(Nothing, False)
''    lngCount = pFClass.FeatureCount(Nothing)
''  Else
''    If booDoAll = True Then
''      Set pCursor = pFClass.Search(Nothing, False)
''      lngCount = pFClass.FeatureCount(Nothing)
''    Else
''      pSelSet.Search Nothing, True, pCursor
''      lngCount = pSelSet.Count
''    End If
''  End If
''
''  Dim pFeature As IFeature
''  Set pFeature = pCursor.NextFeature
''  Do Until pFeature Is Nothing
''    ' DO ACTIONS
''    Set pFeature = pCursor.NextFeature
''  Loop
''
''  ' SAMPLE CODE SNIPPET:  ADD RECORDS TO FEATURE CLASS USING BUFFER
''  Dim pBuffer As IFeatureBuffer
''  Set pBuffer = pFClass.CreateFeatureBuffer
''  Dim pNewFeatureCursor As IFeatureCursor
''  Set pNewFeatureCursor = pFClass.Insert(True)
''  ' LOOP THROUGH WHATEVER STEPS ARE REQUIRED TO GATHER DATA FOR A SINGLE ROW
''    Set pBuffer.Shape = aGeometry
''    pBuffer.Value(lngFieldIndex) = aValue
''    pNewFeatureCursor.InsertFeature pBuffer
''  ' LOOP
''  pNewFeatureCursor.Flush

''  ' SAMPLE SNIPPET FOR TABLES:  ROTATE THROUGH ALL OR SELECTED RECORDS
''  Dim pStandaloneTable As IStandaloneTable
''  Dim pInputTable As ITable
''  Dim pTableSel As ITableSelection
''  Dim pSelSet As ISelectionSet
''  Dim pRowCursor As ICursor
''  Dim lngCount As Long
''
''  Set pInputTable = pStandaloneTable.Table
''  Set pTableSel = pStandaloneTable
''  Set pSelSet = pTableSel.SelectionSet
''
''  If pSelSet.Count = 0 Then
''    Set pRowCursor = pInputTable.Search(Nothing, False)
''    lngCount = pInputTable.FeatureCount(Nothing)
''  Else
''    If booDoAll = True Then
''      Set pRowCursor = pInputTable.Search(Nothing, False)
''      lngCount = pInputTable.FeatureCount(Nothing)
''    Else
''      pSelSet.Search Nothing, True, pRowCursor
''      lngCount = pSelSet.Count
''    End If
''  End If
''
''  Dim pRow As IRow
''  Set pRow = pRowCursor.NextRow
''  Do Until pRow Is Nothing
'''     DO ACTIONS
''    Set pRow = pRowCursor.NextFeature
''  Loop
 
''  ' SAMPLE CODE SNIPPET:  ADD RECORDS TO TABLE USING BUFFER
''  Dim pBuffer As IRowBuffer
''  Set pBuffer = pTable.CreateRowBuffer
''  Dim pTableCursor As ICursor
''  Set pTableCursor = pTable.Insert(True)
''  ' LOOP THROUGH WHATEVER STEPS ARE REQUIRED TO GATHER DATA FOR A SINGLE ROW
''    pBuffer.Value(lngFieldIndex) = aValue
''    pTableCursor.InsertRow pBuffer
''  ' LOOP
''  pTableCursor.Flush
'    MsgBox strReport, vbOKOnly, "Test of LayerID Form:"
'
'  Dim pDocDirty As IDocumentDirty
'  Set pDocDirty = m_pMxDoc
'  pDocDirty.SetDirty
'

End Sub
 

Private Sub txtCells_Change()
  On Error GoTo ErrorHandler

970:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "txtCells_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub txtCells_KeyPress(KeyAscii As Integer)
  On Error GoTo ErrorHandler

980:   TopoCorridor.MyGeneralOperations.CheckNumericIntegerPositive KeyAscii, txtCells

  Exit Sub
ErrorHandler:
  HandleError True, "txtCells_KeyPress " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub txtOutput_Change()
  On Error GoTo ErrorHandler

990:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "txtOutput_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
