VERSION 5.00
Begin VB.Form frmMsgBox 
   Caption         =   " Message"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6930
   Icon            =   "frmMsgBox.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   3195
   ScaleWidth      =   6930
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   345
      Left            =   3428
      TabIndex        =   3
      Top             =   2850
      Width           =   915
   End
   Begin VB.TextBox txtMessage 
      Height          =   2805
      Left            =   -15
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   2
      Text            =   "frmMsgBox.frx":058A
      Top             =   0
      Width           =   6945
   End
   Begin VB.CommandButton cmdNo 
      Caption         =   "No"
      Height          =   345
      Left            =   15
      TabIndex        =   0
      Top             =   2850
      Width           =   825
   End
   Begin VB.CommandButton cmdYes 
      Caption         =   "OK"
      Height          =   345
      Left            =   3053
      TabIndex        =   1
      Top             =   2850
      Width           =   825
   End
   Begin VB.Image imgCornerBars 
      Height          =   225
      Left            =   6705
      Picture         =   "frmMsgBox.frx":0590
      Top             =   2970
      Width           =   225
   End
End
Attribute VB_Name = "frmMsgBox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
 
Private m_MxDoc As esriArcMapUI.IMxDocument
Private m_pApp As IApplication
Private m_pExt As IExtension
Private m_ThisExt As TopoCorridor.clsExtension
Private m_lngResponse As Long
Private Anchors As AnchorObjectList  ' Main anchor control object
Const c_sModuleFileName As String = "...FORM = frmMsgBox.frm"
 
Public Property Set theParameters(pParams As esriSystem.IVariantArray)
  On Error GoTo ErrorHandler

  Dim lngOption As Long
15:   Set m_pApp = pParams.Element(0)
16:   Set m_MxDoc = m_pApp.Document

18:   If m_ThisExt Is Nothing Then
    Dim newUid As New UID
20:     newUid.Value = "TopoCorridor.clsExtension"
21:     Set m_pExt = m_pApp.FindExtensionByCLSID(newUid)
22:     Set m_ThisExt = m_pExt
    
    ' PRESET RESPONSE TO "CANCEL"
25:     m_ThisExt.MessageBoxResponse = 0
26:   End If

28:   lngOption = pParams.Element(1)
    
  Select Case lngOption
    Case 1 ' YES / NO
32:       cmdYes.Left = 1495
33:       cmdYes.Caption = "Yes"
34:       cmdNo.Left = 2365
35:       cmdNo.Visible = False
36:       cmdCancel.Left = 0
37:       cmdCancel.Visible = False
    Case 2 ' OK / CANCEL
39:       cmdYes.Left = 2588
40:       cmdYes.Caption = "OK"
41:       cmdNo.Left = 0
42:       cmdNo.Visible = False
43:       cmdCancel.Left = 3428
44:       cmdCancel.Visible = True
    Case 3 ' YES / NO / CANCEL
46:       cmdYes.Left = 1025
47:       cmdYes.Caption = "Yes"
48:       cmdNo.Left = 1875
49:       cmdNo.Visible = True
50:       cmdCancel.Left = 2730
51:       cmdCancel.Visible = True
    Case 4 ' OK ONLY
53:       cmdYes.Left = 3053
54:       cmdYes.Caption = "OK"
55:       cmdNo.Left = 0
56:       cmdNo.Visible = False
57:       cmdCancel.Left = 0
58:       cmdCancel.Visible = False
59:   End Select

61:   Me.Caption = pParams.Element(2)
62:   txtMessage.Text = pParams.Element(3)

  Exit Property
ErrorHandler:
  HandleError True, "theParameters " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub cmdCancel_Click()
  On Error GoTo ErrorHandler
 
72:   m_ThisExt.MessageBoxResponse = 0
73:   Unload Me
 
  Exit Sub
ErrorHandler:
  HandleError True, "cmdCancel_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdNo_Click()
  On Error GoTo ErrorHandler
 
83:   m_ThisExt.MessageBoxResponse = 2
84:   Unload Me
 
  Exit Sub
ErrorHandler:
  HandleError True, "cmdNo_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdYes_Click()
  On Error GoTo ErrorHandler

94:   m_ThisExt.MessageBoxResponse = 1
95:   Unload Me

  Exit Sub
ErrorHandler:
  HandleError True, "cmdYes_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub Form_Load()
  On Error GoTo ErrorHandler

105:   SetWindowPos Me.hWnd, -1, 0, 0, 0, 0, &H1 Or &H2
106:   Me.Left = (Screen.Width / 2) - (Me.Width / 2)
107:   Me.Top = (2 * Screen.Height / 3) - (Me.Height / 2)
 
109:   Set Anchors = New AnchorObjectList  ' Create new instance
110:   With Anchors
111:      With .Item(cmdNo)
112:         .SetAnchors enumStartSize, enumSizeEnd
113:      End With
114:      With .Item(cmdYes)
115:         .SetAnchors enumStartSize, enumSizeEnd
116:      End With
117:      With .Item(cmdCancel)
118:         .SetAnchors enumStartSize, enumSizeEnd
119:      End With
120:      With .Item(imgCornerBars)
121:         .SetAnchors enumSizeEnd, enumSizeEnd
122:      End With
123:      With .Item(txtMessage)
124:         .SetAnchors enumStartEnd, enumStartEnd
125:      End With
126:      .Form = Me  ' Set form reference (suggested to be last step)
127:   End With

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub Form_Unload(Cancel As Integer)
  On Error GoTo ErrorHandler
 
137:   Set m_MxDoc = Nothing
138:   Set m_pApp = Nothing
139:   Set m_pExt = Nothing
140:   Set m_ThisExt = Nothing
 
  Exit Sub
ErrorHandler:
  HandleError True, "Form_Unload " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub SampleCode()
  On Error GoTo ErrorHandler
 
' FOLLOWING NEEDS TO GO IN EXTENSION
'
'Private m_lngMsgBox As Long
'Public Property Let MessageBoxResponse(lngMsgBox As Long)
'  m_lngMsgBox = lngMsgBox
'End Property
'Public Property Get MessageBoxResponse() As Long
'  MessageBoxResponse = m_lngMsgBox
'End Property
 
' FOLLOWING WILL RUN THE DIALOG AND CHECK THE RESPONSE VARIABLE
 
  ' NEEDS TO HAVE A REFERENCE TO THE APPLICATION
  Dim pParams As esriSystem.IVariantArray
164:   Set pParams = New esriSystem.VarArray

  Dim lngOption As Long
  ' 1 = Yes / No
  ' 2 = OK / Cancel
  ' 3 = Yes / No / Cancel
  ' 4 = OK Only
171:   lngOption = 2

173:   pParams.Add m_pApp
174:   pParams.Add lngOption
175:   pParams.Add " Sample Caption:"                                                 ' DIALOG CAPTION
176:   pParams.Add "This is a sample message that might appear in the message box."   ' MESSAGE

  Dim pForm As TopoCorridor.frmMsgBox
179:   Set pForm = New TopoCorridor.frmMsgBox
180:   Set pForm.theParameters = pParams
181:   pForm.Show vbModal

  Dim pExt As IExtension
  Dim pThisExt As TopoCorridor.clsExtension
  Dim newUid As New UID
186:   newUid.Value = "TopoCorridor.clsExtension"
187:   Set pExt = m_pApp.FindExtensionByCLSID(newUid)
188:   Set pThisExt = pExt

  Dim lngResponse As Long
191:   lngResponse = pThisExt.MessageBoxResponse
  ' 0 = Cancel
  ' 1 = Yes / OK
  ' 2 = No

196:   MsgBox "Message Box Response = " & CStr(lngResponse)
 
  Exit Sub
ErrorHandler:
  HandleError False, "SampleCode " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 

