VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form frmRasterExportLayerID 
   Caption         =   " Select Raster and Feature Layers to Export:"
   ClientHeight    =   7200
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5250
   Icon            =   "frmRasterExportLayerID.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   7200
   ScaleWidth      =   5250
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox chkAddCombined 
      Caption         =   "Add combined multi-band raster to map?"
      Height          =   255
      Left            =   915
      TabIndex        =   6
      Top             =   4695
      Width           =   4035
   End
   Begin VB.ComboBox cbxFormat 
      Height          =   315
      Left            =   2670
      Style           =   2  'Dropdown List
      TabIndex        =   9
      Top             =   5925
      Width           =   2445
   End
   Begin MSComDlg.CommonDialog cdlg 
      Left            =   225
      Top             =   6855
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.ComboBox cbxClipLayer 
      Height          =   315
      Left            =   2565
      Style           =   2  'Dropdown List
      TabIndex        =   8
      Top             =   5280
      Width           =   2550
   End
   Begin VB.CheckBox chkClipData 
      Caption         =   "Clip data to Polygon layer?"
      Height          =   255
      Left            =   180
      TabIndex        =   7
      Top             =   5325
      Width           =   2325
   End
   Begin VB.CommandButton cmdClearAll 
      Caption         =   "Clear All"
      Height          =   300
      Left            =   4155
      TabIndex        =   5
      Top             =   4110
      Width           =   990
   End
   Begin VB.CommandButton cmdAdd 
      Caption         =   "Add New"
      Height          =   300
      Left            =   4155
      TabIndex        =   3
      Top             =   3450
      Width           =   990
   End
   Begin VB.CommandButton cmdDelete 
      Caption         =   "Remove"
      Height          =   300
      Left            =   4155
      TabIndex        =   4
      Top             =   3780
      Width           =   990
   End
   Begin VB.CommandButton cmdManual 
      Caption         =   "Manual"
      Height          =   330
      Left            =   2137
      TabIndex        =   13
      Top             =   6870
      Width           =   975
   End
   Begin VB.ListBox lbxFeatureClasses 
      Height          =   1035
      Left            =   90
      TabIndex        =   2
      Top             =   3405
      Width           =   4005
   End
   Begin VB.ComboBox cbxTemplate 
      Height          =   315
      Left            =   90
      Style           =   2  'Dropdown List
      TabIndex        =   0
      Top             =   1305
      Width           =   5055
   End
   Begin VB.CommandButton cmdGetWorkspace 
      Height          =   345
      Left            =   4590
      Picture         =   "frmRasterExportLayerID.frx":058A
      Style           =   1  'Graphical
      TabIndex        =   11
      ToolTipText     =   "Browse for Output Feature Class..."
      Top             =   6360
      Width           =   555
   End
   Begin VB.TextBox txtOutput 
      Height          =   330
      Left            =   90
      TabIndex        =   10
      Text            =   "txtOutput"
      Top             =   6360
      Width           =   4425
   End
   Begin VB.TextBox txtMessage 
      Height          =   960
      Left            =   0
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   15
      TabStop         =   0   'False
      Text            =   "frmRasterExportLayerID.frx":0600
      Top             =   15
      Width           =   5250
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   330
      Left            =   3120
      TabIndex        =   14
      Top             =   6870
      Width           =   975
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   330
      Left            =   1140
      TabIndex        =   12
      Top             =   6870
      Width           =   975
   End
   Begin VB.ListBox lbxLayers 
      Height          =   1185
      Left            =   90
      Style           =   1  'Checkbox
      TabIndex        =   1
      Top             =   1935
      Width           =   5055
   End
   Begin VB.Label lblFolder 
      Alignment       =   1  'Right Justify
      AutoSize        =   -1  'True
      Caption         =   "Folder:"
      Height          =   195
      Left            =   105
      TabIndex        =   21
      Top             =   6150
      Width           =   480
   End
   Begin VB.Label lblFormat 
      Alignment       =   1  'Right Justify
      AutoSize        =   -1  'True
      Caption         =   "Format:"
      Height          =   195
      Left            =   2115
      TabIndex        =   20
      Top             =   5985
      Width           =   525
   End
   Begin VB.Image imgClip 
      BorderStyle     =   1  'Fixed Single
      Height          =   705
      Left            =   0
      Top             =   5070
      Width           =   5250
   End
   Begin VB.Label lblShapefiles 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      Caption         =   "-- Select Feature Classes to Export --"
      Height          =   195
      Left            =   1320
      TabIndex        =   19
      Top             =   3195
      Width           =   2580
   End
   Begin VB.Label lblAdditional 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      Caption         =   "-- Select Rasters to Export --"
      Height          =   195
      Left            =   1635
      TabIndex        =   18
      Top             =   1725
      Width           =   1980
   End
   Begin VB.Image imgCornerBars 
      Height          =   225
      Left            =   5025
      Picture         =   "frmRasterExportLayerID.frx":060F
      Top             =   6990
      Width           =   225
   End
   Begin VB.Label lblOutputName 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Output Tables:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   195
      Left            =   90
      TabIndex        =   17
      Top             =   5865
      Width           =   1275
   End
   Begin VB.Image imgBackBottom 
      BorderStyle     =   1  'Fixed Single
      Height          =   1020
      Left            =   0
      Top             =   5790
      Width           =   5250
   End
   Begin VB.Label lblLayer 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      Caption         =   "-- Select Categorical Raster --"
      Height          =   195
      Left            =   1590
      TabIndex        =   16
      Top             =   1095
      Width           =   2070
   End
   Begin VB.Image imgBackTop 
      BorderStyle     =   1  'Fixed Single
      Height          =   4050
      Left            =   0
      Top             =   1005
      Width           =   5250
   End
End
Attribute VB_Name = "frmRasterExportLayerID"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
 

Private Declare Function ShellExecute Lib "shell32.dll" Alias _
           "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, _
           ByVal lpFile As String, ByVal lpParameters As String, _
           ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
           
Private m_pMxDoc As esriArcMapUI.IMxDocument
Private m_pApp As IApplication
Private Anchors As AnchorObjectList  ' Main anchor control object
Private m_pLayerArray As esriSystem.IVariantArray
Private m_pLayerNewArray As esriSystem.IVariantArray
Private m_strSelLayerName As String
Private m_booSelToggle As Boolean
Private m_pThisExt As TopoCorridor.clsExtension
Private m_pReturnArray As esriSystem.IVariantArray
Private m_ShapeTypeOption As JenDatasetTypes
Private m_pFeatureLayers As esriSystem.IVariantArray
Private m_pLayerNames As esriSystem.IStringArray
Private m_pClipLayers As esriSystem.IVariantArray
Private m_pLayerNewNames As esriSystem.IVariantArray
Private m_pClassRasters As esriSystem.IVariantArray
Private m_pClassRasterNames As esriSystem.IVariantArray
 
Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\brost_climate_change\code\frmRasterExportLayerID.frm"
 
Public Property Set ArcApplication(ByVal pParams As esriSystem.IVariantArray)
  On Error GoTo ErrorHandler
 

 
33:   Set m_pApp = pParams.Element(0)
34:   m_ShapeTypeOption = ENUM_jenRasterLayers
35:   Set m_pMxDoc = pParams.Element(1)
36:   Set m_pThisExt = pParams.Element(2)
 
  Dim pSelItem As IUnknown
39:   Set pSelItem = m_pMxDoc.SelectedItem
  Dim pLayer As ILayer
  Dim pRastLayer As IRasterLayer
  Dim pStandaloneTable As IStandaloneTable
  Dim lngIndex As Long
  Dim pUnknown As IUnknown
45:   Set m_pClipLayers = New esriSystem.VarArray
46:   Set m_pClassRasters = New esriSystem.VarArray
47:   Set m_pClassRasterNames = New esriSystem.VarArray
  
49:   m_strSelLayerName = ""
 
51:   If Not pSelItem Is Nothing Then
52:     If TypeOf pSelItem Is ILayer Then
53:       Set pLayer = pSelItem
54:       m_strSelLayerName = pLayer.Name
55:     ElseIf TypeOf pSelItem Is IStandaloneTable Then
56:       Set pStandaloneTable = pSelItem
57:       m_strSelLayerName = pStandaloneTable.Name
58:     End If
59:   End If

61:   m_pThisExt.ShouldContinue = False
62:   m_booSelToggle = False

  ' FILL LAYER ARRAYs AND LISTBOXs
65:   cbxTemplate.Clear
'  Dim lngStartSel As Long
'  lngStartSel = 0
'  Dim pRastLayer As IRasterLayer
'  Set m_pLayerArray = TopoCorridor.MyGeneralOperations.ReturnLayersByType(m_pMxDoc.FocusMap, m_ShapeTypeOption)
'  If m_pLayerArray.Count > 0 Then
'    For lngIndex = 0 To m_pLayerArray.Count - 1
'      Set pRastLayer = m_pLayerArray.Element(lngIndex)
'      If pRastLayer.Valid Then
'        cbxTemplate.AddItem pRastLayer.Name
'        If pRastLayer.Name = m_strSelLayerName Then lngStartSel = lngIndex
'      End If
'    Next lngIndex
'    cbxTemplate.ListIndex = lngStartSel
'    cbxTemplate_Click
'  End If
  
  Dim pTempLayerArray As esriSystem.IVariantArray
83:   Set pTempLayerArray = TopoCorridor.MyGeneralOperations.ReturnLayersByType(m_pMxDoc.FocusMap, ENUM_jenRasterLayers)
84:   Set m_pLayerArray = New esriSystem.VarArray
85:   Set m_pLayerNames = New esriSystem.strArray
  
  Dim pRastBandColl As IRasterBandCollection
  Dim pRastBand As IRasterBand
  Dim pRaster As IRaster
  Dim lngIndex2 As Long
  Dim lngSelCounter As Long
92:   lngSelCounter = -1
  Dim strBandName As String
  Dim lngStartSel As Long
95:   lngStartSel = 0
  Dim lngClassSelCounter As Long
97:   lngClassSelCounter = -1
  Dim lngStartClassSel As Long
99:   lngStartClassSel = -1
  
  Dim pTempTable As ITable
  
103:   If pTempLayerArray.Count > 0 Then
104:     For lngIndex = 0 To pTempLayerArray.Count - 1
105:       Set pUnknown = pTempLayerArray.Element(lngIndex)
106:       If TypeOf pUnknown Is IRasterLayer Then
107:         Set pRastLayer = pUnknown
108:         If pRastLayer.Valid Then
109:           Set pRaster = pRastLayer.Raster
110:           Set pRastBandColl = pRaster
111:           If pRastBandColl.Count = 1 Then
112:             strBandName = pRastLayer.Name
113:             m_pLayerNames.Add strBandName
114:             Set pRastBand = pRastBandColl.Item(0)
115:             m_pLayerArray.Add pRastBand
116:             lngSelCounter = lngSelCounter + 1
117:             If pRastLayer.Name = m_strSelLayerName Then lngStartSel = lngSelCounter
            
119:             Set pTempTable = TopoCorridor.TopoCor_Functions.ReturnRasterTable(pRastBand)
            
'            If Not pRastBand.AttributeTable Is Nothing Then
122:             If Not pTempTable Is Nothing Then
123:               lngClassSelCounter = lngClassSelCounter + 1
124:               m_pClassRasters.Add pRastBand
125:               m_pClassRasterNames.Add strBandName
126:               If pRastLayer.Name = m_strSelLayerName Then lngStartClassSel = lngClassSelCounter
127:               cbxTemplate.AddItem strBandName
128:             End If
            
130:           Else
131:             For lngIndex2 = 0 To pRastBandColl.Count - 1
132:               Set pRastBand = pRastBandColl.Item(lngIndex2)
133:               strBandName = pRastLayer.Name & " [Band " & CStr(lngIndex2 + 1) & "]"
134:               m_pLayerNames.Add strBandName
              
136:               Set pTempTable = TopoCorridor.TopoCor_Functions.ReturnRasterTable(pRastBand)
'              If Not pRastBand.AttributeTable Is Nothing Then
138:               If Not pTempTable Is Nothing Then
139:                 lngClassSelCounter = lngClassSelCounter + 1
140:                 m_pClassRasters.Add pRastBand
141:                 m_pClassRasterNames.Add strBandName
142:                 If pRastLayer.Name = m_strSelLayerName Then lngStartClassSel = lngClassSelCounter
143:                 cbxTemplate.AddItem strBandName
144:               End If
              
146:               m_pLayerArray.Add pRastBandColl.Item(lngIndex2)
147:               lngSelCounter = lngSelCounter + 1
148:               If pRastLayer.Name = m_strSelLayerName Then lngStartSel = lngSelCounter
149:             Next lngIndex2
150:           End If
151:         End If
152:       End If
153:     Next lngIndex
'    MsgBox "lngStartClassSel = " & CStr(lngStartClassSel)
155:     If lngStartClassSel = -1 And cbxTemplate.ListCount > 0 Then lngStartClassSel = 0
156:     If lngStartClassSel > -1 Then
157:       cbxTemplate.ListIndex = lngStartClassSel         ' <------------------------------
158:       cbxTemplate_Click
159:     End If
160:   End If
  
162:   lbxFeatureClasses.Clear
  ' MODIFIED OCT 31 TO ALLOW FOR FEATURE CLASS + ATTRIBUE FIELD COMBOS
164:   Set m_pFeatureLayers = New esriSystem.VarArray
  
166:   If m_pThisExt.RasterExportClip Then
167:     chkClipData.Value = 1
168:   Else
169:     chkClipData.Value = 0
170:   End If
  
172:   Set m_pClipLayers = TopoCorridor.MyGeneralOperations.ReturnLayersByType(m_pMxDoc.FocusMap, ENUM_jenPolygonLayers)
  Dim pFeatLayer As IFeatureLayer
174:   cbxClipLayer.Clear
175:   If m_pClipLayers.Count > 0 Then
176:     For lngIndex = 0 To m_pClipLayers.Count - 1
177:       Set pFeatLayer = m_pClipLayers.Element(lngIndex)
178:       If pFeatLayer.Valid Then
179:         cbxClipLayer.AddItem CStr(lngIndex + 1) & "] " & pFeatLayer.Name
180:       End If
181:     Next lngIndex
182:   Else
183:     cbxClipLayer.AddItem "<-- No Polygon Layers -->"
184:   End If
185:   cbxClipLayer.ListIndex = 0
  
187:   If m_pThisExt.RasterExportAddCombined Then
188:     chkAddCombined.Value = 1
189:   Else
190:     chkAddCombined.Value = 0
191:   End If
  
  Dim strBaseString As String
194:   strBaseString = strBaseString & "This tool will export multiple raster and polygon datasets to tables of data suitable for analysis in a stand-alone statistics program such as R.  It will produce a separate table for each unique category it finds in the specified categorical raster." & vbNewLine
195:   strBaseString = strBaseString & " " & vbNewLine
196:   strBaseString = strBaseString & "All exported raster data will be projected and resized, if necessary, to match the projection and size of the specified categorical raster.  All raster and polygon data will be converted to a table where each record contains the values for all data layers at that location.  Tables may be in either dBASE (*.dbf) or comma-delimited text (*.csv) format." & vbNewLine
197:   strBaseString = strBaseString & " " & vbNewLine
198:   strBaseString = strBaseString & "Note:  This tool does not perform the actual statistical analysis!  Use your statistical software to perform the fuzzy clustering routines to decide the appropriate number of clusters and locate the cluster centroid, then use the 'Import from R' tool to apply the cluster results to your original input data." & vbNewLine

200:   txtMessage.Text = strBaseString

  ' FILL OUTPUT FEATURE CLASS SECTION
         
  ' CLEAR INITIAL SELECTION
  Dim boolWorkspaceExists As Boolean
  Dim strDirPath As String
207:   strDirPath = m_pThisExt.Folder_Export_Location
  
209:   boolWorkspaceExists = TopoCorridor.aml_func_mod.ExistFileDir(strDirPath)
'  boolWorkspaceExists = Not Dir$(strDirPath, vbDirectory) = ""
  
212:   If Not boolWorkspaceExists Then
213:     strDirPath = TopoCorridor.aml_func_mod.GetFullFileString(TopoCorridor.aml_func_mod.TempPathLocation)
214:   End If
215:   If Right(strDirPath, 1) <> "\" Then strDirPath = strDirPath & "\"
  
217:   cbxFormat.Clear
218:   cbxFormat.AddItem "dBASE (*.dbf)"
219:   cbxFormat.AddItem "Comma-Delimited (*.csv)"
  
  Dim strTempName As String
222:   strTempName = strDirPath & "FuzzyData"
223:   If m_pThisExt.RasterExportFormat = 0 Then
'    strTempName = TopoCorridor.MyGeneralOperations.MakeUniquedBASEName(strDirPath & "FuzzyData.dbf")
225:     cbxFormat.ListIndex = 0
226:   Else
'    strTempName = TopoCorridor.MyGeneralOperations.MakeUniqueShapeFilename(strDirPath & "FuzzyData.csv")
228:     cbxFormat.ListIndex = 1
229:   End If
  
231:   txtOutput.Text = strDirPath
232:   txtOutput.SelStart = Len(txtOutput.Text)
  
234:   Set m_pThisExt.frmRasterExportLayerIDReturn = Nothing

236:   Set pSelItem = Nothing
237:   Set pLayer = Nothing
238:   Set pRastLayer = Nothing
239:   Set pStandaloneTable = Nothing
240:   Set pUnknown = Nothing
241:   Set pTempLayerArray = Nothing
242:   Set pRastBandColl = Nothing
243:   Set pRastBand = Nothing
244:   Set pRaster = Nothing
245:   Set pFeatLayer = Nothing
246:   Set pTempTable = Nothing
  
248:   CheckEnable
  
 Exit Property
ErrorHandler:
  HandleError True, "ArcApplication " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Public Property Get ReturnArray() As esriSystem.IVariantArray
  On Error GoTo ErrorHandler
 
258:   Set ReturnArray = m_pReturnArray
 
  Exit Property
ErrorHandler:
  HandleError True, "ReturnArray " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub CheckEnable()
  On Error GoTo ErrorHandler
  
268:   If m_pClipLayers.Count = 0 Then
269:     chkClipData.Enabled = False
270:     chkClipData.Value = 0
271:   Else
272:     chkClipData.Enabled = True
273:   End If
  
275:   If chkClipData.Value = 0 Then
276:     cbxClipLayer.Enabled = False
277:     cbxClipLayer.BackColor = &H8000000F
278:   Else
279:     cbxClipLayer.Enabled = True
280:     cbxClipLayer.BackColor = &H80000005
281:   End If
  
283:   cmdOK.Enabled = cbxTemplate.ListCount > 0 And txtOutput.Text <> "" And _
      lbxFeatureClasses.SelCount + lbxLayers.SelCount > 0
285:   cmdDelete.Enabled = lbxFeatureClasses.SelCount = 1
286:   cmdClearAll.Enabled = lbxFeatureClasses.ListCount > 0
 
  Exit Sub
ErrorHandler:
  HandleError False, "CheckEnable " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 

Private Sub cbxClipLayer_Change()
  On Error GoTo ErrorHandler

297:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "cbxClipLayer_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cbxClipLayer_Click()
  On Error GoTo ErrorHandler

307:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "cbxClipLayer_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cbxFormat_Change()
  On Error GoTo ErrorHandler

317:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "cbxFormat_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cbxTemplate_Click()
  On Error GoTo ErrorHandler
  
327:   If cbxTemplate.ListCount > 0 Then
    Dim strCheckName As String
329:     strCheckName = cbxTemplate.Text
    
    Dim pRastBand As IRasterBand
332:     Set pRastBand = m_pClassRasters.Element(cbxTemplate.ListIndex)   ' <-----------------
    
    Dim pTempRastband As IRasterBand
335:     lbxLayers.Clear
    
    Dim strRastName As String
338:     Set m_pLayerNewArray = New esriSystem.VarArray
339:     Set m_pLayerNewNames = New esriSystem.VarArray
    Dim lngIndex As Long
    Dim lngCounter As Long
342:     lngCounter = 0
343:     If m_pLayerArray.Count > 0 Then
344:       For lngIndex = 0 To m_pLayerArray.Count - 1
345:         Set pTempRastband = m_pLayerArray.Element(lngIndex)
346:         strRastName = m_pLayerNames.Element(lngIndex)
347:         If (StrComp(strCheckName, strRastName, vbTextCompare) <> 0) And (Not pTempRastband Is pRastBand) Then
348:           m_pLayerNewArray.Add pTempRastband
349:           lngCounter = lngCounter + 1
350:           m_pLayerNewNames.Add strRastName
351:           lbxLayers.AddItem CStr(lngCounter) & "] " & strRastName
352:         End If
353:       Next lngIndex
354:     End If
355:     CheckEnable
    
357:     Set pRastBand = Nothing
358:     Set pTempRastband = Nothing
359:   End If
  
  Exit Sub
ErrorHandler:
  HandleError True, "cbxTemplate_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub chkClipData_Click()
  On Error GoTo ErrorHandler

369:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "chkClipData_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdAdd_Click()
  On Error GoTo ErrorHandler
  
379:   Set m_pThisExt.frmCircuitscapeLayerIDReturn = Nothing
  
'  Me.Visible = False
  Dim lngWidth As Long
  Dim lngHeight As Long
384:   lngWidth = Me.Width
385:   lngHeight = Me.Height
  
  Dim pVarArray As esriSystem.IVariantArray
388:   Set pVarArray = New VarArray

  ' ADD APPLICATION
391:   pVarArray.Add m_pApp

  ' ADD DESIRED LAYER TYPES
  Dim pLayerTypes As JenLayerTypes
'  pLayerTypes = ENUM_jenPointLayers + ENUM_jenPolylineLayers + ENUM_jenPolygonLayers + ENUM_jenMultipointLayers
396:   pLayerTypes = ENUM_jenPolygonLayers
397:   pVarArray.Add pLayerTypes

  'EXTENSION SHOULD HAVE PROPERTIES FOR "ShouldContinue", "DirectoryPath", "frmCircuitscapeLayerIDReturn",
  '     "DirectoryType", "IsFeatureDataset", "FeatDatasetName"
401:   pVarArray.Add m_pThisExt

  ' ADD DESIRED FIELD TYPES
  Dim pFieldTypes As JenFieldTypes
405:   pFieldTypes = ENUM_FieldNumber + ENUM_FieldOID
406:   pVarArray.Add pFieldTypes

  ' ADD WHETHER TO INCLUDE ID FIELD
409:   pVarArray.Add (False)

  ' ADD WHETHER ANY OUTPUT WILL BE A FEATURE CLASS (TRUE) OR TABLE (FALSE)         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
  Dim booOutputIsFClass As Boolean                                                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
413:   booOutputIsFClass = True                                                         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
414:   pVarArray.Add (booOutputIsFClass)                                                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
  
416:   Me.Height = Me.Height - Me.ScaleHeight
  
  Dim pForm As TopoCorridor.frmCircuitscapeLayerID
419:   Set pForm = New TopoCorridor.frmCircuitscapeLayerID
420:   Set pForm.ArcApplication = pVarArray
421:   pForm.Show vbModal, Me
422:   Set pForm = Nothing

424:   Me.Width = lngWidth
425:   Me.Height = lngHeight
426:   Me.SetFocus
  
428:   If m_pThisExt.ShouldContinue = False Then
429:     Set pVarArray = Nothing
    Exit Sub
431:   End If

  Dim pReturnArray As esriSystem.IVariantArray
434:   Set pReturnArray = m_pThisExt.frmCircuitscapeLayerIDReturn
435:   Set m_pThisExt.frmCircuitscapeLayerIDReturn = Nothing
436:   m_pThisExt.ShouldContinue = False
  
  ' OUTPUT
  ' SELECTED TABLE OR LAYER
  Dim pUnknown As IUnknown
441:   Set pUnknown = pReturnArray.Element(0)

  ' FOR DEBUGGING
  Dim strReport As String
445:   strReport = "Selected Items:" & vbNewLine

447:   If TypeOf pUnknown Is ILayer Then
    Dim pLayer As ILayer
449:     Set pLayer = pUnknown
450:     strReport = strReport & "Name:  " & pLayer.Name & vbNewLine
451:   ElseIf TypeOf pUnknown Is IStandaloneTable Then
    Dim pStTab As IStandaloneTable
453:     Set pStTab = pUnknown
454:     strReport = strReport & "Name:  " & pStTab.Name & vbNewLine
455:   End If

  ' SELECTED FIELD OR FIELDS
  Dim pSelFields As esriSystem.IVariantArray
459:   Set pSelFields = pReturnArray.Element(1)
460:   strReport = strReport & CStr(pSelFields.Count) & " fields selected..." & vbNewLine

  Dim pField As IField
463:   Set pField = pSelFields.Element(0)
464:   strReport = strReport & "First Selected Field is named '" & pField.Name & "'" & vbNewLine

  Dim pAddArray As esriSystem.IVariantArray
467:   Set pAddArray = New esriSystem.VarArray
468:   pAddArray.Add pUnknown
469:   pAddArray.Add pField
  
'  Me.Visible = True
472:   m_pFeatureLayers.Add pAddArray
473:   FillFeatureClassListbox
474:   CheckEnable
  
476:   Set pVarArray = Nothing
477:   Set pForm = Nothing
478:   Set pReturnArray = Nothing
479:   Set pUnknown = Nothing
480:   Set pLayer = Nothing
481:   Set pStTab = Nothing
482:   Set pSelFields = Nothing
483:   Set pField = Nothing
484:   Set pAddArray = Nothing

  Exit Sub
ErrorHandler:
  HandleError True, "cmdAdd_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdClearAll_Click()
  On Error GoTo ErrorHandler

  
495:   m_pFeatureLayers.RemoveAll
496:   FillFeatureClassListbox
497:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "cmdClearAll_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdDelete_Click()
  On Error GoTo ErrorHandler
  Dim lngIndex As Long
  
508:   For lngIndex = 0 To lbxFeatureClasses.ListCount - 1
509:     If lbxFeatureClasses.Selected(lngIndex) Then
510:       m_pFeatureLayers.Remove (lngIndex)
511:       Exit For
512:     End If
513:   Next lngIndex
  
515:   FillFeatureClassListbox
  
517:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "cmdDelete_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub FillFeatureClassListbox()
  On Error GoTo ErrorHandler

527:   lbxFeatureClasses.Clear
  Dim lngIndex As Long
  Dim pSubArray As esriSystem.IVariantArray
  Dim pFeatLayer As IFeatureLayer
  Dim strName As String
  Dim pField As IField
  
534:   If m_pFeatureLayers.Count > 0 Then
535:     For lngIndex = 0 To m_pFeatureLayers.Count - 1
536:       Set pSubArray = m_pFeatureLayers.Element(lngIndex)
537:       Set pFeatLayer = pSubArray.Element(0)
538:       Set pField = pSubArray.Element(1)
539:       strName = pField.AliasName
540:       If strName = "" Then strName = pField.Name
541:       lbxFeatureClasses.AddItem CStr(lngIndex + 1) & "] " & pFeatLayer.Name & ", [" & strName & "]"
542:     Next lngIndex
543:   End If
  
545:   Set pSubArray = Nothing
546:   Set pFeatLayer = Nothing
547:   Set pField = Nothing
548:   lbxLayers.ListIndex = -1

  Exit Sub
ErrorHandler:
  HandleError False, "FillFeatureClassListbox " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdGetWorkspace_Click()
  On Error GoTo ErrorHandler

  Dim strDirPath As String
  Dim strUserName As String
  
561:   strDirPath = txtOutput.Text
562:   If Right(strDirPath, 1) <> "\" And Right(strDirPath, 1) <> "/" Then strDirPath = strDirPath & "\"
563:   If Not TopoCorridor.aml_func_mod.ExistFileDir(strDirPath) Then
564:     strDirPath = TopoCorridor.aml_func_mod.GetFullFileString(TopoCorridor.aml_func_mod.GetMxDocPath(m_pApp))
565:     strDirPath = TopoCorridor.aml_func_mod.ReturnDir(strDirPath)
566:   End If
  
  Dim boolWorkspaceExists As Boolean
  ' MODIFIED FEB 2008 TO ADD vbDirectory
570:   boolWorkspaceExists = TopoCorridor.aml_func_mod.ExistFileDir(strDirPath)
'  boolWorkspaceExists = Not Dir$(strDirPath, vbDirectory) = ""
  
573:   If Not boolWorkspaceExists Then
574:     strDirPath = TopoCorridor.aml_func_mod.GetFullFileString(TopoCorridor.aml_func_mod.TempPathLocation)
575:   End If

  Dim pGxDialog As IGxDialog
578:   Set pGxDialog = New GxDialog
  
  Dim pGxDialogFilter As IGxObjectFilter
581:   Set pGxDialogFilter = New GxFilterBasicTypes
  
  Dim pGxObject As IGxObject
  Dim pGxSelection As IEnumGxObject
  
586:   With pGxDialog
587:     .AllowMultiSelect = False
588:     .StartingLocation = strDirPath
589:     .Title = "Please select (don't open!) folder to save output tables:"
590:     Set .ObjectFilter = pGxDialogFilter
591:   End With
  
  Dim theFinalString As String

595:   If (pGxDialog.DoModalOpen(Me.hWnd, pGxSelection) = True) Then
596:     Set pGxObject = pGxSelection.Next
    
    Dim pGxFile As IGxFile
599:     Set pGxFile = pGxObject
    
601:     theFinalString = pGxObject.FullName
602:     If (Right(theFinalString, 1) <> "\") And (Right(theFinalString, 1) <> "/") Then theFinalString = theFinalString & "\"

604:     txtOutput.Text = theFinalString
605:     txtOutput.BackColor = &H80000005
    
607:   End If
  
609:   CheckEnable
  
611:   Set pGxDialog = Nothing
612:   Set pGxDialogFilter = Nothing
613:   Set pGxObject = Nothing
614:   Set pGxSelection = Nothing
615:   Set pGxFile = Nothing


  
'  ' SET DEFAULT NAME
'  Dim strDefault As String
'  strDefault = txtOutput.Text
'
'  cdlg.Filter = "Comma-Delimited Text (*.csv)|*.csv|dBASE Table (*.dbf)|*.dbf"
'  cdlg.InitDir = TopoCorridor.aml_func_mod.ReturnDir(strDefault)
'  cdlg.FileName = TopoCorridor.aml_func_mod.ReturnFilename(strDefault)
'  cdlg.ShowSave
'
'  Dim strFileName As String
'  strFileName = cdlg.FileName
'
'  If strFileName <> "" Then
'    Dim strBaseName As String
'    strBaseName = TopoCorridor.aml_func_mod.ReturnFilename(strFileName)
'
'  End If
''  MsgBox "strFileName = " & strFileName
'
'  txtOutput.Text = strFileName
'  txtOutput.SelStart = Len(txtOutput.Text)
'---------------------------------------------------------------------------------
'' BELOW FROM CIRCUITSCAPE
'  Dim strDirPath As String
'  Dim strUserName As String
'
'  strDirPath = txtOutput.Text
'  If Right(strDirPath, 1) <> "\" And Right(strDirPath, 1) <> "/" Then strDirPath = strDirPath & "\"
'  If Not TopoCorridor.aml_func_mod.ExistFileDir(strDirPath) Then
'    strDirPath = TopoCorridor.aml_func_mod.GetFullFileString(TopoCorridor.aml_func_mod.GetMxDocPath(m_pApp))
'    strDirPath = TopoCorridor.aml_func_mod.ReturnDir(strDirPath)
'  End If
'
'  Dim boolWorkspaceExists As Boolean
'  ' MODIFIED FEB 2008 TO ADD vbDirectory
'  boolWorkspaceExists = TopoCorridor.aml_func_mod.ExistFileDir(strDirPath)
''  boolWorkspaceExists = Not Dir$(strDirPath, vbDirectory) = ""
'
'  If Not boolWorkspaceExists Then
'    strDirPath = TopoCorridor.aml_func_mod.GetFullFileString(TopoCorridor.aml_func_mod.TempPathLocation)
'  End If
'
'  Dim pGxDialog As IGxDialog
'  Set pGxDialog = New GxDialog
'
'  Dim pGxDialogFilter As IGxObjectFilter
'  Set pGxDialogFilter = New GxFilterBasicTypes
'
'  Dim pGxObject As IGxObject
'  Dim pGxSelection As IEnumGxObject
'
'  With pGxDialog
'    .AllowMultiSelect = False
'    .StartingLocation = strDirPath
'    .Title = "Please select (don't open!) folder to save ASCII rasters:"
'    Set .ObjectFilter = pGxDialogFilter
'  End With
'
'  Dim theFinalString As String
'  Dim pGxFile As IGxFile
'  If (pGxDialog.DoModalOpen(Me.hWnd, pGxSelection) = True) Then
'    Set pGxObject = pGxSelection.Next
'
'
'    Set pGxFile = pGxObject
'
'    theFinalString = pGxObject.FullName
'    If (Right(theFinalString, 1) <> "\") And (Right(theFinalString, 1) <> "/") Then theFinalString = theFinalString & "\"
'
'    txtOutput.Text = theFinalString
'    txtOutput.BackColor = &H80000005
'
'  End If
'
'  CheckEnable
'
'  Set pGxDialog = Nothing
'  Set pGxDialogFilter = Nothing
'  Set pGxObject = Nothing
'  Set pGxSelection = Nothing
'  Set pGxFile = Nothing

  Exit Sub
ErrorHandler:
  HandleError True, "cmdGetWorkspace_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub lbxFeatureClasses_Click()
  On Error GoTo ErrorHandler

709:   CheckEnable
  

  Exit Sub
ErrorHandler:
  HandleError True, "lbxFeatureClasses_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub txtOutput_Change()
  On Error GoTo ErrorHandler
 
720:   CheckEnable
  
  Exit Sub
ErrorHandler:
  HandleError True, "txtOutput_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
Private Sub cmdManual_Click()
  On Error GoTo ErrorHandler

  
  ' CHANGE AS APPROPRIATE
  Dim strDir As String
732:   strDir = App.Path
733:   If Right(strDir, 1) <> "\" Then strDir = strDir & "\"
734:   strDir = strDir & "docs"
  
736:   Call TopoCorridor.MyGeneralOperations.OpenDoc("Land_Facet_Tools.pdf", strDir)
  
  Exit Sub
ErrorHandler:
  HandleError True, "cmdManual_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdCancel_Click()
  On Error GoTo ErrorHandler

746:   m_pThisExt.ShouldContinue = False
747:   Set m_pThisExt.frmRasterExportLayerIDReturn = Nothing
748:   Set m_pReturnArray = Nothing
749:   Unload Me
 
  Exit Sub
ErrorHandler:
  HandleError True, "cmdCancel_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdOK_Click()
  On Error GoTo ErrorHandler

  ' RETURN ARRAY CONTAINS THE FOLLOWING:
  ' 0) IRasterBand:  TPI SLOPE CLASSIFICATION RASTER BAND
  ' 1) String: Name of TPI SLOPE CLASSIFICATION Band Layer
  ' 2) IVariantArray:  ADDITIONAL RASTER LAYERS; COULD BE EMPTY
  ' 3) IVariantArray:  ADDITIONAL FEATURE LAYERS; COULD BE EMPTY
  ' 4) Boolean:  WHETHER TO CLIP OUTPUT TO POLYGON LAYER
  ' 5) IFeatureLayer:  POLYGON LAYER TO CLIP TO, COULD BE NOTHING
  ' 6) String:  cbxFormat Text
  ' 7) IWorkspace: WORKSPACE, EITHER TextFileWorkspace OR ShapefileWorkspace
  ' 8) Boolean:  WHETHER ALL DATASETS ARE MISSING A SPATIAL REFERENCE
  ' 9) Boolean:  Whether to add combined raster to map.
  
771:   Set m_pReturnArray = New esriSystem.VarArray
  
  Dim booAllHaveNoSpRef As Boolean
774:   booAllHaveNoSpRef = True
  Dim booSomeHaveNoSpRef As Boolean
776:   booSomeHaveNoSpRef = False
  
  Dim pCheckSpRef As ISpatialReference
  Dim pCheckGeoDataset As IGeoDataset
  Dim pTempRaster As IRaster
  Dim pTempFClass As IFeatureClass
  Dim pTempSpRef As ISpatialReference
  Dim pProblemList As esriSystem.IStringArray
784:   Set pProblemList = New esriSystem.strArray
  Dim pSubArray As esriSystem.IVariantArray
  
  Dim strHaveSpRef As String
788:   strHaveSpRef = "The following selected datasets have known spatial references:" & vbCrLf
  Dim strNoSpRef As String
790:   strNoSpRef = "The following selected datasets do not have known spatial references:" & vbCrLf
  
  ' SELECTED TEMPLATE
  Dim strInputName As String
  Dim pTemplate As IRasterBand
795:   Set pTemplate = m_pClassRasters.Element(cbxTemplate.ListIndex)
796:   strInputName = m_pClassRasterNames.Element(cbxTemplate.ListIndex)
797:   m_pReturnArray.Add pTemplate
798:   m_pReturnArray.Add strInputName
  
  ' ADDITIONAL RASTERS
  Dim lngIndex As Long
  Dim pAdditionalRasters As esriSystem.IVariantArray
803:   Set pAdditionalRasters = New esriSystem.VarArray
  Dim pTempBand As IRasterBand
  Dim strTempLayerName As String
806:   If lbxLayers.ListCount > 0 Then
807:     For lngIndex = 0 To lbxLayers.ListCount - 1
808:       If lbxLayers.Selected(lngIndex) Then
809:         Set pTempBand = m_pLayerNewArray.Element(lngIndex)
810:         strTempLayerName = m_pLayerNewNames.Element(lngIndex)
811:         Set pCheckGeoDataset = pTempBand
812:         Set pTempSpRef = pCheckGeoDataset.SpatialReference
813:         If Not pTempSpRef Is Nothing Then
814:           If Not TypeOf pTempSpRef Is IUnknownCoordinateSystem Then
815:             booAllHaveNoSpRef = False
816:             strHaveSpRef = strHaveSpRef & "  --> " & strTempLayerName & "   [" & pTempSpRef.Name & "]" & vbCrLf
817:           Else
818:             booSomeHaveNoSpRef = True
819:             pProblemList.Add strTempLayerName & "   [Raster Layer]"
820:             strNoSpRef = strNoSpRef & "  --> " & strTempLayerName & vbCrLf
821:           End If
822:         Else
823:           booSomeHaveNoSpRef = True
824:           pProblemList.Add strTempLayerName & "   [Raster Layer]"
825:           strNoSpRef = strNoSpRef & "  --> " & strTempLayerName & vbCrLf
826:         End If
827:         Set pSubArray = New esriSystem.VarArray
828:         pSubArray.Add pTempBand
829:         pSubArray.Add strTempLayerName
830:         pAdditionalRasters.Add pSubArray
831:       End If
832:     Next lngIndex
833:   End If
834:   m_pReturnArray.Add pAdditionalRasters
  
  ' ADDITIONAL FEATURE LAYERS
  ' MODIFIED OCT 31 2009 TO ALLOW FOR FEATURE LAYER + ID FIELD COMBOS
  Dim pAdditionalFeatLayers As esriSystem.IVariantArray
839:   Set pAdditionalFeatLayers = New esriSystem.VarArray
  Dim pTempFeatLayer As IFeatureLayer
841:   If m_pFeatureLayers.Count > 0 Then
842:     For lngIndex = 0 To m_pFeatureLayers.Count - 1
843:       Set pSubArray = m_pFeatureLayers.Element(lngIndex)
844:       Set pTempFeatLayer = pSubArray.Element(0)
      
846:       Set pTempFClass = pTempFeatLayer.FeatureClass
847:       Set pCheckGeoDataset = pTempFClass
848:       Set pTempSpRef = pCheckGeoDataset.SpatialReference
849:       If Not pTempSpRef Is Nothing Then
850:         If Not TypeOf pTempSpRef Is IUnknownCoordinateSystem Then
851:           booAllHaveNoSpRef = False
852:           strHaveSpRef = strHaveSpRef & "  --> " & pTempFeatLayer.Name & "   [" & pTempSpRef.Name & "]" & vbCrLf
853:         Else
854:           booSomeHaveNoSpRef = True
855:           pProblemList.Add pTempFeatLayer.Name & "   [Feature Layer]"
856:           strNoSpRef = strNoSpRef & "  --> " & pTempFeatLayer.Name & vbCrLf
857:         End If
858:       Else
859:         booSomeHaveNoSpRef = True
860:         pProblemList.Add pTempFeatLayer.Name & "   [Feature Layer]"
861:         strNoSpRef = strNoSpRef & "  --> " & pTempFeatLayer.Name & vbCrLf
862:       End If
863:       pAdditionalFeatLayers.Add pSubArray
864:     Next lngIndex
865:   End If
    
    
'  If lbxFeatureClasses.ListCount > 0 Then
'    For lngIndex = 0 To lbxFeatureClasses.ListCount - 1
'      If lbxFeatureClasses.Selected(lngIndex) Then
'        Set pTempFeatLayer = m_pFeatureLayers.Element(lngIndex)
'        Set pTempFClass = pTempFeatLayer.FeatureClass
'        Set pCheckGeoDataset = pTempFClass
'        Set pTempSpRef = pCheckGeoDataset.SpatialReference
'        If Not pTempSpRef Is Nothing Then
'          If Not TypeOf pTempSpRef Is IUnknownCoordinateSystem Then
'            booAllHaveNoSpRef = False
'            strHaveSpRef = strHaveSpRef & "  --> " & pTempFeatLayer.Name & "   [" & pTempSpRef.Name & "]" & vbCrLf
'          Else
'            booSomeHaveNoSpRef = True
'            pProblemList.Add pTempFeatLayer.Name & "   [Feature Layer]"
'            strNoSpRef = strNoSpRef & "  --> " & pTempFeatLayer.Name & vbCrLf
'          End If
'        Else
'          booSomeHaveNoSpRef = True
'          pProblemList.Add pTempFeatLayer.Name & "   [Feature Layer]"
'          strNoSpRef = strNoSpRef & "  --> " & pTempFeatLayer.Name & vbCrLf
'        End If
'        pAdditionalFeatLayers.Add pTempFeatLayer
'      End If
'    Next lngIndex
'  End If
  
894:   m_pReturnArray.Add pAdditionalFeatLayers
  
  ' CLIP LAYER
  Dim pClipLayer As IFeatureLayer
898:   If m_pClipLayers.Count > 0 And chkClipData.Value = 1 Then
899:     Set pClipLayer = m_pClipLayers.Element(cbxClipLayer.ListIndex)
900:     Set pCheckGeoDataset = pClipLayer.FeatureClass
901:     Set pTempSpRef = pCheckGeoDataset.SpatialReference
902:     If Not pTempSpRef Is Nothing Then
903:       If Not TypeOf pTempSpRef Is IUnknownCoordinateSystem Then
904:         booAllHaveNoSpRef = False
905:         strHaveSpRef = strHaveSpRef & "  --> " & pClipLayer.Name & "   [" & pTempSpRef.Name & "]" & vbCrLf
906:       Else
907:         booSomeHaveNoSpRef = True
908:         pProblemList.Add pClipLayer.Name & "   [Clip Feature Layer]"
909:         strNoSpRef = strNoSpRef & "  --> " & pClipLayer.Name & vbCrLf
910:       End If
911:     Else
912:       booSomeHaveNoSpRef = True
913:       pProblemList.Add pClipLayer.Name & "   [Clip Feature Layer]"
914:       strNoSpRef = strNoSpRef & "  --> " & pClipLayer.Name & vbCrLf
915:     End If
916:     m_pReturnArray.Add True
917:     m_pReturnArray.Add pClipLayer
918:   Else
919:     m_pReturnArray.Add False
920:     m_pReturnArray.Add Nothing
921:   End If
  
  ' OUTPUT SECTION
  Dim strWS As String
  Dim strFilename As String
  Dim pWS As IWorkspace
  Dim pWS2 As IWorkspace2
  Dim pRastWS As IRasterWorkspace2
  Dim pRastWsEx As IRasterWorkspaceEx
  Dim strFullPath As String
  Dim pWsFact As IWorkspaceFactory2
  Dim pDataset As IDataset
  Dim booIsFGB As Boolean
  Dim iPos As Integer
  Dim booExcludeIfAnyNull As Boolean
  
937:   strWS = txtOutput.Text
938:   If Right(strWS, 1) = "\" Then
939:     strWS = Left(strWS, Len(strWS) - 1)
940:   End If
  
  ' MAKE SURE WORKSPACE EXISTS
943:   If Not TopoCorridor.aml_func_mod.ExistFileDir(strWS) Then
944:     MsgBox "Unable to open workspace folder:" & vbCrLf & _
           strWS & " is not a valid folder...", , "Failed to Open Workspace:"
946:     txtOutput.SetFocus
947:     txtOutput.BackColor = vbYellow
    Exit Sub
949:   End If
    
951:   If cbxFormat.ListIndex = 0 Then        ' dBASE
952:     Set pWsFact = New ShapefileWorkspaceFactory
953:   Else                                   ' CSV
954:     Set pWsFact = New TextFileWorkspaceFactory
955:   End If
956:   Set pWS = pWsFact.OpenFromFile(strWS, Me.hWnd)
       
958:   m_pReturnArray.Add cbxFormat.Text
959:   m_pReturnArray.Add pWS
      
'  strFullPath = txtOutput.Text
'  strFileName = TopoCorridor.aml_func_mod.ReturnFilename(strFullPath)
'  strWS = TopoCorridor.aml_func_mod.ReturnDir(strFullPath)
'  If Right(strWS, 1) = "\" Then
'    strWS = Left(strWS, Len(strWS) - 1)
'  End If
'
'  ' CLIP OFF ANY EXTENSIONS TO NAME
'  iPos = InStrRev(strFileName, ".")
'  If iPos > 0 Then
'    strFileName = Left(strFileName, iPos - 1)
'  End If
'
'  Dim strPathMinusExtension As String
'  strPathMinusExtension = strWS & "\" & strFileName
'  Dim strTrueFullpath As String
'  Dim strFileWithExtension As String
'
'  ' MAKE SURE WORKSPACE EXISTS
'  If Not TopoCorridor.aml_func_mod.ExistFileDir(strWS) Then
'    MsgBox "Unable to create table:" & vbCrLf & _
'           strWS & " is not a valid folder...", , "Failed to Create Table:"
'    txtOutput.SetFocus
'    Exit Sub
'  End If
'
'  booIsFGB = StrComp(Right(strWS, 4), ".gdb", vbTextCompare) = 0
'  If booIsFGB Then
'    MsgBox "Problem:" & vbCrLf & _
'           "You have selected a File Geodatabase workspace, but this tool is only intended " & vbCrLf & _
'           "to create comma-delimited text files or dBASE files, for use in other software" & vbCrLf & _
'           "like the R statistical package.  3rd party software packages are generally not able to " & vbCrLf & _
'           "read ESRI file geodatabases.", , "Invalid Workspace Specified:"
'    txtOutput.SetFocus
'    Exit Sub
'  End If
'
'  If cbxFormat.ListIndex = 0 Then        ' dBASE
'    Set pWsFact = New ShapefileWorkspaceFactory
'    strTrueFullpath = strPathMinusExtension & ".dbf"
'    strFileWithExtension = strFileName & ".dbf"
'  Else                                   ' CSV
'    Set pWsFact = New TextFileWorkspaceFactory
'    strTrueFullpath = strPathMinusExtension & ".csv"
'    strFileWithExtension = strFileName & ".csv"
'  End If
'  Set pWS = pWsFact.OpenFromFile(strWS, Me.hWnd)
'
'  m_pReturnArray.Add cbxFormat.Text
'  m_pReturnArray.Add strFileWithExtension
'  m_pReturnArray.Add pWS
  
'  ' MAKE SURE TABLE DOES NOT EXIST
  Dim lngVBResult As VbMsgBoxResult
'  If TopoCorridor.aml_func_mod.ExistFileDir(strTrueFullpath) Then
'    lngVBResult = MsgBox("File '" & strFileWithExtension & "' Already exists!" & vbCrLf & _
'           "Would you like this tool to attempt to delete the existing file?", vbYesNo, _
'           "File Exists:")
'    If lngVBResult = vbYes Then
'      Kill strTrueFullpath
'
'      If TopoCorridor.aml_func_mod.ExistFileDir(strTrueFullpath) Then
'        MsgBox "Unable to delete '" & strFileWithExtension & "'..." & vbCrLf & _
'          "Please delete this file manually before attempting to create a new file with this name."
'        txtOutput.SetFocus
'        Exit Sub
'      End If
'    Else
'      txtOutput.SetFocus
'      Exit Sub
'    End If
'    txtOutput.SetFocus
'    Exit Sub
'  End If
  
'  ' CHECK FOR VALID WORKSPACE
'  Dim strOutput As String
'  strOutput = txtOutput.Text
'  If Not TopoCorridor.aml_func_mod.ExistFileDir(strOutput) Then
'    MsgBox "Unable to Export Rasters:" & vbCrLf & _
'           strOutput & " is not a valid workspace...", , "Failed to Find Output Folder:"
'    txtOutput.SetFocus
'    Exit Sub
'  End If
'  m_pReturnArray.Add strOutput
'  m_pThisExt.Folder_Export_Location = strOutput
  
  ' CHECK SPATIAL REFERENCE EXISTS FOR TEMPLATE
  Dim pSpRef As ISpatialReference
  Dim pExtent As IEnvelope
  Dim pGeoDataset As IGeoDataset
1052:   Set pGeoDataset = pTemplate
1053:   Set pSpRef = pGeoDataset.SpatialReference
1054:   Set pExtent = pGeoDataset.Extent
  
'  MsgBox "TypeOf pSpRef Is IUnknownCoordinateSystem = " & CStr(TypeOf pSpRef Is IUnknownCoordinateSystem)
1057:   If TypeOf pSpRef Is IUnknownCoordinateSystem Then
  
    ' ONLY CONTINUE IF ALL OTHER DATASETS ALSO HAVE NO SPATIAL REFERENCE
1060:     If Not booAllHaveNoSpRef Then
    
1062:       MsgBox "Problem with Template Raster '" & strInputName & "':" & vbCrLf & _
             "  --> Unknown Spatial Reference..." & vbCrLf & vbCrLf & _
             "This function requires that either the Template Raster have a spatial reference," & vbCrLf & _
             "or that all selected datasets have no spatial reference." & vbCrLf & vbCrLf & _
             strHaveSpRef, , "Problem - Unable to Continue:"
1067:       cbxTemplate.SetFocus
      Exit Sub
1069:     End If
1070:   Else
  
    ' CONFIRM OK IF SOME DATASETS HAVE NO SPATIAL REFERENCE
1073:     If booSomeHaveNoSpRef Then
1074:       lngVBResult = MsgBox("Potential Problem:  Please click 'YES' to continue or 'NO' to return to dialog..." & vbCrLf & _
                           vbCrLf & _
                           "Your template raster has the following spatial reference:" & vbCrLf & _
                           "  --> " & pSpRef.Name & vbCrLf & vbCrLf & _
                           strNoSpRef & vbCrLf & _
                           "Should this function assume the datasets above have the same spatial reference as the template?", _
                           vbYesNo, "Potential Problem:")
1081:       If Not lngVBResult = vbYes Then
1082:         cbxTemplate.SetFocus
        Exit Sub
1084:       End If
                           
1086:     End If
1087:   End If
  
1089:   m_pReturnArray.Add booAllHaveNoSpRef
1090:   m_pReturnArray.Add chkAddCombined.Value = 1

1092:   m_pThisExt.RasterExportFormat = cbxFormat.ListIndex
1093:   m_pThisExt.RasterExportClip = chkClipData.Value = 1
1094:   m_pThisExt.RasterExportAddCombined = chkAddCombined.Value = 1
1095:   m_pThisExt.Folder_Export_Location = strWS
1096:   m_pThisExt.ShouldContinue = True

  Dim pSaveArray As esriSystem.IVariantArray
1099:   Set pSaveArray = New esriSystem.VarArray
1100:   For lngIndex = 0 To m_pReturnArray.Count - 1
1101:     pSaveArray.Add m_pReturnArray.Element(lngIndex)
1102:   Next lngIndex
1103:   Set m_pThisExt.frmRasterExportLayerIDReturn = pSaveArray
  

1106:   Set pCheckSpRef = Nothing
1107:   Set pCheckGeoDataset = Nothing
1108:   Set pTempRaster = Nothing
1109:   Set pTempFClass = Nothing
1110:   Set pTempSpRef = Nothing
1111:   Set pProblemList = Nothing
1112:   Set pTemplate = Nothing
1113:   Set pAdditionalRasters = Nothing
1114:   Set pTempBand = Nothing
1115:   Set pAdditionalFeatLayers = Nothing
1116:   Set pTempFeatLayer = Nothing
1117:   Set pSubArray = Nothing
1118:   Set pClipLayer = Nothing
1119:   Set pWS = Nothing
1120:   Set pWS2 = Nothing
1121:   Set pRastWS = Nothing
1122:   Set pRastWsEx = Nothing
1123:   Set pWsFact = Nothing
1124:   Set pDataset = Nothing
1125:   Set pSpRef = Nothing
1126:   Set pExtent = Nothing
1127:   Set pGeoDataset = Nothing
1128:   Set pSaveArray = Nothing
  
1130:   Unload Me
      
'  Me.Visible = False
 
  Exit Sub
ErrorHandler:
  HandleError True, "cmdOK_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub Form_Load()
  On Error GoTo ErrorHandler
 
1142:   SetWindowPos Me.hWnd, -1, 0, 0, 0, 0, &H1 Or &H2
1143:   Me.Left = (Screen.Width / 2) - (Me.Width / 2)
1144:   Me.Top = (Screen.Height / 3) - (Me.Height / 3)
  Dim lngTopBar As Long
1146:   lngTopBar = Me.Height - Me.ScaleHeight
1147:   Me.Height = imgCornerBars.Top + imgCornerBars.Height + lngTopBar
 
1149:   Set Anchors = New AnchorObjectList  ' Create new instance
1150:    With Anchors
1151:       With .Item(cmdCancel)
1152:          .SetAnchors enumSizeEnd, enumSizeEnd
1153:       End With
1154:       With .Item(cmdManual)
1155:          .SetAnchors enumStartSize, enumSizeEnd
1156:       End With
1157:       With .Item(cmdOK)
1158:          .SetAnchors enumSizeEnd, enumSizeEnd
1159:       End With
1160:       With .Item(imgBackTop)
1161:          .SetAnchors enumStartEnd, enumStartEnd
1162:       End With
1163:       With .Item(imgCornerBars)
1164:          .SetAnchors enumSizeEnd, enumSizeEnd
1165:       End With
1166:       With .Item(lblAdditional)
1167:          .SetAnchors enumSize, enumStartSize
1168:       End With
1169:       With .Item(cbxTemplate)
1170:          .SetAnchors enumStartEnd, enumStartSize
1171:       End With
1172:       With .Item(lblLayer)
1173:          .SetAnchors enumSize, enumStartSize
1174:       End With
1175:       With .Item(lbxLayers)
1176:          .SetAnchors enumStartEnd, enumStartEnd
1177:       End With
1178:       With .Item(lblShapefiles)
1179:          .SetAnchors enumSize, enumSizeEnd
1180:       End With
1181:       With .Item(lbxFeatureClasses)
1182:          .SetAnchors enumStartEnd, enumSizeEnd
1183:       End With
1184:       With .Item(txtMessage)
1185:          .SetAnchors enumStartEnd, enumStartSize
1186:       End With
1187:       With .Item(chkAddCombined)
1188:          .SetAnchors enumStartSize, enumSizeEnd
1189:       End With
      
      ' CLIP SECTION
1192:       With .Item(imgClip)
1193:          .SetAnchors enumStartEnd, enumSizeEnd
1194:       End With
1195:       With .Item(chkClipData)
1196:          .SetAnchors enumStartSize, enumSizeEnd
1197:       End With
1198:       With .Item(cbxClipLayer)
1199:          .SetAnchors enumStartEnd, enumSizeEnd
1200:       End With
      
      ' OUTPUT SECTION
1203:       With .Item(imgBackBottom)
1204:          .SetAnchors enumStartEnd, enumSizeEnd
1205:       End With
1206:       With .Item(lblOutputName)
1207:          .SetAnchors enumStartSize, enumSizeEnd
1208:       End With
1209:       With .Item(lblFolder)
1210:          .SetAnchors enumStartSize, enumSizeEnd
1211:       End With
1212:       With .Item(lblFormat)
1213:          .SetAnchors enumStartSize, enumSizeEnd
1214:       End With
1215:       With .Item(cbxFormat)
1216:          .SetAnchors enumStartEnd, enumSizeEnd
1217:       End With
1218:       With .Item(txtOutput)
1219:          .SetAnchors enumStartEnd, enumSizeEnd
1220:       End With
1221:       With .Item(cmdGetWorkspace)
1222:          .SetAnchors enumSizeEnd, enumSizeEnd
1223:       End With
      
      
1226:       With .Item(cmdAdd)
1227:          .SetAnchors enumSizeEnd, enumSizeEnd
1228:       End With
1229:       With .Item(cmdDelete)
1230:          .SetAnchors enumSizeEnd, enumSizeEnd
1231:       End With
1232:       With .Item(cmdClearAll)
1233:          .SetAnchors enumSizeEnd, enumSizeEnd
1234:       End With
1235:       With .Item(cmdManual)
1236:          .SetAnchors enumSizeEnd, enumSizeEnd
1237:       End With
      

1240:       .Form = Me  ' Set form reference (suggested to be last step)
1241:    End With
  
  
1244:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub Form_Unload(Cancel As Integer)
  On Error GoTo ErrorHandler
 
1254:   Set m_pMxDoc = Nothing
1255:   Set m_pApp = Nothing
1256:   Set Anchors = Nothing
1257:   Set m_pLayerArray = Nothing
1258:   Set m_pLayerNewArray = Nothing
1259:   Set m_pThisExt = Nothing
1260:   Set m_pReturnArray = Nothing
1261:   Set m_pFeatureLayers = Nothing
1262:   Set m_pLayerNames = Nothing
1263:   Set m_pClipLayers = Nothing
1264:   Set m_pLayerNewNames = Nothing
1265:   Set m_pClassRasters = Nothing
1266:   Set m_pClassRasterNames = Nothing
  
  Exit Sub
ErrorHandler:
  HandleError True, "Form_Unload " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub lbxLayers_Click()
  On Error GoTo ErrorHandler

  
1277:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "lbxLayers_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub ExtraCodeRequired()
 
  '' PUT IN EXTENSION CLASS
  '
  'Private m_booShouldContinue As Boolean
  'Private m_strDirPath As String
  'Private m_pfrmRasterExportLayerIDReturn As esriSystem.IVariantArray
  'Private m_strDirType As String
  'Private m_booIsFeatDataset As Boolean
  'Private m_strFeatDatasetName As String
  '
  '' PUT IN EXTENSION SHUTDOWN EVENT
  ' Set m_pfrmRasterExportLayerIDReturn = Nothing
  '
  '' SET FOLLOWING PROPERTIES
  'Public Property Let FeatDatasetName(strFeatDatasetName As String)
  '  m_strFeatDatasetName = strFeatDatasetName
  'End Property
  'Public Property Get FeatDatasetName() As String
  '  FeatDatasetName = m_strFeatDatasetName
  'End Property
  'Public Property Let IsFeatureDataset(booIsFeatDataset As Boolean)
  '  m_booIsFeatDataset = booIsFeatDataset
  'End Property
  'Public Property Get IsFeatureDataset() As Boolean
  '  IsFeatureDataset = m_booIsFeatDataset
  'End Property
  'Public Property Let DirectoryType(strDirType As String)
  '  m_strDirType = strDirType
  'End Property
  'Public Property Get DirectoryType() As String
  '  DirectoryType = m_strDirType
  'End Property
  '
  'Public Property Set frmRasterExportLayerIDReturn(pfrmRasterExportLayerIDReturn As esriSystem.IVariantArray)
  '  Set m_pfrmRasterExportLayerIDReturn = pfrmRasterExportLayerIDReturn
  'End Property
  '
  'Public Property Get frmRasterExportLayerIDReturn() As esriSystem.IVariantArray
  '  Set frmRasterExportLayerIDReturn = m_pfrmRasterExportLayerIDReturn
  'End Property
  '
  'Public Property Let DirectoryPath(strPath As String)
  '  On Error GoTo ErrorHandler
  '  m_strDirPath = strPath
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "DirectoryPath " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  'Public Property Get DirectoryPath() As String
  '  On Error GoTo ErrorHandler
  '  DirectoryPath = m_strDirPath
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "DirectoryPath " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  'Public Property Let ShouldContinue(booShouldContinue As Boolean)
  '  On Error GoTo ErrorHandler
  '  m_booShouldContinue = booShouldContinue
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "ShouldContinue " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  'Public Property Get ShouldContinue() As Boolean
  '  On Error GoTo ErrorHandler
  '  ShouldContinue = m_booShouldContinue
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "ShouldContinue " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  '' PUT IN EXTENSION STARTUP EVENT
  '  If m_strDirPath = "" Or m_strDirType = "" Then
  '    m_strDirType = "Shapefile"
  '    m_strDirPath = ""
  '    m_booIsFeatDataset = False
  '    m_strFeatDatasetName = ""
  '  End If
  '
  '===============================================================================================================
  '
' ' SAMPLE CODE
'
'  ' CHECK CURRENT SAVED WORKSPACE AND WORKSPACE TYPE.
'  ' IF EITHER WORKSPACE OR WORKSPACE TYPE = "", OR IF WORKSPACE IS INAPPROPRIATE FOR WORKSPACE
'  ' TYPE, THEN RESET WORKSPACE TO DOCUMENT LOCATION AND WORKSPACE TYPE TO "Shapefile"
'  On Error Resume Next
'  Dim strWsPathname As String
'
''  MsgBox "Before:" & vbCrLf & _
''       "DirectoryPath = " & m_pThisExt.DirectoryPath & vbCrLf & _
''       "DirectoryType = " & m_pThisExt.DirectoryType & vbCrLf & _
''       "IsFeatureDataset = " & m_pThisExt.IsFeatureDataset & vbCrLf & _
''       "FeatDatasetName = " & m_pThisExt.FeatDatasetName
'
'  strWsPathname = TopoCorridor.aml_func_mod.ReturnDir _
'        (TopoCorridor.aml_func_mod.GetFullFileString(TopoCorridor.aml_func_mod.GetMxDocPath(m_pApp)))
'  If Right(strWsPathname, 1 = "\") Then strWsPathname = Left(strWsPathname, Len(strWsPathname) - 1)
'  If m_pThisExt.DirectoryPath = "" Or m_pThisExt.DirectoryType = "" Then
'    m_pThisExt.DirectoryPath = strWsPathname
'    m_pThisExt.DirectoryType = "Shapefile"
'    m_pThisExt.IsFeatureDataset = False
'    m_pThisExt.FeatDatasetName = ""
'  Else
'    ' CHECK IF VALID AND APPROPRIATE WORKSPACE
'    Dim pWsFact As IWorkspaceFactory
'    Dim pFeatWS As IFeatureWorkspace
'    Select Case m_pThisExt.DirectoryType
'      Case "Shapefile", ""
'        Set pWsFact = New ShapefileWorkspaceFactory
'      Case "File Geodatabase"
'        Set pWsFact = New FileGDBWorkspaceFactory
'      Case "Personal Geodatabase"
'        Set pWsFact = New AccessWorkspaceFactory
'      Case Else
'        m_pThisExt.DirectoryPath = strWsPathname
'        m_pThisExt.DirectoryType = "Shapefile"
'        m_pThisExt.IsFeatureDataset = False
'        m_pThisExt.FeatDatasetName = ""
'        Set pWsFact = New ShapefileWorkspaceFactory
'    End Select
'    If Not pWsFact.IsWorkspace(m_pThisExt.DirectoryPath) Then
'      m_pThisExt.DirectoryPath = strWsPathname
'      m_pThisExt.DirectoryType = "Shapefile"
'      m_pThisExt.IsFeatureDataset = False
'      m_pThisExt.FeatDatasetName = ""
'    End If
'  End If
'  On Error GoTo ErrorHandler
'
''    MsgBox "After:" & vbCrLf & _
''         "DirectoryPath = " & m_pThisExt.DirectoryPath & vbCrLf & _
''         "DirectoryType = " & m_pThisExt.DirectoryType & vbCrLf & _
''         "IsFeatureDataset = " & m_pThisExt.IsFeatureDataset & vbCrLf & _
''         "FeatDatasetName = " & m_pThisExt.FeatDatasetName
'
'    Dim pVarArray As esriSystem.IVariantArray
'    Set pVarArray = New VarArray
'
'    ' ADD APPLICATION
'    pVarArray.Add m_pApp
'
'    ' ADD DESIRED LAYER TYPES
'    Dim pLayerTypes As JenLayerTypes
'    pLayerTypes = ENUM_jenRasterLayers
'    pVarArray.Add pLayerTypes
'
'    'EXTENSION SHOULD HAVE PROPERTIES FOR "ShouldContinue", "DirectoryPath", "frmRasterExportLayerIDReturn",
'    '     "DirectoryType", "IsFeatureDataset", "FeatDatasetName"
'    pVarArray.Add m_pThisExt
'
'    ' ADD DESIRED FIELD TYPES
'    pVarArray.Add 0
'
'    ' ADD WHETHER TO INCLUDE ID FIELD
'    pVarArray.Add (False)
'
'    ' ADD WHETHER ANY OUTPUT WILL BE A FEATURE CLASS (TRUE) OR TABLE (FALSE)         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    Dim booOutputIsFClass As Boolean                                                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    booOutputIsFClass = True                                                         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    pVarArray.Add (booOutputIsFClass)                                                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'
'    Dim pForm As TopoCorridor.frmRasterExportLayerID
'    Set pForm = New TopoCorridor.frmRasterExportLayerID
'    Set pForm.ArcApplication = pVarArray
'    pForm.Show vbModal
'    Set pForm = Nothing
'
'    If m_pThisExt.ShouldContinue = False Then
'      MsgBox "Function Canceled:" & vbCrLf & "Bailing out..."
'      Exit Sub
'    End If
'
'    Dim pReturnArray As esrisystem.IVariantArray
'    Set pReturnArray = m_pThisExt.frmRasterExportLayerIDReturn
 
'    ' OUTPUT
'    ' SELECTED TABLE OR LAYER
'    Dim pUnknown As IUnknown
'    Set pUnknown = pReturnArray.Element(0)
'
'    ' FOR DEBUGGING
'    Dim strReport As String
'    strReport = "Selected Items:" & vbNewLine
'
'    If TypeOf pUnknown Is ILayer Then
'      Dim pLayer As ILayer
'      Set pLayer = pUnknown
'      strReport = strReport & "Name:  " & pLayer.Name & vbNewLine
'    ElseIf TypeOf pUnknown Is IStandaloneTable Then
'      Dim pStTab As IStandaloneTable
'      Set pStTab = pUnknown
'      strReport = strReport & "Name:  " & pStTab.Name & vbNewLine
'    End If
'


'  ' CODE SNIPPET TO USE pFieldNamePairs TO TRANSFER ATTRIBUTE DATA FROM OLD SOURCE TO NEW SOURCE
'  ' MAKE IVariantArray OF FIELD NAME INDICES
'  ' STRUCTURE:  ARRAY OF 4-ITEM VARIANT ARRAYS
'  '             ITEMS = 0) ORIGINAL FCLASS FIELD NAME
'  '                     1) ORIGINAL FCLASS FIELD INDEX
'  '                     2) NEW FCLASS FIELD NAME
'  '                     3) NEW FCLASS FIELD INDEX
'  Dim pFieldNamePairs As esriSystem.IVariantArray
'  Set pFieldNamePairs = pOutputArray.Element(9)
'  Dim pFieldNameData As esriSystem.IVariantArray
'  Set pFieldNameData = TopoCorridor.MyGeneralOperations.MakeFieldNameVarArray(pFeatureClass, pNewFClass, pFieldNamePairs, True)
'  Dim lngFieldIndex As Long
'  Dim pFieldSubArray As esriSystem.IVariantArray
'  ' ROTATE THROUGH ALL FEATURES / ROWS
'    ' TRANSFER ATTRIBUTE DATA; ASSUMES pBuffer ALREADY EXISTS
'    For lngFieldIndex = 0 To pFieldNameData.Count - 1
'      Set pFieldSubArray = pFieldNameData.Element(lngFieldIndex)
'      pBuffer.Value(pFieldSubArray.Element(3)) = pFeature.Value(pFieldSubArray.Element(1))
'    Next lngFieldIndex
'  ' LOOP

''  ' SAMPLE SNIPPET FOR FEATURE LAYERS:  ROTATE THROUGH ALL OR SELECTED RECORDS
''  Dim pFeatureLayer As IFeatureLayer
''  Dim pFClass As IFeatureClass
''  Dim pFeatSel As IFeatureSelection
''  Dim pSelSet As ISelectionSet
''  Dim pCursor As IFeatureCursor
''  Dim lngCount As Long
''
''  Set pFClass = pFeatureLayer.FeatureClass
''  Set pFeatSel = pFeatureLayer
''  Set pSelSet = pFeatSel.SelectionSet
''
''  If pSelSet.Count = 0 Then
''    Set pCursor = pFClass.Search(Nothing, False)
''    lngCount = pFClass.FeatureCount(Nothing)
''  Else
''    If booDoAll = True Then
''      Set pCursor = pFClass.Search(Nothing, False)
''      lngCount = pFClass.FeatureCount(Nothing)
''    Else
''      pSelSet.Search Nothing, True, pCursor
''      lngCount = pSelSet.Count
''    End If
''  End If
''
''  Dim pFeature As IFeature
''  Set pFeature = pCursor.NextFeature
''  Do Until pFeature Is Nothing
''    ' DO ACTIONS
''    Set pFeature = pCursor.NextFeature
''  Loop
''
''  ' SAMPLE CODE SNIPPET:  ADD RECORDS TO FEATURE CLASS USING BUFFER
''  Dim pBuffer As IFeatureBuffer
''  Set pBuffer = pFClass.CreateFeatureBuffer
''  Dim pNewFeatureCursor As IFeatureCursor
''  Set pNewFeatureCursor = pFClass.Insert(True)
''  ' LOOP THROUGH WHATEVER STEPS ARE REQUIRED TO GATHER DATA FOR A SINGLE ROW
''    Set pBuffer.Shape = aGeometry
''    pBuffer.Value(lngFieldIndex) = aValue
''    pNewFeatureCursor.InsertFeature pBuffer
''  ' LOOP
''  pNewFeatureCursor.Flush

''  ' SAMPLE SNIPPET FOR TABLES:  ROTATE THROUGH ALL OR SELECTED RECORDS
''  Dim pStandaloneTable As IStandaloneTable
''  Dim pInputTable As ITable
''  Dim pTableSel As ITableSelection
''  Dim pSelSet As ISelectionSet
''  Dim pRowCursor As ICursor
''  Dim lngCount As Long
''
''  Set pInputTable = pStandaloneTable.Table
''  Set pTableSel = pStandaloneTable
''  Set pSelSet = pTableSel.SelectionSet
''
''  If pSelSet.Count = 0 Then
''    Set pRowCursor = pInputTable.Search(Nothing, False)
''    lngCount = pInputTable.FeatureCount(Nothing)
''  Else
''    If booDoAll = True Then
''      Set pRowCursor = pInputTable.Search(Nothing, False)
''      lngCount = pInputTable.FeatureCount(Nothing)
''    Else
''      pSelSet.Search Nothing, True, pRowCursor
''      lngCount = pSelSet.Count
''    End If
''  End If
''
''  Dim pRow As IRow
''  Set pRow = pRowCursor.NextRow
''  Do Until pRow Is Nothing
'''     DO ACTIONS
''    Set pRow = pRowCursor.NextFeature
''  Loop
 
''  ' SAMPLE CODE SNIPPET:  ADD RECORDS TO TABLE USING BUFFER
''  Dim pBuffer As IRowBuffer
''  Set pBuffer = pTable.CreateRowBuffer
''  Dim pTableCursor As ICursor
''  Set pTableCursor = pTable.Insert(True)
''  ' LOOP THROUGH WHATEVER STEPS ARE REQUIRED TO GATHER DATA FOR A SINGLE ROW
''    pBuffer.Value(lngFieldIndex) = aValue
''    pTableCursor.InsertRow pBuffer
''  ' LOOP
''  pTableCursor.Flush
'    ' OUTPUT FEATURE CLASS / TABLE DETAILS
'    Dim pOutputArray As esrisystem.IVariantArray
'    Set pOutputArray = pReturnArray.Element(1)
'
'  If booOutputIsFClass Then
'    Dim pSpRef As ISpatialReference
'    Set pSpRef = pOutputArray.Element(1)
'    strReport = strReport & "Output Details:" & vbCrLf & _
'              "  --> pGeomType = " & CStr(pOutputArray.Element(0)) & vbCrLf & _
'              "  --> Spatial Reference = " & pSpRef.Name & vbCrLf & _
'              "  --> strWsPathName = " & pOutputArray.Element(2) & vbCrLf & _
'              "  --> strBaseName = " & pOutputArray.Element(3) & vbCrLf & _
'              "  --> pCategory = " & CStr(pOutputArray.Element(4)) & vbCrLf & _
'              "  --> Fields Added = " & CStr(Not pOutputArray.Element(5) Is Nothing) & vbCrLf & _
'              "  --> GxDialogCaption = " & pOutputArray.Element(6) & vbCrLf & _
'              "  --> booHasFeatureDataset = " & CStr(pOutputArray.Element(7)) & vbCrLf & _
'              "  --> strFeatDatasetName = " & pOutputArray.Element(8) & vbCrLf
'
'  ' FOR SAMPLE, USE FOLLOWING CODE TO ACTUALLY CREATE FEATURE CLASS
'  ' REQUIRES "MyGeneralOperations", "aml_func_mod"
'    Dim pFClass As IFeatureClass
'    Set pFClass = TopoCorridor.MyGeneralOperations.CreateGeneralFeatureClass(pOutputArray.Element(0), pOutputArray.Element(1), pOutputArray.Element(2), _
'            pOutputArray.Element(3), pOutputArray.Element(4), pOutputArray.Element(5), pOutputArray.Element(6), _
'            pOutputArray.Element(7), pOutputArray.Element(8), True, False, pExtent, lngCount)
'    If pFClass Is Nothing Then
'      MsgBox "No Feature Class Created:" & vbCrLf & "Bailing out..."
'      Exit Sub
'    End If
'  Else
'    strReport = strReport & "Output Details:" & vbCrLf & _
'              "  --> strWsPathName = " & pOutputArray.Element(0) & vbCrLf & _
'              "  --> strBaseName = " & pOutputArray.Element(1) & vbCrLf & _
'              "  --> pCategory = " & CStr(pOutputArray.Element(2)) & vbCrLf & _
'              "  --> Fields Added = " & CStr(Not pOutputArray.Element(3) Is Nothing) & vbCrLf & _
'              "  --> GxDialogCaption = " & pOutputArray.Element(4) & vbCrLf
'    Dim pTable As ITable
'      Set pTable = TopoCorridor.MyGeneralOperations.CreateGeneralTable(pOutputArray.Element(0), pOutputArray.Element(1), _
'            pOutputArray.Element(2), pOutputArray.Element(3), pOutputArray.Element(4))
'    If pTable Is Nothing Then
'      MsgBox "No Table Created:" & vbCrLf & "Bailing out..."
'      Exit Sub
'    End If
'  End If
'
'  ' ----------------------------------------------------------------------------------------------------
'  ' SNIPPET TO MAKE TABLE AND ADD TO MAP DOCUMENT
'  Dim pNewStandaloneTable As IStandaloneTable
'  Dim pTableWindow2 As ITableWindow2
'  Dim pStandaloneTableCollection As IStandaloneTableCollection
'
'  Set pNewStandaloneTable = New StandaloneTable
'  Set pNewStandaloneTable.Table = pTable
'
'  Set pTableWindow2 = New TableWindow
'
'  With pTableWindow2
'    Set .StandaloneTable = pNewStandaloneTable
'    Set .Application = pApp
'    .TableSelectionAction = esriSelectFeatures
'    .ShowAliasNamesInColumnHeadings = True
'    .ShowSelected = False
'    .Show True
'  End With
'  Set pStandaloneTableCollection = pMxDoc.FocusMap
'  pStandaloneTableCollection.AddStandaloneTable pNewStandaloneTable
'
'  pMxDoc.UpdateContents
'  ' ----------------------------------------------------------------------------------------------------
'    MsgBox strReport, vbOKOnly, "Test of LayerID Form:"
'
'  Dim pDocDirty As IDocumentDirty
'  Set pDocDirty = m_pMxDoc
'  pDocDirty.SetDirty
'

End Sub
 
