VERSION 5.00
Begin VB.Form frmSaveTablesGeneral 
   Caption         =   " Save Statistical Data Options [Step 3 of 3]:"
   ClientHeight    =   4440
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6915
   Icon            =   "frmSaveTablesGeneral.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   4440
   ScaleWidth      =   6915
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdBack 
      Caption         =   "<-- Back"
      Height          =   345
      Left            =   1290
      TabIndex        =   18
      Top             =   4095
      Width           =   1065
   End
   Begin VB.CommandButton cmdSpearman 
      Height          =   360
      Left            =   6210
      Picture         =   "frmSaveTablesGeneral.frx":058A
      Style           =   1  'Graphical
      TabIndex        =   17
      ToolTipText     =   "Browse for Output Table..."
      Top             =   3480
      Width           =   555
   End
   Begin VB.TextBox txtSpearman 
      Height          =   330
      Left            =   495
      TabIndex        =   16
      Text            =   "txtSpearman"
      Top             =   3495
      Width           =   5640
   End
   Begin VB.CheckBox chkSpearman 
      Caption         =   "Save Spearman's Rank Correlation (Rho) Matrix?"
      Height          =   240
      Left            =   165
      TabIndex        =   15
      Top             =   3240
      Width           =   4200
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   345
      Left            =   2385
      TabIndex        =   12
      Top             =   4095
      Width           =   1065
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   345
      Left            =   4560
      TabIndex        =   14
      Top             =   4095
      Width           =   1065
   End
   Begin VB.CommandButton cmdManual 
      Caption         =   "Manual"
      Height          =   345
      Left            =   3480
      TabIndex        =   13
      Top             =   4095
      Width           =   1065
   End
   Begin VB.CheckBox chkCorrelation 
      Caption         =   "Save Correlation Matrix?"
      Height          =   240
      Left            =   165
      TabIndex        =   9
      Top             =   2463
      Width           =   3150
   End
   Begin VB.TextBox txtCorrelation 
      Height          =   330
      Left            =   495
      TabIndex        =   10
      Text            =   "txtCorrelation"
      Top             =   2718
      Width           =   5640
   End
   Begin VB.CommandButton cmdCorrelation 
      Height          =   360
      Left            =   6210
      Picture         =   "frmSaveTablesGeneral.frx":0600
      Style           =   1  'Graphical
      TabIndex        =   11
      ToolTipText     =   "Browse for Output Table..."
      Top             =   2703
      Width           =   555
   End
   Begin VB.CheckBox chkInvCov 
      Caption         =   "Save Inverse Covariance Matrix?"
      Height          =   240
      Left            =   165
      TabIndex        =   6
      Top             =   1687
      Width           =   3150
   End
   Begin VB.TextBox txtInvCov 
      Height          =   330
      Left            =   495
      TabIndex        =   7
      Text            =   "txtInvCov"
      Top             =   1942
      Width           =   5640
   End
   Begin VB.CommandButton cmdInvCov 
      Height          =   360
      Left            =   6210
      Picture         =   "frmSaveTablesGeneral.frx":0676
      Style           =   1  'Graphical
      TabIndex        =   8
      ToolTipText     =   "Browse for Output Table..."
      Top             =   1927
      Width           =   555
   End
   Begin VB.CheckBox chkCov 
      Caption         =   "Save Covariance Matrix?"
      Height          =   240
      Left            =   165
      TabIndex        =   3
      Top             =   911
      Width           =   3150
   End
   Begin VB.TextBox txtCov 
      Height          =   330
      Left            =   495
      TabIndex        =   4
      Text            =   "txtCov"
      Top             =   1166
      Width           =   5640
   End
   Begin VB.CommandButton cmdCov 
      Height          =   360
      Left            =   6210
      Picture         =   "frmSaveTablesGeneral.frx":06EC
      Style           =   1  'Graphical
      TabIndex        =   5
      ToolTipText     =   "Browse for Output Table..."
      Top             =   1151
      Width           =   555
   End
   Begin VB.CheckBox chkMeans 
      Caption         =   "Save Vector of Mean Values?"
      Height          =   240
      Left            =   165
      TabIndex        =   0
      Top             =   135
      Width           =   3150
   End
   Begin VB.TextBox txtMeans 
      Height          =   330
      Left            =   495
      TabIndex        =   1
      Text            =   "txtMeans"
      Top             =   390
      Width           =   5640
   End
   Begin VB.CommandButton cmdMeans 
      Height          =   360
      Left            =   6210
      Picture         =   "frmSaveTablesGeneral.frx":0762
      Style           =   1  'Graphical
      TabIndex        =   2
      ToolTipText     =   "Browse for Output Table..."
      Top             =   375
      Width           =   555
   End
   Begin VB.Image imgCornerBars 
      Height          =   225
      Left            =   6690
      Picture         =   "frmSaveTablesGeneral.frx":07D8
      Top             =   4215
      Width           =   225
   End
   Begin VB.Image imgBack 
      BorderStyle     =   1  'Fixed Single
      Height          =   4035
      Left            =   0
      Top             =   0
      Width           =   6915
   End
End
Attribute VB_Name = "frmSaveTablesGeneral"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Anchors As AnchorObjectList  ' Main anchor control objec
Private m_pMxDoc As esriArcMapUI.IMxDocument
Private m_pApp As IApplication
Private m_pThisExt As TopoCorridor.clsExtension
Private m_strMeansBasename As String
Private m_strMeansDirName As String
Private m_strMeansFullText As String
Private m_pMeansWSType As JenDatasetTypes
Private m_strCovBasename As String
Private m_strCovDirName As String
Private m_strCovFullText As String
Private m_pCovWStype As JenDatasetTypes
Private m_strInvCovBasename As String
Private m_strInvCovDirName As String
Private m_strInvCovFullText As String
Private m_pInvCovWStype As JenDatasetTypes
Private m_strCorrBasename As String
Private m_strCorrDirName As String
Private m_strCorrFullText As String
Private m_pCorrWStype As JenDatasetTypes
Private m_strSpearmanCorrBasename As String
Private m_strSpearmanCorrDirName As String
Private m_strSpearmanCorrFullText As String
Private m_pSpearmanCorrWStype As JenDatasetTypes

Const m_booOutputIsFClass As Boolean = False     ' HARD-CODED TO FALSE BECAUSE THIS DIALOG ONLY EXPORTS TO TABLES

Const c_sModuleFileName As String = "D:\arcGIS_stuff\general_tools\Mahalanobis\Code\frmSaveTablesGeneral.frm"

Public Property Set ArcApplication(ByVal pParams As esriSystem.IVariantArray)
  On Error GoTo ErrorHandler
  
34:   Set m_pApp = pParams.Element(0)
35:   Set m_pMxDoc = pParams.Element(1)
36:   Set m_pThisExt = pParams.Element(2)
  
  
  ' FILL OUTPUT FEATURE CLASS SECTION
  Dim strMeansName As String
  Dim strCovName As String
  Dim strInvCovName As String
  Dim strCorrName As String
  Dim strSpearmanName As String
 
  ' WORKSPACE
  ' FIRST SEE IF IT HAS BEEN SAVED TO EXTENSION PROPERTIES.  THIS PROPERTY WILL BE EMPTY THE FIRST TIME THE DIALOG
  '      IS OPENED, BUT EACH TIME THEREAFTER IT WILL HAVE A VALUE.  THIS VALUE ALSO GETS SAVED WITH THE DOCUMENT.
  ' IF NOT IN EXTENSION PROPERTY, THEN CHECK ArcGIS LAST SAVE TO LOCATION
  ' IF THIS DOESN'T WORK, USE MxDoc PATH NAME.
  Dim strDirPath As String
  Dim strUserName As String
  Dim lngDatasetType As JenDatasetTypes
  Dim strDatasetType As String
  Dim booIsFeatDataset As Boolean
  Dim strFeatDatasetName As String
 
58:   strDirPath = m_pThisExt.DirectoryPath
59:   strDatasetType = m_pThisExt.DirectoryType
60:   booIsFeatDataset = m_pThisExt.IsFeatureDataset
61:   strFeatDatasetName = m_pThisExt.FeatDatasetName
  Select Case strDatasetType
    Case "Shapefile", ""
64:       lngDatasetType = ENUM_Shapefile
65:       If m_booOutputIsFClass Then                   ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
66:         strMeansName = "Means.shp"                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
67:         strCovName = "Covariance.shp"                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
68:         strInvCovName = "Inv_Covariance.shp"                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
69:         strCorrName = "Correlation.shp"                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
70:         strSpearmanName = "Spearman_Rho.shp"                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
71:       Else                                          ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
72:         strMeansName = "Means.dbf"                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
73:         strCovName = "Covariance.dbf"                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
74:         strInvCovName = "Inv_Covariance.dbf"                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
75:         strCorrName = "Correlation.dbf"                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
76:         strSpearmanName = "Spearman_Rho.dbf"                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
77:       End If                                        ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
    Case "File Geodatabase"
79:       lngDatasetType = ENUM_FileGDB
80:       strMeansName = "Means"
81:       strCovName = "Covariance"
82:       strInvCovName = "InvCov"
83:       strCorrName = "Correlation"
84:       strSpearmanName = "Spearman_Rho"
    Case "Personal Geodatabase"
86:       lngDatasetType = ENUM_PersonalGDB
87:       strMeansName = "Means"
88:       strCovName = "Covariance"
89:       strInvCovName = "InvCov"
90:       strCorrName = "Correlation"
91:       strSpearmanName = "Spearman_Rho"
    Case Else
93:       lngDatasetType = 0
94:   End Select

  ' IF TABLE, SET FEATURE DATASET TO FALSE          ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
97:   If Not m_booOutputIsFClass Then                   ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
98:     booIsFeatDataset = False                        ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
99:     strFeatDatasetName = ""                         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
100:   End If                                            ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
 
102:   If (Not TopoCorridor.aml_func_mod.ExistFileDir(strDirPath)) Or (lngDatasetType = 0) Then
103:     strDirPath = TopoCorridor.aml_func_mod.GetFullFileString(TopoCorridor.aml_func_mod.GetMxDocPath(m_pApp))
104:     strDirPath = TopoCorridor.aml_func_mod.ReturnDir(strDirPath)
105:     lngDatasetType = ENUM_Shapefile
106:     booIsFeatDataset = False
107:     strFeatDatasetName = ""
108:   End If

  Dim pWsFact As IWorkspaceFactory2
  Dim pFeatWS As IWorkspace2
  Dim strForTextbox As String
  Dim strWsPathname As String
  Dim strBaseName As String

'  MsgBox "Setting Properties:  #1" & vbCrLf & _
         "(Not TopoCorridor.aml_func_mod.ExistFileDir(strDirPath)) = " & CStr((Not TopoCorridor.aml_func_mod.ExistFileDir(strDirPath))) & vbCrLf & _
         "lngDatasetType = " & CStr(lngDatasetType) & vbCrLf & _
         "strDirPath = " & strDirPath & vbCrLf & _
         "strDatasetType = " & strDatasetType & vbCrLf & _
         "booIsFeatDataset = " & CStr(booIsFeatDataset) & vbCrLf & _
         "strFeatDatasetName = " & strFeatDatasetName & vbCrLf & _
         "strShapeName = " & strShapeName
  
  Dim strDirPathMeans As String
  Dim strDirPathCov As String
  Dim strDirPathInvCov As String
  Dim strDirPathCorr As String
  Dim strDirPathSpearman As String
  
  Dim strWsMeans As String
  Dim strWsCov As String
  Dim strWsInvCov As String
  Dim strWsCorr As String
  Dim strWsSpearman As String
  
  Dim strBaseNameMeans As String
  Dim strBaseNameCov As String
  Dim strBaseNameInvCov As String
  Dim strBaseNameCorr As String
  Dim strBaseNameSpearman As String
  
  Select Case lngDatasetType
    Case ENUM_Shapefile
145:       If Right(strDirPath, 1) <> "\" And Right(strDirPath, 1) <> "/" Then
146:         strDirPath = strDirPath & "\"
147:       End If
148:       If m_booOutputIsFClass Then                                          ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
149:         strDirPathMeans = TopoCorridor.MyGeneralOperations.MakeUniqueShapeFilename(strDirPath & strMeansName)
150:         strDirPathCov = TopoCorridor.MyGeneralOperations.MakeUniqueShapeFilename(strDirPath & strCovName)
151:         strDirPathInvCov = TopoCorridor.MyGeneralOperations.MakeUniqueShapeFilename(strDirPath & strInvCovName)
152:         strDirPathCorr = TopoCorridor.MyGeneralOperations.MakeUniqueShapeFilename(strDirPath & strCorrName)
153:         strDirPathSpearman = TopoCorridor.MyGeneralOperations.MakeUniqueShapeFilename(strDirPath & strSpearmanName)
154:       Else
155:         strDirPathMeans = TopoCorridor.MyGeneralOperations.MakeUniquedBASEName(strDirPath & strMeansName)
156:         strDirPathCov = TopoCorridor.MyGeneralOperations.MakeUniquedBASEName(strDirPath & strCovName)
157:         strDirPathInvCov = TopoCorridor.MyGeneralOperations.MakeUniquedBASEName(strDirPath & strInvCovName)
158:         strDirPathCorr = TopoCorridor.MyGeneralOperations.MakeUniquedBASEName(strDirPath & strCorrName)
159:         strDirPathSpearman = TopoCorridor.MyGeneralOperations.MakeUniquedBASEName(strDirPath & strSpearmanName)
160:       End If                                                               ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
      
      ' BREAK UP FULL PATH NAMES INTO FILE AND WORKSPACE NAMES
163:       strWsMeans = TopoCorridor.aml_func_mod.ReturnDir(strDirPathMeans)
164:       strWsCov = TopoCorridor.aml_func_mod.ReturnDir(strDirPathCov)
165:       strWsInvCov = TopoCorridor.aml_func_mod.ReturnDir(strDirPathInvCov)
166:       strWsCorr = TopoCorridor.aml_func_mod.ReturnDir(strDirPathCorr)
167:       strWsSpearman = TopoCorridor.aml_func_mod.ReturnDir(strDirPathSpearman)

169:       If Right(strWsMeans, 1) = "\" Then strWsMeans = Left(strWsMeans, Len(strWsMeans) - 1)
170:       If Right(strWsCov, 1) = "\" Then strWsCov = Left(strWsCov, Len(strWsCov) - 1)
171:       If Right(strWsInvCov, 1) = "\" Then strWsInvCov = Left(strWsInvCov, Len(strWsInvCov) - 1)
172:       If Right(strWsCorr, 1) = "\" Then strWsCorr = Left(strWsCorr, Len(strWsCorr) - 1)
173:       If Right(strWsSpearman, 1) = "\" Then strWsSpearman = Left(strWsSpearman, Len(strWsSpearman) - 1)
      
175:       strBaseNameMeans = TopoCorridor.aml_func_mod.ReturnFilename(strDirPathMeans)
176:       strBaseNameCov = TopoCorridor.aml_func_mod.ReturnFilename(strDirPathCov)
177:       strBaseNameInvCov = TopoCorridor.aml_func_mod.ReturnFilename(strDirPathInvCov)
178:       strBaseNameCorr = TopoCorridor.aml_func_mod.ReturnFilename(strDirPathCorr)
179:       strBaseNameSpearman = TopoCorridor.aml_func_mod.ReturnFilename(strDirPathSpearman)
      
    Case ENUM_FileGDB
182:       If Right(strDirPath, 1) = "\" Or Right(strDirPath, 1) = "/" Then
183:         strDirPath = Left(strDirPath, Len(strDirPath) - 1)
184:       End If
185:       Set pWsFact = New FileGDBWorkspaceFactory
186:       Set pFeatWS = pWsFact.OpenFromFile(strDirPath, Me.hWnd)
187:       If m_booOutputIsFClass Then                                          ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
188:         strMeansName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBFeatureClassName(pFeatWS, strMeansName)
189:         strCovName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBFeatureClassName(pFeatWS, strCovName)
190:         strInvCovName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBFeatureClassName(pFeatWS, strInvCovName)
191:         strCorrName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBFeatureClassName(pFeatWS, strCorrName)
192:         strSpearmanName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBFeatureClassName(pFeatWS, strSpearmanName)
193:       Else
194:         strMeansName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBTableName(pFeatWS, strMeansName)
195:         strCovName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBTableName(pFeatWS, strCovName)
196:         strInvCovName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBTableName(pFeatWS, strInvCovName)
197:         strCorrName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBTableName(pFeatWS, strCorrName)
198:         strSpearmanName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBTableName(pFeatWS, strSpearmanName)
199:       End If                                                               ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
200:       If booIsFeatDataset Then
201:         strDirPathMeans = strDirPath & "\" & strFeatDatasetName & "\" & strMeansName
202:         strDirPathCov = strDirPath & "\" & strFeatDatasetName & "\" & strCovName
203:         strDirPathInvCov = strDirPath & "\" & strFeatDatasetName & "\" & strInvCovName
204:         strDirPathCorr = strDirPath & "\" & strFeatDatasetName & "\" & strCorrName
205:         strDirPathSpearman = strDirPath & "\" & strFeatDatasetName & "\" & strSpearmanName
206:       Else
207:         strDirPathMeans = strDirPath & "\" & strMeansName
208:         strDirPathCov = strDirPath & "\" & strCovName
209:         strDirPathInvCov = strDirPath & "\" & strInvCovName
210:         strDirPathCorr = strDirPath & "\" & strCorrName
211:         strDirPathSpearman = strDirPath & "\" & strSpearmanName
212:       End If
      
214:       strWsPathname = strDirPath
215:       If Right(strWsPathname, 1) = "\" Then strWsPathname = Left(strWsPathname, Len(strWsPathname) - 1)
      
217:       strWsMeans = strWsPathname
218:       strWsCov = strWsPathname
219:       strWsInvCov = strWsPathname
220:       strWsCorr = strWsPathname
221:       strWsSpearman = strWsPathname
      
223:       strBaseNameMeans = strMeansName
224:       strBaseNameCov = strCovName
225:       strBaseNameInvCov = strInvCovName
226:       strBaseNameCorr = strCorrName
227:       strBaseNameSpearman = strSpearmanName
      
    Case ENUM_PersonalGDB
230:       Set pWsFact = New AccessWorkspaceFactory
231:       Set pFeatWS = pWsFact.OpenFromFile(strDirPath, Me.hWnd)
'      MsgBox "In Select Case:  Before " & vbCrLf & "strShapeName = " & strShapeName & vbCrLf & _
              "Workspace is Nothing = " & CStr(pFeatWS Is Nothing)
234:       If m_booOutputIsFClass Then                                          ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
235:         strMeansName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBFeatureClassName(pFeatWS, strMeansName)
236:         strCovName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBFeatureClassName(pFeatWS, strCovName)
237:         strInvCovName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBFeatureClassName(pFeatWS, strInvCovName)
238:         strCorrName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBFeatureClassName(pFeatWS, strCorrName)
239:         strSpearmanName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBFeatureClassName(pFeatWS, strSpearmanName)
240:       Else
241:         strMeansName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBTableName(pFeatWS, strMeansName)
242:         strCovName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBTableName(pFeatWS, strCovName)
243:         strInvCovName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBTableName(pFeatWS, strInvCovName)
244:         strCorrName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBTableName(pFeatWS, strCorrName)
245:         strSpearmanName = TopoCorridor.MyGeneralOperations.MakeUniqueGDBTableName(pFeatWS, strSpearmanName)
246:       End If                                                                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'      MsgBox "In Select Case:  After " & vbCrLf & "strShapeName = " & strShapeName
248:       If booIsFeatDataset Then
249:         strDirPathMeans = strDirPath & "\" & strFeatDatasetName & "\" & strMeansName
250:         strDirPathCov = strDirPath & "\" & strFeatDatasetName & "\" & strCovName
251:         strDirPathInvCov = strDirPath & "\" & strFeatDatasetName & "\" & strInvCovName
252:         strDirPathCorr = strDirPath & "\" & strFeatDatasetName & "\" & strCorrName
253:         strDirPathSpearman = strDirPath & "\" & strFeatDatasetName & "\" & strSpearmanName
254:       Else
255:         strDirPathMeans = strDirPath & "\" & strMeansName
256:         strDirPathCov = strDirPath & "\" & strCovName
257:         strDirPathInvCov = strDirPath & "\" & strInvCovName
258:         strDirPathCorr = strDirPath & "\" & strCorrName
259:         strDirPathSpearman = strDirPath & "\" & strSpearmanName
260:       End If
      
262:       strWsPathname = strDirPath
263:       If Right(strWsPathname, 1) = "\" Then strWsPathname = Left(strWsPathname, Len(strWsPathname) - 1)
      
265:       strWsMeans = strWsPathname
266:       strWsCov = strWsPathname
267:       strWsInvCov = strWsPathname
268:       strWsCorr = strWsPathname
269:       strWsSpearman = strWsPathname
      
271:       strBaseNameMeans = strMeansName
272:       strBaseNameCov = strCovName
273:       strBaseNameInvCov = strInvCovName
274:       strBaseNameCorr = strCorrName
275:       strBaseNameSpearman = strSpearmanName
276:   End Select
  
278:   txtMeans.Text = strDirPathMeans
279:   txtCov.Text = strDirPathCov
280:   txtInvCov.Text = strDirPathInvCov
281:   txtCorrelation.Text = strDirPathCorr
282:   txtSpearman.Text = strDirPathSpearman
283:   txtMeans.SelStart = Len(txtMeans.Text)
284:   txtCov.SelStart = Len(txtCov.Text)
285:   txtInvCov.SelStart = Len(txtInvCov.Text)
286:   txtCorrelation.SelStart = Len(txtCorrelation.Text)
287:   txtSpearman.SelStart = Len(txtSpearman.Text)
  
  ' SET DIALOG CONTROLS
290:   If m_pThisExt.StatsSaveMeans Then
291:     chkMeans.Value = 1
292:   Else
293:     chkMeans.Value = 0
294:   End If
  
296:   If m_pThisExt.StatsSaveCov Then
297:     chkCov.Value = 1
298:   Else
299:     chkCov.Value = 0
300:   End If
  
302:   If m_pThisExt.StatsSaveInvCov Then
303:     chkInvCov.Value = 1
304:   Else
305:     chkInvCov.Value = 0
306:   End If
  
308:   If m_pThisExt.StatsSaveCorrelation Then
309:     chkCorrelation.Value = 1
310:   Else
311:     chkCorrelation.Value = 0
312:   End If
  
314:   If m_pThisExt.StatsSaveSpearman Then
315:     chkSpearman.Value = 1
316:   Else
317:     chkSpearman.Value = 0
318:   End If
  
320:   CheckEnabled
  
  ' SET MODULE VARIABLES
323:   m_strMeansBasename = strBaseNameMeans
324:   m_strMeansDirName = strWsMeans
325:   m_strMeansFullText = strDirPathMeans
326:   m_pMeansWSType = lngDatasetType
327:   m_strCovBasename = strBaseNameCov
328:   m_strCovDirName = strWsCov
329:   m_strCovFullText = strDirPathCov
330:   m_pCovWStype = lngDatasetType
331:   m_strInvCovBasename = strBaseNameInvCov
332:   m_strInvCovDirName = strWsInvCov
333:   m_strInvCovFullText = strDirPathInvCov
334:   m_pInvCovWStype = lngDatasetType
335:   m_strCorrBasename = strBaseNameCorr
336:   m_strCorrDirName = strWsCorr
337:   m_strCorrFullText = strDirPathCorr
338:   m_pCorrWStype = lngDatasetType
339:   m_strSpearmanCorrBasename = strBaseNameSpearman
340:   m_strSpearmanCorrDirName = strWsSpearman
341:   m_strSpearmanCorrFullText = strDirPathSpearman
342:   m_pSpearmanCorrWStype = lngDatasetType
 
 Exit Property
ErrorHandler:
  HandleError True, "ArcApplication " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub CheckEnabled()
  On Error GoTo ErrorHandler
  
  Dim booEnableOK As Boolean
353:   booEnableOK = False

355:   If chkMeans.Value = 1 Then
356:     txtMeans.Enabled = True
357:     cmdMeans.Enabled = True
358:     booEnableOK = True
359:     txtMeans.BackColor = &H80000005
360:   Else
361:     txtMeans.Enabled = False
362:     cmdMeans.Enabled = False
363:     txtMeans.BackColor = &H8000000F
364:   End If
  
366:   If chkCov.Value = 1 Then
367:     txtCov.Enabled = True
368:     cmdCov.Enabled = True
369:     booEnableOK = True
370:     txtCov.BackColor = &H80000005
371:   Else
372:     txtCov.Enabled = False
373:     cmdCov.Enabled = False
374:     txtCov.BackColor = &H8000000F
375:   End If
  
377:   If chkInvCov.Value = 1 Then
378:     txtInvCov.Enabled = True
379:     cmdInvCov.Enabled = True
380:     booEnableOK = True
381:     txtInvCov.BackColor = &H80000005
382:   Else
383:     txtInvCov.Enabled = False
384:     cmdInvCov.Enabled = False
385:     txtInvCov.BackColor = &H8000000F
386:   End If
  
388:   If chkCorrelation.Value = 1 Then
389:     txtCorrelation.Enabled = True
390:     cmdCorrelation.Enabled = True
391:     booEnableOK = True
392:     txtCorrelation.BackColor = &H80000005
393:   Else
394:     txtCorrelation.Enabled = False
395:     cmdCorrelation.Enabled = False
396:     txtCorrelation.BackColor = &H8000000F
397:   End If
  
399:   If chkSpearman.Value = 1 Then
400:     txtSpearman.Enabled = True
401:     cmdSpearman.Enabled = True
402:     txtSpearman.BackColor = &H80000005
403:     booEnableOK = True
404:   Else
405:     txtSpearman.Enabled = False
406:     cmdSpearman.Enabled = False
407:     txtSpearman.BackColor = &H8000000F
408:   End If
  
410:   cmdOK.Enabled = booEnableOK

  Exit Sub
ErrorHandler:
  HandleError False, "CheckEnabled " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub chkCorrelation_Click()
  On Error GoTo ErrorHandler

420:   CheckEnabled

  Exit Sub
ErrorHandler:
  HandleError True, "chkCorrelation_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub chkCov_Click()
  On Error GoTo ErrorHandler

430:   CheckEnabled

  Exit Sub
ErrorHandler:
  HandleError True, "chkCov_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub chkInvCov_Click()
  On Error GoTo ErrorHandler

440:   CheckEnabled

  Exit Sub
ErrorHandler:
  HandleError True, "chkInvCov_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub chkMeans_Click()
  On Error GoTo ErrorHandler

450:   CheckEnabled

  Exit Sub
ErrorHandler:
  HandleError True, "chkMeans_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub chkSpearman_Click()
  On Error GoTo ErrorHandler


461:   CheckEnabled
  

  Exit Sub
ErrorHandler:
  HandleError True, "chkSpearman_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdBack_Click()
  On Error GoTo ErrorHandler


473:   m_pThisExt.ShouldContinue = True
474:   m_pThisExt.InputStep = 2
475:   Me.Visible = False
'  Unload Me
  

  Exit Sub
ErrorHandler:
  HandleError True, "cmdBack_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdCancel_Click()
  On Error GoTo ErrorHandler
  
487:   m_pThisExt.ShouldContinue = False
488:   Unload Me
  

  Exit Sub
ErrorHandler:
  HandleError True, "cmdCancel_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdCorrelation_Click()
  On Error GoTo ErrorHandler

  Dim pGxDialog As IGxDialog
 
  ' SET DEFAULT NAME
  Dim strDefault As String
503:   If m_pCorrWStype = ENUM_Shapefile Then
504:     strDefault = TopoCorridor.MyGeneralOperations.MakeUniqueShapeFilename(txtCorrelation.Text)
505:   Else
506:     strDefault = txtCorrelation.Text
507:   End If

  ' SAMPLE CODE BELOW
  Dim pGxDataset As IGxDataset
  Dim pDataset As IDataset
  Dim pWorkspace As IWorkspace
  Dim pFeatureDataset As IFeatureDataset
  Dim booHasFeatureDataset As Boolean
  Dim strFeatDatasetName As String
  Dim strCategory As String
  Dim strBaseName As String
  Dim strWsPathname As String
  Dim pGxObj As IGxObject
  Dim pGxFCFilter As IGxObjectFilter
  Dim pFilterCol As IGxObjectFilterCollection
  Dim pCategory As JenDatasetTypes
  Dim lngReturn As VbMsgBoxResult
  Dim booValidDataset As Boolean

'  MsgBox "m_strOutputBasename = " & m_strOutputBasename & vbCrLf & _
         "m_strOutputWorkspace = " & m_strOutputWorkspace & vbCrLf & _
         "m_booOutputFeatDataset = " & CStr(m_booOutputFeatDataset) & vbCrLf & _
         "m_strOutputFeatDatasetName = " & m_strOutputFeatDatasetName
         
531:   booValidDataset = False
532:   Do Until booValidDataset = True

    ' FOR SAMPLE; QUERY USER FOR NEW FEATURE CLASS LOCATION
    ' CAN BE A SHAPEFILE, OR IN A FILE / PERSONAL GEODATABASE
536:     Set pGxDialog = New GxDialog
537:     If m_booOutputIsFClass Then                                                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
538:       Set pGxFCFilter = New GxFilterFeatureClasses                             ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
539:     Else                                                                       ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
540:       Set pGxFCFilter = New GxFilterTables                                     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
541:     End If                                                                     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
    
543:     Set pFilterCol = pGxDialog
544:     pFilterCol.AddFilter pGxFCFilter, True
    
546:     With pGxDialog
547:       .AllowMultiSelect = False
548:       .StartingLocation = Replace(strDefault, ":", "\")
549:       If m_booOutputIsFClass Then                                              ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
550:         .Title = "Enter the name of your new Feature Class or Shapefile:"      ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
551:       Else                                                                     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
552:         .Title = "Enter the name of your new Correlation Table:"                           ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
553:       End If                                                                   ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
554:       .Name = m_strCorrBasename
555:     End With

557:     If Not pGxDialog.DoModalSave(Me.hWnd) Then
      Exit Sub 'Exit if user press Cancel
559:     End If
    
561:     Set pGxObj = pGxDialog.FinalLocation
562:     strWsPathname = pGxObj.FullName
563:     strBaseName = pGxDialog.Name
564:     booHasFeatureDataset = False
565:     strFeatDatasetName = ""
    
    ' CHECK TO SEE IF WE ARE WRITING TO A FEATURE DATASET
568:     If TypeOf pGxObj Is IGxDataset Then
569:       Set pGxDataset = pGxObj
        
571:       Set pDataset = pGxDataset.Dataset
572:       Set pWorkspace = pDataset.Workspace
573:       strWsPathname = pWorkspace.PathName
      
575:       booHasFeatureDataset = TypeOf pDataset Is IFeatureDataset
576:       If booHasFeatureDataset Then
577:         Set pFeatureDataset = pDataset
578:         strFeatDatasetName = pFeatureDataset.Name
579:       End If
580:     End If
    
    ' BACK OUT OF FEATURE DATASET IF CREATING A TABLE                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
583:     If Not m_booOutputIsFClass Then                                  ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
584:       booHasFeatureDataset = False                                   ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
585:       strFeatDatasetName = ""                                        ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
586:     End If                                                           ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
    
    ' FOR SAMPLE; GET CATEGORY
589:     strCategory = pGxObj.Category
    Select Case strCategory
      Case "Shapefile", "Folder", "dBASE Table"                                                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
592:         pCategory = ENUM_Shapefile
593:         booValidDataset = True
      Case "File Geodatabase Feature Class", "File Geodatabase Raster Catalog", _
           "File Geodatabase", "File Geodatabase Feature Dataset", "File Geodatabase Table"     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
596:         pCategory = ENUM_FileGDB
597:         booValidDataset = True
        ' REMOVE ".SHP" IF PRESENT
599:         If Right(strBaseName, 4) = ".shp" Then strBaseName = Left(strBaseName, Len(strBaseName) - 4)
        ' REPLACE ODD CHARACTERS
601:         strBaseName = TopoCorridor.MyGeneralOperations.ReplaceBadChars(strBaseName, True, True, True, True)
      Case "Personal Geodatabase Feature Class", "Personal Geodatabase Raster Catalog", _
           "Personal Geodatabase", "Personal Geodatabase Feature Dataset", _
           "Personal Geodatabase Table"                                                         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
605:         pCategory = ENUM_PersonalGDB
606:         booValidDataset = True
        ' REMOVE ".SHP" IF PRESENT
608:         If Right(strBaseName, 4) = ".shp" Then strBaseName = Left(strBaseName, Len(strBaseName) - 4)
        ' REPLACE ODD CHARACTERS
610:         strBaseName = TopoCorridor.MyGeneralOperations.ReplaceBadChars(strBaseName, True, True, True, True)
      Case Else
612:         lngReturn = MsgBox("Unexpected Feature Class Type (" & strCategory & ")!" & vbCrLf & _
            "This function will only create shapefiles or feature classes in " & vbCrLf & _
            "File or Personal GeoDatabases.  Please click 'OK' to select a " & vbCrLf & _
            "new Feature Class Name, or 'Cancel' to bail out.", vbOKCancel, "Invalid Feature Class Type:")
616:         If lngReturn = vbOK Then
617:           booValidDataset = False
618:         Else
          Exit Sub
620:         End If
621:     End Select
622:   Loop

624:   m_strCorrDirName = strWsPathname
625:   m_strCorrBasename = strBaseName
626:   m_pCorrWStype = pCategory
627:   m_strCorrFullText = strWsPathname & "\" & strBaseName
628:   txtCorrelation.Text = m_strCorrFullText
629:   txtCorrelation.SelStart = Len(txtCorrelation.Text)

631:   CheckEnabled

  Exit Sub
ErrorHandler:
  HandleError True, "cmdCorrelation_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdCov_Click()
  On Error GoTo ErrorHandler

  Dim pGxDialog As IGxDialog
 
  ' SET DEFAULT NAME
  Dim strDefault As String
645:   If m_pCovWStype = ENUM_Shapefile Then
646:     strDefault = TopoCorridor.MyGeneralOperations.MakeUniqueShapeFilename(txtCov.Text)
647:   Else
648:     strDefault = txtCov.Text
649:   End If

  ' SAMPLE CODE BELOW
  Dim pGxDataset As IGxDataset
  Dim pDataset As IDataset
  Dim pWorkspace As IWorkspace
  Dim pFeatureDataset As IFeatureDataset
  Dim booHasFeatureDataset As Boolean
  Dim strFeatDatasetName As String
  Dim strCategory As String
  Dim strBaseName As String
  Dim strWsPathname As String
  Dim pGxObj As IGxObject
  Dim pGxFCFilter As IGxObjectFilter
  Dim pFilterCol As IGxObjectFilterCollection
  Dim pCategory As JenDatasetTypes
  Dim lngReturn As VbMsgBoxResult
  Dim booValidDataset As Boolean

'  MsgBox "m_strOutputBasename = " & m_strOutputBasename & vbCrLf & _
         "m_strOutputWorkspace = " & m_strOutputWorkspace & vbCrLf & _
         "m_booOutputFeatDataset = " & CStr(m_booOutputFeatDataset) & vbCrLf & _
         "m_strOutputFeatDatasetName = " & m_strOutputFeatDatasetName
         
673:   booValidDataset = False
674:   Do Until booValidDataset = True

    ' FOR SAMPLE; QUERY USER FOR NEW FEATURE CLASS LOCATION
    ' CAN BE A SHAPEFILE, OR IN A FILE / PERSONAL GEODATABASE
678:     Set pGxDialog = New GxDialog
679:     If m_booOutputIsFClass Then                                                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
680:       Set pGxFCFilter = New GxFilterFeatureClasses                             ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
681:     Else                                                                       ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
682:       Set pGxFCFilter = New GxFilterTables                                     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
683:     End If                                                                     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
    
685:     Set pFilterCol = pGxDialog
686:     pFilterCol.AddFilter pGxFCFilter, True
    
688:     With pGxDialog
689:       .AllowMultiSelect = False
690:       .StartingLocation = Replace(strDefault, ":", "\")
691:       If m_booOutputIsFClass Then                                              ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
692:         .Title = "Enter the name of your new Feature Class or Shapefile:"      ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
693:       Else                                                                     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
694:         .Title = "Enter the name of your new Covariance Table:"                           ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
695:       End If                                                                   ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
696:       .Name = m_strCovBasename
697:     End With

699:     If Not pGxDialog.DoModalSave(Me.hWnd) Then
      Exit Sub 'Exit if user press Cancel
701:     End If
    
703:     Set pGxObj = pGxDialog.FinalLocation
704:     strWsPathname = pGxObj.FullName
705:     strBaseName = pGxDialog.Name
706:     booHasFeatureDataset = False
707:     strFeatDatasetName = ""
    
    ' CHECK TO SEE IF WE ARE WRITING TO A FEATURE DATASET
710:     If TypeOf pGxObj Is IGxDataset Then
711:       Set pGxDataset = pGxObj
        
713:       Set pDataset = pGxDataset.Dataset
714:       Set pWorkspace = pDataset.Workspace
715:       strWsPathname = pWorkspace.PathName
      
717:       booHasFeatureDataset = TypeOf pDataset Is IFeatureDataset
718:       If booHasFeatureDataset Then
719:         Set pFeatureDataset = pDataset
720:         strFeatDatasetName = pFeatureDataset.Name
721:       End If
722:     End If
    
    ' BACK OUT OF FEATURE DATASET IF CREATING A TABLE                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
725:     If Not m_booOutputIsFClass Then                                  ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
726:       booHasFeatureDataset = False                                   ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
727:       strFeatDatasetName = ""                                        ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
728:     End If                                                           ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
    
    ' FOR SAMPLE; GET CATEGORY
731:     strCategory = pGxObj.Category
    Select Case strCategory
      Case "Shapefile", "Folder", "dBASE Table"                                                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
734:         pCategory = ENUM_Shapefile
735:         booValidDataset = True
      Case "File Geodatabase Feature Class", "File Geodatabase Raster Catalog", _
           "File Geodatabase", "File Geodatabase Feature Dataset", "File Geodatabase Table"     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
738:         pCategory = ENUM_FileGDB
739:         booValidDataset = True
        ' REMOVE ".SHP" IF PRESENT
741:         If Right(strBaseName, 4) = ".shp" Then strBaseName = Left(strBaseName, Len(strBaseName) - 4)
        ' REPLACE ODD CHARACTERS
743:         strBaseName = TopoCorridor.MyGeneralOperations.ReplaceBadChars(strBaseName, True, True, True, True)
      Case "Personal Geodatabase Feature Class", "Personal Geodatabase Raster Catalog", _
           "Personal Geodatabase", "Personal Geodatabase Feature Dataset", _
           "Personal Geodatabase Table"                                                         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
747:         pCategory = ENUM_PersonalGDB
748:         booValidDataset = True
        ' REMOVE ".SHP" IF PRESENT
750:         If Right(strBaseName, 4) = ".shp" Then strBaseName = Left(strBaseName, Len(strBaseName) - 4)
        ' REPLACE ODD CHARACTERS
752:         strBaseName = TopoCorridor.MyGeneralOperations.ReplaceBadChars(strBaseName, True, True, True, True)
      Case Else
754:         lngReturn = MsgBox("Unexpected Feature Class Type (" & strCategory & ")!" & vbCrLf & _
            "This function will only create shapefiles or feature classes in " & vbCrLf & _
            "File or Personal GeoDatabases.  Please click 'OK' to select a " & vbCrLf & _
            "new Feature Class Name, or 'Cancel' to bail out.", vbOKCancel, "Invalid Feature Class Type:")
758:         If lngReturn = vbOK Then
759:           booValidDataset = False
760:         Else
          Exit Sub
762:         End If
763:     End Select
764:   Loop

766:   m_strCovDirName = strWsPathname
767:   m_strCovBasename = strBaseName
768:   m_pCovWStype = pCategory
769:   m_strCovFullText = strWsPathname & "\" & strBaseName
770:   txtCov.Text = m_strCovFullText
771:   txtCov.SelStart = Len(txtCov.Text)

773:   CheckEnabled

  Exit Sub
ErrorHandler:
  HandleError True, "cmdCov_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdInvCov_Click()
  On Error GoTo ErrorHandler

  Dim pGxDialog As IGxDialog
 
  ' SET DEFAULT NAME
  Dim strDefault As String
787:   If m_pInvCovWStype = ENUM_Shapefile Then
788:     strDefault = TopoCorridor.MyGeneralOperations.MakeUniqueShapeFilename(txtInvCov.Text)
789:   Else
790:     strDefault = txtInvCov.Text
791:   End If

  ' SAMPLE CODE BELOW
  Dim pGxDataset As IGxDataset
  Dim pDataset As IDataset
  Dim pWorkspace As IWorkspace
  Dim pFeatureDataset As IFeatureDataset
  Dim booHasFeatureDataset As Boolean
  Dim strFeatDatasetName As String
  Dim strCategory As String
  Dim strBaseName As String
  Dim strWsPathname As String
  Dim pGxObj As IGxObject
  Dim pGxFCFilter As IGxObjectFilter
  Dim pFilterCol As IGxObjectFilterCollection
  Dim pCategory As JenDatasetTypes
  Dim lngReturn As VbMsgBoxResult
  Dim booValidDataset As Boolean

'  MsgBox "m_strOutputBasename = " & m_strOutputBasename & vbCrLf & _
         "m_strOutputWorkspace = " & m_strOutputWorkspace & vbCrLf & _
         "m_booOutputFeatDataset = " & CStr(m_booOutputFeatDataset) & vbCrLf & _
         "m_strOutputFeatDatasetName = " & m_strOutputFeatDatasetName
         
815:   booValidDataset = False
816:   Do Until booValidDataset = True

    ' FOR SAMPLE; QUERY USER FOR NEW FEATURE CLASS LOCATION
    ' CAN BE A SHAPEFILE, OR IN A FILE / PERSONAL GEODATABASE
820:     Set pGxDialog = New GxDialog
821:     If m_booOutputIsFClass Then                                                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
822:       Set pGxFCFilter = New GxFilterFeatureClasses                             ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
823:     Else                                                                       ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
824:       Set pGxFCFilter = New GxFilterTables                                     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
825:     End If                                                                     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
    
827:     Set pFilterCol = pGxDialog
828:     pFilterCol.AddFilter pGxFCFilter, True
    
830:     With pGxDialog
831:       .AllowMultiSelect = False
832:       .StartingLocation = Replace(strDefault, ":", "\")
833:       If m_booOutputIsFClass Then                                              ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
834:         .Title = "Enter the name of your new Feature Class or Shapefile:"      ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
835:       Else                                                                     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
836:         .Title = "Enter the name of your new Inverse Covariance Table:"                           ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
837:       End If                                                                   ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
838:       .Name = m_strInvCovBasename
839:     End With

841:     If Not pGxDialog.DoModalSave(Me.hWnd) Then
      Exit Sub 'Exit if user press Cancel
843:     End If
    
845:     Set pGxObj = pGxDialog.FinalLocation
846:     strWsPathname = pGxObj.FullName
847:     strBaseName = pGxDialog.Name
848:     booHasFeatureDataset = False
849:     strFeatDatasetName = ""
    
    ' CHECK TO SEE IF WE ARE WRITING TO A FEATURE DATASET
852:     If TypeOf pGxObj Is IGxDataset Then
853:       Set pGxDataset = pGxObj
        
855:       Set pDataset = pGxDataset.Dataset
856:       Set pWorkspace = pDataset.Workspace
857:       strWsPathname = pWorkspace.PathName
      
859:       booHasFeatureDataset = TypeOf pDataset Is IFeatureDataset
860:       If booHasFeatureDataset Then
861:         Set pFeatureDataset = pDataset
862:         strFeatDatasetName = pFeatureDataset.Name
863:       End If
864:     End If
    
    ' BACK OUT OF FEATURE DATASET IF CREATING A TABLE                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
867:     If Not m_booOutputIsFClass Then                                  ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
868:       booHasFeatureDataset = False                                   ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
869:       strFeatDatasetName = ""                                        ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
870:     End If                                                           ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
    
    ' FOR SAMPLE; GET CATEGORY
873:     strCategory = pGxObj.Category
    Select Case strCategory
      Case "Shapefile", "Folder", "dBASE Table"                                                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
876:         pCategory = ENUM_Shapefile
877:         booValidDataset = True
      Case "File Geodatabase Feature Class", "File Geodatabase Raster Catalog", _
           "File Geodatabase", "File Geodatabase Feature Dataset", "File Geodatabase Table"     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
880:         pCategory = ENUM_FileGDB
881:         booValidDataset = True
        ' REMOVE ".SHP" IF PRESENT
883:         If Right(strBaseName, 4) = ".shp" Then strBaseName = Left(strBaseName, Len(strBaseName) - 4)
        ' REPLACE ODD CHARACTERS
885:         strBaseName = TopoCorridor.MyGeneralOperations.ReplaceBadChars(strBaseName, True, True, True, True)
      Case "Personal Geodatabase Feature Class", "Personal Geodatabase Raster Catalog", _
           "Personal Geodatabase", "Personal Geodatabase Feature Dataset", _
           "Personal Geodatabase Table"                                                         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
889:         pCategory = ENUM_PersonalGDB
890:         booValidDataset = True
        ' REMOVE ".SHP" IF PRESENT
892:         If Right(strBaseName, 4) = ".shp" Then strBaseName = Left(strBaseName, Len(strBaseName) - 4)
        ' REPLACE ODD CHARACTERS
894:         strBaseName = TopoCorridor.MyGeneralOperations.ReplaceBadChars(strBaseName, True, True, True, True)
      Case Else
896:         lngReturn = MsgBox("Unexpected Feature Class Type (" & strCategory & ")!" & vbCrLf & _
            "This function will only create shapefiles or feature classes in " & vbCrLf & _
            "File or Personal GeoDatabases.  Please click 'OK' to select a " & vbCrLf & _
            "new Feature Class Name, or 'Cancel' to bail out.", vbOKCancel, "Invalid Feature Class Type:")
900:         If lngReturn = vbOK Then
901:           booValidDataset = False
902:         Else
          Exit Sub
904:         End If
905:     End Select
906:   Loop

908:   m_strInvCovDirName = strWsPathname
909:   m_strInvCovBasename = strBaseName
910:   m_pInvCovWStype = pCategory
911:   m_strInvCovFullText = strWsPathname & "\" & strBaseName
912:   txtInvCov.Text = m_strInvCovFullText
913:   txtInvCov.SelStart = Len(txtInvCov.Text)

915:   CheckEnabled

  Exit Sub
ErrorHandler:
  HandleError True, "cmdInvCov_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdManual_Click()
  On Error GoTo ErrorHandler

  
  ' CHANGE AS APPROPRIATE
  Dim strDir As String
928:   strDir = App.Path
929:   If Right(strDir, 1) <> "\" Then strDir = strDir & "\"
930:   strDir = strDir & "docs"
  
932:   Call TopoCorridor.MyGeneralOperations.OpenDoc("Land_Facet_Tools.pdf", strDir)
  

  Exit Sub
ErrorHandler:
  HandleError True, "cmdManual_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdMeans_Click()
  On Error GoTo ErrorHandler

 
  Dim pGxDialog As IGxDialog
 
  ' SET DEFAULT NAME
  Dim strDefault As String
948:   If m_pMeansWSType = ENUM_Shapefile Then
949:     strDefault = TopoCorridor.MyGeneralOperations.MakeUniqueShapeFilename(txtMeans.Text)
950:   Else
951:     strDefault = txtMeans.Text
952:   End If

  ' SAMPLE CODE BELOW
  Dim pGxDataset As IGxDataset
  Dim pDataset As IDataset
  Dim pWorkspace As IWorkspace
  Dim pFeatureDataset As IFeatureDataset
  Dim booHasFeatureDataset As Boolean
  Dim strFeatDatasetName As String
  Dim strCategory As String
  Dim strBaseName As String
  Dim strWsPathname As String
  Dim pGxObj As IGxObject
  Dim pGxFCFilter As IGxObjectFilter
  Dim pFilterCol As IGxObjectFilterCollection
  Dim pCategory As JenDatasetTypes
  Dim lngReturn As VbMsgBoxResult
  Dim booValidDataset As Boolean

'  MsgBox "m_strOutputBasename = " & m_strOutputBasename & vbCrLf & _
         "m_strOutputWorkspace = " & m_strOutputWorkspace & vbCrLf & _
         "m_booOutputFeatDataset = " & CStr(m_booOutputFeatDataset) & vbCrLf & _
         "m_strOutputFeatDatasetName = " & m_strOutputFeatDatasetName
         
976:   booValidDataset = False
977:   Do Until booValidDataset = True

    ' FOR SAMPLE; QUERY USER FOR NEW FEATURE CLASS LOCATION
    ' CAN BE A SHAPEFILE, OR IN A FILE / PERSONAL GEODATABASE
981:     Set pGxDialog = New GxDialog
982:     If m_booOutputIsFClass Then                                                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
983:       Set pGxFCFilter = New GxFilterFeatureClasses                             ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
984:     Else                                                                       ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
985:       Set pGxFCFilter = New GxFilterTables                                     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
986:     End If                                                                     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
    
988:     Set pFilterCol = pGxDialog
989:     pFilterCol.AddFilter pGxFCFilter, True
    
991:     With pGxDialog
992:       .AllowMultiSelect = False
993:       .StartingLocation = Replace(strDefault, ":", "\")
994:       If m_booOutputIsFClass Then                                              ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
995:         .Title = "Enter the name of your new Feature Class or Shapefile:"      ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
996:       Else                                                                     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
997:         .Title = "Enter the name of your new Means Table:"                           ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
998:       End If                                                                   ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
999:       .Name = m_strMeansBasename
1000:     End With

1002:     If Not pGxDialog.DoModalSave(Me.hWnd) Then
      Exit Sub 'Exit if user press Cancel
1004:     End If
    
1006:     Set pGxObj = pGxDialog.FinalLocation
1007:     strWsPathname = pGxObj.FullName
1008:     strBaseName = pGxDialog.Name
1009:     booHasFeatureDataset = False
1010:     strFeatDatasetName = ""
    
    ' CHECK TO SEE IF WE ARE WRITING TO A FEATURE DATASET
1013:     If TypeOf pGxObj Is IGxDataset Then
1014:       Set pGxDataset = pGxObj
        
1016:       Set pDataset = pGxDataset.Dataset
1017:       Set pWorkspace = pDataset.Workspace
1018:       strWsPathname = pWorkspace.PathName
      
1020:       booHasFeatureDataset = TypeOf pDataset Is IFeatureDataset
1021:       If booHasFeatureDataset Then
1022:         Set pFeatureDataset = pDataset
1023:         strFeatDatasetName = pFeatureDataset.Name
1024:       End If
1025:     End If
    
    ' BACK OUT OF FEATURE DATASET IF CREATING A TABLE                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
1028:     If Not m_booOutputIsFClass Then                                  ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
1029:       booHasFeatureDataset = False                                   ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
1030:       strFeatDatasetName = ""                                        ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
1031:     End If                                                           ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
    
    ' FOR SAMPLE; GET CATEGORY
1034:     strCategory = pGxObj.Category
    Select Case strCategory
      Case "Shapefile", "Folder", "dBASE Table"                                                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
1037:         pCategory = ENUM_Shapefile
1038:         booValidDataset = True
      Case "File Geodatabase Feature Class", "File Geodatabase Raster Catalog", _
           "File Geodatabase", "File Geodatabase Feature Dataset", "File Geodatabase Table"     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
1041:         pCategory = ENUM_FileGDB
1042:         booValidDataset = True
        ' REMOVE ".SHP" IF PRESENT
1044:         If Right(strBaseName, 4) = ".shp" Then strBaseName = Left(strBaseName, Len(strBaseName) - 4)
        ' REPLACE ODD CHARACTERS
1046:         strBaseName = TopoCorridor.MyGeneralOperations.ReplaceBadChars(strBaseName, True, True, True, True)
      Case "Personal Geodatabase Feature Class", "Personal Geodatabase Raster Catalog", _
           "Personal Geodatabase", "Personal Geodatabase Feature Dataset", _
           "Personal Geodatabase Table"                                                         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
1050:         pCategory = ENUM_PersonalGDB
1051:         booValidDataset = True
        ' REMOVE ".SHP" IF PRESENT
1053:         If Right(strBaseName, 4) = ".shp" Then strBaseName = Left(strBaseName, Len(strBaseName) - 4)
        ' REPLACE ODD CHARACTERS
1055:         strBaseName = TopoCorridor.MyGeneralOperations.ReplaceBadChars(strBaseName, True, True, True, True)
      Case Else
1057:         lngReturn = MsgBox("Unexpected Feature Class Type (" & strCategory & ")!" & vbCrLf & _
            "This function will only create shapefiles or feature classes in " & vbCrLf & _
            "File or Personal GeoDatabases.  Please click 'OK' to select a " & vbCrLf & _
            "new Feature Class Name, or 'Cancel' to bail out.", vbOKCancel, "Invalid Feature Class Type:")
1061:         If lngReturn = vbOK Then
1062:           booValidDataset = False
1063:         Else
          Exit Sub
1065:         End If
1066:     End Select
1067:   Loop

1069:   m_strMeansDirName = strWsPathname
1070:   m_strMeansBasename = strBaseName
1071:   m_pMeansWSType = pCategory
1072:   m_strMeansFullText = strWsPathname & "\" & strBaseName
1073:   txtMeans.Text = m_strMeansFullText
1074:   txtMeans.SelStart = Len(txtMeans.Text)

1076:   CheckEnabled

  Exit Sub
ErrorHandler:
  HandleError True, "cmdMeans_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdOK_Click()
  On Error GoTo ErrorHandler


  ' SAVE OPTIONS TO EXTENSION PROPERTIES
1088:   If chkMeans.Value = 1 Then
    Dim pMeanOptions As esriSystem.IVariantArray
1090:     Set pMeanOptions = New esriSystem.VarArray
1091:     pMeanOptions.Add m_strMeansBasename
1092:     pMeanOptions.Add m_strMeansDirName
1093:     pMeanOptions.Add m_strMeansFullText
1094:     pMeanOptions.Add m_pMeansWSType
    
1096:     m_pThisExt.StatsSaveMeans = True
1097:     Set m_pThisExt.StatsSaveMeansOptions = pMeanOptions
1098:   Else
1099:     m_pThisExt.StatsSaveMeans = False
1100:     Set m_pThisExt.StatsSaveMeansOptions = Nothing
1101:   End If
  
1103:   If chkCov.Value = 1 Then
    Dim pCovOptions As esriSystem.IVariantArray
1105:     Set pCovOptions = New esriSystem.VarArray
1106:     pCovOptions.Add m_strCovBasename
1107:     pCovOptions.Add m_strCovDirName
1108:     pCovOptions.Add m_strCovFullText
1109:     pCovOptions.Add m_pCovWStype
    
1111:     m_pThisExt.StatsSaveCov = True
1112:     Set m_pThisExt.StatsSaveCovOptions = pCovOptions
1113:   Else
1114:     m_pThisExt.StatsSaveCov = False
1115:     Set m_pThisExt.StatsSaveCovOptions = Nothing
1116:   End If
    
1118:   If chkInvCov.Value = 1 Then
    Dim pInvCovOptions As esriSystem.IVariantArray
1120:     Set pInvCovOptions = New esriSystem.VarArray
1121:     pInvCovOptions.Add m_strInvCovBasename
1122:     pInvCovOptions.Add m_strInvCovDirName
1123:     pInvCovOptions.Add m_strInvCovFullText
1124:     pInvCovOptions.Add m_pInvCovWStype
    
1126:     m_pThisExt.StatsSaveInvCov = True
1127:     Set m_pThisExt.StatsSaveInvCovOptions = pInvCovOptions
1128:   Else
1129:     m_pThisExt.StatsSaveInvCov = False
1130:     Set m_pThisExt.StatsSaveInvCovOptions = Nothing
1131:   End If
    
1133:   If chkCorrelation.Value = 1 Then
    Dim pCorrOptions As esriSystem.IVariantArray
1135:     Set pCorrOptions = New esriSystem.VarArray
1136:     pCorrOptions.Add m_strCorrBasename
1137:     pCorrOptions.Add m_strCorrDirName
1138:     pCorrOptions.Add m_strCorrFullText
1139:     pCorrOptions.Add m_pCorrWStype
    
1141:     m_pThisExt.StatsSaveCorrelation = True
1142:     Set m_pThisExt.StatsSaveCorrelationOptions = pCorrOptions
1143:   Else
1144:     m_pThisExt.StatsSaveCorrelation = False
1145:     Set m_pThisExt.StatsSaveCorrelationOptions = Nothing
1146:   End If
    
1148:   If chkSpearman.Value = 1 Then
    Dim pSpearmanCorrOptions As esriSystem.IVariantArray
1150:     Set pSpearmanCorrOptions = New esriSystem.VarArray
1151:     pSpearmanCorrOptions.Add m_strSpearmanCorrBasename
1152:     pSpearmanCorrOptions.Add m_strSpearmanCorrDirName
1153:     pSpearmanCorrOptions.Add m_strSpearmanCorrFullText
1154:     pSpearmanCorrOptions.Add m_pSpearmanCorrWStype
    
1156:     m_pThisExt.StatsSaveSpearman = True
1157:     Set m_pThisExt.StatsSaveSpearmanOptions = pSpearmanCorrOptions
1158:   Else
1159:     m_pThisExt.StatsSaveSpearman = False
1160:     Set m_pThisExt.StatsSaveSpearmanOptions = Nothing
1161:   End If
  
1163:   m_pThisExt.InputStep = 4
1164:   m_pThisExt.ShouldContinue = True
  
1166:   Unload Me

  Exit Sub
ErrorHandler:
  HandleError True, "cmdOK_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdSpearman_Click()
  On Error GoTo ErrorHandler


  Dim pGxDialog As IGxDialog
 
  ' SET DEFAULT NAME
  Dim strDefault As String
1181:   If m_pSpearmanCorrWStype = ENUM_Shapefile Then
1182:     strDefault = TopoCorridor.MyGeneralOperations.MakeUniqueShapeFilename(txtSpearman.Text)
1183:   Else
1184:     strDefault = txtCorrelation.Text
1185:   End If

  ' SAMPLE CODE BELOW
  Dim pGxDataset As IGxDataset
  Dim pDataset As IDataset
  Dim pWorkspace As IWorkspace
  Dim pFeatureDataset As IFeatureDataset
  Dim booHasFeatureDataset As Boolean
  Dim strFeatDatasetName As String
  Dim strCategory As String
  Dim strBaseName As String
  Dim strWsPathname As String
  Dim pGxObj As IGxObject
  Dim pGxFCFilter As IGxObjectFilter
  Dim pFilterCol As IGxObjectFilterCollection
  Dim pCategory As JenDatasetTypes
  Dim lngReturn As VbMsgBoxResult
  Dim booValidDataset As Boolean

'  MsgBox "m_strOutputBasename = " & m_strOutputBasename & vbCrLf & _
         "m_strOutputWorkspace = " & m_strOutputWorkspace & vbCrLf & _
         "m_booOutputFeatDataset = " & CStr(m_booOutputFeatDataset) & vbCrLf & _
         "m_strOutputFeatDatasetName = " & m_strOutputFeatDatasetName
         
1209:   booValidDataset = False
1210:   Do Until booValidDataset = True

    ' FOR SAMPLE; QUERY USER FOR NEW FEATURE CLASS LOCATION
    ' CAN BE A SHAPEFILE, OR IN A FILE / PERSONAL GEODATABASE
1214:     Set pGxDialog = New GxDialog
1215:     If m_booOutputIsFClass Then                                                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
1216:       Set pGxFCFilter = New GxFilterFeatureClasses                             ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
1217:     Else                                                                       ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
1218:       Set pGxFCFilter = New GxFilterTables                                     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
1219:     End If                                                                     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
    
1221:     Set pFilterCol = pGxDialog
1222:     pFilterCol.AddFilter pGxFCFilter, True
    
1224:     With pGxDialog
1225:       .AllowMultiSelect = False
1226:       .StartingLocation = Replace(strDefault, ":", "\")
1227:       If m_booOutputIsFClass Then                                              ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
1228:         .Title = "Enter the name of your new Feature Class or Shapefile:"      ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
1229:       Else                                                                     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
1230:         .Title = "Enter the name of your new Spearman's Rho Correlation Table:"                           ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
1231:       End If                                                                   ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
1232:       .Name = m_strSpearmanCorrBasename
1233:     End With

1235:     If Not pGxDialog.DoModalSave(Me.hWnd) Then
      Exit Sub 'Exit if user press Cancel
1237:     End If
    
1239:     Set pGxObj = pGxDialog.FinalLocation
1240:     strWsPathname = pGxObj.FullName
1241:     strBaseName = pGxDialog.Name
1242:     booHasFeatureDataset = False
1243:     strFeatDatasetName = ""
    
    ' CHECK TO SEE IF WE ARE WRITING TO A FEATURE DATASET
1246:     If TypeOf pGxObj Is IGxDataset Then
1247:       Set pGxDataset = pGxObj
        
1249:       Set pDataset = pGxDataset.Dataset
1250:       Set pWorkspace = pDataset.Workspace
1251:       strWsPathname = pWorkspace.PathName
      
1253:       booHasFeatureDataset = TypeOf pDataset Is IFeatureDataset
1254:       If booHasFeatureDataset Then
1255:         Set pFeatureDataset = pDataset
1256:         strFeatDatasetName = pFeatureDataset.Name
1257:       End If
1258:     End If
    
    ' BACK OUT OF FEATURE DATASET IF CREATING A TABLE                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
1261:     If Not m_booOutputIsFClass Then                                  ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
1262:       booHasFeatureDataset = False                                   ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
1263:       strFeatDatasetName = ""                                        ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
1264:     End If                                                           ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
    
    ' FOR SAMPLE; GET CATEGORY
1267:     strCategory = pGxObj.Category
    Select Case strCategory
      Case "Shapefile", "Folder", "dBASE Table"                                                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
1270:         pCategory = ENUM_Shapefile
1271:         booValidDataset = True
      Case "File Geodatabase Feature Class", "File Geodatabase Raster Catalog", _
           "File Geodatabase", "File Geodatabase Feature Dataset", "File Geodatabase Table"     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
1274:         pCategory = ENUM_FileGDB
1275:         booValidDataset = True
        ' REMOVE ".SHP" IF PRESENT
1277:         If Right(strBaseName, 4) = ".shp" Then strBaseName = Left(strBaseName, Len(strBaseName) - 4)
        ' REPLACE ODD CHARACTERS
1279:         strBaseName = TopoCorridor.MyGeneralOperations.ReplaceBadChars(strBaseName, True, True, True, True)
      Case "Personal Geodatabase Feature Class", "Personal Geodatabase Raster Catalog", _
           "Personal Geodatabase", "Personal Geodatabase Feature Dataset", _
           "Personal Geodatabase Table"                                                         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
1283:         pCategory = ENUM_PersonalGDB
1284:         booValidDataset = True
        ' REMOVE ".SHP" IF PRESENT
1286:         If Right(strBaseName, 4) = ".shp" Then strBaseName = Left(strBaseName, Len(strBaseName) - 4)
        ' REPLACE ODD CHARACTERS
1288:         strBaseName = TopoCorridor.MyGeneralOperations.ReplaceBadChars(strBaseName, True, True, True, True)
      Case Else
1290:         lngReturn = MsgBox("Unexpected Feature Class Type (" & strCategory & ")!" & vbCrLf & _
            "This function will only create shapefiles or feature classes in " & vbCrLf & _
            "File or Personal GeoDatabases.  Please click 'OK' to select a " & vbCrLf & _
            "new Feature Class Name, or 'Cancel' to bail out.", vbOKCancel, "Invalid Feature Class Type:")
1294:         If lngReturn = vbOK Then
1295:           booValidDataset = False
1296:         Else
          Exit Sub
1298:         End If
1299:     End Select
1300:   Loop

1302:   m_strSpearmanCorrDirName = strWsPathname
1303:   m_strSpearmanCorrBasename = strBaseName
1304:   m_pSpearmanCorrWStype = pCategory
1305:   m_strSpearmanCorrFullText = strWsPathname & "\" & strBaseName
1306:   txtSpearman.Text = m_strSpearmanCorrFullText
1307:   txtSpearman.SelStart = Len(txtSpearman.Text)



  Exit Sub
ErrorHandler:
  HandleError True, "cmdSpearman_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Form_Activate()
  On Error GoTo ErrorHandler

1319:   m_pThisExt.ShouldContinue = False

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Activate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Form_Load()
  On Error GoTo ErrorHandler


1330:   SetWindowPos Me.hWnd, -1, 0, 0, 0, 0, &H1 Or &H2
1331:   Me.Left = (Screen.Width / 2) - (Me.Width / 2)
1332:   Me.Top = (Screen.Height / 3) - (Me.Height / 3)
   
1334:    Set Anchors = New AnchorObjectList  ' Create new instance
1335:    With Anchors
1336:       With .Item(chkCorrelation)
1337:          .SetAnchors enumStartSize, enumStartSize
1338:       End With
1339:       With .Item(chkCov)
1340:          .SetAnchors enumStartSize, enumStartSize
1341:       End With
1342:       With .Item(chkInvCov)
1343:          .SetAnchors enumStartSize, enumStartSize
1344:       End With
1345:       With .Item(chkMeans)
1346:          .SetAnchors enumStartSize, enumStartSize
1347:       End With
1348:       With .Item(chkSpearman)
1349:          .SetAnchors enumStartSize, enumStartSize
1350:       End With
1351:       With .Item(cmdCancel)
1352:          .SetAnchors enumSizeEnd, enumSizeEnd
1353:       End With
1354:       With .Item(cmdCorrelation)
1355:          .SetAnchors enumSizeEnd, enumStartSize
1356:       End With
1357:       With .Item(cmdCov)
1358:          .SetAnchors enumSizeEnd, enumStartSize
1359:       End With
1360:       With .Item(cmdInvCov)
1361:          .SetAnchors enumSizeEnd, enumStartSize
1362:       End With
1363:       With .Item(cmdManual)
1364:          .SetAnchors enumSizeEnd, enumSizeEnd
1365:       End With
1366:       With .Item(cmdBack)
1367:          .SetAnchors enumSizeEnd, enumSizeEnd
1368:       End With
1369:       With .Item(cmdMeans)
1370:          .SetAnchors enumSizeEnd, enumStartSize
1371:       End With
1372:       With .Item(cmdSpearman)
1373:          .SetAnchors enumSizeEnd, enumStartSize
1374:       End With
1375:       With .Item(cmdOK)
1376:          .SetAnchors enumSizeEnd, enumSizeEnd
1377:       End With
1378:       With .Item(imgBack)
1379:          .SetAnchors enumStartEnd, enumStartSize
1380:       End With
1381:       With .Item(imgCornerBars)
1382:          .SetAnchors enumSizeEnd, enumSizeEnd
1383:       End With
1384:       With .Item(txtCorrelation)
1385:          .SetAnchors enumStartEnd, enumStartSize
1386:       End With
1387:       With .Item(txtCov)
1388:          .SetAnchors enumStartEnd, enumStartSize
1389:       End With
1390:       With .Item(txtInvCov)
1391:          .SetAnchors enumStartEnd, enumStartSize
1392:       End With
1393:       With .Item(txtMeans)
1394:          .SetAnchors enumStartEnd, enumStartSize
1395:       End With
1396:       With .Item(txtSpearman)
1397:          .SetAnchors enumStartEnd, enumStartSize
1398:       End With
1399:       .Form = Me  ' Set form reference (suggested to be last step)
1400:    End With


  Exit Sub
ErrorHandler:
  HandleError True, "Form_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Form_Terminate()
  On Error GoTo ErrorHandler

1411:   Set m_pMxDoc = Nothing
1412:   Set m_pApp = Nothing
1413:   Set m_pThisExt = Nothing

  Exit Sub
  HandleError True, "Form_Terminate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
ErrorHandler:
End Sub

Private Sub txtCorrelation_Change()
  On Error GoTo ErrorHandler


  Dim strFullPath As String
1425:   strFullPath = txtCorrelation.Text
  Dim strFile As String
  Dim strDir As String
1428:   strFile = TopoCorridor.aml_func_mod.ReturnFilename(strFullPath)
1429:   strDir = TopoCorridor.aml_func_mod.ReturnDir(strFullPath)
  
1431:   If Right(strDir, 1) = "\" Or Right(strDir, 1) = "/" Then
1432:     strDir = Left(strDir, Len(strDir) - 1)
1433:   End If
  
1435:   m_strCorrDirName = strDir
1436:   m_strCorrBasename = strFile
1437:   m_strCorrFullText = strFullPath
  
1439:   If Right(strDir, 4) = ".gdb" Then       ' IS A FILE GEODATABASE
1440:     m_pCorrWStype = ENUM_FileGDB
1441:   ElseIf Right(strDir, 4) = ".mdb" Then   ' IS A PERSONAL GEODATABASE
1442:     m_pCorrWStype = ENUM_PersonalGDB
1443:   Else                                    ' TREAT AS SHAPEFILE
1444:     m_pCorrWStype = ENUM_Shapefile
1445:     m_strCorrBasename = TopoCorridor.aml_func_mod.SetExtension(m_strCorrBasename, "dbf")
1446:   End If
  
'  Private m_strCorrBasename As String
'  Private m_strCorrDirName As String
'  Private m_strCorrFullText As String
'  Private m_pCorrWStype As JenDatasetTypes
  

  Exit Sub
ErrorHandler:
  HandleError True, "txtCorrelation_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub txtCov_Change()
  On Error GoTo ErrorHandler


  Dim strFullPath As String
1464:   strFullPath = txtCov.Text
  Dim strFile As String
  Dim strDir As String
1467:   strFile = TopoCorridor.aml_func_mod.ReturnFilename(strFullPath)
1468:   strDir = TopoCorridor.aml_func_mod.ReturnDir(strFullPath)
  
1470:   If Right(strDir, 1) = "\" Or Right(strDir, 1) = "/" Then
1471:     strDir = Left(strDir, Len(strDir) - 1)
1472:   End If
  
1474:   m_strCovDirName = strDir
1475:   m_strCovBasename = strFile
1476:   m_strCovFullText = strFullPath
  
1478:   If Right(strDir, 4) = ".gdb" Then       ' IS A FILE GEODATABASE
1479:     m_pCovWStype = ENUM_FileGDB
1480:   ElseIf Right(strDir, 4) = ".mdb" Then   ' IS A PERSONAL GEODATABASE
1481:     m_pCovWStype = ENUM_PersonalGDB
1482:   Else                                    ' TREAT AS SHAPEFILE
1483:     m_pCovWStype = ENUM_Shapefile
1484:     m_strCovBasename = TopoCorridor.aml_func_mod.SetExtension(m_strCovBasename, "dbf")
1485:   End If
  
'  Private m_strCovBasename As String
'  Private m_strCovDirName As String
'  Private m_strCovFullText As String
'  Private m_pCovWStype As JenDatasetTypes


  Exit Sub
ErrorHandler:
  HandleError True, "txtCov_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub txtInvCov_Change()
  On Error GoTo ErrorHandler


  Dim strFullPath As String
1503:   strFullPath = txtInvCov.Text
  Dim strFile As String
  Dim strDir As String
1506:   strFile = TopoCorridor.aml_func_mod.ReturnFilename(strFullPath)
1507:   strDir = TopoCorridor.aml_func_mod.ReturnDir(strFullPath)
  
1509:   If Right(strDir, 1) = "\" Or Right(strDir, 1) = "/" Then
1510:     strDir = Left(strDir, Len(strDir) - 1)
1511:   End If
  
1513:   m_strInvCovDirName = strDir
1514:   m_strInvCovBasename = strFile
1515:   m_strInvCovFullText = strFullPath
  
1517:   If Right(strDir, 4) = ".gdb" Then       ' IS A FILE GEODATABASE
1518:     m_pInvCovWStype = ENUM_FileGDB
1519:   ElseIf Right(strDir, 4) = ".mdb" Then   ' IS A PERSONAL GEODATABASE
1520:     m_pInvCovWStype = ENUM_PersonalGDB
1521:   Else                                    ' TREAT AS SHAPEFILE
1522:     m_pInvCovWStype = ENUM_Shapefile
1523:     m_strInvCovBasename = TopoCorridor.aml_func_mod.SetExtension(m_strInvCovBasename, "dbf")
1524:   End If
  
'  Private m_strInvCovBasename As String
'  Private m_strInvCovDirName As String
'  Private m_strInvCovFullText As String
'  Private m_pInvCovWStype As JenDatasetTypes


  Exit Sub
ErrorHandler:
  HandleError True, "txtInvCov_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub txtMeans_Change()
  On Error GoTo ErrorHandler


  Dim strFullPath As String
1542:   strFullPath = txtMeans.Text
  Dim strFile As String
  Dim strDir As String
  
1546:   strFile = TopoCorridor.aml_func_mod.ReturnFilename(strFullPath)
1547:   strDir = TopoCorridor.aml_func_mod.ReturnDir(strFullPath)
  
1549:   If Right(strDir, 1) = "\" Or Right(strDir, 1) = "/" Then
1550:     strDir = Left(strDir, Len(strDir) - 1)
1551:   End If
  
1553:   m_strMeansDirName = strDir
1554:   m_strMeansBasename = strFile
1555:   m_strMeansFullText = strFullPath
  
1557:   If Right(strDir, 4) = ".gdb" Then       ' IS A FILE GEODATABASE
1558:     m_pMeansWSType = ENUM_FileGDB
1559:   ElseIf Right(strDir, 4) = ".mdb" Then   ' IS A PERSONAL GEODATABASE
1560:     m_pMeansWSType = ENUM_PersonalGDB
1561:   Else                                    ' TREAT AS SHAPEFILE
1562:     m_pMeansWSType = ENUM_Shapefile
1563:     m_strMeansBasename = TopoCorridor.aml_func_mod.SetExtension(m_strMeansBasename, "dbf")
1564:   End If
  
'  Private m_strMeansBasename As String
'  Private m_strMeansDirName As String
'  Private m_strMeansFullText As String
'  Private m_pMeansWSType As JenDatasetTypes


  Exit Sub
ErrorHandler:
  HandleError True, "txtMeans_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub txtSpearman_Change()
  On Error GoTo ErrorHandler


  Dim strFullPath As String
1582:   strFullPath = txtSpearman.Text
  Dim strFile As String
  Dim strDir As String
1585:   strFile = TopoCorridor.aml_func_mod.ReturnFilename(strFullPath)
1586:   strDir = TopoCorridor.aml_func_mod.ReturnDir(strFullPath)
  
1588:   If Right(strDir, 1) = "\" Or Right(strDir, 1) = "/" Then
1589:     strDir = Left(strDir, Len(strDir) - 1)
1590:   End If
  
1592:   m_strSpearmanCorrDirName = strDir
1593:   m_strSpearmanCorrBasename = strFile
1594:   m_strSpearmanCorrFullText = strFullPath
  
1596:   If Right(strDir, 4) = ".gdb" Then       ' IS A FILE GEODATABASE
1597:     m_pSpearmanCorrWStype = ENUM_FileGDB
1598:   ElseIf Right(strDir, 4) = ".mdb" Then   ' IS A PERSONAL GEODATABASE
1599:     m_pSpearmanCorrWStype = ENUM_PersonalGDB
1600:   Else                                    ' TREAT AS SHAPEFILE
1601:     m_pSpearmanCorrWStype = ENUM_Shapefile
1602:     m_strSpearmanCorrBasename = TopoCorridor.aml_func_mod.SetExtension(m_strSpearmanCorrBasename, "dbf")
1603:   End If
  
'  Private m_strSpearmanCorrBasename As String
'  Private m_strSpearmanCorrDirName As String
'  Private m_strSpearmanCorrFullText As String
'  Private m_pSpearmanCorrWStype As JenDatasetTypes

  Exit Sub
ErrorHandler:
  HandleError True, "txtSpearman_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
